#include "parser.h"

#if defined(__GNUC__) || defined(__clang__)
#pragma GCC diagnostic push
#pragma GCC diagnostic ignored "-Wmissing-field-initializers"
#endif

#define LANGUAGE_VERSION 13
#define STATE_COUNT 1356
#define LARGE_STATE_COUNT 207
#define SYMBOL_COUNT 241
#define ALIAS_COUNT 5
#define TOKEN_COUNT 124
#define EXTERNAL_TOKEN_COUNT 2
#define FIELD_COUNT 34
#define MAX_ALIAS_SEQUENCE_LENGTH 7
#define PRODUCTION_ID_COUNT 94

enum {
  sym_identifier = 1,
  sym_hash_bang_line = 2,
  anon_sym_export = 3,
  anon_sym_STAR = 4,
  anon_sym_default = 5,
  anon_sym_LBRACE = 6,
  anon_sym_COMMA = 7,
  anon_sym_RBRACE = 8,
  anon_sym_as = 9,
  anon_sym_import = 10,
  anon_sym_from = 11,
  anon_sym_var = 12,
  anon_sym_let = 13,
  anon_sym_const = 14,
  anon_sym_else = 15,
  anon_sym_if = 16,
  anon_sym_switch = 17,
  anon_sym_for = 18,
  anon_sym_LPAREN = 19,
  anon_sym_RPAREN = 20,
  anon_sym_await = 21,
  anon_sym_in = 22,
  anon_sym_of = 23,
  anon_sym_while = 24,
  anon_sym_do = 25,
  anon_sym_try = 26,
  anon_sym_with = 27,
  anon_sym_break = 28,
  anon_sym_continue = 29,
  anon_sym_debugger = 30,
  anon_sym_return = 31,
  anon_sym_throw = 32,
  anon_sym_SEMI = 33,
  anon_sym_COLON = 34,
  anon_sym_case = 35,
  anon_sym_catch = 36,
  anon_sym_finally = 37,
  anon_sym_yield = 38,
  anon_sym_EQ = 39,
  anon_sym_LBRACK = 40,
  anon_sym_RBRACK = 41,
  anon_sym_LT = 42,
  anon_sym_GT = 43,
  anon_sym_SLASH = 44,
  sym_jsx_text = 45,
  sym_jsx_identifier = 46,
  anon_sym_DOT = 47,
  anon_sym_class = 48,
  anon_sym_extends = 49,
  anon_sym_async = 50,
  anon_sym_function = 51,
  anon_sym_EQ_GT = 52,
  anon_sym_QMARK_DOT = 53,
  anon_sym_new = 54,
  anon_sym_PLUS_EQ = 55,
  anon_sym_DASH_EQ = 56,
  anon_sym_STAR_EQ = 57,
  anon_sym_SLASH_EQ = 58,
  anon_sym_PERCENT_EQ = 59,
  anon_sym_CARET_EQ = 60,
  anon_sym_AMP_EQ = 61,
  anon_sym_PIPE_EQ = 62,
  anon_sym_GT_GT_EQ = 63,
  anon_sym_GT_GT_GT_EQ = 64,
  anon_sym_LT_LT_EQ = 65,
  anon_sym_STAR_STAR_EQ = 66,
  anon_sym_AMP_AMP_EQ = 67,
  anon_sym_PIPE_PIPE_EQ = 68,
  anon_sym_QMARK_QMARK_EQ = 69,
  anon_sym_DOT_DOT_DOT = 70,
  anon_sym_QMARK = 71,
  anon_sym_AMP_AMP = 72,
  anon_sym_PIPE_PIPE = 73,
  anon_sym_GT_GT = 74,
  anon_sym_GT_GT_GT = 75,
  anon_sym_LT_LT = 76,
  anon_sym_AMP = 77,
  anon_sym_CARET = 78,
  anon_sym_PIPE = 79,
  anon_sym_PLUS = 80,
  anon_sym_DASH = 81,
  anon_sym_PERCENT = 82,
  anon_sym_STAR_STAR = 83,
  anon_sym_LT_EQ = 84,
  anon_sym_EQ_EQ = 85,
  anon_sym_EQ_EQ_EQ = 86,
  anon_sym_BANG_EQ = 87,
  anon_sym_BANG_EQ_EQ = 88,
  anon_sym_GT_EQ = 89,
  anon_sym_QMARK_QMARK = 90,
  anon_sym_instanceof = 91,
  anon_sym_BANG = 92,
  anon_sym_TILDE = 93,
  anon_sym_typeof = 94,
  anon_sym_void = 95,
  anon_sym_delete = 96,
  anon_sym_PLUS_PLUS = 97,
  anon_sym_DASH_DASH = 98,
  anon_sym_DQUOTE = 99,
  aux_sym_string_token1 = 100,
  anon_sym_SQUOTE = 101,
  aux_sym_string_token2 = 102,
  sym_escape_sequence = 103,
  sym_comment = 104,
  anon_sym_BQUOTE = 105,
  anon_sym_DOLLAR_LBRACE = 106,
  anon_sym_SLASH2 = 107,
  sym_regex_pattern = 108,
  sym_regex_flags = 109,
  sym_number = 110,
  anon_sym_target = 111,
  sym_this = 112,
  sym_super = 113,
  sym_true = 114,
  sym_false = 115,
  sym_null = 116,
  sym_undefined = 117,
  anon_sym_AT = 118,
  anon_sym_static = 119,
  anon_sym_get = 120,
  anon_sym_set = 121,
  sym__automatic_semicolon = 122,
  sym__template_chars = 123,
  sym_program = 124,
  sym_export_statement = 125,
  sym_export_clause = 126,
  sym__import_export_specifier = 127,
  sym_declaration = 128,
  sym_import = 129,
  sym_import_statement = 130,
  sym_import_clause = 131,
  sym__from_clause = 132,
  sym_namespace_import = 133,
  sym_named_imports = 134,
  sym_expression_statement = 135,
  sym_variable_declaration = 136,
  sym_lexical_declaration = 137,
  sym_variable_declarator = 138,
  sym_statement_block = 139,
  sym_else_clause = 140,
  sym_if_statement = 141,
  sym_switch_statement = 142,
  sym_for_statement = 143,
  sym_for_in_statement = 144,
  sym__for_header = 145,
  sym_while_statement = 146,
  sym_do_statement = 147,
  sym_try_statement = 148,
  sym_with_statement = 149,
  sym_break_statement = 150,
  sym_continue_statement = 151,
  sym_debugger_statement = 152,
  sym_return_statement = 153,
  sym_throw_statement = 154,
  sym_empty_statement = 155,
  sym_labeled_statement = 156,
  sym_switch_body = 157,
  sym_switch_case = 158,
  sym_switch_default = 159,
  sym_catch_clause = 160,
  sym_finally_clause = 161,
  sym_parenthesized_expression = 162,
  sym_expression = 163,
  sym_primary_expression = 164,
  sym_yield_expression = 165,
  sym_object = 166,
  sym_object_pattern = 167,
  sym_assignment_pattern = 168,
  sym_object_assignment_pattern = 169,
  sym_array = 170,
  sym_array_pattern = 171,
  sym_jsx_element = 172,
  sym_jsx_fragment = 173,
  sym_jsx_expression = 174,
  sym_jsx_opening_element = 175,
  sym_nested_identifier = 176,
  sym_jsx_namespace_name = 177,
  sym_jsx_closing_element = 178,
  sym_jsx_self_closing_element = 179,
  sym_jsx_attribute = 180,
  sym_class = 181,
  sym_class_declaration = 182,
  sym_class_heritage = 183,
  sym_function = 184,
  sym_function_declaration = 185,
  sym_generator_function = 186,
  sym_generator_function_declaration = 187,
  sym_arrow_function = 188,
  sym_call_expression = 189,
  sym_new_expression = 190,
  sym_await_expression = 191,
  sym_member_expression = 192,
  sym_subscript_expression = 193,
  sym_assignment_expression = 194,
  sym__augmented_assignment_lhs = 195,
  sym_augmented_assignment_expression = 196,
  sym__initializer = 197,
  sym__destructuring_pattern = 198,
  sym_spread_element = 199,
  sym_ternary_expression = 200,
  sym_binary_expression = 201,
  sym_unary_expression = 202,
  sym_update_expression = 203,
  sym_sequence_expression = 204,
  sym_string = 205,
  sym_template_string = 206,
  sym_template_substitution = 207,
  sym_regex = 208,
  sym_meta_property = 209,
  sym_arguments = 210,
  sym_decorator = 211,
  sym_decorator_member_expression = 212,
  sym_decorator_call_expression = 213,
  sym_class_body = 214,
  sym_public_field_definition = 215,
  sym_formal_parameters = 216,
  sym_pattern = 217,
  sym_rest_pattern = 218,
  sym_method_definition = 219,
  sym_pair = 220,
  sym_pair_pattern = 221,
  sym__property_name = 222,
  sym_computed_property_name = 223,
  aux_sym_program_repeat1 = 224,
  aux_sym_export_statement_repeat1 = 225,
  aux_sym_export_clause_repeat1 = 226,
  aux_sym_named_imports_repeat1 = 227,
  aux_sym_variable_declaration_repeat1 = 228,
  aux_sym_switch_body_repeat1 = 229,
  aux_sym_object_repeat1 = 230,
  aux_sym_object_pattern_repeat1 = 231,
  aux_sym_array_repeat1 = 232,
  aux_sym_array_pattern_repeat1 = 233,
  aux_sym_jsx_element_repeat1 = 234,
  aux_sym_jsx_opening_element_repeat1 = 235,
  aux_sym_string_repeat1 = 236,
  aux_sym_string_repeat2 = 237,
  aux_sym_template_string_repeat1 = 238,
  aux_sym_class_body_repeat1 = 239,
  aux_sym_formal_parameters_repeat1 = 240,
  alias_sym_import_specifier = 241,
  alias_sym_property_identifier = 242,
  alias_sym_shorthand_property_identifier = 243,
  alias_sym_shorthand_property_identifier_pattern = 244,
  alias_sym_statement_identifier = 245,
};

static const char *ts_symbol_names[] = {
  [ts_builtin_sym_end] = "end",
  [sym_identifier] = "identifier",
  [sym_hash_bang_line] = "hash_bang_line",
  [anon_sym_export] = "export",
  [anon_sym_STAR] = "*",
  [anon_sym_default] = "default",
  [anon_sym_LBRACE] = "{",
  [anon_sym_COMMA] = ",",
  [anon_sym_RBRACE] = "}",
  [anon_sym_as] = "as",
  [anon_sym_import] = "import",
  [anon_sym_from] = "from",
  [anon_sym_var] = "var",
  [anon_sym_let] = "let",
  [anon_sym_const] = "const",
  [anon_sym_else] = "else",
  [anon_sym_if] = "if",
  [anon_sym_switch] = "switch",
  [anon_sym_for] = "for",
  [anon_sym_LPAREN] = "(",
  [anon_sym_RPAREN] = ")",
  [anon_sym_await] = "await",
  [anon_sym_in] = "in",
  [anon_sym_of] = "of",
  [anon_sym_while] = "while",
  [anon_sym_do] = "do",
  [anon_sym_try] = "try",
  [anon_sym_with] = "with",
  [anon_sym_break] = "break",
  [anon_sym_continue] = "continue",
  [anon_sym_debugger] = "debugger",
  [anon_sym_return] = "return",
  [anon_sym_throw] = "throw",
  [anon_sym_SEMI] = ";",
  [anon_sym_COLON] = ":",
  [anon_sym_case] = "case",
  [anon_sym_catch] = "catch",
  [anon_sym_finally] = "finally",
  [anon_sym_yield] = "yield",
  [anon_sym_EQ] = "=",
  [anon_sym_LBRACK] = "[",
  [anon_sym_RBRACK] = "]",
  [anon_sym_LT] = "<",
  [anon_sym_GT] = ">",
  [anon_sym_SLASH] = "/",
  [sym_jsx_text] = "jsx_text",
  [sym_jsx_identifier] = "identifier",
  [anon_sym_DOT] = ".",
  [anon_sym_class] = "class",
  [anon_sym_extends] = "extends",
  [anon_sym_async] = "async",
  [anon_sym_function] = "function",
  [anon_sym_EQ_GT] = "=>",
  [anon_sym_QMARK_DOT] = "\?.",
  [anon_sym_new] = "new",
  [anon_sym_PLUS_EQ] = "+=",
  [anon_sym_DASH_EQ] = "-=",
  [anon_sym_STAR_EQ] = "*=",
  [anon_sym_SLASH_EQ] = "/=",
  [anon_sym_PERCENT_EQ] = "%=",
  [anon_sym_CARET_EQ] = "^=",
  [anon_sym_AMP_EQ] = "&=",
  [anon_sym_PIPE_EQ] = "|=",
  [anon_sym_GT_GT_EQ] = ">>=",
  [anon_sym_GT_GT_GT_EQ] = ">>>=",
  [anon_sym_LT_LT_EQ] = "<<=",
  [anon_sym_STAR_STAR_EQ] = "**=",
  [anon_sym_AMP_AMP_EQ] = "&&=",
  [anon_sym_PIPE_PIPE_EQ] = "||=",
  [anon_sym_QMARK_QMARK_EQ] = "\?\?=",
  [anon_sym_DOT_DOT_DOT] = "...",
  [anon_sym_QMARK] = "\?",
  [anon_sym_AMP_AMP] = "&&",
  [anon_sym_PIPE_PIPE] = "||",
  [anon_sym_GT_GT] = ">>",
  [anon_sym_GT_GT_GT] = ">>>",
  [anon_sym_LT_LT] = "<<",
  [anon_sym_AMP] = "&",
  [anon_sym_CARET] = "^",
  [anon_sym_PIPE] = "|",
  [anon_sym_PLUS] = "+",
  [anon_sym_DASH] = "-",
  [anon_sym_PERCENT] = "%",
  [anon_sym_STAR_STAR] = "**",
  [anon_sym_LT_EQ] = "<=",
  [anon_sym_EQ_EQ] = "==",
  [anon_sym_EQ_EQ_EQ] = "===",
  [anon_sym_BANG_EQ] = "!=",
  [anon_sym_BANG_EQ_EQ] = "!==",
  [anon_sym_GT_EQ] = ">=",
  [anon_sym_QMARK_QMARK] = "\?\?",
  [anon_sym_instanceof] = "instanceof",
  [anon_sym_BANG] = "!",
  [anon_sym_TILDE] = "~",
  [anon_sym_typeof] = "typeof",
  [anon_sym_void] = "void",
  [anon_sym_delete] = "delete",
  [anon_sym_PLUS_PLUS] = "++",
  [anon_sym_DASH_DASH] = "--",
  [anon_sym_DQUOTE] = "\"",
  [aux_sym_string_token1] = "string_token1",
  [anon_sym_SQUOTE] = "'",
  [aux_sym_string_token2] = "string_token2",
  [sym_escape_sequence] = "escape_sequence",
  [sym_comment] = "comment",
  [anon_sym_BQUOTE] = "`",
  [anon_sym_DOLLAR_LBRACE] = "${",
  [anon_sym_SLASH2] = "/",
  [sym_regex_pattern] = "regex_pattern",
  [sym_regex_flags] = "regex_flags",
  [sym_number] = "number",
  [anon_sym_target] = "target",
  [sym_this] = "this",
  [sym_super] = "super",
  [sym_true] = "true",
  [sym_false] = "false",
  [sym_null] = "null",
  [sym_undefined] = "undefined",
  [anon_sym_AT] = "@",
  [anon_sym_static] = "static",
  [anon_sym_get] = "get",
  [anon_sym_set] = "set",
  [sym__automatic_semicolon] = "_automatic_semicolon",
  [sym__template_chars] = "_template_chars",
  [sym_program] = "program",
  [sym_export_statement] = "export_statement",
  [sym_export_clause] = "export_clause",
  [sym__import_export_specifier] = "export_specifier",
  [sym_declaration] = "declaration",
  [sym_import] = "import",
  [sym_import_statement] = "import_statement",
  [sym_import_clause] = "import_clause",
  [sym__from_clause] = "_from_clause",
  [sym_namespace_import] = "namespace_import",
  [sym_named_imports] = "named_imports",
  [sym_expression_statement] = "expression_statement",
  [sym_variable_declaration] = "variable_declaration",
  [sym_lexical_declaration] = "lexical_declaration",
  [sym_variable_declarator] = "variable_declarator",
  [sym_statement_block] = "statement_block",
  [sym_else_clause] = "else_clause",
  [sym_if_statement] = "if_statement",
  [sym_switch_statement] = "switch_statement",
  [sym_for_statement] = "for_statement",
  [sym_for_in_statement] = "for_in_statement",
  [sym__for_header] = "_for_header",
  [sym_while_statement] = "while_statement",
  [sym_do_statement] = "do_statement",
  [sym_try_statement] = "try_statement",
  [sym_with_statement] = "with_statement",
  [sym_break_statement] = "break_statement",
  [sym_continue_statement] = "continue_statement",
  [sym_debugger_statement] = "debugger_statement",
  [sym_return_statement] = "return_statement",
  [sym_throw_statement] = "throw_statement",
  [sym_empty_statement] = "empty_statement",
  [sym_labeled_statement] = "labeled_statement",
  [sym_switch_body] = "switch_body",
  [sym_switch_case] = "switch_case",
  [sym_switch_default] = "switch_default",
  [sym_catch_clause] = "catch_clause",
  [sym_finally_clause] = "finally_clause",
  [sym_parenthesized_expression] = "parenthesized_expression",
  [sym_expression] = "expression",
  [sym_primary_expression] = "primary_expression",
  [sym_yield_expression] = "yield_expression",
  [sym_object] = "object",
  [sym_object_pattern] = "object_pattern",
  [sym_assignment_pattern] = "assignment_pattern",
  [sym_object_assignment_pattern] = "object_assignment_pattern",
  [sym_array] = "array",
  [sym_array_pattern] = "array_pattern",
  [sym_jsx_element] = "jsx_element",
  [sym_jsx_fragment] = "jsx_fragment",
  [sym_jsx_expression] = "jsx_expression",
  [sym_jsx_opening_element] = "jsx_opening_element",
  [sym_nested_identifier] = "nested_identifier",
  [sym_jsx_namespace_name] = "jsx_namespace_name",
  [sym_jsx_closing_element] = "jsx_closing_element",
  [sym_jsx_self_closing_element] = "jsx_self_closing_element",
  [sym_jsx_attribute] = "jsx_attribute",
  [sym_class] = "class",
  [sym_class_declaration] = "class_declaration",
  [sym_class_heritage] = "class_heritage",
  [sym_function] = "function",
  [sym_function_declaration] = "function_declaration",
  [sym_generator_function] = "generator_function",
  [sym_generator_function_declaration] = "generator_function_declaration",
  [sym_arrow_function] = "arrow_function",
  [sym_call_expression] = "call_expression",
  [sym_new_expression] = "new_expression",
  [sym_await_expression] = "await_expression",
  [sym_member_expression] = "member_expression",
  [sym_subscript_expression] = "subscript_expression",
  [sym_assignment_expression] = "assignment_expression",
  [sym__augmented_assignment_lhs] = "_augmented_assignment_lhs",
  [sym_augmented_assignment_expression] = "augmented_assignment_expression",
  [sym__initializer] = "_initializer",
  [sym__destructuring_pattern] = "_destructuring_pattern",
  [sym_spread_element] = "spread_element",
  [sym_ternary_expression] = "ternary_expression",
  [sym_binary_expression] = "binary_expression",
  [sym_unary_expression] = "unary_expression",
  [sym_update_expression] = "update_expression",
  [sym_sequence_expression] = "sequence_expression",
  [sym_string] = "string",
  [sym_template_string] = "template_string",
  [sym_template_substitution] = "template_substitution",
  [sym_regex] = "regex",
  [sym_meta_property] = "meta_property",
  [sym_arguments] = "arguments",
  [sym_decorator] = "decorator",
  [sym_decorator_member_expression] = "member_expression",
  [sym_decorator_call_expression] = "call_expression",
  [sym_class_body] = "class_body",
  [sym_public_field_definition] = "public_field_definition",
  [sym_formal_parameters] = "formal_parameters",
  [sym_pattern] = "pattern",
  [sym_rest_pattern] = "rest_pattern",
  [sym_method_definition] = "method_definition",
  [sym_pair] = "pair",
  [sym_pair_pattern] = "pair_pattern",
  [sym__property_name] = "_property_name",
  [sym_computed_property_name] = "computed_property_name",
  [aux_sym_program_repeat1] = "program_repeat1",
  [aux_sym_export_statement_repeat1] = "export_statement_repeat1",
  [aux_sym_export_clause_repeat1] = "export_clause_repeat1",
  [aux_sym_named_imports_repeat1] = "named_imports_repeat1",
  [aux_sym_variable_declaration_repeat1] = "variable_declaration_repeat1",
  [aux_sym_switch_body_repeat1] = "switch_body_repeat1",
  [aux_sym_object_repeat1] = "object_repeat1",
  [aux_sym_object_pattern_repeat1] = "object_pattern_repeat1",
  [aux_sym_array_repeat1] = "array_repeat1",
  [aux_sym_array_pattern_repeat1] = "array_pattern_repeat1",
  [aux_sym_jsx_element_repeat1] = "jsx_element_repeat1",
  [aux_sym_jsx_opening_element_repeat1] = "jsx_opening_element_repeat1",
  [aux_sym_string_repeat1] = "string_repeat1",
  [aux_sym_string_repeat2] = "string_repeat2",
  [aux_sym_template_string_repeat1] = "template_string_repeat1",
  [aux_sym_class_body_repeat1] = "class_body_repeat1",
  [aux_sym_formal_parameters_repeat1] = "formal_parameters_repeat1",
  [alias_sym_import_specifier] = "import_specifier",
  [alias_sym_property_identifier] = "property_identifier",
  [alias_sym_shorthand_property_identifier] = "shorthand_property_identifier",
  [alias_sym_shorthand_property_identifier_pattern] = "shorthand_property_identifier_pattern",
  [alias_sym_statement_identifier] = "statement_identifier",
};

static TSSymbol ts_symbol_map[] = {
  [ts_builtin_sym_end] = ts_builtin_sym_end,
  [sym_identifier] = sym_identifier,
  [sym_hash_bang_line] = sym_hash_bang_line,
  [anon_sym_export] = anon_sym_export,
  [anon_sym_STAR] = anon_sym_STAR,
  [anon_sym_default] = anon_sym_default,
  [anon_sym_LBRACE] = anon_sym_LBRACE,
  [anon_sym_COMMA] = anon_sym_COMMA,
  [anon_sym_RBRACE] = anon_sym_RBRACE,
  [anon_sym_as] = anon_sym_as,
  [anon_sym_import] = anon_sym_import,
  [anon_sym_from] = anon_sym_from,
  [anon_sym_var] = anon_sym_var,
  [anon_sym_let] = anon_sym_let,
  [anon_sym_const] = anon_sym_const,
  [anon_sym_else] = anon_sym_else,
  [anon_sym_if] = anon_sym_if,
  [anon_sym_switch] = anon_sym_switch,
  [anon_sym_for] = anon_sym_for,
  [anon_sym_LPAREN] = anon_sym_LPAREN,
  [anon_sym_RPAREN] = anon_sym_RPAREN,
  [anon_sym_await] = anon_sym_await,
  [anon_sym_in] = anon_sym_in,
  [anon_sym_of] = anon_sym_of,
  [anon_sym_while] = anon_sym_while,
  [anon_sym_do] = anon_sym_do,
  [anon_sym_try] = anon_sym_try,
  [anon_sym_with] = anon_sym_with,
  [anon_sym_break] = anon_sym_break,
  [anon_sym_continue] = anon_sym_continue,
  [anon_sym_debugger] = anon_sym_debugger,
  [anon_sym_return] = anon_sym_return,
  [anon_sym_throw] = anon_sym_throw,
  [anon_sym_SEMI] = anon_sym_SEMI,
  [anon_sym_COLON] = anon_sym_COLON,
  [anon_sym_case] = anon_sym_case,
  [anon_sym_catch] = anon_sym_catch,
  [anon_sym_finally] = anon_sym_finally,
  [anon_sym_yield] = anon_sym_yield,
  [anon_sym_EQ] = anon_sym_EQ,
  [anon_sym_LBRACK] = anon_sym_LBRACK,
  [anon_sym_RBRACK] = anon_sym_RBRACK,
  [anon_sym_LT] = anon_sym_LT,
  [anon_sym_GT] = anon_sym_GT,
  [anon_sym_SLASH] = anon_sym_SLASH,
  [sym_jsx_text] = sym_jsx_text,
  [sym_jsx_identifier] = sym_identifier,
  [anon_sym_DOT] = anon_sym_DOT,
  [anon_sym_class] = anon_sym_class,
  [anon_sym_extends] = anon_sym_extends,
  [anon_sym_async] = anon_sym_async,
  [anon_sym_function] = anon_sym_function,
  [anon_sym_EQ_GT] = anon_sym_EQ_GT,
  [anon_sym_QMARK_DOT] = anon_sym_QMARK_DOT,
  [anon_sym_new] = anon_sym_new,
  [anon_sym_PLUS_EQ] = anon_sym_PLUS_EQ,
  [anon_sym_DASH_EQ] = anon_sym_DASH_EQ,
  [anon_sym_STAR_EQ] = anon_sym_STAR_EQ,
  [anon_sym_SLASH_EQ] = anon_sym_SLASH_EQ,
  [anon_sym_PERCENT_EQ] = anon_sym_PERCENT_EQ,
  [anon_sym_CARET_EQ] = anon_sym_CARET_EQ,
  [anon_sym_AMP_EQ] = anon_sym_AMP_EQ,
  [anon_sym_PIPE_EQ] = anon_sym_PIPE_EQ,
  [anon_sym_GT_GT_EQ] = anon_sym_GT_GT_EQ,
  [anon_sym_GT_GT_GT_EQ] = anon_sym_GT_GT_GT_EQ,
  [anon_sym_LT_LT_EQ] = anon_sym_LT_LT_EQ,
  [anon_sym_STAR_STAR_EQ] = anon_sym_STAR_STAR_EQ,
  [anon_sym_AMP_AMP_EQ] = anon_sym_AMP_AMP_EQ,
  [anon_sym_PIPE_PIPE_EQ] = anon_sym_PIPE_PIPE_EQ,
  [anon_sym_QMARK_QMARK_EQ] = anon_sym_QMARK_QMARK_EQ,
  [anon_sym_DOT_DOT_DOT] = anon_sym_DOT_DOT_DOT,
  [anon_sym_QMARK] = anon_sym_QMARK,
  [anon_sym_AMP_AMP] = anon_sym_AMP_AMP,
  [anon_sym_PIPE_PIPE] = anon_sym_PIPE_PIPE,
  [anon_sym_GT_GT] = anon_sym_GT_GT,
  [anon_sym_GT_GT_GT] = anon_sym_GT_GT_GT,
  [anon_sym_LT_LT] = anon_sym_LT_LT,
  [anon_sym_AMP] = anon_sym_AMP,
  [anon_sym_CARET] = anon_sym_CARET,
  [anon_sym_PIPE] = anon_sym_PIPE,
  [anon_sym_PLUS] = anon_sym_PLUS,
  [anon_sym_DASH] = anon_sym_DASH,
  [anon_sym_PERCENT] = anon_sym_PERCENT,
  [anon_sym_STAR_STAR] = anon_sym_STAR_STAR,
  [anon_sym_LT_EQ] = anon_sym_LT_EQ,
  [anon_sym_EQ_EQ] = anon_sym_EQ_EQ,
  [anon_sym_EQ_EQ_EQ] = anon_sym_EQ_EQ_EQ,
  [anon_sym_BANG_EQ] = anon_sym_BANG_EQ,
  [anon_sym_BANG_EQ_EQ] = anon_sym_BANG_EQ_EQ,
  [anon_sym_GT_EQ] = anon_sym_GT_EQ,
  [anon_sym_QMARK_QMARK] = anon_sym_QMARK_QMARK,
  [anon_sym_instanceof] = anon_sym_instanceof,
  [anon_sym_BANG] = anon_sym_BANG,
  [anon_sym_TILDE] = anon_sym_TILDE,
  [anon_sym_typeof] = anon_sym_typeof,
  [anon_sym_void] = anon_sym_void,
  [anon_sym_delete] = anon_sym_delete,
  [anon_sym_PLUS_PLUS] = anon_sym_PLUS_PLUS,
  [anon_sym_DASH_DASH] = anon_sym_DASH_DASH,
  [anon_sym_DQUOTE] = anon_sym_DQUOTE,
  [aux_sym_string_token1] = aux_sym_string_token1,
  [anon_sym_SQUOTE] = anon_sym_SQUOTE,
  [aux_sym_string_token2] = aux_sym_string_token2,
  [sym_escape_sequence] = sym_escape_sequence,
  [sym_comment] = sym_comment,
  [anon_sym_BQUOTE] = anon_sym_BQUOTE,
  [anon_sym_DOLLAR_LBRACE] = anon_sym_DOLLAR_LBRACE,
  [anon_sym_SLASH2] = anon_sym_SLASH,
  [sym_regex_pattern] = sym_regex_pattern,
  [sym_regex_flags] = sym_regex_flags,
  [sym_number] = sym_number,
  [anon_sym_target] = anon_sym_target,
  [sym_this] = sym_this,
  [sym_super] = sym_super,
  [sym_true] = sym_true,
  [sym_false] = sym_false,
  [sym_null] = sym_null,
  [sym_undefined] = sym_undefined,
  [anon_sym_AT] = anon_sym_AT,
  [anon_sym_static] = anon_sym_static,
  [anon_sym_get] = anon_sym_get,
  [anon_sym_set] = anon_sym_set,
  [sym__automatic_semicolon] = sym__automatic_semicolon,
  [sym__template_chars] = sym__template_chars,
  [sym_program] = sym_program,
  [sym_export_statement] = sym_export_statement,
  [sym_export_clause] = sym_export_clause,
  [sym__import_export_specifier] = sym__import_export_specifier,
  [sym_declaration] = sym_declaration,
  [sym_import] = sym_import,
  [sym_import_statement] = sym_import_statement,
  [sym_import_clause] = sym_import_clause,
  [sym__from_clause] = sym__from_clause,
  [sym_namespace_import] = sym_namespace_import,
  [sym_named_imports] = sym_named_imports,
  [sym_expression_statement] = sym_expression_statement,
  [sym_variable_declaration] = sym_variable_declaration,
  [sym_lexical_declaration] = sym_lexical_declaration,
  [sym_variable_declarator] = sym_variable_declarator,
  [sym_statement_block] = sym_statement_block,
  [sym_else_clause] = sym_else_clause,
  [sym_if_statement] = sym_if_statement,
  [sym_switch_statement] = sym_switch_statement,
  [sym_for_statement] = sym_for_statement,
  [sym_for_in_statement] = sym_for_in_statement,
  [sym__for_header] = sym__for_header,
  [sym_while_statement] = sym_while_statement,
  [sym_do_statement] = sym_do_statement,
  [sym_try_statement] = sym_try_statement,
  [sym_with_statement] = sym_with_statement,
  [sym_break_statement] = sym_break_statement,
  [sym_continue_statement] = sym_continue_statement,
  [sym_debugger_statement] = sym_debugger_statement,
  [sym_return_statement] = sym_return_statement,
  [sym_throw_statement] = sym_throw_statement,
  [sym_empty_statement] = sym_empty_statement,
  [sym_labeled_statement] = sym_labeled_statement,
  [sym_switch_body] = sym_switch_body,
  [sym_switch_case] = sym_switch_case,
  [sym_switch_default] = sym_switch_default,
  [sym_catch_clause] = sym_catch_clause,
  [sym_finally_clause] = sym_finally_clause,
  [sym_parenthesized_expression] = sym_parenthesized_expression,
  [sym_expression] = sym_expression,
  [sym_primary_expression] = sym_primary_expression,
  [sym_yield_expression] = sym_yield_expression,
  [sym_object] = sym_object,
  [sym_object_pattern] = sym_object_pattern,
  [sym_assignment_pattern] = sym_assignment_pattern,
  [sym_object_assignment_pattern] = sym_object_assignment_pattern,
  [sym_array] = sym_array,
  [sym_array_pattern] = sym_array_pattern,
  [sym_jsx_element] = sym_jsx_element,
  [sym_jsx_fragment] = sym_jsx_fragment,
  [sym_jsx_expression] = sym_jsx_expression,
  [sym_jsx_opening_element] = sym_jsx_opening_element,
  [sym_nested_identifier] = sym_nested_identifier,
  [sym_jsx_namespace_name] = sym_jsx_namespace_name,
  [sym_jsx_closing_element] = sym_jsx_closing_element,
  [sym_jsx_self_closing_element] = sym_jsx_self_closing_element,
  [sym_jsx_attribute] = sym_jsx_attribute,
  [sym_class] = sym_class,
  [sym_class_declaration] = sym_class_declaration,
  [sym_class_heritage] = sym_class_heritage,
  [sym_function] = sym_function,
  [sym_function_declaration] = sym_function_declaration,
  [sym_generator_function] = sym_generator_function,
  [sym_generator_function_declaration] = sym_generator_function_declaration,
  [sym_arrow_function] = sym_arrow_function,
  [sym_call_expression] = sym_call_expression,
  [sym_new_expression] = sym_new_expression,
  [sym_await_expression] = sym_await_expression,
  [sym_member_expression] = sym_member_expression,
  [sym_subscript_expression] = sym_subscript_expression,
  [sym_assignment_expression] = sym_assignment_expression,
  [sym__augmented_assignment_lhs] = sym__augmented_assignment_lhs,
  [sym_augmented_assignment_expression] = sym_augmented_assignment_expression,
  [sym__initializer] = sym__initializer,
  [sym__destructuring_pattern] = sym__destructuring_pattern,
  [sym_spread_element] = sym_spread_element,
  [sym_ternary_expression] = sym_ternary_expression,
  [sym_binary_expression] = sym_binary_expression,
  [sym_unary_expression] = sym_unary_expression,
  [sym_update_expression] = sym_update_expression,
  [sym_sequence_expression] = sym_sequence_expression,
  [sym_string] = sym_string,
  [sym_template_string] = sym_template_string,
  [sym_template_substitution] = sym_template_substitution,
  [sym_regex] = sym_regex,
  [sym_meta_property] = sym_meta_property,
  [sym_arguments] = sym_arguments,
  [sym_decorator] = sym_decorator,
  [sym_decorator_member_expression] = sym_member_expression,
  [sym_decorator_call_expression] = sym_call_expression,
  [sym_class_body] = sym_class_body,
  [sym_public_field_definition] = sym_public_field_definition,
  [sym_formal_parameters] = sym_formal_parameters,
  [sym_pattern] = sym_pattern,
  [sym_rest_pattern] = sym_rest_pattern,
  [sym_method_definition] = sym_method_definition,
  [sym_pair] = sym_pair,
  [sym_pair_pattern] = sym_pair_pattern,
  [sym__property_name] = sym__property_name,
  [sym_computed_property_name] = sym_computed_property_name,
  [aux_sym_program_repeat1] = aux_sym_program_repeat1,
  [aux_sym_export_statement_repeat1] = aux_sym_export_statement_repeat1,
  [aux_sym_export_clause_repeat1] = aux_sym_export_clause_repeat1,
  [aux_sym_named_imports_repeat1] = aux_sym_named_imports_repeat1,
  [aux_sym_variable_declaration_repeat1] = aux_sym_variable_declaration_repeat1,
  [aux_sym_switch_body_repeat1] = aux_sym_switch_body_repeat1,
  [aux_sym_object_repeat1] = aux_sym_object_repeat1,
  [aux_sym_object_pattern_repeat1] = aux_sym_object_pattern_repeat1,
  [aux_sym_array_repeat1] = aux_sym_array_repeat1,
  [aux_sym_array_pattern_repeat1] = aux_sym_array_pattern_repeat1,
  [aux_sym_jsx_element_repeat1] = aux_sym_jsx_element_repeat1,
  [aux_sym_jsx_opening_element_repeat1] = aux_sym_jsx_opening_element_repeat1,
  [aux_sym_string_repeat1] = aux_sym_string_repeat1,
  [aux_sym_string_repeat2] = aux_sym_string_repeat2,
  [aux_sym_template_string_repeat1] = aux_sym_template_string_repeat1,
  [aux_sym_class_body_repeat1] = aux_sym_class_body_repeat1,
  [aux_sym_formal_parameters_repeat1] = aux_sym_formal_parameters_repeat1,
  [alias_sym_import_specifier] = alias_sym_import_specifier,
  [alias_sym_property_identifier] = alias_sym_property_identifier,
  [alias_sym_shorthand_property_identifier] = alias_sym_shorthand_property_identifier,
  [alias_sym_shorthand_property_identifier_pattern] = alias_sym_shorthand_property_identifier_pattern,
  [alias_sym_statement_identifier] = alias_sym_statement_identifier,
};

static const TSSymbolMetadata ts_symbol_metadata[] = {
  [ts_builtin_sym_end] = {
    .visible = false,
    .named = true,
  },
  [sym_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_hash_bang_line] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_export] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_default] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COMMA] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_as] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_import] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_from] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_var] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_let] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_const] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_else] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_if] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_switch] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_for] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_await] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_in] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_of] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_while] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_do] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_try] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_with] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_break] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_continue] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_debugger] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_return] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_throw] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SEMI] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_case] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_catch] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_finally] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_yield] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH] = {
    .visible = true,
    .named = false,
  },
  [sym_jsx_text] = {
    .visible = true,
    .named = true,
  },
  [sym_jsx_identifier] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_class] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_extends] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_async] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_function] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_QMARK_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_new] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CARET_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_STAR_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_AMP_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_PIPE_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_QMARK_QMARK_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT_DOT_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_QMARK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CARET] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_EQ_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG_EQ_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_QMARK_QMARK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_instanceof] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_TILDE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_typeof] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_void] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_delete] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_string_token1] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_SQUOTE] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_string_token2] = {
    .visible = false,
    .named = false,
  },
  [sym_escape_sequence] = {
    .visible = true,
    .named = true,
  },
  [sym_comment] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_BQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOLLAR_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH2] = {
    .visible = true,
    .named = false,
  },
  [sym_regex_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_regex_flags] = {
    .visible = true,
    .named = true,
  },
  [sym_number] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_target] = {
    .visible = true,
    .named = false,
  },
  [sym_this] = {
    .visible = true,
    .named = true,
  },
  [sym_super] = {
    .visible = true,
    .named = true,
  },
  [sym_true] = {
    .visible = true,
    .named = true,
  },
  [sym_false] = {
    .visible = true,
    .named = true,
  },
  [sym_null] = {
    .visible = true,
    .named = true,
  },
  [sym_undefined] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_AT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_static] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_get] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_set] = {
    .visible = true,
    .named = false,
  },
  [sym__automatic_semicolon] = {
    .visible = false,
    .named = true,
  },
  [sym__template_chars] = {
    .visible = false,
    .named = true,
  },
  [sym_program] = {
    .visible = true,
    .named = true,
  },
  [sym_export_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_export_clause] = {
    .visible = true,
    .named = true,
  },
  [sym__import_export_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym_declaration] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_import] = {
    .visible = true,
    .named = true,
  },
  [sym_import_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_import_clause] = {
    .visible = true,
    .named = true,
  },
  [sym__from_clause] = {
    .visible = false,
    .named = true,
  },
  [sym_namespace_import] = {
    .visible = true,
    .named = true,
  },
  [sym_named_imports] = {
    .visible = true,
    .named = true,
  },
  [sym_expression_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_variable_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_lexical_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_variable_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_statement_block] = {
    .visible = true,
    .named = true,
  },
  [sym_else_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_if_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_switch_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_for_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_for_in_statement] = {
    .visible = true,
    .named = true,
  },
  [sym__for_header] = {
    .visible = false,
    .named = true,
  },
  [sym_while_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_do_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_try_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_with_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_break_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_continue_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_debugger_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_return_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_throw_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_empty_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_labeled_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_switch_body] = {
    .visible = true,
    .named = true,
  },
  [sym_switch_case] = {
    .visible = true,
    .named = true,
  },
  [sym_switch_default] = {
    .visible = true,
    .named = true,
  },
  [sym_catch_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_finally_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_parenthesized_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_expression] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_primary_expression] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_yield_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_object] = {
    .visible = true,
    .named = true,
  },
  [sym_object_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_assignment_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_object_assignment_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_array] = {
    .visible = true,
    .named = true,
  },
  [sym_array_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_jsx_element] = {
    .visible = true,
    .named = true,
  },
  [sym_jsx_fragment] = {
    .visible = true,
    .named = true,
  },
  [sym_jsx_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_jsx_opening_element] = {
    .visible = true,
    .named = true,
  },
  [sym_nested_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_jsx_namespace_name] = {
    .visible = true,
    .named = true,
  },
  [sym_jsx_closing_element] = {
    .visible = true,
    .named = true,
  },
  [sym_jsx_self_closing_element] = {
    .visible = true,
    .named = true,
  },
  [sym_jsx_attribute] = {
    .visible = true,
    .named = true,
  },
  [sym_class] = {
    .visible = true,
    .named = true,
  },
  [sym_class_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_class_heritage] = {
    .visible = true,
    .named = true,
  },
  [sym_function] = {
    .visible = true,
    .named = true,
  },
  [sym_function_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_generator_function] = {
    .visible = true,
    .named = true,
  },
  [sym_generator_function_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_arrow_function] = {
    .visible = true,
    .named = true,
  },
  [sym_call_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_new_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_await_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_member_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_subscript_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_assignment_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__augmented_assignment_lhs] = {
    .visible = false,
    .named = true,
  },
  [sym_augmented_assignment_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__initializer] = {
    .visible = false,
    .named = true,
  },
  [sym__destructuring_pattern] = {
    .visible = false,
    .named = true,
  },
  [sym_spread_element] = {
    .visible = true,
    .named = true,
  },
  [sym_ternary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_binary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_unary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_update_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_sequence_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_string] = {
    .visible = true,
    .named = true,
  },
  [sym_template_string] = {
    .visible = true,
    .named = true,
  },
  [sym_template_substitution] = {
    .visible = true,
    .named = true,
  },
  [sym_regex] = {
    .visible = true,
    .named = true,
  },
  [sym_meta_property] = {
    .visible = true,
    .named = true,
  },
  [sym_arguments] = {
    .visible = true,
    .named = true,
  },
  [sym_decorator] = {
    .visible = true,
    .named = true,
  },
  [sym_decorator_member_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_decorator_call_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_class_body] = {
    .visible = true,
    .named = true,
  },
  [sym_public_field_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_formal_parameters] = {
    .visible = true,
    .named = true,
  },
  [sym_pattern] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_rest_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_method_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_pair] = {
    .visible = true,
    .named = true,
  },
  [sym_pair_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym__property_name] = {
    .visible = false,
    .named = true,
  },
  [sym_computed_property_name] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_program_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_export_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_export_clause_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_named_imports_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_variable_declaration_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_switch_body_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_object_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_object_pattern_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_array_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_array_pattern_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_jsx_element_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_jsx_opening_element_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_string_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_string_repeat2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_template_string_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_class_body_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_formal_parameters_repeat1] = {
    .visible = false,
    .named = false,
  },
  [alias_sym_import_specifier] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_property_identifier] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_shorthand_property_identifier] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_shorthand_property_identifier_pattern] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_statement_identifier] = {
    .visible = true,
    .named = true,
  },
};

enum {
  field_alias = 1,
  field_alternative = 2,
  field_argument = 3,
  field_arguments = 4,
  field_attribute = 5,
  field_body = 6,
  field_close_tag = 7,
  field_condition = 8,
  field_consequence = 9,
  field_constructor = 10,
  field_declaration = 11,
  field_decorator = 12,
  field_finalizer = 13,
  field_flags = 14,
  field_function = 15,
  field_handler = 16,
  field_increment = 17,
  field_index = 18,
  field_initializer = 19,
  field_key = 20,
  field_label = 21,
  field_left = 22,
  field_member = 23,
  field_name = 24,
  field_object = 25,
  field_open_tag = 26,
  field_operator = 27,
  field_parameter = 28,
  field_parameters = 29,
  field_pattern = 30,
  field_property = 31,
  field_right = 32,
  field_source = 33,
  field_value = 34,
};

static const char *ts_field_names[] = {
  [0] = NULL,
  [field_alias] = "alias",
  [field_alternative] = "alternative",
  [field_argument] = "argument",
  [field_arguments] = "arguments",
  [field_attribute] = "attribute",
  [field_body] = "body",
  [field_close_tag] = "close_tag",
  [field_condition] = "condition",
  [field_consequence] = "consequence",
  [field_constructor] = "constructor",
  [field_declaration] = "declaration",
  [field_decorator] = "decorator",
  [field_finalizer] = "finalizer",
  [field_flags] = "flags",
  [field_function] = "function",
  [field_handler] = "handler",
  [field_increment] = "increment",
  [field_index] = "index",
  [field_initializer] = "initializer",
  [field_key] = "key",
  [field_label] = "label",
  [field_left] = "left",
  [field_member] = "member",
  [field_name] = "name",
  [field_object] = "object",
  [field_open_tag] = "open_tag",
  [field_operator] = "operator",
  [field_parameter] = "parameter",
  [field_parameters] = "parameters",
  [field_pattern] = "pattern",
  [field_property] = "property",
  [field_right] = "right",
  [field_source] = "source",
  [field_value] = "value",
};

static const TSFieldMapSlice ts_field_map_slices[PRODUCTION_ID_COUNT] = {
  [2] = {.index = 0, .length = 1},
  [3] = {.index = 1, .length = 1},
  [5] = {.index = 2, .length = 1},
  [6] = {.index = 3, .length = 1},
  [7] = {.index = 4, .length = 1},
  [8] = {.index = 5, .length = 2},
  [9] = {.index = 7, .length = 2},
  [10] = {.index = 9, .length = 2},
  [11] = {.index = 11, .length = 2},
  [12] = {.index = 13, .length = 2},
  [13] = {.index = 15, .length = 1},
  [14] = {.index = 16, .length = 2},
  [15] = {.index = 18, .length = 2},
  [18] = {.index = 20, .length = 1},
  [19] = {.index = 21, .length = 2},
  [20] = {.index = 23, .length = 2},
  [21] = {.index = 25, .length = 2},
  [22] = {.index = 27, .length = 3},
  [23] = {.index = 30, .length = 2},
  [24] = {.index = 32, .length = 2},
  [25] = {.index = 34, .length = 2},
  [26] = {.index = 36, .length = 2},
  [27] = {.index = 38, .length = 1},
  [28] = {.index = 39, .length = 1},
  [29] = {.index = 40, .length = 1},
  [30] = {.index = 41, .length = 1},
  [31] = {.index = 42, .length = 1},
  [32] = {.index = 43, .length = 1},
  [33] = {.index = 44, .length = 2},
  [34] = {.index = 46, .length = 1},
  [35] = {.index = 47, .length = 2},
  [36] = {.index = 49, .length = 2},
  [37] = {.index = 16, .length = 2},
  [38] = {.index = 18, .length = 2},
  [39] = {.index = 51, .length = 3},
  [40] = {.index = 54, .length = 2},
  [41] = {.index = 56, .length = 2},
  [42] = {.index = 58, .length = 2},
  [43] = {.index = 60, .length = 2},
  [44] = {.index = 62, .length = 2},
  [45] = {.index = 64, .length = 2},
  [46] = {.index = 66, .length = 1},
  [47] = {.index = 67, .length = 1},
  [48] = {.index = 68, .length = 2},
  [49] = {.index = 16, .length = 2},
  [50] = {.index = 70, .length = 2},
  [51] = {.index = 72, .length = 3},
  [52] = {.index = 68, .length = 2},
  [53] = {.index = 75, .length = 1},
  [54] = {.index = 76, .length = 3},
  [55] = {.index = 79, .length = 3},
  [56] = {.index = 82, .length = 3},
  [57] = {.index = 85, .length = 2},
  [58] = {.index = 87, .length = 2},
  [59] = {.index = 89, .length = 2},
  [60] = {.index = 91, .length = 1},
  [61] = {.index = 92, .length = 2},
  [62] = {.index = 94, .length = 1},
  [63] = {.index = 95, .length = 2},
  [64] = {.index = 97, .length = 2},
  [65] = {.index = 99, .length = 2},
  [66] = {.index = 101, .length = 2},
  [67] = {.index = 99, .length = 2},
  [68] = {.index = 103, .length = 2},
  [69] = {.index = 105, .length = 3},
  [70] = {.index = 108, .length = 2},
  [71] = {.index = 110, .length = 3},
  [72] = {.index = 113, .length = 2},
  [73] = {.index = 115, .length = 2},
  [74] = {.index = 117, .length = 4},
  [75] = {.index = 121, .length = 2},
  [76] = {.index = 123, .length = 2},
  [77] = {.index = 125, .length = 2},
  [78] = {.index = 127, .length = 3},
  [79] = {.index = 130, .length = 2},
  [80] = {.index = 132, .length = 3},
  [81] = {.index = 135, .length = 1},
  [82] = {.index = 136, .length = 2},
  [83] = {.index = 138, .length = 3},
  [84] = {.index = 141, .length = 4},
  [85] = {.index = 145, .length = 2},
  [86] = {.index = 145, .length = 2},
  [87] = {.index = 147, .length = 3},
  [88] = {.index = 150, .length = 3},
  [89] = {.index = 153, .length = 4},
  [90] = {.index = 157, .length = 2},
  [91] = {.index = 159, .length = 4},
  [92] = {.index = 163, .length = 2},
  [93] = {.index = 165, .length = 4},
};

static const TSFieldMapEntry ts_field_map_entries[] = {
  [0] =
    {field_decorator, 0},
  [1] =
    {field_declaration, 1},
  [2] =
    {field_name, 0},
  [3] =
    {field_body, 1},
  [4] =
    {field_constructor, 1},
  [5] =
    {field_argument, 1},
    {field_operator, 0},
  [7] =
    {field_argument, 0},
    {field_operator, 1},
  [9] =
    {field_arguments, 1},
    {field_function, 0},
  [11] =
    {field_close_tag, 1},
    {field_open_tag, 0},
  [13] =
    {field_decorator, 0, .inherited = true},
    {field_decorator, 1, .inherited = true},
  [15] =
    {field_label, 0},
  [16] =
    {field_left, 0},
    {field_right, 2},
  [18] =
    {field_body, 2},
    {field_parameter, 0},
  [20] =
    {field_source, 1},
  [21] =
    {field_name, 0},
    {field_value, 1, .inherited = true},
  [23] =
    {field_condition, 1},
    {field_consequence, 2},
  [25] =
    {field_body, 2},
    {field_value, 1},
  [27] =
    {field_body, 2},
    {field_left, 1, .inherited = true},
    {field_right, 1, .inherited = true},
  [30] =
    {field_body, 2},
    {field_condition, 1},
  [32] =
    {field_body, 1},
    {field_handler, 2},
  [34] =
    {field_body, 1},
    {field_finalizer, 2},
  [36] =
    {field_body, 2},
    {field_object, 1},
  [38] =
    {field_label, 1},
  [39] =
    {field_name, 1},
  [40] =
    {field_attribute, 0},
  [41] =
    {field_pattern, 1},
  [42] =
    {field_member, 0},
  [43] =
    {field_property, 0},
  [44] =
    {field_body, 2},
    {field_name, 1},
  [46] =
    {field_body, 2},
  [47] =
    {field_body, 2},
    {field_parameters, 1},
  [49] =
    {field_arguments, 2},
    {field_constructor, 1},
  [51] =
    {field_left, 0},
    {field_operator, 1},
    {field_right, 2},
  [54] =
    {field_object, 0},
    {field_property, 2},
  [56] =
    {field_arguments, 2},
    {field_function, 0},
  [58] =
    {field_close_tag, 2},
    {field_open_tag, 0},
  [60] =
    {field_body, 2},
    {field_parameters, 0},
  [62] =
    {field_declaration, 2},
    {field_decorator, 0, .inherited = true},
  [64] =
    {field_body, 2},
    {field_decorator, 0, .inherited = true},
  [66] =
    {field_source, 2, .inherited = true},
  [67] =
    {field_value, 2},
  [68] =
    {field_alias, 1, .inherited = true},
    {field_name, 1, .inherited = true},
  [70] =
    {field_key, 0},
    {field_value, 2},
  [72] =
    {field_body, 2},
    {field_name, 0},
    {field_parameters, 1},
  [75] =
    {field_value, 1},
  [76] =
    {field_alternative, 3},
    {field_condition, 1},
    {field_consequence, 2},
  [79] =
    {field_body, 3},
    {field_left, 2, .inherited = true},
    {field_right, 2, .inherited = true},
  [82] =
    {field_body, 1},
    {field_finalizer, 3},
    {field_handler, 2},
  [85] =
    {field_attribute, 2, .inherited = true},
    {field_name, 1},
  [87] =
    {field_attribute, 0, .inherited = true},
    {field_attribute, 1, .inherited = true},
  [89] =
    {field_flags, 3},
    {field_pattern, 1},
  [91] =
    {field_property, 1},
  [92] =
    {field_property, 0},
    {field_value, 1, .inherited = true},
  [94] =
    {field_member, 1, .inherited = true},
  [95] =
    {field_member, 0, .inherited = true},
    {field_member, 1, .inherited = true},
  [97] =
    {field_body, 3},
    {field_name, 1},
  [99] =
    {field_body, 3},
    {field_parameter, 1},
  [101] =
    {field_body, 3},
    {field_parameters, 2},
  [103] =
    {field_body, 3},
    {field_parameters, 1},
  [105] =
    {field_body, 3},
    {field_name, 1},
    {field_parameters, 2},
  [108] =
    {field_index, 2},
    {field_object, 0},
  [110] =
    {field_body, 3},
    {field_decorator, 0, .inherited = true},
    {field_name, 2},
  [113] =
    {field_body, 3},
    {field_decorator, 0, .inherited = true},
  [115] =
    {field_alias, 2},
    {field_name, 0},
  [117] =
    {field_body, 3},
    {field_decorator, 0, .inherited = true},
    {field_name, 1},
    {field_parameters, 2},
  [121] =
    {field_body, 1},
    {field_condition, 3},
  [123] =
    {field_property, 1},
    {field_value, 2, .inherited = true},
  [125] =
    {field_body, 4},
    {field_parameters, 3},
  [127] =
    {field_body, 4},
    {field_name, 2},
    {field_parameters, 3},
  [130] =
    {field_index, 3},
    {field_object, 0},
  [132] =
    {field_alternative, 4},
    {field_condition, 0},
    {field_consequence, 2},
  [135] =
    {field_name, 2},
  [136] =
    {field_decorator, 0, .inherited = true},
    {field_value, 3},
  [138] =
    {field_body, 4},
    {field_decorator, 0, .inherited = true},
    {field_name, 2},
  [141] =
    {field_body, 4},
    {field_decorator, 0, .inherited = true},
    {field_name, 2},
    {field_parameters, 3},
  [145] =
    {field_left, 1},
    {field_right, 3},
  [147] =
    {field_body, 5},
    {field_condition, 3},
    {field_initializer, 2},
  [150] =
    {field_body, 5},
    {field_name, 3},
    {field_parameters, 4},
  [153] =
    {field_body, 5},
    {field_decorator, 0, .inherited = true},
    {field_name, 3},
    {field_parameters, 4},
  [157] =
    {field_left, 2},
    {field_right, 4},
  [159] =
    {field_body, 6},
    {field_condition, 3},
    {field_increment, 4},
    {field_initializer, 2},
  [163] =
    {field_body, 4},
    {field_parameter, 2},
  [165] =
    {field_body, 6},
    {field_decorator, 0, .inherited = true},
    {field_name, 4},
    {field_parameters, 5},
};

static TSSymbol ts_alias_sequences[PRODUCTION_ID_COUNT][MAX_ALIAS_SEQUENCE_LENGTH] = {
  [0] = {0},
  [1] = {
    [0] = sym_identifier,
  },
  [4] = {
    [0] = alias_sym_property_identifier,
  },
  [13] = {
    [0] = alias_sym_statement_identifier,
  },
  [14] = {
    [0] = sym_identifier,
  },
  [15] = {
    [0] = sym_identifier,
  },
  [16] = {
    [1] = alias_sym_shorthand_property_identifier,
  },
  [17] = {
    [1] = alias_sym_shorthand_property_identifier_pattern,
  },
  [27] = {
    [1] = alias_sym_statement_identifier,
  },
  [40] = {
    [2] = alias_sym_property_identifier,
  },
  [49] = {
    [0] = alias_sym_shorthand_property_identifier_pattern,
  },
  [52] = {
    [1] = alias_sym_import_specifier,
  },
  [65] = {
    [1] = sym_identifier,
  },
  [85] = {
    [1] = sym_identifier,
  },
};

static uint16_t ts_non_terminal_alias_map[] = {
  sym__import_export_specifier, 2,
    sym__import_export_specifier,
    alias_sym_import_specifier,
  0,
};

static inline bool sym_identifier_character_set_1(int32_t c) {
  return (c < '`'
    ? (c < '%'
      ? (c < 0
        ? c == 0
        : c <= '#')
      : (c <= '/' || (c < '['
        ? (c >= ':' && c <= '@')
        : c <= '^')))
    : (c <= '`' || (c < 8203
      ? (c < 160
        ? (c >= '{' && c <= '~')
        : c <= 160)
      : (c <= 8203 || (c < 65279
        ? c == 8288
        : c <= 65279)))));
}

static bool ts_lex(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (eof) ADVANCE(57);
      if (lookahead == '!') ADVANCE(146);
      if (lookahead == '"') ADVANCE(150);
      if (lookahead == '#') ADVANCE(2);
      if (lookahead == '$') ADVANCE(187);
      if (lookahead == '%') ADVANCE(134);
      if (lookahead == '&') ADVANCE(123);
      if (lookahead == '\'') ADVANCE(157);
      if (lookahead == '(') ADVANCE(65);
      if (lookahead == ')') ADVANCE(66);
      if (lookahead == '*') ADVANCE(60);
      if (lookahead == '+') ADVANCE(130);
      if (lookahead == ',') ADVANCE(63);
      if (lookahead == '-') ADVANCE(132);
      if (lookahead == '.') ADVANCE(91);
      if (lookahead == '/') ADVANCE(172);
      if (lookahead == '0') ADVANCE(177);
      if (lookahead == ':') ADVANCE(68);
      if (lookahead == ';') ADVANCE(67);
      if (lookahead == '<') ADVANCE(76);
      if (lookahead == '=') ADVANCE(71);
      if (lookahead == '>') ADVANCE(79);
      if (lookahead == '?') ADVANCE(111);
      if (lookahead == '@') ADVANCE(189);
      if (lookahead == '[') ADVANCE(73);
      if (lookahead == '\\') ADVANCE(22);
      if (lookahead == ']') ADVANCE(74);
      if (lookahead == '^') ADVANCE(126);
      if (lookahead == '`') ADVANCE(170);
      if (lookahead == '{') ADVANCE(62);
      if (lookahead == '|') ADVANCE(127);
      if (lookahead == '}') ADVANCE(64);
      if (lookahead == '~') ADVANCE(147);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(54)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(178);
      if (lookahead != 0 &&
          lookahead > 31) ADVANCE(188);
      END_STATE();
    case 1:
      if (lookahead == '\n') SKIP(18)
      if (lookahead == '/') ADVANCE(11);
      if (lookahead == '[') ADVANCE(21);
      if (lookahead == '\\') ADVANCE(53);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) ADVANCE(173);
      if (lookahead != 0) ADVANCE(174);
      END_STATE();
    case 2:
      if (lookahead == '!') ADVANCE(58);
      END_STATE();
    case 3:
      if (lookahead == '!') ADVANCE(145);
      if (lookahead == '"') ADVANCE(150);
      if (lookahead == '\'') ADVANCE(157);
      if (lookahead == '(') ADVANCE(65);
      if (lookahead == '+') ADVANCE(129);
      if (lookahead == '-') ADVANCE(131);
      if (lookahead == '.') ADVANCE(92);
      if (lookahead == '/') ADVANCE(81);
      if (lookahead == '0') ADVANCE(177);
      if (lookahead == ':') ADVANCE(68);
      if (lookahead == '<') ADVANCE(75);
      if (lookahead == '>') ADVANCE(78);
      if (lookahead == '@') ADVANCE(189);
      if (lookahead == '[') ADVANCE(73);
      if (lookahead == '\\') ADVANCE(23);
      if (lookahead == '`') ADVANCE(170);
      if (lookahead == '{') ADVANCE(62);
      if (lookahead == '~') ADVANCE(147);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(3)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(178);
      if (lookahead != 0 &&
          lookahead > '#' &&
          (lookahead < '%' || '?' < lookahead) &&
          lookahead != ']' &&
          lookahead != '^' &&
          lookahead != '|' &&
          lookahead != '}') ADVANCE(188);
      END_STATE();
    case 4:
      if (lookahead == '!') ADVANCE(19);
      if (lookahead == '"') ADVANCE(150);
      if (lookahead == '%') ADVANCE(134);
      if (lookahead == '&') ADVANCE(123);
      if (lookahead == '\'') ADVANCE(157);
      if (lookahead == '(') ADVANCE(65);
      if (lookahead == ')') ADVANCE(66);
      if (lookahead == '*') ADVANCE(60);
      if (lookahead == '+') ADVANCE(130);
      if (lookahead == ',') ADVANCE(63);
      if (lookahead == '-') ADVANCE(132);
      if (lookahead == '.') ADVANCE(92);
      if (lookahead == '/') ADVANCE(82);
      if (lookahead == '0') ADVANCE(177);
      if (lookahead == ':') ADVANCE(68);
      if (lookahead == ';') ADVANCE(67);
      if (lookahead == '<') ADVANCE(76);
      if (lookahead == '=') ADVANCE(71);
      if (lookahead == '>') ADVANCE(79);
      if (lookahead == '?') ADVANCE(111);
      if (lookahead == '@') ADVANCE(189);
      if (lookahead == '[') ADVANCE(73);
      if (lookahead == '\\') ADVANCE(23);
      if (lookahead == ']') ADVANCE(74);
      if (lookahead == '^') ADVANCE(126);
      if (lookahead == '`') ADVANCE(170);
      if (lookahead == '{') ADVANCE(62);
      if (lookahead == '|') ADVANCE(127);
      if (lookahead == '}') ADVANCE(64);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(4)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(178);
      if (lookahead != 0 &&
          lookahead > '#' &&
          lookahead != '~') ADVANCE(188);
      END_STATE();
    case 5:
      if (lookahead == '!') ADVANCE(19);
      if (lookahead == '%') ADVANCE(133);
      if (lookahead == '&') ADVANCE(124);
      if (lookahead == '(') ADVANCE(65);
      if (lookahead == ')') ADVANCE(66);
      if (lookahead == '*') ADVANCE(61);
      if (lookahead == '+') ADVANCE(129);
      if (lookahead == ',') ADVANCE(63);
      if (lookahead == '-') ADVANCE(131);
      if (lookahead == '.') ADVANCE(90);
      if (lookahead == '/') ADVANCE(81);
      if (lookahead == ':') ADVANCE(68);
      if (lookahead == ';') ADVANCE(67);
      if (lookahead == '<') ADVANCE(77);
      if (lookahead == '=') ADVANCE(20);
      if (lookahead == '>') ADVANCE(80);
      if (lookahead == '?') ADVANCE(112);
      if (lookahead == '[') ADVANCE(73);
      if (lookahead == '\\') ADVANCE(23);
      if (lookahead == ']') ADVANCE(74);
      if (lookahead == '^') ADVANCE(125);
      if (lookahead == '`') ADVANCE(170);
      if (lookahead == '{') ADVANCE(62);
      if (lookahead == '|') ADVANCE(128);
      if (lookahead == '}') ADVANCE(64);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(6)
      if (('a' <= lookahead && lookahead <= 'z')) ADVANCE(175);
      if (lookahead != 0 &&
          lookahead > '#' &&
          (lookahead < '\'' || '@' < lookahead) &&
          lookahead != '~') ADVANCE(188);
      END_STATE();
    case 6:
      if (lookahead == '!') ADVANCE(19);
      if (lookahead == '%') ADVANCE(133);
      if (lookahead == '&') ADVANCE(124);
      if (lookahead == '(') ADVANCE(65);
      if (lookahead == ')') ADVANCE(66);
      if (lookahead == '*') ADVANCE(61);
      if (lookahead == '+') ADVANCE(129);
      if (lookahead == ',') ADVANCE(63);
      if (lookahead == '-') ADVANCE(131);
      if (lookahead == '.') ADVANCE(90);
      if (lookahead == '/') ADVANCE(81);
      if (lookahead == ':') ADVANCE(68);
      if (lookahead == ';') ADVANCE(67);
      if (lookahead == '<') ADVANCE(77);
      if (lookahead == '=') ADVANCE(20);
      if (lookahead == '>') ADVANCE(80);
      if (lookahead == '?') ADVANCE(112);
      if (lookahead == '[') ADVANCE(73);
      if (lookahead == '\\') ADVANCE(23);
      if (lookahead == ']') ADVANCE(74);
      if (lookahead == '^') ADVANCE(125);
      if (lookahead == '`') ADVANCE(170);
      if (lookahead == '{') ADVANCE(62);
      if (lookahead == '|') ADVANCE(128);
      if (lookahead == '}') ADVANCE(64);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(6)
      if (lookahead != 0 &&
          lookahead > '#' &&
          (lookahead < '\'' || '@' < lookahead) &&
          lookahead != '~') ADVANCE(188);
      END_STATE();
    case 7:
      if (lookahead == '"') ADVANCE(150);
      if (lookahead == '/') ADVANCE(152);
      if (lookahead == '\\') ADVANCE(24);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) ADVANCE(155);
      if (lookahead != 0) ADVANCE(156);
      END_STATE();
    case 8:
      if (lookahead == '$') ADVANCE(25);
      if (lookahead == '/') ADVANCE(172);
      if (lookahead == '\\') ADVANCE(24);
      if (lookahead == '`') ADVANCE(170);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(9)
      END_STATE();
    case 9:
      if (lookahead == '$') ADVANCE(25);
      if (lookahead == '/') ADVANCE(11);
      if (lookahead == '`') ADVANCE(170);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(9)
      END_STATE();
    case 10:
      if (lookahead == '\'') ADVANCE(157);
      if (lookahead == '/') ADVANCE(159);
      if (lookahead == '\\') ADVANCE(24);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) ADVANCE(162);
      if (lookahead != 0) ADVANCE(163);
      END_STATE();
    case 11:
      if (lookahead == '*') ADVANCE(13);
      if (lookahead == '/') ADVANCE(169);
      END_STATE();
    case 12:
      if (lookahead == '*') ADVANCE(12);
      if (lookahead == '/') ADVANCE(168);
      if (lookahead != 0) ADVANCE(13);
      END_STATE();
    case 13:
      if (lookahead == '*') ADVANCE(12);
      if (lookahead != 0) ADVANCE(13);
      END_STATE();
    case 14:
      if (lookahead == '.') ADVANCE(15);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(184);
      END_STATE();
    case 15:
      if (lookahead == '.') ADVANCE(110);
      END_STATE();
    case 16:
      if (lookahead == '.') ADVANCE(90);
      if (lookahead == '/') ADVANCE(81);
      if (lookahead == ':') ADVANCE(68);
      if (lookahead == '=') ADVANCE(69);
      if (lookahead == '>') ADVANCE(78);
      if (lookahead == '\\') ADVANCE(23);
      if (lookahead == '{') ADVANCE(62);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(16)
      if (lookahead == '$' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(186);
      if (lookahead != 0 &&
          lookahead > '~') ADVANCE(188);
      END_STATE();
    case 17:
      if (lookahead == '/') ADVANCE(84);
      if (lookahead == '<') ADVANCE(75);
      if (lookahead == '{') ADVANCE(62);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) ADVANCE(87);
      if (lookahead != 0 &&
          lookahead != '>' &&
          lookahead != '}') ADVANCE(88);
      END_STATE();
    case 18:
      if (lookahead == '/') ADVANCE(11);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(18)
      END_STATE();
    case 19:
      if (lookahead == '=') ADVANCE(140);
      END_STATE();
    case 20:
      if (lookahead == '=') ADVANCE(138);
      END_STATE();
    case 21:
      if (lookahead == '\\') ADVANCE(52);
      if (lookahead == ']') ADVANCE(174);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(21);
      END_STATE();
    case 22:
      if (lookahead == 'u') ADVANCE(26);
      if (lookahead == 'x') ADVANCE(47);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(167);
      if (lookahead != 0) ADVANCE(164);
      END_STATE();
    case 23:
      if (lookahead == 'u') ADVANCE(27);
      END_STATE();
    case 24:
      if (lookahead == 'u') ADVANCE(28);
      if (lookahead == 'x') ADVANCE(47);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(167);
      if (lookahead != 0) ADVANCE(164);
      END_STATE();
    case 25:
      if (lookahead == '{') ADVANCE(171);
      END_STATE();
    case 26:
      if (lookahead == '{') ADVANCE(42);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(50);
      END_STATE();
    case 27:
      if (lookahead == '{') ADVANCE(45);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(51);
      END_STATE();
    case 28:
      if (lookahead == '{') ADVANCE(46);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(44);
      END_STATE();
    case 29:
      if (lookahead == '}') ADVANCE(188);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(29);
      END_STATE();
    case 30:
      if (lookahead == '}') ADVANCE(164);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(30);
      END_STATE();
    case 31:
      if (lookahead == '}') ADVANCE(165);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(31);
      END_STATE();
    case 32:
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(38);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(183);
      END_STATE();
    case 33:
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(179);
      END_STATE();
    case 34:
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(180);
      END_STATE();
    case 35:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(178);
      END_STATE();
    case 36:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(184);
      END_STATE();
    case 37:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(182);
      END_STATE();
    case 38:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(183);
      END_STATE();
    case 39:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(188);
      END_STATE();
    case 40:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(164);
      END_STATE();
    case 41:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(181);
      END_STATE();
    case 42:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(31);
      END_STATE();
    case 43:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(165);
      END_STATE();
    case 44:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(47);
      END_STATE();
    case 45:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(29);
      END_STATE();
    case 46:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(30);
      END_STATE();
    case 47:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(40);
      END_STATE();
    case 48:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(43);
      END_STATE();
    case 49:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(39);
      END_STATE();
    case 50:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(48);
      END_STATE();
    case 51:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(49);
      END_STATE();
    case 52:
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(21);
      END_STATE();
    case 53:
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(174);
      END_STATE();
    case 54:
      if (eof) ADVANCE(57);
      if (lookahead == '!') ADVANCE(146);
      if (lookahead == '"') ADVANCE(150);
      if (lookahead == '#') ADVANCE(2);
      if (lookahead == '$') ADVANCE(187);
      if (lookahead == '%') ADVANCE(134);
      if (lookahead == '&') ADVANCE(123);
      if (lookahead == '\'') ADVANCE(157);
      if (lookahead == '(') ADVANCE(65);
      if (lookahead == ')') ADVANCE(66);
      if (lookahead == '*') ADVANCE(60);
      if (lookahead == '+') ADVANCE(130);
      if (lookahead == ',') ADVANCE(63);
      if (lookahead == '-') ADVANCE(132);
      if (lookahead == '.') ADVANCE(91);
      if (lookahead == '/') ADVANCE(81);
      if (lookahead == '0') ADVANCE(177);
      if (lookahead == ':') ADVANCE(68);
      if (lookahead == ';') ADVANCE(67);
      if (lookahead == '<') ADVANCE(76);
      if (lookahead == '=') ADVANCE(71);
      if (lookahead == '>') ADVANCE(79);
      if (lookahead == '?') ADVANCE(111);
      if (lookahead == '@') ADVANCE(189);
      if (lookahead == '[') ADVANCE(73);
      if (lookahead == '\\') ADVANCE(23);
      if (lookahead == ']') ADVANCE(74);
      if (lookahead == '^') ADVANCE(126);
      if (lookahead == '`') ADVANCE(170);
      if (lookahead == '{') ADVANCE(62);
      if (lookahead == '|') ADVANCE(127);
      if (lookahead == '}') ADVANCE(64);
      if (lookahead == '~') ADVANCE(147);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(54)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(178);
      if (lookahead != 0 &&
          lookahead > 31) ADVANCE(188);
      END_STATE();
    case 55:
      if (eof) ADVANCE(57);
      if (lookahead == '!') ADVANCE(146);
      if (lookahead == '"') ADVANCE(150);
      if (lookahead == '%') ADVANCE(133);
      if (lookahead == '&') ADVANCE(124);
      if (lookahead == '\'') ADVANCE(157);
      if (lookahead == '(') ADVANCE(65);
      if (lookahead == ')') ADVANCE(66);
      if (lookahead == '*') ADVANCE(61);
      if (lookahead == '+') ADVANCE(129);
      if (lookahead == ',') ADVANCE(63);
      if (lookahead == '-') ADVANCE(131);
      if (lookahead == '.') ADVANCE(92);
      if (lookahead == '/') ADVANCE(81);
      if (lookahead == '0') ADVANCE(177);
      if (lookahead == ':') ADVANCE(68);
      if (lookahead == ';') ADVANCE(67);
      if (lookahead == '<') ADVANCE(77);
      if (lookahead == '=') ADVANCE(70);
      if (lookahead == '>') ADVANCE(80);
      if (lookahead == '?') ADVANCE(112);
      if (lookahead == '@') ADVANCE(189);
      if (lookahead == '[') ADVANCE(73);
      if (lookahead == '\\') ADVANCE(23);
      if (lookahead == ']') ADVANCE(74);
      if (lookahead == '^') ADVANCE(125);
      if (lookahead == '`') ADVANCE(170);
      if (lookahead == '{') ADVANCE(62);
      if (lookahead == '|') ADVANCE(128);
      if (lookahead == '}') ADVANCE(64);
      if (lookahead == '~') ADVANCE(147);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(55)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(178);
      if (lookahead != 0 &&
          lookahead > '#') ADVANCE(188);
      END_STATE();
    case 56:
      if (eof) ADVANCE(57);
      if (lookahead == '!') ADVANCE(145);
      if (lookahead == '"') ADVANCE(150);
      if (lookahead == '#') ADVANCE(2);
      if (lookahead == '\'') ADVANCE(157);
      if (lookahead == '(') ADVANCE(65);
      if (lookahead == ')') ADVANCE(66);
      if (lookahead == '*') ADVANCE(59);
      if (lookahead == '+') ADVANCE(129);
      if (lookahead == ',') ADVANCE(63);
      if (lookahead == '-') ADVANCE(131);
      if (lookahead == '.') ADVANCE(14);
      if (lookahead == '/') ADVANCE(81);
      if (lookahead == '0') ADVANCE(177);
      if (lookahead == ':') ADVANCE(68);
      if (lookahead == ';') ADVANCE(67);
      if (lookahead == '<') ADVANCE(75);
      if (lookahead == '=') ADVANCE(72);
      if (lookahead == '>') ADVANCE(78);
      if (lookahead == '@') ADVANCE(189);
      if (lookahead == '[') ADVANCE(73);
      if (lookahead == '\\') ADVANCE(23);
      if (lookahead == ']') ADVANCE(74);
      if (lookahead == '`') ADVANCE(170);
      if (lookahead == '{') ADVANCE(62);
      if (lookahead == '}') ADVANCE(64);
      if (lookahead == '~') ADVANCE(147);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(56)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(178);
      if (lookahead != 0 &&
          lookahead > 31 &&
          (lookahead < '%' || '?' < lookahead) &&
          lookahead != '^' &&
          lookahead != '|') ADVANCE(188);
      END_STATE();
    case 57:
      ACCEPT_TOKEN(ts_builtin_sym_end);
      END_STATE();
    case 58:
      ACCEPT_TOKEN(sym_hash_bang_line);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(58);
      END_STATE();
    case 59:
      ACCEPT_TOKEN(anon_sym_STAR);
      END_STATE();
    case 60:
      ACCEPT_TOKEN(anon_sym_STAR);
      if (lookahead == '*') ADVANCE(136);
      if (lookahead == '=') ADVANCE(97);
      END_STATE();
    case 61:
      ACCEPT_TOKEN(anon_sym_STAR);
      if (lookahead == '*') ADVANCE(135);
      END_STATE();
    case 62:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      END_STATE();
    case 63:
      ACCEPT_TOKEN(anon_sym_COMMA);
      END_STATE();
    case 64:
      ACCEPT_TOKEN(anon_sym_RBRACE);
      END_STATE();
    case 65:
      ACCEPT_TOKEN(anon_sym_LPAREN);
      END_STATE();
    case 66:
      ACCEPT_TOKEN(anon_sym_RPAREN);
      END_STATE();
    case 67:
      ACCEPT_TOKEN(anon_sym_SEMI);
      END_STATE();
    case 68:
      ACCEPT_TOKEN(anon_sym_COLON);
      END_STATE();
    case 69:
      ACCEPT_TOKEN(anon_sym_EQ);
      END_STATE();
    case 70:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '=') ADVANCE(138);
      END_STATE();
    case 71:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '=') ADVANCE(138);
      if (lookahead == '>') ADVANCE(93);
      END_STATE();
    case 72:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '>') ADVANCE(93);
      END_STATE();
    case 73:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      END_STATE();
    case 74:
      ACCEPT_TOKEN(anon_sym_RBRACK);
      END_STATE();
    case 75:
      ACCEPT_TOKEN(anon_sym_LT);
      END_STATE();
    case 76:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '<') ADVANCE(122);
      if (lookahead == '=') ADVANCE(137);
      END_STATE();
    case 77:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '<') ADVANCE(121);
      if (lookahead == '=') ADVANCE(137);
      END_STATE();
    case 78:
      ACCEPT_TOKEN(anon_sym_GT);
      END_STATE();
    case 79:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=') ADVANCE(142);
      if (lookahead == '>') ADVANCE(117);
      END_STATE();
    case 80:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=') ADVANCE(142);
      if (lookahead == '>') ADVANCE(118);
      END_STATE();
    case 81:
      ACCEPT_TOKEN(anon_sym_SLASH);
      if (lookahead == '*') ADVANCE(13);
      if (lookahead == '/') ADVANCE(169);
      END_STATE();
    case 82:
      ACCEPT_TOKEN(anon_sym_SLASH);
      if (lookahead == '*') ADVANCE(13);
      if (lookahead == '/') ADVANCE(169);
      if (lookahead == '=') ADVANCE(98);
      END_STATE();
    case 83:
      ACCEPT_TOKEN(sym_jsx_text);
      if (lookahead == '\n') ADVANCE(88);
      if (lookahead == '<' ||
          lookahead == '>' ||
          lookahead == '{' ||
          lookahead == '}') ADVANCE(169);
      if (lookahead != 0) ADVANCE(83);
      END_STATE();
    case 84:
      ACCEPT_TOKEN(sym_jsx_text);
      if (lookahead == '*') ADVANCE(86);
      if (lookahead == '/') ADVANCE(83);
      if (lookahead != 0 &&
          lookahead != '<' &&
          lookahead != '>' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(88);
      END_STATE();
    case 85:
      ACCEPT_TOKEN(sym_jsx_text);
      if (lookahead == '*') ADVANCE(85);
      if (lookahead == '/') ADVANCE(88);
      if (lookahead == '<' ||
          lookahead == '>' ||
          lookahead == '{' ||
          lookahead == '}') ADVANCE(13);
      if (lookahead != 0) ADVANCE(86);
      END_STATE();
    case 86:
      ACCEPT_TOKEN(sym_jsx_text);
      if (lookahead == '*') ADVANCE(85);
      if (lookahead == '<' ||
          lookahead == '>' ||
          lookahead == '{' ||
          lookahead == '}') ADVANCE(13);
      if (lookahead != 0) ADVANCE(86);
      END_STATE();
    case 87:
      ACCEPT_TOKEN(sym_jsx_text);
      if (lookahead == '/') ADVANCE(84);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) ADVANCE(87);
      if (lookahead != 0 &&
          lookahead != '<' &&
          lookahead != '>' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(88);
      END_STATE();
    case 88:
      ACCEPT_TOKEN(sym_jsx_text);
      if (lookahead != 0 &&
          lookahead != '<' &&
          lookahead != '>' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(88);
      END_STATE();
    case 89:
      ACCEPT_TOKEN(sym_jsx_identifier);
      if (lookahead == '$' ||
          lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(89);
      END_STATE();
    case 90:
      ACCEPT_TOKEN(anon_sym_DOT);
      END_STATE();
    case 91:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (lookahead == '.') ADVANCE(15);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(184);
      END_STATE();
    case 92:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(184);
      END_STATE();
    case 93:
      ACCEPT_TOKEN(anon_sym_EQ_GT);
      END_STATE();
    case 94:
      ACCEPT_TOKEN(anon_sym_QMARK_DOT);
      END_STATE();
    case 95:
      ACCEPT_TOKEN(anon_sym_PLUS_EQ);
      END_STATE();
    case 96:
      ACCEPT_TOKEN(anon_sym_DASH_EQ);
      END_STATE();
    case 97:
      ACCEPT_TOKEN(anon_sym_STAR_EQ);
      END_STATE();
    case 98:
      ACCEPT_TOKEN(anon_sym_SLASH_EQ);
      END_STATE();
    case 99:
      ACCEPT_TOKEN(anon_sym_PERCENT_EQ);
      END_STATE();
    case 100:
      ACCEPT_TOKEN(anon_sym_CARET_EQ);
      END_STATE();
    case 101:
      ACCEPT_TOKEN(anon_sym_AMP_EQ);
      END_STATE();
    case 102:
      ACCEPT_TOKEN(anon_sym_PIPE_EQ);
      END_STATE();
    case 103:
      ACCEPT_TOKEN(anon_sym_GT_GT_EQ);
      END_STATE();
    case 104:
      ACCEPT_TOKEN(anon_sym_GT_GT_GT_EQ);
      END_STATE();
    case 105:
      ACCEPT_TOKEN(anon_sym_LT_LT_EQ);
      END_STATE();
    case 106:
      ACCEPT_TOKEN(anon_sym_STAR_STAR_EQ);
      END_STATE();
    case 107:
      ACCEPT_TOKEN(anon_sym_AMP_AMP_EQ);
      END_STATE();
    case 108:
      ACCEPT_TOKEN(anon_sym_PIPE_PIPE_EQ);
      END_STATE();
    case 109:
      ACCEPT_TOKEN(anon_sym_QMARK_QMARK_EQ);
      END_STATE();
    case 110:
      ACCEPT_TOKEN(anon_sym_DOT_DOT_DOT);
      END_STATE();
    case 111:
      ACCEPT_TOKEN(anon_sym_QMARK);
      if (lookahead == '.') ADVANCE(94);
      if (lookahead == '?') ADVANCE(144);
      END_STATE();
    case 112:
      ACCEPT_TOKEN(anon_sym_QMARK);
      if (lookahead == '.') ADVANCE(94);
      if (lookahead == '?') ADVANCE(143);
      END_STATE();
    case 113:
      ACCEPT_TOKEN(anon_sym_AMP_AMP);
      END_STATE();
    case 114:
      ACCEPT_TOKEN(anon_sym_AMP_AMP);
      if (lookahead == '=') ADVANCE(107);
      END_STATE();
    case 115:
      ACCEPT_TOKEN(anon_sym_PIPE_PIPE);
      END_STATE();
    case 116:
      ACCEPT_TOKEN(anon_sym_PIPE_PIPE);
      if (lookahead == '=') ADVANCE(108);
      END_STATE();
    case 117:
      ACCEPT_TOKEN(anon_sym_GT_GT);
      if (lookahead == '=') ADVANCE(103);
      if (lookahead == '>') ADVANCE(120);
      END_STATE();
    case 118:
      ACCEPT_TOKEN(anon_sym_GT_GT);
      if (lookahead == '>') ADVANCE(119);
      END_STATE();
    case 119:
      ACCEPT_TOKEN(anon_sym_GT_GT_GT);
      END_STATE();
    case 120:
      ACCEPT_TOKEN(anon_sym_GT_GT_GT);
      if (lookahead == '=') ADVANCE(104);
      END_STATE();
    case 121:
      ACCEPT_TOKEN(anon_sym_LT_LT);
      END_STATE();
    case 122:
      ACCEPT_TOKEN(anon_sym_LT_LT);
      if (lookahead == '=') ADVANCE(105);
      END_STATE();
    case 123:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '&') ADVANCE(114);
      if (lookahead == '=') ADVANCE(101);
      END_STATE();
    case 124:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '&') ADVANCE(113);
      END_STATE();
    case 125:
      ACCEPT_TOKEN(anon_sym_CARET);
      END_STATE();
    case 126:
      ACCEPT_TOKEN(anon_sym_CARET);
      if (lookahead == '=') ADVANCE(100);
      END_STATE();
    case 127:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '=') ADVANCE(102);
      if (lookahead == '|') ADVANCE(116);
      END_STATE();
    case 128:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '|') ADVANCE(115);
      END_STATE();
    case 129:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '+') ADVANCE(148);
      END_STATE();
    case 130:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '+') ADVANCE(148);
      if (lookahead == '=') ADVANCE(95);
      END_STATE();
    case 131:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-') ADVANCE(149);
      END_STATE();
    case 132:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-') ADVANCE(149);
      if (lookahead == '=') ADVANCE(96);
      END_STATE();
    case 133:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      END_STATE();
    case 134:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      if (lookahead == '=') ADVANCE(99);
      END_STATE();
    case 135:
      ACCEPT_TOKEN(anon_sym_STAR_STAR);
      END_STATE();
    case 136:
      ACCEPT_TOKEN(anon_sym_STAR_STAR);
      if (lookahead == '=') ADVANCE(106);
      END_STATE();
    case 137:
      ACCEPT_TOKEN(anon_sym_LT_EQ);
      END_STATE();
    case 138:
      ACCEPT_TOKEN(anon_sym_EQ_EQ);
      if (lookahead == '=') ADVANCE(139);
      END_STATE();
    case 139:
      ACCEPT_TOKEN(anon_sym_EQ_EQ_EQ);
      END_STATE();
    case 140:
      ACCEPT_TOKEN(anon_sym_BANG_EQ);
      if (lookahead == '=') ADVANCE(141);
      END_STATE();
    case 141:
      ACCEPT_TOKEN(anon_sym_BANG_EQ_EQ);
      END_STATE();
    case 142:
      ACCEPT_TOKEN(anon_sym_GT_EQ);
      END_STATE();
    case 143:
      ACCEPT_TOKEN(anon_sym_QMARK_QMARK);
      END_STATE();
    case 144:
      ACCEPT_TOKEN(anon_sym_QMARK_QMARK);
      if (lookahead == '=') ADVANCE(109);
      END_STATE();
    case 145:
      ACCEPT_TOKEN(anon_sym_BANG);
      END_STATE();
    case 146:
      ACCEPT_TOKEN(anon_sym_BANG);
      if (lookahead == '=') ADVANCE(140);
      END_STATE();
    case 147:
      ACCEPT_TOKEN(anon_sym_TILDE);
      END_STATE();
    case 148:
      ACCEPT_TOKEN(anon_sym_PLUS_PLUS);
      END_STATE();
    case 149:
      ACCEPT_TOKEN(anon_sym_DASH_DASH);
      END_STATE();
    case 150:
      ACCEPT_TOKEN(anon_sym_DQUOTE);
      END_STATE();
    case 151:
      ACCEPT_TOKEN(aux_sym_string_token1);
      if (lookahead == '\n') ADVANCE(156);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(151);
      END_STATE();
    case 152:
      ACCEPT_TOKEN(aux_sym_string_token1);
      if (lookahead == '*') ADVANCE(154);
      if (lookahead == '/') ADVANCE(151);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(156);
      END_STATE();
    case 153:
      ACCEPT_TOKEN(aux_sym_string_token1);
      if (lookahead == '*') ADVANCE(153);
      if (lookahead == '/') ADVANCE(156);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(154);
      END_STATE();
    case 154:
      ACCEPT_TOKEN(aux_sym_string_token1);
      if (lookahead == '*') ADVANCE(153);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(154);
      END_STATE();
    case 155:
      ACCEPT_TOKEN(aux_sym_string_token1);
      if (lookahead == '/') ADVANCE(152);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) ADVANCE(155);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(156);
      END_STATE();
    case 156:
      ACCEPT_TOKEN(aux_sym_string_token1);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(156);
      END_STATE();
    case 157:
      ACCEPT_TOKEN(anon_sym_SQUOTE);
      END_STATE();
    case 158:
      ACCEPT_TOKEN(aux_sym_string_token2);
      if (lookahead == '\n') ADVANCE(163);
      if (lookahead != 0 &&
          lookahead != '\'' &&
          lookahead != '\\') ADVANCE(158);
      END_STATE();
    case 159:
      ACCEPT_TOKEN(aux_sym_string_token2);
      if (lookahead == '*') ADVANCE(161);
      if (lookahead == '/') ADVANCE(158);
      if (lookahead != 0 &&
          lookahead != '\'' &&
          lookahead != '\\') ADVANCE(163);
      END_STATE();
    case 160:
      ACCEPT_TOKEN(aux_sym_string_token2);
      if (lookahead == '*') ADVANCE(160);
      if (lookahead == '/') ADVANCE(163);
      if (lookahead != 0 &&
          lookahead != '\'' &&
          lookahead != '\\') ADVANCE(161);
      END_STATE();
    case 161:
      ACCEPT_TOKEN(aux_sym_string_token2);
      if (lookahead == '*') ADVANCE(160);
      if (lookahead != 0 &&
          lookahead != '\'' &&
          lookahead != '\\') ADVANCE(161);
      END_STATE();
    case 162:
      ACCEPT_TOKEN(aux_sym_string_token2);
      if (lookahead == '/') ADVANCE(159);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) ADVANCE(162);
      if (lookahead != 0 &&
          lookahead != '\'' &&
          lookahead != '\\') ADVANCE(163);
      END_STATE();
    case 163:
      ACCEPT_TOKEN(aux_sym_string_token2);
      if (lookahead != 0 &&
          lookahead != '\'' &&
          lookahead != '\\') ADVANCE(163);
      END_STATE();
    case 164:
      ACCEPT_TOKEN(sym_escape_sequence);
      END_STATE();
    case 165:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (lookahead == '\\') ADVANCE(23);
      if (!sym_identifier_character_set_1(lookahead)) ADVANCE(188);
      END_STATE();
    case 166:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(164);
      END_STATE();
    case 167:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(166);
      END_STATE();
    case 168:
      ACCEPT_TOKEN(sym_comment);
      END_STATE();
    case 169:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(169);
      END_STATE();
    case 170:
      ACCEPT_TOKEN(anon_sym_BQUOTE);
      END_STATE();
    case 171:
      ACCEPT_TOKEN(anon_sym_DOLLAR_LBRACE);
      END_STATE();
    case 172:
      ACCEPT_TOKEN(anon_sym_SLASH2);
      if (lookahead == '*') ADVANCE(13);
      if (lookahead == '/') ADVANCE(169);
      END_STATE();
    case 173:
      ACCEPT_TOKEN(sym_regex_pattern);
      if (lookahead == '\n') SKIP(18)
      if (lookahead == '/') ADVANCE(11);
      if (lookahead == '[') ADVANCE(21);
      if (lookahead == '\\') ADVANCE(53);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) ADVANCE(173);
      if (lookahead != 0) ADVANCE(174);
      END_STATE();
    case 174:
      ACCEPT_TOKEN(sym_regex_pattern);
      if (lookahead == '[') ADVANCE(21);
      if (lookahead == '\\') ADVANCE(53);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '/') ADVANCE(174);
      END_STATE();
    case 175:
      ACCEPT_TOKEN(sym_regex_flags);
      if (lookahead == '\\') ADVANCE(23);
      if (('a' <= lookahead && lookahead <= 'z')) ADVANCE(175);
      if (lookahead != 0 &&
          lookahead > '#' &&
          (lookahead < '%' || '/' < lookahead) &&
          (lookahead < ':' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          (lookahead < '`' || '~' < lookahead) &&
          lookahead != 160 &&
          lookahead != 8203 &&
          lookahead != 8288 &&
          lookahead != 65279) ADVANCE(188);
      END_STATE();
    case 176:
      ACCEPT_TOKEN(sym_number);
      END_STATE();
    case 177:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '.') ADVANCE(185);
      if (lookahead == '0') ADVANCE(182);
      if (lookahead == 'B' ||
          lookahead == 'b') ADVANCE(33);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(32);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(34);
      if (lookahead == 'X' ||
          lookahead == 'x') ADVANCE(41);
      if (lookahead == '_') ADVANCE(37);
      if (lookahead == 'n') ADVANCE(176);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(178);
      END_STATE();
    case 178:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '.') ADVANCE(185);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(32);
      if (lookahead == '_') ADVANCE(35);
      if (lookahead == 'n') ADVANCE(176);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(178);
      END_STATE();
    case 179:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '_') ADVANCE(33);
      if (lookahead == 'n') ADVANCE(176);
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(179);
      END_STATE();
    case 180:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '_') ADVANCE(34);
      if (lookahead == 'n') ADVANCE(176);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(180);
      END_STATE();
    case 181:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '_') ADVANCE(41);
      if (lookahead == 'n') ADVANCE(176);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(181);
      END_STATE();
    case 182:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '_') ADVANCE(37);
      if (lookahead == 'n') ADVANCE(176);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(182);
      END_STATE();
    case 183:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '_') ADVANCE(38);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(183);
      END_STATE();
    case 184:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(32);
      if (lookahead == '_') ADVANCE(36);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(184);
      END_STATE();
    case 185:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(32);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(184);
      END_STATE();
    case 186:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '-') ADVANCE(89);
      if (lookahead == '\\') ADVANCE(23);
      if (lookahead == '$' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(186);
      if (lookahead != 0 &&
          lookahead > '~' &&
          lookahead != 160 &&
          lookahead != 8203 &&
          lookahead != 8288 &&
          lookahead != 65279) ADVANCE(188);
      END_STATE();
    case 187:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(23);
      if (lookahead == '{') ADVANCE(171);
      if (lookahead != 0 &&
          lookahead > '#' &&
          (lookahead < '%' || '/' < lookahead) &&
          (lookahead < ':' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '|' || '~' < lookahead) &&
          lookahead != 160 &&
          lookahead != 8203 &&
          lookahead != 8288 &&
          lookahead != 65279) ADVANCE(188);
      END_STATE();
    case 188:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(23);
      if (!sym_identifier_character_set_1(lookahead)) ADVANCE(188);
      END_STATE();
    case 189:
      ACCEPT_TOKEN(anon_sym_AT);
      END_STATE();
    default:
      return false;
  }
}

static bool ts_lex_keywords(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (lookahead == 'a') ADVANCE(1);
      if (lookahead == 'b') ADVANCE(2);
      if (lookahead == 'c') ADVANCE(3);
      if (lookahead == 'd') ADVANCE(4);
      if (lookahead == 'e') ADVANCE(5);
      if (lookahead == 'f') ADVANCE(6);
      if (lookahead == 'g') ADVANCE(7);
      if (lookahead == 'i') ADVANCE(8);
      if (lookahead == 'l') ADVANCE(9);
      if (lookahead == 'n') ADVANCE(10);
      if (lookahead == 'o') ADVANCE(11);
      if (lookahead == 'r') ADVANCE(12);
      if (lookahead == 's') ADVANCE(13);
      if (lookahead == 't') ADVANCE(14);
      if (lookahead == 'u') ADVANCE(15);
      if (lookahead == 'v') ADVANCE(16);
      if (lookahead == 'w') ADVANCE(17);
      if (lookahead == 'y') ADVANCE(18);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(0)
      END_STATE();
    case 1:
      if (lookahead == 's') ADVANCE(19);
      if (lookahead == 'w') ADVANCE(20);
      END_STATE();
    case 2:
      if (lookahead == 'r') ADVANCE(21);
      END_STATE();
    case 3:
      if (lookahead == 'a') ADVANCE(22);
      if (lookahead == 'l') ADVANCE(23);
      if (lookahead == 'o') ADVANCE(24);
      END_STATE();
    case 4:
      if (lookahead == 'e') ADVANCE(25);
      if (lookahead == 'o') ADVANCE(26);
      END_STATE();
    case 5:
      if (lookahead == 'l') ADVANCE(27);
      if (lookahead == 'x') ADVANCE(28);
      END_STATE();
    case 6:
      if (lookahead == 'a') ADVANCE(29);
      if (lookahead == 'i') ADVANCE(30);
      if (lookahead == 'o') ADVANCE(31);
      if (lookahead == 'r') ADVANCE(32);
      if (lookahead == 'u') ADVANCE(33);
      END_STATE();
    case 7:
      if (lookahead == 'e') ADVANCE(34);
      END_STATE();
    case 8:
      if (lookahead == 'f') ADVANCE(35);
      if (lookahead == 'm') ADVANCE(36);
      if (lookahead == 'n') ADVANCE(37);
      END_STATE();
    case 9:
      if (lookahead == 'e') ADVANCE(38);
      END_STATE();
    case 10:
      if (lookahead == 'e') ADVANCE(39);
      if (lookahead == 'u') ADVANCE(40);
      END_STATE();
    case 11:
      if (lookahead == 'f') ADVANCE(41);
      END_STATE();
    case 12:
      if (lookahead == 'e') ADVANCE(42);
      END_STATE();
    case 13:
      if (lookahead == 'e') ADVANCE(43);
      if (lookahead == 't') ADVANCE(44);
      if (lookahead == 'u') ADVANCE(45);
      if (lookahead == 'w') ADVANCE(46);
      END_STATE();
    case 14:
      if (lookahead == 'a') ADVANCE(47);
      if (lookahead == 'h') ADVANCE(48);
      if (lookahead == 'r') ADVANCE(49);
      if (lookahead == 'y') ADVANCE(50);
      END_STATE();
    case 15:
      if (lookahead == 'n') ADVANCE(51);
      END_STATE();
    case 16:
      if (lookahead == 'a') ADVANCE(52);
      if (lookahead == 'o') ADVANCE(53);
      END_STATE();
    case 17:
      if (lookahead == 'h') ADVANCE(54);
      if (lookahead == 'i') ADVANCE(55);
      END_STATE();
    case 18:
      if (lookahead == 'i') ADVANCE(56);
      END_STATE();
    case 19:
      ACCEPT_TOKEN(anon_sym_as);
      if (lookahead == 'y') ADVANCE(57);
      END_STATE();
    case 20:
      if (lookahead == 'a') ADVANCE(58);
      END_STATE();
    case 21:
      if (lookahead == 'e') ADVANCE(59);
      END_STATE();
    case 22:
      if (lookahead == 's') ADVANCE(60);
      if (lookahead == 't') ADVANCE(61);
      END_STATE();
    case 23:
      if (lookahead == 'a') ADVANCE(62);
      END_STATE();
    case 24:
      if (lookahead == 'n') ADVANCE(63);
      END_STATE();
    case 25:
      if (lookahead == 'b') ADVANCE(64);
      if (lookahead == 'f') ADVANCE(65);
      if (lookahead == 'l') ADVANCE(66);
      END_STATE();
    case 26:
      ACCEPT_TOKEN(anon_sym_do);
      END_STATE();
    case 27:
      if (lookahead == 's') ADVANCE(67);
      END_STATE();
    case 28:
      if (lookahead == 'p') ADVANCE(68);
      if (lookahead == 't') ADVANCE(69);
      END_STATE();
    case 29:
      if (lookahead == 'l') ADVANCE(70);
      END_STATE();
    case 30:
      if (lookahead == 'n') ADVANCE(71);
      END_STATE();
    case 31:
      if (lookahead == 'r') ADVANCE(72);
      END_STATE();
    case 32:
      if (lookahead == 'o') ADVANCE(73);
      END_STATE();
    case 33:
      if (lookahead == 'n') ADVANCE(74);
      END_STATE();
    case 34:
      if (lookahead == 't') ADVANCE(75);
      END_STATE();
    case 35:
      ACCEPT_TOKEN(anon_sym_if);
      END_STATE();
    case 36:
      if (lookahead == 'p') ADVANCE(76);
      END_STATE();
    case 37:
      ACCEPT_TOKEN(anon_sym_in);
      if (lookahead == 's') ADVANCE(77);
      END_STATE();
    case 38:
      if (lookahead == 't') ADVANCE(78);
      END_STATE();
    case 39:
      if (lookahead == 'w') ADVANCE(79);
      END_STATE();
    case 40:
      if (lookahead == 'l') ADVANCE(80);
      END_STATE();
    case 41:
      ACCEPT_TOKEN(anon_sym_of);
      END_STATE();
    case 42:
      if (lookahead == 't') ADVANCE(81);
      END_STATE();
    case 43:
      if (lookahead == 't') ADVANCE(82);
      END_STATE();
    case 44:
      if (lookahead == 'a') ADVANCE(83);
      END_STATE();
    case 45:
      if (lookahead == 'p') ADVANCE(84);
      END_STATE();
    case 46:
      if (lookahead == 'i') ADVANCE(85);
      END_STATE();
    case 47:
      if (lookahead == 'r') ADVANCE(86);
      END_STATE();
    case 48:
      if (lookahead == 'i') ADVANCE(87);
      if (lookahead == 'r') ADVANCE(88);
      END_STATE();
    case 49:
      if (lookahead == 'u') ADVANCE(89);
      if (lookahead == 'y') ADVANCE(90);
      END_STATE();
    case 50:
      if (lookahead == 'p') ADVANCE(91);
      END_STATE();
    case 51:
      if (lookahead == 'd') ADVANCE(92);
      END_STATE();
    case 52:
      if (lookahead == 'r') ADVANCE(93);
      END_STATE();
    case 53:
      if (lookahead == 'i') ADVANCE(94);
      END_STATE();
    case 54:
      if (lookahead == 'i') ADVANCE(95);
      END_STATE();
    case 55:
      if (lookahead == 't') ADVANCE(96);
      END_STATE();
    case 56:
      if (lookahead == 'e') ADVANCE(97);
      END_STATE();
    case 57:
      if (lookahead == 'n') ADVANCE(98);
      END_STATE();
    case 58:
      if (lookahead == 'i') ADVANCE(99);
      END_STATE();
    case 59:
      if (lookahead == 'a') ADVANCE(100);
      END_STATE();
    case 60:
      if (lookahead == 'e') ADVANCE(101);
      END_STATE();
    case 61:
      if (lookahead == 'c') ADVANCE(102);
      END_STATE();
    case 62:
      if (lookahead == 's') ADVANCE(103);
      END_STATE();
    case 63:
      if (lookahead == 's') ADVANCE(104);
      if (lookahead == 't') ADVANCE(105);
      END_STATE();
    case 64:
      if (lookahead == 'u') ADVANCE(106);
      END_STATE();
    case 65:
      if (lookahead == 'a') ADVANCE(107);
      END_STATE();
    case 66:
      if (lookahead == 'e') ADVANCE(108);
      END_STATE();
    case 67:
      if (lookahead == 'e') ADVANCE(109);
      END_STATE();
    case 68:
      if (lookahead == 'o') ADVANCE(110);
      END_STATE();
    case 69:
      if (lookahead == 'e') ADVANCE(111);
      END_STATE();
    case 70:
      if (lookahead == 's') ADVANCE(112);
      END_STATE();
    case 71:
      if (lookahead == 'a') ADVANCE(113);
      END_STATE();
    case 72:
      ACCEPT_TOKEN(anon_sym_for);
      END_STATE();
    case 73:
      if (lookahead == 'm') ADVANCE(114);
      END_STATE();
    case 74:
      if (lookahead == 'c') ADVANCE(115);
      END_STATE();
    case 75:
      ACCEPT_TOKEN(anon_sym_get);
      END_STATE();
    case 76:
      if (lookahead == 'o') ADVANCE(116);
      END_STATE();
    case 77:
      if (lookahead == 't') ADVANCE(117);
      END_STATE();
    case 78:
      ACCEPT_TOKEN(anon_sym_let);
      END_STATE();
    case 79:
      ACCEPT_TOKEN(anon_sym_new);
      END_STATE();
    case 80:
      if (lookahead == 'l') ADVANCE(118);
      END_STATE();
    case 81:
      if (lookahead == 'u') ADVANCE(119);
      END_STATE();
    case 82:
      ACCEPT_TOKEN(anon_sym_set);
      END_STATE();
    case 83:
      if (lookahead == 't') ADVANCE(120);
      END_STATE();
    case 84:
      if (lookahead == 'e') ADVANCE(121);
      END_STATE();
    case 85:
      if (lookahead == 't') ADVANCE(122);
      END_STATE();
    case 86:
      if (lookahead == 'g') ADVANCE(123);
      END_STATE();
    case 87:
      if (lookahead == 's') ADVANCE(124);
      END_STATE();
    case 88:
      if (lookahead == 'o') ADVANCE(125);
      END_STATE();
    case 89:
      if (lookahead == 'e') ADVANCE(126);
      END_STATE();
    case 90:
      ACCEPT_TOKEN(anon_sym_try);
      END_STATE();
    case 91:
      if (lookahead == 'e') ADVANCE(127);
      END_STATE();
    case 92:
      if (lookahead == 'e') ADVANCE(128);
      END_STATE();
    case 93:
      ACCEPT_TOKEN(anon_sym_var);
      END_STATE();
    case 94:
      if (lookahead == 'd') ADVANCE(129);
      END_STATE();
    case 95:
      if (lookahead == 'l') ADVANCE(130);
      END_STATE();
    case 96:
      if (lookahead == 'h') ADVANCE(131);
      END_STATE();
    case 97:
      if (lookahead == 'l') ADVANCE(132);
      END_STATE();
    case 98:
      if (lookahead == 'c') ADVANCE(133);
      END_STATE();
    case 99:
      if (lookahead == 't') ADVANCE(134);
      END_STATE();
    case 100:
      if (lookahead == 'k') ADVANCE(135);
      END_STATE();
    case 101:
      ACCEPT_TOKEN(anon_sym_case);
      END_STATE();
    case 102:
      if (lookahead == 'h') ADVANCE(136);
      END_STATE();
    case 103:
      if (lookahead == 's') ADVANCE(137);
      END_STATE();
    case 104:
      if (lookahead == 't') ADVANCE(138);
      END_STATE();
    case 105:
      if (lookahead == 'i') ADVANCE(139);
      END_STATE();
    case 106:
      if (lookahead == 'g') ADVANCE(140);
      END_STATE();
    case 107:
      if (lookahead == 'u') ADVANCE(141);
      END_STATE();
    case 108:
      if (lookahead == 't') ADVANCE(142);
      END_STATE();
    case 109:
      ACCEPT_TOKEN(anon_sym_else);
      END_STATE();
    case 110:
      if (lookahead == 'r') ADVANCE(143);
      END_STATE();
    case 111:
      if (lookahead == 'n') ADVANCE(144);
      END_STATE();
    case 112:
      if (lookahead == 'e') ADVANCE(145);
      END_STATE();
    case 113:
      if (lookahead == 'l') ADVANCE(146);
      END_STATE();
    case 114:
      ACCEPT_TOKEN(anon_sym_from);
      END_STATE();
    case 115:
      if (lookahead == 't') ADVANCE(147);
      END_STATE();
    case 116:
      if (lookahead == 'r') ADVANCE(148);
      END_STATE();
    case 117:
      if (lookahead == 'a') ADVANCE(149);
      END_STATE();
    case 118:
      ACCEPT_TOKEN(sym_null);
      END_STATE();
    case 119:
      if (lookahead == 'r') ADVANCE(150);
      END_STATE();
    case 120:
      if (lookahead == 'i') ADVANCE(151);
      END_STATE();
    case 121:
      if (lookahead == 'r') ADVANCE(152);
      END_STATE();
    case 122:
      if (lookahead == 'c') ADVANCE(153);
      END_STATE();
    case 123:
      if (lookahead == 'e') ADVANCE(154);
      END_STATE();
    case 124:
      ACCEPT_TOKEN(sym_this);
      END_STATE();
    case 125:
      if (lookahead == 'w') ADVANCE(155);
      END_STATE();
    case 126:
      ACCEPT_TOKEN(sym_true);
      END_STATE();
    case 127:
      if (lookahead == 'o') ADVANCE(156);
      END_STATE();
    case 128:
      if (lookahead == 'f') ADVANCE(157);
      END_STATE();
    case 129:
      ACCEPT_TOKEN(anon_sym_void);
      END_STATE();
    case 130:
      if (lookahead == 'e') ADVANCE(158);
      END_STATE();
    case 131:
      ACCEPT_TOKEN(anon_sym_with);
      END_STATE();
    case 132:
      if (lookahead == 'd') ADVANCE(159);
      END_STATE();
    case 133:
      ACCEPT_TOKEN(anon_sym_async);
      END_STATE();
    case 134:
      ACCEPT_TOKEN(anon_sym_await);
      END_STATE();
    case 135:
      ACCEPT_TOKEN(anon_sym_break);
      END_STATE();
    case 136:
      ACCEPT_TOKEN(anon_sym_catch);
      END_STATE();
    case 137:
      ACCEPT_TOKEN(anon_sym_class);
      END_STATE();
    case 138:
      ACCEPT_TOKEN(anon_sym_const);
      END_STATE();
    case 139:
      if (lookahead == 'n') ADVANCE(160);
      END_STATE();
    case 140:
      if (lookahead == 'g') ADVANCE(161);
      END_STATE();
    case 141:
      if (lookahead == 'l') ADVANCE(162);
      END_STATE();
    case 142:
      if (lookahead == 'e') ADVANCE(163);
      END_STATE();
    case 143:
      if (lookahead == 't') ADVANCE(164);
      END_STATE();
    case 144:
      if (lookahead == 'd') ADVANCE(165);
      END_STATE();
    case 145:
      ACCEPT_TOKEN(sym_false);
      END_STATE();
    case 146:
      if (lookahead == 'l') ADVANCE(166);
      END_STATE();
    case 147:
      if (lookahead == 'i') ADVANCE(167);
      END_STATE();
    case 148:
      if (lookahead == 't') ADVANCE(168);
      END_STATE();
    case 149:
      if (lookahead == 'n') ADVANCE(169);
      END_STATE();
    case 150:
      if (lookahead == 'n') ADVANCE(170);
      END_STATE();
    case 151:
      if (lookahead == 'c') ADVANCE(171);
      END_STATE();
    case 152:
      ACCEPT_TOKEN(sym_super);
      END_STATE();
    case 153:
      if (lookahead == 'h') ADVANCE(172);
      END_STATE();
    case 154:
      if (lookahead == 't') ADVANCE(173);
      END_STATE();
    case 155:
      ACCEPT_TOKEN(anon_sym_throw);
      END_STATE();
    case 156:
      if (lookahead == 'f') ADVANCE(174);
      END_STATE();
    case 157:
      if (lookahead == 'i') ADVANCE(175);
      END_STATE();
    case 158:
      ACCEPT_TOKEN(anon_sym_while);
      END_STATE();
    case 159:
      ACCEPT_TOKEN(anon_sym_yield);
      END_STATE();
    case 160:
      if (lookahead == 'u') ADVANCE(176);
      END_STATE();
    case 161:
      if (lookahead == 'e') ADVANCE(177);
      END_STATE();
    case 162:
      if (lookahead == 't') ADVANCE(178);
      END_STATE();
    case 163:
      ACCEPT_TOKEN(anon_sym_delete);
      END_STATE();
    case 164:
      ACCEPT_TOKEN(anon_sym_export);
      END_STATE();
    case 165:
      if (lookahead == 's') ADVANCE(179);
      END_STATE();
    case 166:
      if (lookahead == 'y') ADVANCE(180);
      END_STATE();
    case 167:
      if (lookahead == 'o') ADVANCE(181);
      END_STATE();
    case 168:
      ACCEPT_TOKEN(anon_sym_import);
      END_STATE();
    case 169:
      if (lookahead == 'c') ADVANCE(182);
      END_STATE();
    case 170:
      ACCEPT_TOKEN(anon_sym_return);
      END_STATE();
    case 171:
      ACCEPT_TOKEN(anon_sym_static);
      END_STATE();
    case 172:
      ACCEPT_TOKEN(anon_sym_switch);
      END_STATE();
    case 173:
      ACCEPT_TOKEN(anon_sym_target);
      END_STATE();
    case 174:
      ACCEPT_TOKEN(anon_sym_typeof);
      END_STATE();
    case 175:
      if (lookahead == 'n') ADVANCE(183);
      END_STATE();
    case 176:
      if (lookahead == 'e') ADVANCE(184);
      END_STATE();
    case 177:
      if (lookahead == 'r') ADVANCE(185);
      END_STATE();
    case 178:
      ACCEPT_TOKEN(anon_sym_default);
      END_STATE();
    case 179:
      ACCEPT_TOKEN(anon_sym_extends);
      END_STATE();
    case 180:
      ACCEPT_TOKEN(anon_sym_finally);
      END_STATE();
    case 181:
      if (lookahead == 'n') ADVANCE(186);
      END_STATE();
    case 182:
      if (lookahead == 'e') ADVANCE(187);
      END_STATE();
    case 183:
      if (lookahead == 'e') ADVANCE(188);
      END_STATE();
    case 184:
      ACCEPT_TOKEN(anon_sym_continue);
      END_STATE();
    case 185:
      ACCEPT_TOKEN(anon_sym_debugger);
      END_STATE();
    case 186:
      ACCEPT_TOKEN(anon_sym_function);
      END_STATE();
    case 187:
      if (lookahead == 'o') ADVANCE(189);
      END_STATE();
    case 188:
      if (lookahead == 'd') ADVANCE(190);
      END_STATE();
    case 189:
      if (lookahead == 'f') ADVANCE(191);
      END_STATE();
    case 190:
      ACCEPT_TOKEN(sym_undefined);
      END_STATE();
    case 191:
      ACCEPT_TOKEN(anon_sym_instanceof);
      END_STATE();
    default:
      return false;
  }
}

static TSLexMode ts_lex_modes[STATE_COUNT] = {
  [0] = {.lex_state = 0, .external_lex_state = 1},
  [1] = {.lex_state = 56},
  [2] = {.lex_state = 56},
  [3] = {.lex_state = 56},
  [4] = {.lex_state = 56},
  [5] = {.lex_state = 56},
  [6] = {.lex_state = 56},
  [7] = {.lex_state = 56},
  [8] = {.lex_state = 56},
  [9] = {.lex_state = 56},
  [10] = {.lex_state = 56},
  [11] = {.lex_state = 56},
  [12] = {.lex_state = 56},
  [13] = {.lex_state = 56},
  [14] = {.lex_state = 56},
  [15] = {.lex_state = 56},
  [16] = {.lex_state = 56},
  [17] = {.lex_state = 56},
  [18] = {.lex_state = 56},
  [19] = {.lex_state = 56},
  [20] = {.lex_state = 56},
  [21] = {.lex_state = 56},
  [22] = {.lex_state = 56},
  [23] = {.lex_state = 56},
  [24] = {.lex_state = 56},
  [25] = {.lex_state = 56},
  [26] = {.lex_state = 56},
  [27] = {.lex_state = 56},
  [28] = {.lex_state = 56},
  [29] = {.lex_state = 56},
  [30] = {.lex_state = 56},
  [31] = {.lex_state = 56},
  [32] = {.lex_state = 56},
  [33] = {.lex_state = 56},
  [34] = {.lex_state = 56},
  [35] = {.lex_state = 56},
  [36] = {.lex_state = 56},
  [37] = {.lex_state = 56},
  [38] = {.lex_state = 56},
  [39] = {.lex_state = 56},
  [40] = {.lex_state = 56},
  [41] = {.lex_state = 56},
  [42] = {.lex_state = 56},
  [43] = {.lex_state = 56},
  [44] = {.lex_state = 55},
  [45] = {.lex_state = 55, .external_lex_state = 2},
  [46] = {.lex_state = 55},
  [47] = {.lex_state = 55, .external_lex_state = 2},
  [48] = {.lex_state = 55, .external_lex_state = 2},
  [49] = {.lex_state = 55, .external_lex_state = 2},
  [50] = {.lex_state = 55, .external_lex_state = 2},
  [51] = {.lex_state = 55, .external_lex_state = 2},
  [52] = {.lex_state = 55, .external_lex_state = 2},
  [53] = {.lex_state = 55, .external_lex_state = 2},
  [54] = {.lex_state = 55, .external_lex_state = 2},
  [55] = {.lex_state = 55, .external_lex_state = 2},
  [56] = {.lex_state = 55, .external_lex_state = 2},
  [57] = {.lex_state = 55, .external_lex_state = 2},
  [58] = {.lex_state = 55, .external_lex_state = 2},
  [59] = {.lex_state = 55, .external_lex_state = 2},
  [60] = {.lex_state = 55, .external_lex_state = 2},
  [61] = {.lex_state = 55, .external_lex_state = 2},
  [62] = {.lex_state = 56},
  [63] = {.lex_state = 56},
  [64] = {.lex_state = 56},
  [65] = {.lex_state = 56},
  [66] = {.lex_state = 56},
  [67] = {.lex_state = 56},
  [68] = {.lex_state = 56},
  [69] = {.lex_state = 56},
  [70] = {.lex_state = 56},
  [71] = {.lex_state = 56},
  [72] = {.lex_state = 56},
  [73] = {.lex_state = 56},
  [74] = {.lex_state = 56},
  [75] = {.lex_state = 56},
  [76] = {.lex_state = 56},
  [77] = {.lex_state = 56},
  [78] = {.lex_state = 56},
  [79] = {.lex_state = 56},
  [80] = {.lex_state = 56},
  [81] = {.lex_state = 56},
  [82] = {.lex_state = 56},
  [83] = {.lex_state = 56, .external_lex_state = 2},
  [84] = {.lex_state = 56},
  [85] = {.lex_state = 56},
  [86] = {.lex_state = 56},
  [87] = {.lex_state = 56},
  [88] = {.lex_state = 56},
  [89] = {.lex_state = 56},
  [90] = {.lex_state = 56},
  [91] = {.lex_state = 56},
  [92] = {.lex_state = 4, .external_lex_state = 2},
  [93] = {.lex_state = 56},
  [94] = {.lex_state = 56},
  [95] = {.lex_state = 56},
  [96] = {.lex_state = 3},
  [97] = {.lex_state = 56},
  [98] = {.lex_state = 56},
  [99] = {.lex_state = 56},
  [100] = {.lex_state = 56},
  [101] = {.lex_state = 56},
  [102] = {.lex_state = 56},
  [103] = {.lex_state = 56},
  [104] = {.lex_state = 56},
  [105] = {.lex_state = 56},
  [106] = {.lex_state = 3},
  [107] = {.lex_state = 4, .external_lex_state = 2},
  [108] = {.lex_state = 56},
  [109] = {.lex_state = 56},
  [110] = {.lex_state = 56},
  [111] = {.lex_state = 56},
  [112] = {.lex_state = 56},
  [113] = {.lex_state = 56},
  [114] = {.lex_state = 56},
  [115] = {.lex_state = 56},
  [116] = {.lex_state = 3},
  [117] = {.lex_state = 56},
  [118] = {.lex_state = 56},
  [119] = {.lex_state = 56},
  [120] = {.lex_state = 56},
  [121] = {.lex_state = 4, .external_lex_state = 2},
  [122] = {.lex_state = 3},
  [123] = {.lex_state = 56},
  [124] = {.lex_state = 56},
  [125] = {.lex_state = 56},
  [126] = {.lex_state = 56},
  [127] = {.lex_state = 56},
  [128] = {.lex_state = 56},
  [129] = {.lex_state = 56},
  [130] = {.lex_state = 56},
  [131] = {.lex_state = 56},
  [132] = {.lex_state = 56},
  [133] = {.lex_state = 56},
  [134] = {.lex_state = 56},
  [135] = {.lex_state = 56},
  [136] = {.lex_state = 56},
  [137] = {.lex_state = 56},
  [138] = {.lex_state = 56},
  [139] = {.lex_state = 56},
  [140] = {.lex_state = 56},
  [141] = {.lex_state = 56},
  [142] = {.lex_state = 56},
  [143] = {.lex_state = 56},
  [144] = {.lex_state = 56},
  [145] = {.lex_state = 56},
  [146] = {.lex_state = 56},
  [147] = {.lex_state = 56},
  [148] = {.lex_state = 56},
  [149] = {.lex_state = 56},
  [150] = {.lex_state = 56},
  [151] = {.lex_state = 56},
  [152] = {.lex_state = 56},
  [153] = {.lex_state = 56},
  [154] = {.lex_state = 56},
  [155] = {.lex_state = 56},
  [156] = {.lex_state = 56},
  [157] = {.lex_state = 56},
  [158] = {.lex_state = 56},
  [159] = {.lex_state = 56},
  [160] = {.lex_state = 56},
  [161] = {.lex_state = 56},
  [162] = {.lex_state = 56},
  [163] = {.lex_state = 56},
  [164] = {.lex_state = 56},
  [165] = {.lex_state = 56},
  [166] = {.lex_state = 56},
  [167] = {.lex_state = 56},
  [168] = {.lex_state = 56},
  [169] = {.lex_state = 56},
  [170] = {.lex_state = 56},
  [171] = {.lex_state = 56},
  [172] = {.lex_state = 56},
  [173] = {.lex_state = 56},
  [174] = {.lex_state = 56},
  [175] = {.lex_state = 56},
  [176] = {.lex_state = 56},
  [177] = {.lex_state = 56},
  [178] = {.lex_state = 56},
  [179] = {.lex_state = 56},
  [180] = {.lex_state = 56},
  [181] = {.lex_state = 56},
  [182] = {.lex_state = 56},
  [183] = {.lex_state = 56},
  [184] = {.lex_state = 56},
  [185] = {.lex_state = 56},
  [186] = {.lex_state = 56},
  [187] = {.lex_state = 56},
  [188] = {.lex_state = 56},
  [189] = {.lex_state = 56},
  [190] = {.lex_state = 56},
  [191] = {.lex_state = 56},
  [192] = {.lex_state = 56},
  [193] = {.lex_state = 56},
  [194] = {.lex_state = 56},
  [195] = {.lex_state = 56},
  [196] = {.lex_state = 4, .external_lex_state = 2},
  [197] = {.lex_state = 4, .external_lex_state = 2},
  [198] = {.lex_state = 4, .external_lex_state = 2},
  [199] = {.lex_state = 4, .external_lex_state = 2},
  [200] = {.lex_state = 4, .external_lex_state = 2},
  [201] = {.lex_state = 4, .external_lex_state = 2},
  [202] = {.lex_state = 4, .external_lex_state = 2},
  [203] = {.lex_state = 4, .external_lex_state = 2},
  [204] = {.lex_state = 4, .external_lex_state = 2},
  [205] = {.lex_state = 4, .external_lex_state = 2},
  [206] = {.lex_state = 4, .external_lex_state = 2},
  [207] = {.lex_state = 4},
  [208] = {.lex_state = 56, .external_lex_state = 2},
  [209] = {.lex_state = 56, .external_lex_state = 2},
  [210] = {.lex_state = 4},
  [211] = {.lex_state = 4, .external_lex_state = 2},
  [212] = {.lex_state = 4, .external_lex_state = 2},
  [213] = {.lex_state = 4, .external_lex_state = 2},
  [214] = {.lex_state = 4, .external_lex_state = 2},
  [215] = {.lex_state = 56},
  [216] = {.lex_state = 4, .external_lex_state = 2},
  [217] = {.lex_state = 56},
  [218] = {.lex_state = 56},
  [219] = {.lex_state = 4},
  [220] = {.lex_state = 4},
  [221] = {.lex_state = 56},
  [222] = {.lex_state = 4},
  [223] = {.lex_state = 4},
  [224] = {.lex_state = 56, .external_lex_state = 2},
  [225] = {.lex_state = 56, .external_lex_state = 2},
  [226] = {.lex_state = 4},
  [227] = {.lex_state = 56},
  [228] = {.lex_state = 56},
  [229] = {.lex_state = 56, .external_lex_state = 2},
  [230] = {.lex_state = 56, .external_lex_state = 2},
  [231] = {.lex_state = 56, .external_lex_state = 2},
  [232] = {.lex_state = 56},
  [233] = {.lex_state = 56, .external_lex_state = 2},
  [234] = {.lex_state = 56, .external_lex_state = 2},
  [235] = {.lex_state = 56, .external_lex_state = 2},
  [236] = {.lex_state = 56},
  [237] = {.lex_state = 56, .external_lex_state = 2},
  [238] = {.lex_state = 56, .external_lex_state = 2},
  [239] = {.lex_state = 56, .external_lex_state = 2},
  [240] = {.lex_state = 56},
  [241] = {.lex_state = 56, .external_lex_state = 2},
  [242] = {.lex_state = 56, .external_lex_state = 2},
  [243] = {.lex_state = 56, .external_lex_state = 2},
  [244] = {.lex_state = 56},
  [245] = {.lex_state = 56},
  [246] = {.lex_state = 56},
  [247] = {.lex_state = 56},
  [248] = {.lex_state = 56},
  [249] = {.lex_state = 56},
  [250] = {.lex_state = 56},
  [251] = {.lex_state = 56},
  [252] = {.lex_state = 56},
  [253] = {.lex_state = 56},
  [254] = {.lex_state = 56},
  [255] = {.lex_state = 56},
  [256] = {.lex_state = 56},
  [257] = {.lex_state = 56},
  [258] = {.lex_state = 56},
  [259] = {.lex_state = 56},
  [260] = {.lex_state = 56},
  [261] = {.lex_state = 56},
  [262] = {.lex_state = 56},
  [263] = {.lex_state = 56},
  [264] = {.lex_state = 56},
  [265] = {.lex_state = 56},
  [266] = {.lex_state = 56},
  [267] = {.lex_state = 56},
  [268] = {.lex_state = 56},
  [269] = {.lex_state = 56},
  [270] = {.lex_state = 56},
  [271] = {.lex_state = 56},
  [272] = {.lex_state = 56},
  [273] = {.lex_state = 56},
  [274] = {.lex_state = 56},
  [275] = {.lex_state = 56},
  [276] = {.lex_state = 56},
  [277] = {.lex_state = 56},
  [278] = {.lex_state = 56},
  [279] = {.lex_state = 56},
  [280] = {.lex_state = 56},
  [281] = {.lex_state = 56},
  [282] = {.lex_state = 56},
  [283] = {.lex_state = 56},
  [284] = {.lex_state = 56},
  [285] = {.lex_state = 56},
  [286] = {.lex_state = 56},
  [287] = {.lex_state = 56},
  [288] = {.lex_state = 56},
  [289] = {.lex_state = 56},
  [290] = {.lex_state = 56},
  [291] = {.lex_state = 56},
  [292] = {.lex_state = 56},
  [293] = {.lex_state = 56},
  [294] = {.lex_state = 56},
  [295] = {.lex_state = 56},
  [296] = {.lex_state = 56},
  [297] = {.lex_state = 56},
  [298] = {.lex_state = 56},
  [299] = {.lex_state = 56},
  [300] = {.lex_state = 56},
  [301] = {.lex_state = 56},
  [302] = {.lex_state = 56},
  [303] = {.lex_state = 56},
  [304] = {.lex_state = 56},
  [305] = {.lex_state = 56},
  [306] = {.lex_state = 56},
  [307] = {.lex_state = 56},
  [308] = {.lex_state = 56},
  [309] = {.lex_state = 56},
  [310] = {.lex_state = 56},
  [311] = {.lex_state = 56},
  [312] = {.lex_state = 56},
  [313] = {.lex_state = 56},
  [314] = {.lex_state = 56},
  [315] = {.lex_state = 56},
  [316] = {.lex_state = 56},
  [317] = {.lex_state = 56},
  [318] = {.lex_state = 56},
  [319] = {.lex_state = 56},
  [320] = {.lex_state = 56},
  [321] = {.lex_state = 56},
  [322] = {.lex_state = 56},
  [323] = {.lex_state = 56},
  [324] = {.lex_state = 56},
  [325] = {.lex_state = 56},
  [326] = {.lex_state = 56},
  [327] = {.lex_state = 56},
  [328] = {.lex_state = 56},
  [329] = {.lex_state = 56},
  [330] = {.lex_state = 56},
  [331] = {.lex_state = 56},
  [332] = {.lex_state = 4, .external_lex_state = 2},
  [333] = {.lex_state = 4, .external_lex_state = 2},
  [334] = {.lex_state = 4, .external_lex_state = 2},
  [335] = {.lex_state = 4},
  [336] = {.lex_state = 4},
  [337] = {.lex_state = 4},
  [338] = {.lex_state = 4},
  [339] = {.lex_state = 4},
  [340] = {.lex_state = 4},
  [341] = {.lex_state = 4},
  [342] = {.lex_state = 4},
  [343] = {.lex_state = 4},
  [344] = {.lex_state = 4, .external_lex_state = 2},
  [345] = {.lex_state = 4, .external_lex_state = 2},
  [346] = {.lex_state = 4, .external_lex_state = 2},
  [347] = {.lex_state = 4, .external_lex_state = 2},
  [348] = {.lex_state = 4, .external_lex_state = 2},
  [349] = {.lex_state = 4, .external_lex_state = 2},
  [350] = {.lex_state = 4, .external_lex_state = 2},
  [351] = {.lex_state = 4, .external_lex_state = 2},
  [352] = {.lex_state = 4, .external_lex_state = 2},
  [353] = {.lex_state = 4, .external_lex_state = 2},
  [354] = {.lex_state = 4, .external_lex_state = 2},
  [355] = {.lex_state = 4},
  [356] = {.lex_state = 4, .external_lex_state = 2},
  [357] = {.lex_state = 4, .external_lex_state = 2},
  [358] = {.lex_state = 4, .external_lex_state = 2},
  [359] = {.lex_state = 4},
  [360] = {.lex_state = 4},
  [361] = {.lex_state = 56},
  [362] = {.lex_state = 4, .external_lex_state = 2},
  [363] = {.lex_state = 4, .external_lex_state = 2},
  [364] = {.lex_state = 56},
  [365] = {.lex_state = 56},
  [366] = {.lex_state = 56},
  [367] = {.lex_state = 4, .external_lex_state = 2},
  [368] = {.lex_state = 4},
  [369] = {.lex_state = 4},
  [370] = {.lex_state = 4},
  [371] = {.lex_state = 4},
  [372] = {.lex_state = 4},
  [373] = {.lex_state = 4},
  [374] = {.lex_state = 4},
  [375] = {.lex_state = 4},
  [376] = {.lex_state = 4},
  [377] = {.lex_state = 4},
  [378] = {.lex_state = 55},
  [379] = {.lex_state = 55},
  [380] = {.lex_state = 4},
  [381] = {.lex_state = 55},
  [382] = {.lex_state = 55, .external_lex_state = 2},
  [383] = {.lex_state = 55},
  [384] = {.lex_state = 55, .external_lex_state = 2},
  [385] = {.lex_state = 55},
  [386] = {.lex_state = 55},
  [387] = {.lex_state = 55},
  [388] = {.lex_state = 55},
  [389] = {.lex_state = 55},
  [390] = {.lex_state = 55},
  [391] = {.lex_state = 55},
  [392] = {.lex_state = 55, .external_lex_state = 2},
  [393] = {.lex_state = 55},
  [394] = {.lex_state = 5},
  [395] = {.lex_state = 55},
  [396] = {.lex_state = 55},
  [397] = {.lex_state = 55},
  [398] = {.lex_state = 55},
  [399] = {.lex_state = 55},
  [400] = {.lex_state = 55},
  [401] = {.lex_state = 55},
  [402] = {.lex_state = 55},
  [403] = {.lex_state = 55},
  [404] = {.lex_state = 55},
  [405] = {.lex_state = 55},
  [406] = {.lex_state = 55},
  [407] = {.lex_state = 55},
  [408] = {.lex_state = 55},
  [409] = {.lex_state = 55},
  [410] = {.lex_state = 55},
  [411] = {.lex_state = 55, .external_lex_state = 2},
  [412] = {.lex_state = 55},
  [413] = {.lex_state = 55},
  [414] = {.lex_state = 55},
  [415] = {.lex_state = 55},
  [416] = {.lex_state = 55},
  [417] = {.lex_state = 55},
  [418] = {.lex_state = 55},
  [419] = {.lex_state = 55},
  [420] = {.lex_state = 55},
  [421] = {.lex_state = 55},
  [422] = {.lex_state = 55, .external_lex_state = 2},
  [423] = {.lex_state = 55, .external_lex_state = 2},
  [424] = {.lex_state = 55},
  [425] = {.lex_state = 55},
  [426] = {.lex_state = 55},
  [427] = {.lex_state = 55, .external_lex_state = 2},
  [428] = {.lex_state = 55},
  [429] = {.lex_state = 55, .external_lex_state = 2},
  [430] = {.lex_state = 55},
  [431] = {.lex_state = 55},
  [432] = {.lex_state = 55, .external_lex_state = 2},
  [433] = {.lex_state = 55, .external_lex_state = 2},
  [434] = {.lex_state = 55},
  [435] = {.lex_state = 55},
  [436] = {.lex_state = 55, .external_lex_state = 2},
  [437] = {.lex_state = 55},
  [438] = {.lex_state = 55},
  [439] = {.lex_state = 55, .external_lex_state = 2},
  [440] = {.lex_state = 55},
  [441] = {.lex_state = 55},
  [442] = {.lex_state = 55, .external_lex_state = 2},
  [443] = {.lex_state = 55, .external_lex_state = 2},
  [444] = {.lex_state = 55, .external_lex_state = 2},
  [445] = {.lex_state = 55, .external_lex_state = 2},
  [446] = {.lex_state = 55, .external_lex_state = 2},
  [447] = {.lex_state = 55, .external_lex_state = 2},
  [448] = {.lex_state = 55, .external_lex_state = 2},
  [449] = {.lex_state = 55, .external_lex_state = 2},
  [450] = {.lex_state = 55, .external_lex_state = 2},
  [451] = {.lex_state = 55},
  [452] = {.lex_state = 55},
  [453] = {.lex_state = 55},
  [454] = {.lex_state = 55},
  [455] = {.lex_state = 55},
  [456] = {.lex_state = 55},
  [457] = {.lex_state = 55, .external_lex_state = 2},
  [458] = {.lex_state = 55},
  [459] = {.lex_state = 55},
  [460] = {.lex_state = 55},
  [461] = {.lex_state = 55},
  [462] = {.lex_state = 55},
  [463] = {.lex_state = 55},
  [464] = {.lex_state = 55},
  [465] = {.lex_state = 55},
  [466] = {.lex_state = 55},
  [467] = {.lex_state = 55},
  [468] = {.lex_state = 55},
  [469] = {.lex_state = 55, .external_lex_state = 2},
  [470] = {.lex_state = 55},
  [471] = {.lex_state = 55},
  [472] = {.lex_state = 55},
  [473] = {.lex_state = 55, .external_lex_state = 2},
  [474] = {.lex_state = 55},
  [475] = {.lex_state = 55, .external_lex_state = 2},
  [476] = {.lex_state = 55},
  [477] = {.lex_state = 55},
  [478] = {.lex_state = 55},
  [479] = {.lex_state = 55},
  [480] = {.lex_state = 55, .external_lex_state = 2},
  [481] = {.lex_state = 55},
  [482] = {.lex_state = 55, .external_lex_state = 2},
  [483] = {.lex_state = 55, .external_lex_state = 2},
  [484] = {.lex_state = 55},
  [485] = {.lex_state = 55},
  [486] = {.lex_state = 55},
  [487] = {.lex_state = 55, .external_lex_state = 2},
  [488] = {.lex_state = 55, .external_lex_state = 2},
  [489] = {.lex_state = 55},
  [490] = {.lex_state = 55},
  [491] = {.lex_state = 55},
  [492] = {.lex_state = 55},
  [493] = {.lex_state = 55},
  [494] = {.lex_state = 55},
  [495] = {.lex_state = 55},
  [496] = {.lex_state = 55, .external_lex_state = 2},
  [497] = {.lex_state = 55},
  [498] = {.lex_state = 55},
  [499] = {.lex_state = 55, .external_lex_state = 2},
  [500] = {.lex_state = 55},
  [501] = {.lex_state = 55, .external_lex_state = 2},
  [502] = {.lex_state = 55},
  [503] = {.lex_state = 55, .external_lex_state = 2},
  [504] = {.lex_state = 55},
  [505] = {.lex_state = 5, .external_lex_state = 2},
  [506] = {.lex_state = 55},
  [507] = {.lex_state = 55, .external_lex_state = 2},
  [508] = {.lex_state = 55, .external_lex_state = 2},
  [509] = {.lex_state = 55, .external_lex_state = 2},
  [510] = {.lex_state = 55},
  [511] = {.lex_state = 55, .external_lex_state = 2},
  [512] = {.lex_state = 55, .external_lex_state = 2},
  [513] = {.lex_state = 55, .external_lex_state = 2},
  [514] = {.lex_state = 55, .external_lex_state = 2},
  [515] = {.lex_state = 55},
  [516] = {.lex_state = 55, .external_lex_state = 2},
  [517] = {.lex_state = 55, .external_lex_state = 2},
  [518] = {.lex_state = 55, .external_lex_state = 2},
  [519] = {.lex_state = 55, .external_lex_state = 2},
  [520] = {.lex_state = 55, .external_lex_state = 2},
  [521] = {.lex_state = 55, .external_lex_state = 2},
  [522] = {.lex_state = 55, .external_lex_state = 2},
  [523] = {.lex_state = 55, .external_lex_state = 2},
  [524] = {.lex_state = 55, .external_lex_state = 2},
  [525] = {.lex_state = 55},
  [526] = {.lex_state = 55},
  [527] = {.lex_state = 55, .external_lex_state = 2},
  [528] = {.lex_state = 55, .external_lex_state = 2},
  [529] = {.lex_state = 55, .external_lex_state = 2},
  [530] = {.lex_state = 55},
  [531] = {.lex_state = 55},
  [532] = {.lex_state = 55, .external_lex_state = 2},
  [533] = {.lex_state = 55, .external_lex_state = 2},
  [534] = {.lex_state = 55, .external_lex_state = 2},
  [535] = {.lex_state = 55},
  [536] = {.lex_state = 55},
  [537] = {.lex_state = 55, .external_lex_state = 2},
  [538] = {.lex_state = 55, .external_lex_state = 2},
  [539] = {.lex_state = 55, .external_lex_state = 2},
  [540] = {.lex_state = 55, .external_lex_state = 2},
  [541] = {.lex_state = 55},
  [542] = {.lex_state = 55},
  [543] = {.lex_state = 55},
  [544] = {.lex_state = 55},
  [545] = {.lex_state = 55, .external_lex_state = 2},
  [546] = {.lex_state = 55, .external_lex_state = 2},
  [547] = {.lex_state = 55, .external_lex_state = 2},
  [548] = {.lex_state = 55, .external_lex_state = 2},
  [549] = {.lex_state = 55},
  [550] = {.lex_state = 55, .external_lex_state = 2},
  [551] = {.lex_state = 55, .external_lex_state = 2},
  [552] = {.lex_state = 55, .external_lex_state = 2},
  [553] = {.lex_state = 55},
  [554] = {.lex_state = 55, .external_lex_state = 2},
  [555] = {.lex_state = 55},
  [556] = {.lex_state = 55, .external_lex_state = 2},
  [557] = {.lex_state = 55, .external_lex_state = 2},
  [558] = {.lex_state = 55},
  [559] = {.lex_state = 55},
  [560] = {.lex_state = 55, .external_lex_state = 2},
  [561] = {.lex_state = 55},
  [562] = {.lex_state = 55, .external_lex_state = 2},
  [563] = {.lex_state = 55},
  [564] = {.lex_state = 55, .external_lex_state = 2},
  [565] = {.lex_state = 55, .external_lex_state = 2},
  [566] = {.lex_state = 55, .external_lex_state = 2},
  [567] = {.lex_state = 55, .external_lex_state = 2},
  [568] = {.lex_state = 55},
  [569] = {.lex_state = 55, .external_lex_state = 2},
  [570] = {.lex_state = 55, .external_lex_state = 2},
  [571] = {.lex_state = 55, .external_lex_state = 2},
  [572] = {.lex_state = 55},
  [573] = {.lex_state = 55},
  [574] = {.lex_state = 55},
  [575] = {.lex_state = 55, .external_lex_state = 2},
  [576] = {.lex_state = 55},
  [577] = {.lex_state = 55, .external_lex_state = 2},
  [578] = {.lex_state = 55},
  [579] = {.lex_state = 55, .external_lex_state = 2},
  [580] = {.lex_state = 55, .external_lex_state = 2},
  [581] = {.lex_state = 55},
  [582] = {.lex_state = 55, .external_lex_state = 2},
  [583] = {.lex_state = 55},
  [584] = {.lex_state = 55},
  [585] = {.lex_state = 55},
  [586] = {.lex_state = 55, .external_lex_state = 2},
  [587] = {.lex_state = 55},
  [588] = {.lex_state = 55, .external_lex_state = 2},
  [589] = {.lex_state = 55},
  [590] = {.lex_state = 55, .external_lex_state = 2},
  [591] = {.lex_state = 55},
  [592] = {.lex_state = 55, .external_lex_state = 2},
  [593] = {.lex_state = 55},
  [594] = {.lex_state = 55, .external_lex_state = 2},
  [595] = {.lex_state = 55, .external_lex_state = 2},
  [596] = {.lex_state = 55, .external_lex_state = 2},
  [597] = {.lex_state = 55},
  [598] = {.lex_state = 55, .external_lex_state = 2},
  [599] = {.lex_state = 55, .external_lex_state = 2},
  [600] = {.lex_state = 55},
  [601] = {.lex_state = 55, .external_lex_state = 2},
  [602] = {.lex_state = 55},
  [603] = {.lex_state = 55, .external_lex_state = 2},
  [604] = {.lex_state = 55, .external_lex_state = 2},
  [605] = {.lex_state = 55, .external_lex_state = 2},
  [606] = {.lex_state = 55, .external_lex_state = 2},
  [607] = {.lex_state = 55, .external_lex_state = 2},
  [608] = {.lex_state = 55, .external_lex_state = 2},
  [609] = {.lex_state = 55, .external_lex_state = 2},
  [610] = {.lex_state = 55, .external_lex_state = 2},
  [611] = {.lex_state = 55, .external_lex_state = 2},
  [612] = {.lex_state = 55, .external_lex_state = 2},
  [613] = {.lex_state = 55, .external_lex_state = 2},
  [614] = {.lex_state = 55, .external_lex_state = 2},
  [615] = {.lex_state = 55},
  [616] = {.lex_state = 55},
  [617] = {.lex_state = 55, .external_lex_state = 2},
  [618] = {.lex_state = 55},
  [619] = {.lex_state = 55},
  [620] = {.lex_state = 55, .external_lex_state = 2},
  [621] = {.lex_state = 55},
  [622] = {.lex_state = 55},
  [623] = {.lex_state = 55},
  [624] = {.lex_state = 55, .external_lex_state = 2},
  [625] = {.lex_state = 55},
  [626] = {.lex_state = 55},
  [627] = {.lex_state = 55, .external_lex_state = 2},
  [628] = {.lex_state = 55, .external_lex_state = 2},
  [629] = {.lex_state = 55},
  [630] = {.lex_state = 55},
  [631] = {.lex_state = 55},
  [632] = {.lex_state = 55},
  [633] = {.lex_state = 55},
  [634] = {.lex_state = 55},
  [635] = {.lex_state = 55},
  [636] = {.lex_state = 55},
  [637] = {.lex_state = 55},
  [638] = {.lex_state = 55},
  [639] = {.lex_state = 55},
  [640] = {.lex_state = 55},
  [641] = {.lex_state = 55},
  [642] = {.lex_state = 55},
  [643] = {.lex_state = 56},
  [644] = {.lex_state = 56},
  [645] = {.lex_state = 56},
  [646] = {.lex_state = 56},
  [647] = {.lex_state = 56},
  [648] = {.lex_state = 56},
  [649] = {.lex_state = 56},
  [650] = {.lex_state = 56},
  [651] = {.lex_state = 56},
  [652] = {.lex_state = 56},
  [653] = {.lex_state = 56},
  [654] = {.lex_state = 56},
  [655] = {.lex_state = 56},
  [656] = {.lex_state = 56},
  [657] = {.lex_state = 56},
  [658] = {.lex_state = 56},
  [659] = {.lex_state = 56},
  [660] = {.lex_state = 56},
  [661] = {.lex_state = 56},
  [662] = {.lex_state = 56},
  [663] = {.lex_state = 56},
  [664] = {.lex_state = 56},
  [665] = {.lex_state = 56},
  [666] = {.lex_state = 56},
  [667] = {.lex_state = 56},
  [668] = {.lex_state = 56},
  [669] = {.lex_state = 56},
  [670] = {.lex_state = 56},
  [671] = {.lex_state = 56},
  [672] = {.lex_state = 56},
  [673] = {.lex_state = 56},
  [674] = {.lex_state = 56},
  [675] = {.lex_state = 56},
  [676] = {.lex_state = 56},
  [677] = {.lex_state = 56},
  [678] = {.lex_state = 56},
  [679] = {.lex_state = 56},
  [680] = {.lex_state = 56},
  [681] = {.lex_state = 56},
  [682] = {.lex_state = 56, .external_lex_state = 2},
  [683] = {.lex_state = 56},
  [684] = {.lex_state = 56, .external_lex_state = 2},
  [685] = {.lex_state = 56},
  [686] = {.lex_state = 56},
  [687] = {.lex_state = 56, .external_lex_state = 2},
  [688] = {.lex_state = 56},
  [689] = {.lex_state = 56},
  [690] = {.lex_state = 56, .external_lex_state = 2},
  [691] = {.lex_state = 56, .external_lex_state = 2},
  [692] = {.lex_state = 56},
  [693] = {.lex_state = 56},
  [694] = {.lex_state = 56},
  [695] = {.lex_state = 56},
  [696] = {.lex_state = 56},
  [697] = {.lex_state = 56},
  [698] = {.lex_state = 56},
  [699] = {.lex_state = 55},
  [700] = {.lex_state = 56},
  [701] = {.lex_state = 56},
  [702] = {.lex_state = 56},
  [703] = {.lex_state = 56},
  [704] = {.lex_state = 55},
  [705] = {.lex_state = 56},
  [706] = {.lex_state = 56},
  [707] = {.lex_state = 56},
  [708] = {.lex_state = 56},
  [709] = {.lex_state = 56},
  [710] = {.lex_state = 56},
  [711] = {.lex_state = 56},
  [712] = {.lex_state = 4},
  [713] = {.lex_state = 56},
  [714] = {.lex_state = 4},
  [715] = {.lex_state = 56},
  [716] = {.lex_state = 56},
  [717] = {.lex_state = 56},
  [718] = {.lex_state = 56},
  [719] = {.lex_state = 56},
  [720] = {.lex_state = 4},
  [721] = {.lex_state = 56},
  [722] = {.lex_state = 56},
  [723] = {.lex_state = 56},
  [724] = {.lex_state = 56},
  [725] = {.lex_state = 56},
  [726] = {.lex_state = 56},
  [727] = {.lex_state = 56},
  [728] = {.lex_state = 56},
  [729] = {.lex_state = 56},
  [730] = {.lex_state = 56},
  [731] = {.lex_state = 56},
  [732] = {.lex_state = 56},
  [733] = {.lex_state = 56},
  [734] = {.lex_state = 56},
  [735] = {.lex_state = 56},
  [736] = {.lex_state = 56},
  [737] = {.lex_state = 56},
  [738] = {.lex_state = 56},
  [739] = {.lex_state = 56},
  [740] = {.lex_state = 56},
  [741] = {.lex_state = 56},
  [742] = {.lex_state = 56},
  [743] = {.lex_state = 56},
  [744] = {.lex_state = 56},
  [745] = {.lex_state = 56},
  [746] = {.lex_state = 56},
  [747] = {.lex_state = 56},
  [748] = {.lex_state = 56},
  [749] = {.lex_state = 56},
  [750] = {.lex_state = 56},
  [751] = {.lex_state = 56},
  [752] = {.lex_state = 56},
  [753] = {.lex_state = 56},
  [754] = {.lex_state = 56},
  [755] = {.lex_state = 56},
  [756] = {.lex_state = 16},
  [757] = {.lex_state = 16},
  [758] = {.lex_state = 16},
  [759] = {.lex_state = 16},
  [760] = {.lex_state = 17},
  [761] = {.lex_state = 16},
  [762] = {.lex_state = 16},
  [763] = {.lex_state = 17},
  [764] = {.lex_state = 16},
  [765] = {.lex_state = 17},
  [766] = {.lex_state = 56},
  [767] = {.lex_state = 17},
  [768] = {.lex_state = 17},
  [769] = {.lex_state = 16},
  [770] = {.lex_state = 17},
  [771] = {.lex_state = 16},
  [772] = {.lex_state = 17},
  [773] = {.lex_state = 17},
  [774] = {.lex_state = 56},
  [775] = {.lex_state = 16},
  [776] = {.lex_state = 16},
  [777] = {.lex_state = 16},
  [778] = {.lex_state = 17},
  [779] = {.lex_state = 16},
  [780] = {.lex_state = 17},
  [781] = {.lex_state = 16},
  [782] = {.lex_state = 17},
  [783] = {.lex_state = 16},
  [784] = {.lex_state = 16},
  [785] = {.lex_state = 16},
  [786] = {.lex_state = 17},
  [787] = {.lex_state = 16},
  [788] = {.lex_state = 17},
  [789] = {.lex_state = 16},
  [790] = {.lex_state = 17},
  [791] = {.lex_state = 17},
  [792] = {.lex_state = 16},
  [793] = {.lex_state = 16},
  [794] = {.lex_state = 16},
  [795] = {.lex_state = 16},
  [796] = {.lex_state = 16},
  [797] = {.lex_state = 17},
  [798] = {.lex_state = 16},
  [799] = {.lex_state = 16},
  [800] = {.lex_state = 16},
  [801] = {.lex_state = 17},
  [802] = {.lex_state = 16},
  [803] = {.lex_state = 16},
  [804] = {.lex_state = 16},
  [805] = {.lex_state = 16},
  [806] = {.lex_state = 16},
  [807] = {.lex_state = 16},
  [808] = {.lex_state = 56},
  [809] = {.lex_state = 56},
  [810] = {.lex_state = 56},
  [811] = {.lex_state = 56},
  [812] = {.lex_state = 56},
  [813] = {.lex_state = 0},
  [814] = {.lex_state = 56},
  [815] = {.lex_state = 56, .external_lex_state = 2},
  [816] = {.lex_state = 0},
  [817] = {.lex_state = 0},
  [818] = {.lex_state = 0},
  [819] = {.lex_state = 0},
  [820] = {.lex_state = 0},
  [821] = {.lex_state = 56},
  [822] = {.lex_state = 56},
  [823] = {.lex_state = 56},
  [824] = {.lex_state = 56},
  [825] = {.lex_state = 56},
  [826] = {.lex_state = 56},
  [827] = {.lex_state = 56},
  [828] = {.lex_state = 16},
  [829] = {.lex_state = 16},
  [830] = {.lex_state = 8, .external_lex_state = 3},
  [831] = {.lex_state = 8, .external_lex_state = 3},
  [832] = {.lex_state = 0, .external_lex_state = 2},
  [833] = {.lex_state = 56, .external_lex_state = 2},
  [834] = {.lex_state = 16},
  [835] = {.lex_state = 16},
  [836] = {.lex_state = 16},
  [837] = {.lex_state = 56, .external_lex_state = 2},
  [838] = {.lex_state = 56, .external_lex_state = 2},
  [839] = {.lex_state = 56},
  [840] = {.lex_state = 16},
  [841] = {.lex_state = 56, .external_lex_state = 2},
  [842] = {.lex_state = 16},
  [843] = {.lex_state = 56, .external_lex_state = 2},
  [844] = {.lex_state = 8, .external_lex_state = 3},
  [845] = {.lex_state = 56, .external_lex_state = 2},
  [846] = {.lex_state = 56},
  [847] = {.lex_state = 16},
  [848] = {.lex_state = 16},
  [849] = {.lex_state = 0, .external_lex_state = 2},
  [850] = {.lex_state = 56},
  [851] = {.lex_state = 16},
  [852] = {.lex_state = 56, .external_lex_state = 2},
  [853] = {.lex_state = 56},
  [854] = {.lex_state = 8, .external_lex_state = 3},
  [855] = {.lex_state = 16},
  [856] = {.lex_state = 16},
  [857] = {.lex_state = 16},
  [858] = {.lex_state = 16},
  [859] = {.lex_state = 56, .external_lex_state = 2},
  [860] = {.lex_state = 16},
  [861] = {.lex_state = 16},
  [862] = {.lex_state = 56},
  [863] = {.lex_state = 8, .external_lex_state = 3},
  [864] = {.lex_state = 56},
  [865] = {.lex_state = 0},
  [866] = {.lex_state = 56},
  [867] = {.lex_state = 56},
  [868] = {.lex_state = 0},
  [869] = {.lex_state = 16},
  [870] = {.lex_state = 16},
  [871] = {.lex_state = 16},
  [872] = {.lex_state = 16},
  [873] = {.lex_state = 0},
  [874] = {.lex_state = 16},
  [875] = {.lex_state = 16},
  [876] = {.lex_state = 16},
  [877] = {.lex_state = 16},
  [878] = {.lex_state = 16},
  [879] = {.lex_state = 16},
  [880] = {.lex_state = 56},
  [881] = {.lex_state = 16},
  [882] = {.lex_state = 56},
  [883] = {.lex_state = 16},
  [884] = {.lex_state = 16},
  [885] = {.lex_state = 16},
  [886] = {.lex_state = 16},
  [887] = {.lex_state = 56},
  [888] = {.lex_state = 0},
  [889] = {.lex_state = 16},
  [890] = {.lex_state = 0},
  [891] = {.lex_state = 56},
  [892] = {.lex_state = 56},
  [893] = {.lex_state = 56},
  [894] = {.lex_state = 56},
  [895] = {.lex_state = 0},
  [896] = {.lex_state = 16},
  [897] = {.lex_state = 16},
  [898] = {.lex_state = 16},
  [899] = {.lex_state = 56},
  [900] = {.lex_state = 16},
  [901] = {.lex_state = 0, .external_lex_state = 2},
  [902] = {.lex_state = 16},
  [903] = {.lex_state = 56},
  [904] = {.lex_state = 56},
  [905] = {.lex_state = 7},
  [906] = {.lex_state = 10},
  [907] = {.lex_state = 7},
  [908] = {.lex_state = 56},
  [909] = {.lex_state = 56},
  [910] = {.lex_state = 0, .external_lex_state = 2},
  [911] = {.lex_state = 16},
  [912] = {.lex_state = 0, .external_lex_state = 2},
  [913] = {.lex_state = 56},
  [914] = {.lex_state = 0},
  [915] = {.lex_state = 0},
  [916] = {.lex_state = 56},
  [917] = {.lex_state = 0},
  [918] = {.lex_state = 56},
  [919] = {.lex_state = 0},
  [920] = {.lex_state = 56},
  [921] = {.lex_state = 0},
  [922] = {.lex_state = 56},
  [923] = {.lex_state = 0, .external_lex_state = 2},
  [924] = {.lex_state = 56},
  [925] = {.lex_state = 56},
  [926] = {.lex_state = 56},
  [927] = {.lex_state = 56, .external_lex_state = 2},
  [928] = {.lex_state = 0},
  [929] = {.lex_state = 56},
  [930] = {.lex_state = 0},
  [931] = {.lex_state = 16},
  [932] = {.lex_state = 56},
  [933] = {.lex_state = 56},
  [934] = {.lex_state = 10},
  [935] = {.lex_state = 56},
  [936] = {.lex_state = 0, .external_lex_state = 2},
  [937] = {.lex_state = 0, .external_lex_state = 2},
  [938] = {.lex_state = 56},
  [939] = {.lex_state = 56},
  [940] = {.lex_state = 0},
  [941] = {.lex_state = 0, .external_lex_state = 2},
  [942] = {.lex_state = 7},
  [943] = {.lex_state = 10},
  [944] = {.lex_state = 56},
  [945] = {.lex_state = 10},
  [946] = {.lex_state = 10},
  [947] = {.lex_state = 7},
  [948] = {.lex_state = 7},
  [949] = {.lex_state = 10},
  [950] = {.lex_state = 7},
  [951] = {.lex_state = 8, .external_lex_state = 3},
  [952] = {.lex_state = 16},
  [953] = {.lex_state = 56},
  [954] = {.lex_state = 56},
  [955] = {.lex_state = 56},
  [956] = {.lex_state = 56},
  [957] = {.lex_state = 56},
  [958] = {.lex_state = 0},
  [959] = {.lex_state = 10},
  [960] = {.lex_state = 56},
  [961] = {.lex_state = 56},
  [962] = {.lex_state = 56},
  [963] = {.lex_state = 7},
  [964] = {.lex_state = 56},
  [965] = {.lex_state = 16},
  [966] = {.lex_state = 0, .external_lex_state = 2},
  [967] = {.lex_state = 17},
  [968] = {.lex_state = 0},
  [969] = {.lex_state = 17},
  [970] = {.lex_state = 0},
  [971] = {.lex_state = 17},
  [972] = {.lex_state = 17},
  [973] = {.lex_state = 0, .external_lex_state = 2},
  [974] = {.lex_state = 17},
  [975] = {.lex_state = 0},
  [976] = {.lex_state = 0},
  [977] = {.lex_state = 17},
  [978] = {.lex_state = 0},
  [979] = {.lex_state = 17},
  [980] = {.lex_state = 17},
  [981] = {.lex_state = 17},
  [982] = {.lex_state = 17},
  [983] = {.lex_state = 17},
  [984] = {.lex_state = 17},
  [985] = {.lex_state = 56, .external_lex_state = 2},
  [986] = {.lex_state = 0},
  [987] = {.lex_state = 3},
  [988] = {.lex_state = 17},
  [989] = {.lex_state = 56},
  [990] = {.lex_state = 0},
  [991] = {.lex_state = 0},
  [992] = {.lex_state = 0},
  [993] = {.lex_state = 0},
  [994] = {.lex_state = 0},
  [995] = {.lex_state = 56, .external_lex_state = 2},
  [996] = {.lex_state = 0},
  [997] = {.lex_state = 56},
  [998] = {.lex_state = 0},
  [999] = {.lex_state = 0},
  [1000] = {.lex_state = 17},
  [1001] = {.lex_state = 0},
  [1002] = {.lex_state = 3},
  [1003] = {.lex_state = 56, .external_lex_state = 2},
  [1004] = {.lex_state = 3},
  [1005] = {.lex_state = 0},
  [1006] = {.lex_state = 56},
  [1007] = {.lex_state = 0, .external_lex_state = 2},
  [1008] = {.lex_state = 56, .external_lex_state = 2},
  [1009] = {.lex_state = 56},
  [1010] = {.lex_state = 0},
  [1011] = {.lex_state = 56},
  [1012] = {.lex_state = 56},
  [1013] = {.lex_state = 0},
  [1014] = {.lex_state = 56},
  [1015] = {.lex_state = 0},
  [1016] = {.lex_state = 0},
  [1017] = {.lex_state = 0},
  [1018] = {.lex_state = 0},
  [1019] = {.lex_state = 0},
  [1020] = {.lex_state = 17},
  [1021] = {.lex_state = 0},
  [1022] = {.lex_state = 0},
  [1023] = {.lex_state = 0},
  [1024] = {.lex_state = 56},
  [1025] = {.lex_state = 0},
  [1026] = {.lex_state = 0},
  [1027] = {.lex_state = 0},
  [1028] = {.lex_state = 0},
  [1029] = {.lex_state = 0},
  [1030] = {.lex_state = 0},
  [1031] = {.lex_state = 56},
  [1032] = {.lex_state = 0},
  [1033] = {.lex_state = 0},
  [1034] = {.lex_state = 0},
  [1035] = {.lex_state = 56},
  [1036] = {.lex_state = 0},
  [1037] = {.lex_state = 0},
  [1038] = {.lex_state = 17},
  [1039] = {.lex_state = 56},
  [1040] = {.lex_state = 0},
  [1041] = {.lex_state = 0},
  [1042] = {.lex_state = 56},
  [1043] = {.lex_state = 56},
  [1044] = {.lex_state = 0},
  [1045] = {.lex_state = 56},
  [1046] = {.lex_state = 3},
  [1047] = {.lex_state = 0},
  [1048] = {.lex_state = 0},
  [1049] = {.lex_state = 0},
  [1050] = {.lex_state = 0},
  [1051] = {.lex_state = 0},
  [1052] = {.lex_state = 0},
  [1053] = {.lex_state = 56, .external_lex_state = 2},
  [1054] = {.lex_state = 56},
  [1055] = {.lex_state = 56, .external_lex_state = 2},
  [1056] = {.lex_state = 56},
  [1057] = {.lex_state = 56},
  [1058] = {.lex_state = 0},
  [1059] = {.lex_state = 0},
  [1060] = {.lex_state = 0},
  [1061] = {.lex_state = 0},
  [1062] = {.lex_state = 0},
  [1063] = {.lex_state = 56},
  [1064] = {.lex_state = 56, .external_lex_state = 2},
  [1065] = {.lex_state = 0},
  [1066] = {.lex_state = 17},
  [1067] = {.lex_state = 56, .external_lex_state = 2},
  [1068] = {.lex_state = 56, .external_lex_state = 2},
  [1069] = {.lex_state = 56},
  [1070] = {.lex_state = 0},
  [1071] = {.lex_state = 0},
  [1072] = {.lex_state = 0},
  [1073] = {.lex_state = 0},
  [1074] = {.lex_state = 0},
  [1075] = {.lex_state = 3},
  [1076] = {.lex_state = 56},
  [1077] = {.lex_state = 56},
  [1078] = {.lex_state = 0, .external_lex_state = 2},
  [1079] = {.lex_state = 0},
  [1080] = {.lex_state = 0},
  [1081] = {.lex_state = 56},
  [1082] = {.lex_state = 0},
  [1083] = {.lex_state = 0},
  [1084] = {.lex_state = 0},
  [1085] = {.lex_state = 0},
  [1086] = {.lex_state = 0},
  [1087] = {.lex_state = 0},
  [1088] = {.lex_state = 0},
  [1089] = {.lex_state = 0},
  [1090] = {.lex_state = 0},
  [1091] = {.lex_state = 0, .external_lex_state = 2},
  [1092] = {.lex_state = 0},
  [1093] = {.lex_state = 0},
  [1094] = {.lex_state = 0},
  [1095] = {.lex_state = 0},
  [1096] = {.lex_state = 0},
  [1097] = {.lex_state = 0},
  [1098] = {.lex_state = 0},
  [1099] = {.lex_state = 0},
  [1100] = {.lex_state = 0},
  [1101] = {.lex_state = 0},
  [1102] = {.lex_state = 0},
  [1103] = {.lex_state = 0},
  [1104] = {.lex_state = 0},
  [1105] = {.lex_state = 0},
  [1106] = {.lex_state = 0},
  [1107] = {.lex_state = 56},
  [1108] = {.lex_state = 0},
  [1109] = {.lex_state = 3},
  [1110] = {.lex_state = 0, .external_lex_state = 2},
  [1111] = {.lex_state = 56},
  [1112] = {.lex_state = 0},
  [1113] = {.lex_state = 0},
  [1114] = {.lex_state = 0},
  [1115] = {.lex_state = 0},
  [1116] = {.lex_state = 0},
  [1117] = {.lex_state = 0},
  [1118] = {.lex_state = 0},
  [1119] = {.lex_state = 0},
  [1120] = {.lex_state = 0},
  [1121] = {.lex_state = 0},
  [1122] = {.lex_state = 0},
  [1123] = {.lex_state = 0},
  [1124] = {.lex_state = 0},
  [1125] = {.lex_state = 0},
  [1126] = {.lex_state = 0},
  [1127] = {.lex_state = 0},
  [1128] = {.lex_state = 0, .external_lex_state = 2},
  [1129] = {.lex_state = 0},
  [1130] = {.lex_state = 0},
  [1131] = {.lex_state = 0},
  [1132] = {.lex_state = 0},
  [1133] = {.lex_state = 16},
  [1134] = {.lex_state = 0},
  [1135] = {.lex_state = 0},
  [1136] = {.lex_state = 0},
  [1137] = {.lex_state = 0},
  [1138] = {.lex_state = 0},
  [1139] = {.lex_state = 0},
  [1140] = {.lex_state = 0},
  [1141] = {.lex_state = 0},
  [1142] = {.lex_state = 0},
  [1143] = {.lex_state = 0},
  [1144] = {.lex_state = 0},
  [1145] = {.lex_state = 0},
  [1146] = {.lex_state = 0},
  [1147] = {.lex_state = 0},
  [1148] = {.lex_state = 0},
  [1149] = {.lex_state = 0},
  [1150] = {.lex_state = 0},
  [1151] = {.lex_state = 0},
  [1152] = {.lex_state = 0},
  [1153] = {.lex_state = 0},
  [1154] = {.lex_state = 0},
  [1155] = {.lex_state = 0},
  [1156] = {.lex_state = 0, .external_lex_state = 2},
  [1157] = {.lex_state = 0},
  [1158] = {.lex_state = 0, .external_lex_state = 2},
  [1159] = {.lex_state = 56},
  [1160] = {.lex_state = 56},
  [1161] = {.lex_state = 0},
  [1162] = {.lex_state = 56},
  [1163] = {.lex_state = 0, .external_lex_state = 2},
  [1164] = {.lex_state = 0},
  [1165] = {.lex_state = 0},
  [1166] = {.lex_state = 0},
  [1167] = {.lex_state = 0},
  [1168] = {.lex_state = 0},
  [1169] = {.lex_state = 0},
  [1170] = {.lex_state = 0},
  [1171] = {.lex_state = 0},
  [1172] = {.lex_state = 0},
  [1173] = {.lex_state = 0},
  [1174] = {.lex_state = 0},
  [1175] = {.lex_state = 0},
  [1176] = {.lex_state = 0},
  [1177] = {.lex_state = 0},
  [1178] = {.lex_state = 0},
  [1179] = {.lex_state = 0},
  [1180] = {.lex_state = 0},
  [1181] = {.lex_state = 0},
  [1182] = {.lex_state = 0},
  [1183] = {.lex_state = 56},
  [1184] = {.lex_state = 0, .external_lex_state = 2},
  [1185] = {.lex_state = 56},
  [1186] = {.lex_state = 0},
  [1187] = {.lex_state = 0},
  [1188] = {.lex_state = 0, .external_lex_state = 2},
  [1189] = {.lex_state = 0},
  [1190] = {.lex_state = 0},
  [1191] = {.lex_state = 0},
  [1192] = {.lex_state = 56},
  [1193] = {.lex_state = 0, .external_lex_state = 2},
  [1194] = {.lex_state = 0},
  [1195] = {.lex_state = 0},
  [1196] = {.lex_state = 56},
  [1197] = {.lex_state = 0},
  [1198] = {.lex_state = 0, .external_lex_state = 2},
  [1199] = {.lex_state = 0},
  [1200] = {.lex_state = 0},
  [1201] = {.lex_state = 0},
  [1202] = {.lex_state = 0},
  [1203] = {.lex_state = 0},
  [1204] = {.lex_state = 0},
  [1205] = {.lex_state = 56},
  [1206] = {.lex_state = 0},
  [1207] = {.lex_state = 3},
  [1208] = {.lex_state = 0},
  [1209] = {.lex_state = 0},
  [1210] = {.lex_state = 0},
  [1211] = {.lex_state = 0},
  [1212] = {.lex_state = 0},
  [1213] = {.lex_state = 0, .external_lex_state = 2},
  [1214] = {.lex_state = 0},
  [1215] = {.lex_state = 56},
  [1216] = {.lex_state = 0},
  [1217] = {.lex_state = 56},
  [1218] = {.lex_state = 0},
  [1219] = {.lex_state = 0},
  [1220] = {.lex_state = 0},
  [1221] = {.lex_state = 0},
  [1222] = {.lex_state = 0},
  [1223] = {.lex_state = 0},
  [1224] = {.lex_state = 0},
  [1225] = {.lex_state = 0},
  [1226] = {.lex_state = 0},
  [1227] = {.lex_state = 0, .external_lex_state = 2},
  [1228] = {.lex_state = 0},
  [1229] = {.lex_state = 56},
  [1230] = {.lex_state = 0},
  [1231] = {.lex_state = 3},
  [1232] = {.lex_state = 0},
  [1233] = {.lex_state = 0},
  [1234] = {.lex_state = 0, .external_lex_state = 2},
  [1235] = {.lex_state = 0},
  [1236] = {.lex_state = 0, .external_lex_state = 2},
  [1237] = {.lex_state = 0},
  [1238] = {.lex_state = 0},
  [1239] = {.lex_state = 0, .external_lex_state = 2},
  [1240] = {.lex_state = 0},
  [1241] = {.lex_state = 0},
  [1242] = {.lex_state = 0},
  [1243] = {.lex_state = 0},
  [1244] = {.lex_state = 0},
  [1245] = {.lex_state = 0},
  [1246] = {.lex_state = 0},
  [1247] = {.lex_state = 0},
  [1248] = {.lex_state = 0},
  [1249] = {.lex_state = 0},
  [1250] = {.lex_state = 0},
  [1251] = {.lex_state = 0},
  [1252] = {.lex_state = 0},
  [1253] = {.lex_state = 8},
  [1254] = {.lex_state = 0},
  [1255] = {.lex_state = 56},
  [1256] = {.lex_state = 0},
  [1257] = {.lex_state = 0},
  [1258] = {.lex_state = 56},
  [1259] = {.lex_state = 56},
  [1260] = {.lex_state = 56},
  [1261] = {.lex_state = 56},
  [1262] = {.lex_state = 56},
  [1263] = {.lex_state = 56},
  [1264] = {.lex_state = 56},
  [1265] = {.lex_state = 56},
  [1266] = {.lex_state = 56},
  [1267] = {.lex_state = 0},
  [1268] = {.lex_state = 56},
  [1269] = {.lex_state = 56},
  [1270] = {.lex_state = 56},
  [1271] = {.lex_state = 56},
  [1272] = {.lex_state = 56},
  [1273] = {.lex_state = 0},
  [1274] = {.lex_state = 56},
  [1275] = {.lex_state = 0},
  [1276] = {.lex_state = 56},
  [1277] = {.lex_state = 56},
  [1278] = {.lex_state = 56},
  [1279] = {.lex_state = 56},
  [1280] = {.lex_state = 56},
  [1281] = {.lex_state = 56},
  [1282] = {.lex_state = 56},
  [1283] = {.lex_state = 0},
  [1284] = {.lex_state = 0},
  [1285] = {.lex_state = 56},
  [1286] = {.lex_state = 0},
  [1287] = {.lex_state = 0},
  [1288] = {.lex_state = 56},
  [1289] = {.lex_state = 56},
  [1290] = {.lex_state = 56},
  [1291] = {.lex_state = 56},
  [1292] = {.lex_state = 56},
  [1293] = {.lex_state = 56},
  [1294] = {.lex_state = 0},
  [1295] = {.lex_state = 0},
  [1296] = {.lex_state = 0},
  [1297] = {.lex_state = 0},
  [1298] = {.lex_state = 56},
  [1299] = {.lex_state = 56},
  [1300] = {.lex_state = 0},
  [1301] = {.lex_state = 0},
  [1302] = {.lex_state = 56},
  [1303] = {.lex_state = 0},
  [1304] = {.lex_state = 56},
  [1305] = {.lex_state = 56},
  [1306] = {.lex_state = 0},
  [1307] = {.lex_state = 0},
  [1308] = {.lex_state = 0},
  [1309] = {.lex_state = 56},
  [1310] = {.lex_state = 56},
  [1311] = {.lex_state = 0},
  [1312] = {.lex_state = 56},
  [1313] = {.lex_state = 56},
  [1314] = {.lex_state = 56},
  [1315] = {.lex_state = 0},
  [1316] = {.lex_state = 56},
  [1317] = {.lex_state = 0},
  [1318] = {.lex_state = 0},
  [1319] = {.lex_state = 0},
  [1320] = {.lex_state = 0},
  [1321] = {.lex_state = 0},
  [1322] = {.lex_state = 0},
  [1323] = {.lex_state = 56},
  [1324] = {.lex_state = 56},
  [1325] = {.lex_state = 56},
  [1326] = {.lex_state = 0},
  [1327] = {.lex_state = 8},
  [1328] = {.lex_state = 56},
  [1329] = {.lex_state = 56},
  [1330] = {.lex_state = 0},
  [1331] = {.lex_state = 0},
  [1332] = {.lex_state = 0},
  [1333] = {.lex_state = 0},
  [1334] = {.lex_state = 1},
  [1335] = {.lex_state = 56},
  [1336] = {.lex_state = 56},
  [1337] = {.lex_state = 56},
  [1338] = {.lex_state = 0},
  [1339] = {.lex_state = 56},
  [1340] = {.lex_state = 0},
  [1341] = {.lex_state = 56},
  [1342] = {.lex_state = 56},
  [1343] = {.lex_state = 56},
  [1344] = {.lex_state = 56},
  [1345] = {.lex_state = 56},
  [1346] = {.lex_state = 56},
  [1347] = {.lex_state = 0},
  [1348] = {.lex_state = 0},
  [1349] = {.lex_state = 0},
  [1350] = {.lex_state = 1},
  [1351] = {.lex_state = 56},
  [1352] = {.lex_state = 56},
  [1353] = {.lex_state = 56},
  [1354] = {.lex_state = 56},
  [1355] = {.lex_state = 56},
};

enum {
  ts_external_token__automatic_semicolon = 0,
  ts_external_token__template_chars = 1,
};

static TSSymbol ts_external_scanner_symbol_map[EXTERNAL_TOKEN_COUNT] = {
  [ts_external_token__automatic_semicolon] = sym__automatic_semicolon,
  [ts_external_token__template_chars] = sym__template_chars,
};

static bool ts_external_scanner_states[4][EXTERNAL_TOKEN_COUNT] = {
  [1] = {
    [ts_external_token__automatic_semicolon] = true,
    [ts_external_token__template_chars] = true,
  },
  [2] = {
    [ts_external_token__automatic_semicolon] = true,
  },
  [3] = {
    [ts_external_token__template_chars] = true,
  },
};

static uint16_t ts_parse_table[LARGE_STATE_COUNT][SYMBOL_COUNT] = {
  [0] = {
    [ts_builtin_sym_end] = ACTIONS(1),
    [sym_identifier] = ACTIONS(1),
    [sym_hash_bang_line] = ACTIONS(1),
    [anon_sym_export] = ACTIONS(1),
    [anon_sym_STAR] = ACTIONS(1),
    [anon_sym_default] = ACTIONS(1),
    [anon_sym_LBRACE] = ACTIONS(1),
    [anon_sym_COMMA] = ACTIONS(1),
    [anon_sym_RBRACE] = ACTIONS(1),
    [anon_sym_as] = ACTIONS(1),
    [anon_sym_import] = ACTIONS(1),
    [anon_sym_from] = ACTIONS(1),
    [anon_sym_var] = ACTIONS(1),
    [anon_sym_let] = ACTIONS(1),
    [anon_sym_const] = ACTIONS(1),
    [anon_sym_else] = ACTIONS(1),
    [anon_sym_if] = ACTIONS(1),
    [anon_sym_switch] = ACTIONS(1),
    [anon_sym_for] = ACTIONS(1),
    [anon_sym_LPAREN] = ACTIONS(1),
    [anon_sym_RPAREN] = ACTIONS(1),
    [anon_sym_await] = ACTIONS(1),
    [anon_sym_in] = ACTIONS(1),
    [anon_sym_of] = ACTIONS(1),
    [anon_sym_while] = ACTIONS(1),
    [anon_sym_do] = ACTIONS(1),
    [anon_sym_try] = ACTIONS(1),
    [anon_sym_with] = ACTIONS(1),
    [anon_sym_break] = ACTIONS(1),
    [anon_sym_continue] = ACTIONS(1),
    [anon_sym_debugger] = ACTIONS(1),
    [anon_sym_return] = ACTIONS(1),
    [anon_sym_throw] = ACTIONS(1),
    [anon_sym_SEMI] = ACTIONS(1),
    [anon_sym_COLON] = ACTIONS(1),
    [anon_sym_case] = ACTIONS(1),
    [anon_sym_catch] = ACTIONS(1),
    [anon_sym_finally] = ACTIONS(1),
    [anon_sym_yield] = ACTIONS(1),
    [anon_sym_EQ] = ACTIONS(1),
    [anon_sym_LBRACK] = ACTIONS(1),
    [anon_sym_RBRACK] = ACTIONS(1),
    [anon_sym_LT] = ACTIONS(1),
    [anon_sym_GT] = ACTIONS(1),
    [anon_sym_SLASH] = ACTIONS(1),
    [anon_sym_DOT] = ACTIONS(1),
    [anon_sym_class] = ACTIONS(1),
    [anon_sym_extends] = ACTIONS(1),
    [anon_sym_async] = ACTIONS(1),
    [anon_sym_function] = ACTIONS(1),
    [anon_sym_EQ_GT] = ACTIONS(1),
    [anon_sym_QMARK_DOT] = ACTIONS(1),
    [anon_sym_new] = ACTIONS(1),
    [anon_sym_PLUS_EQ] = ACTIONS(1),
    [anon_sym_DASH_EQ] = ACTIONS(1),
    [anon_sym_STAR_EQ] = ACTIONS(1),
    [anon_sym_PERCENT_EQ] = ACTIONS(1),
    [anon_sym_CARET_EQ] = ACTIONS(1),
    [anon_sym_AMP_EQ] = ACTIONS(1),
    [anon_sym_PIPE_EQ] = ACTIONS(1),
    [anon_sym_GT_GT_EQ] = ACTIONS(1),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1),
    [anon_sym_LT_LT_EQ] = ACTIONS(1),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1),
    [anon_sym_QMARK] = ACTIONS(1),
    [anon_sym_AMP_AMP] = ACTIONS(1),
    [anon_sym_PIPE_PIPE] = ACTIONS(1),
    [anon_sym_GT_GT] = ACTIONS(1),
    [anon_sym_GT_GT_GT] = ACTIONS(1),
    [anon_sym_LT_LT] = ACTIONS(1),
    [anon_sym_AMP] = ACTIONS(1),
    [anon_sym_CARET] = ACTIONS(1),
    [anon_sym_PIPE] = ACTIONS(1),
    [anon_sym_PLUS] = ACTIONS(1),
    [anon_sym_DASH] = ACTIONS(1),
    [anon_sym_PERCENT] = ACTIONS(1),
    [anon_sym_STAR_STAR] = ACTIONS(1),
    [anon_sym_LT_EQ] = ACTIONS(1),
    [anon_sym_EQ_EQ] = ACTIONS(1),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1),
    [anon_sym_BANG_EQ] = ACTIONS(1),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1),
    [anon_sym_GT_EQ] = ACTIONS(1),
    [anon_sym_QMARK_QMARK] = ACTIONS(1),
    [anon_sym_instanceof] = ACTIONS(1),
    [anon_sym_BANG] = ACTIONS(1),
    [anon_sym_TILDE] = ACTIONS(1),
    [anon_sym_typeof] = ACTIONS(1),
    [anon_sym_void] = ACTIONS(1),
    [anon_sym_delete] = ACTIONS(1),
    [anon_sym_PLUS_PLUS] = ACTIONS(1),
    [anon_sym_DASH_DASH] = ACTIONS(1),
    [anon_sym_DQUOTE] = ACTIONS(1),
    [anon_sym_SQUOTE] = ACTIONS(1),
    [sym_escape_sequence] = ACTIONS(1),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1),
    [anon_sym_SLASH2] = ACTIONS(1),
    [sym_number] = ACTIONS(1),
    [anon_sym_target] = ACTIONS(1),
    [sym_this] = ACTIONS(1),
    [sym_super] = ACTIONS(1),
    [sym_true] = ACTIONS(1),
    [sym_false] = ACTIONS(1),
    [sym_null] = ACTIONS(1),
    [sym_undefined] = ACTIONS(1),
    [anon_sym_AT] = ACTIONS(1),
    [anon_sym_static] = ACTIONS(1),
    [anon_sym_get] = ACTIONS(1),
    [anon_sym_set] = ACTIONS(1),
    [sym__automatic_semicolon] = ACTIONS(1),
    [sym__template_chars] = ACTIONS(1),
  },
  [1] = {
    [sym_program] = STATE(1321),
    [sym_export_statement] = STATE(17),
    [sym_declaration] = STATE(17),
    [sym_import] = STATE(539),
    [sym_import_statement] = STATE(17),
    [sym_expression_statement] = STATE(17),
    [sym_variable_declaration] = STATE(275),
    [sym_lexical_declaration] = STATE(275),
    [sym_statement_block] = STATE(17),
    [sym_if_statement] = STATE(17),
    [sym_switch_statement] = STATE(17),
    [sym_for_statement] = STATE(17),
    [sym_for_in_statement] = STATE(17),
    [sym_while_statement] = STATE(17),
    [sym_do_statement] = STATE(17),
    [sym_try_statement] = STATE(17),
    [sym_with_statement] = STATE(17),
    [sym_break_statement] = STATE(17),
    [sym_continue_statement] = STATE(17),
    [sym_debugger_statement] = STATE(17),
    [sym_return_statement] = STATE(17),
    [sym_throw_statement] = STATE(17),
    [sym_empty_statement] = STATE(17),
    [sym_labeled_statement] = STATE(17),
    [sym_parenthesized_expression] = STATE(362),
    [sym_expression] = STATE(522),
    [sym_primary_expression] = STATE(546),
    [sym_yield_expression] = STATE(550),
    [sym_object] = STATE(539),
    [sym_object_pattern] = STATE(1320),
    [sym_array] = STATE(539),
    [sym_array_pattern] = STATE(1320),
    [sym_jsx_element] = STATE(550),
    [sym_jsx_fragment] = STATE(550),
    [sym_jsx_opening_element] = STATE(772),
    [sym_jsx_self_closing_element] = STATE(550),
    [sym_class] = STATE(539),
    [sym_class_declaration] = STATE(275),
    [sym_function] = STATE(539),
    [sym_function_declaration] = STATE(275),
    [sym_generator_function] = STATE(539),
    [sym_generator_function_declaration] = STATE(275),
    [sym_arrow_function] = STATE(539),
    [sym_call_expression] = STATE(539),
    [sym_new_expression] = STATE(550),
    [sym_await_expression] = STATE(550),
    [sym_member_expression] = STATE(362),
    [sym_subscript_expression] = STATE(362),
    [sym_assignment_expression] = STATE(550),
    [sym__augmented_assignment_lhs] = STATE(720),
    [sym_augmented_assignment_expression] = STATE(550),
    [sym__destructuring_pattern] = STATE(1320),
    [sym_ternary_expression] = STATE(550),
    [sym_binary_expression] = STATE(550),
    [sym_unary_expression] = STATE(550),
    [sym_update_expression] = STATE(550),
    [sym_sequence_expression] = STATE(1156),
    [sym_string] = STATE(539),
    [sym_template_string] = STATE(539),
    [sym_regex] = STATE(539),
    [sym_meta_property] = STATE(539),
    [sym_decorator] = STATE(750),
    [sym_formal_parameters] = STATE(1318),
    [aux_sym_program_repeat1] = STATE(17),
    [aux_sym_export_statement_repeat1] = STATE(891),
    [ts_builtin_sym_end] = ACTIONS(5),
    [sym_identifier] = ACTIONS(7),
    [sym_hash_bang_line] = ACTIONS(9),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_import] = ACTIONS(15),
    [anon_sym_var] = ACTIONS(17),
    [anon_sym_let] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(19),
    [anon_sym_if] = ACTIONS(21),
    [anon_sym_switch] = ACTIONS(23),
    [anon_sym_for] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(29),
    [anon_sym_while] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(33),
    [anon_sym_try] = ACTIONS(35),
    [anon_sym_with] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_debugger] = ACTIONS(43),
    [anon_sym_return] = ACTIONS(45),
    [anon_sym_throw] = ACTIONS(47),
    [anon_sym_SEMI] = ACTIONS(49),
    [anon_sym_yield] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(53),
    [anon_sym_LT] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(59),
    [anon_sym_async] = ACTIONS(61),
    [anon_sym_function] = ACTIONS(63),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_typeof] = ACTIONS(71),
    [anon_sym_void] = ACTIONS(71),
    [anon_sym_delete] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DQUOTE] = ACTIONS(75),
    [anon_sym_SQUOTE] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(79),
    [sym_number] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(83),
    [sym_true] = ACTIONS(83),
    [sym_false] = ACTIONS(83),
    [sym_null] = ACTIONS(83),
    [sym_undefined] = ACTIONS(83),
    [anon_sym_AT] = ACTIONS(85),
    [anon_sym_static] = ACTIONS(87),
    [anon_sym_get] = ACTIONS(87),
    [anon_sym_set] = ACTIONS(87),
  },
  [2] = {
    [sym_export_statement] = STATE(15),
    [sym_declaration] = STATE(15),
    [sym_import] = STATE(539),
    [sym_import_statement] = STATE(15),
    [sym_expression_statement] = STATE(15),
    [sym_variable_declaration] = STATE(275),
    [sym_lexical_declaration] = STATE(275),
    [sym_statement_block] = STATE(15),
    [sym_if_statement] = STATE(15),
    [sym_switch_statement] = STATE(15),
    [sym_for_statement] = STATE(15),
    [sym_for_in_statement] = STATE(15),
    [sym_while_statement] = STATE(15),
    [sym_do_statement] = STATE(15),
    [sym_try_statement] = STATE(15),
    [sym_with_statement] = STATE(15),
    [sym_break_statement] = STATE(15),
    [sym_continue_statement] = STATE(15),
    [sym_debugger_statement] = STATE(15),
    [sym_return_statement] = STATE(15),
    [sym_throw_statement] = STATE(15),
    [sym_empty_statement] = STATE(15),
    [sym_labeled_statement] = STATE(15),
    [sym_parenthesized_expression] = STATE(362),
    [sym_expression] = STATE(522),
    [sym_primary_expression] = STATE(546),
    [sym_yield_expression] = STATE(550),
    [sym_object] = STATE(539),
    [sym_object_pattern] = STATE(1307),
    [sym_object_assignment_pattern] = STATE(1052),
    [sym_array] = STATE(539),
    [sym_array_pattern] = STATE(1307),
    [sym_jsx_element] = STATE(550),
    [sym_jsx_fragment] = STATE(550),
    [sym_jsx_opening_element] = STATE(772),
    [sym_jsx_self_closing_element] = STATE(550),
    [sym_class] = STATE(539),
    [sym_class_declaration] = STATE(275),
    [sym_function] = STATE(539),
    [sym_function_declaration] = STATE(275),
    [sym_generator_function] = STATE(539),
    [sym_generator_function_declaration] = STATE(275),
    [sym_arrow_function] = STATE(539),
    [sym_call_expression] = STATE(539),
    [sym_new_expression] = STATE(550),
    [sym_await_expression] = STATE(550),
    [sym_member_expression] = STATE(362),
    [sym_subscript_expression] = STATE(362),
    [sym_assignment_expression] = STATE(550),
    [sym__augmented_assignment_lhs] = STATE(720),
    [sym_augmented_assignment_expression] = STATE(550),
    [sym__destructuring_pattern] = STATE(1307),
    [sym_spread_element] = STATE(1050),
    [sym_ternary_expression] = STATE(550),
    [sym_binary_expression] = STATE(550),
    [sym_unary_expression] = STATE(550),
    [sym_update_expression] = STATE(550),
    [sym_sequence_expression] = STATE(1156),
    [sym_string] = STATE(564),
    [sym_template_string] = STATE(539),
    [sym_regex] = STATE(539),
    [sym_meta_property] = STATE(539),
    [sym_decorator] = STATE(750),
    [sym_formal_parameters] = STATE(1318),
    [sym_rest_pattern] = STATE(1052),
    [sym_method_definition] = STATE(1050),
    [sym_pair] = STATE(1050),
    [sym_pair_pattern] = STATE(1052),
    [sym__property_name] = STATE(1049),
    [sym_computed_property_name] = STATE(1049),
    [aux_sym_program_repeat1] = STATE(15),
    [aux_sym_export_statement_repeat1] = STATE(688),
    [aux_sym_object_repeat1] = STATE(1048),
    [aux_sym_object_pattern_repeat1] = STATE(1044),
    [sym_identifier] = ACTIONS(89),
    [anon_sym_export] = ACTIONS(91),
    [anon_sym_STAR] = ACTIONS(93),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_COMMA] = ACTIONS(95),
    [anon_sym_RBRACE] = ACTIONS(97),
    [anon_sym_import] = ACTIONS(15),
    [anon_sym_var] = ACTIONS(17),
    [anon_sym_let] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(19),
    [anon_sym_if] = ACTIONS(21),
    [anon_sym_switch] = ACTIONS(23),
    [anon_sym_for] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(29),
    [anon_sym_while] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(33),
    [anon_sym_try] = ACTIONS(35),
    [anon_sym_with] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_debugger] = ACTIONS(43),
    [anon_sym_return] = ACTIONS(45),
    [anon_sym_throw] = ACTIONS(47),
    [anon_sym_SEMI] = ACTIONS(49),
    [anon_sym_yield] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(99),
    [anon_sym_LT] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(59),
    [anon_sym_async] = ACTIONS(101),
    [anon_sym_function] = ACTIONS(63),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_typeof] = ACTIONS(71),
    [anon_sym_void] = ACTIONS(71),
    [anon_sym_delete] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DQUOTE] = ACTIONS(75),
    [anon_sym_SQUOTE] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(79),
    [sym_number] = ACTIONS(105),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(83),
    [sym_true] = ACTIONS(83),
    [sym_false] = ACTIONS(83),
    [sym_null] = ACTIONS(83),
    [sym_undefined] = ACTIONS(83),
    [anon_sym_AT] = ACTIONS(85),
    [anon_sym_static] = ACTIONS(107),
    [anon_sym_get] = ACTIONS(109),
    [anon_sym_set] = ACTIONS(109),
  },
  [3] = {
    [sym_export_statement] = STATE(12),
    [sym_declaration] = STATE(12),
    [sym_import] = STATE(539),
    [sym_import_statement] = STATE(12),
    [sym_expression_statement] = STATE(12),
    [sym_variable_declaration] = STATE(275),
    [sym_lexical_declaration] = STATE(275),
    [sym_statement_block] = STATE(12),
    [sym_if_statement] = STATE(12),
    [sym_switch_statement] = STATE(12),
    [sym_for_statement] = STATE(12),
    [sym_for_in_statement] = STATE(12),
    [sym_while_statement] = STATE(12),
    [sym_do_statement] = STATE(12),
    [sym_try_statement] = STATE(12),
    [sym_with_statement] = STATE(12),
    [sym_break_statement] = STATE(12),
    [sym_continue_statement] = STATE(12),
    [sym_debugger_statement] = STATE(12),
    [sym_return_statement] = STATE(12),
    [sym_throw_statement] = STATE(12),
    [sym_empty_statement] = STATE(12),
    [sym_labeled_statement] = STATE(12),
    [sym_parenthesized_expression] = STATE(362),
    [sym_expression] = STATE(522),
    [sym_primary_expression] = STATE(546),
    [sym_yield_expression] = STATE(550),
    [sym_object] = STATE(539),
    [sym_object_pattern] = STATE(1307),
    [sym_object_assignment_pattern] = STATE(1052),
    [sym_array] = STATE(539),
    [sym_array_pattern] = STATE(1307),
    [sym_jsx_element] = STATE(550),
    [sym_jsx_fragment] = STATE(550),
    [sym_jsx_opening_element] = STATE(772),
    [sym_jsx_self_closing_element] = STATE(550),
    [sym_class] = STATE(539),
    [sym_class_declaration] = STATE(275),
    [sym_function] = STATE(539),
    [sym_function_declaration] = STATE(275),
    [sym_generator_function] = STATE(539),
    [sym_generator_function_declaration] = STATE(275),
    [sym_arrow_function] = STATE(539),
    [sym_call_expression] = STATE(539),
    [sym_new_expression] = STATE(550),
    [sym_await_expression] = STATE(550),
    [sym_member_expression] = STATE(362),
    [sym_subscript_expression] = STATE(362),
    [sym_assignment_expression] = STATE(550),
    [sym__augmented_assignment_lhs] = STATE(720),
    [sym_augmented_assignment_expression] = STATE(550),
    [sym__destructuring_pattern] = STATE(1307),
    [sym_spread_element] = STATE(1050),
    [sym_ternary_expression] = STATE(550),
    [sym_binary_expression] = STATE(550),
    [sym_unary_expression] = STATE(550),
    [sym_update_expression] = STATE(550),
    [sym_sequence_expression] = STATE(1156),
    [sym_string] = STATE(564),
    [sym_template_string] = STATE(539),
    [sym_regex] = STATE(539),
    [sym_meta_property] = STATE(539),
    [sym_decorator] = STATE(750),
    [sym_formal_parameters] = STATE(1318),
    [sym_rest_pattern] = STATE(1052),
    [sym_method_definition] = STATE(1050),
    [sym_pair] = STATE(1050),
    [sym_pair_pattern] = STATE(1052),
    [sym__property_name] = STATE(1049),
    [sym_computed_property_name] = STATE(1049),
    [aux_sym_program_repeat1] = STATE(12),
    [aux_sym_export_statement_repeat1] = STATE(688),
    [aux_sym_object_repeat1] = STATE(1048),
    [aux_sym_object_pattern_repeat1] = STATE(1044),
    [sym_identifier] = ACTIONS(89),
    [anon_sym_export] = ACTIONS(91),
    [anon_sym_STAR] = ACTIONS(93),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_COMMA] = ACTIONS(95),
    [anon_sym_RBRACE] = ACTIONS(111),
    [anon_sym_import] = ACTIONS(15),
    [anon_sym_var] = ACTIONS(17),
    [anon_sym_let] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(19),
    [anon_sym_if] = ACTIONS(21),
    [anon_sym_switch] = ACTIONS(23),
    [anon_sym_for] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(29),
    [anon_sym_while] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(33),
    [anon_sym_try] = ACTIONS(35),
    [anon_sym_with] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_debugger] = ACTIONS(43),
    [anon_sym_return] = ACTIONS(45),
    [anon_sym_throw] = ACTIONS(47),
    [anon_sym_SEMI] = ACTIONS(49),
    [anon_sym_yield] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(99),
    [anon_sym_LT] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(59),
    [anon_sym_async] = ACTIONS(101),
    [anon_sym_function] = ACTIONS(63),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_typeof] = ACTIONS(71),
    [anon_sym_void] = ACTIONS(71),
    [anon_sym_delete] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DQUOTE] = ACTIONS(75),
    [anon_sym_SQUOTE] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(79),
    [sym_number] = ACTIONS(105),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(83),
    [sym_true] = ACTIONS(83),
    [sym_false] = ACTIONS(83),
    [sym_null] = ACTIONS(83),
    [sym_undefined] = ACTIONS(83),
    [anon_sym_AT] = ACTIONS(85),
    [anon_sym_static] = ACTIONS(107),
    [anon_sym_get] = ACTIONS(109),
    [anon_sym_set] = ACTIONS(109),
  },
  [4] = {
    [sym_export_statement] = STATE(18),
    [sym_declaration] = STATE(18),
    [sym_import] = STATE(539),
    [sym_import_statement] = STATE(18),
    [sym_expression_statement] = STATE(18),
    [sym_variable_declaration] = STATE(275),
    [sym_lexical_declaration] = STATE(275),
    [sym_statement_block] = STATE(18),
    [sym_if_statement] = STATE(18),
    [sym_switch_statement] = STATE(18),
    [sym_for_statement] = STATE(18),
    [sym_for_in_statement] = STATE(18),
    [sym_while_statement] = STATE(18),
    [sym_do_statement] = STATE(18),
    [sym_try_statement] = STATE(18),
    [sym_with_statement] = STATE(18),
    [sym_break_statement] = STATE(18),
    [sym_continue_statement] = STATE(18),
    [sym_debugger_statement] = STATE(18),
    [sym_return_statement] = STATE(18),
    [sym_throw_statement] = STATE(18),
    [sym_empty_statement] = STATE(18),
    [sym_labeled_statement] = STATE(18),
    [sym_parenthesized_expression] = STATE(362),
    [sym_expression] = STATE(522),
    [sym_primary_expression] = STATE(546),
    [sym_yield_expression] = STATE(550),
    [sym_object] = STATE(539),
    [sym_object_pattern] = STATE(1307),
    [sym_object_assignment_pattern] = STATE(1052),
    [sym_array] = STATE(539),
    [sym_array_pattern] = STATE(1307),
    [sym_jsx_element] = STATE(550),
    [sym_jsx_fragment] = STATE(550),
    [sym_jsx_opening_element] = STATE(772),
    [sym_jsx_self_closing_element] = STATE(550),
    [sym_class] = STATE(539),
    [sym_class_declaration] = STATE(275),
    [sym_function] = STATE(539),
    [sym_function_declaration] = STATE(275),
    [sym_generator_function] = STATE(539),
    [sym_generator_function_declaration] = STATE(275),
    [sym_arrow_function] = STATE(539),
    [sym_call_expression] = STATE(539),
    [sym_new_expression] = STATE(550),
    [sym_await_expression] = STATE(550),
    [sym_member_expression] = STATE(362),
    [sym_subscript_expression] = STATE(362),
    [sym_assignment_expression] = STATE(550),
    [sym__augmented_assignment_lhs] = STATE(720),
    [sym_augmented_assignment_expression] = STATE(550),
    [sym__destructuring_pattern] = STATE(1307),
    [sym_spread_element] = STATE(1016),
    [sym_ternary_expression] = STATE(550),
    [sym_binary_expression] = STATE(550),
    [sym_unary_expression] = STATE(550),
    [sym_update_expression] = STATE(550),
    [sym_sequence_expression] = STATE(1156),
    [sym_string] = STATE(564),
    [sym_template_string] = STATE(539),
    [sym_regex] = STATE(539),
    [sym_meta_property] = STATE(539),
    [sym_decorator] = STATE(750),
    [sym_formal_parameters] = STATE(1318),
    [sym_rest_pattern] = STATE(1052),
    [sym_method_definition] = STATE(1016),
    [sym_pair] = STATE(1016),
    [sym_pair_pattern] = STATE(1052),
    [sym__property_name] = STATE(1049),
    [sym_computed_property_name] = STATE(1049),
    [aux_sym_program_repeat1] = STATE(18),
    [aux_sym_export_statement_repeat1] = STATE(688),
    [aux_sym_object_repeat1] = STATE(1018),
    [aux_sym_object_pattern_repeat1] = STATE(1044),
    [sym_identifier] = ACTIONS(113),
    [anon_sym_export] = ACTIONS(115),
    [anon_sym_STAR] = ACTIONS(93),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_COMMA] = ACTIONS(95),
    [anon_sym_RBRACE] = ACTIONS(117),
    [anon_sym_import] = ACTIONS(15),
    [anon_sym_var] = ACTIONS(17),
    [anon_sym_let] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(19),
    [anon_sym_if] = ACTIONS(21),
    [anon_sym_switch] = ACTIONS(23),
    [anon_sym_for] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(29),
    [anon_sym_while] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(33),
    [anon_sym_try] = ACTIONS(35),
    [anon_sym_with] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_debugger] = ACTIONS(43),
    [anon_sym_return] = ACTIONS(45),
    [anon_sym_throw] = ACTIONS(47),
    [anon_sym_SEMI] = ACTIONS(49),
    [anon_sym_yield] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(99),
    [anon_sym_LT] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(59),
    [anon_sym_async] = ACTIONS(119),
    [anon_sym_function] = ACTIONS(63),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_typeof] = ACTIONS(71),
    [anon_sym_void] = ACTIONS(71),
    [anon_sym_delete] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DQUOTE] = ACTIONS(75),
    [anon_sym_SQUOTE] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(79),
    [sym_number] = ACTIONS(105),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(83),
    [sym_true] = ACTIONS(83),
    [sym_false] = ACTIONS(83),
    [sym_null] = ACTIONS(83),
    [sym_undefined] = ACTIONS(83),
    [anon_sym_AT] = ACTIONS(85),
    [anon_sym_static] = ACTIONS(121),
    [anon_sym_get] = ACTIONS(123),
    [anon_sym_set] = ACTIONS(123),
  },
  [5] = {
    [sym_export_statement] = STATE(18),
    [sym_declaration] = STATE(18),
    [sym_import] = STATE(539),
    [sym_import_statement] = STATE(18),
    [sym_expression_statement] = STATE(18),
    [sym_variable_declaration] = STATE(275),
    [sym_lexical_declaration] = STATE(275),
    [sym_statement_block] = STATE(18),
    [sym_if_statement] = STATE(18),
    [sym_switch_statement] = STATE(18),
    [sym_for_statement] = STATE(18),
    [sym_for_in_statement] = STATE(18),
    [sym_while_statement] = STATE(18),
    [sym_do_statement] = STATE(18),
    [sym_try_statement] = STATE(18),
    [sym_with_statement] = STATE(18),
    [sym_break_statement] = STATE(18),
    [sym_continue_statement] = STATE(18),
    [sym_debugger_statement] = STATE(18),
    [sym_return_statement] = STATE(18),
    [sym_throw_statement] = STATE(18),
    [sym_empty_statement] = STATE(18),
    [sym_labeled_statement] = STATE(18),
    [sym_parenthesized_expression] = STATE(362),
    [sym_expression] = STATE(522),
    [sym_primary_expression] = STATE(546),
    [sym_yield_expression] = STATE(550),
    [sym_object] = STATE(539),
    [sym_object_pattern] = STATE(1307),
    [sym_object_assignment_pattern] = STATE(1052),
    [sym_array] = STATE(539),
    [sym_array_pattern] = STATE(1307),
    [sym_jsx_element] = STATE(550),
    [sym_jsx_fragment] = STATE(550),
    [sym_jsx_opening_element] = STATE(772),
    [sym_jsx_self_closing_element] = STATE(550),
    [sym_class] = STATE(539),
    [sym_class_declaration] = STATE(275),
    [sym_function] = STATE(539),
    [sym_function_declaration] = STATE(275),
    [sym_generator_function] = STATE(539),
    [sym_generator_function_declaration] = STATE(275),
    [sym_arrow_function] = STATE(539),
    [sym_call_expression] = STATE(539),
    [sym_new_expression] = STATE(550),
    [sym_await_expression] = STATE(550),
    [sym_member_expression] = STATE(362),
    [sym_subscript_expression] = STATE(362),
    [sym_assignment_expression] = STATE(550),
    [sym__augmented_assignment_lhs] = STATE(720),
    [sym_augmented_assignment_expression] = STATE(550),
    [sym__destructuring_pattern] = STATE(1307),
    [sym_spread_element] = STATE(1016),
    [sym_ternary_expression] = STATE(550),
    [sym_binary_expression] = STATE(550),
    [sym_unary_expression] = STATE(550),
    [sym_update_expression] = STATE(550),
    [sym_sequence_expression] = STATE(1156),
    [sym_string] = STATE(564),
    [sym_template_string] = STATE(539),
    [sym_regex] = STATE(539),
    [sym_meta_property] = STATE(539),
    [sym_decorator] = STATE(750),
    [sym_formal_parameters] = STATE(1318),
    [sym_rest_pattern] = STATE(1052),
    [sym_method_definition] = STATE(1016),
    [sym_pair] = STATE(1016),
    [sym_pair_pattern] = STATE(1052),
    [sym__property_name] = STATE(1049),
    [sym_computed_property_name] = STATE(1049),
    [aux_sym_program_repeat1] = STATE(18),
    [aux_sym_export_statement_repeat1] = STATE(688),
    [aux_sym_object_repeat1] = STATE(1018),
    [aux_sym_object_pattern_repeat1] = STATE(1044),
    [sym_identifier] = ACTIONS(125),
    [anon_sym_export] = ACTIONS(127),
    [anon_sym_STAR] = ACTIONS(93),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_COMMA] = ACTIONS(95),
    [anon_sym_RBRACE] = ACTIONS(117),
    [anon_sym_import] = ACTIONS(15),
    [anon_sym_var] = ACTIONS(17),
    [anon_sym_let] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(19),
    [anon_sym_if] = ACTIONS(21),
    [anon_sym_switch] = ACTIONS(23),
    [anon_sym_for] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(29),
    [anon_sym_while] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(33),
    [anon_sym_try] = ACTIONS(35),
    [anon_sym_with] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_debugger] = ACTIONS(43),
    [anon_sym_return] = ACTIONS(45),
    [anon_sym_throw] = ACTIONS(47),
    [anon_sym_SEMI] = ACTIONS(49),
    [anon_sym_yield] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(99),
    [anon_sym_LT] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(59),
    [anon_sym_async] = ACTIONS(129),
    [anon_sym_function] = ACTIONS(63),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_typeof] = ACTIONS(71),
    [anon_sym_void] = ACTIONS(71),
    [anon_sym_delete] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DQUOTE] = ACTIONS(75),
    [anon_sym_SQUOTE] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(79),
    [sym_number] = ACTIONS(105),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(83),
    [sym_true] = ACTIONS(83),
    [sym_false] = ACTIONS(83),
    [sym_null] = ACTIONS(83),
    [sym_undefined] = ACTIONS(83),
    [anon_sym_AT] = ACTIONS(85),
    [anon_sym_static] = ACTIONS(131),
    [anon_sym_get] = ACTIONS(133),
    [anon_sym_set] = ACTIONS(133),
  },
  [6] = {
    [sym_export_statement] = STATE(12),
    [sym_declaration] = STATE(12),
    [sym_import] = STATE(539),
    [sym_import_statement] = STATE(12),
    [sym_expression_statement] = STATE(12),
    [sym_variable_declaration] = STATE(275),
    [sym_lexical_declaration] = STATE(275),
    [sym_statement_block] = STATE(12),
    [sym_if_statement] = STATE(12),
    [sym_switch_statement] = STATE(12),
    [sym_for_statement] = STATE(12),
    [sym_for_in_statement] = STATE(12),
    [sym_while_statement] = STATE(12),
    [sym_do_statement] = STATE(12),
    [sym_try_statement] = STATE(12),
    [sym_with_statement] = STATE(12),
    [sym_break_statement] = STATE(12),
    [sym_continue_statement] = STATE(12),
    [sym_debugger_statement] = STATE(12),
    [sym_return_statement] = STATE(12),
    [sym_throw_statement] = STATE(12),
    [sym_empty_statement] = STATE(12),
    [sym_labeled_statement] = STATE(12),
    [sym_parenthesized_expression] = STATE(362),
    [sym_expression] = STATE(522),
    [sym_primary_expression] = STATE(546),
    [sym_yield_expression] = STATE(550),
    [sym_object] = STATE(539),
    [sym_object_pattern] = STATE(1307),
    [sym_object_assignment_pattern] = STATE(1052),
    [sym_array] = STATE(539),
    [sym_array_pattern] = STATE(1307),
    [sym_jsx_element] = STATE(550),
    [sym_jsx_fragment] = STATE(550),
    [sym_jsx_opening_element] = STATE(772),
    [sym_jsx_self_closing_element] = STATE(550),
    [sym_class] = STATE(539),
    [sym_class_declaration] = STATE(275),
    [sym_function] = STATE(539),
    [sym_function_declaration] = STATE(275),
    [sym_generator_function] = STATE(539),
    [sym_generator_function_declaration] = STATE(275),
    [sym_arrow_function] = STATE(539),
    [sym_call_expression] = STATE(539),
    [sym_new_expression] = STATE(550),
    [sym_await_expression] = STATE(550),
    [sym_member_expression] = STATE(362),
    [sym_subscript_expression] = STATE(362),
    [sym_assignment_expression] = STATE(550),
    [sym__augmented_assignment_lhs] = STATE(720),
    [sym_augmented_assignment_expression] = STATE(550),
    [sym__destructuring_pattern] = STATE(1307),
    [sym_spread_element] = STATE(1050),
    [sym_ternary_expression] = STATE(550),
    [sym_binary_expression] = STATE(550),
    [sym_unary_expression] = STATE(550),
    [sym_update_expression] = STATE(550),
    [sym_sequence_expression] = STATE(1156),
    [sym_string] = STATE(564),
    [sym_template_string] = STATE(539),
    [sym_regex] = STATE(539),
    [sym_meta_property] = STATE(539),
    [sym_decorator] = STATE(750),
    [sym_formal_parameters] = STATE(1318),
    [sym_rest_pattern] = STATE(1052),
    [sym_method_definition] = STATE(1050),
    [sym_pair] = STATE(1050),
    [sym_pair_pattern] = STATE(1052),
    [sym__property_name] = STATE(1049),
    [sym_computed_property_name] = STATE(1049),
    [aux_sym_program_repeat1] = STATE(12),
    [aux_sym_export_statement_repeat1] = STATE(688),
    [aux_sym_object_repeat1] = STATE(1048),
    [aux_sym_object_pattern_repeat1] = STATE(1044),
    [sym_identifier] = ACTIONS(89),
    [anon_sym_export] = ACTIONS(91),
    [anon_sym_STAR] = ACTIONS(93),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_COMMA] = ACTIONS(95),
    [anon_sym_RBRACE] = ACTIONS(135),
    [anon_sym_import] = ACTIONS(15),
    [anon_sym_var] = ACTIONS(17),
    [anon_sym_let] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(19),
    [anon_sym_if] = ACTIONS(21),
    [anon_sym_switch] = ACTIONS(23),
    [anon_sym_for] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(29),
    [anon_sym_while] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(33),
    [anon_sym_try] = ACTIONS(35),
    [anon_sym_with] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_debugger] = ACTIONS(43),
    [anon_sym_return] = ACTIONS(45),
    [anon_sym_throw] = ACTIONS(47),
    [anon_sym_SEMI] = ACTIONS(49),
    [anon_sym_yield] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(99),
    [anon_sym_LT] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(59),
    [anon_sym_async] = ACTIONS(101),
    [anon_sym_function] = ACTIONS(63),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_typeof] = ACTIONS(71),
    [anon_sym_void] = ACTIONS(71),
    [anon_sym_delete] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DQUOTE] = ACTIONS(75),
    [anon_sym_SQUOTE] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(79),
    [sym_number] = ACTIONS(105),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(83),
    [sym_true] = ACTIONS(83),
    [sym_false] = ACTIONS(83),
    [sym_null] = ACTIONS(83),
    [sym_undefined] = ACTIONS(83),
    [anon_sym_AT] = ACTIONS(85),
    [anon_sym_static] = ACTIONS(107),
    [anon_sym_get] = ACTIONS(109),
    [anon_sym_set] = ACTIONS(109),
  },
  [7] = {
    [sym_export_statement] = STATE(7),
    [sym_declaration] = STATE(7),
    [sym_import] = STATE(539),
    [sym_import_statement] = STATE(7),
    [sym_expression_statement] = STATE(7),
    [sym_variable_declaration] = STATE(275),
    [sym_lexical_declaration] = STATE(275),
    [sym_statement_block] = STATE(7),
    [sym_if_statement] = STATE(7),
    [sym_switch_statement] = STATE(7),
    [sym_for_statement] = STATE(7),
    [sym_for_in_statement] = STATE(7),
    [sym_while_statement] = STATE(7),
    [sym_do_statement] = STATE(7),
    [sym_try_statement] = STATE(7),
    [sym_with_statement] = STATE(7),
    [sym_break_statement] = STATE(7),
    [sym_continue_statement] = STATE(7),
    [sym_debugger_statement] = STATE(7),
    [sym_return_statement] = STATE(7),
    [sym_throw_statement] = STATE(7),
    [sym_empty_statement] = STATE(7),
    [sym_labeled_statement] = STATE(7),
    [sym_parenthesized_expression] = STATE(362),
    [sym_expression] = STATE(522),
    [sym_primary_expression] = STATE(546),
    [sym_yield_expression] = STATE(550),
    [sym_object] = STATE(539),
    [sym_object_pattern] = STATE(1320),
    [sym_array] = STATE(539),
    [sym_array_pattern] = STATE(1320),
    [sym_jsx_element] = STATE(550),
    [sym_jsx_fragment] = STATE(550),
    [sym_jsx_opening_element] = STATE(772),
    [sym_jsx_self_closing_element] = STATE(550),
    [sym_class] = STATE(539),
    [sym_class_declaration] = STATE(275),
    [sym_function] = STATE(539),
    [sym_function_declaration] = STATE(275),
    [sym_generator_function] = STATE(539),
    [sym_generator_function_declaration] = STATE(275),
    [sym_arrow_function] = STATE(539),
    [sym_call_expression] = STATE(539),
    [sym_new_expression] = STATE(550),
    [sym_await_expression] = STATE(550),
    [sym_member_expression] = STATE(362),
    [sym_subscript_expression] = STATE(362),
    [sym_assignment_expression] = STATE(550),
    [sym__augmented_assignment_lhs] = STATE(720),
    [sym_augmented_assignment_expression] = STATE(550),
    [sym__destructuring_pattern] = STATE(1320),
    [sym_ternary_expression] = STATE(550),
    [sym_binary_expression] = STATE(550),
    [sym_unary_expression] = STATE(550),
    [sym_update_expression] = STATE(550),
    [sym_sequence_expression] = STATE(1156),
    [sym_string] = STATE(539),
    [sym_template_string] = STATE(539),
    [sym_regex] = STATE(539),
    [sym_meta_property] = STATE(539),
    [sym_decorator] = STATE(750),
    [sym_formal_parameters] = STATE(1318),
    [aux_sym_program_repeat1] = STATE(7),
    [aux_sym_export_statement_repeat1] = STATE(891),
    [ts_builtin_sym_end] = ACTIONS(137),
    [sym_identifier] = ACTIONS(139),
    [anon_sym_export] = ACTIONS(142),
    [anon_sym_default] = ACTIONS(145),
    [anon_sym_LBRACE] = ACTIONS(147),
    [anon_sym_RBRACE] = ACTIONS(137),
    [anon_sym_import] = ACTIONS(150),
    [anon_sym_var] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(156),
    [anon_sym_const] = ACTIONS(156),
    [anon_sym_if] = ACTIONS(159),
    [anon_sym_switch] = ACTIONS(162),
    [anon_sym_for] = ACTIONS(165),
    [anon_sym_LPAREN] = ACTIONS(168),
    [anon_sym_await] = ACTIONS(171),
    [anon_sym_while] = ACTIONS(174),
    [anon_sym_do] = ACTIONS(177),
    [anon_sym_try] = ACTIONS(180),
    [anon_sym_with] = ACTIONS(183),
    [anon_sym_break] = ACTIONS(186),
    [anon_sym_continue] = ACTIONS(189),
    [anon_sym_debugger] = ACTIONS(192),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_throw] = ACTIONS(198),
    [anon_sym_SEMI] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(145),
    [anon_sym_yield] = ACTIONS(204),
    [anon_sym_LBRACK] = ACTIONS(207),
    [anon_sym_LT] = ACTIONS(210),
    [anon_sym_SLASH] = ACTIONS(213),
    [anon_sym_class] = ACTIONS(216),
    [anon_sym_async] = ACTIONS(219),
    [anon_sym_function] = ACTIONS(222),
    [anon_sym_new] = ACTIONS(225),
    [anon_sym_PLUS] = ACTIONS(228),
    [anon_sym_DASH] = ACTIONS(228),
    [anon_sym_BANG] = ACTIONS(231),
    [anon_sym_TILDE] = ACTIONS(231),
    [anon_sym_typeof] = ACTIONS(234),
    [anon_sym_void] = ACTIONS(234),
    [anon_sym_delete] = ACTIONS(234),
    [anon_sym_PLUS_PLUS] = ACTIONS(237),
    [anon_sym_DASH_DASH] = ACTIONS(237),
    [anon_sym_DQUOTE] = ACTIONS(240),
    [anon_sym_SQUOTE] = ACTIONS(243),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(246),
    [sym_number] = ACTIONS(249),
    [sym_this] = ACTIONS(252),
    [sym_super] = ACTIONS(252),
    [sym_true] = ACTIONS(252),
    [sym_false] = ACTIONS(252),
    [sym_null] = ACTIONS(252),
    [sym_undefined] = ACTIONS(252),
    [anon_sym_AT] = ACTIONS(255),
    [anon_sym_static] = ACTIONS(258),
    [anon_sym_get] = ACTIONS(258),
    [anon_sym_set] = ACTIONS(258),
  },
  [8] = {
    [sym_export_statement] = STATE(7),
    [sym_declaration] = STATE(7),
    [sym_import] = STATE(539),
    [sym_import_statement] = STATE(7),
    [sym_expression_statement] = STATE(7),
    [sym_variable_declaration] = STATE(275),
    [sym_lexical_declaration] = STATE(275),
    [sym_statement_block] = STATE(7),
    [sym_if_statement] = STATE(7),
    [sym_switch_statement] = STATE(7),
    [sym_for_statement] = STATE(7),
    [sym_for_in_statement] = STATE(7),
    [sym_while_statement] = STATE(7),
    [sym_do_statement] = STATE(7),
    [sym_try_statement] = STATE(7),
    [sym_with_statement] = STATE(7),
    [sym_break_statement] = STATE(7),
    [sym_continue_statement] = STATE(7),
    [sym_debugger_statement] = STATE(7),
    [sym_return_statement] = STATE(7),
    [sym_throw_statement] = STATE(7),
    [sym_empty_statement] = STATE(7),
    [sym_labeled_statement] = STATE(7),
    [sym_parenthesized_expression] = STATE(362),
    [sym_expression] = STATE(522),
    [sym_primary_expression] = STATE(546),
    [sym_yield_expression] = STATE(550),
    [sym_object] = STATE(539),
    [sym_object_pattern] = STATE(1320),
    [sym_array] = STATE(539),
    [sym_array_pattern] = STATE(1320),
    [sym_jsx_element] = STATE(550),
    [sym_jsx_fragment] = STATE(550),
    [sym_jsx_opening_element] = STATE(772),
    [sym_jsx_self_closing_element] = STATE(550),
    [sym_class] = STATE(539),
    [sym_class_declaration] = STATE(275),
    [sym_function] = STATE(539),
    [sym_function_declaration] = STATE(275),
    [sym_generator_function] = STATE(539),
    [sym_generator_function_declaration] = STATE(275),
    [sym_arrow_function] = STATE(539),
    [sym_call_expression] = STATE(539),
    [sym_new_expression] = STATE(550),
    [sym_await_expression] = STATE(550),
    [sym_member_expression] = STATE(362),
    [sym_subscript_expression] = STATE(362),
    [sym_assignment_expression] = STATE(550),
    [sym__augmented_assignment_lhs] = STATE(720),
    [sym_augmented_assignment_expression] = STATE(550),
    [sym__destructuring_pattern] = STATE(1320),
    [sym_ternary_expression] = STATE(550),
    [sym_binary_expression] = STATE(550),
    [sym_unary_expression] = STATE(550),
    [sym_update_expression] = STATE(550),
    [sym_sequence_expression] = STATE(1156),
    [sym_string] = STATE(539),
    [sym_template_string] = STATE(539),
    [sym_regex] = STATE(539),
    [sym_meta_property] = STATE(539),
    [sym_decorator] = STATE(750),
    [sym_formal_parameters] = STATE(1318),
    [aux_sym_program_repeat1] = STATE(7),
    [aux_sym_export_statement_repeat1] = STATE(891),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_default] = ACTIONS(261),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_RBRACE] = ACTIONS(263),
    [anon_sym_import] = ACTIONS(15),
    [anon_sym_var] = ACTIONS(17),
    [anon_sym_let] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(19),
    [anon_sym_if] = ACTIONS(21),
    [anon_sym_switch] = ACTIONS(23),
    [anon_sym_for] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(29),
    [anon_sym_while] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(33),
    [anon_sym_try] = ACTIONS(35),
    [anon_sym_with] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_debugger] = ACTIONS(43),
    [anon_sym_return] = ACTIONS(45),
    [anon_sym_throw] = ACTIONS(47),
    [anon_sym_SEMI] = ACTIONS(49),
    [anon_sym_case] = ACTIONS(261),
    [anon_sym_yield] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(53),
    [anon_sym_LT] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(59),
    [anon_sym_async] = ACTIONS(61),
    [anon_sym_function] = ACTIONS(63),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_typeof] = ACTIONS(71),
    [anon_sym_void] = ACTIONS(71),
    [anon_sym_delete] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DQUOTE] = ACTIONS(75),
    [anon_sym_SQUOTE] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(79),
    [sym_number] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(83),
    [sym_true] = ACTIONS(83),
    [sym_false] = ACTIONS(83),
    [sym_null] = ACTIONS(83),
    [sym_undefined] = ACTIONS(83),
    [anon_sym_AT] = ACTIONS(85),
    [anon_sym_static] = ACTIONS(87),
    [anon_sym_get] = ACTIONS(87),
    [anon_sym_set] = ACTIONS(87),
  },
  [9] = {
    [sym_export_statement] = STATE(7),
    [sym_declaration] = STATE(7),
    [sym_import] = STATE(539),
    [sym_import_statement] = STATE(7),
    [sym_expression_statement] = STATE(7),
    [sym_variable_declaration] = STATE(275),
    [sym_lexical_declaration] = STATE(275),
    [sym_statement_block] = STATE(7),
    [sym_if_statement] = STATE(7),
    [sym_switch_statement] = STATE(7),
    [sym_for_statement] = STATE(7),
    [sym_for_in_statement] = STATE(7),
    [sym_while_statement] = STATE(7),
    [sym_do_statement] = STATE(7),
    [sym_try_statement] = STATE(7),
    [sym_with_statement] = STATE(7),
    [sym_break_statement] = STATE(7),
    [sym_continue_statement] = STATE(7),
    [sym_debugger_statement] = STATE(7),
    [sym_return_statement] = STATE(7),
    [sym_throw_statement] = STATE(7),
    [sym_empty_statement] = STATE(7),
    [sym_labeled_statement] = STATE(7),
    [sym_parenthesized_expression] = STATE(362),
    [sym_expression] = STATE(522),
    [sym_primary_expression] = STATE(546),
    [sym_yield_expression] = STATE(550),
    [sym_object] = STATE(539),
    [sym_object_pattern] = STATE(1320),
    [sym_array] = STATE(539),
    [sym_array_pattern] = STATE(1320),
    [sym_jsx_element] = STATE(550),
    [sym_jsx_fragment] = STATE(550),
    [sym_jsx_opening_element] = STATE(772),
    [sym_jsx_self_closing_element] = STATE(550),
    [sym_class] = STATE(539),
    [sym_class_declaration] = STATE(275),
    [sym_function] = STATE(539),
    [sym_function_declaration] = STATE(275),
    [sym_generator_function] = STATE(539),
    [sym_generator_function_declaration] = STATE(275),
    [sym_arrow_function] = STATE(539),
    [sym_call_expression] = STATE(539),
    [sym_new_expression] = STATE(550),
    [sym_await_expression] = STATE(550),
    [sym_member_expression] = STATE(362),
    [sym_subscript_expression] = STATE(362),
    [sym_assignment_expression] = STATE(550),
    [sym__augmented_assignment_lhs] = STATE(720),
    [sym_augmented_assignment_expression] = STATE(550),
    [sym__destructuring_pattern] = STATE(1320),
    [sym_ternary_expression] = STATE(550),
    [sym_binary_expression] = STATE(550),
    [sym_unary_expression] = STATE(550),
    [sym_update_expression] = STATE(550),
    [sym_sequence_expression] = STATE(1156),
    [sym_string] = STATE(539),
    [sym_template_string] = STATE(539),
    [sym_regex] = STATE(539),
    [sym_meta_property] = STATE(539),
    [sym_decorator] = STATE(750),
    [sym_formal_parameters] = STATE(1318),
    [aux_sym_program_repeat1] = STATE(7),
    [aux_sym_export_statement_repeat1] = STATE(891),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_default] = ACTIONS(265),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_RBRACE] = ACTIONS(267),
    [anon_sym_import] = ACTIONS(15),
    [anon_sym_var] = ACTIONS(17),
    [anon_sym_let] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(19),
    [anon_sym_if] = ACTIONS(21),
    [anon_sym_switch] = ACTIONS(23),
    [anon_sym_for] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(29),
    [anon_sym_while] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(33),
    [anon_sym_try] = ACTIONS(35),
    [anon_sym_with] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_debugger] = ACTIONS(43),
    [anon_sym_return] = ACTIONS(45),
    [anon_sym_throw] = ACTIONS(47),
    [anon_sym_SEMI] = ACTIONS(49),
    [anon_sym_case] = ACTIONS(265),
    [anon_sym_yield] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(53),
    [anon_sym_LT] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(59),
    [anon_sym_async] = ACTIONS(61),
    [anon_sym_function] = ACTIONS(63),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_typeof] = ACTIONS(71),
    [anon_sym_void] = ACTIONS(71),
    [anon_sym_delete] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DQUOTE] = ACTIONS(75),
    [anon_sym_SQUOTE] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(79),
    [sym_number] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(83),
    [sym_true] = ACTIONS(83),
    [sym_false] = ACTIONS(83),
    [sym_null] = ACTIONS(83),
    [sym_undefined] = ACTIONS(83),
    [anon_sym_AT] = ACTIONS(85),
    [anon_sym_static] = ACTIONS(87),
    [anon_sym_get] = ACTIONS(87),
    [anon_sym_set] = ACTIONS(87),
  },
  [10] = {
    [sym_export_statement] = STATE(8),
    [sym_declaration] = STATE(8),
    [sym_import] = STATE(539),
    [sym_import_statement] = STATE(8),
    [sym_expression_statement] = STATE(8),
    [sym_variable_declaration] = STATE(275),
    [sym_lexical_declaration] = STATE(275),
    [sym_statement_block] = STATE(8),
    [sym_if_statement] = STATE(8),
    [sym_switch_statement] = STATE(8),
    [sym_for_statement] = STATE(8),
    [sym_for_in_statement] = STATE(8),
    [sym_while_statement] = STATE(8),
    [sym_do_statement] = STATE(8),
    [sym_try_statement] = STATE(8),
    [sym_with_statement] = STATE(8),
    [sym_break_statement] = STATE(8),
    [sym_continue_statement] = STATE(8),
    [sym_debugger_statement] = STATE(8),
    [sym_return_statement] = STATE(8),
    [sym_throw_statement] = STATE(8),
    [sym_empty_statement] = STATE(8),
    [sym_labeled_statement] = STATE(8),
    [sym_parenthesized_expression] = STATE(362),
    [sym_expression] = STATE(522),
    [sym_primary_expression] = STATE(546),
    [sym_yield_expression] = STATE(550),
    [sym_object] = STATE(539),
    [sym_object_pattern] = STATE(1320),
    [sym_array] = STATE(539),
    [sym_array_pattern] = STATE(1320),
    [sym_jsx_element] = STATE(550),
    [sym_jsx_fragment] = STATE(550),
    [sym_jsx_opening_element] = STATE(772),
    [sym_jsx_self_closing_element] = STATE(550),
    [sym_class] = STATE(539),
    [sym_class_declaration] = STATE(275),
    [sym_function] = STATE(539),
    [sym_function_declaration] = STATE(275),
    [sym_generator_function] = STATE(539),
    [sym_generator_function_declaration] = STATE(275),
    [sym_arrow_function] = STATE(539),
    [sym_call_expression] = STATE(539),
    [sym_new_expression] = STATE(550),
    [sym_await_expression] = STATE(550),
    [sym_member_expression] = STATE(362),
    [sym_subscript_expression] = STATE(362),
    [sym_assignment_expression] = STATE(550),
    [sym__augmented_assignment_lhs] = STATE(720),
    [sym_augmented_assignment_expression] = STATE(550),
    [sym__destructuring_pattern] = STATE(1320),
    [sym_ternary_expression] = STATE(550),
    [sym_binary_expression] = STATE(550),
    [sym_unary_expression] = STATE(550),
    [sym_update_expression] = STATE(550),
    [sym_sequence_expression] = STATE(1156),
    [sym_string] = STATE(539),
    [sym_template_string] = STATE(539),
    [sym_regex] = STATE(539),
    [sym_meta_property] = STATE(539),
    [sym_decorator] = STATE(750),
    [sym_formal_parameters] = STATE(1318),
    [aux_sym_program_repeat1] = STATE(8),
    [aux_sym_export_statement_repeat1] = STATE(891),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_default] = ACTIONS(269),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_RBRACE] = ACTIONS(271),
    [anon_sym_import] = ACTIONS(15),
    [anon_sym_var] = ACTIONS(17),
    [anon_sym_let] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(19),
    [anon_sym_if] = ACTIONS(21),
    [anon_sym_switch] = ACTIONS(23),
    [anon_sym_for] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(29),
    [anon_sym_while] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(33),
    [anon_sym_try] = ACTIONS(35),
    [anon_sym_with] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_debugger] = ACTIONS(43),
    [anon_sym_return] = ACTIONS(45),
    [anon_sym_throw] = ACTIONS(47),
    [anon_sym_SEMI] = ACTIONS(49),
    [anon_sym_case] = ACTIONS(269),
    [anon_sym_yield] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(53),
    [anon_sym_LT] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(59),
    [anon_sym_async] = ACTIONS(61),
    [anon_sym_function] = ACTIONS(63),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_typeof] = ACTIONS(71),
    [anon_sym_void] = ACTIONS(71),
    [anon_sym_delete] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DQUOTE] = ACTIONS(75),
    [anon_sym_SQUOTE] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(79),
    [sym_number] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(83),
    [sym_true] = ACTIONS(83),
    [sym_false] = ACTIONS(83),
    [sym_null] = ACTIONS(83),
    [sym_undefined] = ACTIONS(83),
    [anon_sym_AT] = ACTIONS(85),
    [anon_sym_static] = ACTIONS(87),
    [anon_sym_get] = ACTIONS(87),
    [anon_sym_set] = ACTIONS(87),
  },
  [11] = {
    [sym_export_statement] = STATE(9),
    [sym_declaration] = STATE(9),
    [sym_import] = STATE(539),
    [sym_import_statement] = STATE(9),
    [sym_expression_statement] = STATE(9),
    [sym_variable_declaration] = STATE(275),
    [sym_lexical_declaration] = STATE(275),
    [sym_statement_block] = STATE(9),
    [sym_if_statement] = STATE(9),
    [sym_switch_statement] = STATE(9),
    [sym_for_statement] = STATE(9),
    [sym_for_in_statement] = STATE(9),
    [sym_while_statement] = STATE(9),
    [sym_do_statement] = STATE(9),
    [sym_try_statement] = STATE(9),
    [sym_with_statement] = STATE(9),
    [sym_break_statement] = STATE(9),
    [sym_continue_statement] = STATE(9),
    [sym_debugger_statement] = STATE(9),
    [sym_return_statement] = STATE(9),
    [sym_throw_statement] = STATE(9),
    [sym_empty_statement] = STATE(9),
    [sym_labeled_statement] = STATE(9),
    [sym_parenthesized_expression] = STATE(362),
    [sym_expression] = STATE(522),
    [sym_primary_expression] = STATE(546),
    [sym_yield_expression] = STATE(550),
    [sym_object] = STATE(539),
    [sym_object_pattern] = STATE(1320),
    [sym_array] = STATE(539),
    [sym_array_pattern] = STATE(1320),
    [sym_jsx_element] = STATE(550),
    [sym_jsx_fragment] = STATE(550),
    [sym_jsx_opening_element] = STATE(772),
    [sym_jsx_self_closing_element] = STATE(550),
    [sym_class] = STATE(539),
    [sym_class_declaration] = STATE(275),
    [sym_function] = STATE(539),
    [sym_function_declaration] = STATE(275),
    [sym_generator_function] = STATE(539),
    [sym_generator_function_declaration] = STATE(275),
    [sym_arrow_function] = STATE(539),
    [sym_call_expression] = STATE(539),
    [sym_new_expression] = STATE(550),
    [sym_await_expression] = STATE(550),
    [sym_member_expression] = STATE(362),
    [sym_subscript_expression] = STATE(362),
    [sym_assignment_expression] = STATE(550),
    [sym__augmented_assignment_lhs] = STATE(720),
    [sym_augmented_assignment_expression] = STATE(550),
    [sym__destructuring_pattern] = STATE(1320),
    [sym_ternary_expression] = STATE(550),
    [sym_binary_expression] = STATE(550),
    [sym_unary_expression] = STATE(550),
    [sym_update_expression] = STATE(550),
    [sym_sequence_expression] = STATE(1156),
    [sym_string] = STATE(539),
    [sym_template_string] = STATE(539),
    [sym_regex] = STATE(539),
    [sym_meta_property] = STATE(539),
    [sym_decorator] = STATE(750),
    [sym_formal_parameters] = STATE(1318),
    [aux_sym_program_repeat1] = STATE(9),
    [aux_sym_export_statement_repeat1] = STATE(891),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_default] = ACTIONS(273),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_RBRACE] = ACTIONS(275),
    [anon_sym_import] = ACTIONS(15),
    [anon_sym_var] = ACTIONS(17),
    [anon_sym_let] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(19),
    [anon_sym_if] = ACTIONS(21),
    [anon_sym_switch] = ACTIONS(23),
    [anon_sym_for] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(29),
    [anon_sym_while] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(33),
    [anon_sym_try] = ACTIONS(35),
    [anon_sym_with] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_debugger] = ACTIONS(43),
    [anon_sym_return] = ACTIONS(45),
    [anon_sym_throw] = ACTIONS(47),
    [anon_sym_SEMI] = ACTIONS(49),
    [anon_sym_case] = ACTIONS(273),
    [anon_sym_yield] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(53),
    [anon_sym_LT] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(59),
    [anon_sym_async] = ACTIONS(61),
    [anon_sym_function] = ACTIONS(63),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_typeof] = ACTIONS(71),
    [anon_sym_void] = ACTIONS(71),
    [anon_sym_delete] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DQUOTE] = ACTIONS(75),
    [anon_sym_SQUOTE] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(79),
    [sym_number] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(83),
    [sym_true] = ACTIONS(83),
    [sym_false] = ACTIONS(83),
    [sym_null] = ACTIONS(83),
    [sym_undefined] = ACTIONS(83),
    [anon_sym_AT] = ACTIONS(85),
    [anon_sym_static] = ACTIONS(87),
    [anon_sym_get] = ACTIONS(87),
    [anon_sym_set] = ACTIONS(87),
  },
  [12] = {
    [sym_export_statement] = STATE(7),
    [sym_declaration] = STATE(7),
    [sym_import] = STATE(539),
    [sym_import_statement] = STATE(7),
    [sym_expression_statement] = STATE(7),
    [sym_variable_declaration] = STATE(275),
    [sym_lexical_declaration] = STATE(275),
    [sym_statement_block] = STATE(7),
    [sym_if_statement] = STATE(7),
    [sym_switch_statement] = STATE(7),
    [sym_for_statement] = STATE(7),
    [sym_for_in_statement] = STATE(7),
    [sym_while_statement] = STATE(7),
    [sym_do_statement] = STATE(7),
    [sym_try_statement] = STATE(7),
    [sym_with_statement] = STATE(7),
    [sym_break_statement] = STATE(7),
    [sym_continue_statement] = STATE(7),
    [sym_debugger_statement] = STATE(7),
    [sym_return_statement] = STATE(7),
    [sym_throw_statement] = STATE(7),
    [sym_empty_statement] = STATE(7),
    [sym_labeled_statement] = STATE(7),
    [sym_parenthesized_expression] = STATE(362),
    [sym_expression] = STATE(522),
    [sym_primary_expression] = STATE(546),
    [sym_yield_expression] = STATE(550),
    [sym_object] = STATE(539),
    [sym_object_pattern] = STATE(1320),
    [sym_array] = STATE(539),
    [sym_array_pattern] = STATE(1320),
    [sym_jsx_element] = STATE(550),
    [sym_jsx_fragment] = STATE(550),
    [sym_jsx_opening_element] = STATE(772),
    [sym_jsx_self_closing_element] = STATE(550),
    [sym_class] = STATE(539),
    [sym_class_declaration] = STATE(275),
    [sym_function] = STATE(539),
    [sym_function_declaration] = STATE(275),
    [sym_generator_function] = STATE(539),
    [sym_generator_function_declaration] = STATE(275),
    [sym_arrow_function] = STATE(539),
    [sym_call_expression] = STATE(539),
    [sym_new_expression] = STATE(550),
    [sym_await_expression] = STATE(550),
    [sym_member_expression] = STATE(362),
    [sym_subscript_expression] = STATE(362),
    [sym_assignment_expression] = STATE(550),
    [sym__augmented_assignment_lhs] = STATE(720),
    [sym_augmented_assignment_expression] = STATE(550),
    [sym__destructuring_pattern] = STATE(1320),
    [sym_ternary_expression] = STATE(550),
    [sym_binary_expression] = STATE(550),
    [sym_unary_expression] = STATE(550),
    [sym_update_expression] = STATE(550),
    [sym_sequence_expression] = STATE(1156),
    [sym_string] = STATE(539),
    [sym_template_string] = STATE(539),
    [sym_regex] = STATE(539),
    [sym_meta_property] = STATE(539),
    [sym_decorator] = STATE(750),
    [sym_formal_parameters] = STATE(1318),
    [aux_sym_program_repeat1] = STATE(7),
    [aux_sym_export_statement_repeat1] = STATE(891),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_RBRACE] = ACTIONS(277),
    [anon_sym_import] = ACTIONS(15),
    [anon_sym_var] = ACTIONS(17),
    [anon_sym_let] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(19),
    [anon_sym_if] = ACTIONS(21),
    [anon_sym_switch] = ACTIONS(23),
    [anon_sym_for] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(29),
    [anon_sym_while] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(33),
    [anon_sym_try] = ACTIONS(35),
    [anon_sym_with] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_debugger] = ACTIONS(43),
    [anon_sym_return] = ACTIONS(45),
    [anon_sym_throw] = ACTIONS(47),
    [anon_sym_SEMI] = ACTIONS(49),
    [anon_sym_yield] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(53),
    [anon_sym_LT] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(59),
    [anon_sym_async] = ACTIONS(61),
    [anon_sym_function] = ACTIONS(63),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_typeof] = ACTIONS(71),
    [anon_sym_void] = ACTIONS(71),
    [anon_sym_delete] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DQUOTE] = ACTIONS(75),
    [anon_sym_SQUOTE] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(79),
    [sym_number] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(83),
    [sym_true] = ACTIONS(83),
    [sym_false] = ACTIONS(83),
    [sym_null] = ACTIONS(83),
    [sym_undefined] = ACTIONS(83),
    [anon_sym_AT] = ACTIONS(85),
    [anon_sym_static] = ACTIONS(87),
    [anon_sym_get] = ACTIONS(87),
    [anon_sym_set] = ACTIONS(87),
  },
  [13] = {
    [sym_export_statement] = STATE(20),
    [sym_declaration] = STATE(20),
    [sym_import] = STATE(539),
    [sym_import_statement] = STATE(20),
    [sym_expression_statement] = STATE(20),
    [sym_variable_declaration] = STATE(275),
    [sym_lexical_declaration] = STATE(275),
    [sym_statement_block] = STATE(20),
    [sym_if_statement] = STATE(20),
    [sym_switch_statement] = STATE(20),
    [sym_for_statement] = STATE(20),
    [sym_for_in_statement] = STATE(20),
    [sym_while_statement] = STATE(20),
    [sym_do_statement] = STATE(20),
    [sym_try_statement] = STATE(20),
    [sym_with_statement] = STATE(20),
    [sym_break_statement] = STATE(20),
    [sym_continue_statement] = STATE(20),
    [sym_debugger_statement] = STATE(20),
    [sym_return_statement] = STATE(20),
    [sym_throw_statement] = STATE(20),
    [sym_empty_statement] = STATE(20),
    [sym_labeled_statement] = STATE(20),
    [sym_parenthesized_expression] = STATE(362),
    [sym_expression] = STATE(522),
    [sym_primary_expression] = STATE(546),
    [sym_yield_expression] = STATE(550),
    [sym_object] = STATE(539),
    [sym_object_pattern] = STATE(1320),
    [sym_array] = STATE(539),
    [sym_array_pattern] = STATE(1320),
    [sym_jsx_element] = STATE(550),
    [sym_jsx_fragment] = STATE(550),
    [sym_jsx_opening_element] = STATE(772),
    [sym_jsx_self_closing_element] = STATE(550),
    [sym_class] = STATE(539),
    [sym_class_declaration] = STATE(275),
    [sym_function] = STATE(539),
    [sym_function_declaration] = STATE(275),
    [sym_generator_function] = STATE(539),
    [sym_generator_function_declaration] = STATE(275),
    [sym_arrow_function] = STATE(539),
    [sym_call_expression] = STATE(539),
    [sym_new_expression] = STATE(550),
    [sym_await_expression] = STATE(550),
    [sym_member_expression] = STATE(362),
    [sym_subscript_expression] = STATE(362),
    [sym_assignment_expression] = STATE(550),
    [sym__augmented_assignment_lhs] = STATE(720),
    [sym_augmented_assignment_expression] = STATE(550),
    [sym__destructuring_pattern] = STATE(1320),
    [sym_ternary_expression] = STATE(550),
    [sym_binary_expression] = STATE(550),
    [sym_unary_expression] = STATE(550),
    [sym_update_expression] = STATE(550),
    [sym_sequence_expression] = STATE(1156),
    [sym_string] = STATE(539),
    [sym_template_string] = STATE(539),
    [sym_regex] = STATE(539),
    [sym_meta_property] = STATE(539),
    [sym_decorator] = STATE(750),
    [sym_formal_parameters] = STATE(1318),
    [aux_sym_program_repeat1] = STATE(20),
    [aux_sym_export_statement_repeat1] = STATE(891),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_RBRACE] = ACTIONS(279),
    [anon_sym_import] = ACTIONS(15),
    [anon_sym_var] = ACTIONS(17),
    [anon_sym_let] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(19),
    [anon_sym_if] = ACTIONS(21),
    [anon_sym_switch] = ACTIONS(23),
    [anon_sym_for] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(29),
    [anon_sym_while] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(33),
    [anon_sym_try] = ACTIONS(35),
    [anon_sym_with] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_debugger] = ACTIONS(43),
    [anon_sym_return] = ACTIONS(45),
    [anon_sym_throw] = ACTIONS(47),
    [anon_sym_SEMI] = ACTIONS(49),
    [anon_sym_yield] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(53),
    [anon_sym_LT] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(59),
    [anon_sym_async] = ACTIONS(61),
    [anon_sym_function] = ACTIONS(63),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_typeof] = ACTIONS(71),
    [anon_sym_void] = ACTIONS(71),
    [anon_sym_delete] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DQUOTE] = ACTIONS(75),
    [anon_sym_SQUOTE] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(79),
    [sym_number] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(83),
    [sym_true] = ACTIONS(83),
    [sym_false] = ACTIONS(83),
    [sym_null] = ACTIONS(83),
    [sym_undefined] = ACTIONS(83),
    [anon_sym_AT] = ACTIONS(85),
    [anon_sym_static] = ACTIONS(87),
    [anon_sym_get] = ACTIONS(87),
    [anon_sym_set] = ACTIONS(87),
  },
  [14] = {
    [sym_export_statement] = STATE(16),
    [sym_declaration] = STATE(16),
    [sym_import] = STATE(539),
    [sym_import_statement] = STATE(16),
    [sym_expression_statement] = STATE(16),
    [sym_variable_declaration] = STATE(275),
    [sym_lexical_declaration] = STATE(275),
    [sym_statement_block] = STATE(16),
    [sym_if_statement] = STATE(16),
    [sym_switch_statement] = STATE(16),
    [sym_for_statement] = STATE(16),
    [sym_for_in_statement] = STATE(16),
    [sym_while_statement] = STATE(16),
    [sym_do_statement] = STATE(16),
    [sym_try_statement] = STATE(16),
    [sym_with_statement] = STATE(16),
    [sym_break_statement] = STATE(16),
    [sym_continue_statement] = STATE(16),
    [sym_debugger_statement] = STATE(16),
    [sym_return_statement] = STATE(16),
    [sym_throw_statement] = STATE(16),
    [sym_empty_statement] = STATE(16),
    [sym_labeled_statement] = STATE(16),
    [sym_parenthesized_expression] = STATE(362),
    [sym_expression] = STATE(522),
    [sym_primary_expression] = STATE(546),
    [sym_yield_expression] = STATE(550),
    [sym_object] = STATE(539),
    [sym_object_pattern] = STATE(1320),
    [sym_array] = STATE(539),
    [sym_array_pattern] = STATE(1320),
    [sym_jsx_element] = STATE(550),
    [sym_jsx_fragment] = STATE(550),
    [sym_jsx_opening_element] = STATE(772),
    [sym_jsx_self_closing_element] = STATE(550),
    [sym_class] = STATE(539),
    [sym_class_declaration] = STATE(275),
    [sym_function] = STATE(539),
    [sym_function_declaration] = STATE(275),
    [sym_generator_function] = STATE(539),
    [sym_generator_function_declaration] = STATE(275),
    [sym_arrow_function] = STATE(539),
    [sym_call_expression] = STATE(539),
    [sym_new_expression] = STATE(550),
    [sym_await_expression] = STATE(550),
    [sym_member_expression] = STATE(362),
    [sym_subscript_expression] = STATE(362),
    [sym_assignment_expression] = STATE(550),
    [sym__augmented_assignment_lhs] = STATE(720),
    [sym_augmented_assignment_expression] = STATE(550),
    [sym__destructuring_pattern] = STATE(1320),
    [sym_ternary_expression] = STATE(550),
    [sym_binary_expression] = STATE(550),
    [sym_unary_expression] = STATE(550),
    [sym_update_expression] = STATE(550),
    [sym_sequence_expression] = STATE(1156),
    [sym_string] = STATE(539),
    [sym_template_string] = STATE(539),
    [sym_regex] = STATE(539),
    [sym_meta_property] = STATE(539),
    [sym_decorator] = STATE(750),
    [sym_formal_parameters] = STATE(1318),
    [aux_sym_program_repeat1] = STATE(16),
    [aux_sym_export_statement_repeat1] = STATE(891),
    [ts_builtin_sym_end] = ACTIONS(281),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_import] = ACTIONS(15),
    [anon_sym_var] = ACTIONS(17),
    [anon_sym_let] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(19),
    [anon_sym_if] = ACTIONS(21),
    [anon_sym_switch] = ACTIONS(23),
    [anon_sym_for] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(29),
    [anon_sym_while] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(33),
    [anon_sym_try] = ACTIONS(35),
    [anon_sym_with] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_debugger] = ACTIONS(43),
    [anon_sym_return] = ACTIONS(45),
    [anon_sym_throw] = ACTIONS(47),
    [anon_sym_SEMI] = ACTIONS(49),
    [anon_sym_yield] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(53),
    [anon_sym_LT] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(59),
    [anon_sym_async] = ACTIONS(61),
    [anon_sym_function] = ACTIONS(63),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_typeof] = ACTIONS(71),
    [anon_sym_void] = ACTIONS(71),
    [anon_sym_delete] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DQUOTE] = ACTIONS(75),
    [anon_sym_SQUOTE] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(79),
    [sym_number] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(83),
    [sym_true] = ACTIONS(83),
    [sym_false] = ACTIONS(83),
    [sym_null] = ACTIONS(83),
    [sym_undefined] = ACTIONS(83),
    [anon_sym_AT] = ACTIONS(85),
    [anon_sym_static] = ACTIONS(87),
    [anon_sym_get] = ACTIONS(87),
    [anon_sym_set] = ACTIONS(87),
  },
  [15] = {
    [sym_export_statement] = STATE(7),
    [sym_declaration] = STATE(7),
    [sym_import] = STATE(539),
    [sym_import_statement] = STATE(7),
    [sym_expression_statement] = STATE(7),
    [sym_variable_declaration] = STATE(275),
    [sym_lexical_declaration] = STATE(275),
    [sym_statement_block] = STATE(7),
    [sym_if_statement] = STATE(7),
    [sym_switch_statement] = STATE(7),
    [sym_for_statement] = STATE(7),
    [sym_for_in_statement] = STATE(7),
    [sym_while_statement] = STATE(7),
    [sym_do_statement] = STATE(7),
    [sym_try_statement] = STATE(7),
    [sym_with_statement] = STATE(7),
    [sym_break_statement] = STATE(7),
    [sym_continue_statement] = STATE(7),
    [sym_debugger_statement] = STATE(7),
    [sym_return_statement] = STATE(7),
    [sym_throw_statement] = STATE(7),
    [sym_empty_statement] = STATE(7),
    [sym_labeled_statement] = STATE(7),
    [sym_parenthesized_expression] = STATE(362),
    [sym_expression] = STATE(522),
    [sym_primary_expression] = STATE(546),
    [sym_yield_expression] = STATE(550),
    [sym_object] = STATE(539),
    [sym_object_pattern] = STATE(1320),
    [sym_array] = STATE(539),
    [sym_array_pattern] = STATE(1320),
    [sym_jsx_element] = STATE(550),
    [sym_jsx_fragment] = STATE(550),
    [sym_jsx_opening_element] = STATE(772),
    [sym_jsx_self_closing_element] = STATE(550),
    [sym_class] = STATE(539),
    [sym_class_declaration] = STATE(275),
    [sym_function] = STATE(539),
    [sym_function_declaration] = STATE(275),
    [sym_generator_function] = STATE(539),
    [sym_generator_function_declaration] = STATE(275),
    [sym_arrow_function] = STATE(539),
    [sym_call_expression] = STATE(539),
    [sym_new_expression] = STATE(550),
    [sym_await_expression] = STATE(550),
    [sym_member_expression] = STATE(362),
    [sym_subscript_expression] = STATE(362),
    [sym_assignment_expression] = STATE(550),
    [sym__augmented_assignment_lhs] = STATE(720),
    [sym_augmented_assignment_expression] = STATE(550),
    [sym__destructuring_pattern] = STATE(1320),
    [sym_ternary_expression] = STATE(550),
    [sym_binary_expression] = STATE(550),
    [sym_unary_expression] = STATE(550),
    [sym_update_expression] = STATE(550),
    [sym_sequence_expression] = STATE(1156),
    [sym_string] = STATE(539),
    [sym_template_string] = STATE(539),
    [sym_regex] = STATE(539),
    [sym_meta_property] = STATE(539),
    [sym_decorator] = STATE(750),
    [sym_formal_parameters] = STATE(1318),
    [aux_sym_program_repeat1] = STATE(7),
    [aux_sym_export_statement_repeat1] = STATE(891),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_RBRACE] = ACTIONS(283),
    [anon_sym_import] = ACTIONS(15),
    [anon_sym_var] = ACTIONS(17),
    [anon_sym_let] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(19),
    [anon_sym_if] = ACTIONS(21),
    [anon_sym_switch] = ACTIONS(23),
    [anon_sym_for] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(29),
    [anon_sym_while] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(33),
    [anon_sym_try] = ACTIONS(35),
    [anon_sym_with] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_debugger] = ACTIONS(43),
    [anon_sym_return] = ACTIONS(45),
    [anon_sym_throw] = ACTIONS(47),
    [anon_sym_SEMI] = ACTIONS(49),
    [anon_sym_yield] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(53),
    [anon_sym_LT] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(59),
    [anon_sym_async] = ACTIONS(61),
    [anon_sym_function] = ACTIONS(63),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_typeof] = ACTIONS(71),
    [anon_sym_void] = ACTIONS(71),
    [anon_sym_delete] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DQUOTE] = ACTIONS(75),
    [anon_sym_SQUOTE] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(79),
    [sym_number] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(83),
    [sym_true] = ACTIONS(83),
    [sym_false] = ACTIONS(83),
    [sym_null] = ACTIONS(83),
    [sym_undefined] = ACTIONS(83),
    [anon_sym_AT] = ACTIONS(85),
    [anon_sym_static] = ACTIONS(87),
    [anon_sym_get] = ACTIONS(87),
    [anon_sym_set] = ACTIONS(87),
  },
  [16] = {
    [sym_export_statement] = STATE(7),
    [sym_declaration] = STATE(7),
    [sym_import] = STATE(539),
    [sym_import_statement] = STATE(7),
    [sym_expression_statement] = STATE(7),
    [sym_variable_declaration] = STATE(275),
    [sym_lexical_declaration] = STATE(275),
    [sym_statement_block] = STATE(7),
    [sym_if_statement] = STATE(7),
    [sym_switch_statement] = STATE(7),
    [sym_for_statement] = STATE(7),
    [sym_for_in_statement] = STATE(7),
    [sym_while_statement] = STATE(7),
    [sym_do_statement] = STATE(7),
    [sym_try_statement] = STATE(7),
    [sym_with_statement] = STATE(7),
    [sym_break_statement] = STATE(7),
    [sym_continue_statement] = STATE(7),
    [sym_debugger_statement] = STATE(7),
    [sym_return_statement] = STATE(7),
    [sym_throw_statement] = STATE(7),
    [sym_empty_statement] = STATE(7),
    [sym_labeled_statement] = STATE(7),
    [sym_parenthesized_expression] = STATE(362),
    [sym_expression] = STATE(522),
    [sym_primary_expression] = STATE(546),
    [sym_yield_expression] = STATE(550),
    [sym_object] = STATE(539),
    [sym_object_pattern] = STATE(1320),
    [sym_array] = STATE(539),
    [sym_array_pattern] = STATE(1320),
    [sym_jsx_element] = STATE(550),
    [sym_jsx_fragment] = STATE(550),
    [sym_jsx_opening_element] = STATE(772),
    [sym_jsx_self_closing_element] = STATE(550),
    [sym_class] = STATE(539),
    [sym_class_declaration] = STATE(275),
    [sym_function] = STATE(539),
    [sym_function_declaration] = STATE(275),
    [sym_generator_function] = STATE(539),
    [sym_generator_function_declaration] = STATE(275),
    [sym_arrow_function] = STATE(539),
    [sym_call_expression] = STATE(539),
    [sym_new_expression] = STATE(550),
    [sym_await_expression] = STATE(550),
    [sym_member_expression] = STATE(362),
    [sym_subscript_expression] = STATE(362),
    [sym_assignment_expression] = STATE(550),
    [sym__augmented_assignment_lhs] = STATE(720),
    [sym_augmented_assignment_expression] = STATE(550),
    [sym__destructuring_pattern] = STATE(1320),
    [sym_ternary_expression] = STATE(550),
    [sym_binary_expression] = STATE(550),
    [sym_unary_expression] = STATE(550),
    [sym_update_expression] = STATE(550),
    [sym_sequence_expression] = STATE(1156),
    [sym_string] = STATE(539),
    [sym_template_string] = STATE(539),
    [sym_regex] = STATE(539),
    [sym_meta_property] = STATE(539),
    [sym_decorator] = STATE(750),
    [sym_formal_parameters] = STATE(1318),
    [aux_sym_program_repeat1] = STATE(7),
    [aux_sym_export_statement_repeat1] = STATE(891),
    [ts_builtin_sym_end] = ACTIONS(285),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_import] = ACTIONS(15),
    [anon_sym_var] = ACTIONS(17),
    [anon_sym_let] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(19),
    [anon_sym_if] = ACTIONS(21),
    [anon_sym_switch] = ACTIONS(23),
    [anon_sym_for] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(29),
    [anon_sym_while] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(33),
    [anon_sym_try] = ACTIONS(35),
    [anon_sym_with] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_debugger] = ACTIONS(43),
    [anon_sym_return] = ACTIONS(45),
    [anon_sym_throw] = ACTIONS(47),
    [anon_sym_SEMI] = ACTIONS(49),
    [anon_sym_yield] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(53),
    [anon_sym_LT] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(59),
    [anon_sym_async] = ACTIONS(61),
    [anon_sym_function] = ACTIONS(63),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_typeof] = ACTIONS(71),
    [anon_sym_void] = ACTIONS(71),
    [anon_sym_delete] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DQUOTE] = ACTIONS(75),
    [anon_sym_SQUOTE] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(79),
    [sym_number] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(83),
    [sym_true] = ACTIONS(83),
    [sym_false] = ACTIONS(83),
    [sym_null] = ACTIONS(83),
    [sym_undefined] = ACTIONS(83),
    [anon_sym_AT] = ACTIONS(85),
    [anon_sym_static] = ACTIONS(87),
    [anon_sym_get] = ACTIONS(87),
    [anon_sym_set] = ACTIONS(87),
  },
  [17] = {
    [sym_export_statement] = STATE(7),
    [sym_declaration] = STATE(7),
    [sym_import] = STATE(539),
    [sym_import_statement] = STATE(7),
    [sym_expression_statement] = STATE(7),
    [sym_variable_declaration] = STATE(275),
    [sym_lexical_declaration] = STATE(275),
    [sym_statement_block] = STATE(7),
    [sym_if_statement] = STATE(7),
    [sym_switch_statement] = STATE(7),
    [sym_for_statement] = STATE(7),
    [sym_for_in_statement] = STATE(7),
    [sym_while_statement] = STATE(7),
    [sym_do_statement] = STATE(7),
    [sym_try_statement] = STATE(7),
    [sym_with_statement] = STATE(7),
    [sym_break_statement] = STATE(7),
    [sym_continue_statement] = STATE(7),
    [sym_debugger_statement] = STATE(7),
    [sym_return_statement] = STATE(7),
    [sym_throw_statement] = STATE(7),
    [sym_empty_statement] = STATE(7),
    [sym_labeled_statement] = STATE(7),
    [sym_parenthesized_expression] = STATE(362),
    [sym_expression] = STATE(522),
    [sym_primary_expression] = STATE(546),
    [sym_yield_expression] = STATE(550),
    [sym_object] = STATE(539),
    [sym_object_pattern] = STATE(1320),
    [sym_array] = STATE(539),
    [sym_array_pattern] = STATE(1320),
    [sym_jsx_element] = STATE(550),
    [sym_jsx_fragment] = STATE(550),
    [sym_jsx_opening_element] = STATE(772),
    [sym_jsx_self_closing_element] = STATE(550),
    [sym_class] = STATE(539),
    [sym_class_declaration] = STATE(275),
    [sym_function] = STATE(539),
    [sym_function_declaration] = STATE(275),
    [sym_generator_function] = STATE(539),
    [sym_generator_function_declaration] = STATE(275),
    [sym_arrow_function] = STATE(539),
    [sym_call_expression] = STATE(539),
    [sym_new_expression] = STATE(550),
    [sym_await_expression] = STATE(550),
    [sym_member_expression] = STATE(362),
    [sym_subscript_expression] = STATE(362),
    [sym_assignment_expression] = STATE(550),
    [sym__augmented_assignment_lhs] = STATE(720),
    [sym_augmented_assignment_expression] = STATE(550),
    [sym__destructuring_pattern] = STATE(1320),
    [sym_ternary_expression] = STATE(550),
    [sym_binary_expression] = STATE(550),
    [sym_unary_expression] = STATE(550),
    [sym_update_expression] = STATE(550),
    [sym_sequence_expression] = STATE(1156),
    [sym_string] = STATE(539),
    [sym_template_string] = STATE(539),
    [sym_regex] = STATE(539),
    [sym_meta_property] = STATE(539),
    [sym_decorator] = STATE(750),
    [sym_formal_parameters] = STATE(1318),
    [aux_sym_program_repeat1] = STATE(7),
    [aux_sym_export_statement_repeat1] = STATE(891),
    [ts_builtin_sym_end] = ACTIONS(281),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_import] = ACTIONS(15),
    [anon_sym_var] = ACTIONS(17),
    [anon_sym_let] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(19),
    [anon_sym_if] = ACTIONS(21),
    [anon_sym_switch] = ACTIONS(23),
    [anon_sym_for] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(29),
    [anon_sym_while] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(33),
    [anon_sym_try] = ACTIONS(35),
    [anon_sym_with] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_debugger] = ACTIONS(43),
    [anon_sym_return] = ACTIONS(45),
    [anon_sym_throw] = ACTIONS(47),
    [anon_sym_SEMI] = ACTIONS(49),
    [anon_sym_yield] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(53),
    [anon_sym_LT] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(59),
    [anon_sym_async] = ACTIONS(61),
    [anon_sym_function] = ACTIONS(63),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_typeof] = ACTIONS(71),
    [anon_sym_void] = ACTIONS(71),
    [anon_sym_delete] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DQUOTE] = ACTIONS(75),
    [anon_sym_SQUOTE] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(79),
    [sym_number] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(83),
    [sym_true] = ACTIONS(83),
    [sym_false] = ACTIONS(83),
    [sym_null] = ACTIONS(83),
    [sym_undefined] = ACTIONS(83),
    [anon_sym_AT] = ACTIONS(85),
    [anon_sym_static] = ACTIONS(87),
    [anon_sym_get] = ACTIONS(87),
    [anon_sym_set] = ACTIONS(87),
  },
  [18] = {
    [sym_export_statement] = STATE(7),
    [sym_declaration] = STATE(7),
    [sym_import] = STATE(539),
    [sym_import_statement] = STATE(7),
    [sym_expression_statement] = STATE(7),
    [sym_variable_declaration] = STATE(275),
    [sym_lexical_declaration] = STATE(275),
    [sym_statement_block] = STATE(7),
    [sym_if_statement] = STATE(7),
    [sym_switch_statement] = STATE(7),
    [sym_for_statement] = STATE(7),
    [sym_for_in_statement] = STATE(7),
    [sym_while_statement] = STATE(7),
    [sym_do_statement] = STATE(7),
    [sym_try_statement] = STATE(7),
    [sym_with_statement] = STATE(7),
    [sym_break_statement] = STATE(7),
    [sym_continue_statement] = STATE(7),
    [sym_debugger_statement] = STATE(7),
    [sym_return_statement] = STATE(7),
    [sym_throw_statement] = STATE(7),
    [sym_empty_statement] = STATE(7),
    [sym_labeled_statement] = STATE(7),
    [sym_parenthesized_expression] = STATE(362),
    [sym_expression] = STATE(522),
    [sym_primary_expression] = STATE(546),
    [sym_yield_expression] = STATE(550),
    [sym_object] = STATE(539),
    [sym_object_pattern] = STATE(1320),
    [sym_array] = STATE(539),
    [sym_array_pattern] = STATE(1320),
    [sym_jsx_element] = STATE(550),
    [sym_jsx_fragment] = STATE(550),
    [sym_jsx_opening_element] = STATE(772),
    [sym_jsx_self_closing_element] = STATE(550),
    [sym_class] = STATE(539),
    [sym_class_declaration] = STATE(275),
    [sym_function] = STATE(539),
    [sym_function_declaration] = STATE(275),
    [sym_generator_function] = STATE(539),
    [sym_generator_function_declaration] = STATE(275),
    [sym_arrow_function] = STATE(539),
    [sym_call_expression] = STATE(539),
    [sym_new_expression] = STATE(550),
    [sym_await_expression] = STATE(550),
    [sym_member_expression] = STATE(362),
    [sym_subscript_expression] = STATE(362),
    [sym_assignment_expression] = STATE(550),
    [sym__augmented_assignment_lhs] = STATE(720),
    [sym_augmented_assignment_expression] = STATE(550),
    [sym__destructuring_pattern] = STATE(1320),
    [sym_ternary_expression] = STATE(550),
    [sym_binary_expression] = STATE(550),
    [sym_unary_expression] = STATE(550),
    [sym_update_expression] = STATE(550),
    [sym_sequence_expression] = STATE(1156),
    [sym_string] = STATE(539),
    [sym_template_string] = STATE(539),
    [sym_regex] = STATE(539),
    [sym_meta_property] = STATE(539),
    [sym_decorator] = STATE(750),
    [sym_formal_parameters] = STATE(1318),
    [aux_sym_program_repeat1] = STATE(7),
    [aux_sym_export_statement_repeat1] = STATE(891),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_RBRACE] = ACTIONS(287),
    [anon_sym_import] = ACTIONS(15),
    [anon_sym_var] = ACTIONS(17),
    [anon_sym_let] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(19),
    [anon_sym_if] = ACTIONS(21),
    [anon_sym_switch] = ACTIONS(23),
    [anon_sym_for] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(29),
    [anon_sym_while] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(33),
    [anon_sym_try] = ACTIONS(35),
    [anon_sym_with] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_debugger] = ACTIONS(43),
    [anon_sym_return] = ACTIONS(45),
    [anon_sym_throw] = ACTIONS(47),
    [anon_sym_SEMI] = ACTIONS(49),
    [anon_sym_yield] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(53),
    [anon_sym_LT] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(59),
    [anon_sym_async] = ACTIONS(61),
    [anon_sym_function] = ACTIONS(63),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_typeof] = ACTIONS(71),
    [anon_sym_void] = ACTIONS(71),
    [anon_sym_delete] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DQUOTE] = ACTIONS(75),
    [anon_sym_SQUOTE] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(79),
    [sym_number] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(83),
    [sym_true] = ACTIONS(83),
    [sym_false] = ACTIONS(83),
    [sym_null] = ACTIONS(83),
    [sym_undefined] = ACTIONS(83),
    [anon_sym_AT] = ACTIONS(85),
    [anon_sym_static] = ACTIONS(87),
    [anon_sym_get] = ACTIONS(87),
    [anon_sym_set] = ACTIONS(87),
  },
  [19] = {
    [sym_export_statement] = STATE(24),
    [sym_declaration] = STATE(24),
    [sym_import] = STATE(539),
    [sym_import_statement] = STATE(24),
    [sym_expression_statement] = STATE(24),
    [sym_variable_declaration] = STATE(275),
    [sym_lexical_declaration] = STATE(275),
    [sym_statement_block] = STATE(24),
    [sym_if_statement] = STATE(24),
    [sym_switch_statement] = STATE(24),
    [sym_for_statement] = STATE(24),
    [sym_for_in_statement] = STATE(24),
    [sym_while_statement] = STATE(24),
    [sym_do_statement] = STATE(24),
    [sym_try_statement] = STATE(24),
    [sym_with_statement] = STATE(24),
    [sym_break_statement] = STATE(24),
    [sym_continue_statement] = STATE(24),
    [sym_debugger_statement] = STATE(24),
    [sym_return_statement] = STATE(24),
    [sym_throw_statement] = STATE(24),
    [sym_empty_statement] = STATE(24),
    [sym_labeled_statement] = STATE(24),
    [sym_parenthesized_expression] = STATE(362),
    [sym_expression] = STATE(522),
    [sym_primary_expression] = STATE(546),
    [sym_yield_expression] = STATE(550),
    [sym_object] = STATE(539),
    [sym_object_pattern] = STATE(1320),
    [sym_array] = STATE(539),
    [sym_array_pattern] = STATE(1320),
    [sym_jsx_element] = STATE(550),
    [sym_jsx_fragment] = STATE(550),
    [sym_jsx_opening_element] = STATE(772),
    [sym_jsx_self_closing_element] = STATE(550),
    [sym_class] = STATE(539),
    [sym_class_declaration] = STATE(275),
    [sym_function] = STATE(539),
    [sym_function_declaration] = STATE(275),
    [sym_generator_function] = STATE(539),
    [sym_generator_function_declaration] = STATE(275),
    [sym_arrow_function] = STATE(539),
    [sym_call_expression] = STATE(539),
    [sym_new_expression] = STATE(550),
    [sym_await_expression] = STATE(550),
    [sym_member_expression] = STATE(362),
    [sym_subscript_expression] = STATE(362),
    [sym_assignment_expression] = STATE(550),
    [sym__augmented_assignment_lhs] = STATE(720),
    [sym_augmented_assignment_expression] = STATE(550),
    [sym__destructuring_pattern] = STATE(1320),
    [sym_ternary_expression] = STATE(550),
    [sym_binary_expression] = STATE(550),
    [sym_unary_expression] = STATE(550),
    [sym_update_expression] = STATE(550),
    [sym_sequence_expression] = STATE(1156),
    [sym_string] = STATE(539),
    [sym_template_string] = STATE(539),
    [sym_regex] = STATE(539),
    [sym_meta_property] = STATE(539),
    [sym_decorator] = STATE(750),
    [sym_formal_parameters] = STATE(1318),
    [aux_sym_program_repeat1] = STATE(24),
    [aux_sym_export_statement_repeat1] = STATE(891),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_RBRACE] = ACTIONS(289),
    [anon_sym_import] = ACTIONS(15),
    [anon_sym_var] = ACTIONS(17),
    [anon_sym_let] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(19),
    [anon_sym_if] = ACTIONS(21),
    [anon_sym_switch] = ACTIONS(23),
    [anon_sym_for] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(29),
    [anon_sym_while] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(33),
    [anon_sym_try] = ACTIONS(35),
    [anon_sym_with] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_debugger] = ACTIONS(43),
    [anon_sym_return] = ACTIONS(45),
    [anon_sym_throw] = ACTIONS(47),
    [anon_sym_SEMI] = ACTIONS(49),
    [anon_sym_yield] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(53),
    [anon_sym_LT] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(59),
    [anon_sym_async] = ACTIONS(61),
    [anon_sym_function] = ACTIONS(63),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_typeof] = ACTIONS(71),
    [anon_sym_void] = ACTIONS(71),
    [anon_sym_delete] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DQUOTE] = ACTIONS(75),
    [anon_sym_SQUOTE] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(79),
    [sym_number] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(83),
    [sym_true] = ACTIONS(83),
    [sym_false] = ACTIONS(83),
    [sym_null] = ACTIONS(83),
    [sym_undefined] = ACTIONS(83),
    [anon_sym_AT] = ACTIONS(85),
    [anon_sym_static] = ACTIONS(87),
    [anon_sym_get] = ACTIONS(87),
    [anon_sym_set] = ACTIONS(87),
  },
  [20] = {
    [sym_export_statement] = STATE(7),
    [sym_declaration] = STATE(7),
    [sym_import] = STATE(539),
    [sym_import_statement] = STATE(7),
    [sym_expression_statement] = STATE(7),
    [sym_variable_declaration] = STATE(275),
    [sym_lexical_declaration] = STATE(275),
    [sym_statement_block] = STATE(7),
    [sym_if_statement] = STATE(7),
    [sym_switch_statement] = STATE(7),
    [sym_for_statement] = STATE(7),
    [sym_for_in_statement] = STATE(7),
    [sym_while_statement] = STATE(7),
    [sym_do_statement] = STATE(7),
    [sym_try_statement] = STATE(7),
    [sym_with_statement] = STATE(7),
    [sym_break_statement] = STATE(7),
    [sym_continue_statement] = STATE(7),
    [sym_debugger_statement] = STATE(7),
    [sym_return_statement] = STATE(7),
    [sym_throw_statement] = STATE(7),
    [sym_empty_statement] = STATE(7),
    [sym_labeled_statement] = STATE(7),
    [sym_parenthesized_expression] = STATE(362),
    [sym_expression] = STATE(522),
    [sym_primary_expression] = STATE(546),
    [sym_yield_expression] = STATE(550),
    [sym_object] = STATE(539),
    [sym_object_pattern] = STATE(1320),
    [sym_array] = STATE(539),
    [sym_array_pattern] = STATE(1320),
    [sym_jsx_element] = STATE(550),
    [sym_jsx_fragment] = STATE(550),
    [sym_jsx_opening_element] = STATE(772),
    [sym_jsx_self_closing_element] = STATE(550),
    [sym_class] = STATE(539),
    [sym_class_declaration] = STATE(275),
    [sym_function] = STATE(539),
    [sym_function_declaration] = STATE(275),
    [sym_generator_function] = STATE(539),
    [sym_generator_function_declaration] = STATE(275),
    [sym_arrow_function] = STATE(539),
    [sym_call_expression] = STATE(539),
    [sym_new_expression] = STATE(550),
    [sym_await_expression] = STATE(550),
    [sym_member_expression] = STATE(362),
    [sym_subscript_expression] = STATE(362),
    [sym_assignment_expression] = STATE(550),
    [sym__augmented_assignment_lhs] = STATE(720),
    [sym_augmented_assignment_expression] = STATE(550),
    [sym__destructuring_pattern] = STATE(1320),
    [sym_ternary_expression] = STATE(550),
    [sym_binary_expression] = STATE(550),
    [sym_unary_expression] = STATE(550),
    [sym_update_expression] = STATE(550),
    [sym_sequence_expression] = STATE(1156),
    [sym_string] = STATE(539),
    [sym_template_string] = STATE(539),
    [sym_regex] = STATE(539),
    [sym_meta_property] = STATE(539),
    [sym_decorator] = STATE(750),
    [sym_formal_parameters] = STATE(1318),
    [aux_sym_program_repeat1] = STATE(7),
    [aux_sym_export_statement_repeat1] = STATE(891),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_RBRACE] = ACTIONS(291),
    [anon_sym_import] = ACTIONS(15),
    [anon_sym_var] = ACTIONS(17),
    [anon_sym_let] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(19),
    [anon_sym_if] = ACTIONS(21),
    [anon_sym_switch] = ACTIONS(23),
    [anon_sym_for] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(29),
    [anon_sym_while] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(33),
    [anon_sym_try] = ACTIONS(35),
    [anon_sym_with] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_debugger] = ACTIONS(43),
    [anon_sym_return] = ACTIONS(45),
    [anon_sym_throw] = ACTIONS(47),
    [anon_sym_SEMI] = ACTIONS(49),
    [anon_sym_yield] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(53),
    [anon_sym_LT] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(59),
    [anon_sym_async] = ACTIONS(61),
    [anon_sym_function] = ACTIONS(63),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_typeof] = ACTIONS(71),
    [anon_sym_void] = ACTIONS(71),
    [anon_sym_delete] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DQUOTE] = ACTIONS(75),
    [anon_sym_SQUOTE] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(79),
    [sym_number] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(83),
    [sym_true] = ACTIONS(83),
    [sym_false] = ACTIONS(83),
    [sym_null] = ACTIONS(83),
    [sym_undefined] = ACTIONS(83),
    [anon_sym_AT] = ACTIONS(85),
    [anon_sym_static] = ACTIONS(87),
    [anon_sym_get] = ACTIONS(87),
    [anon_sym_set] = ACTIONS(87),
  },
  [21] = {
    [sym_export_statement] = STATE(18),
    [sym_declaration] = STATE(18),
    [sym_import] = STATE(539),
    [sym_import_statement] = STATE(18),
    [sym_expression_statement] = STATE(18),
    [sym_variable_declaration] = STATE(275),
    [sym_lexical_declaration] = STATE(275),
    [sym_statement_block] = STATE(18),
    [sym_if_statement] = STATE(18),
    [sym_switch_statement] = STATE(18),
    [sym_for_statement] = STATE(18),
    [sym_for_in_statement] = STATE(18),
    [sym_while_statement] = STATE(18),
    [sym_do_statement] = STATE(18),
    [sym_try_statement] = STATE(18),
    [sym_with_statement] = STATE(18),
    [sym_break_statement] = STATE(18),
    [sym_continue_statement] = STATE(18),
    [sym_debugger_statement] = STATE(18),
    [sym_return_statement] = STATE(18),
    [sym_throw_statement] = STATE(18),
    [sym_empty_statement] = STATE(18),
    [sym_labeled_statement] = STATE(18),
    [sym_parenthesized_expression] = STATE(362),
    [sym_expression] = STATE(522),
    [sym_primary_expression] = STATE(546),
    [sym_yield_expression] = STATE(550),
    [sym_object] = STATE(539),
    [sym_object_pattern] = STATE(1320),
    [sym_array] = STATE(539),
    [sym_array_pattern] = STATE(1320),
    [sym_jsx_element] = STATE(550),
    [sym_jsx_fragment] = STATE(550),
    [sym_jsx_opening_element] = STATE(772),
    [sym_jsx_self_closing_element] = STATE(550),
    [sym_class] = STATE(539),
    [sym_class_declaration] = STATE(275),
    [sym_function] = STATE(539),
    [sym_function_declaration] = STATE(275),
    [sym_generator_function] = STATE(539),
    [sym_generator_function_declaration] = STATE(275),
    [sym_arrow_function] = STATE(539),
    [sym_call_expression] = STATE(539),
    [sym_new_expression] = STATE(550),
    [sym_await_expression] = STATE(550),
    [sym_member_expression] = STATE(362),
    [sym_subscript_expression] = STATE(362),
    [sym_assignment_expression] = STATE(550),
    [sym__augmented_assignment_lhs] = STATE(720),
    [sym_augmented_assignment_expression] = STATE(550),
    [sym__destructuring_pattern] = STATE(1320),
    [sym_ternary_expression] = STATE(550),
    [sym_binary_expression] = STATE(550),
    [sym_unary_expression] = STATE(550),
    [sym_update_expression] = STATE(550),
    [sym_sequence_expression] = STATE(1156),
    [sym_string] = STATE(539),
    [sym_template_string] = STATE(539),
    [sym_regex] = STATE(539),
    [sym_meta_property] = STATE(539),
    [sym_decorator] = STATE(750),
    [sym_formal_parameters] = STATE(1318),
    [aux_sym_program_repeat1] = STATE(18),
    [aux_sym_export_statement_repeat1] = STATE(891),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_RBRACE] = ACTIONS(293),
    [anon_sym_import] = ACTIONS(15),
    [anon_sym_var] = ACTIONS(17),
    [anon_sym_let] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(19),
    [anon_sym_if] = ACTIONS(21),
    [anon_sym_switch] = ACTIONS(23),
    [anon_sym_for] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(29),
    [anon_sym_while] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(33),
    [anon_sym_try] = ACTIONS(35),
    [anon_sym_with] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_debugger] = ACTIONS(43),
    [anon_sym_return] = ACTIONS(45),
    [anon_sym_throw] = ACTIONS(47),
    [anon_sym_SEMI] = ACTIONS(49),
    [anon_sym_yield] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(53),
    [anon_sym_LT] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(59),
    [anon_sym_async] = ACTIONS(61),
    [anon_sym_function] = ACTIONS(63),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_typeof] = ACTIONS(71),
    [anon_sym_void] = ACTIONS(71),
    [anon_sym_delete] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DQUOTE] = ACTIONS(75),
    [anon_sym_SQUOTE] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(79),
    [sym_number] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(83),
    [sym_true] = ACTIONS(83),
    [sym_false] = ACTIONS(83),
    [sym_null] = ACTIONS(83),
    [sym_undefined] = ACTIONS(83),
    [anon_sym_AT] = ACTIONS(85),
    [anon_sym_static] = ACTIONS(87),
    [anon_sym_get] = ACTIONS(87),
    [anon_sym_set] = ACTIONS(87),
  },
  [22] = {
    [sym_export_statement] = STATE(15),
    [sym_declaration] = STATE(15),
    [sym_import] = STATE(539),
    [sym_import_statement] = STATE(15),
    [sym_expression_statement] = STATE(15),
    [sym_variable_declaration] = STATE(275),
    [sym_lexical_declaration] = STATE(275),
    [sym_statement_block] = STATE(15),
    [sym_if_statement] = STATE(15),
    [sym_switch_statement] = STATE(15),
    [sym_for_statement] = STATE(15),
    [sym_for_in_statement] = STATE(15),
    [sym_while_statement] = STATE(15),
    [sym_do_statement] = STATE(15),
    [sym_try_statement] = STATE(15),
    [sym_with_statement] = STATE(15),
    [sym_break_statement] = STATE(15),
    [sym_continue_statement] = STATE(15),
    [sym_debugger_statement] = STATE(15),
    [sym_return_statement] = STATE(15),
    [sym_throw_statement] = STATE(15),
    [sym_empty_statement] = STATE(15),
    [sym_labeled_statement] = STATE(15),
    [sym_parenthesized_expression] = STATE(362),
    [sym_expression] = STATE(522),
    [sym_primary_expression] = STATE(546),
    [sym_yield_expression] = STATE(550),
    [sym_object] = STATE(539),
    [sym_object_pattern] = STATE(1320),
    [sym_array] = STATE(539),
    [sym_array_pattern] = STATE(1320),
    [sym_jsx_element] = STATE(550),
    [sym_jsx_fragment] = STATE(550),
    [sym_jsx_opening_element] = STATE(772),
    [sym_jsx_self_closing_element] = STATE(550),
    [sym_class] = STATE(539),
    [sym_class_declaration] = STATE(275),
    [sym_function] = STATE(539),
    [sym_function_declaration] = STATE(275),
    [sym_generator_function] = STATE(539),
    [sym_generator_function_declaration] = STATE(275),
    [sym_arrow_function] = STATE(539),
    [sym_call_expression] = STATE(539),
    [sym_new_expression] = STATE(550),
    [sym_await_expression] = STATE(550),
    [sym_member_expression] = STATE(362),
    [sym_subscript_expression] = STATE(362),
    [sym_assignment_expression] = STATE(550),
    [sym__augmented_assignment_lhs] = STATE(720),
    [sym_augmented_assignment_expression] = STATE(550),
    [sym__destructuring_pattern] = STATE(1320),
    [sym_ternary_expression] = STATE(550),
    [sym_binary_expression] = STATE(550),
    [sym_unary_expression] = STATE(550),
    [sym_update_expression] = STATE(550),
    [sym_sequence_expression] = STATE(1156),
    [sym_string] = STATE(539),
    [sym_template_string] = STATE(539),
    [sym_regex] = STATE(539),
    [sym_meta_property] = STATE(539),
    [sym_decorator] = STATE(750),
    [sym_formal_parameters] = STATE(1318),
    [aux_sym_program_repeat1] = STATE(15),
    [aux_sym_export_statement_repeat1] = STATE(891),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_RBRACE] = ACTIONS(289),
    [anon_sym_import] = ACTIONS(15),
    [anon_sym_var] = ACTIONS(17),
    [anon_sym_let] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(19),
    [anon_sym_if] = ACTIONS(21),
    [anon_sym_switch] = ACTIONS(23),
    [anon_sym_for] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(29),
    [anon_sym_while] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(33),
    [anon_sym_try] = ACTIONS(35),
    [anon_sym_with] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_debugger] = ACTIONS(43),
    [anon_sym_return] = ACTIONS(45),
    [anon_sym_throw] = ACTIONS(47),
    [anon_sym_SEMI] = ACTIONS(49),
    [anon_sym_yield] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(53),
    [anon_sym_LT] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(59),
    [anon_sym_async] = ACTIONS(61),
    [anon_sym_function] = ACTIONS(63),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_typeof] = ACTIONS(71),
    [anon_sym_void] = ACTIONS(71),
    [anon_sym_delete] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DQUOTE] = ACTIONS(75),
    [anon_sym_SQUOTE] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(79),
    [sym_number] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(83),
    [sym_true] = ACTIONS(83),
    [sym_false] = ACTIONS(83),
    [sym_null] = ACTIONS(83),
    [sym_undefined] = ACTIONS(83),
    [anon_sym_AT] = ACTIONS(85),
    [anon_sym_static] = ACTIONS(87),
    [anon_sym_get] = ACTIONS(87),
    [anon_sym_set] = ACTIONS(87),
  },
  [23] = {
    [sym_export_statement] = STATE(12),
    [sym_declaration] = STATE(12),
    [sym_import] = STATE(539),
    [sym_import_statement] = STATE(12),
    [sym_expression_statement] = STATE(12),
    [sym_variable_declaration] = STATE(275),
    [sym_lexical_declaration] = STATE(275),
    [sym_statement_block] = STATE(12),
    [sym_if_statement] = STATE(12),
    [sym_switch_statement] = STATE(12),
    [sym_for_statement] = STATE(12),
    [sym_for_in_statement] = STATE(12),
    [sym_while_statement] = STATE(12),
    [sym_do_statement] = STATE(12),
    [sym_try_statement] = STATE(12),
    [sym_with_statement] = STATE(12),
    [sym_break_statement] = STATE(12),
    [sym_continue_statement] = STATE(12),
    [sym_debugger_statement] = STATE(12),
    [sym_return_statement] = STATE(12),
    [sym_throw_statement] = STATE(12),
    [sym_empty_statement] = STATE(12),
    [sym_labeled_statement] = STATE(12),
    [sym_parenthesized_expression] = STATE(362),
    [sym_expression] = STATE(522),
    [sym_primary_expression] = STATE(546),
    [sym_yield_expression] = STATE(550),
    [sym_object] = STATE(539),
    [sym_object_pattern] = STATE(1320),
    [sym_array] = STATE(539),
    [sym_array_pattern] = STATE(1320),
    [sym_jsx_element] = STATE(550),
    [sym_jsx_fragment] = STATE(550),
    [sym_jsx_opening_element] = STATE(772),
    [sym_jsx_self_closing_element] = STATE(550),
    [sym_class] = STATE(539),
    [sym_class_declaration] = STATE(275),
    [sym_function] = STATE(539),
    [sym_function_declaration] = STATE(275),
    [sym_generator_function] = STATE(539),
    [sym_generator_function_declaration] = STATE(275),
    [sym_arrow_function] = STATE(539),
    [sym_call_expression] = STATE(539),
    [sym_new_expression] = STATE(550),
    [sym_await_expression] = STATE(550),
    [sym_member_expression] = STATE(362),
    [sym_subscript_expression] = STATE(362),
    [sym_assignment_expression] = STATE(550),
    [sym__augmented_assignment_lhs] = STATE(720),
    [sym_augmented_assignment_expression] = STATE(550),
    [sym__destructuring_pattern] = STATE(1320),
    [sym_ternary_expression] = STATE(550),
    [sym_binary_expression] = STATE(550),
    [sym_unary_expression] = STATE(550),
    [sym_update_expression] = STATE(550),
    [sym_sequence_expression] = STATE(1156),
    [sym_string] = STATE(539),
    [sym_template_string] = STATE(539),
    [sym_regex] = STATE(539),
    [sym_meta_property] = STATE(539),
    [sym_decorator] = STATE(750),
    [sym_formal_parameters] = STATE(1318),
    [aux_sym_program_repeat1] = STATE(12),
    [aux_sym_export_statement_repeat1] = STATE(891),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_RBRACE] = ACTIONS(295),
    [anon_sym_import] = ACTIONS(15),
    [anon_sym_var] = ACTIONS(17),
    [anon_sym_let] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(19),
    [anon_sym_if] = ACTIONS(21),
    [anon_sym_switch] = ACTIONS(23),
    [anon_sym_for] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(29),
    [anon_sym_while] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(33),
    [anon_sym_try] = ACTIONS(35),
    [anon_sym_with] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_debugger] = ACTIONS(43),
    [anon_sym_return] = ACTIONS(45),
    [anon_sym_throw] = ACTIONS(47),
    [anon_sym_SEMI] = ACTIONS(49),
    [anon_sym_yield] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(53),
    [anon_sym_LT] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(59),
    [anon_sym_async] = ACTIONS(61),
    [anon_sym_function] = ACTIONS(63),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_typeof] = ACTIONS(71),
    [anon_sym_void] = ACTIONS(71),
    [anon_sym_delete] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DQUOTE] = ACTIONS(75),
    [anon_sym_SQUOTE] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(79),
    [sym_number] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(83),
    [sym_true] = ACTIONS(83),
    [sym_false] = ACTIONS(83),
    [sym_null] = ACTIONS(83),
    [sym_undefined] = ACTIONS(83),
    [anon_sym_AT] = ACTIONS(85),
    [anon_sym_static] = ACTIONS(87),
    [anon_sym_get] = ACTIONS(87),
    [anon_sym_set] = ACTIONS(87),
  },
  [24] = {
    [sym_export_statement] = STATE(7),
    [sym_declaration] = STATE(7),
    [sym_import] = STATE(539),
    [sym_import_statement] = STATE(7),
    [sym_expression_statement] = STATE(7),
    [sym_variable_declaration] = STATE(275),
    [sym_lexical_declaration] = STATE(275),
    [sym_statement_block] = STATE(7),
    [sym_if_statement] = STATE(7),
    [sym_switch_statement] = STATE(7),
    [sym_for_statement] = STATE(7),
    [sym_for_in_statement] = STATE(7),
    [sym_while_statement] = STATE(7),
    [sym_do_statement] = STATE(7),
    [sym_try_statement] = STATE(7),
    [sym_with_statement] = STATE(7),
    [sym_break_statement] = STATE(7),
    [sym_continue_statement] = STATE(7),
    [sym_debugger_statement] = STATE(7),
    [sym_return_statement] = STATE(7),
    [sym_throw_statement] = STATE(7),
    [sym_empty_statement] = STATE(7),
    [sym_labeled_statement] = STATE(7),
    [sym_parenthesized_expression] = STATE(362),
    [sym_expression] = STATE(522),
    [sym_primary_expression] = STATE(546),
    [sym_yield_expression] = STATE(550),
    [sym_object] = STATE(539),
    [sym_object_pattern] = STATE(1320),
    [sym_array] = STATE(539),
    [sym_array_pattern] = STATE(1320),
    [sym_jsx_element] = STATE(550),
    [sym_jsx_fragment] = STATE(550),
    [sym_jsx_opening_element] = STATE(772),
    [sym_jsx_self_closing_element] = STATE(550),
    [sym_class] = STATE(539),
    [sym_class_declaration] = STATE(275),
    [sym_function] = STATE(539),
    [sym_function_declaration] = STATE(275),
    [sym_generator_function] = STATE(539),
    [sym_generator_function_declaration] = STATE(275),
    [sym_arrow_function] = STATE(539),
    [sym_call_expression] = STATE(539),
    [sym_new_expression] = STATE(550),
    [sym_await_expression] = STATE(550),
    [sym_member_expression] = STATE(362),
    [sym_subscript_expression] = STATE(362),
    [sym_assignment_expression] = STATE(550),
    [sym__augmented_assignment_lhs] = STATE(720),
    [sym_augmented_assignment_expression] = STATE(550),
    [sym__destructuring_pattern] = STATE(1320),
    [sym_ternary_expression] = STATE(550),
    [sym_binary_expression] = STATE(550),
    [sym_unary_expression] = STATE(550),
    [sym_update_expression] = STATE(550),
    [sym_sequence_expression] = STATE(1156),
    [sym_string] = STATE(539),
    [sym_template_string] = STATE(539),
    [sym_regex] = STATE(539),
    [sym_meta_property] = STATE(539),
    [sym_decorator] = STATE(750),
    [sym_formal_parameters] = STATE(1318),
    [aux_sym_program_repeat1] = STATE(7),
    [aux_sym_export_statement_repeat1] = STATE(891),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_RBRACE] = ACTIONS(297),
    [anon_sym_import] = ACTIONS(15),
    [anon_sym_var] = ACTIONS(17),
    [anon_sym_let] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(19),
    [anon_sym_if] = ACTIONS(21),
    [anon_sym_switch] = ACTIONS(23),
    [anon_sym_for] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(29),
    [anon_sym_while] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(33),
    [anon_sym_try] = ACTIONS(35),
    [anon_sym_with] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_debugger] = ACTIONS(43),
    [anon_sym_return] = ACTIONS(45),
    [anon_sym_throw] = ACTIONS(47),
    [anon_sym_SEMI] = ACTIONS(49),
    [anon_sym_yield] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(53),
    [anon_sym_LT] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(59),
    [anon_sym_async] = ACTIONS(61),
    [anon_sym_function] = ACTIONS(63),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_typeof] = ACTIONS(71),
    [anon_sym_void] = ACTIONS(71),
    [anon_sym_delete] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DQUOTE] = ACTIONS(75),
    [anon_sym_SQUOTE] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(79),
    [sym_number] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(83),
    [sym_true] = ACTIONS(83),
    [sym_false] = ACTIONS(83),
    [sym_null] = ACTIONS(83),
    [sym_undefined] = ACTIONS(83),
    [anon_sym_AT] = ACTIONS(85),
    [anon_sym_static] = ACTIONS(87),
    [anon_sym_get] = ACTIONS(87),
    [anon_sym_set] = ACTIONS(87),
  },
  [25] = {
    [sym_export_statement] = STATE(247),
    [sym_declaration] = STATE(246),
    [sym_import] = STATE(539),
    [sym_import_statement] = STATE(274),
    [sym_expression_statement] = STATE(281),
    [sym_variable_declaration] = STATE(275),
    [sym_lexical_declaration] = STATE(275),
    [sym_statement_block] = STATE(255),
    [sym_if_statement] = STATE(306),
    [sym_switch_statement] = STATE(261),
    [sym_for_statement] = STATE(252),
    [sym_for_in_statement] = STATE(297),
    [sym_while_statement] = STATE(296),
    [sym_do_statement] = STATE(254),
    [sym_try_statement] = STATE(256),
    [sym_with_statement] = STATE(258),
    [sym_break_statement] = STATE(260),
    [sym_continue_statement] = STATE(262),
    [sym_debugger_statement] = STATE(263),
    [sym_return_statement] = STATE(264),
    [sym_throw_statement] = STATE(266),
    [sym_empty_statement] = STATE(267),
    [sym_labeled_statement] = STATE(268),
    [sym_parenthesized_expression] = STATE(362),
    [sym_expression] = STATE(522),
    [sym_primary_expression] = STATE(546),
    [sym_yield_expression] = STATE(550),
    [sym_object] = STATE(539),
    [sym_object_pattern] = STATE(1320),
    [sym_array] = STATE(539),
    [sym_array_pattern] = STATE(1320),
    [sym_jsx_element] = STATE(550),
    [sym_jsx_fragment] = STATE(550),
    [sym_jsx_opening_element] = STATE(772),
    [sym_jsx_self_closing_element] = STATE(550),
    [sym_class] = STATE(539),
    [sym_class_declaration] = STATE(275),
    [sym_function] = STATE(539),
    [sym_function_declaration] = STATE(275),
    [sym_generator_function] = STATE(539),
    [sym_generator_function_declaration] = STATE(275),
    [sym_arrow_function] = STATE(539),
    [sym_call_expression] = STATE(539),
    [sym_new_expression] = STATE(550),
    [sym_await_expression] = STATE(550),
    [sym_member_expression] = STATE(362),
    [sym_subscript_expression] = STATE(362),
    [sym_assignment_expression] = STATE(550),
    [sym__augmented_assignment_lhs] = STATE(720),
    [sym_augmented_assignment_expression] = STATE(550),
    [sym__destructuring_pattern] = STATE(1320),
    [sym_ternary_expression] = STATE(550),
    [sym_binary_expression] = STATE(550),
    [sym_unary_expression] = STATE(550),
    [sym_update_expression] = STATE(550),
    [sym_sequence_expression] = STATE(1156),
    [sym_string] = STATE(539),
    [sym_template_string] = STATE(539),
    [sym_regex] = STATE(539),
    [sym_meta_property] = STATE(539),
    [sym_decorator] = STATE(750),
    [sym_formal_parameters] = STATE(1318),
    [aux_sym_export_statement_repeat1] = STATE(882),
    [sym_identifier] = ACTIONS(299),
    [anon_sym_export] = ACTIONS(301),
    [anon_sym_LBRACE] = ACTIONS(303),
    [anon_sym_import] = ACTIONS(15),
    [anon_sym_var] = ACTIONS(17),
    [anon_sym_let] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(19),
    [anon_sym_if] = ACTIONS(305),
    [anon_sym_switch] = ACTIONS(23),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(29),
    [anon_sym_while] = ACTIONS(309),
    [anon_sym_do] = ACTIONS(33),
    [anon_sym_try] = ACTIONS(35),
    [anon_sym_with] = ACTIONS(311),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_debugger] = ACTIONS(43),
    [anon_sym_return] = ACTIONS(45),
    [anon_sym_throw] = ACTIONS(47),
    [anon_sym_SEMI] = ACTIONS(49),
    [anon_sym_yield] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(53),
    [anon_sym_LT] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(313),
    [anon_sym_async] = ACTIONS(315),
    [anon_sym_function] = ACTIONS(317),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_typeof] = ACTIONS(71),
    [anon_sym_void] = ACTIONS(71),
    [anon_sym_delete] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DQUOTE] = ACTIONS(75),
    [anon_sym_SQUOTE] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(79),
    [sym_number] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(83),
    [sym_true] = ACTIONS(83),
    [sym_false] = ACTIONS(83),
    [sym_null] = ACTIONS(83),
    [sym_undefined] = ACTIONS(83),
    [anon_sym_AT] = ACTIONS(85),
    [anon_sym_static] = ACTIONS(319),
    [anon_sym_get] = ACTIONS(319),
    [anon_sym_set] = ACTIONS(319),
  },
  [26] = {
    [sym_export_statement] = STATE(247),
    [sym_declaration] = STATE(246),
    [sym_import] = STATE(539),
    [sym_import_statement] = STATE(274),
    [sym_expression_statement] = STATE(281),
    [sym_variable_declaration] = STATE(275),
    [sym_lexical_declaration] = STATE(275),
    [sym_statement_block] = STATE(255),
    [sym_if_statement] = STATE(306),
    [sym_switch_statement] = STATE(261),
    [sym_for_statement] = STATE(252),
    [sym_for_in_statement] = STATE(297),
    [sym_while_statement] = STATE(296),
    [sym_do_statement] = STATE(254),
    [sym_try_statement] = STATE(256),
    [sym_with_statement] = STATE(258),
    [sym_break_statement] = STATE(260),
    [sym_continue_statement] = STATE(262),
    [sym_debugger_statement] = STATE(263),
    [sym_return_statement] = STATE(264),
    [sym_throw_statement] = STATE(266),
    [sym_empty_statement] = STATE(267),
    [sym_labeled_statement] = STATE(268),
    [sym_parenthesized_expression] = STATE(362),
    [sym_expression] = STATE(522),
    [sym_primary_expression] = STATE(546),
    [sym_yield_expression] = STATE(550),
    [sym_object] = STATE(539),
    [sym_object_pattern] = STATE(1320),
    [sym_array] = STATE(539),
    [sym_array_pattern] = STATE(1320),
    [sym_jsx_element] = STATE(550),
    [sym_jsx_fragment] = STATE(550),
    [sym_jsx_opening_element] = STATE(772),
    [sym_jsx_self_closing_element] = STATE(550),
    [sym_class] = STATE(539),
    [sym_class_declaration] = STATE(275),
    [sym_function] = STATE(539),
    [sym_function_declaration] = STATE(275),
    [sym_generator_function] = STATE(539),
    [sym_generator_function_declaration] = STATE(275),
    [sym_arrow_function] = STATE(539),
    [sym_call_expression] = STATE(539),
    [sym_new_expression] = STATE(550),
    [sym_await_expression] = STATE(550),
    [sym_member_expression] = STATE(362),
    [sym_subscript_expression] = STATE(362),
    [sym_assignment_expression] = STATE(550),
    [sym__augmented_assignment_lhs] = STATE(720),
    [sym_augmented_assignment_expression] = STATE(550),
    [sym__destructuring_pattern] = STATE(1320),
    [sym_ternary_expression] = STATE(550),
    [sym_binary_expression] = STATE(550),
    [sym_unary_expression] = STATE(550),
    [sym_update_expression] = STATE(550),
    [sym_sequence_expression] = STATE(1156),
    [sym_string] = STATE(539),
    [sym_template_string] = STATE(539),
    [sym_regex] = STATE(539),
    [sym_meta_property] = STATE(539),
    [sym_decorator] = STATE(750),
    [sym_formal_parameters] = STATE(1318),
    [aux_sym_export_statement_repeat1] = STATE(891),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_import] = ACTIONS(15),
    [anon_sym_var] = ACTIONS(17),
    [anon_sym_let] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(19),
    [anon_sym_if] = ACTIONS(21),
    [anon_sym_switch] = ACTIONS(23),
    [anon_sym_for] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(29),
    [anon_sym_while] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(33),
    [anon_sym_try] = ACTIONS(35),
    [anon_sym_with] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_debugger] = ACTIONS(43),
    [anon_sym_return] = ACTIONS(45),
    [anon_sym_throw] = ACTIONS(47),
    [anon_sym_SEMI] = ACTIONS(49),
    [anon_sym_yield] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(53),
    [anon_sym_LT] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(59),
    [anon_sym_async] = ACTIONS(61),
    [anon_sym_function] = ACTIONS(63),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_typeof] = ACTIONS(71),
    [anon_sym_void] = ACTIONS(71),
    [anon_sym_delete] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DQUOTE] = ACTIONS(75),
    [anon_sym_SQUOTE] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(79),
    [sym_number] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(83),
    [sym_true] = ACTIONS(83),
    [sym_false] = ACTIONS(83),
    [sym_null] = ACTIONS(83),
    [sym_undefined] = ACTIONS(83),
    [anon_sym_AT] = ACTIONS(85),
    [anon_sym_static] = ACTIONS(87),
    [anon_sym_get] = ACTIONS(87),
    [anon_sym_set] = ACTIONS(87),
  },
  [27] = {
    [sym_export_statement] = STATE(282),
    [sym_declaration] = STATE(282),
    [sym_import] = STATE(539),
    [sym_import_statement] = STATE(282),
    [sym_expression_statement] = STATE(282),
    [sym_variable_declaration] = STATE(275),
    [sym_lexical_declaration] = STATE(275),
    [sym_statement_block] = STATE(282),
    [sym_if_statement] = STATE(282),
    [sym_switch_statement] = STATE(282),
    [sym_for_statement] = STATE(282),
    [sym_for_in_statement] = STATE(282),
    [sym_while_statement] = STATE(282),
    [sym_do_statement] = STATE(282),
    [sym_try_statement] = STATE(282),
    [sym_with_statement] = STATE(282),
    [sym_break_statement] = STATE(282),
    [sym_continue_statement] = STATE(282),
    [sym_debugger_statement] = STATE(282),
    [sym_return_statement] = STATE(282),
    [sym_throw_statement] = STATE(282),
    [sym_empty_statement] = STATE(282),
    [sym_labeled_statement] = STATE(282),
    [sym_parenthesized_expression] = STATE(362),
    [sym_expression] = STATE(522),
    [sym_primary_expression] = STATE(546),
    [sym_yield_expression] = STATE(550),
    [sym_object] = STATE(539),
    [sym_object_pattern] = STATE(1320),
    [sym_array] = STATE(539),
    [sym_array_pattern] = STATE(1320),
    [sym_jsx_element] = STATE(550),
    [sym_jsx_fragment] = STATE(550),
    [sym_jsx_opening_element] = STATE(772),
    [sym_jsx_self_closing_element] = STATE(550),
    [sym_class] = STATE(539),
    [sym_class_declaration] = STATE(275),
    [sym_function] = STATE(539),
    [sym_function_declaration] = STATE(275),
    [sym_generator_function] = STATE(539),
    [sym_generator_function_declaration] = STATE(275),
    [sym_arrow_function] = STATE(539),
    [sym_call_expression] = STATE(539),
    [sym_new_expression] = STATE(550),
    [sym_await_expression] = STATE(550),
    [sym_member_expression] = STATE(362),
    [sym_subscript_expression] = STATE(362),
    [sym_assignment_expression] = STATE(550),
    [sym__augmented_assignment_lhs] = STATE(720),
    [sym_augmented_assignment_expression] = STATE(550),
    [sym__destructuring_pattern] = STATE(1320),
    [sym_ternary_expression] = STATE(550),
    [sym_binary_expression] = STATE(550),
    [sym_unary_expression] = STATE(550),
    [sym_update_expression] = STATE(550),
    [sym_sequence_expression] = STATE(1156),
    [sym_string] = STATE(539),
    [sym_template_string] = STATE(539),
    [sym_regex] = STATE(539),
    [sym_meta_property] = STATE(539),
    [sym_decorator] = STATE(750),
    [sym_formal_parameters] = STATE(1318),
    [aux_sym_export_statement_repeat1] = STATE(891),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_import] = ACTIONS(15),
    [anon_sym_var] = ACTIONS(17),
    [anon_sym_let] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(19),
    [anon_sym_if] = ACTIONS(21),
    [anon_sym_switch] = ACTIONS(23),
    [anon_sym_for] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(29),
    [anon_sym_while] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(33),
    [anon_sym_try] = ACTIONS(35),
    [anon_sym_with] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_debugger] = ACTIONS(43),
    [anon_sym_return] = ACTIONS(45),
    [anon_sym_throw] = ACTIONS(47),
    [anon_sym_SEMI] = ACTIONS(49),
    [anon_sym_yield] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(53),
    [anon_sym_LT] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(59),
    [anon_sym_async] = ACTIONS(61),
    [anon_sym_function] = ACTIONS(63),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_typeof] = ACTIONS(71),
    [anon_sym_void] = ACTIONS(71),
    [anon_sym_delete] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DQUOTE] = ACTIONS(75),
    [anon_sym_SQUOTE] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(79),
    [sym_number] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(83),
    [sym_true] = ACTIONS(83),
    [sym_false] = ACTIONS(83),
    [sym_null] = ACTIONS(83),
    [sym_undefined] = ACTIONS(83),
    [anon_sym_AT] = ACTIONS(85),
    [anon_sym_static] = ACTIONS(87),
    [anon_sym_get] = ACTIONS(87),
    [anon_sym_set] = ACTIONS(87),
  },
  [28] = {
    [sym_export_statement] = STATE(265),
    [sym_declaration] = STATE(265),
    [sym_import] = STATE(539),
    [sym_import_statement] = STATE(265),
    [sym_expression_statement] = STATE(265),
    [sym_variable_declaration] = STATE(275),
    [sym_lexical_declaration] = STATE(275),
    [sym_statement_block] = STATE(265),
    [sym_if_statement] = STATE(265),
    [sym_switch_statement] = STATE(265),
    [sym_for_statement] = STATE(265),
    [sym_for_in_statement] = STATE(265),
    [sym_while_statement] = STATE(265),
    [sym_do_statement] = STATE(265),
    [sym_try_statement] = STATE(265),
    [sym_with_statement] = STATE(265),
    [sym_break_statement] = STATE(265),
    [sym_continue_statement] = STATE(265),
    [sym_debugger_statement] = STATE(265),
    [sym_return_statement] = STATE(265),
    [sym_throw_statement] = STATE(265),
    [sym_empty_statement] = STATE(265),
    [sym_labeled_statement] = STATE(265),
    [sym_parenthesized_expression] = STATE(362),
    [sym_expression] = STATE(522),
    [sym_primary_expression] = STATE(546),
    [sym_yield_expression] = STATE(550),
    [sym_object] = STATE(539),
    [sym_object_pattern] = STATE(1320),
    [sym_array] = STATE(539),
    [sym_array_pattern] = STATE(1320),
    [sym_jsx_element] = STATE(550),
    [sym_jsx_fragment] = STATE(550),
    [sym_jsx_opening_element] = STATE(772),
    [sym_jsx_self_closing_element] = STATE(550),
    [sym_class] = STATE(539),
    [sym_class_declaration] = STATE(275),
    [sym_function] = STATE(539),
    [sym_function_declaration] = STATE(275),
    [sym_generator_function] = STATE(539),
    [sym_generator_function_declaration] = STATE(275),
    [sym_arrow_function] = STATE(539),
    [sym_call_expression] = STATE(539),
    [sym_new_expression] = STATE(550),
    [sym_await_expression] = STATE(550),
    [sym_member_expression] = STATE(362),
    [sym_subscript_expression] = STATE(362),
    [sym_assignment_expression] = STATE(550),
    [sym__augmented_assignment_lhs] = STATE(720),
    [sym_augmented_assignment_expression] = STATE(550),
    [sym__destructuring_pattern] = STATE(1320),
    [sym_ternary_expression] = STATE(550),
    [sym_binary_expression] = STATE(550),
    [sym_unary_expression] = STATE(550),
    [sym_update_expression] = STATE(550),
    [sym_sequence_expression] = STATE(1156),
    [sym_string] = STATE(539),
    [sym_template_string] = STATE(539),
    [sym_regex] = STATE(539),
    [sym_meta_property] = STATE(539),
    [sym_decorator] = STATE(750),
    [sym_formal_parameters] = STATE(1318),
    [aux_sym_export_statement_repeat1] = STATE(891),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_import] = ACTIONS(15),
    [anon_sym_var] = ACTIONS(17),
    [anon_sym_let] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(19),
    [anon_sym_if] = ACTIONS(21),
    [anon_sym_switch] = ACTIONS(23),
    [anon_sym_for] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(29),
    [anon_sym_while] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(33),
    [anon_sym_try] = ACTIONS(35),
    [anon_sym_with] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_debugger] = ACTIONS(43),
    [anon_sym_return] = ACTIONS(45),
    [anon_sym_throw] = ACTIONS(47),
    [anon_sym_SEMI] = ACTIONS(49),
    [anon_sym_yield] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(53),
    [anon_sym_LT] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(59),
    [anon_sym_async] = ACTIONS(61),
    [anon_sym_function] = ACTIONS(63),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_typeof] = ACTIONS(71),
    [anon_sym_void] = ACTIONS(71),
    [anon_sym_delete] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DQUOTE] = ACTIONS(75),
    [anon_sym_SQUOTE] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(79),
    [sym_number] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(83),
    [sym_true] = ACTIONS(83),
    [sym_false] = ACTIONS(83),
    [sym_null] = ACTIONS(83),
    [sym_undefined] = ACTIONS(83),
    [anon_sym_AT] = ACTIONS(85),
    [anon_sym_static] = ACTIONS(87),
    [anon_sym_get] = ACTIONS(87),
    [anon_sym_set] = ACTIONS(87),
  },
  [29] = {
    [sym_export_statement] = STATE(282),
    [sym_declaration] = STATE(282),
    [sym_import] = STATE(539),
    [sym_import_statement] = STATE(282),
    [sym_expression_statement] = STATE(282),
    [sym_variable_declaration] = STATE(275),
    [sym_lexical_declaration] = STATE(275),
    [sym_statement_block] = STATE(282),
    [sym_if_statement] = STATE(282),
    [sym_switch_statement] = STATE(282),
    [sym_for_statement] = STATE(282),
    [sym_for_in_statement] = STATE(282),
    [sym_while_statement] = STATE(282),
    [sym_do_statement] = STATE(282),
    [sym_try_statement] = STATE(282),
    [sym_with_statement] = STATE(282),
    [sym_break_statement] = STATE(282),
    [sym_continue_statement] = STATE(282),
    [sym_debugger_statement] = STATE(282),
    [sym_return_statement] = STATE(282),
    [sym_throw_statement] = STATE(282),
    [sym_empty_statement] = STATE(282),
    [sym_labeled_statement] = STATE(282),
    [sym_parenthesized_expression] = STATE(362),
    [sym_expression] = STATE(522),
    [sym_primary_expression] = STATE(546),
    [sym_yield_expression] = STATE(550),
    [sym_object] = STATE(539),
    [sym_object_pattern] = STATE(1320),
    [sym_array] = STATE(539),
    [sym_array_pattern] = STATE(1320),
    [sym_jsx_element] = STATE(550),
    [sym_jsx_fragment] = STATE(550),
    [sym_jsx_opening_element] = STATE(772),
    [sym_jsx_self_closing_element] = STATE(550),
    [sym_class] = STATE(539),
    [sym_class_declaration] = STATE(275),
    [sym_function] = STATE(539),
    [sym_function_declaration] = STATE(275),
    [sym_generator_function] = STATE(539),
    [sym_generator_function_declaration] = STATE(275),
    [sym_arrow_function] = STATE(539),
    [sym_call_expression] = STATE(539),
    [sym_new_expression] = STATE(550),
    [sym_await_expression] = STATE(550),
    [sym_member_expression] = STATE(362),
    [sym_subscript_expression] = STATE(362),
    [sym_assignment_expression] = STATE(550),
    [sym__augmented_assignment_lhs] = STATE(720),
    [sym_augmented_assignment_expression] = STATE(550),
    [sym__destructuring_pattern] = STATE(1320),
    [sym_ternary_expression] = STATE(550),
    [sym_binary_expression] = STATE(550),
    [sym_unary_expression] = STATE(550),
    [sym_update_expression] = STATE(550),
    [sym_sequence_expression] = STATE(1156),
    [sym_string] = STATE(539),
    [sym_template_string] = STATE(539),
    [sym_regex] = STATE(539),
    [sym_meta_property] = STATE(539),
    [sym_decorator] = STATE(750),
    [sym_formal_parameters] = STATE(1318),
    [aux_sym_export_statement_repeat1] = STATE(882),
    [sym_identifier] = ACTIONS(299),
    [anon_sym_export] = ACTIONS(301),
    [anon_sym_LBRACE] = ACTIONS(303),
    [anon_sym_import] = ACTIONS(15),
    [anon_sym_var] = ACTIONS(17),
    [anon_sym_let] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(19),
    [anon_sym_if] = ACTIONS(305),
    [anon_sym_switch] = ACTIONS(23),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(29),
    [anon_sym_while] = ACTIONS(309),
    [anon_sym_do] = ACTIONS(33),
    [anon_sym_try] = ACTIONS(35),
    [anon_sym_with] = ACTIONS(311),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_debugger] = ACTIONS(43),
    [anon_sym_return] = ACTIONS(45),
    [anon_sym_throw] = ACTIONS(47),
    [anon_sym_SEMI] = ACTIONS(49),
    [anon_sym_yield] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(53),
    [anon_sym_LT] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(313),
    [anon_sym_async] = ACTIONS(315),
    [anon_sym_function] = ACTIONS(317),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_typeof] = ACTIONS(71),
    [anon_sym_void] = ACTIONS(71),
    [anon_sym_delete] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DQUOTE] = ACTIONS(75),
    [anon_sym_SQUOTE] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(79),
    [sym_number] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(83),
    [sym_true] = ACTIONS(83),
    [sym_false] = ACTIONS(83),
    [sym_null] = ACTIONS(83),
    [sym_undefined] = ACTIONS(83),
    [anon_sym_AT] = ACTIONS(85),
    [anon_sym_static] = ACTIONS(319),
    [anon_sym_get] = ACTIONS(319),
    [anon_sym_set] = ACTIONS(319),
  },
  [30] = {
    [sym_export_statement] = STATE(279),
    [sym_declaration] = STATE(279),
    [sym_import] = STATE(539),
    [sym_import_statement] = STATE(279),
    [sym_expression_statement] = STATE(279),
    [sym_variable_declaration] = STATE(275),
    [sym_lexical_declaration] = STATE(275),
    [sym_statement_block] = STATE(279),
    [sym_if_statement] = STATE(279),
    [sym_switch_statement] = STATE(279),
    [sym_for_statement] = STATE(279),
    [sym_for_in_statement] = STATE(279),
    [sym_while_statement] = STATE(279),
    [sym_do_statement] = STATE(279),
    [sym_try_statement] = STATE(279),
    [sym_with_statement] = STATE(279),
    [sym_break_statement] = STATE(279),
    [sym_continue_statement] = STATE(279),
    [sym_debugger_statement] = STATE(279),
    [sym_return_statement] = STATE(279),
    [sym_throw_statement] = STATE(279),
    [sym_empty_statement] = STATE(279),
    [sym_labeled_statement] = STATE(279),
    [sym_parenthesized_expression] = STATE(362),
    [sym_expression] = STATE(522),
    [sym_primary_expression] = STATE(546),
    [sym_yield_expression] = STATE(550),
    [sym_object] = STATE(539),
    [sym_object_pattern] = STATE(1320),
    [sym_array] = STATE(539),
    [sym_array_pattern] = STATE(1320),
    [sym_jsx_element] = STATE(550),
    [sym_jsx_fragment] = STATE(550),
    [sym_jsx_opening_element] = STATE(772),
    [sym_jsx_self_closing_element] = STATE(550),
    [sym_class] = STATE(539),
    [sym_class_declaration] = STATE(275),
    [sym_function] = STATE(539),
    [sym_function_declaration] = STATE(275),
    [sym_generator_function] = STATE(539),
    [sym_generator_function_declaration] = STATE(275),
    [sym_arrow_function] = STATE(539),
    [sym_call_expression] = STATE(539),
    [sym_new_expression] = STATE(550),
    [sym_await_expression] = STATE(550),
    [sym_member_expression] = STATE(362),
    [sym_subscript_expression] = STATE(362),
    [sym_assignment_expression] = STATE(550),
    [sym__augmented_assignment_lhs] = STATE(720),
    [sym_augmented_assignment_expression] = STATE(550),
    [sym__destructuring_pattern] = STATE(1320),
    [sym_ternary_expression] = STATE(550),
    [sym_binary_expression] = STATE(550),
    [sym_unary_expression] = STATE(550),
    [sym_update_expression] = STATE(550),
    [sym_sequence_expression] = STATE(1156),
    [sym_string] = STATE(539),
    [sym_template_string] = STATE(539),
    [sym_regex] = STATE(539),
    [sym_meta_property] = STATE(539),
    [sym_decorator] = STATE(750),
    [sym_formal_parameters] = STATE(1318),
    [aux_sym_export_statement_repeat1] = STATE(891),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_import] = ACTIONS(15),
    [anon_sym_var] = ACTIONS(17),
    [anon_sym_let] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(19),
    [anon_sym_if] = ACTIONS(21),
    [anon_sym_switch] = ACTIONS(23),
    [anon_sym_for] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(29),
    [anon_sym_while] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(33),
    [anon_sym_try] = ACTIONS(35),
    [anon_sym_with] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_debugger] = ACTIONS(43),
    [anon_sym_return] = ACTIONS(45),
    [anon_sym_throw] = ACTIONS(47),
    [anon_sym_SEMI] = ACTIONS(49),
    [anon_sym_yield] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(53),
    [anon_sym_LT] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(59),
    [anon_sym_async] = ACTIONS(61),
    [anon_sym_function] = ACTIONS(63),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_typeof] = ACTIONS(71),
    [anon_sym_void] = ACTIONS(71),
    [anon_sym_delete] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DQUOTE] = ACTIONS(75),
    [anon_sym_SQUOTE] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(79),
    [sym_number] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(83),
    [sym_true] = ACTIONS(83),
    [sym_false] = ACTIONS(83),
    [sym_null] = ACTIONS(83),
    [sym_undefined] = ACTIONS(83),
    [anon_sym_AT] = ACTIONS(85),
    [anon_sym_static] = ACTIONS(87),
    [anon_sym_get] = ACTIONS(87),
    [anon_sym_set] = ACTIONS(87),
  },
  [31] = {
    [sym_export_statement] = STATE(279),
    [sym_declaration] = STATE(279),
    [sym_import] = STATE(539),
    [sym_import_statement] = STATE(279),
    [sym_expression_statement] = STATE(279),
    [sym_variable_declaration] = STATE(275),
    [sym_lexical_declaration] = STATE(275),
    [sym_statement_block] = STATE(279),
    [sym_if_statement] = STATE(279),
    [sym_switch_statement] = STATE(279),
    [sym_for_statement] = STATE(279),
    [sym_for_in_statement] = STATE(279),
    [sym_while_statement] = STATE(279),
    [sym_do_statement] = STATE(279),
    [sym_try_statement] = STATE(279),
    [sym_with_statement] = STATE(279),
    [sym_break_statement] = STATE(279),
    [sym_continue_statement] = STATE(279),
    [sym_debugger_statement] = STATE(279),
    [sym_return_statement] = STATE(279),
    [sym_throw_statement] = STATE(279),
    [sym_empty_statement] = STATE(279),
    [sym_labeled_statement] = STATE(279),
    [sym_parenthesized_expression] = STATE(362),
    [sym_expression] = STATE(522),
    [sym_primary_expression] = STATE(546),
    [sym_yield_expression] = STATE(550),
    [sym_object] = STATE(539),
    [sym_object_pattern] = STATE(1320),
    [sym_array] = STATE(539),
    [sym_array_pattern] = STATE(1320),
    [sym_jsx_element] = STATE(550),
    [sym_jsx_fragment] = STATE(550),
    [sym_jsx_opening_element] = STATE(772),
    [sym_jsx_self_closing_element] = STATE(550),
    [sym_class] = STATE(539),
    [sym_class_declaration] = STATE(275),
    [sym_function] = STATE(539),
    [sym_function_declaration] = STATE(275),
    [sym_generator_function] = STATE(539),
    [sym_generator_function_declaration] = STATE(275),
    [sym_arrow_function] = STATE(539),
    [sym_call_expression] = STATE(539),
    [sym_new_expression] = STATE(550),
    [sym_await_expression] = STATE(550),
    [sym_member_expression] = STATE(362),
    [sym_subscript_expression] = STATE(362),
    [sym_assignment_expression] = STATE(550),
    [sym__augmented_assignment_lhs] = STATE(720),
    [sym_augmented_assignment_expression] = STATE(550),
    [sym__destructuring_pattern] = STATE(1320),
    [sym_ternary_expression] = STATE(550),
    [sym_binary_expression] = STATE(550),
    [sym_unary_expression] = STATE(550),
    [sym_update_expression] = STATE(550),
    [sym_sequence_expression] = STATE(1156),
    [sym_string] = STATE(539),
    [sym_template_string] = STATE(539),
    [sym_regex] = STATE(539),
    [sym_meta_property] = STATE(539),
    [sym_decorator] = STATE(750),
    [sym_formal_parameters] = STATE(1318),
    [aux_sym_export_statement_repeat1] = STATE(882),
    [sym_identifier] = ACTIONS(299),
    [anon_sym_export] = ACTIONS(301),
    [anon_sym_LBRACE] = ACTIONS(303),
    [anon_sym_import] = ACTIONS(15),
    [anon_sym_var] = ACTIONS(17),
    [anon_sym_let] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(19),
    [anon_sym_if] = ACTIONS(305),
    [anon_sym_switch] = ACTIONS(23),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(29),
    [anon_sym_while] = ACTIONS(309),
    [anon_sym_do] = ACTIONS(33),
    [anon_sym_try] = ACTIONS(35),
    [anon_sym_with] = ACTIONS(311),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_debugger] = ACTIONS(43),
    [anon_sym_return] = ACTIONS(45),
    [anon_sym_throw] = ACTIONS(47),
    [anon_sym_SEMI] = ACTIONS(49),
    [anon_sym_yield] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(53),
    [anon_sym_LT] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(313),
    [anon_sym_async] = ACTIONS(315),
    [anon_sym_function] = ACTIONS(317),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_typeof] = ACTIONS(71),
    [anon_sym_void] = ACTIONS(71),
    [anon_sym_delete] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DQUOTE] = ACTIONS(75),
    [anon_sym_SQUOTE] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(79),
    [sym_number] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(83),
    [sym_true] = ACTIONS(83),
    [sym_false] = ACTIONS(83),
    [sym_null] = ACTIONS(83),
    [sym_undefined] = ACTIONS(83),
    [anon_sym_AT] = ACTIONS(85),
    [anon_sym_static] = ACTIONS(319),
    [anon_sym_get] = ACTIONS(319),
    [anon_sym_set] = ACTIONS(319),
  },
  [32] = {
    [sym_export_statement] = STATE(308),
    [sym_declaration] = STATE(308),
    [sym_import] = STATE(539),
    [sym_import_statement] = STATE(308),
    [sym_expression_statement] = STATE(308),
    [sym_variable_declaration] = STATE(275),
    [sym_lexical_declaration] = STATE(275),
    [sym_statement_block] = STATE(308),
    [sym_if_statement] = STATE(308),
    [sym_switch_statement] = STATE(308),
    [sym_for_statement] = STATE(308),
    [sym_for_in_statement] = STATE(308),
    [sym_while_statement] = STATE(308),
    [sym_do_statement] = STATE(308),
    [sym_try_statement] = STATE(308),
    [sym_with_statement] = STATE(308),
    [sym_break_statement] = STATE(308),
    [sym_continue_statement] = STATE(308),
    [sym_debugger_statement] = STATE(308),
    [sym_return_statement] = STATE(308),
    [sym_throw_statement] = STATE(308),
    [sym_empty_statement] = STATE(308),
    [sym_labeled_statement] = STATE(308),
    [sym_parenthesized_expression] = STATE(362),
    [sym_expression] = STATE(522),
    [sym_primary_expression] = STATE(546),
    [sym_yield_expression] = STATE(550),
    [sym_object] = STATE(539),
    [sym_object_pattern] = STATE(1320),
    [sym_array] = STATE(539),
    [sym_array_pattern] = STATE(1320),
    [sym_jsx_element] = STATE(550),
    [sym_jsx_fragment] = STATE(550),
    [sym_jsx_opening_element] = STATE(772),
    [sym_jsx_self_closing_element] = STATE(550),
    [sym_class] = STATE(539),
    [sym_class_declaration] = STATE(275),
    [sym_function] = STATE(539),
    [sym_function_declaration] = STATE(275),
    [sym_generator_function] = STATE(539),
    [sym_generator_function_declaration] = STATE(275),
    [sym_arrow_function] = STATE(539),
    [sym_call_expression] = STATE(539),
    [sym_new_expression] = STATE(550),
    [sym_await_expression] = STATE(550),
    [sym_member_expression] = STATE(362),
    [sym_subscript_expression] = STATE(362),
    [sym_assignment_expression] = STATE(550),
    [sym__augmented_assignment_lhs] = STATE(720),
    [sym_augmented_assignment_expression] = STATE(550),
    [sym__destructuring_pattern] = STATE(1320),
    [sym_ternary_expression] = STATE(550),
    [sym_binary_expression] = STATE(550),
    [sym_unary_expression] = STATE(550),
    [sym_update_expression] = STATE(550),
    [sym_sequence_expression] = STATE(1156),
    [sym_string] = STATE(539),
    [sym_template_string] = STATE(539),
    [sym_regex] = STATE(539),
    [sym_meta_property] = STATE(539),
    [sym_decorator] = STATE(750),
    [sym_formal_parameters] = STATE(1318),
    [aux_sym_export_statement_repeat1] = STATE(882),
    [sym_identifier] = ACTIONS(299),
    [anon_sym_export] = ACTIONS(301),
    [anon_sym_LBRACE] = ACTIONS(303),
    [anon_sym_import] = ACTIONS(15),
    [anon_sym_var] = ACTIONS(17),
    [anon_sym_let] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(19),
    [anon_sym_if] = ACTIONS(305),
    [anon_sym_switch] = ACTIONS(23),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(29),
    [anon_sym_while] = ACTIONS(309),
    [anon_sym_do] = ACTIONS(33),
    [anon_sym_try] = ACTIONS(35),
    [anon_sym_with] = ACTIONS(311),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_debugger] = ACTIONS(43),
    [anon_sym_return] = ACTIONS(45),
    [anon_sym_throw] = ACTIONS(47),
    [anon_sym_SEMI] = ACTIONS(49),
    [anon_sym_yield] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(53),
    [anon_sym_LT] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(313),
    [anon_sym_async] = ACTIONS(315),
    [anon_sym_function] = ACTIONS(317),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_typeof] = ACTIONS(71),
    [anon_sym_void] = ACTIONS(71),
    [anon_sym_delete] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DQUOTE] = ACTIONS(75),
    [anon_sym_SQUOTE] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(79),
    [sym_number] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(83),
    [sym_true] = ACTIONS(83),
    [sym_false] = ACTIONS(83),
    [sym_null] = ACTIONS(83),
    [sym_undefined] = ACTIONS(83),
    [anon_sym_AT] = ACTIONS(85),
    [anon_sym_static] = ACTIONS(319),
    [anon_sym_get] = ACTIONS(319),
    [anon_sym_set] = ACTIONS(319),
  },
  [33] = {
    [sym_export_statement] = STATE(310),
    [sym_declaration] = STATE(311),
    [sym_import] = STATE(539),
    [sym_import_statement] = STATE(312),
    [sym_expression_statement] = STATE(313),
    [sym_variable_declaration] = STATE(275),
    [sym_lexical_declaration] = STATE(275),
    [sym_statement_block] = STATE(314),
    [sym_if_statement] = STATE(315),
    [sym_switch_statement] = STATE(316),
    [sym_for_statement] = STATE(317),
    [sym_for_in_statement] = STATE(318),
    [sym_while_statement] = STATE(319),
    [sym_do_statement] = STATE(320),
    [sym_try_statement] = STATE(321),
    [sym_with_statement] = STATE(322),
    [sym_break_statement] = STATE(323),
    [sym_continue_statement] = STATE(324),
    [sym_debugger_statement] = STATE(325),
    [sym_return_statement] = STATE(326),
    [sym_throw_statement] = STATE(327),
    [sym_empty_statement] = STATE(328),
    [sym_labeled_statement] = STATE(329),
    [sym_parenthesized_expression] = STATE(362),
    [sym_expression] = STATE(522),
    [sym_primary_expression] = STATE(546),
    [sym_yield_expression] = STATE(550),
    [sym_object] = STATE(539),
    [sym_object_pattern] = STATE(1320),
    [sym_array] = STATE(539),
    [sym_array_pattern] = STATE(1320),
    [sym_jsx_element] = STATE(550),
    [sym_jsx_fragment] = STATE(550),
    [sym_jsx_opening_element] = STATE(772),
    [sym_jsx_self_closing_element] = STATE(550),
    [sym_class] = STATE(539),
    [sym_class_declaration] = STATE(275),
    [sym_function] = STATE(539),
    [sym_function_declaration] = STATE(275),
    [sym_generator_function] = STATE(539),
    [sym_generator_function_declaration] = STATE(275),
    [sym_arrow_function] = STATE(539),
    [sym_call_expression] = STATE(539),
    [sym_new_expression] = STATE(550),
    [sym_await_expression] = STATE(550),
    [sym_member_expression] = STATE(362),
    [sym_subscript_expression] = STATE(362),
    [sym_assignment_expression] = STATE(550),
    [sym__augmented_assignment_lhs] = STATE(720),
    [sym_augmented_assignment_expression] = STATE(550),
    [sym__destructuring_pattern] = STATE(1320),
    [sym_ternary_expression] = STATE(550),
    [sym_binary_expression] = STATE(550),
    [sym_unary_expression] = STATE(550),
    [sym_update_expression] = STATE(550),
    [sym_sequence_expression] = STATE(1156),
    [sym_string] = STATE(539),
    [sym_template_string] = STATE(539),
    [sym_regex] = STATE(539),
    [sym_meta_property] = STATE(539),
    [sym_decorator] = STATE(750),
    [sym_formal_parameters] = STATE(1318),
    [aux_sym_export_statement_repeat1] = STATE(891),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_import] = ACTIONS(15),
    [anon_sym_var] = ACTIONS(17),
    [anon_sym_let] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(19),
    [anon_sym_if] = ACTIONS(21),
    [anon_sym_switch] = ACTIONS(23),
    [anon_sym_for] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(29),
    [anon_sym_while] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(33),
    [anon_sym_try] = ACTIONS(35),
    [anon_sym_with] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_debugger] = ACTIONS(43),
    [anon_sym_return] = ACTIONS(45),
    [anon_sym_throw] = ACTIONS(47),
    [anon_sym_SEMI] = ACTIONS(49),
    [anon_sym_yield] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(53),
    [anon_sym_LT] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(59),
    [anon_sym_async] = ACTIONS(61),
    [anon_sym_function] = ACTIONS(63),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_typeof] = ACTIONS(71),
    [anon_sym_void] = ACTIONS(71),
    [anon_sym_delete] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DQUOTE] = ACTIONS(75),
    [anon_sym_SQUOTE] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(79),
    [sym_number] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(83),
    [sym_true] = ACTIONS(83),
    [sym_false] = ACTIONS(83),
    [sym_null] = ACTIONS(83),
    [sym_undefined] = ACTIONS(83),
    [anon_sym_AT] = ACTIONS(85),
    [anon_sym_static] = ACTIONS(87),
    [anon_sym_get] = ACTIONS(87),
    [anon_sym_set] = ACTIONS(87),
  },
  [34] = {
    [sym_export_statement] = STATE(280),
    [sym_declaration] = STATE(280),
    [sym_import] = STATE(539),
    [sym_import_statement] = STATE(280),
    [sym_expression_statement] = STATE(280),
    [sym_variable_declaration] = STATE(275),
    [sym_lexical_declaration] = STATE(275),
    [sym_statement_block] = STATE(280),
    [sym_if_statement] = STATE(280),
    [sym_switch_statement] = STATE(280),
    [sym_for_statement] = STATE(280),
    [sym_for_in_statement] = STATE(280),
    [sym_while_statement] = STATE(280),
    [sym_do_statement] = STATE(280),
    [sym_try_statement] = STATE(280),
    [sym_with_statement] = STATE(280),
    [sym_break_statement] = STATE(280),
    [sym_continue_statement] = STATE(280),
    [sym_debugger_statement] = STATE(280),
    [sym_return_statement] = STATE(280),
    [sym_throw_statement] = STATE(280),
    [sym_empty_statement] = STATE(280),
    [sym_labeled_statement] = STATE(280),
    [sym_parenthesized_expression] = STATE(362),
    [sym_expression] = STATE(522),
    [sym_primary_expression] = STATE(546),
    [sym_yield_expression] = STATE(550),
    [sym_object] = STATE(539),
    [sym_object_pattern] = STATE(1320),
    [sym_array] = STATE(539),
    [sym_array_pattern] = STATE(1320),
    [sym_jsx_element] = STATE(550),
    [sym_jsx_fragment] = STATE(550),
    [sym_jsx_opening_element] = STATE(772),
    [sym_jsx_self_closing_element] = STATE(550),
    [sym_class] = STATE(539),
    [sym_class_declaration] = STATE(275),
    [sym_function] = STATE(539),
    [sym_function_declaration] = STATE(275),
    [sym_generator_function] = STATE(539),
    [sym_generator_function_declaration] = STATE(275),
    [sym_arrow_function] = STATE(539),
    [sym_call_expression] = STATE(539),
    [sym_new_expression] = STATE(550),
    [sym_await_expression] = STATE(550),
    [sym_member_expression] = STATE(362),
    [sym_subscript_expression] = STATE(362),
    [sym_assignment_expression] = STATE(550),
    [sym__augmented_assignment_lhs] = STATE(720),
    [sym_augmented_assignment_expression] = STATE(550),
    [sym__destructuring_pattern] = STATE(1320),
    [sym_ternary_expression] = STATE(550),
    [sym_binary_expression] = STATE(550),
    [sym_unary_expression] = STATE(550),
    [sym_update_expression] = STATE(550),
    [sym_sequence_expression] = STATE(1156),
    [sym_string] = STATE(539),
    [sym_template_string] = STATE(539),
    [sym_regex] = STATE(539),
    [sym_meta_property] = STATE(539),
    [sym_decorator] = STATE(750),
    [sym_formal_parameters] = STATE(1318),
    [aux_sym_export_statement_repeat1] = STATE(882),
    [sym_identifier] = ACTIONS(299),
    [anon_sym_export] = ACTIONS(301),
    [anon_sym_LBRACE] = ACTIONS(303),
    [anon_sym_import] = ACTIONS(15),
    [anon_sym_var] = ACTIONS(17),
    [anon_sym_let] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(19),
    [anon_sym_if] = ACTIONS(305),
    [anon_sym_switch] = ACTIONS(23),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(29),
    [anon_sym_while] = ACTIONS(309),
    [anon_sym_do] = ACTIONS(33),
    [anon_sym_try] = ACTIONS(35),
    [anon_sym_with] = ACTIONS(311),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_debugger] = ACTIONS(43),
    [anon_sym_return] = ACTIONS(45),
    [anon_sym_throw] = ACTIONS(47),
    [anon_sym_SEMI] = ACTIONS(49),
    [anon_sym_yield] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(53),
    [anon_sym_LT] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(313),
    [anon_sym_async] = ACTIONS(315),
    [anon_sym_function] = ACTIONS(317),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_typeof] = ACTIONS(71),
    [anon_sym_void] = ACTIONS(71),
    [anon_sym_delete] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DQUOTE] = ACTIONS(75),
    [anon_sym_SQUOTE] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(79),
    [sym_number] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(83),
    [sym_true] = ACTIONS(83),
    [sym_false] = ACTIONS(83),
    [sym_null] = ACTIONS(83),
    [sym_undefined] = ACTIONS(83),
    [anon_sym_AT] = ACTIONS(85),
    [anon_sym_static] = ACTIONS(319),
    [anon_sym_get] = ACTIONS(319),
    [anon_sym_set] = ACTIONS(319),
  },
  [35] = {
    [sym_export_statement] = STATE(304),
    [sym_declaration] = STATE(304),
    [sym_import] = STATE(539),
    [sym_import_statement] = STATE(304),
    [sym_expression_statement] = STATE(304),
    [sym_variable_declaration] = STATE(275),
    [sym_lexical_declaration] = STATE(275),
    [sym_statement_block] = STATE(304),
    [sym_if_statement] = STATE(304),
    [sym_switch_statement] = STATE(304),
    [sym_for_statement] = STATE(304),
    [sym_for_in_statement] = STATE(304),
    [sym_while_statement] = STATE(304),
    [sym_do_statement] = STATE(304),
    [sym_try_statement] = STATE(304),
    [sym_with_statement] = STATE(304),
    [sym_break_statement] = STATE(304),
    [sym_continue_statement] = STATE(304),
    [sym_debugger_statement] = STATE(304),
    [sym_return_statement] = STATE(304),
    [sym_throw_statement] = STATE(304),
    [sym_empty_statement] = STATE(304),
    [sym_labeled_statement] = STATE(304),
    [sym_parenthesized_expression] = STATE(362),
    [sym_expression] = STATE(522),
    [sym_primary_expression] = STATE(546),
    [sym_yield_expression] = STATE(550),
    [sym_object] = STATE(539),
    [sym_object_pattern] = STATE(1320),
    [sym_array] = STATE(539),
    [sym_array_pattern] = STATE(1320),
    [sym_jsx_element] = STATE(550),
    [sym_jsx_fragment] = STATE(550),
    [sym_jsx_opening_element] = STATE(772),
    [sym_jsx_self_closing_element] = STATE(550),
    [sym_class] = STATE(539),
    [sym_class_declaration] = STATE(275),
    [sym_function] = STATE(539),
    [sym_function_declaration] = STATE(275),
    [sym_generator_function] = STATE(539),
    [sym_generator_function_declaration] = STATE(275),
    [sym_arrow_function] = STATE(539),
    [sym_call_expression] = STATE(539),
    [sym_new_expression] = STATE(550),
    [sym_await_expression] = STATE(550),
    [sym_member_expression] = STATE(362),
    [sym_subscript_expression] = STATE(362),
    [sym_assignment_expression] = STATE(550),
    [sym__augmented_assignment_lhs] = STATE(720),
    [sym_augmented_assignment_expression] = STATE(550),
    [sym__destructuring_pattern] = STATE(1320),
    [sym_ternary_expression] = STATE(550),
    [sym_binary_expression] = STATE(550),
    [sym_unary_expression] = STATE(550),
    [sym_update_expression] = STATE(550),
    [sym_sequence_expression] = STATE(1156),
    [sym_string] = STATE(539),
    [sym_template_string] = STATE(539),
    [sym_regex] = STATE(539),
    [sym_meta_property] = STATE(539),
    [sym_decorator] = STATE(750),
    [sym_formal_parameters] = STATE(1318),
    [aux_sym_export_statement_repeat1] = STATE(882),
    [sym_identifier] = ACTIONS(299),
    [anon_sym_export] = ACTIONS(301),
    [anon_sym_LBRACE] = ACTIONS(303),
    [anon_sym_import] = ACTIONS(15),
    [anon_sym_var] = ACTIONS(17),
    [anon_sym_let] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(19),
    [anon_sym_if] = ACTIONS(305),
    [anon_sym_switch] = ACTIONS(23),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(29),
    [anon_sym_while] = ACTIONS(309),
    [anon_sym_do] = ACTIONS(33),
    [anon_sym_try] = ACTIONS(35),
    [anon_sym_with] = ACTIONS(311),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_debugger] = ACTIONS(43),
    [anon_sym_return] = ACTIONS(45),
    [anon_sym_throw] = ACTIONS(47),
    [anon_sym_SEMI] = ACTIONS(49),
    [anon_sym_yield] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(53),
    [anon_sym_LT] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(313),
    [anon_sym_async] = ACTIONS(315),
    [anon_sym_function] = ACTIONS(317),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_typeof] = ACTIONS(71),
    [anon_sym_void] = ACTIONS(71),
    [anon_sym_delete] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DQUOTE] = ACTIONS(75),
    [anon_sym_SQUOTE] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(79),
    [sym_number] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(83),
    [sym_true] = ACTIONS(83),
    [sym_false] = ACTIONS(83),
    [sym_null] = ACTIONS(83),
    [sym_undefined] = ACTIONS(83),
    [anon_sym_AT] = ACTIONS(85),
    [anon_sym_static] = ACTIONS(319),
    [anon_sym_get] = ACTIONS(319),
    [anon_sym_set] = ACTIONS(319),
  },
  [36] = {
    [sym_export_statement] = STATE(304),
    [sym_declaration] = STATE(304),
    [sym_import] = STATE(539),
    [sym_import_statement] = STATE(304),
    [sym_expression_statement] = STATE(304),
    [sym_variable_declaration] = STATE(275),
    [sym_lexical_declaration] = STATE(275),
    [sym_statement_block] = STATE(304),
    [sym_if_statement] = STATE(304),
    [sym_switch_statement] = STATE(304),
    [sym_for_statement] = STATE(304),
    [sym_for_in_statement] = STATE(304),
    [sym_while_statement] = STATE(304),
    [sym_do_statement] = STATE(304),
    [sym_try_statement] = STATE(304),
    [sym_with_statement] = STATE(304),
    [sym_break_statement] = STATE(304),
    [sym_continue_statement] = STATE(304),
    [sym_debugger_statement] = STATE(304),
    [sym_return_statement] = STATE(304),
    [sym_throw_statement] = STATE(304),
    [sym_empty_statement] = STATE(304),
    [sym_labeled_statement] = STATE(304),
    [sym_parenthesized_expression] = STATE(362),
    [sym_expression] = STATE(522),
    [sym_primary_expression] = STATE(546),
    [sym_yield_expression] = STATE(550),
    [sym_object] = STATE(539),
    [sym_object_pattern] = STATE(1320),
    [sym_array] = STATE(539),
    [sym_array_pattern] = STATE(1320),
    [sym_jsx_element] = STATE(550),
    [sym_jsx_fragment] = STATE(550),
    [sym_jsx_opening_element] = STATE(772),
    [sym_jsx_self_closing_element] = STATE(550),
    [sym_class] = STATE(539),
    [sym_class_declaration] = STATE(275),
    [sym_function] = STATE(539),
    [sym_function_declaration] = STATE(275),
    [sym_generator_function] = STATE(539),
    [sym_generator_function_declaration] = STATE(275),
    [sym_arrow_function] = STATE(539),
    [sym_call_expression] = STATE(539),
    [sym_new_expression] = STATE(550),
    [sym_await_expression] = STATE(550),
    [sym_member_expression] = STATE(362),
    [sym_subscript_expression] = STATE(362),
    [sym_assignment_expression] = STATE(550),
    [sym__augmented_assignment_lhs] = STATE(720),
    [sym_augmented_assignment_expression] = STATE(550),
    [sym__destructuring_pattern] = STATE(1320),
    [sym_ternary_expression] = STATE(550),
    [sym_binary_expression] = STATE(550),
    [sym_unary_expression] = STATE(550),
    [sym_update_expression] = STATE(550),
    [sym_sequence_expression] = STATE(1156),
    [sym_string] = STATE(539),
    [sym_template_string] = STATE(539),
    [sym_regex] = STATE(539),
    [sym_meta_property] = STATE(539),
    [sym_decorator] = STATE(750),
    [sym_formal_parameters] = STATE(1318),
    [aux_sym_export_statement_repeat1] = STATE(891),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_import] = ACTIONS(15),
    [anon_sym_var] = ACTIONS(17),
    [anon_sym_let] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(19),
    [anon_sym_if] = ACTIONS(21),
    [anon_sym_switch] = ACTIONS(23),
    [anon_sym_for] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(29),
    [anon_sym_while] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(33),
    [anon_sym_try] = ACTIONS(35),
    [anon_sym_with] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_debugger] = ACTIONS(43),
    [anon_sym_return] = ACTIONS(45),
    [anon_sym_throw] = ACTIONS(47),
    [anon_sym_SEMI] = ACTIONS(49),
    [anon_sym_yield] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(53),
    [anon_sym_LT] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(59),
    [anon_sym_async] = ACTIONS(61),
    [anon_sym_function] = ACTIONS(63),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_typeof] = ACTIONS(71),
    [anon_sym_void] = ACTIONS(71),
    [anon_sym_delete] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DQUOTE] = ACTIONS(75),
    [anon_sym_SQUOTE] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(79),
    [sym_number] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(83),
    [sym_true] = ACTIONS(83),
    [sym_false] = ACTIONS(83),
    [sym_null] = ACTIONS(83),
    [sym_undefined] = ACTIONS(83),
    [anon_sym_AT] = ACTIONS(85),
    [anon_sym_static] = ACTIONS(87),
    [anon_sym_get] = ACTIONS(87),
    [anon_sym_set] = ACTIONS(87),
  },
  [37] = {
    [sym_export_statement] = STATE(265),
    [sym_declaration] = STATE(265),
    [sym_import] = STATE(539),
    [sym_import_statement] = STATE(265),
    [sym_expression_statement] = STATE(265),
    [sym_variable_declaration] = STATE(275),
    [sym_lexical_declaration] = STATE(275),
    [sym_statement_block] = STATE(265),
    [sym_if_statement] = STATE(265),
    [sym_switch_statement] = STATE(265),
    [sym_for_statement] = STATE(265),
    [sym_for_in_statement] = STATE(265),
    [sym_while_statement] = STATE(265),
    [sym_do_statement] = STATE(265),
    [sym_try_statement] = STATE(265),
    [sym_with_statement] = STATE(265),
    [sym_break_statement] = STATE(265),
    [sym_continue_statement] = STATE(265),
    [sym_debugger_statement] = STATE(265),
    [sym_return_statement] = STATE(265),
    [sym_throw_statement] = STATE(265),
    [sym_empty_statement] = STATE(265),
    [sym_labeled_statement] = STATE(265),
    [sym_parenthesized_expression] = STATE(362),
    [sym_expression] = STATE(522),
    [sym_primary_expression] = STATE(546),
    [sym_yield_expression] = STATE(550),
    [sym_object] = STATE(539),
    [sym_object_pattern] = STATE(1320),
    [sym_array] = STATE(539),
    [sym_array_pattern] = STATE(1320),
    [sym_jsx_element] = STATE(550),
    [sym_jsx_fragment] = STATE(550),
    [sym_jsx_opening_element] = STATE(772),
    [sym_jsx_self_closing_element] = STATE(550),
    [sym_class] = STATE(539),
    [sym_class_declaration] = STATE(275),
    [sym_function] = STATE(539),
    [sym_function_declaration] = STATE(275),
    [sym_generator_function] = STATE(539),
    [sym_generator_function_declaration] = STATE(275),
    [sym_arrow_function] = STATE(539),
    [sym_call_expression] = STATE(539),
    [sym_new_expression] = STATE(550),
    [sym_await_expression] = STATE(550),
    [sym_member_expression] = STATE(362),
    [sym_subscript_expression] = STATE(362),
    [sym_assignment_expression] = STATE(550),
    [sym__augmented_assignment_lhs] = STATE(720),
    [sym_augmented_assignment_expression] = STATE(550),
    [sym__destructuring_pattern] = STATE(1320),
    [sym_ternary_expression] = STATE(550),
    [sym_binary_expression] = STATE(550),
    [sym_unary_expression] = STATE(550),
    [sym_update_expression] = STATE(550),
    [sym_sequence_expression] = STATE(1156),
    [sym_string] = STATE(539),
    [sym_template_string] = STATE(539),
    [sym_regex] = STATE(539),
    [sym_meta_property] = STATE(539),
    [sym_decorator] = STATE(750),
    [sym_formal_parameters] = STATE(1318),
    [aux_sym_export_statement_repeat1] = STATE(882),
    [sym_identifier] = ACTIONS(299),
    [anon_sym_export] = ACTIONS(301),
    [anon_sym_LBRACE] = ACTIONS(303),
    [anon_sym_import] = ACTIONS(15),
    [anon_sym_var] = ACTIONS(17),
    [anon_sym_let] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(19),
    [anon_sym_if] = ACTIONS(305),
    [anon_sym_switch] = ACTIONS(23),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(29),
    [anon_sym_while] = ACTIONS(309),
    [anon_sym_do] = ACTIONS(33),
    [anon_sym_try] = ACTIONS(35),
    [anon_sym_with] = ACTIONS(311),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_debugger] = ACTIONS(43),
    [anon_sym_return] = ACTIONS(45),
    [anon_sym_throw] = ACTIONS(47),
    [anon_sym_SEMI] = ACTIONS(49),
    [anon_sym_yield] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(53),
    [anon_sym_LT] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(313),
    [anon_sym_async] = ACTIONS(315),
    [anon_sym_function] = ACTIONS(317),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_typeof] = ACTIONS(71),
    [anon_sym_void] = ACTIONS(71),
    [anon_sym_delete] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DQUOTE] = ACTIONS(75),
    [anon_sym_SQUOTE] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(79),
    [sym_number] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(83),
    [sym_true] = ACTIONS(83),
    [sym_false] = ACTIONS(83),
    [sym_null] = ACTIONS(83),
    [sym_undefined] = ACTIONS(83),
    [anon_sym_AT] = ACTIONS(85),
    [anon_sym_static] = ACTIONS(319),
    [anon_sym_get] = ACTIONS(319),
    [anon_sym_set] = ACTIONS(319),
  },
  [38] = {
    [sym_export_statement] = STATE(232),
    [sym_declaration] = STATE(232),
    [sym_import] = STATE(539),
    [sym_import_statement] = STATE(232),
    [sym_expression_statement] = STATE(232),
    [sym_variable_declaration] = STATE(275),
    [sym_lexical_declaration] = STATE(275),
    [sym_statement_block] = STATE(232),
    [sym_if_statement] = STATE(232),
    [sym_switch_statement] = STATE(232),
    [sym_for_statement] = STATE(232),
    [sym_for_in_statement] = STATE(232),
    [sym_while_statement] = STATE(232),
    [sym_do_statement] = STATE(232),
    [sym_try_statement] = STATE(232),
    [sym_with_statement] = STATE(232),
    [sym_break_statement] = STATE(232),
    [sym_continue_statement] = STATE(232),
    [sym_debugger_statement] = STATE(232),
    [sym_return_statement] = STATE(232),
    [sym_throw_statement] = STATE(232),
    [sym_empty_statement] = STATE(232),
    [sym_labeled_statement] = STATE(232),
    [sym_parenthesized_expression] = STATE(362),
    [sym_expression] = STATE(522),
    [sym_primary_expression] = STATE(546),
    [sym_yield_expression] = STATE(550),
    [sym_object] = STATE(539),
    [sym_object_pattern] = STATE(1320),
    [sym_array] = STATE(539),
    [sym_array_pattern] = STATE(1320),
    [sym_jsx_element] = STATE(550),
    [sym_jsx_fragment] = STATE(550),
    [sym_jsx_opening_element] = STATE(772),
    [sym_jsx_self_closing_element] = STATE(550),
    [sym_class] = STATE(539),
    [sym_class_declaration] = STATE(275),
    [sym_function] = STATE(539),
    [sym_function_declaration] = STATE(275),
    [sym_generator_function] = STATE(539),
    [sym_generator_function_declaration] = STATE(275),
    [sym_arrow_function] = STATE(539),
    [sym_call_expression] = STATE(539),
    [sym_new_expression] = STATE(550),
    [sym_await_expression] = STATE(550),
    [sym_member_expression] = STATE(362),
    [sym_subscript_expression] = STATE(362),
    [sym_assignment_expression] = STATE(550),
    [sym__augmented_assignment_lhs] = STATE(720),
    [sym_augmented_assignment_expression] = STATE(550),
    [sym__destructuring_pattern] = STATE(1320),
    [sym_ternary_expression] = STATE(550),
    [sym_binary_expression] = STATE(550),
    [sym_unary_expression] = STATE(550),
    [sym_update_expression] = STATE(550),
    [sym_sequence_expression] = STATE(1156),
    [sym_string] = STATE(539),
    [sym_template_string] = STATE(539),
    [sym_regex] = STATE(539),
    [sym_meta_property] = STATE(539),
    [sym_decorator] = STATE(750),
    [sym_formal_parameters] = STATE(1318),
    [aux_sym_export_statement_repeat1] = STATE(891),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_import] = ACTIONS(15),
    [anon_sym_var] = ACTIONS(17),
    [anon_sym_let] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(19),
    [anon_sym_if] = ACTIONS(21),
    [anon_sym_switch] = ACTIONS(23),
    [anon_sym_for] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(29),
    [anon_sym_while] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(33),
    [anon_sym_try] = ACTIONS(35),
    [anon_sym_with] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_debugger] = ACTIONS(43),
    [anon_sym_return] = ACTIONS(45),
    [anon_sym_throw] = ACTIONS(47),
    [anon_sym_SEMI] = ACTIONS(49),
    [anon_sym_yield] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(53),
    [anon_sym_LT] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(59),
    [anon_sym_async] = ACTIONS(61),
    [anon_sym_function] = ACTIONS(63),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_typeof] = ACTIONS(71),
    [anon_sym_void] = ACTIONS(71),
    [anon_sym_delete] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DQUOTE] = ACTIONS(75),
    [anon_sym_SQUOTE] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(79),
    [sym_number] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(83),
    [sym_true] = ACTIONS(83),
    [sym_false] = ACTIONS(83),
    [sym_null] = ACTIONS(83),
    [sym_undefined] = ACTIONS(83),
    [anon_sym_AT] = ACTIONS(85),
    [anon_sym_static] = ACTIONS(87),
    [anon_sym_get] = ACTIONS(87),
    [anon_sym_set] = ACTIONS(87),
  },
  [39] = {
    [sym_export_statement] = STATE(310),
    [sym_declaration] = STATE(311),
    [sym_import] = STATE(539),
    [sym_import_statement] = STATE(312),
    [sym_expression_statement] = STATE(313),
    [sym_variable_declaration] = STATE(275),
    [sym_lexical_declaration] = STATE(275),
    [sym_statement_block] = STATE(314),
    [sym_if_statement] = STATE(315),
    [sym_switch_statement] = STATE(316),
    [sym_for_statement] = STATE(317),
    [sym_for_in_statement] = STATE(318),
    [sym_while_statement] = STATE(319),
    [sym_do_statement] = STATE(320),
    [sym_try_statement] = STATE(321),
    [sym_with_statement] = STATE(322),
    [sym_break_statement] = STATE(323),
    [sym_continue_statement] = STATE(324),
    [sym_debugger_statement] = STATE(325),
    [sym_return_statement] = STATE(326),
    [sym_throw_statement] = STATE(327),
    [sym_empty_statement] = STATE(328),
    [sym_labeled_statement] = STATE(329),
    [sym_parenthesized_expression] = STATE(362),
    [sym_expression] = STATE(522),
    [sym_primary_expression] = STATE(546),
    [sym_yield_expression] = STATE(550),
    [sym_object] = STATE(539),
    [sym_object_pattern] = STATE(1320),
    [sym_array] = STATE(539),
    [sym_array_pattern] = STATE(1320),
    [sym_jsx_element] = STATE(550),
    [sym_jsx_fragment] = STATE(550),
    [sym_jsx_opening_element] = STATE(772),
    [sym_jsx_self_closing_element] = STATE(550),
    [sym_class] = STATE(539),
    [sym_class_declaration] = STATE(275),
    [sym_function] = STATE(539),
    [sym_function_declaration] = STATE(275),
    [sym_generator_function] = STATE(539),
    [sym_generator_function_declaration] = STATE(275),
    [sym_arrow_function] = STATE(539),
    [sym_call_expression] = STATE(539),
    [sym_new_expression] = STATE(550),
    [sym_await_expression] = STATE(550),
    [sym_member_expression] = STATE(362),
    [sym_subscript_expression] = STATE(362),
    [sym_assignment_expression] = STATE(550),
    [sym__augmented_assignment_lhs] = STATE(720),
    [sym_augmented_assignment_expression] = STATE(550),
    [sym__destructuring_pattern] = STATE(1320),
    [sym_ternary_expression] = STATE(550),
    [sym_binary_expression] = STATE(550),
    [sym_unary_expression] = STATE(550),
    [sym_update_expression] = STATE(550),
    [sym_sequence_expression] = STATE(1156),
    [sym_string] = STATE(539),
    [sym_template_string] = STATE(539),
    [sym_regex] = STATE(539),
    [sym_meta_property] = STATE(539),
    [sym_decorator] = STATE(750),
    [sym_formal_parameters] = STATE(1318),
    [aux_sym_export_statement_repeat1] = STATE(882),
    [sym_identifier] = ACTIONS(299),
    [anon_sym_export] = ACTIONS(301),
    [anon_sym_LBRACE] = ACTIONS(303),
    [anon_sym_import] = ACTIONS(15),
    [anon_sym_var] = ACTIONS(17),
    [anon_sym_let] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(19),
    [anon_sym_if] = ACTIONS(305),
    [anon_sym_switch] = ACTIONS(23),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(29),
    [anon_sym_while] = ACTIONS(309),
    [anon_sym_do] = ACTIONS(33),
    [anon_sym_try] = ACTIONS(35),
    [anon_sym_with] = ACTIONS(311),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_debugger] = ACTIONS(43),
    [anon_sym_return] = ACTIONS(45),
    [anon_sym_throw] = ACTIONS(47),
    [anon_sym_SEMI] = ACTIONS(49),
    [anon_sym_yield] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(53),
    [anon_sym_LT] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(313),
    [anon_sym_async] = ACTIONS(315),
    [anon_sym_function] = ACTIONS(317),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_typeof] = ACTIONS(71),
    [anon_sym_void] = ACTIONS(71),
    [anon_sym_delete] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DQUOTE] = ACTIONS(75),
    [anon_sym_SQUOTE] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(79),
    [sym_number] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(83),
    [sym_true] = ACTIONS(83),
    [sym_false] = ACTIONS(83),
    [sym_null] = ACTIONS(83),
    [sym_undefined] = ACTIONS(83),
    [anon_sym_AT] = ACTIONS(85),
    [anon_sym_static] = ACTIONS(319),
    [anon_sym_get] = ACTIONS(319),
    [anon_sym_set] = ACTIONS(319),
  },
  [40] = {
    [sym_export_statement] = STATE(1262),
    [sym_declaration] = STATE(1262),
    [sym_import] = STATE(539),
    [sym_import_statement] = STATE(1262),
    [sym_expression_statement] = STATE(1262),
    [sym_variable_declaration] = STATE(275),
    [sym_lexical_declaration] = STATE(275),
    [sym_statement_block] = STATE(1262),
    [sym_if_statement] = STATE(1262),
    [sym_switch_statement] = STATE(1262),
    [sym_for_statement] = STATE(1262),
    [sym_for_in_statement] = STATE(1262),
    [sym_while_statement] = STATE(1262),
    [sym_do_statement] = STATE(1262),
    [sym_try_statement] = STATE(1262),
    [sym_with_statement] = STATE(1262),
    [sym_break_statement] = STATE(1262),
    [sym_continue_statement] = STATE(1262),
    [sym_debugger_statement] = STATE(1262),
    [sym_return_statement] = STATE(1262),
    [sym_throw_statement] = STATE(1262),
    [sym_empty_statement] = STATE(1262),
    [sym_labeled_statement] = STATE(1262),
    [sym_parenthesized_expression] = STATE(362),
    [sym_expression] = STATE(522),
    [sym_primary_expression] = STATE(546),
    [sym_yield_expression] = STATE(550),
    [sym_object] = STATE(539),
    [sym_object_pattern] = STATE(1320),
    [sym_array] = STATE(539),
    [sym_array_pattern] = STATE(1320),
    [sym_jsx_element] = STATE(550),
    [sym_jsx_fragment] = STATE(550),
    [sym_jsx_opening_element] = STATE(772),
    [sym_jsx_self_closing_element] = STATE(550),
    [sym_class] = STATE(539),
    [sym_class_declaration] = STATE(275),
    [sym_function] = STATE(539),
    [sym_function_declaration] = STATE(275),
    [sym_generator_function] = STATE(539),
    [sym_generator_function_declaration] = STATE(275),
    [sym_arrow_function] = STATE(539),
    [sym_call_expression] = STATE(539),
    [sym_new_expression] = STATE(550),
    [sym_await_expression] = STATE(550),
    [sym_member_expression] = STATE(362),
    [sym_subscript_expression] = STATE(362),
    [sym_assignment_expression] = STATE(550),
    [sym__augmented_assignment_lhs] = STATE(720),
    [sym_augmented_assignment_expression] = STATE(550),
    [sym__destructuring_pattern] = STATE(1320),
    [sym_ternary_expression] = STATE(550),
    [sym_binary_expression] = STATE(550),
    [sym_unary_expression] = STATE(550),
    [sym_update_expression] = STATE(550),
    [sym_sequence_expression] = STATE(1156),
    [sym_string] = STATE(539),
    [sym_template_string] = STATE(539),
    [sym_regex] = STATE(539),
    [sym_meta_property] = STATE(539),
    [sym_decorator] = STATE(750),
    [sym_formal_parameters] = STATE(1318),
    [aux_sym_export_statement_repeat1] = STATE(882),
    [sym_identifier] = ACTIONS(299),
    [anon_sym_export] = ACTIONS(301),
    [anon_sym_LBRACE] = ACTIONS(303),
    [anon_sym_import] = ACTIONS(15),
    [anon_sym_var] = ACTIONS(17),
    [anon_sym_let] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(19),
    [anon_sym_if] = ACTIONS(305),
    [anon_sym_switch] = ACTIONS(23),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(29),
    [anon_sym_while] = ACTIONS(309),
    [anon_sym_do] = ACTIONS(33),
    [anon_sym_try] = ACTIONS(35),
    [anon_sym_with] = ACTIONS(311),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_debugger] = ACTIONS(43),
    [anon_sym_return] = ACTIONS(45),
    [anon_sym_throw] = ACTIONS(47),
    [anon_sym_SEMI] = ACTIONS(49),
    [anon_sym_yield] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(53),
    [anon_sym_LT] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(313),
    [anon_sym_async] = ACTIONS(315),
    [anon_sym_function] = ACTIONS(317),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_typeof] = ACTIONS(71),
    [anon_sym_void] = ACTIONS(71),
    [anon_sym_delete] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DQUOTE] = ACTIONS(75),
    [anon_sym_SQUOTE] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(79),
    [sym_number] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(83),
    [sym_true] = ACTIONS(83),
    [sym_false] = ACTIONS(83),
    [sym_null] = ACTIONS(83),
    [sym_undefined] = ACTIONS(83),
    [anon_sym_AT] = ACTIONS(85),
    [anon_sym_static] = ACTIONS(319),
    [anon_sym_get] = ACTIONS(319),
    [anon_sym_set] = ACTIONS(319),
  },
  [41] = {
    [sym_export_statement] = STATE(1031),
    [sym_declaration] = STATE(1031),
    [sym_import] = STATE(539),
    [sym_import_statement] = STATE(1031),
    [sym_expression_statement] = STATE(1031),
    [sym_variable_declaration] = STATE(275),
    [sym_lexical_declaration] = STATE(275),
    [sym_statement_block] = STATE(1031),
    [sym_if_statement] = STATE(1031),
    [sym_switch_statement] = STATE(1031),
    [sym_for_statement] = STATE(1031),
    [sym_for_in_statement] = STATE(1031),
    [sym_while_statement] = STATE(1031),
    [sym_do_statement] = STATE(1031),
    [sym_try_statement] = STATE(1031),
    [sym_with_statement] = STATE(1031),
    [sym_break_statement] = STATE(1031),
    [sym_continue_statement] = STATE(1031),
    [sym_debugger_statement] = STATE(1031),
    [sym_return_statement] = STATE(1031),
    [sym_throw_statement] = STATE(1031),
    [sym_empty_statement] = STATE(1031),
    [sym_labeled_statement] = STATE(1031),
    [sym_parenthesized_expression] = STATE(362),
    [sym_expression] = STATE(522),
    [sym_primary_expression] = STATE(546),
    [sym_yield_expression] = STATE(550),
    [sym_object] = STATE(539),
    [sym_object_pattern] = STATE(1320),
    [sym_array] = STATE(539),
    [sym_array_pattern] = STATE(1320),
    [sym_jsx_element] = STATE(550),
    [sym_jsx_fragment] = STATE(550),
    [sym_jsx_opening_element] = STATE(772),
    [sym_jsx_self_closing_element] = STATE(550),
    [sym_class] = STATE(539),
    [sym_class_declaration] = STATE(275),
    [sym_function] = STATE(539),
    [sym_function_declaration] = STATE(275),
    [sym_generator_function] = STATE(539),
    [sym_generator_function_declaration] = STATE(275),
    [sym_arrow_function] = STATE(539),
    [sym_call_expression] = STATE(539),
    [sym_new_expression] = STATE(550),
    [sym_await_expression] = STATE(550),
    [sym_member_expression] = STATE(362),
    [sym_subscript_expression] = STATE(362),
    [sym_assignment_expression] = STATE(550),
    [sym__augmented_assignment_lhs] = STATE(720),
    [sym_augmented_assignment_expression] = STATE(550),
    [sym__destructuring_pattern] = STATE(1320),
    [sym_ternary_expression] = STATE(550),
    [sym_binary_expression] = STATE(550),
    [sym_unary_expression] = STATE(550),
    [sym_update_expression] = STATE(550),
    [sym_sequence_expression] = STATE(1156),
    [sym_string] = STATE(539),
    [sym_template_string] = STATE(539),
    [sym_regex] = STATE(539),
    [sym_meta_property] = STATE(539),
    [sym_decorator] = STATE(750),
    [sym_formal_parameters] = STATE(1318),
    [aux_sym_export_statement_repeat1] = STATE(882),
    [sym_identifier] = ACTIONS(299),
    [anon_sym_export] = ACTIONS(301),
    [anon_sym_LBRACE] = ACTIONS(303),
    [anon_sym_import] = ACTIONS(15),
    [anon_sym_var] = ACTIONS(17),
    [anon_sym_let] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(19),
    [anon_sym_if] = ACTIONS(305),
    [anon_sym_switch] = ACTIONS(23),
    [anon_sym_for] = ACTIONS(307),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(29),
    [anon_sym_while] = ACTIONS(309),
    [anon_sym_do] = ACTIONS(33),
    [anon_sym_try] = ACTIONS(35),
    [anon_sym_with] = ACTIONS(311),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_debugger] = ACTIONS(43),
    [anon_sym_return] = ACTIONS(45),
    [anon_sym_throw] = ACTIONS(47),
    [anon_sym_SEMI] = ACTIONS(49),
    [anon_sym_yield] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(53),
    [anon_sym_LT] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(313),
    [anon_sym_async] = ACTIONS(315),
    [anon_sym_function] = ACTIONS(317),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_typeof] = ACTIONS(71),
    [anon_sym_void] = ACTIONS(71),
    [anon_sym_delete] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DQUOTE] = ACTIONS(75),
    [anon_sym_SQUOTE] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(79),
    [sym_number] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(83),
    [sym_true] = ACTIONS(83),
    [sym_false] = ACTIONS(83),
    [sym_null] = ACTIONS(83),
    [sym_undefined] = ACTIONS(83),
    [anon_sym_AT] = ACTIONS(85),
    [anon_sym_static] = ACTIONS(319),
    [anon_sym_get] = ACTIONS(319),
    [anon_sym_set] = ACTIONS(319),
  },
  [42] = {
    [sym_export_statement] = STATE(308),
    [sym_declaration] = STATE(308),
    [sym_import] = STATE(539),
    [sym_import_statement] = STATE(308),
    [sym_expression_statement] = STATE(308),
    [sym_variable_declaration] = STATE(275),
    [sym_lexical_declaration] = STATE(275),
    [sym_statement_block] = STATE(308),
    [sym_if_statement] = STATE(308),
    [sym_switch_statement] = STATE(308),
    [sym_for_statement] = STATE(308),
    [sym_for_in_statement] = STATE(308),
    [sym_while_statement] = STATE(308),
    [sym_do_statement] = STATE(308),
    [sym_try_statement] = STATE(308),
    [sym_with_statement] = STATE(308),
    [sym_break_statement] = STATE(308),
    [sym_continue_statement] = STATE(308),
    [sym_debugger_statement] = STATE(308),
    [sym_return_statement] = STATE(308),
    [sym_throw_statement] = STATE(308),
    [sym_empty_statement] = STATE(308),
    [sym_labeled_statement] = STATE(308),
    [sym_parenthesized_expression] = STATE(362),
    [sym_expression] = STATE(522),
    [sym_primary_expression] = STATE(546),
    [sym_yield_expression] = STATE(550),
    [sym_object] = STATE(539),
    [sym_object_pattern] = STATE(1320),
    [sym_array] = STATE(539),
    [sym_array_pattern] = STATE(1320),
    [sym_jsx_element] = STATE(550),
    [sym_jsx_fragment] = STATE(550),
    [sym_jsx_opening_element] = STATE(772),
    [sym_jsx_self_closing_element] = STATE(550),
    [sym_class] = STATE(539),
    [sym_class_declaration] = STATE(275),
    [sym_function] = STATE(539),
    [sym_function_declaration] = STATE(275),
    [sym_generator_function] = STATE(539),
    [sym_generator_function_declaration] = STATE(275),
    [sym_arrow_function] = STATE(539),
    [sym_call_expression] = STATE(539),
    [sym_new_expression] = STATE(550),
    [sym_await_expression] = STATE(550),
    [sym_member_expression] = STATE(362),
    [sym_subscript_expression] = STATE(362),
    [sym_assignment_expression] = STATE(550),
    [sym__augmented_assignment_lhs] = STATE(720),
    [sym_augmented_assignment_expression] = STATE(550),
    [sym__destructuring_pattern] = STATE(1320),
    [sym_ternary_expression] = STATE(550),
    [sym_binary_expression] = STATE(550),
    [sym_unary_expression] = STATE(550),
    [sym_update_expression] = STATE(550),
    [sym_sequence_expression] = STATE(1156),
    [sym_string] = STATE(539),
    [sym_template_string] = STATE(539),
    [sym_regex] = STATE(539),
    [sym_meta_property] = STATE(539),
    [sym_decorator] = STATE(750),
    [sym_formal_parameters] = STATE(1318),
    [aux_sym_export_statement_repeat1] = STATE(891),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_import] = ACTIONS(15),
    [anon_sym_var] = ACTIONS(17),
    [anon_sym_let] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(19),
    [anon_sym_if] = ACTIONS(21),
    [anon_sym_switch] = ACTIONS(23),
    [anon_sym_for] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(29),
    [anon_sym_while] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(33),
    [anon_sym_try] = ACTIONS(35),
    [anon_sym_with] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_debugger] = ACTIONS(43),
    [anon_sym_return] = ACTIONS(45),
    [anon_sym_throw] = ACTIONS(47),
    [anon_sym_SEMI] = ACTIONS(49),
    [anon_sym_yield] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(53),
    [anon_sym_LT] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(59),
    [anon_sym_async] = ACTIONS(61),
    [anon_sym_function] = ACTIONS(63),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_typeof] = ACTIONS(71),
    [anon_sym_void] = ACTIONS(71),
    [anon_sym_delete] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DQUOTE] = ACTIONS(75),
    [anon_sym_SQUOTE] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(79),
    [sym_number] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(83),
    [sym_true] = ACTIONS(83),
    [sym_false] = ACTIONS(83),
    [sym_null] = ACTIONS(83),
    [sym_undefined] = ACTIONS(83),
    [anon_sym_AT] = ACTIONS(85),
    [anon_sym_static] = ACTIONS(87),
    [anon_sym_get] = ACTIONS(87),
    [anon_sym_set] = ACTIONS(87),
  },
  [43] = {
    [sym_export_statement] = STATE(280),
    [sym_declaration] = STATE(280),
    [sym_import] = STATE(539),
    [sym_import_statement] = STATE(280),
    [sym_expression_statement] = STATE(280),
    [sym_variable_declaration] = STATE(275),
    [sym_lexical_declaration] = STATE(275),
    [sym_statement_block] = STATE(280),
    [sym_if_statement] = STATE(280),
    [sym_switch_statement] = STATE(280),
    [sym_for_statement] = STATE(280),
    [sym_for_in_statement] = STATE(280),
    [sym_while_statement] = STATE(280),
    [sym_do_statement] = STATE(280),
    [sym_try_statement] = STATE(280),
    [sym_with_statement] = STATE(280),
    [sym_break_statement] = STATE(280),
    [sym_continue_statement] = STATE(280),
    [sym_debugger_statement] = STATE(280),
    [sym_return_statement] = STATE(280),
    [sym_throw_statement] = STATE(280),
    [sym_empty_statement] = STATE(280),
    [sym_labeled_statement] = STATE(280),
    [sym_parenthesized_expression] = STATE(362),
    [sym_expression] = STATE(522),
    [sym_primary_expression] = STATE(546),
    [sym_yield_expression] = STATE(550),
    [sym_object] = STATE(539),
    [sym_object_pattern] = STATE(1320),
    [sym_array] = STATE(539),
    [sym_array_pattern] = STATE(1320),
    [sym_jsx_element] = STATE(550),
    [sym_jsx_fragment] = STATE(550),
    [sym_jsx_opening_element] = STATE(772),
    [sym_jsx_self_closing_element] = STATE(550),
    [sym_class] = STATE(539),
    [sym_class_declaration] = STATE(275),
    [sym_function] = STATE(539),
    [sym_function_declaration] = STATE(275),
    [sym_generator_function] = STATE(539),
    [sym_generator_function_declaration] = STATE(275),
    [sym_arrow_function] = STATE(539),
    [sym_call_expression] = STATE(539),
    [sym_new_expression] = STATE(550),
    [sym_await_expression] = STATE(550),
    [sym_member_expression] = STATE(362),
    [sym_subscript_expression] = STATE(362),
    [sym_assignment_expression] = STATE(550),
    [sym__augmented_assignment_lhs] = STATE(720),
    [sym_augmented_assignment_expression] = STATE(550),
    [sym__destructuring_pattern] = STATE(1320),
    [sym_ternary_expression] = STATE(550),
    [sym_binary_expression] = STATE(550),
    [sym_unary_expression] = STATE(550),
    [sym_update_expression] = STATE(550),
    [sym_sequence_expression] = STATE(1156),
    [sym_string] = STATE(539),
    [sym_template_string] = STATE(539),
    [sym_regex] = STATE(539),
    [sym_meta_property] = STATE(539),
    [sym_decorator] = STATE(750),
    [sym_formal_parameters] = STATE(1318),
    [aux_sym_export_statement_repeat1] = STATE(891),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_import] = ACTIONS(15),
    [anon_sym_var] = ACTIONS(17),
    [anon_sym_let] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(19),
    [anon_sym_if] = ACTIONS(21),
    [anon_sym_switch] = ACTIONS(23),
    [anon_sym_for] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(29),
    [anon_sym_while] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(33),
    [anon_sym_try] = ACTIONS(35),
    [anon_sym_with] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_debugger] = ACTIONS(43),
    [anon_sym_return] = ACTIONS(45),
    [anon_sym_throw] = ACTIONS(47),
    [anon_sym_SEMI] = ACTIONS(49),
    [anon_sym_yield] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(53),
    [anon_sym_LT] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(59),
    [anon_sym_async] = ACTIONS(61),
    [anon_sym_function] = ACTIONS(63),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_typeof] = ACTIONS(71),
    [anon_sym_void] = ACTIONS(71),
    [anon_sym_delete] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DQUOTE] = ACTIONS(75),
    [anon_sym_SQUOTE] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(79),
    [sym_number] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(83),
    [sym_true] = ACTIONS(83),
    [sym_false] = ACTIONS(83),
    [sym_null] = ACTIONS(83),
    [sym_undefined] = ACTIONS(83),
    [anon_sym_AT] = ACTIONS(85),
    [anon_sym_static] = ACTIONS(87),
    [anon_sym_get] = ACTIONS(87),
    [anon_sym_set] = ACTIONS(87),
  },
  [44] = {
    [sym_import] = STATE(426),
    [sym_parenthesized_expression] = STATE(355),
    [sym_expression] = STATE(404),
    [sym_primary_expression] = STATE(425),
    [sym_yield_expression] = STATE(424),
    [sym_object] = STATE(426),
    [sym_object_pattern] = STATE(1333),
    [sym_array] = STATE(426),
    [sym_array_pattern] = STATE(1333),
    [sym_jsx_element] = STATE(424),
    [sym_jsx_fragment] = STATE(424),
    [sym_jsx_opening_element] = STATE(768),
    [sym_jsx_self_closing_element] = STATE(424),
    [sym_class] = STATE(426),
    [sym_function] = STATE(426),
    [sym_generator_function] = STATE(426),
    [sym_arrow_function] = STATE(426),
    [sym_call_expression] = STATE(426),
    [sym_new_expression] = STATE(424),
    [sym_await_expression] = STATE(424),
    [sym_member_expression] = STATE(355),
    [sym_subscript_expression] = STATE(355),
    [sym_assignment_expression] = STATE(424),
    [sym__augmented_assignment_lhs] = STATE(714),
    [sym_augmented_assignment_expression] = STATE(424),
    [sym__destructuring_pattern] = STATE(1333),
    [sym_ternary_expression] = STATE(424),
    [sym_binary_expression] = STATE(424),
    [sym_unary_expression] = STATE(424),
    [sym_update_expression] = STATE(424),
    [sym_string] = STATE(426),
    [sym_template_string] = STATE(426),
    [sym_regex] = STATE(426),
    [sym_meta_property] = STATE(426),
    [sym_decorator] = STATE(750),
    [sym_formal_parameters] = STATE(1322),
    [aux_sym_export_statement_repeat1] = STATE(924),
    [sym_identifier] = ACTIONS(321),
    [anon_sym_export] = ACTIONS(323),
    [anon_sym_STAR] = ACTIONS(325),
    [anon_sym_LBRACE] = ACTIONS(327),
    [anon_sym_COMMA] = ACTIONS(329),
    [anon_sym_RBRACE] = ACTIONS(329),
    [anon_sym_import] = ACTIONS(331),
    [anon_sym_LPAREN] = ACTIONS(333),
    [anon_sym_RPAREN] = ACTIONS(329),
    [anon_sym_await] = ACTIONS(335),
    [anon_sym_in] = ACTIONS(337),
    [anon_sym_COLON] = ACTIONS(329),
    [anon_sym_yield] = ACTIONS(339),
    [anon_sym_LBRACK] = ACTIONS(341),
    [anon_sym_RBRACK] = ACTIONS(329),
    [anon_sym_LT] = ACTIONS(343),
    [anon_sym_GT] = ACTIONS(337),
    [anon_sym_SLASH] = ACTIONS(345),
    [anon_sym_DOT] = ACTIONS(337),
    [anon_sym_class] = ACTIONS(347),
    [anon_sym_async] = ACTIONS(349),
    [anon_sym_function] = ACTIONS(351),
    [anon_sym_QMARK_DOT] = ACTIONS(329),
    [anon_sym_new] = ACTIONS(353),
    [anon_sym_QMARK] = ACTIONS(337),
    [anon_sym_AMP_AMP] = ACTIONS(329),
    [anon_sym_PIPE_PIPE] = ACTIONS(329),
    [anon_sym_GT_GT] = ACTIONS(337),
    [anon_sym_GT_GT_GT] = ACTIONS(329),
    [anon_sym_LT_LT] = ACTIONS(329),
    [anon_sym_AMP] = ACTIONS(337),
    [anon_sym_CARET] = ACTIONS(329),
    [anon_sym_PIPE] = ACTIONS(337),
    [anon_sym_PLUS] = ACTIONS(355),
    [anon_sym_DASH] = ACTIONS(355),
    [anon_sym_PERCENT] = ACTIONS(329),
    [anon_sym_STAR_STAR] = ACTIONS(329),
    [anon_sym_LT_EQ] = ACTIONS(329),
    [anon_sym_EQ_EQ] = ACTIONS(337),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(329),
    [anon_sym_BANG_EQ] = ACTIONS(337),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(329),
    [anon_sym_GT_EQ] = ACTIONS(329),
    [anon_sym_QMARK_QMARK] = ACTIONS(329),
    [anon_sym_instanceof] = ACTIONS(337),
    [anon_sym_BANG] = ACTIONS(355),
    [anon_sym_TILDE] = ACTIONS(357),
    [anon_sym_typeof] = ACTIONS(359),
    [anon_sym_void] = ACTIONS(359),
    [anon_sym_delete] = ACTIONS(359),
    [anon_sym_PLUS_PLUS] = ACTIONS(361),
    [anon_sym_DASH_DASH] = ACTIONS(361),
    [anon_sym_DQUOTE] = ACTIONS(363),
    [anon_sym_SQUOTE] = ACTIONS(365),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(367),
    [sym_number] = ACTIONS(369),
    [sym_this] = ACTIONS(371),
    [sym_super] = ACTIONS(371),
    [sym_true] = ACTIONS(371),
    [sym_false] = ACTIONS(371),
    [sym_null] = ACTIONS(371),
    [sym_undefined] = ACTIONS(371),
    [anon_sym_AT] = ACTIONS(85),
    [anon_sym_static] = ACTIONS(323),
    [anon_sym_get] = ACTIONS(323),
    [anon_sym_set] = ACTIONS(323),
  },
  [45] = {
    [sym_import] = STATE(539),
    [sym_parenthesized_expression] = STATE(362),
    [sym_expression] = STATE(475),
    [sym_primary_expression] = STATE(546),
    [sym_yield_expression] = STATE(550),
    [sym_object] = STATE(539),
    [sym_object_pattern] = STATE(1320),
    [sym_array] = STATE(539),
    [sym_array_pattern] = STATE(1320),
    [sym_jsx_element] = STATE(550),
    [sym_jsx_fragment] = STATE(550),
    [sym_jsx_opening_element] = STATE(772),
    [sym_jsx_self_closing_element] = STATE(550),
    [sym_class] = STATE(539),
    [sym_function] = STATE(539),
    [sym_generator_function] = STATE(539),
    [sym_arrow_function] = STATE(539),
    [sym_call_expression] = STATE(539),
    [sym_new_expression] = STATE(550),
    [sym_await_expression] = STATE(550),
    [sym_member_expression] = STATE(362),
    [sym_subscript_expression] = STATE(362),
    [sym_assignment_expression] = STATE(550),
    [sym__augmented_assignment_lhs] = STATE(720),
    [sym_augmented_assignment_expression] = STATE(550),
    [sym__destructuring_pattern] = STATE(1320),
    [sym_ternary_expression] = STATE(550),
    [sym_binary_expression] = STATE(550),
    [sym_unary_expression] = STATE(550),
    [sym_update_expression] = STATE(550),
    [sym_string] = STATE(539),
    [sym_template_string] = STATE(539),
    [sym_regex] = STATE(539),
    [sym_meta_property] = STATE(539),
    [sym_decorator] = STATE(750),
    [sym_formal_parameters] = STATE(1318),
    [aux_sym_export_statement_repeat1] = STATE(925),
    [sym_identifier] = ACTIONS(373),
    [anon_sym_export] = ACTIONS(375),
    [anon_sym_STAR] = ACTIONS(377),
    [anon_sym_LBRACE] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(329),
    [anon_sym_RBRACE] = ACTIONS(329),
    [anon_sym_import] = ACTIONS(381),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(29),
    [anon_sym_in] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(329),
    [anon_sym_yield] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(53),
    [anon_sym_LT] = ACTIONS(383),
    [anon_sym_GT] = ACTIONS(337),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_DOT] = ACTIONS(337),
    [anon_sym_class] = ACTIONS(385),
    [anon_sym_async] = ACTIONS(387),
    [anon_sym_function] = ACTIONS(389),
    [anon_sym_QMARK_DOT] = ACTIONS(329),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_QMARK] = ACTIONS(337),
    [anon_sym_AMP_AMP] = ACTIONS(329),
    [anon_sym_PIPE_PIPE] = ACTIONS(329),
    [anon_sym_GT_GT] = ACTIONS(337),
    [anon_sym_GT_GT_GT] = ACTIONS(329),
    [anon_sym_LT_LT] = ACTIONS(329),
    [anon_sym_AMP] = ACTIONS(337),
    [anon_sym_CARET] = ACTIONS(329),
    [anon_sym_PIPE] = ACTIONS(337),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_PERCENT] = ACTIONS(329),
    [anon_sym_STAR_STAR] = ACTIONS(329),
    [anon_sym_LT_EQ] = ACTIONS(329),
    [anon_sym_EQ_EQ] = ACTIONS(337),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(329),
    [anon_sym_BANG_EQ] = ACTIONS(337),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(329),
    [anon_sym_GT_EQ] = ACTIONS(329),
    [anon_sym_QMARK_QMARK] = ACTIONS(329),
    [anon_sym_instanceof] = ACTIONS(337),
    [anon_sym_BANG] = ACTIONS(67),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_typeof] = ACTIONS(71),
    [anon_sym_void] = ACTIONS(71),
    [anon_sym_delete] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DQUOTE] = ACTIONS(75),
    [anon_sym_SQUOTE] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(79),
    [sym_number] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(83),
    [sym_true] = ACTIONS(83),
    [sym_false] = ACTIONS(83),
    [sym_null] = ACTIONS(83),
    [sym_undefined] = ACTIONS(83),
    [anon_sym_AT] = ACTIONS(85),
    [anon_sym_static] = ACTIONS(375),
    [anon_sym_get] = ACTIONS(375),
    [anon_sym_set] = ACTIONS(375),
    [sym__automatic_semicolon] = ACTIONS(329),
  },
  [46] = {
    [sym_import] = STATE(426),
    [sym_parenthesized_expression] = STATE(340),
    [sym_expression] = STATE(574),
    [sym_primary_expression] = STATE(425),
    [sym_yield_expression] = STATE(424),
    [sym_object] = STATE(426),
    [sym_object_pattern] = STATE(1317),
    [sym_array] = STATE(426),
    [sym_array_pattern] = STATE(1317),
    [sym_jsx_element] = STATE(424),
    [sym_jsx_fragment] = STATE(424),
    [sym_jsx_opening_element] = STATE(768),
    [sym_jsx_self_closing_element] = STATE(424),
    [sym_class] = STATE(426),
    [sym_function] = STATE(426),
    [sym_generator_function] = STATE(426),
    [sym_arrow_function] = STATE(426),
    [sym_call_expression] = STATE(426),
    [sym_new_expression] = STATE(424),
    [sym_await_expression] = STATE(424),
    [sym_member_expression] = STATE(340),
    [sym_subscript_expression] = STATE(340),
    [sym_assignment_expression] = STATE(424),
    [sym__augmented_assignment_lhs] = STATE(712),
    [sym_augmented_assignment_expression] = STATE(424),
    [sym__destructuring_pattern] = STATE(1317),
    [sym_ternary_expression] = STATE(424),
    [sym_binary_expression] = STATE(424),
    [sym_unary_expression] = STATE(424),
    [sym_update_expression] = STATE(424),
    [sym_string] = STATE(426),
    [sym_template_string] = STATE(426),
    [sym_regex] = STATE(426),
    [sym_meta_property] = STATE(426),
    [sym_decorator] = STATE(750),
    [sym_formal_parameters] = STATE(1267),
    [aux_sym_export_statement_repeat1] = STATE(924),
    [sym_identifier] = ACTIONS(391),
    [anon_sym_export] = ACTIONS(393),
    [anon_sym_STAR] = ACTIONS(395),
    [anon_sym_LBRACE] = ACTIONS(397),
    [anon_sym_import] = ACTIONS(331),
    [anon_sym_LPAREN] = ACTIONS(333),
    [anon_sym_await] = ACTIONS(399),
    [anon_sym_in] = ACTIONS(337),
    [anon_sym_COLON] = ACTIONS(329),
    [anon_sym_yield] = ACTIONS(401),
    [anon_sym_LBRACK] = ACTIONS(403),
    [anon_sym_LT] = ACTIONS(343),
    [anon_sym_GT] = ACTIONS(337),
    [anon_sym_SLASH] = ACTIONS(345),
    [anon_sym_DOT] = ACTIONS(337),
    [anon_sym_class] = ACTIONS(347),
    [anon_sym_async] = ACTIONS(405),
    [anon_sym_function] = ACTIONS(351),
    [anon_sym_QMARK_DOT] = ACTIONS(329),
    [anon_sym_new] = ACTIONS(407),
    [anon_sym_QMARK] = ACTIONS(337),
    [anon_sym_AMP_AMP] = ACTIONS(329),
    [anon_sym_PIPE_PIPE] = ACTIONS(329),
    [anon_sym_GT_GT] = ACTIONS(337),
    [anon_sym_GT_GT_GT] = ACTIONS(329),
    [anon_sym_LT_LT] = ACTIONS(329),
    [anon_sym_AMP] = ACTIONS(337),
    [anon_sym_CARET] = ACTIONS(329),
    [anon_sym_PIPE] = ACTIONS(337),
    [anon_sym_PLUS] = ACTIONS(409),
    [anon_sym_DASH] = ACTIONS(409),
    [anon_sym_PERCENT] = ACTIONS(329),
    [anon_sym_STAR_STAR] = ACTIONS(329),
    [anon_sym_LT_EQ] = ACTIONS(329),
    [anon_sym_EQ_EQ] = ACTIONS(337),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(329),
    [anon_sym_BANG_EQ] = ACTIONS(337),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(329),
    [anon_sym_GT_EQ] = ACTIONS(329),
    [anon_sym_QMARK_QMARK] = ACTIONS(329),
    [anon_sym_instanceof] = ACTIONS(337),
    [anon_sym_BANG] = ACTIONS(409),
    [anon_sym_TILDE] = ACTIONS(411),
    [anon_sym_typeof] = ACTIONS(413),
    [anon_sym_void] = ACTIONS(413),
    [anon_sym_delete] = ACTIONS(413),
    [anon_sym_PLUS_PLUS] = ACTIONS(415),
    [anon_sym_DASH_DASH] = ACTIONS(415),
    [anon_sym_DQUOTE] = ACTIONS(363),
    [anon_sym_SQUOTE] = ACTIONS(365),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(367),
    [sym_number] = ACTIONS(369),
    [sym_this] = ACTIONS(371),
    [sym_super] = ACTIONS(371),
    [sym_true] = ACTIONS(371),
    [sym_false] = ACTIONS(371),
    [sym_null] = ACTIONS(371),
    [sym_undefined] = ACTIONS(371),
    [anon_sym_AT] = ACTIONS(85),
    [anon_sym_static] = ACTIONS(393),
    [anon_sym_get] = ACTIONS(393),
    [anon_sym_set] = ACTIONS(393),
  },
  [47] = {
    [ts_builtin_sym_end] = ACTIONS(417),
    [sym_identifier] = ACTIONS(419),
    [anon_sym_export] = ACTIONS(419),
    [anon_sym_STAR] = ACTIONS(421),
    [anon_sym_default] = ACTIONS(419),
    [anon_sym_LBRACE] = ACTIONS(417),
    [anon_sym_COMMA] = ACTIONS(423),
    [anon_sym_RBRACE] = ACTIONS(417),
    [anon_sym_import] = ACTIONS(419),
    [anon_sym_var] = ACTIONS(419),
    [anon_sym_let] = ACTIONS(419),
    [anon_sym_const] = ACTIONS(419),
    [anon_sym_else] = ACTIONS(419),
    [anon_sym_if] = ACTIONS(419),
    [anon_sym_switch] = ACTIONS(419),
    [anon_sym_for] = ACTIONS(419),
    [anon_sym_LPAREN] = ACTIONS(417),
    [anon_sym_await] = ACTIONS(419),
    [anon_sym_in] = ACTIONS(421),
    [anon_sym_while] = ACTIONS(419),
    [anon_sym_do] = ACTIONS(419),
    [anon_sym_try] = ACTIONS(419),
    [anon_sym_with] = ACTIONS(419),
    [anon_sym_break] = ACTIONS(419),
    [anon_sym_continue] = ACTIONS(419),
    [anon_sym_debugger] = ACTIONS(419),
    [anon_sym_return] = ACTIONS(419),
    [anon_sym_throw] = ACTIONS(419),
    [anon_sym_SEMI] = ACTIONS(417),
    [anon_sym_case] = ACTIONS(419),
    [anon_sym_yield] = ACTIONS(419),
    [anon_sym_EQ] = ACTIONS(425),
    [anon_sym_LBRACK] = ACTIONS(417),
    [anon_sym_LT] = ACTIONS(419),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_SLASH] = ACTIONS(419),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(419),
    [anon_sym_async] = ACTIONS(419),
    [anon_sym_function] = ACTIONS(419),
    [anon_sym_QMARK_DOT] = ACTIONS(423),
    [anon_sym_new] = ACTIONS(419),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_AMP_AMP] = ACTIONS(423),
    [anon_sym_PIPE_PIPE] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(421),
    [anon_sym_GT_GT_GT] = ACTIONS(423),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_CARET] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_PLUS] = ACTIONS(419),
    [anon_sym_DASH] = ACTIONS(419),
    [anon_sym_PERCENT] = ACTIONS(423),
    [anon_sym_STAR_STAR] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_BANG_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(423),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_QMARK_QMARK] = ACTIONS(423),
    [anon_sym_instanceof] = ACTIONS(421),
    [anon_sym_BANG] = ACTIONS(419),
    [anon_sym_TILDE] = ACTIONS(417),
    [anon_sym_typeof] = ACTIONS(419),
    [anon_sym_void] = ACTIONS(419),
    [anon_sym_delete] = ACTIONS(419),
    [anon_sym_PLUS_PLUS] = ACTIONS(417),
    [anon_sym_DASH_DASH] = ACTIONS(417),
    [anon_sym_DQUOTE] = ACTIONS(417),
    [anon_sym_SQUOTE] = ACTIONS(417),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_number] = ACTIONS(417),
    [sym_this] = ACTIONS(419),
    [sym_super] = ACTIONS(419),
    [sym_true] = ACTIONS(419),
    [sym_false] = ACTIONS(419),
    [sym_null] = ACTIONS(419),
    [sym_undefined] = ACTIONS(419),
    [anon_sym_AT] = ACTIONS(417),
    [anon_sym_static] = ACTIONS(419),
    [anon_sym_get] = ACTIONS(419),
    [anon_sym_set] = ACTIONS(419),
    [sym__automatic_semicolon] = ACTIONS(427),
  },
  [48] = {
    [ts_builtin_sym_end] = ACTIONS(429),
    [sym_identifier] = ACTIONS(431),
    [anon_sym_export] = ACTIONS(431),
    [anon_sym_STAR] = ACTIONS(433),
    [anon_sym_default] = ACTIONS(431),
    [anon_sym_LBRACE] = ACTIONS(429),
    [anon_sym_COMMA] = ACTIONS(435),
    [anon_sym_RBRACE] = ACTIONS(429),
    [anon_sym_import] = ACTIONS(431),
    [anon_sym_var] = ACTIONS(431),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_const] = ACTIONS(431),
    [anon_sym_else] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(431),
    [anon_sym_switch] = ACTIONS(431),
    [anon_sym_for] = ACTIONS(431),
    [anon_sym_LPAREN] = ACTIONS(429),
    [anon_sym_await] = ACTIONS(431),
    [anon_sym_in] = ACTIONS(433),
    [anon_sym_while] = ACTIONS(431),
    [anon_sym_do] = ACTIONS(431),
    [anon_sym_try] = ACTIONS(431),
    [anon_sym_with] = ACTIONS(431),
    [anon_sym_break] = ACTIONS(431),
    [anon_sym_continue] = ACTIONS(431),
    [anon_sym_debugger] = ACTIONS(431),
    [anon_sym_return] = ACTIONS(431),
    [anon_sym_throw] = ACTIONS(431),
    [anon_sym_SEMI] = ACTIONS(429),
    [anon_sym_case] = ACTIONS(431),
    [anon_sym_yield] = ACTIONS(431),
    [anon_sym_LBRACK] = ACTIONS(429),
    [anon_sym_LT] = ACTIONS(431),
    [anon_sym_GT] = ACTIONS(433),
    [anon_sym_SLASH] = ACTIONS(431),
    [anon_sym_DOT] = ACTIONS(433),
    [anon_sym_class] = ACTIONS(431),
    [anon_sym_async] = ACTIONS(431),
    [anon_sym_function] = ACTIONS(431),
    [anon_sym_QMARK_DOT] = ACTIONS(435),
    [anon_sym_new] = ACTIONS(431),
    [anon_sym_QMARK] = ACTIONS(433),
    [anon_sym_AMP_AMP] = ACTIONS(435),
    [anon_sym_PIPE_PIPE] = ACTIONS(435),
    [anon_sym_GT_GT] = ACTIONS(433),
    [anon_sym_GT_GT_GT] = ACTIONS(435),
    [anon_sym_LT_LT] = ACTIONS(435),
    [anon_sym_AMP] = ACTIONS(433),
    [anon_sym_CARET] = ACTIONS(435),
    [anon_sym_PIPE] = ACTIONS(433),
    [anon_sym_PLUS] = ACTIONS(431),
    [anon_sym_DASH] = ACTIONS(431),
    [anon_sym_PERCENT] = ACTIONS(435),
    [anon_sym_STAR_STAR] = ACTIONS(435),
    [anon_sym_LT_EQ] = ACTIONS(435),
    [anon_sym_EQ_EQ] = ACTIONS(433),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(435),
    [anon_sym_BANG_EQ] = ACTIONS(433),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(435),
    [anon_sym_GT_EQ] = ACTIONS(435),
    [anon_sym_QMARK_QMARK] = ACTIONS(435),
    [anon_sym_instanceof] = ACTIONS(433),
    [anon_sym_BANG] = ACTIONS(431),
    [anon_sym_TILDE] = ACTIONS(429),
    [anon_sym_typeof] = ACTIONS(431),
    [anon_sym_void] = ACTIONS(431),
    [anon_sym_delete] = ACTIONS(431),
    [anon_sym_PLUS_PLUS] = ACTIONS(429),
    [anon_sym_DASH_DASH] = ACTIONS(429),
    [anon_sym_DQUOTE] = ACTIONS(429),
    [anon_sym_SQUOTE] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(429),
    [sym_number] = ACTIONS(429),
    [sym_this] = ACTIONS(431),
    [sym_super] = ACTIONS(431),
    [sym_true] = ACTIONS(431),
    [sym_false] = ACTIONS(431),
    [sym_null] = ACTIONS(431),
    [sym_undefined] = ACTIONS(431),
    [anon_sym_AT] = ACTIONS(429),
    [anon_sym_static] = ACTIONS(431),
    [anon_sym_get] = ACTIONS(431),
    [anon_sym_set] = ACTIONS(431),
    [sym__automatic_semicolon] = ACTIONS(437),
  },
  [49] = {
    [ts_builtin_sym_end] = ACTIONS(439),
    [sym_identifier] = ACTIONS(441),
    [anon_sym_export] = ACTIONS(441),
    [anon_sym_STAR] = ACTIONS(443),
    [anon_sym_default] = ACTIONS(441),
    [anon_sym_LBRACE] = ACTIONS(439),
    [anon_sym_COMMA] = ACTIONS(445),
    [anon_sym_RBRACE] = ACTIONS(439),
    [anon_sym_import] = ACTIONS(441),
    [anon_sym_var] = ACTIONS(441),
    [anon_sym_let] = ACTIONS(441),
    [anon_sym_const] = ACTIONS(441),
    [anon_sym_else] = ACTIONS(441),
    [anon_sym_if] = ACTIONS(441),
    [anon_sym_switch] = ACTIONS(441),
    [anon_sym_for] = ACTIONS(441),
    [anon_sym_LPAREN] = ACTIONS(439),
    [anon_sym_await] = ACTIONS(441),
    [anon_sym_in] = ACTIONS(443),
    [anon_sym_while] = ACTIONS(441),
    [anon_sym_do] = ACTIONS(441),
    [anon_sym_try] = ACTIONS(441),
    [anon_sym_with] = ACTIONS(441),
    [anon_sym_break] = ACTIONS(441),
    [anon_sym_continue] = ACTIONS(441),
    [anon_sym_debugger] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(441),
    [anon_sym_throw] = ACTIONS(441),
    [anon_sym_SEMI] = ACTIONS(439),
    [anon_sym_case] = ACTIONS(441),
    [anon_sym_yield] = ACTIONS(441),
    [anon_sym_LBRACK] = ACTIONS(439),
    [anon_sym_LT] = ACTIONS(441),
    [anon_sym_GT] = ACTIONS(443),
    [anon_sym_SLASH] = ACTIONS(441),
    [anon_sym_DOT] = ACTIONS(443),
    [anon_sym_class] = ACTIONS(441),
    [anon_sym_async] = ACTIONS(441),
    [anon_sym_function] = ACTIONS(441),
    [anon_sym_QMARK_DOT] = ACTIONS(445),
    [anon_sym_new] = ACTIONS(441),
    [anon_sym_QMARK] = ACTIONS(443),
    [anon_sym_AMP_AMP] = ACTIONS(445),
    [anon_sym_PIPE_PIPE] = ACTIONS(445),
    [anon_sym_GT_GT] = ACTIONS(443),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(443),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(443),
    [anon_sym_PLUS] = ACTIONS(441),
    [anon_sym_DASH] = ACTIONS(441),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ] = ACTIONS(443),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ] = ACTIONS(443),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(445),
    [anon_sym_GT_EQ] = ACTIONS(445),
    [anon_sym_QMARK_QMARK] = ACTIONS(445),
    [anon_sym_instanceof] = ACTIONS(443),
    [anon_sym_BANG] = ACTIONS(441),
    [anon_sym_TILDE] = ACTIONS(439),
    [anon_sym_typeof] = ACTIONS(441),
    [anon_sym_void] = ACTIONS(441),
    [anon_sym_delete] = ACTIONS(441),
    [anon_sym_PLUS_PLUS] = ACTIONS(439),
    [anon_sym_DASH_DASH] = ACTIONS(439),
    [anon_sym_DQUOTE] = ACTIONS(439),
    [anon_sym_SQUOTE] = ACTIONS(439),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(439),
    [sym_number] = ACTIONS(439),
    [sym_this] = ACTIONS(441),
    [sym_super] = ACTIONS(441),
    [sym_true] = ACTIONS(441),
    [sym_false] = ACTIONS(441),
    [sym_null] = ACTIONS(441),
    [sym_undefined] = ACTIONS(441),
    [anon_sym_AT] = ACTIONS(439),
    [anon_sym_static] = ACTIONS(441),
    [anon_sym_get] = ACTIONS(441),
    [anon_sym_set] = ACTIONS(441),
    [sym__automatic_semicolon] = ACTIONS(447),
  },
  [50] = {
    [ts_builtin_sym_end] = ACTIONS(449),
    [sym_identifier] = ACTIONS(451),
    [anon_sym_export] = ACTIONS(451),
    [anon_sym_STAR] = ACTIONS(451),
    [anon_sym_default] = ACTIONS(451),
    [anon_sym_LBRACE] = ACTIONS(449),
    [anon_sym_COMMA] = ACTIONS(449),
    [anon_sym_RBRACE] = ACTIONS(449),
    [anon_sym_import] = ACTIONS(451),
    [anon_sym_var] = ACTIONS(451),
    [anon_sym_let] = ACTIONS(451),
    [anon_sym_const] = ACTIONS(451),
    [anon_sym_else] = ACTIONS(451),
    [anon_sym_if] = ACTIONS(451),
    [anon_sym_switch] = ACTIONS(451),
    [anon_sym_for] = ACTIONS(451),
    [anon_sym_LPAREN] = ACTIONS(449),
    [anon_sym_await] = ACTIONS(451),
    [anon_sym_in] = ACTIONS(451),
    [anon_sym_while] = ACTIONS(451),
    [anon_sym_do] = ACTIONS(451),
    [anon_sym_try] = ACTIONS(451),
    [anon_sym_with] = ACTIONS(451),
    [anon_sym_break] = ACTIONS(451),
    [anon_sym_continue] = ACTIONS(451),
    [anon_sym_debugger] = ACTIONS(451),
    [anon_sym_return] = ACTIONS(451),
    [anon_sym_throw] = ACTIONS(451),
    [anon_sym_SEMI] = ACTIONS(449),
    [anon_sym_case] = ACTIONS(451),
    [anon_sym_yield] = ACTIONS(451),
    [anon_sym_LBRACK] = ACTIONS(449),
    [anon_sym_LT] = ACTIONS(451),
    [anon_sym_GT] = ACTIONS(451),
    [anon_sym_SLASH] = ACTIONS(451),
    [anon_sym_DOT] = ACTIONS(451),
    [anon_sym_class] = ACTIONS(451),
    [anon_sym_async] = ACTIONS(451),
    [anon_sym_function] = ACTIONS(451),
    [anon_sym_QMARK_DOT] = ACTIONS(449),
    [anon_sym_new] = ACTIONS(451),
    [anon_sym_QMARK] = ACTIONS(451),
    [anon_sym_AMP_AMP] = ACTIONS(449),
    [anon_sym_PIPE_PIPE] = ACTIONS(449),
    [anon_sym_GT_GT] = ACTIONS(451),
    [anon_sym_GT_GT_GT] = ACTIONS(449),
    [anon_sym_LT_LT] = ACTIONS(449),
    [anon_sym_AMP] = ACTIONS(451),
    [anon_sym_CARET] = ACTIONS(449),
    [anon_sym_PIPE] = ACTIONS(451),
    [anon_sym_PLUS] = ACTIONS(451),
    [anon_sym_DASH] = ACTIONS(451),
    [anon_sym_PERCENT] = ACTIONS(449),
    [anon_sym_STAR_STAR] = ACTIONS(449),
    [anon_sym_LT_EQ] = ACTIONS(449),
    [anon_sym_EQ_EQ] = ACTIONS(451),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(449),
    [anon_sym_BANG_EQ] = ACTIONS(451),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(449),
    [anon_sym_GT_EQ] = ACTIONS(449),
    [anon_sym_QMARK_QMARK] = ACTIONS(449),
    [anon_sym_instanceof] = ACTIONS(451),
    [anon_sym_BANG] = ACTIONS(451),
    [anon_sym_TILDE] = ACTIONS(449),
    [anon_sym_typeof] = ACTIONS(451),
    [anon_sym_void] = ACTIONS(451),
    [anon_sym_delete] = ACTIONS(451),
    [anon_sym_PLUS_PLUS] = ACTIONS(449),
    [anon_sym_DASH_DASH] = ACTIONS(449),
    [anon_sym_DQUOTE] = ACTIONS(449),
    [anon_sym_SQUOTE] = ACTIONS(449),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(449),
    [sym_number] = ACTIONS(449),
    [sym_this] = ACTIONS(451),
    [sym_super] = ACTIONS(451),
    [sym_true] = ACTIONS(451),
    [sym_false] = ACTIONS(451),
    [sym_null] = ACTIONS(451),
    [sym_undefined] = ACTIONS(451),
    [anon_sym_AT] = ACTIONS(449),
    [anon_sym_static] = ACTIONS(451),
    [anon_sym_get] = ACTIONS(451),
    [anon_sym_set] = ACTIONS(451),
    [sym__automatic_semicolon] = ACTIONS(449),
  },
  [51] = {
    [ts_builtin_sym_end] = ACTIONS(417),
    [sym_identifier] = ACTIONS(419),
    [anon_sym_export] = ACTIONS(419),
    [anon_sym_STAR] = ACTIONS(419),
    [anon_sym_default] = ACTIONS(419),
    [anon_sym_LBRACE] = ACTIONS(417),
    [anon_sym_COMMA] = ACTIONS(417),
    [anon_sym_RBRACE] = ACTIONS(417),
    [anon_sym_import] = ACTIONS(419),
    [anon_sym_var] = ACTIONS(419),
    [anon_sym_let] = ACTIONS(419),
    [anon_sym_const] = ACTIONS(419),
    [anon_sym_else] = ACTIONS(419),
    [anon_sym_if] = ACTIONS(419),
    [anon_sym_switch] = ACTIONS(419),
    [anon_sym_for] = ACTIONS(419),
    [anon_sym_LPAREN] = ACTIONS(417),
    [anon_sym_await] = ACTIONS(419),
    [anon_sym_in] = ACTIONS(419),
    [anon_sym_while] = ACTIONS(419),
    [anon_sym_do] = ACTIONS(419),
    [anon_sym_try] = ACTIONS(419),
    [anon_sym_with] = ACTIONS(419),
    [anon_sym_break] = ACTIONS(419),
    [anon_sym_continue] = ACTIONS(419),
    [anon_sym_debugger] = ACTIONS(419),
    [anon_sym_return] = ACTIONS(419),
    [anon_sym_throw] = ACTIONS(419),
    [anon_sym_SEMI] = ACTIONS(417),
    [anon_sym_case] = ACTIONS(419),
    [anon_sym_yield] = ACTIONS(419),
    [anon_sym_LBRACK] = ACTIONS(417),
    [anon_sym_LT] = ACTIONS(419),
    [anon_sym_GT] = ACTIONS(419),
    [anon_sym_SLASH] = ACTIONS(419),
    [anon_sym_DOT] = ACTIONS(419),
    [anon_sym_class] = ACTIONS(419),
    [anon_sym_async] = ACTIONS(419),
    [anon_sym_function] = ACTIONS(419),
    [anon_sym_QMARK_DOT] = ACTIONS(417),
    [anon_sym_new] = ACTIONS(419),
    [anon_sym_QMARK] = ACTIONS(419),
    [anon_sym_AMP_AMP] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(417),
    [anon_sym_GT_GT] = ACTIONS(419),
    [anon_sym_GT_GT_GT] = ACTIONS(417),
    [anon_sym_LT_LT] = ACTIONS(417),
    [anon_sym_AMP] = ACTIONS(419),
    [anon_sym_CARET] = ACTIONS(417),
    [anon_sym_PIPE] = ACTIONS(419),
    [anon_sym_PLUS] = ACTIONS(419),
    [anon_sym_DASH] = ACTIONS(419),
    [anon_sym_PERCENT] = ACTIONS(417),
    [anon_sym_STAR_STAR] = ACTIONS(417),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_EQ_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(417),
    [anon_sym_QMARK_QMARK] = ACTIONS(417),
    [anon_sym_instanceof] = ACTIONS(419),
    [anon_sym_BANG] = ACTIONS(419),
    [anon_sym_TILDE] = ACTIONS(417),
    [anon_sym_typeof] = ACTIONS(419),
    [anon_sym_void] = ACTIONS(419),
    [anon_sym_delete] = ACTIONS(419),
    [anon_sym_PLUS_PLUS] = ACTIONS(417),
    [anon_sym_DASH_DASH] = ACTIONS(417),
    [anon_sym_DQUOTE] = ACTIONS(417),
    [anon_sym_SQUOTE] = ACTIONS(417),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_number] = ACTIONS(417),
    [sym_this] = ACTIONS(419),
    [sym_super] = ACTIONS(419),
    [sym_true] = ACTIONS(419),
    [sym_false] = ACTIONS(419),
    [sym_null] = ACTIONS(419),
    [sym_undefined] = ACTIONS(419),
    [anon_sym_AT] = ACTIONS(417),
    [anon_sym_static] = ACTIONS(419),
    [anon_sym_get] = ACTIONS(419),
    [anon_sym_set] = ACTIONS(419),
    [sym__automatic_semicolon] = ACTIONS(453),
  },
  [52] = {
    [ts_builtin_sym_end] = ACTIONS(455),
    [sym_identifier] = ACTIONS(457),
    [anon_sym_export] = ACTIONS(457),
    [anon_sym_STAR] = ACTIONS(459),
    [anon_sym_default] = ACTIONS(457),
    [anon_sym_LBRACE] = ACTIONS(455),
    [anon_sym_COMMA] = ACTIONS(461),
    [anon_sym_RBRACE] = ACTIONS(455),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_var] = ACTIONS(457),
    [anon_sym_let] = ACTIONS(457),
    [anon_sym_const] = ACTIONS(457),
    [anon_sym_else] = ACTIONS(457),
    [anon_sym_if] = ACTIONS(457),
    [anon_sym_switch] = ACTIONS(457),
    [anon_sym_for] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_await] = ACTIONS(457),
    [anon_sym_in] = ACTIONS(459),
    [anon_sym_while] = ACTIONS(457),
    [anon_sym_do] = ACTIONS(457),
    [anon_sym_try] = ACTIONS(457),
    [anon_sym_with] = ACTIONS(457),
    [anon_sym_break] = ACTIONS(457),
    [anon_sym_continue] = ACTIONS(457),
    [anon_sym_debugger] = ACTIONS(457),
    [anon_sym_return] = ACTIONS(457),
    [anon_sym_throw] = ACTIONS(457),
    [anon_sym_SEMI] = ACTIONS(455),
    [anon_sym_case] = ACTIONS(457),
    [anon_sym_yield] = ACTIONS(457),
    [anon_sym_LBRACK] = ACTIONS(455),
    [anon_sym_LT] = ACTIONS(457),
    [anon_sym_GT] = ACTIONS(459),
    [anon_sym_SLASH] = ACTIONS(457),
    [anon_sym_DOT] = ACTIONS(459),
    [anon_sym_class] = ACTIONS(457),
    [anon_sym_async] = ACTIONS(457),
    [anon_sym_function] = ACTIONS(457),
    [anon_sym_QMARK_DOT] = ACTIONS(461),
    [anon_sym_new] = ACTIONS(457),
    [anon_sym_QMARK] = ACTIONS(459),
    [anon_sym_AMP_AMP] = ACTIONS(461),
    [anon_sym_PIPE_PIPE] = ACTIONS(461),
    [anon_sym_GT_GT] = ACTIONS(459),
    [anon_sym_GT_GT_GT] = ACTIONS(461),
    [anon_sym_LT_LT] = ACTIONS(461),
    [anon_sym_AMP] = ACTIONS(459),
    [anon_sym_CARET] = ACTIONS(461),
    [anon_sym_PIPE] = ACTIONS(459),
    [anon_sym_PLUS] = ACTIONS(457),
    [anon_sym_DASH] = ACTIONS(457),
    [anon_sym_PERCENT] = ACTIONS(461),
    [anon_sym_STAR_STAR] = ACTIONS(461),
    [anon_sym_LT_EQ] = ACTIONS(461),
    [anon_sym_EQ_EQ] = ACTIONS(459),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(461),
    [anon_sym_BANG_EQ] = ACTIONS(459),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(461),
    [anon_sym_GT_EQ] = ACTIONS(461),
    [anon_sym_QMARK_QMARK] = ACTIONS(461),
    [anon_sym_instanceof] = ACTIONS(459),
    [anon_sym_BANG] = ACTIONS(457),
    [anon_sym_TILDE] = ACTIONS(455),
    [anon_sym_typeof] = ACTIONS(457),
    [anon_sym_void] = ACTIONS(457),
    [anon_sym_delete] = ACTIONS(457),
    [anon_sym_PLUS_PLUS] = ACTIONS(455),
    [anon_sym_DASH_DASH] = ACTIONS(455),
    [anon_sym_DQUOTE] = ACTIONS(455),
    [anon_sym_SQUOTE] = ACTIONS(455),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(455),
    [sym_number] = ACTIONS(455),
    [sym_this] = ACTIONS(457),
    [sym_super] = ACTIONS(457),
    [sym_true] = ACTIONS(457),
    [sym_false] = ACTIONS(457),
    [sym_null] = ACTIONS(457),
    [sym_undefined] = ACTIONS(457),
    [anon_sym_AT] = ACTIONS(455),
    [anon_sym_static] = ACTIONS(457),
    [anon_sym_get] = ACTIONS(457),
    [anon_sym_set] = ACTIONS(457),
    [sym__automatic_semicolon] = ACTIONS(463),
  },
  [53] = {
    [ts_builtin_sym_end] = ACTIONS(465),
    [sym_identifier] = ACTIONS(467),
    [anon_sym_export] = ACTIONS(467),
    [anon_sym_STAR] = ACTIONS(467),
    [anon_sym_default] = ACTIONS(467),
    [anon_sym_LBRACE] = ACTIONS(465),
    [anon_sym_COMMA] = ACTIONS(465),
    [anon_sym_RBRACE] = ACTIONS(465),
    [anon_sym_import] = ACTIONS(467),
    [anon_sym_var] = ACTIONS(467),
    [anon_sym_let] = ACTIONS(467),
    [anon_sym_const] = ACTIONS(467),
    [anon_sym_else] = ACTIONS(467),
    [anon_sym_if] = ACTIONS(467),
    [anon_sym_switch] = ACTIONS(467),
    [anon_sym_for] = ACTIONS(467),
    [anon_sym_LPAREN] = ACTIONS(465),
    [anon_sym_await] = ACTIONS(467),
    [anon_sym_in] = ACTIONS(467),
    [anon_sym_while] = ACTIONS(467),
    [anon_sym_do] = ACTIONS(467),
    [anon_sym_try] = ACTIONS(467),
    [anon_sym_with] = ACTIONS(467),
    [anon_sym_break] = ACTIONS(467),
    [anon_sym_continue] = ACTIONS(467),
    [anon_sym_debugger] = ACTIONS(467),
    [anon_sym_return] = ACTIONS(467),
    [anon_sym_throw] = ACTIONS(467),
    [anon_sym_SEMI] = ACTIONS(465),
    [anon_sym_case] = ACTIONS(467),
    [anon_sym_yield] = ACTIONS(467),
    [anon_sym_LBRACK] = ACTIONS(465),
    [anon_sym_LT] = ACTIONS(467),
    [anon_sym_GT] = ACTIONS(467),
    [anon_sym_SLASH] = ACTIONS(467),
    [anon_sym_DOT] = ACTIONS(467),
    [anon_sym_class] = ACTIONS(467),
    [anon_sym_async] = ACTIONS(467),
    [anon_sym_function] = ACTIONS(467),
    [anon_sym_QMARK_DOT] = ACTIONS(465),
    [anon_sym_new] = ACTIONS(467),
    [anon_sym_QMARK] = ACTIONS(467),
    [anon_sym_AMP_AMP] = ACTIONS(465),
    [anon_sym_PIPE_PIPE] = ACTIONS(465),
    [anon_sym_GT_GT] = ACTIONS(467),
    [anon_sym_GT_GT_GT] = ACTIONS(465),
    [anon_sym_LT_LT] = ACTIONS(465),
    [anon_sym_AMP] = ACTIONS(467),
    [anon_sym_CARET] = ACTIONS(465),
    [anon_sym_PIPE] = ACTIONS(467),
    [anon_sym_PLUS] = ACTIONS(467),
    [anon_sym_DASH] = ACTIONS(467),
    [anon_sym_PERCENT] = ACTIONS(465),
    [anon_sym_STAR_STAR] = ACTIONS(465),
    [anon_sym_LT_EQ] = ACTIONS(465),
    [anon_sym_EQ_EQ] = ACTIONS(467),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(465),
    [anon_sym_BANG_EQ] = ACTIONS(467),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(465),
    [anon_sym_GT_EQ] = ACTIONS(465),
    [anon_sym_QMARK_QMARK] = ACTIONS(465),
    [anon_sym_instanceof] = ACTIONS(467),
    [anon_sym_BANG] = ACTIONS(467),
    [anon_sym_TILDE] = ACTIONS(465),
    [anon_sym_typeof] = ACTIONS(467),
    [anon_sym_void] = ACTIONS(467),
    [anon_sym_delete] = ACTIONS(467),
    [anon_sym_PLUS_PLUS] = ACTIONS(465),
    [anon_sym_DASH_DASH] = ACTIONS(465),
    [anon_sym_DQUOTE] = ACTIONS(465),
    [anon_sym_SQUOTE] = ACTIONS(465),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(465),
    [sym_number] = ACTIONS(465),
    [sym_this] = ACTIONS(467),
    [sym_super] = ACTIONS(467),
    [sym_true] = ACTIONS(467),
    [sym_false] = ACTIONS(467),
    [sym_null] = ACTIONS(467),
    [sym_undefined] = ACTIONS(467),
    [anon_sym_AT] = ACTIONS(465),
    [anon_sym_static] = ACTIONS(467),
    [anon_sym_get] = ACTIONS(467),
    [anon_sym_set] = ACTIONS(467),
    [sym__automatic_semicolon] = ACTIONS(465),
  },
  [54] = {
    [ts_builtin_sym_end] = ACTIONS(469),
    [sym_identifier] = ACTIONS(471),
    [anon_sym_export] = ACTIONS(471),
    [anon_sym_STAR] = ACTIONS(473),
    [anon_sym_default] = ACTIONS(471),
    [anon_sym_LBRACE] = ACTIONS(469),
    [anon_sym_COMMA] = ACTIONS(475),
    [anon_sym_RBRACE] = ACTIONS(469),
    [anon_sym_import] = ACTIONS(471),
    [anon_sym_var] = ACTIONS(471),
    [anon_sym_let] = ACTIONS(471),
    [anon_sym_const] = ACTIONS(471),
    [anon_sym_else] = ACTIONS(471),
    [anon_sym_if] = ACTIONS(471),
    [anon_sym_switch] = ACTIONS(471),
    [anon_sym_for] = ACTIONS(471),
    [anon_sym_LPAREN] = ACTIONS(469),
    [anon_sym_await] = ACTIONS(471),
    [anon_sym_in] = ACTIONS(473),
    [anon_sym_while] = ACTIONS(471),
    [anon_sym_do] = ACTIONS(471),
    [anon_sym_try] = ACTIONS(471),
    [anon_sym_with] = ACTIONS(471),
    [anon_sym_break] = ACTIONS(471),
    [anon_sym_continue] = ACTIONS(471),
    [anon_sym_debugger] = ACTIONS(471),
    [anon_sym_return] = ACTIONS(471),
    [anon_sym_throw] = ACTIONS(471),
    [anon_sym_SEMI] = ACTIONS(469),
    [anon_sym_case] = ACTIONS(471),
    [anon_sym_yield] = ACTIONS(471),
    [anon_sym_LBRACK] = ACTIONS(469),
    [anon_sym_LT] = ACTIONS(471),
    [anon_sym_GT] = ACTIONS(473),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_DOT] = ACTIONS(473),
    [anon_sym_class] = ACTIONS(471),
    [anon_sym_async] = ACTIONS(471),
    [anon_sym_function] = ACTIONS(471),
    [anon_sym_QMARK_DOT] = ACTIONS(475),
    [anon_sym_new] = ACTIONS(471),
    [anon_sym_QMARK] = ACTIONS(473),
    [anon_sym_AMP_AMP] = ACTIONS(475),
    [anon_sym_PIPE_PIPE] = ACTIONS(475),
    [anon_sym_GT_GT] = ACTIONS(473),
    [anon_sym_GT_GT_GT] = ACTIONS(475),
    [anon_sym_LT_LT] = ACTIONS(475),
    [anon_sym_AMP] = ACTIONS(473),
    [anon_sym_CARET] = ACTIONS(475),
    [anon_sym_PIPE] = ACTIONS(473),
    [anon_sym_PLUS] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(471),
    [anon_sym_PERCENT] = ACTIONS(475),
    [anon_sym_STAR_STAR] = ACTIONS(475),
    [anon_sym_LT_EQ] = ACTIONS(475),
    [anon_sym_EQ_EQ] = ACTIONS(473),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(475),
    [anon_sym_BANG_EQ] = ACTIONS(473),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(475),
    [anon_sym_GT_EQ] = ACTIONS(475),
    [anon_sym_QMARK_QMARK] = ACTIONS(475),
    [anon_sym_instanceof] = ACTIONS(473),
    [anon_sym_BANG] = ACTIONS(471),
    [anon_sym_TILDE] = ACTIONS(469),
    [anon_sym_typeof] = ACTIONS(471),
    [anon_sym_void] = ACTIONS(471),
    [anon_sym_delete] = ACTIONS(471),
    [anon_sym_PLUS_PLUS] = ACTIONS(469),
    [anon_sym_DASH_DASH] = ACTIONS(469),
    [anon_sym_DQUOTE] = ACTIONS(469),
    [anon_sym_SQUOTE] = ACTIONS(469),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(469),
    [sym_number] = ACTIONS(469),
    [sym_this] = ACTIONS(471),
    [sym_super] = ACTIONS(471),
    [sym_true] = ACTIONS(471),
    [sym_false] = ACTIONS(471),
    [sym_null] = ACTIONS(471),
    [sym_undefined] = ACTIONS(471),
    [anon_sym_AT] = ACTIONS(469),
    [anon_sym_static] = ACTIONS(471),
    [anon_sym_get] = ACTIONS(471),
    [anon_sym_set] = ACTIONS(471),
    [sym__automatic_semicolon] = ACTIONS(477),
  },
  [55] = {
    [ts_builtin_sym_end] = ACTIONS(479),
    [sym_identifier] = ACTIONS(481),
    [anon_sym_export] = ACTIONS(481),
    [anon_sym_STAR] = ACTIONS(481),
    [anon_sym_default] = ACTIONS(481),
    [anon_sym_LBRACE] = ACTIONS(479),
    [anon_sym_COMMA] = ACTIONS(479),
    [anon_sym_RBRACE] = ACTIONS(479),
    [anon_sym_import] = ACTIONS(481),
    [anon_sym_var] = ACTIONS(481),
    [anon_sym_let] = ACTIONS(481),
    [anon_sym_const] = ACTIONS(481),
    [anon_sym_else] = ACTIONS(481),
    [anon_sym_if] = ACTIONS(481),
    [anon_sym_switch] = ACTIONS(481),
    [anon_sym_for] = ACTIONS(481),
    [anon_sym_LPAREN] = ACTIONS(479),
    [anon_sym_await] = ACTIONS(481),
    [anon_sym_in] = ACTIONS(481),
    [anon_sym_while] = ACTIONS(481),
    [anon_sym_do] = ACTIONS(481),
    [anon_sym_try] = ACTIONS(481),
    [anon_sym_with] = ACTIONS(481),
    [anon_sym_break] = ACTIONS(481),
    [anon_sym_continue] = ACTIONS(481),
    [anon_sym_debugger] = ACTIONS(481),
    [anon_sym_return] = ACTIONS(481),
    [anon_sym_throw] = ACTIONS(481),
    [anon_sym_SEMI] = ACTIONS(479),
    [anon_sym_case] = ACTIONS(481),
    [anon_sym_yield] = ACTIONS(481),
    [anon_sym_LBRACK] = ACTIONS(479),
    [anon_sym_LT] = ACTIONS(481),
    [anon_sym_GT] = ACTIONS(481),
    [anon_sym_SLASH] = ACTIONS(481),
    [anon_sym_DOT] = ACTIONS(481),
    [anon_sym_class] = ACTIONS(481),
    [anon_sym_async] = ACTIONS(481),
    [anon_sym_function] = ACTIONS(481),
    [anon_sym_QMARK_DOT] = ACTIONS(479),
    [anon_sym_new] = ACTIONS(481),
    [anon_sym_QMARK] = ACTIONS(481),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(481),
    [anon_sym_GT_GT_GT] = ACTIONS(479),
    [anon_sym_LT_LT] = ACTIONS(479),
    [anon_sym_AMP] = ACTIONS(481),
    [anon_sym_CARET] = ACTIONS(479),
    [anon_sym_PIPE] = ACTIONS(481),
    [anon_sym_PLUS] = ACTIONS(481),
    [anon_sym_DASH] = ACTIONS(481),
    [anon_sym_PERCENT] = ACTIONS(479),
    [anon_sym_STAR_STAR] = ACTIONS(479),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(481),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(481),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_QMARK_QMARK] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(481),
    [anon_sym_BANG] = ACTIONS(481),
    [anon_sym_TILDE] = ACTIONS(479),
    [anon_sym_typeof] = ACTIONS(481),
    [anon_sym_void] = ACTIONS(481),
    [anon_sym_delete] = ACTIONS(481),
    [anon_sym_PLUS_PLUS] = ACTIONS(479),
    [anon_sym_DASH_DASH] = ACTIONS(479),
    [anon_sym_DQUOTE] = ACTIONS(479),
    [anon_sym_SQUOTE] = ACTIONS(479),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym_number] = ACTIONS(479),
    [sym_this] = ACTIONS(481),
    [sym_super] = ACTIONS(481),
    [sym_true] = ACTIONS(481),
    [sym_false] = ACTIONS(481),
    [sym_null] = ACTIONS(481),
    [sym_undefined] = ACTIONS(481),
    [anon_sym_AT] = ACTIONS(479),
    [anon_sym_static] = ACTIONS(481),
    [anon_sym_get] = ACTIONS(481),
    [anon_sym_set] = ACTIONS(481),
    [sym__automatic_semicolon] = ACTIONS(483),
  },
  [56] = {
    [ts_builtin_sym_end] = ACTIONS(485),
    [sym_identifier] = ACTIONS(487),
    [anon_sym_export] = ACTIONS(487),
    [anon_sym_STAR] = ACTIONS(489),
    [anon_sym_default] = ACTIONS(487),
    [anon_sym_LBRACE] = ACTIONS(485),
    [anon_sym_COMMA] = ACTIONS(491),
    [anon_sym_RBRACE] = ACTIONS(485),
    [anon_sym_import] = ACTIONS(487),
    [anon_sym_var] = ACTIONS(487),
    [anon_sym_let] = ACTIONS(487),
    [anon_sym_const] = ACTIONS(487),
    [anon_sym_else] = ACTIONS(487),
    [anon_sym_if] = ACTIONS(487),
    [anon_sym_switch] = ACTIONS(487),
    [anon_sym_for] = ACTIONS(487),
    [anon_sym_LPAREN] = ACTIONS(485),
    [anon_sym_await] = ACTIONS(487),
    [anon_sym_in] = ACTIONS(489),
    [anon_sym_while] = ACTIONS(487),
    [anon_sym_do] = ACTIONS(487),
    [anon_sym_try] = ACTIONS(487),
    [anon_sym_with] = ACTIONS(487),
    [anon_sym_break] = ACTIONS(487),
    [anon_sym_continue] = ACTIONS(487),
    [anon_sym_debugger] = ACTIONS(487),
    [anon_sym_return] = ACTIONS(487),
    [anon_sym_throw] = ACTIONS(487),
    [anon_sym_SEMI] = ACTIONS(485),
    [anon_sym_case] = ACTIONS(487),
    [anon_sym_yield] = ACTIONS(487),
    [anon_sym_LBRACK] = ACTIONS(485),
    [anon_sym_LT] = ACTIONS(487),
    [anon_sym_GT] = ACTIONS(489),
    [anon_sym_SLASH] = ACTIONS(487),
    [anon_sym_DOT] = ACTIONS(489),
    [anon_sym_class] = ACTIONS(487),
    [anon_sym_async] = ACTIONS(487),
    [anon_sym_function] = ACTIONS(487),
    [anon_sym_QMARK_DOT] = ACTIONS(491),
    [anon_sym_new] = ACTIONS(487),
    [anon_sym_QMARK] = ACTIONS(489),
    [anon_sym_AMP_AMP] = ACTIONS(491),
    [anon_sym_PIPE_PIPE] = ACTIONS(491),
    [anon_sym_GT_GT] = ACTIONS(489),
    [anon_sym_GT_GT_GT] = ACTIONS(491),
    [anon_sym_LT_LT] = ACTIONS(491),
    [anon_sym_AMP] = ACTIONS(489),
    [anon_sym_CARET] = ACTIONS(491),
    [anon_sym_PIPE] = ACTIONS(489),
    [anon_sym_PLUS] = ACTIONS(487),
    [anon_sym_DASH] = ACTIONS(487),
    [anon_sym_PERCENT] = ACTIONS(491),
    [anon_sym_STAR_STAR] = ACTIONS(491),
    [anon_sym_LT_EQ] = ACTIONS(491),
    [anon_sym_EQ_EQ] = ACTIONS(489),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(491),
    [anon_sym_BANG_EQ] = ACTIONS(489),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(491),
    [anon_sym_GT_EQ] = ACTIONS(491),
    [anon_sym_QMARK_QMARK] = ACTIONS(491),
    [anon_sym_instanceof] = ACTIONS(489),
    [anon_sym_BANG] = ACTIONS(487),
    [anon_sym_TILDE] = ACTIONS(485),
    [anon_sym_typeof] = ACTIONS(487),
    [anon_sym_void] = ACTIONS(487),
    [anon_sym_delete] = ACTIONS(487),
    [anon_sym_PLUS_PLUS] = ACTIONS(485),
    [anon_sym_DASH_DASH] = ACTIONS(485),
    [anon_sym_DQUOTE] = ACTIONS(485),
    [anon_sym_SQUOTE] = ACTIONS(485),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(485),
    [sym_number] = ACTIONS(485),
    [sym_this] = ACTIONS(487),
    [sym_super] = ACTIONS(487),
    [sym_true] = ACTIONS(487),
    [sym_false] = ACTIONS(487),
    [sym_null] = ACTIONS(487),
    [sym_undefined] = ACTIONS(487),
    [anon_sym_AT] = ACTIONS(485),
    [anon_sym_static] = ACTIONS(487),
    [anon_sym_get] = ACTIONS(487),
    [anon_sym_set] = ACTIONS(487),
    [sym__automatic_semicolon] = ACTIONS(493),
  },
  [57] = {
    [ts_builtin_sym_end] = ACTIONS(479),
    [sym_identifier] = ACTIONS(481),
    [anon_sym_export] = ACTIONS(481),
    [anon_sym_STAR] = ACTIONS(481),
    [anon_sym_default] = ACTIONS(481),
    [anon_sym_LBRACE] = ACTIONS(479),
    [anon_sym_COMMA] = ACTIONS(479),
    [anon_sym_RBRACE] = ACTIONS(479),
    [anon_sym_import] = ACTIONS(481),
    [anon_sym_var] = ACTIONS(481),
    [anon_sym_let] = ACTIONS(481),
    [anon_sym_const] = ACTIONS(481),
    [anon_sym_else] = ACTIONS(481),
    [anon_sym_if] = ACTIONS(481),
    [anon_sym_switch] = ACTIONS(481),
    [anon_sym_for] = ACTIONS(481),
    [anon_sym_LPAREN] = ACTIONS(479),
    [anon_sym_await] = ACTIONS(481),
    [anon_sym_in] = ACTIONS(481),
    [anon_sym_while] = ACTIONS(481),
    [anon_sym_do] = ACTIONS(481),
    [anon_sym_try] = ACTIONS(481),
    [anon_sym_with] = ACTIONS(481),
    [anon_sym_break] = ACTIONS(481),
    [anon_sym_continue] = ACTIONS(481),
    [anon_sym_debugger] = ACTIONS(481),
    [anon_sym_return] = ACTIONS(481),
    [anon_sym_throw] = ACTIONS(481),
    [anon_sym_SEMI] = ACTIONS(479),
    [anon_sym_case] = ACTIONS(481),
    [anon_sym_yield] = ACTIONS(481),
    [anon_sym_LBRACK] = ACTIONS(479),
    [anon_sym_LT] = ACTIONS(481),
    [anon_sym_GT] = ACTIONS(481),
    [anon_sym_SLASH] = ACTIONS(481),
    [anon_sym_DOT] = ACTIONS(481),
    [anon_sym_class] = ACTIONS(481),
    [anon_sym_async] = ACTIONS(481),
    [anon_sym_function] = ACTIONS(481),
    [anon_sym_QMARK_DOT] = ACTIONS(479),
    [anon_sym_new] = ACTIONS(481),
    [anon_sym_QMARK] = ACTIONS(481),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(481),
    [anon_sym_GT_GT_GT] = ACTIONS(479),
    [anon_sym_LT_LT] = ACTIONS(479),
    [anon_sym_AMP] = ACTIONS(481),
    [anon_sym_CARET] = ACTIONS(479),
    [anon_sym_PIPE] = ACTIONS(481),
    [anon_sym_PLUS] = ACTIONS(481),
    [anon_sym_DASH] = ACTIONS(481),
    [anon_sym_PERCENT] = ACTIONS(479),
    [anon_sym_STAR_STAR] = ACTIONS(479),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(481),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(481),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_QMARK_QMARK] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(481),
    [anon_sym_BANG] = ACTIONS(481),
    [anon_sym_TILDE] = ACTIONS(479),
    [anon_sym_typeof] = ACTIONS(481),
    [anon_sym_void] = ACTIONS(481),
    [anon_sym_delete] = ACTIONS(481),
    [anon_sym_PLUS_PLUS] = ACTIONS(479),
    [anon_sym_DASH_DASH] = ACTIONS(479),
    [anon_sym_DQUOTE] = ACTIONS(479),
    [anon_sym_SQUOTE] = ACTIONS(479),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym_number] = ACTIONS(479),
    [sym_this] = ACTIONS(481),
    [sym_super] = ACTIONS(481),
    [sym_true] = ACTIONS(481),
    [sym_false] = ACTIONS(481),
    [sym_null] = ACTIONS(481),
    [sym_undefined] = ACTIONS(481),
    [anon_sym_AT] = ACTIONS(479),
    [anon_sym_static] = ACTIONS(481),
    [anon_sym_get] = ACTIONS(481),
    [anon_sym_set] = ACTIONS(481),
    [sym__automatic_semicolon] = ACTIONS(479),
  },
  [58] = {
    [ts_builtin_sym_end] = ACTIONS(495),
    [sym_identifier] = ACTIONS(497),
    [anon_sym_export] = ACTIONS(497),
    [anon_sym_STAR] = ACTIONS(499),
    [anon_sym_default] = ACTIONS(497),
    [anon_sym_LBRACE] = ACTIONS(495),
    [anon_sym_COMMA] = ACTIONS(501),
    [anon_sym_RBRACE] = ACTIONS(495),
    [anon_sym_import] = ACTIONS(497),
    [anon_sym_var] = ACTIONS(497),
    [anon_sym_let] = ACTIONS(497),
    [anon_sym_const] = ACTIONS(497),
    [anon_sym_else] = ACTIONS(497),
    [anon_sym_if] = ACTIONS(497),
    [anon_sym_switch] = ACTIONS(497),
    [anon_sym_for] = ACTIONS(497),
    [anon_sym_LPAREN] = ACTIONS(495),
    [anon_sym_await] = ACTIONS(497),
    [anon_sym_in] = ACTIONS(499),
    [anon_sym_while] = ACTIONS(497),
    [anon_sym_do] = ACTIONS(497),
    [anon_sym_try] = ACTIONS(497),
    [anon_sym_with] = ACTIONS(497),
    [anon_sym_break] = ACTIONS(497),
    [anon_sym_continue] = ACTIONS(497),
    [anon_sym_debugger] = ACTIONS(497),
    [anon_sym_return] = ACTIONS(497),
    [anon_sym_throw] = ACTIONS(497),
    [anon_sym_SEMI] = ACTIONS(495),
    [anon_sym_case] = ACTIONS(497),
    [anon_sym_yield] = ACTIONS(497),
    [anon_sym_LBRACK] = ACTIONS(495),
    [anon_sym_LT] = ACTIONS(497),
    [anon_sym_GT] = ACTIONS(499),
    [anon_sym_SLASH] = ACTIONS(497),
    [anon_sym_DOT] = ACTIONS(499),
    [anon_sym_class] = ACTIONS(497),
    [anon_sym_async] = ACTIONS(497),
    [anon_sym_function] = ACTIONS(497),
    [anon_sym_QMARK_DOT] = ACTIONS(501),
    [anon_sym_new] = ACTIONS(497),
    [anon_sym_QMARK] = ACTIONS(499),
    [anon_sym_AMP_AMP] = ACTIONS(501),
    [anon_sym_PIPE_PIPE] = ACTIONS(501),
    [anon_sym_GT_GT] = ACTIONS(499),
    [anon_sym_GT_GT_GT] = ACTIONS(501),
    [anon_sym_LT_LT] = ACTIONS(501),
    [anon_sym_AMP] = ACTIONS(499),
    [anon_sym_CARET] = ACTIONS(501),
    [anon_sym_PIPE] = ACTIONS(499),
    [anon_sym_PLUS] = ACTIONS(497),
    [anon_sym_DASH] = ACTIONS(497),
    [anon_sym_PERCENT] = ACTIONS(501),
    [anon_sym_STAR_STAR] = ACTIONS(501),
    [anon_sym_LT_EQ] = ACTIONS(501),
    [anon_sym_EQ_EQ] = ACTIONS(499),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(501),
    [anon_sym_BANG_EQ] = ACTIONS(499),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(501),
    [anon_sym_GT_EQ] = ACTIONS(501),
    [anon_sym_QMARK_QMARK] = ACTIONS(501),
    [anon_sym_instanceof] = ACTIONS(499),
    [anon_sym_BANG] = ACTIONS(497),
    [anon_sym_TILDE] = ACTIONS(495),
    [anon_sym_typeof] = ACTIONS(497),
    [anon_sym_void] = ACTIONS(497),
    [anon_sym_delete] = ACTIONS(497),
    [anon_sym_PLUS_PLUS] = ACTIONS(495),
    [anon_sym_DASH_DASH] = ACTIONS(495),
    [anon_sym_DQUOTE] = ACTIONS(495),
    [anon_sym_SQUOTE] = ACTIONS(495),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(495),
    [sym_number] = ACTIONS(495),
    [sym_this] = ACTIONS(497),
    [sym_super] = ACTIONS(497),
    [sym_true] = ACTIONS(497),
    [sym_false] = ACTIONS(497),
    [sym_null] = ACTIONS(497),
    [sym_undefined] = ACTIONS(497),
    [anon_sym_AT] = ACTIONS(495),
    [anon_sym_static] = ACTIONS(497),
    [anon_sym_get] = ACTIONS(497),
    [anon_sym_set] = ACTIONS(497),
    [sym__automatic_semicolon] = ACTIONS(503),
  },
  [59] = {
    [ts_builtin_sym_end] = ACTIONS(505),
    [sym_identifier] = ACTIONS(507),
    [anon_sym_export] = ACTIONS(507),
    [anon_sym_STAR] = ACTIONS(509),
    [anon_sym_default] = ACTIONS(507),
    [anon_sym_LBRACE] = ACTIONS(505),
    [anon_sym_COMMA] = ACTIONS(511),
    [anon_sym_RBRACE] = ACTIONS(505),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_var] = ACTIONS(507),
    [anon_sym_let] = ACTIONS(507),
    [anon_sym_const] = ACTIONS(507),
    [anon_sym_else] = ACTIONS(507),
    [anon_sym_if] = ACTIONS(507),
    [anon_sym_switch] = ACTIONS(507),
    [anon_sym_for] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(505),
    [anon_sym_await] = ACTIONS(507),
    [anon_sym_in] = ACTIONS(509),
    [anon_sym_while] = ACTIONS(507),
    [anon_sym_do] = ACTIONS(507),
    [anon_sym_try] = ACTIONS(507),
    [anon_sym_with] = ACTIONS(507),
    [anon_sym_break] = ACTIONS(507),
    [anon_sym_continue] = ACTIONS(507),
    [anon_sym_debugger] = ACTIONS(507),
    [anon_sym_return] = ACTIONS(507),
    [anon_sym_throw] = ACTIONS(507),
    [anon_sym_SEMI] = ACTIONS(505),
    [anon_sym_case] = ACTIONS(507),
    [anon_sym_yield] = ACTIONS(507),
    [anon_sym_LBRACK] = ACTIONS(505),
    [anon_sym_LT] = ACTIONS(507),
    [anon_sym_GT] = ACTIONS(509),
    [anon_sym_SLASH] = ACTIONS(507),
    [anon_sym_DOT] = ACTIONS(509),
    [anon_sym_class] = ACTIONS(507),
    [anon_sym_async] = ACTIONS(507),
    [anon_sym_function] = ACTIONS(507),
    [anon_sym_QMARK_DOT] = ACTIONS(511),
    [anon_sym_new] = ACTIONS(507),
    [anon_sym_QMARK] = ACTIONS(509),
    [anon_sym_AMP_AMP] = ACTIONS(511),
    [anon_sym_PIPE_PIPE] = ACTIONS(511),
    [anon_sym_GT_GT] = ACTIONS(509),
    [anon_sym_GT_GT_GT] = ACTIONS(511),
    [anon_sym_LT_LT] = ACTIONS(511),
    [anon_sym_AMP] = ACTIONS(509),
    [anon_sym_CARET] = ACTIONS(511),
    [anon_sym_PIPE] = ACTIONS(509),
    [anon_sym_PLUS] = ACTIONS(507),
    [anon_sym_DASH] = ACTIONS(507),
    [anon_sym_PERCENT] = ACTIONS(511),
    [anon_sym_STAR_STAR] = ACTIONS(511),
    [anon_sym_LT_EQ] = ACTIONS(511),
    [anon_sym_EQ_EQ] = ACTIONS(509),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(511),
    [anon_sym_BANG_EQ] = ACTIONS(509),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(511),
    [anon_sym_GT_EQ] = ACTIONS(511),
    [anon_sym_QMARK_QMARK] = ACTIONS(511),
    [anon_sym_instanceof] = ACTIONS(509),
    [anon_sym_BANG] = ACTIONS(507),
    [anon_sym_TILDE] = ACTIONS(505),
    [anon_sym_typeof] = ACTIONS(507),
    [anon_sym_void] = ACTIONS(507),
    [anon_sym_delete] = ACTIONS(507),
    [anon_sym_PLUS_PLUS] = ACTIONS(505),
    [anon_sym_DASH_DASH] = ACTIONS(505),
    [anon_sym_DQUOTE] = ACTIONS(505),
    [anon_sym_SQUOTE] = ACTIONS(505),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(505),
    [sym_number] = ACTIONS(505),
    [sym_this] = ACTIONS(507),
    [sym_super] = ACTIONS(507),
    [sym_true] = ACTIONS(507),
    [sym_false] = ACTIONS(507),
    [sym_null] = ACTIONS(507),
    [sym_undefined] = ACTIONS(507),
    [anon_sym_AT] = ACTIONS(505),
    [anon_sym_static] = ACTIONS(507),
    [anon_sym_get] = ACTIONS(507),
    [anon_sym_set] = ACTIONS(507),
    [sym__automatic_semicolon] = ACTIONS(513),
  },
  [60] = {
    [ts_builtin_sym_end] = ACTIONS(515),
    [sym_identifier] = ACTIONS(517),
    [anon_sym_export] = ACTIONS(517),
    [anon_sym_STAR] = ACTIONS(517),
    [anon_sym_default] = ACTIONS(517),
    [anon_sym_LBRACE] = ACTIONS(515),
    [anon_sym_COMMA] = ACTIONS(515),
    [anon_sym_RBRACE] = ACTIONS(515),
    [anon_sym_import] = ACTIONS(517),
    [anon_sym_var] = ACTIONS(517),
    [anon_sym_let] = ACTIONS(517),
    [anon_sym_const] = ACTIONS(517),
    [anon_sym_else] = ACTIONS(517),
    [anon_sym_if] = ACTIONS(517),
    [anon_sym_switch] = ACTIONS(517),
    [anon_sym_for] = ACTIONS(517),
    [anon_sym_LPAREN] = ACTIONS(515),
    [anon_sym_await] = ACTIONS(517),
    [anon_sym_in] = ACTIONS(517),
    [anon_sym_while] = ACTIONS(517),
    [anon_sym_do] = ACTIONS(517),
    [anon_sym_try] = ACTIONS(517),
    [anon_sym_with] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(517),
    [anon_sym_continue] = ACTIONS(517),
    [anon_sym_debugger] = ACTIONS(517),
    [anon_sym_return] = ACTIONS(517),
    [anon_sym_throw] = ACTIONS(517),
    [anon_sym_SEMI] = ACTIONS(515),
    [anon_sym_case] = ACTIONS(517),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_LBRACK] = ACTIONS(515),
    [anon_sym_LT] = ACTIONS(517),
    [anon_sym_GT] = ACTIONS(517),
    [anon_sym_SLASH] = ACTIONS(517),
    [anon_sym_DOT] = ACTIONS(517),
    [anon_sym_class] = ACTIONS(517),
    [anon_sym_async] = ACTIONS(517),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_QMARK_DOT] = ACTIONS(515),
    [anon_sym_new] = ACTIONS(517),
    [anon_sym_QMARK] = ACTIONS(517),
    [anon_sym_AMP_AMP] = ACTIONS(515),
    [anon_sym_PIPE_PIPE] = ACTIONS(515),
    [anon_sym_GT_GT] = ACTIONS(517),
    [anon_sym_GT_GT_GT] = ACTIONS(515),
    [anon_sym_LT_LT] = ACTIONS(515),
    [anon_sym_AMP] = ACTIONS(517),
    [anon_sym_CARET] = ACTIONS(515),
    [anon_sym_PIPE] = ACTIONS(517),
    [anon_sym_PLUS] = ACTIONS(517),
    [anon_sym_DASH] = ACTIONS(517),
    [anon_sym_PERCENT] = ACTIONS(515),
    [anon_sym_STAR_STAR] = ACTIONS(515),
    [anon_sym_LT_EQ] = ACTIONS(515),
    [anon_sym_EQ_EQ] = ACTIONS(517),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(515),
    [anon_sym_BANG_EQ] = ACTIONS(517),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(515),
    [anon_sym_GT_EQ] = ACTIONS(515),
    [anon_sym_QMARK_QMARK] = ACTIONS(515),
    [anon_sym_instanceof] = ACTIONS(517),
    [anon_sym_BANG] = ACTIONS(517),
    [anon_sym_TILDE] = ACTIONS(515),
    [anon_sym_typeof] = ACTIONS(517),
    [anon_sym_void] = ACTIONS(517),
    [anon_sym_delete] = ACTIONS(517),
    [anon_sym_PLUS_PLUS] = ACTIONS(515),
    [anon_sym_DASH_DASH] = ACTIONS(515),
    [anon_sym_DQUOTE] = ACTIONS(515),
    [anon_sym_SQUOTE] = ACTIONS(515),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(515),
    [sym_number] = ACTIONS(515),
    [sym_this] = ACTIONS(517),
    [sym_super] = ACTIONS(517),
    [sym_true] = ACTIONS(517),
    [sym_false] = ACTIONS(517),
    [sym_null] = ACTIONS(517),
    [sym_undefined] = ACTIONS(517),
    [anon_sym_AT] = ACTIONS(515),
    [anon_sym_static] = ACTIONS(517),
    [anon_sym_get] = ACTIONS(517),
    [anon_sym_set] = ACTIONS(517),
    [sym__automatic_semicolon] = ACTIONS(515),
  },
  [61] = {
    [ts_builtin_sym_end] = ACTIONS(519),
    [sym_identifier] = ACTIONS(521),
    [anon_sym_export] = ACTIONS(521),
    [anon_sym_STAR] = ACTIONS(523),
    [anon_sym_default] = ACTIONS(521),
    [anon_sym_LBRACE] = ACTIONS(519),
    [anon_sym_COMMA] = ACTIONS(525),
    [anon_sym_RBRACE] = ACTIONS(519),
    [anon_sym_import] = ACTIONS(521),
    [anon_sym_var] = ACTIONS(521),
    [anon_sym_let] = ACTIONS(521),
    [anon_sym_const] = ACTIONS(521),
    [anon_sym_else] = ACTIONS(521),
    [anon_sym_if] = ACTIONS(521),
    [anon_sym_switch] = ACTIONS(521),
    [anon_sym_for] = ACTIONS(521),
    [anon_sym_LPAREN] = ACTIONS(519),
    [anon_sym_await] = ACTIONS(521),
    [anon_sym_in] = ACTIONS(523),
    [anon_sym_while] = ACTIONS(521),
    [anon_sym_do] = ACTIONS(521),
    [anon_sym_try] = ACTIONS(521),
    [anon_sym_with] = ACTIONS(521),
    [anon_sym_break] = ACTIONS(521),
    [anon_sym_continue] = ACTIONS(521),
    [anon_sym_debugger] = ACTIONS(521),
    [anon_sym_return] = ACTIONS(521),
    [anon_sym_throw] = ACTIONS(521),
    [anon_sym_SEMI] = ACTIONS(519),
    [anon_sym_case] = ACTIONS(521),
    [anon_sym_yield] = ACTIONS(521),
    [anon_sym_LBRACK] = ACTIONS(519),
    [anon_sym_LT] = ACTIONS(521),
    [anon_sym_GT] = ACTIONS(523),
    [anon_sym_SLASH] = ACTIONS(521),
    [anon_sym_DOT] = ACTIONS(523),
    [anon_sym_class] = ACTIONS(521),
    [anon_sym_async] = ACTIONS(521),
    [anon_sym_function] = ACTIONS(521),
    [anon_sym_QMARK_DOT] = ACTIONS(525),
    [anon_sym_new] = ACTIONS(521),
    [anon_sym_QMARK] = ACTIONS(523),
    [anon_sym_AMP_AMP] = ACTIONS(525),
    [anon_sym_PIPE_PIPE] = ACTIONS(525),
    [anon_sym_GT_GT] = ACTIONS(523),
    [anon_sym_GT_GT_GT] = ACTIONS(525),
    [anon_sym_LT_LT] = ACTIONS(525),
    [anon_sym_AMP] = ACTIONS(523),
    [anon_sym_CARET] = ACTIONS(525),
    [anon_sym_PIPE] = ACTIONS(523),
    [anon_sym_PLUS] = ACTIONS(521),
    [anon_sym_DASH] = ACTIONS(521),
    [anon_sym_PERCENT] = ACTIONS(525),
    [anon_sym_STAR_STAR] = ACTIONS(525),
    [anon_sym_LT_EQ] = ACTIONS(525),
    [anon_sym_EQ_EQ] = ACTIONS(523),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(525),
    [anon_sym_BANG_EQ] = ACTIONS(523),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(525),
    [anon_sym_GT_EQ] = ACTIONS(525),
    [anon_sym_QMARK_QMARK] = ACTIONS(525),
    [anon_sym_instanceof] = ACTIONS(523),
    [anon_sym_BANG] = ACTIONS(521),
    [anon_sym_TILDE] = ACTIONS(519),
    [anon_sym_typeof] = ACTIONS(521),
    [anon_sym_void] = ACTIONS(521),
    [anon_sym_delete] = ACTIONS(521),
    [anon_sym_PLUS_PLUS] = ACTIONS(519),
    [anon_sym_DASH_DASH] = ACTIONS(519),
    [anon_sym_DQUOTE] = ACTIONS(519),
    [anon_sym_SQUOTE] = ACTIONS(519),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(519),
    [sym_number] = ACTIONS(519),
    [sym_this] = ACTIONS(521),
    [sym_super] = ACTIONS(521),
    [sym_true] = ACTIONS(521),
    [sym_false] = ACTIONS(521),
    [sym_null] = ACTIONS(521),
    [sym_undefined] = ACTIONS(521),
    [anon_sym_AT] = ACTIONS(519),
    [anon_sym_static] = ACTIONS(521),
    [anon_sym_get] = ACTIONS(521),
    [anon_sym_set] = ACTIONS(521),
    [sym__automatic_semicolon] = ACTIONS(527),
  },
  [62] = {
    [sym_import] = STATE(426),
    [sym_parenthesized_expression] = STATE(355),
    [sym_expression] = STATE(525),
    [sym_primary_expression] = STATE(425),
    [sym_yield_expression] = STATE(424),
    [sym_object] = STATE(426),
    [sym_object_pattern] = STATE(919),
    [sym_assignment_pattern] = STATE(1026),
    [sym_array] = STATE(426),
    [sym_array_pattern] = STATE(919),
    [sym_jsx_element] = STATE(424),
    [sym_jsx_fragment] = STATE(424),
    [sym_jsx_opening_element] = STATE(768),
    [sym_jsx_self_closing_element] = STATE(424),
    [sym_class] = STATE(426),
    [sym_function] = STATE(426),
    [sym_generator_function] = STATE(426),
    [sym_arrow_function] = STATE(426),
    [sym_call_expression] = STATE(426),
    [sym_new_expression] = STATE(424),
    [sym_await_expression] = STATE(424),
    [sym_member_expression] = STATE(355),
    [sym_subscript_expression] = STATE(355),
    [sym_assignment_expression] = STATE(424),
    [sym__augmented_assignment_lhs] = STATE(714),
    [sym_augmented_assignment_expression] = STATE(424),
    [sym__destructuring_pattern] = STATE(919),
    [sym_spread_element] = STATE(1034),
    [sym_ternary_expression] = STATE(424),
    [sym_binary_expression] = STATE(424),
    [sym_unary_expression] = STATE(424),
    [sym_update_expression] = STATE(424),
    [sym_string] = STATE(426),
    [sym_template_string] = STATE(426),
    [sym_regex] = STATE(426),
    [sym_meta_property] = STATE(426),
    [sym_decorator] = STATE(750),
    [sym_formal_parameters] = STATE(1322),
    [sym_pattern] = STATE(930),
    [sym_rest_pattern] = STATE(895),
    [aux_sym_export_statement_repeat1] = STATE(924),
    [aux_sym_array_repeat1] = STATE(1036),
    [aux_sym_array_pattern_repeat1] = STATE(1013),
    [sym_identifier] = ACTIONS(529),
    [anon_sym_export] = ACTIONS(531),
    [anon_sym_LBRACE] = ACTIONS(397),
    [anon_sym_COMMA] = ACTIONS(533),
    [anon_sym_import] = ACTIONS(331),
    [anon_sym_LPAREN] = ACTIONS(333),
    [anon_sym_await] = ACTIONS(335),
    [anon_sym_yield] = ACTIONS(339),
    [anon_sym_LBRACK] = ACTIONS(403),
    [anon_sym_RBRACK] = ACTIONS(535),
    [anon_sym_LT] = ACTIONS(537),
    [anon_sym_SLASH] = ACTIONS(345),
    [anon_sym_class] = ACTIONS(347),
    [anon_sym_async] = ACTIONS(539),
    [anon_sym_function] = ACTIONS(351),
    [anon_sym_new] = ACTIONS(353),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(541),
    [anon_sym_PLUS] = ACTIONS(355),
    [anon_sym_DASH] = ACTIONS(355),
    [anon_sym_BANG] = ACTIONS(357),
    [anon_sym_TILDE] = ACTIONS(357),
    [anon_sym_typeof] = ACTIONS(359),
    [anon_sym_void] = ACTIONS(359),
    [anon_sym_delete] = ACTIONS(359),
    [anon_sym_PLUS_PLUS] = ACTIONS(361),
    [anon_sym_DASH_DASH] = ACTIONS(361),
    [anon_sym_DQUOTE] = ACTIONS(363),
    [anon_sym_SQUOTE] = ACTIONS(365),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(367),
    [sym_number] = ACTIONS(369),
    [sym_this] = ACTIONS(371),
    [sym_super] = ACTIONS(371),
    [sym_true] = ACTIONS(371),
    [sym_false] = ACTIONS(371),
    [sym_null] = ACTIONS(371),
    [sym_undefined] = ACTIONS(371),
    [anon_sym_AT] = ACTIONS(85),
    [anon_sym_static] = ACTIONS(531),
    [anon_sym_get] = ACTIONS(531),
    [anon_sym_set] = ACTIONS(531),
  },
  [63] = {
    [sym_import] = STATE(426),
    [sym_parenthesized_expression] = STATE(355),
    [sym_expression] = STATE(525),
    [sym_primary_expression] = STATE(425),
    [sym_yield_expression] = STATE(424),
    [sym_object] = STATE(426),
    [sym_object_pattern] = STATE(919),
    [sym_assignment_pattern] = STATE(1026),
    [sym_array] = STATE(426),
    [sym_array_pattern] = STATE(919),
    [sym_jsx_element] = STATE(424),
    [sym_jsx_fragment] = STATE(424),
    [sym_jsx_opening_element] = STATE(768),
    [sym_jsx_self_closing_element] = STATE(424),
    [sym_class] = STATE(426),
    [sym_function] = STATE(426),
    [sym_generator_function] = STATE(426),
    [sym_arrow_function] = STATE(426),
    [sym_call_expression] = STATE(426),
    [sym_new_expression] = STATE(424),
    [sym_await_expression] = STATE(424),
    [sym_member_expression] = STATE(355),
    [sym_subscript_expression] = STATE(355),
    [sym_assignment_expression] = STATE(424),
    [sym__augmented_assignment_lhs] = STATE(714),
    [sym_augmented_assignment_expression] = STATE(424),
    [sym__destructuring_pattern] = STATE(919),
    [sym_spread_element] = STATE(1034),
    [sym_ternary_expression] = STATE(424),
    [sym_binary_expression] = STATE(424),
    [sym_unary_expression] = STATE(424),
    [sym_update_expression] = STATE(424),
    [sym_string] = STATE(426),
    [sym_template_string] = STATE(426),
    [sym_regex] = STATE(426),
    [sym_meta_property] = STATE(426),
    [sym_decorator] = STATE(750),
    [sym_formal_parameters] = STATE(1322),
    [sym_pattern] = STATE(930),
    [sym_rest_pattern] = STATE(895),
    [aux_sym_export_statement_repeat1] = STATE(924),
    [aux_sym_array_repeat1] = STATE(1036),
    [aux_sym_array_pattern_repeat1] = STATE(1013),
    [sym_identifier] = ACTIONS(529),
    [anon_sym_export] = ACTIONS(531),
    [anon_sym_LBRACE] = ACTIONS(397),
    [anon_sym_COMMA] = ACTIONS(533),
    [anon_sym_import] = ACTIONS(331),
    [anon_sym_LPAREN] = ACTIONS(333),
    [anon_sym_await] = ACTIONS(335),
    [anon_sym_yield] = ACTIONS(339),
    [anon_sym_LBRACK] = ACTIONS(403),
    [anon_sym_RBRACK] = ACTIONS(543),
    [anon_sym_LT] = ACTIONS(537),
    [anon_sym_SLASH] = ACTIONS(345),
    [anon_sym_class] = ACTIONS(347),
    [anon_sym_async] = ACTIONS(539),
    [anon_sym_function] = ACTIONS(351),
    [anon_sym_new] = ACTIONS(353),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(541),
    [anon_sym_PLUS] = ACTIONS(355),
    [anon_sym_DASH] = ACTIONS(355),
    [anon_sym_BANG] = ACTIONS(357),
    [anon_sym_TILDE] = ACTIONS(357),
    [anon_sym_typeof] = ACTIONS(359),
    [anon_sym_void] = ACTIONS(359),
    [anon_sym_delete] = ACTIONS(359),
    [anon_sym_PLUS_PLUS] = ACTIONS(361),
    [anon_sym_DASH_DASH] = ACTIONS(361),
    [anon_sym_DQUOTE] = ACTIONS(363),
    [anon_sym_SQUOTE] = ACTIONS(365),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(367),
    [sym_number] = ACTIONS(369),
    [sym_this] = ACTIONS(371),
    [sym_super] = ACTIONS(371),
    [sym_true] = ACTIONS(371),
    [sym_false] = ACTIONS(371),
    [sym_null] = ACTIONS(371),
    [sym_undefined] = ACTIONS(371),
    [anon_sym_AT] = ACTIONS(85),
    [anon_sym_static] = ACTIONS(531),
    [anon_sym_get] = ACTIONS(531),
    [anon_sym_set] = ACTIONS(531),
  },
  [64] = {
    [sym_import] = STATE(426),
    [sym_parenthesized_expression] = STATE(355),
    [sym_expression] = STATE(525),
    [sym_primary_expression] = STATE(425),
    [sym_yield_expression] = STATE(424),
    [sym_object] = STATE(426),
    [sym_object_pattern] = STATE(919),
    [sym_assignment_pattern] = STATE(1026),
    [sym_array] = STATE(426),
    [sym_array_pattern] = STATE(919),
    [sym_jsx_element] = STATE(424),
    [sym_jsx_fragment] = STATE(424),
    [sym_jsx_opening_element] = STATE(768),
    [sym_jsx_self_closing_element] = STATE(424),
    [sym_class] = STATE(426),
    [sym_function] = STATE(426),
    [sym_generator_function] = STATE(426),
    [sym_arrow_function] = STATE(426),
    [sym_call_expression] = STATE(426),
    [sym_new_expression] = STATE(424),
    [sym_await_expression] = STATE(424),
    [sym_member_expression] = STATE(355),
    [sym_subscript_expression] = STATE(355),
    [sym_assignment_expression] = STATE(424),
    [sym__augmented_assignment_lhs] = STATE(714),
    [sym_augmented_assignment_expression] = STATE(424),
    [sym__destructuring_pattern] = STATE(919),
    [sym_spread_element] = STATE(1034),
    [sym_ternary_expression] = STATE(424),
    [sym_binary_expression] = STATE(424),
    [sym_unary_expression] = STATE(424),
    [sym_update_expression] = STATE(424),
    [sym_string] = STATE(426),
    [sym_template_string] = STATE(426),
    [sym_regex] = STATE(426),
    [sym_meta_property] = STATE(426),
    [sym_decorator] = STATE(750),
    [sym_formal_parameters] = STATE(1322),
    [sym_pattern] = STATE(930),
    [sym_rest_pattern] = STATE(895),
    [aux_sym_export_statement_repeat1] = STATE(924),
    [aux_sym_array_repeat1] = STATE(1036),
    [aux_sym_array_pattern_repeat1] = STATE(1013),
    [sym_identifier] = ACTIONS(529),
    [anon_sym_export] = ACTIONS(531),
    [anon_sym_LBRACE] = ACTIONS(397),
    [anon_sym_COMMA] = ACTIONS(533),
    [anon_sym_import] = ACTIONS(331),
    [anon_sym_LPAREN] = ACTIONS(333),
    [anon_sym_await] = ACTIONS(335),
    [anon_sym_yield] = ACTIONS(339),
    [anon_sym_LBRACK] = ACTIONS(403),
    [anon_sym_RBRACK] = ACTIONS(545),
    [anon_sym_LT] = ACTIONS(537),
    [anon_sym_SLASH] = ACTIONS(345),
    [anon_sym_class] = ACTIONS(347),
    [anon_sym_async] = ACTIONS(539),
    [anon_sym_function] = ACTIONS(351),
    [anon_sym_new] = ACTIONS(353),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(541),
    [anon_sym_PLUS] = ACTIONS(355),
    [anon_sym_DASH] = ACTIONS(355),
    [anon_sym_BANG] = ACTIONS(357),
    [anon_sym_TILDE] = ACTIONS(357),
    [anon_sym_typeof] = ACTIONS(359),
    [anon_sym_void] = ACTIONS(359),
    [anon_sym_delete] = ACTIONS(359),
    [anon_sym_PLUS_PLUS] = ACTIONS(361),
    [anon_sym_DASH_DASH] = ACTIONS(361),
    [anon_sym_DQUOTE] = ACTIONS(363),
    [anon_sym_SQUOTE] = ACTIONS(365),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(367),
    [sym_number] = ACTIONS(369),
    [sym_this] = ACTIONS(371),
    [sym_super] = ACTIONS(371),
    [sym_true] = ACTIONS(371),
    [sym_false] = ACTIONS(371),
    [sym_null] = ACTIONS(371),
    [sym_undefined] = ACTIONS(371),
    [anon_sym_AT] = ACTIONS(85),
    [anon_sym_static] = ACTIONS(531),
    [anon_sym_get] = ACTIONS(531),
    [anon_sym_set] = ACTIONS(531),
  },
  [65] = {
    [sym_import] = STATE(539),
    [sym_expression_statement] = STATE(80),
    [sym_variable_declaration] = STATE(80),
    [sym_lexical_declaration] = STATE(80),
    [sym_empty_statement] = STATE(80),
    [sym_parenthesized_expression] = STATE(363),
    [sym_expression] = STATE(522),
    [sym_primary_expression] = STATE(546),
    [sym_yield_expression] = STATE(550),
    [sym_object] = STATE(539),
    [sym_object_pattern] = STATE(1011),
    [sym_array] = STATE(539),
    [sym_array_pattern] = STATE(1011),
    [sym_jsx_element] = STATE(550),
    [sym_jsx_fragment] = STATE(550),
    [sym_jsx_opening_element] = STATE(772),
    [sym_jsx_self_closing_element] = STATE(550),
    [sym_class] = STATE(539),
    [sym_function] = STATE(539),
    [sym_generator_function] = STATE(539),
    [sym_arrow_function] = STATE(539),
    [sym_call_expression] = STATE(539),
    [sym_new_expression] = STATE(550),
    [sym_await_expression] = STATE(550),
    [sym_member_expression] = STATE(363),
    [sym_subscript_expression] = STATE(363),
    [sym_assignment_expression] = STATE(550),
    [sym__augmented_assignment_lhs] = STATE(720),
    [sym_augmented_assignment_expression] = STATE(550),
    [sym__destructuring_pattern] = STATE(1011),
    [sym_ternary_expression] = STATE(550),
    [sym_binary_expression] = STATE(550),
    [sym_unary_expression] = STATE(550),
    [sym_update_expression] = STATE(550),
    [sym_sequence_expression] = STATE(1156),
    [sym_string] = STATE(539),
    [sym_template_string] = STATE(539),
    [sym_regex] = STATE(539),
    [sym_meta_property] = STATE(539),
    [sym_decorator] = STATE(750),
    [sym_formal_parameters] = STATE(1318),
    [aux_sym_export_statement_repeat1] = STATE(925),
    [sym_identifier] = ACTIONS(547),
    [anon_sym_export] = ACTIONS(549),
    [anon_sym_LBRACE] = ACTIONS(551),
    [anon_sym_import] = ACTIONS(381),
    [anon_sym_var] = ACTIONS(553),
    [anon_sym_let] = ACTIONS(555),
    [anon_sym_const] = ACTIONS(555),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(49),
    [anon_sym_yield] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(557),
    [anon_sym_LT] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(385),
    [anon_sym_async] = ACTIONS(559),
    [anon_sym_function] = ACTIONS(389),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_typeof] = ACTIONS(71),
    [anon_sym_void] = ACTIONS(71),
    [anon_sym_delete] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DQUOTE] = ACTIONS(75),
    [anon_sym_SQUOTE] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(79),
    [sym_number] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(83),
    [sym_true] = ACTIONS(83),
    [sym_false] = ACTIONS(83),
    [sym_null] = ACTIONS(83),
    [sym_undefined] = ACTIONS(83),
    [anon_sym_AT] = ACTIONS(85),
    [anon_sym_static] = ACTIONS(549),
    [anon_sym_get] = ACTIONS(549),
    [anon_sym_set] = ACTIONS(549),
  },
  [66] = {
    [sym_import] = STATE(426),
    [sym_parenthesized_expression] = STATE(355),
    [sym_expression] = STATE(515),
    [sym_primary_expression] = STATE(425),
    [sym_yield_expression] = STATE(424),
    [sym_object] = STATE(426),
    [sym_object_pattern] = STATE(919),
    [sym_assignment_pattern] = STATE(1026),
    [sym_array] = STATE(426),
    [sym_array_pattern] = STATE(919),
    [sym_jsx_element] = STATE(424),
    [sym_jsx_fragment] = STATE(424),
    [sym_jsx_opening_element] = STATE(768),
    [sym_jsx_self_closing_element] = STATE(424),
    [sym_class] = STATE(426),
    [sym_function] = STATE(426),
    [sym_generator_function] = STATE(426),
    [sym_arrow_function] = STATE(426),
    [sym_call_expression] = STATE(426),
    [sym_new_expression] = STATE(424),
    [sym_await_expression] = STATE(424),
    [sym_member_expression] = STATE(355),
    [sym_subscript_expression] = STATE(355),
    [sym_assignment_expression] = STATE(424),
    [sym__augmented_assignment_lhs] = STATE(714),
    [sym_augmented_assignment_expression] = STATE(424),
    [sym__destructuring_pattern] = STATE(919),
    [sym_spread_element] = STATE(1025),
    [sym_ternary_expression] = STATE(424),
    [sym_binary_expression] = STATE(424),
    [sym_unary_expression] = STATE(424),
    [sym_update_expression] = STATE(424),
    [sym_string] = STATE(426),
    [sym_template_string] = STATE(426),
    [sym_regex] = STATE(426),
    [sym_meta_property] = STATE(426),
    [sym_decorator] = STATE(750),
    [sym_formal_parameters] = STATE(1322),
    [sym_pattern] = STATE(930),
    [sym_rest_pattern] = STATE(895),
    [aux_sym_export_statement_repeat1] = STATE(924),
    [aux_sym_array_repeat1] = STATE(968),
    [aux_sym_array_pattern_repeat1] = STATE(1013),
    [sym_identifier] = ACTIONS(529),
    [anon_sym_export] = ACTIONS(531),
    [anon_sym_LBRACE] = ACTIONS(397),
    [anon_sym_COMMA] = ACTIONS(533),
    [anon_sym_import] = ACTIONS(331),
    [anon_sym_LPAREN] = ACTIONS(333),
    [anon_sym_await] = ACTIONS(335),
    [anon_sym_yield] = ACTIONS(339),
    [anon_sym_LBRACK] = ACTIONS(403),
    [anon_sym_RBRACK] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(537),
    [anon_sym_SLASH] = ACTIONS(345),
    [anon_sym_class] = ACTIONS(347),
    [anon_sym_async] = ACTIONS(539),
    [anon_sym_function] = ACTIONS(351),
    [anon_sym_new] = ACTIONS(353),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(541),
    [anon_sym_PLUS] = ACTIONS(355),
    [anon_sym_DASH] = ACTIONS(355),
    [anon_sym_BANG] = ACTIONS(357),
    [anon_sym_TILDE] = ACTIONS(357),
    [anon_sym_typeof] = ACTIONS(359),
    [anon_sym_void] = ACTIONS(359),
    [anon_sym_delete] = ACTIONS(359),
    [anon_sym_PLUS_PLUS] = ACTIONS(361),
    [anon_sym_DASH_DASH] = ACTIONS(361),
    [anon_sym_DQUOTE] = ACTIONS(363),
    [anon_sym_SQUOTE] = ACTIONS(365),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(367),
    [sym_number] = ACTIONS(369),
    [sym_this] = ACTIONS(371),
    [sym_super] = ACTIONS(371),
    [sym_true] = ACTIONS(371),
    [sym_false] = ACTIONS(371),
    [sym_null] = ACTIONS(371),
    [sym_undefined] = ACTIONS(371),
    [anon_sym_AT] = ACTIONS(85),
    [anon_sym_static] = ACTIONS(531),
    [anon_sym_get] = ACTIONS(531),
    [anon_sym_set] = ACTIONS(531),
  },
  [67] = {
    [sym_import] = STATE(539),
    [sym_expression_statement] = STATE(78),
    [sym_variable_declaration] = STATE(78),
    [sym_lexical_declaration] = STATE(78),
    [sym_empty_statement] = STATE(78),
    [sym_parenthesized_expression] = STATE(363),
    [sym_expression] = STATE(522),
    [sym_primary_expression] = STATE(546),
    [sym_yield_expression] = STATE(550),
    [sym_object] = STATE(539),
    [sym_object_pattern] = STATE(1011),
    [sym_array] = STATE(539),
    [sym_array_pattern] = STATE(1011),
    [sym_jsx_element] = STATE(550),
    [sym_jsx_fragment] = STATE(550),
    [sym_jsx_opening_element] = STATE(772),
    [sym_jsx_self_closing_element] = STATE(550),
    [sym_class] = STATE(539),
    [sym_function] = STATE(539),
    [sym_generator_function] = STATE(539),
    [sym_arrow_function] = STATE(539),
    [sym_call_expression] = STATE(539),
    [sym_new_expression] = STATE(550),
    [sym_await_expression] = STATE(550),
    [sym_member_expression] = STATE(363),
    [sym_subscript_expression] = STATE(363),
    [sym_assignment_expression] = STATE(550),
    [sym__augmented_assignment_lhs] = STATE(720),
    [sym_augmented_assignment_expression] = STATE(550),
    [sym__destructuring_pattern] = STATE(1011),
    [sym_ternary_expression] = STATE(550),
    [sym_binary_expression] = STATE(550),
    [sym_unary_expression] = STATE(550),
    [sym_update_expression] = STATE(550),
    [sym_sequence_expression] = STATE(1156),
    [sym_string] = STATE(539),
    [sym_template_string] = STATE(539),
    [sym_regex] = STATE(539),
    [sym_meta_property] = STATE(539),
    [sym_decorator] = STATE(750),
    [sym_formal_parameters] = STATE(1318),
    [aux_sym_export_statement_repeat1] = STATE(925),
    [sym_identifier] = ACTIONS(547),
    [anon_sym_export] = ACTIONS(549),
    [anon_sym_LBRACE] = ACTIONS(551),
    [anon_sym_import] = ACTIONS(381),
    [anon_sym_var] = ACTIONS(553),
    [anon_sym_let] = ACTIONS(555),
    [anon_sym_const] = ACTIONS(555),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(49),
    [anon_sym_yield] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(557),
    [anon_sym_LT] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(385),
    [anon_sym_async] = ACTIONS(559),
    [anon_sym_function] = ACTIONS(389),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_typeof] = ACTIONS(71),
    [anon_sym_void] = ACTIONS(71),
    [anon_sym_delete] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DQUOTE] = ACTIONS(75),
    [anon_sym_SQUOTE] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(79),
    [sym_number] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(83),
    [sym_true] = ACTIONS(83),
    [sym_false] = ACTIONS(83),
    [sym_null] = ACTIONS(83),
    [sym_undefined] = ACTIONS(83),
    [anon_sym_AT] = ACTIONS(85),
    [anon_sym_static] = ACTIONS(549),
    [anon_sym_get] = ACTIONS(549),
    [anon_sym_set] = ACTIONS(549),
  },
  [68] = {
    [sym_import] = STATE(426),
    [sym_parenthesized_expression] = STATE(355),
    [sym_expression] = STATE(525),
    [sym_primary_expression] = STATE(425),
    [sym_yield_expression] = STATE(424),
    [sym_object] = STATE(426),
    [sym_object_pattern] = STATE(919),
    [sym_assignment_pattern] = STATE(1026),
    [sym_array] = STATE(426),
    [sym_array_pattern] = STATE(919),
    [sym_jsx_element] = STATE(424),
    [sym_jsx_fragment] = STATE(424),
    [sym_jsx_opening_element] = STATE(768),
    [sym_jsx_self_closing_element] = STATE(424),
    [sym_class] = STATE(426),
    [sym_function] = STATE(426),
    [sym_generator_function] = STATE(426),
    [sym_arrow_function] = STATE(426),
    [sym_call_expression] = STATE(426),
    [sym_new_expression] = STATE(424),
    [sym_await_expression] = STATE(424),
    [sym_member_expression] = STATE(355),
    [sym_subscript_expression] = STATE(355),
    [sym_assignment_expression] = STATE(424),
    [sym__augmented_assignment_lhs] = STATE(714),
    [sym_augmented_assignment_expression] = STATE(424),
    [sym__destructuring_pattern] = STATE(919),
    [sym_spread_element] = STATE(1034),
    [sym_ternary_expression] = STATE(424),
    [sym_binary_expression] = STATE(424),
    [sym_unary_expression] = STATE(424),
    [sym_update_expression] = STATE(424),
    [sym_string] = STATE(426),
    [sym_template_string] = STATE(426),
    [sym_regex] = STATE(426),
    [sym_meta_property] = STATE(426),
    [sym_decorator] = STATE(750),
    [sym_formal_parameters] = STATE(1322),
    [sym_pattern] = STATE(930),
    [sym_rest_pattern] = STATE(895),
    [aux_sym_export_statement_repeat1] = STATE(924),
    [aux_sym_array_repeat1] = STATE(1036),
    [aux_sym_array_pattern_repeat1] = STATE(1013),
    [sym_identifier] = ACTIONS(529),
    [anon_sym_export] = ACTIONS(531),
    [anon_sym_LBRACE] = ACTIONS(397),
    [anon_sym_COMMA] = ACTIONS(533),
    [anon_sym_import] = ACTIONS(331),
    [anon_sym_LPAREN] = ACTIONS(333),
    [anon_sym_await] = ACTIONS(335),
    [anon_sym_yield] = ACTIONS(339),
    [anon_sym_LBRACK] = ACTIONS(403),
    [anon_sym_RBRACK] = ACTIONS(563),
    [anon_sym_LT] = ACTIONS(537),
    [anon_sym_SLASH] = ACTIONS(345),
    [anon_sym_class] = ACTIONS(347),
    [anon_sym_async] = ACTIONS(539),
    [anon_sym_function] = ACTIONS(351),
    [anon_sym_new] = ACTIONS(353),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(541),
    [anon_sym_PLUS] = ACTIONS(355),
    [anon_sym_DASH] = ACTIONS(355),
    [anon_sym_BANG] = ACTIONS(357),
    [anon_sym_TILDE] = ACTIONS(357),
    [anon_sym_typeof] = ACTIONS(359),
    [anon_sym_void] = ACTIONS(359),
    [anon_sym_delete] = ACTIONS(359),
    [anon_sym_PLUS_PLUS] = ACTIONS(361),
    [anon_sym_DASH_DASH] = ACTIONS(361),
    [anon_sym_DQUOTE] = ACTIONS(363),
    [anon_sym_SQUOTE] = ACTIONS(365),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(367),
    [sym_number] = ACTIONS(369),
    [sym_this] = ACTIONS(371),
    [sym_super] = ACTIONS(371),
    [sym_true] = ACTIONS(371),
    [sym_false] = ACTIONS(371),
    [sym_null] = ACTIONS(371),
    [sym_undefined] = ACTIONS(371),
    [anon_sym_AT] = ACTIONS(85),
    [anon_sym_static] = ACTIONS(531),
    [anon_sym_get] = ACTIONS(531),
    [anon_sym_set] = ACTIONS(531),
  },
  [69] = {
    [sym_import] = STATE(426),
    [sym_parenthesized_expression] = STATE(355),
    [sym_expression] = STATE(515),
    [sym_primary_expression] = STATE(425),
    [sym_yield_expression] = STATE(424),
    [sym_object] = STATE(426),
    [sym_object_pattern] = STATE(919),
    [sym_assignment_pattern] = STATE(1026),
    [sym_array] = STATE(426),
    [sym_array_pattern] = STATE(919),
    [sym_jsx_element] = STATE(424),
    [sym_jsx_fragment] = STATE(424),
    [sym_jsx_opening_element] = STATE(768),
    [sym_jsx_self_closing_element] = STATE(424),
    [sym_class] = STATE(426),
    [sym_function] = STATE(426),
    [sym_generator_function] = STATE(426),
    [sym_arrow_function] = STATE(426),
    [sym_call_expression] = STATE(426),
    [sym_new_expression] = STATE(424),
    [sym_await_expression] = STATE(424),
    [sym_member_expression] = STATE(355),
    [sym_subscript_expression] = STATE(355),
    [sym_assignment_expression] = STATE(424),
    [sym__augmented_assignment_lhs] = STATE(714),
    [sym_augmented_assignment_expression] = STATE(424),
    [sym__destructuring_pattern] = STATE(919),
    [sym_spread_element] = STATE(1025),
    [sym_ternary_expression] = STATE(424),
    [sym_binary_expression] = STATE(424),
    [sym_unary_expression] = STATE(424),
    [sym_update_expression] = STATE(424),
    [sym_string] = STATE(426),
    [sym_template_string] = STATE(426),
    [sym_regex] = STATE(426),
    [sym_meta_property] = STATE(426),
    [sym_decorator] = STATE(750),
    [sym_formal_parameters] = STATE(1322),
    [sym_pattern] = STATE(930),
    [sym_rest_pattern] = STATE(895),
    [aux_sym_export_statement_repeat1] = STATE(924),
    [aux_sym_array_repeat1] = STATE(968),
    [aux_sym_array_pattern_repeat1] = STATE(1013),
    [sym_identifier] = ACTIONS(529),
    [anon_sym_export] = ACTIONS(531),
    [anon_sym_LBRACE] = ACTIONS(397),
    [anon_sym_COMMA] = ACTIONS(533),
    [anon_sym_import] = ACTIONS(331),
    [anon_sym_LPAREN] = ACTIONS(333),
    [anon_sym_await] = ACTIONS(335),
    [anon_sym_yield] = ACTIONS(339),
    [anon_sym_LBRACK] = ACTIONS(403),
    [anon_sym_RBRACK] = ACTIONS(565),
    [anon_sym_LT] = ACTIONS(537),
    [anon_sym_SLASH] = ACTIONS(345),
    [anon_sym_class] = ACTIONS(347),
    [anon_sym_async] = ACTIONS(539),
    [anon_sym_function] = ACTIONS(351),
    [anon_sym_new] = ACTIONS(353),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(541),
    [anon_sym_PLUS] = ACTIONS(355),
    [anon_sym_DASH] = ACTIONS(355),
    [anon_sym_BANG] = ACTIONS(357),
    [anon_sym_TILDE] = ACTIONS(357),
    [anon_sym_typeof] = ACTIONS(359),
    [anon_sym_void] = ACTIONS(359),
    [anon_sym_delete] = ACTIONS(359),
    [anon_sym_PLUS_PLUS] = ACTIONS(361),
    [anon_sym_DASH_DASH] = ACTIONS(361),
    [anon_sym_DQUOTE] = ACTIONS(363),
    [anon_sym_SQUOTE] = ACTIONS(365),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(367),
    [sym_number] = ACTIONS(369),
    [sym_this] = ACTIONS(371),
    [sym_super] = ACTIONS(371),
    [sym_true] = ACTIONS(371),
    [sym_false] = ACTIONS(371),
    [sym_null] = ACTIONS(371),
    [sym_undefined] = ACTIONS(371),
    [anon_sym_AT] = ACTIONS(85),
    [anon_sym_static] = ACTIONS(531),
    [anon_sym_get] = ACTIONS(531),
    [anon_sym_set] = ACTIONS(531),
  },
  [70] = {
    [sym_import] = STATE(426),
    [sym_parenthesized_expression] = STATE(355),
    [sym_expression] = STATE(506),
    [sym_primary_expression] = STATE(425),
    [sym_yield_expression] = STATE(424),
    [sym_object] = STATE(426),
    [sym_object_pattern] = STATE(919),
    [sym_assignment_pattern] = STATE(1026),
    [sym_array] = STATE(426),
    [sym_array_pattern] = STATE(919),
    [sym_jsx_element] = STATE(424),
    [sym_jsx_fragment] = STATE(424),
    [sym_jsx_opening_element] = STATE(768),
    [sym_jsx_self_closing_element] = STATE(424),
    [sym_class] = STATE(426),
    [sym_function] = STATE(426),
    [sym_generator_function] = STATE(426),
    [sym_arrow_function] = STATE(426),
    [sym_call_expression] = STATE(426),
    [sym_new_expression] = STATE(424),
    [sym_await_expression] = STATE(424),
    [sym_member_expression] = STATE(355),
    [sym_subscript_expression] = STATE(355),
    [sym_assignment_expression] = STATE(424),
    [sym__augmented_assignment_lhs] = STATE(714),
    [sym_augmented_assignment_expression] = STATE(424),
    [sym__destructuring_pattern] = STATE(919),
    [sym_spread_element] = STATE(1025),
    [sym_ternary_expression] = STATE(424),
    [sym_binary_expression] = STATE(424),
    [sym_unary_expression] = STATE(424),
    [sym_update_expression] = STATE(424),
    [sym_string] = STATE(426),
    [sym_template_string] = STATE(426),
    [sym_regex] = STATE(426),
    [sym_meta_property] = STATE(426),
    [sym_decorator] = STATE(750),
    [sym_formal_parameters] = STATE(1322),
    [sym_pattern] = STATE(930),
    [sym_rest_pattern] = STATE(895),
    [aux_sym_export_statement_repeat1] = STATE(924),
    [aux_sym_array_repeat1] = STATE(968),
    [aux_sym_array_pattern_repeat1] = STATE(1013),
    [sym_identifier] = ACTIONS(529),
    [anon_sym_export] = ACTIONS(531),
    [anon_sym_LBRACE] = ACTIONS(397),
    [anon_sym_COMMA] = ACTIONS(533),
    [anon_sym_import] = ACTIONS(331),
    [anon_sym_LPAREN] = ACTIONS(333),
    [anon_sym_await] = ACTIONS(335),
    [anon_sym_yield] = ACTIONS(339),
    [anon_sym_LBRACK] = ACTIONS(403),
    [anon_sym_RBRACK] = ACTIONS(565),
    [anon_sym_LT] = ACTIONS(537),
    [anon_sym_SLASH] = ACTIONS(345),
    [anon_sym_class] = ACTIONS(347),
    [anon_sym_async] = ACTIONS(539),
    [anon_sym_function] = ACTIONS(351),
    [anon_sym_new] = ACTIONS(353),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(541),
    [anon_sym_PLUS] = ACTIONS(355),
    [anon_sym_DASH] = ACTIONS(355),
    [anon_sym_BANG] = ACTIONS(357),
    [anon_sym_TILDE] = ACTIONS(357),
    [anon_sym_typeof] = ACTIONS(359),
    [anon_sym_void] = ACTIONS(359),
    [anon_sym_delete] = ACTIONS(359),
    [anon_sym_PLUS_PLUS] = ACTIONS(361),
    [anon_sym_DASH_DASH] = ACTIONS(361),
    [anon_sym_DQUOTE] = ACTIONS(363),
    [anon_sym_SQUOTE] = ACTIONS(365),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(367),
    [sym_number] = ACTIONS(369),
    [sym_this] = ACTIONS(371),
    [sym_super] = ACTIONS(371),
    [sym_true] = ACTIONS(371),
    [sym_false] = ACTIONS(371),
    [sym_null] = ACTIONS(371),
    [sym_undefined] = ACTIONS(371),
    [anon_sym_AT] = ACTIONS(85),
    [anon_sym_static] = ACTIONS(531),
    [anon_sym_get] = ACTIONS(531),
    [anon_sym_set] = ACTIONS(531),
  },
  [71] = {
    [sym_import] = STATE(426),
    [sym_parenthesized_expression] = STATE(355),
    [sym_expression] = STATE(510),
    [sym_primary_expression] = STATE(425),
    [sym_yield_expression] = STATE(424),
    [sym_object] = STATE(426),
    [sym_object_pattern] = STATE(919),
    [sym_assignment_pattern] = STATE(1140),
    [sym_array] = STATE(426),
    [sym_array_pattern] = STATE(919),
    [sym_jsx_element] = STATE(424),
    [sym_jsx_fragment] = STATE(424),
    [sym_jsx_opening_element] = STATE(768),
    [sym_jsx_self_closing_element] = STATE(424),
    [sym_class] = STATE(426),
    [sym_function] = STATE(426),
    [sym_generator_function] = STATE(426),
    [sym_arrow_function] = STATE(426),
    [sym_call_expression] = STATE(426),
    [sym_new_expression] = STATE(424),
    [sym_await_expression] = STATE(424),
    [sym_member_expression] = STATE(355),
    [sym_subscript_expression] = STATE(355),
    [sym_assignment_expression] = STATE(424),
    [sym__augmented_assignment_lhs] = STATE(714),
    [sym_augmented_assignment_expression] = STATE(424),
    [sym__destructuring_pattern] = STATE(919),
    [sym_spread_element] = STATE(1022),
    [sym_ternary_expression] = STATE(424),
    [sym_binary_expression] = STATE(424),
    [sym_unary_expression] = STATE(424),
    [sym_update_expression] = STATE(424),
    [sym_string] = STATE(426),
    [sym_template_string] = STATE(426),
    [sym_regex] = STATE(426),
    [sym_meta_property] = STATE(426),
    [sym_decorator] = STATE(750),
    [sym_formal_parameters] = STATE(1322),
    [sym_pattern] = STATE(1027),
    [sym_rest_pattern] = STATE(895),
    [aux_sym_export_statement_repeat1] = STATE(924),
    [sym_identifier] = ACTIONS(529),
    [anon_sym_export] = ACTIONS(531),
    [anon_sym_LBRACE] = ACTIONS(397),
    [anon_sym_COMMA] = ACTIONS(567),
    [anon_sym_import] = ACTIONS(331),
    [anon_sym_LPAREN] = ACTIONS(333),
    [anon_sym_await] = ACTIONS(335),
    [anon_sym_yield] = ACTIONS(339),
    [anon_sym_LBRACK] = ACTIONS(403),
    [anon_sym_RBRACK] = ACTIONS(567),
    [anon_sym_LT] = ACTIONS(537),
    [anon_sym_SLASH] = ACTIONS(345),
    [anon_sym_class] = ACTIONS(347),
    [anon_sym_async] = ACTIONS(539),
    [anon_sym_function] = ACTIONS(351),
    [anon_sym_new] = ACTIONS(353),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(541),
    [anon_sym_PLUS] = ACTIONS(355),
    [anon_sym_DASH] = ACTIONS(355),
    [anon_sym_BANG] = ACTIONS(357),
    [anon_sym_TILDE] = ACTIONS(357),
    [anon_sym_typeof] = ACTIONS(359),
    [anon_sym_void] = ACTIONS(359),
    [anon_sym_delete] = ACTIONS(359),
    [anon_sym_PLUS_PLUS] = ACTIONS(361),
    [anon_sym_DASH_DASH] = ACTIONS(361),
    [anon_sym_DQUOTE] = ACTIONS(363),
    [anon_sym_SQUOTE] = ACTIONS(365),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(367),
    [sym_number] = ACTIONS(369),
    [sym_this] = ACTIONS(371),
    [sym_super] = ACTIONS(371),
    [sym_true] = ACTIONS(371),
    [sym_false] = ACTIONS(371),
    [sym_null] = ACTIONS(371),
    [sym_undefined] = ACTIONS(371),
    [anon_sym_AT] = ACTIONS(85),
    [anon_sym_static] = ACTIONS(531),
    [anon_sym_get] = ACTIONS(531),
    [anon_sym_set] = ACTIONS(531),
  },
  [72] = {
    [sym_import] = STATE(426),
    [sym_parenthesized_expression] = STATE(355),
    [sym_expression] = STATE(637),
    [sym_primary_expression] = STATE(425),
    [sym_yield_expression] = STATE(424),
    [sym_object] = STATE(426),
    [sym_object_pattern] = STATE(919),
    [sym_assignment_pattern] = STATE(1026),
    [sym_array] = STATE(426),
    [sym_array_pattern] = STATE(919),
    [sym_jsx_element] = STATE(424),
    [sym_jsx_fragment] = STATE(424),
    [sym_jsx_opening_element] = STATE(768),
    [sym_jsx_self_closing_element] = STATE(424),
    [sym_class] = STATE(426),
    [sym_function] = STATE(426),
    [sym_generator_function] = STATE(426),
    [sym_arrow_function] = STATE(426),
    [sym_call_expression] = STATE(426),
    [sym_new_expression] = STATE(424),
    [sym_await_expression] = STATE(424),
    [sym_member_expression] = STATE(355),
    [sym_subscript_expression] = STATE(355),
    [sym_assignment_expression] = STATE(424),
    [sym__augmented_assignment_lhs] = STATE(714),
    [sym_augmented_assignment_expression] = STATE(424),
    [sym__destructuring_pattern] = STATE(919),
    [sym_ternary_expression] = STATE(424),
    [sym_binary_expression] = STATE(424),
    [sym_unary_expression] = STATE(424),
    [sym_update_expression] = STATE(424),
    [sym_string] = STATE(426),
    [sym_template_string] = STATE(426),
    [sym_regex] = STATE(426),
    [sym_meta_property] = STATE(426),
    [sym_decorator] = STATE(750),
    [sym_formal_parameters] = STATE(1322),
    [sym_pattern] = STATE(930),
    [sym_rest_pattern] = STATE(895),
    [aux_sym_export_statement_repeat1] = STATE(924),
    [aux_sym_array_pattern_repeat1] = STATE(1013),
    [sym_identifier] = ACTIONS(570),
    [anon_sym_export] = ACTIONS(572),
    [anon_sym_LBRACE] = ACTIONS(574),
    [anon_sym_COMMA] = ACTIONS(576),
    [anon_sym_import] = ACTIONS(331),
    [anon_sym_LPAREN] = ACTIONS(333),
    [anon_sym_await] = ACTIONS(335),
    [anon_sym_yield] = ACTIONS(339),
    [anon_sym_LBRACK] = ACTIONS(578),
    [anon_sym_RBRACK] = ACTIONS(580),
    [anon_sym_LT] = ACTIONS(537),
    [anon_sym_SLASH] = ACTIONS(345),
    [anon_sym_class] = ACTIONS(347),
    [anon_sym_async] = ACTIONS(582),
    [anon_sym_function] = ACTIONS(351),
    [anon_sym_new] = ACTIONS(353),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(584),
    [anon_sym_PLUS] = ACTIONS(355),
    [anon_sym_DASH] = ACTIONS(355),
    [anon_sym_BANG] = ACTIONS(357),
    [anon_sym_TILDE] = ACTIONS(357),
    [anon_sym_typeof] = ACTIONS(359),
    [anon_sym_void] = ACTIONS(359),
    [anon_sym_delete] = ACTIONS(359),
    [anon_sym_PLUS_PLUS] = ACTIONS(361),
    [anon_sym_DASH_DASH] = ACTIONS(361),
    [anon_sym_DQUOTE] = ACTIONS(363),
    [anon_sym_SQUOTE] = ACTIONS(365),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(367),
    [sym_number] = ACTIONS(369),
    [sym_this] = ACTIONS(371),
    [sym_super] = ACTIONS(371),
    [sym_true] = ACTIONS(371),
    [sym_false] = ACTIONS(371),
    [sym_null] = ACTIONS(371),
    [sym_undefined] = ACTIONS(371),
    [anon_sym_AT] = ACTIONS(85),
    [anon_sym_static] = ACTIONS(572),
    [anon_sym_get] = ACTIONS(572),
    [anon_sym_set] = ACTIONS(572),
  },
  [73] = {
    [sym_import] = STATE(426),
    [sym_parenthesized_expression] = STATE(355),
    [sym_expression] = STATE(549),
    [sym_primary_expression] = STATE(425),
    [sym_yield_expression] = STATE(424),
    [sym_object] = STATE(426),
    [sym_object_pattern] = STATE(919),
    [sym_assignment_pattern] = STATE(1030),
    [sym_array] = STATE(426),
    [sym_array_pattern] = STATE(919),
    [sym_jsx_element] = STATE(424),
    [sym_jsx_fragment] = STATE(424),
    [sym_jsx_opening_element] = STATE(768),
    [sym_jsx_self_closing_element] = STATE(424),
    [sym_class] = STATE(426),
    [sym_function] = STATE(426),
    [sym_generator_function] = STATE(426),
    [sym_arrow_function] = STATE(426),
    [sym_call_expression] = STATE(426),
    [sym_new_expression] = STATE(424),
    [sym_await_expression] = STATE(424),
    [sym_member_expression] = STATE(355),
    [sym_subscript_expression] = STATE(355),
    [sym_assignment_expression] = STATE(424),
    [sym__augmented_assignment_lhs] = STATE(714),
    [sym_augmented_assignment_expression] = STATE(424),
    [sym__destructuring_pattern] = STATE(919),
    [sym_ternary_expression] = STATE(424),
    [sym_binary_expression] = STATE(424),
    [sym_unary_expression] = STATE(424),
    [sym_update_expression] = STATE(424),
    [sym_sequence_expression] = STATE(1300),
    [sym_string] = STATE(426),
    [sym_template_string] = STATE(426),
    [sym_regex] = STATE(426),
    [sym_meta_property] = STATE(426),
    [sym_decorator] = STATE(750),
    [sym_formal_parameters] = STATE(1322),
    [sym_pattern] = STATE(921),
    [sym_rest_pattern] = STATE(895),
    [aux_sym_export_statement_repeat1] = STATE(924),
    [sym_identifier] = ACTIONS(529),
    [anon_sym_export] = ACTIONS(531),
    [anon_sym_LBRACE] = ACTIONS(397),
    [anon_sym_import] = ACTIONS(331),
    [anon_sym_LPAREN] = ACTIONS(333),
    [anon_sym_RPAREN] = ACTIONS(586),
    [anon_sym_await] = ACTIONS(335),
    [anon_sym_yield] = ACTIONS(339),
    [anon_sym_LBRACK] = ACTIONS(403),
    [anon_sym_LT] = ACTIONS(537),
    [anon_sym_SLASH] = ACTIONS(345),
    [anon_sym_class] = ACTIONS(347),
    [anon_sym_async] = ACTIONS(539),
    [anon_sym_function] = ACTIONS(351),
    [anon_sym_new] = ACTIONS(353),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(584),
    [anon_sym_PLUS] = ACTIONS(355),
    [anon_sym_DASH] = ACTIONS(355),
    [anon_sym_BANG] = ACTIONS(357),
    [anon_sym_TILDE] = ACTIONS(357),
    [anon_sym_typeof] = ACTIONS(359),
    [anon_sym_void] = ACTIONS(359),
    [anon_sym_delete] = ACTIONS(359),
    [anon_sym_PLUS_PLUS] = ACTIONS(361),
    [anon_sym_DASH_DASH] = ACTIONS(361),
    [anon_sym_DQUOTE] = ACTIONS(363),
    [anon_sym_SQUOTE] = ACTIONS(365),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(367),
    [sym_number] = ACTIONS(369),
    [sym_this] = ACTIONS(371),
    [sym_super] = ACTIONS(371),
    [sym_true] = ACTIONS(371),
    [sym_false] = ACTIONS(371),
    [sym_null] = ACTIONS(371),
    [sym_undefined] = ACTIONS(371),
    [anon_sym_AT] = ACTIONS(85),
    [anon_sym_static] = ACTIONS(531),
    [anon_sym_get] = ACTIONS(531),
    [anon_sym_set] = ACTIONS(531),
  },
  [74] = {
    [sym_import] = STATE(426),
    [sym_parenthesized_expression] = STATE(355),
    [sym_expression] = STATE(602),
    [sym_primary_expression] = STATE(425),
    [sym_yield_expression] = STATE(424),
    [sym_object] = STATE(426),
    [sym_object_pattern] = STATE(919),
    [sym_assignment_pattern] = STATE(1030),
    [sym_array] = STATE(426),
    [sym_array_pattern] = STATE(919),
    [sym_jsx_element] = STATE(424),
    [sym_jsx_fragment] = STATE(424),
    [sym_jsx_opening_element] = STATE(768),
    [sym_jsx_self_closing_element] = STATE(424),
    [sym_class] = STATE(426),
    [sym_function] = STATE(426),
    [sym_generator_function] = STATE(426),
    [sym_arrow_function] = STATE(426),
    [sym_call_expression] = STATE(426),
    [sym_new_expression] = STATE(424),
    [sym_await_expression] = STATE(424),
    [sym_member_expression] = STATE(355),
    [sym_subscript_expression] = STATE(355),
    [sym_assignment_expression] = STATE(424),
    [sym__augmented_assignment_lhs] = STATE(714),
    [sym_augmented_assignment_expression] = STATE(424),
    [sym__destructuring_pattern] = STATE(919),
    [sym_ternary_expression] = STATE(424),
    [sym_binary_expression] = STATE(424),
    [sym_unary_expression] = STATE(424),
    [sym_update_expression] = STATE(424),
    [sym_sequence_expression] = STATE(1252),
    [sym_string] = STATE(426),
    [sym_template_string] = STATE(426),
    [sym_regex] = STATE(426),
    [sym_meta_property] = STATE(426),
    [sym_decorator] = STATE(750),
    [sym_formal_parameters] = STATE(1322),
    [sym_pattern] = STATE(921),
    [sym_rest_pattern] = STATE(895),
    [aux_sym_export_statement_repeat1] = STATE(924),
    [sym_identifier] = ACTIONS(529),
    [anon_sym_export] = ACTIONS(531),
    [anon_sym_LBRACE] = ACTIONS(397),
    [anon_sym_import] = ACTIONS(331),
    [anon_sym_LPAREN] = ACTIONS(333),
    [anon_sym_RPAREN] = ACTIONS(586),
    [anon_sym_await] = ACTIONS(335),
    [anon_sym_yield] = ACTIONS(339),
    [anon_sym_LBRACK] = ACTIONS(403),
    [anon_sym_LT] = ACTIONS(537),
    [anon_sym_SLASH] = ACTIONS(345),
    [anon_sym_class] = ACTIONS(347),
    [anon_sym_async] = ACTIONS(539),
    [anon_sym_function] = ACTIONS(351),
    [anon_sym_new] = ACTIONS(353),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(584),
    [anon_sym_PLUS] = ACTIONS(355),
    [anon_sym_DASH] = ACTIONS(355),
    [anon_sym_BANG] = ACTIONS(357),
    [anon_sym_TILDE] = ACTIONS(357),
    [anon_sym_typeof] = ACTIONS(359),
    [anon_sym_void] = ACTIONS(359),
    [anon_sym_delete] = ACTIONS(359),
    [anon_sym_PLUS_PLUS] = ACTIONS(361),
    [anon_sym_DASH_DASH] = ACTIONS(361),
    [anon_sym_DQUOTE] = ACTIONS(363),
    [anon_sym_SQUOTE] = ACTIONS(365),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(367),
    [sym_number] = ACTIONS(369),
    [sym_this] = ACTIONS(371),
    [sym_super] = ACTIONS(371),
    [sym_true] = ACTIONS(371),
    [sym_false] = ACTIONS(371),
    [sym_null] = ACTIONS(371),
    [sym_undefined] = ACTIONS(371),
    [anon_sym_AT] = ACTIONS(85),
    [anon_sym_static] = ACTIONS(531),
    [anon_sym_get] = ACTIONS(531),
    [anon_sym_set] = ACTIONS(531),
  },
  [75] = {
    [sym_import] = STATE(426),
    [sym_parenthesized_expression] = STATE(355),
    [sym_expression] = STATE(526),
    [sym_primary_expression] = STATE(425),
    [sym_yield_expression] = STATE(424),
    [sym_object] = STATE(426),
    [sym_object_pattern] = STATE(1333),
    [sym_array] = STATE(426),
    [sym_array_pattern] = STATE(1333),
    [sym_jsx_element] = STATE(424),
    [sym_jsx_fragment] = STATE(424),
    [sym_jsx_opening_element] = STATE(768),
    [sym_jsx_self_closing_element] = STATE(424),
    [sym_class] = STATE(426),
    [sym_function] = STATE(426),
    [sym_generator_function] = STATE(426),
    [sym_arrow_function] = STATE(426),
    [sym_call_expression] = STATE(426),
    [sym_new_expression] = STATE(424),
    [sym_await_expression] = STATE(424),
    [sym_member_expression] = STATE(355),
    [sym_subscript_expression] = STATE(355),
    [sym_assignment_expression] = STATE(424),
    [sym__augmented_assignment_lhs] = STATE(714),
    [sym_augmented_assignment_expression] = STATE(424),
    [sym__destructuring_pattern] = STATE(1333),
    [sym_spread_element] = STATE(1073),
    [sym_ternary_expression] = STATE(424),
    [sym_binary_expression] = STATE(424),
    [sym_unary_expression] = STATE(424),
    [sym_update_expression] = STATE(424),
    [sym_string] = STATE(426),
    [sym_template_string] = STATE(426),
    [sym_regex] = STATE(426),
    [sym_meta_property] = STATE(426),
    [sym_decorator] = STATE(750),
    [sym_formal_parameters] = STATE(1322),
    [aux_sym_export_statement_repeat1] = STATE(924),
    [aux_sym_array_repeat1] = STATE(970),
    [sym_identifier] = ACTIONS(321),
    [anon_sym_export] = ACTIONS(323),
    [anon_sym_LBRACE] = ACTIONS(327),
    [anon_sym_COMMA] = ACTIONS(588),
    [anon_sym_import] = ACTIONS(331),
    [anon_sym_LPAREN] = ACTIONS(333),
    [anon_sym_RPAREN] = ACTIONS(590),
    [anon_sym_await] = ACTIONS(335),
    [anon_sym_yield] = ACTIONS(339),
    [anon_sym_LBRACK] = ACTIONS(341),
    [anon_sym_LT] = ACTIONS(537),
    [anon_sym_SLASH] = ACTIONS(345),
    [anon_sym_class] = ACTIONS(347),
    [anon_sym_async] = ACTIONS(349),
    [anon_sym_function] = ACTIONS(351),
    [anon_sym_new] = ACTIONS(353),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(592),
    [anon_sym_PLUS] = ACTIONS(355),
    [anon_sym_DASH] = ACTIONS(355),
    [anon_sym_BANG] = ACTIONS(357),
    [anon_sym_TILDE] = ACTIONS(357),
    [anon_sym_typeof] = ACTIONS(359),
    [anon_sym_void] = ACTIONS(359),
    [anon_sym_delete] = ACTIONS(359),
    [anon_sym_PLUS_PLUS] = ACTIONS(361),
    [anon_sym_DASH_DASH] = ACTIONS(361),
    [anon_sym_DQUOTE] = ACTIONS(363),
    [anon_sym_SQUOTE] = ACTIONS(365),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(367),
    [sym_number] = ACTIONS(369),
    [sym_this] = ACTIONS(371),
    [sym_super] = ACTIONS(371),
    [sym_true] = ACTIONS(371),
    [sym_false] = ACTIONS(371),
    [sym_null] = ACTIONS(371),
    [sym_undefined] = ACTIONS(371),
    [anon_sym_AT] = ACTIONS(85),
    [anon_sym_static] = ACTIONS(323),
    [anon_sym_get] = ACTIONS(323),
    [anon_sym_set] = ACTIONS(323),
  },
  [76] = {
    [sym_import] = STATE(426),
    [sym_parenthesized_expression] = STATE(355),
    [sym_expression] = STATE(510),
    [sym_primary_expression] = STATE(425),
    [sym_yield_expression] = STATE(424),
    [sym_object] = STATE(426),
    [sym_object_pattern] = STATE(1333),
    [sym_array] = STATE(426),
    [sym_array_pattern] = STATE(1333),
    [sym_jsx_element] = STATE(424),
    [sym_jsx_fragment] = STATE(424),
    [sym_jsx_opening_element] = STATE(768),
    [sym_jsx_self_closing_element] = STATE(424),
    [sym_class] = STATE(426),
    [sym_function] = STATE(426),
    [sym_generator_function] = STATE(426),
    [sym_arrow_function] = STATE(426),
    [sym_call_expression] = STATE(426),
    [sym_new_expression] = STATE(424),
    [sym_await_expression] = STATE(424),
    [sym_member_expression] = STATE(355),
    [sym_subscript_expression] = STATE(355),
    [sym_assignment_expression] = STATE(424),
    [sym__augmented_assignment_lhs] = STATE(714),
    [sym_augmented_assignment_expression] = STATE(424),
    [sym__destructuring_pattern] = STATE(1333),
    [sym_spread_element] = STATE(1022),
    [sym_ternary_expression] = STATE(424),
    [sym_binary_expression] = STATE(424),
    [sym_unary_expression] = STATE(424),
    [sym_update_expression] = STATE(424),
    [sym_string] = STATE(426),
    [sym_template_string] = STATE(426),
    [sym_regex] = STATE(426),
    [sym_meta_property] = STATE(426),
    [sym_decorator] = STATE(750),
    [sym_formal_parameters] = STATE(1322),
    [aux_sym_export_statement_repeat1] = STATE(924),
    [sym_identifier] = ACTIONS(321),
    [anon_sym_export] = ACTIONS(323),
    [anon_sym_LBRACE] = ACTIONS(327),
    [anon_sym_COMMA] = ACTIONS(594),
    [anon_sym_import] = ACTIONS(331),
    [anon_sym_LPAREN] = ACTIONS(333),
    [anon_sym_RPAREN] = ACTIONS(594),
    [anon_sym_await] = ACTIONS(335),
    [anon_sym_yield] = ACTIONS(339),
    [anon_sym_LBRACK] = ACTIONS(341),
    [anon_sym_RBRACK] = ACTIONS(594),
    [anon_sym_LT] = ACTIONS(537),
    [anon_sym_SLASH] = ACTIONS(345),
    [anon_sym_class] = ACTIONS(347),
    [anon_sym_async] = ACTIONS(349),
    [anon_sym_function] = ACTIONS(351),
    [anon_sym_new] = ACTIONS(353),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(592),
    [anon_sym_PLUS] = ACTIONS(355),
    [anon_sym_DASH] = ACTIONS(355),
    [anon_sym_BANG] = ACTIONS(357),
    [anon_sym_TILDE] = ACTIONS(357),
    [anon_sym_typeof] = ACTIONS(359),
    [anon_sym_void] = ACTIONS(359),
    [anon_sym_delete] = ACTIONS(359),
    [anon_sym_PLUS_PLUS] = ACTIONS(361),
    [anon_sym_DASH_DASH] = ACTIONS(361),
    [anon_sym_DQUOTE] = ACTIONS(363),
    [anon_sym_SQUOTE] = ACTIONS(365),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(367),
    [sym_number] = ACTIONS(369),
    [sym_this] = ACTIONS(371),
    [sym_super] = ACTIONS(371),
    [sym_true] = ACTIONS(371),
    [sym_false] = ACTIONS(371),
    [sym_null] = ACTIONS(371),
    [sym_undefined] = ACTIONS(371),
    [anon_sym_AT] = ACTIONS(85),
    [anon_sym_static] = ACTIONS(323),
    [anon_sym_get] = ACTIONS(323),
    [anon_sym_set] = ACTIONS(323),
  },
  [77] = {
    [sym_import] = STATE(426),
    [sym_parenthesized_expression] = STATE(355),
    [sym_expression] = STATE(531),
    [sym_primary_expression] = STATE(425),
    [sym_yield_expression] = STATE(424),
    [sym_object] = STATE(426),
    [sym_object_pattern] = STATE(1333),
    [sym_array] = STATE(426),
    [sym_array_pattern] = STATE(1333),
    [sym_jsx_element] = STATE(424),
    [sym_jsx_fragment] = STATE(424),
    [sym_jsx_opening_element] = STATE(768),
    [sym_jsx_self_closing_element] = STATE(424),
    [sym_class] = STATE(426),
    [sym_function] = STATE(426),
    [sym_generator_function] = STATE(426),
    [sym_arrow_function] = STATE(426),
    [sym_call_expression] = STATE(426),
    [sym_new_expression] = STATE(424),
    [sym_await_expression] = STATE(424),
    [sym_member_expression] = STATE(355),
    [sym_subscript_expression] = STATE(355),
    [sym_assignment_expression] = STATE(424),
    [sym__augmented_assignment_lhs] = STATE(714),
    [sym_augmented_assignment_expression] = STATE(424),
    [sym__destructuring_pattern] = STATE(1333),
    [sym_spread_element] = STATE(1065),
    [sym_ternary_expression] = STATE(424),
    [sym_binary_expression] = STATE(424),
    [sym_unary_expression] = STATE(424),
    [sym_update_expression] = STATE(424),
    [sym_string] = STATE(426),
    [sym_template_string] = STATE(426),
    [sym_regex] = STATE(426),
    [sym_meta_property] = STATE(426),
    [sym_decorator] = STATE(750),
    [sym_formal_parameters] = STATE(1322),
    [aux_sym_export_statement_repeat1] = STATE(924),
    [aux_sym_array_repeat1] = STATE(1062),
    [sym_identifier] = ACTIONS(321),
    [anon_sym_export] = ACTIONS(323),
    [anon_sym_LBRACE] = ACTIONS(327),
    [anon_sym_COMMA] = ACTIONS(588),
    [anon_sym_import] = ACTIONS(331),
    [anon_sym_LPAREN] = ACTIONS(333),
    [anon_sym_RPAREN] = ACTIONS(596),
    [anon_sym_await] = ACTIONS(335),
    [anon_sym_yield] = ACTIONS(339),
    [anon_sym_LBRACK] = ACTIONS(341),
    [anon_sym_LT] = ACTIONS(537),
    [anon_sym_SLASH] = ACTIONS(345),
    [anon_sym_class] = ACTIONS(347),
    [anon_sym_async] = ACTIONS(349),
    [anon_sym_function] = ACTIONS(351),
    [anon_sym_new] = ACTIONS(353),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(592),
    [anon_sym_PLUS] = ACTIONS(355),
    [anon_sym_DASH] = ACTIONS(355),
    [anon_sym_BANG] = ACTIONS(357),
    [anon_sym_TILDE] = ACTIONS(357),
    [anon_sym_typeof] = ACTIONS(359),
    [anon_sym_void] = ACTIONS(359),
    [anon_sym_delete] = ACTIONS(359),
    [anon_sym_PLUS_PLUS] = ACTIONS(361),
    [anon_sym_DASH_DASH] = ACTIONS(361),
    [anon_sym_DQUOTE] = ACTIONS(363),
    [anon_sym_SQUOTE] = ACTIONS(365),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(367),
    [sym_number] = ACTIONS(369),
    [sym_this] = ACTIONS(371),
    [sym_super] = ACTIONS(371),
    [sym_true] = ACTIONS(371),
    [sym_false] = ACTIONS(371),
    [sym_null] = ACTIONS(371),
    [sym_undefined] = ACTIONS(371),
    [anon_sym_AT] = ACTIONS(85),
    [anon_sym_static] = ACTIONS(323),
    [anon_sym_get] = ACTIONS(323),
    [anon_sym_set] = ACTIONS(323),
  },
  [78] = {
    [sym_import] = STATE(539),
    [sym_expression_statement] = STATE(86),
    [sym_empty_statement] = STATE(86),
    [sym_parenthesized_expression] = STATE(362),
    [sym_expression] = STATE(522),
    [sym_primary_expression] = STATE(546),
    [sym_yield_expression] = STATE(550),
    [sym_object] = STATE(539),
    [sym_object_pattern] = STATE(1320),
    [sym_array] = STATE(539),
    [sym_array_pattern] = STATE(1320),
    [sym_jsx_element] = STATE(550),
    [sym_jsx_fragment] = STATE(550),
    [sym_jsx_opening_element] = STATE(772),
    [sym_jsx_self_closing_element] = STATE(550),
    [sym_class] = STATE(539),
    [sym_function] = STATE(539),
    [sym_generator_function] = STATE(539),
    [sym_arrow_function] = STATE(539),
    [sym_call_expression] = STATE(539),
    [sym_new_expression] = STATE(550),
    [sym_await_expression] = STATE(550),
    [sym_member_expression] = STATE(362),
    [sym_subscript_expression] = STATE(362),
    [sym_assignment_expression] = STATE(550),
    [sym__augmented_assignment_lhs] = STATE(720),
    [sym_augmented_assignment_expression] = STATE(550),
    [sym__destructuring_pattern] = STATE(1320),
    [sym_ternary_expression] = STATE(550),
    [sym_binary_expression] = STATE(550),
    [sym_unary_expression] = STATE(550),
    [sym_update_expression] = STATE(550),
    [sym_sequence_expression] = STATE(1156),
    [sym_string] = STATE(539),
    [sym_template_string] = STATE(539),
    [sym_regex] = STATE(539),
    [sym_meta_property] = STATE(539),
    [sym_decorator] = STATE(750),
    [sym_formal_parameters] = STATE(1318),
    [aux_sym_export_statement_repeat1] = STATE(925),
    [sym_identifier] = ACTIONS(373),
    [anon_sym_export] = ACTIONS(375),
    [anon_sym_LBRACE] = ACTIONS(379),
    [anon_sym_import] = ACTIONS(381),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(49),
    [anon_sym_yield] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(53),
    [anon_sym_LT] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(385),
    [anon_sym_async] = ACTIONS(387),
    [anon_sym_function] = ACTIONS(389),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_typeof] = ACTIONS(71),
    [anon_sym_void] = ACTIONS(71),
    [anon_sym_delete] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DQUOTE] = ACTIONS(75),
    [anon_sym_SQUOTE] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(79),
    [sym_number] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(83),
    [sym_true] = ACTIONS(83),
    [sym_false] = ACTIONS(83),
    [sym_null] = ACTIONS(83),
    [sym_undefined] = ACTIONS(83),
    [anon_sym_AT] = ACTIONS(85),
    [anon_sym_static] = ACTIONS(375),
    [anon_sym_get] = ACTIONS(375),
    [anon_sym_set] = ACTIONS(375),
  },
  [79] = {
    [sym_import] = STATE(426),
    [sym_parenthesized_expression] = STATE(355),
    [sym_expression] = STATE(589),
    [sym_primary_expression] = STATE(425),
    [sym_yield_expression] = STATE(424),
    [sym_object] = STATE(426),
    [sym_object_pattern] = STATE(1333),
    [sym_array] = STATE(426),
    [sym_array_pattern] = STATE(1333),
    [sym_jsx_element] = STATE(424),
    [sym_jsx_fragment] = STATE(424),
    [sym_jsx_opening_element] = STATE(768),
    [sym_jsx_self_closing_element] = STATE(424),
    [sym_class] = STATE(426),
    [sym_function] = STATE(426),
    [sym_generator_function] = STATE(426),
    [sym_arrow_function] = STATE(426),
    [sym_call_expression] = STATE(426),
    [sym_new_expression] = STATE(424),
    [sym_await_expression] = STATE(424),
    [sym_member_expression] = STATE(355),
    [sym_subscript_expression] = STATE(355),
    [sym_assignment_expression] = STATE(424),
    [sym__augmented_assignment_lhs] = STATE(714),
    [sym_augmented_assignment_expression] = STATE(424),
    [sym__destructuring_pattern] = STATE(1333),
    [sym_spread_element] = STATE(1303),
    [sym_ternary_expression] = STATE(424),
    [sym_binary_expression] = STATE(424),
    [sym_unary_expression] = STATE(424),
    [sym_update_expression] = STATE(424),
    [sym_sequence_expression] = STATE(1303),
    [sym_string] = STATE(426),
    [sym_template_string] = STATE(426),
    [sym_regex] = STATE(426),
    [sym_meta_property] = STATE(426),
    [sym_decorator] = STATE(750),
    [sym_formal_parameters] = STATE(1322),
    [aux_sym_export_statement_repeat1] = STATE(924),
    [sym_identifier] = ACTIONS(321),
    [anon_sym_export] = ACTIONS(323),
    [anon_sym_LBRACE] = ACTIONS(327),
    [anon_sym_RBRACE] = ACTIONS(598),
    [anon_sym_import] = ACTIONS(331),
    [anon_sym_LPAREN] = ACTIONS(333),
    [anon_sym_await] = ACTIONS(335),
    [anon_sym_yield] = ACTIONS(339),
    [anon_sym_LBRACK] = ACTIONS(341),
    [anon_sym_LT] = ACTIONS(537),
    [anon_sym_SLASH] = ACTIONS(345),
    [anon_sym_class] = ACTIONS(347),
    [anon_sym_async] = ACTIONS(349),
    [anon_sym_function] = ACTIONS(351),
    [anon_sym_new] = ACTIONS(353),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(592),
    [anon_sym_PLUS] = ACTIONS(355),
    [anon_sym_DASH] = ACTIONS(355),
    [anon_sym_BANG] = ACTIONS(357),
    [anon_sym_TILDE] = ACTIONS(357),
    [anon_sym_typeof] = ACTIONS(359),
    [anon_sym_void] = ACTIONS(359),
    [anon_sym_delete] = ACTIONS(359),
    [anon_sym_PLUS_PLUS] = ACTIONS(361),
    [anon_sym_DASH_DASH] = ACTIONS(361),
    [anon_sym_DQUOTE] = ACTIONS(363),
    [anon_sym_SQUOTE] = ACTIONS(365),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(367),
    [sym_number] = ACTIONS(369),
    [sym_this] = ACTIONS(371),
    [sym_super] = ACTIONS(371),
    [sym_true] = ACTIONS(371),
    [sym_false] = ACTIONS(371),
    [sym_null] = ACTIONS(371),
    [sym_undefined] = ACTIONS(371),
    [anon_sym_AT] = ACTIONS(85),
    [anon_sym_static] = ACTIONS(323),
    [anon_sym_get] = ACTIONS(323),
    [anon_sym_set] = ACTIONS(323),
  },
  [80] = {
    [sym_import] = STATE(539),
    [sym_expression_statement] = STATE(85),
    [sym_empty_statement] = STATE(85),
    [sym_parenthesized_expression] = STATE(362),
    [sym_expression] = STATE(522),
    [sym_primary_expression] = STATE(546),
    [sym_yield_expression] = STATE(550),
    [sym_object] = STATE(539),
    [sym_object_pattern] = STATE(1320),
    [sym_array] = STATE(539),
    [sym_array_pattern] = STATE(1320),
    [sym_jsx_element] = STATE(550),
    [sym_jsx_fragment] = STATE(550),
    [sym_jsx_opening_element] = STATE(772),
    [sym_jsx_self_closing_element] = STATE(550),
    [sym_class] = STATE(539),
    [sym_function] = STATE(539),
    [sym_generator_function] = STATE(539),
    [sym_arrow_function] = STATE(539),
    [sym_call_expression] = STATE(539),
    [sym_new_expression] = STATE(550),
    [sym_await_expression] = STATE(550),
    [sym_member_expression] = STATE(362),
    [sym_subscript_expression] = STATE(362),
    [sym_assignment_expression] = STATE(550),
    [sym__augmented_assignment_lhs] = STATE(720),
    [sym_augmented_assignment_expression] = STATE(550),
    [sym__destructuring_pattern] = STATE(1320),
    [sym_ternary_expression] = STATE(550),
    [sym_binary_expression] = STATE(550),
    [sym_unary_expression] = STATE(550),
    [sym_update_expression] = STATE(550),
    [sym_sequence_expression] = STATE(1156),
    [sym_string] = STATE(539),
    [sym_template_string] = STATE(539),
    [sym_regex] = STATE(539),
    [sym_meta_property] = STATE(539),
    [sym_decorator] = STATE(750),
    [sym_formal_parameters] = STATE(1318),
    [aux_sym_export_statement_repeat1] = STATE(925),
    [sym_identifier] = ACTIONS(373),
    [anon_sym_export] = ACTIONS(375),
    [anon_sym_LBRACE] = ACTIONS(379),
    [anon_sym_import] = ACTIONS(381),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(49),
    [anon_sym_yield] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(53),
    [anon_sym_LT] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(385),
    [anon_sym_async] = ACTIONS(387),
    [anon_sym_function] = ACTIONS(389),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_typeof] = ACTIONS(71),
    [anon_sym_void] = ACTIONS(71),
    [anon_sym_delete] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DQUOTE] = ACTIONS(75),
    [anon_sym_SQUOTE] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(79),
    [sym_number] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(83),
    [sym_true] = ACTIONS(83),
    [sym_false] = ACTIONS(83),
    [sym_null] = ACTIONS(83),
    [sym_undefined] = ACTIONS(83),
    [anon_sym_AT] = ACTIONS(85),
    [anon_sym_static] = ACTIONS(375),
    [anon_sym_get] = ACTIONS(375),
    [anon_sym_set] = ACTIONS(375),
  },
  [81] = {
    [sym_import] = STATE(426),
    [sym_parenthesized_expression] = STATE(355),
    [sym_expression] = STATE(559),
    [sym_primary_expression] = STATE(425),
    [sym_yield_expression] = STATE(424),
    [sym_object] = STATE(426),
    [sym_object_pattern] = STATE(1333),
    [sym_array] = STATE(426),
    [sym_array_pattern] = STATE(1333),
    [sym_jsx_element] = STATE(424),
    [sym_jsx_fragment] = STATE(424),
    [sym_jsx_opening_element] = STATE(768),
    [sym_jsx_self_closing_element] = STATE(424),
    [sym_class] = STATE(426),
    [sym_function] = STATE(426),
    [sym_generator_function] = STATE(426),
    [sym_arrow_function] = STATE(426),
    [sym_call_expression] = STATE(426),
    [sym_new_expression] = STATE(424),
    [sym_await_expression] = STATE(424),
    [sym_member_expression] = STATE(355),
    [sym_subscript_expression] = STATE(355),
    [sym_assignment_expression] = STATE(424),
    [sym__augmented_assignment_lhs] = STATE(714),
    [sym_augmented_assignment_expression] = STATE(424),
    [sym__destructuring_pattern] = STATE(1333),
    [sym_spread_element] = STATE(1347),
    [sym_ternary_expression] = STATE(424),
    [sym_binary_expression] = STATE(424),
    [sym_unary_expression] = STATE(424),
    [sym_update_expression] = STATE(424),
    [sym_sequence_expression] = STATE(1347),
    [sym_string] = STATE(426),
    [sym_template_string] = STATE(426),
    [sym_regex] = STATE(426),
    [sym_meta_property] = STATE(426),
    [sym_decorator] = STATE(750),
    [sym_formal_parameters] = STATE(1322),
    [aux_sym_export_statement_repeat1] = STATE(924),
    [sym_identifier] = ACTIONS(321),
    [anon_sym_export] = ACTIONS(323),
    [anon_sym_LBRACE] = ACTIONS(327),
    [anon_sym_RBRACE] = ACTIONS(600),
    [anon_sym_import] = ACTIONS(331),
    [anon_sym_LPAREN] = ACTIONS(333),
    [anon_sym_await] = ACTIONS(335),
    [anon_sym_yield] = ACTIONS(339),
    [anon_sym_LBRACK] = ACTIONS(341),
    [anon_sym_LT] = ACTIONS(537),
    [anon_sym_SLASH] = ACTIONS(345),
    [anon_sym_class] = ACTIONS(347),
    [anon_sym_async] = ACTIONS(349),
    [anon_sym_function] = ACTIONS(351),
    [anon_sym_new] = ACTIONS(353),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(592),
    [anon_sym_PLUS] = ACTIONS(355),
    [anon_sym_DASH] = ACTIONS(355),
    [anon_sym_BANG] = ACTIONS(357),
    [anon_sym_TILDE] = ACTIONS(357),
    [anon_sym_typeof] = ACTIONS(359),
    [anon_sym_void] = ACTIONS(359),
    [anon_sym_delete] = ACTIONS(359),
    [anon_sym_PLUS_PLUS] = ACTIONS(361),
    [anon_sym_DASH_DASH] = ACTIONS(361),
    [anon_sym_DQUOTE] = ACTIONS(363),
    [anon_sym_SQUOTE] = ACTIONS(365),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(367),
    [sym_number] = ACTIONS(369),
    [sym_this] = ACTIONS(371),
    [sym_super] = ACTIONS(371),
    [sym_true] = ACTIONS(371),
    [sym_false] = ACTIONS(371),
    [sym_null] = ACTIONS(371),
    [sym_undefined] = ACTIONS(371),
    [anon_sym_AT] = ACTIONS(85),
    [anon_sym_static] = ACTIONS(323),
    [anon_sym_get] = ACTIONS(323),
    [anon_sym_set] = ACTIONS(323),
  },
  [82] = {
    [sym_import] = STATE(426),
    [sym_parenthesized_expression] = STATE(355),
    [sym_expression] = STATE(558),
    [sym_primary_expression] = STATE(425),
    [sym_yield_expression] = STATE(424),
    [sym_object] = STATE(426),
    [sym_object_pattern] = STATE(975),
    [sym_array] = STATE(426),
    [sym_array_pattern] = STATE(975),
    [sym_jsx_element] = STATE(424),
    [sym_jsx_fragment] = STATE(424),
    [sym_jsx_opening_element] = STATE(768),
    [sym_jsx_self_closing_element] = STATE(424),
    [sym_class] = STATE(426),
    [sym_function] = STATE(426),
    [sym_generator_function] = STATE(426),
    [sym_arrow_function] = STATE(426),
    [sym_call_expression] = STATE(426),
    [sym_new_expression] = STATE(424),
    [sym_await_expression] = STATE(424),
    [sym_member_expression] = STATE(355),
    [sym_subscript_expression] = STATE(355),
    [sym_assignment_expression] = STATE(424),
    [sym__augmented_assignment_lhs] = STATE(714),
    [sym_augmented_assignment_expression] = STATE(424),
    [sym__destructuring_pattern] = STATE(975),
    [sym_ternary_expression] = STATE(424),
    [sym_binary_expression] = STATE(424),
    [sym_unary_expression] = STATE(424),
    [sym_update_expression] = STATE(424),
    [sym_string] = STATE(426),
    [sym_template_string] = STATE(426),
    [sym_regex] = STATE(426),
    [sym_meta_property] = STATE(426),
    [sym_decorator] = STATE(750),
    [sym_formal_parameters] = STATE(1322),
    [sym_pattern] = STATE(1142),
    [sym_rest_pattern] = STATE(895),
    [aux_sym_export_statement_repeat1] = STATE(924),
    [sym_identifier] = ACTIONS(602),
    [anon_sym_export] = ACTIONS(604),
    [anon_sym_LBRACE] = ACTIONS(397),
    [anon_sym_import] = ACTIONS(331),
    [anon_sym_LPAREN] = ACTIONS(333),
    [anon_sym_await] = ACTIONS(335),
    [anon_sym_yield] = ACTIONS(339),
    [anon_sym_LBRACK] = ACTIONS(403),
    [anon_sym_LT] = ACTIONS(537),
    [anon_sym_SLASH] = ACTIONS(345),
    [anon_sym_class] = ACTIONS(347),
    [anon_sym_async] = ACTIONS(606),
    [anon_sym_function] = ACTIONS(351),
    [anon_sym_new] = ACTIONS(353),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(584),
    [anon_sym_PLUS] = ACTIONS(355),
    [anon_sym_DASH] = ACTIONS(355),
    [anon_sym_BANG] = ACTIONS(357),
    [anon_sym_TILDE] = ACTIONS(357),
    [anon_sym_typeof] = ACTIONS(359),
    [anon_sym_void] = ACTIONS(359),
    [anon_sym_delete] = ACTIONS(359),
    [anon_sym_PLUS_PLUS] = ACTIONS(361),
    [anon_sym_DASH_DASH] = ACTIONS(361),
    [anon_sym_DQUOTE] = ACTIONS(363),
    [anon_sym_SQUOTE] = ACTIONS(365),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(367),
    [sym_number] = ACTIONS(369),
    [sym_this] = ACTIONS(371),
    [sym_super] = ACTIONS(371),
    [sym_true] = ACTIONS(371),
    [sym_false] = ACTIONS(371),
    [sym_null] = ACTIONS(371),
    [sym_undefined] = ACTIONS(371),
    [anon_sym_AT] = ACTIONS(85),
    [anon_sym_static] = ACTIONS(604),
    [anon_sym_get] = ACTIONS(604),
    [anon_sym_set] = ACTIONS(604),
  },
  [83] = {
    [sym_import] = STATE(539),
    [sym_parenthesized_expression] = STATE(362),
    [sym_expression] = STATE(507),
    [sym_primary_expression] = STATE(546),
    [sym_yield_expression] = STATE(550),
    [sym_object] = STATE(539),
    [sym_object_pattern] = STATE(1320),
    [sym_array] = STATE(539),
    [sym_array_pattern] = STATE(1320),
    [sym_jsx_element] = STATE(550),
    [sym_jsx_fragment] = STATE(550),
    [sym_jsx_opening_element] = STATE(772),
    [sym_jsx_self_closing_element] = STATE(550),
    [sym_class] = STATE(539),
    [sym_function] = STATE(539),
    [sym_generator_function] = STATE(539),
    [sym_arrow_function] = STATE(539),
    [sym_call_expression] = STATE(539),
    [sym_new_expression] = STATE(550),
    [sym_await_expression] = STATE(550),
    [sym_member_expression] = STATE(362),
    [sym_subscript_expression] = STATE(362),
    [sym_assignment_expression] = STATE(550),
    [sym__augmented_assignment_lhs] = STATE(720),
    [sym_augmented_assignment_expression] = STATE(550),
    [sym__destructuring_pattern] = STATE(1320),
    [sym_ternary_expression] = STATE(550),
    [sym_binary_expression] = STATE(550),
    [sym_unary_expression] = STATE(550),
    [sym_update_expression] = STATE(550),
    [sym_sequence_expression] = STATE(1234),
    [sym_string] = STATE(539),
    [sym_template_string] = STATE(539),
    [sym_regex] = STATE(539),
    [sym_meta_property] = STATE(539),
    [sym_decorator] = STATE(750),
    [sym_formal_parameters] = STATE(1318),
    [aux_sym_export_statement_repeat1] = STATE(925),
    [sym_identifier] = ACTIONS(373),
    [anon_sym_export] = ACTIONS(375),
    [anon_sym_LBRACE] = ACTIONS(379),
    [anon_sym_import] = ACTIONS(381),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(608),
    [anon_sym_yield] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(53),
    [anon_sym_LT] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(385),
    [anon_sym_async] = ACTIONS(387),
    [anon_sym_function] = ACTIONS(389),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_typeof] = ACTIONS(71),
    [anon_sym_void] = ACTIONS(71),
    [anon_sym_delete] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DQUOTE] = ACTIONS(75),
    [anon_sym_SQUOTE] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(79),
    [sym_number] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(83),
    [sym_true] = ACTIONS(83),
    [sym_false] = ACTIONS(83),
    [sym_null] = ACTIONS(83),
    [sym_undefined] = ACTIONS(83),
    [anon_sym_AT] = ACTIONS(85),
    [anon_sym_static] = ACTIONS(375),
    [anon_sym_get] = ACTIONS(375),
    [anon_sym_set] = ACTIONS(375),
    [sym__automatic_semicolon] = ACTIONS(608),
  },
  [84] = {
    [sym_import] = STATE(426),
    [sym_parenthesized_expression] = STATE(380),
    [sym_expression] = STATE(640),
    [sym_primary_expression] = STATE(425),
    [sym_yield_expression] = STATE(424),
    [sym_object] = STATE(426),
    [sym_object_pattern] = STATE(1045),
    [sym_array] = STATE(426),
    [sym_array_pattern] = STATE(1045),
    [sym_jsx_element] = STATE(424),
    [sym_jsx_fragment] = STATE(424),
    [sym_jsx_opening_element] = STATE(768),
    [sym_jsx_self_closing_element] = STATE(424),
    [sym_class] = STATE(426),
    [sym_function] = STATE(426),
    [sym_generator_function] = STATE(426),
    [sym_arrow_function] = STATE(426),
    [sym_call_expression] = STATE(426),
    [sym_new_expression] = STATE(424),
    [sym_await_expression] = STATE(424),
    [sym_member_expression] = STATE(380),
    [sym_subscript_expression] = STATE(380),
    [sym_assignment_expression] = STATE(424),
    [sym__augmented_assignment_lhs] = STATE(712),
    [sym_augmented_assignment_expression] = STATE(424),
    [sym__destructuring_pattern] = STATE(1045),
    [sym_ternary_expression] = STATE(424),
    [sym_binary_expression] = STATE(424),
    [sym_unary_expression] = STATE(424),
    [sym_update_expression] = STATE(424),
    [sym_string] = STATE(426),
    [sym_template_string] = STATE(426),
    [sym_regex] = STATE(426),
    [sym_meta_property] = STATE(426),
    [sym_decorator] = STATE(750),
    [sym_formal_parameters] = STATE(1267),
    [aux_sym_export_statement_repeat1] = STATE(924),
    [sym_identifier] = ACTIONS(610),
    [anon_sym_export] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(614),
    [anon_sym_import] = ACTIONS(331),
    [anon_sym_var] = ACTIONS(616),
    [anon_sym_let] = ACTIONS(616),
    [anon_sym_const] = ACTIONS(616),
    [anon_sym_LPAREN] = ACTIONS(333),
    [anon_sym_await] = ACTIONS(399),
    [anon_sym_yield] = ACTIONS(401),
    [anon_sym_LBRACK] = ACTIONS(618),
    [anon_sym_LT] = ACTIONS(537),
    [anon_sym_SLASH] = ACTIONS(345),
    [anon_sym_class] = ACTIONS(347),
    [anon_sym_async] = ACTIONS(620),
    [anon_sym_function] = ACTIONS(351),
    [anon_sym_new] = ACTIONS(407),
    [anon_sym_PLUS] = ACTIONS(409),
    [anon_sym_DASH] = ACTIONS(409),
    [anon_sym_BANG] = ACTIONS(411),
    [anon_sym_TILDE] = ACTIONS(411),
    [anon_sym_typeof] = ACTIONS(413),
    [anon_sym_void] = ACTIONS(413),
    [anon_sym_delete] = ACTIONS(413),
    [anon_sym_PLUS_PLUS] = ACTIONS(415),
    [anon_sym_DASH_DASH] = ACTIONS(415),
    [anon_sym_DQUOTE] = ACTIONS(363),
    [anon_sym_SQUOTE] = ACTIONS(365),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(367),
    [sym_number] = ACTIONS(369),
    [sym_this] = ACTIONS(371),
    [sym_super] = ACTIONS(371),
    [sym_true] = ACTIONS(371),
    [sym_false] = ACTIONS(371),
    [sym_null] = ACTIONS(371),
    [sym_undefined] = ACTIONS(371),
    [anon_sym_AT] = ACTIONS(85),
    [anon_sym_static] = ACTIONS(612),
    [anon_sym_get] = ACTIONS(612),
    [anon_sym_set] = ACTIONS(612),
  },
  [85] = {
    [sym_import] = STATE(426),
    [sym_parenthesized_expression] = STATE(355),
    [sym_expression] = STATE(585),
    [sym_primary_expression] = STATE(425),
    [sym_yield_expression] = STATE(424),
    [sym_object] = STATE(426),
    [sym_object_pattern] = STATE(1333),
    [sym_array] = STATE(426),
    [sym_array_pattern] = STATE(1333),
    [sym_jsx_element] = STATE(424),
    [sym_jsx_fragment] = STATE(424),
    [sym_jsx_opening_element] = STATE(768),
    [sym_jsx_self_closing_element] = STATE(424),
    [sym_class] = STATE(426),
    [sym_function] = STATE(426),
    [sym_generator_function] = STATE(426),
    [sym_arrow_function] = STATE(426),
    [sym_call_expression] = STATE(426),
    [sym_new_expression] = STATE(424),
    [sym_await_expression] = STATE(424),
    [sym_member_expression] = STATE(355),
    [sym_subscript_expression] = STATE(355),
    [sym_assignment_expression] = STATE(424),
    [sym__augmented_assignment_lhs] = STATE(714),
    [sym_augmented_assignment_expression] = STATE(424),
    [sym__destructuring_pattern] = STATE(1333),
    [sym_ternary_expression] = STATE(424),
    [sym_binary_expression] = STATE(424),
    [sym_unary_expression] = STATE(424),
    [sym_update_expression] = STATE(424),
    [sym_sequence_expression] = STATE(1295),
    [sym_string] = STATE(426),
    [sym_template_string] = STATE(426),
    [sym_regex] = STATE(426),
    [sym_meta_property] = STATE(426),
    [sym_decorator] = STATE(750),
    [sym_formal_parameters] = STATE(1322),
    [aux_sym_export_statement_repeat1] = STATE(924),
    [sym_identifier] = ACTIONS(321),
    [anon_sym_export] = ACTIONS(323),
    [anon_sym_LBRACE] = ACTIONS(327),
    [anon_sym_import] = ACTIONS(331),
    [anon_sym_LPAREN] = ACTIONS(333),
    [anon_sym_RPAREN] = ACTIONS(622),
    [anon_sym_await] = ACTIONS(335),
    [anon_sym_yield] = ACTIONS(339),
    [anon_sym_LBRACK] = ACTIONS(341),
    [anon_sym_LT] = ACTIONS(537),
    [anon_sym_SLASH] = ACTIONS(345),
    [anon_sym_class] = ACTIONS(347),
    [anon_sym_async] = ACTIONS(349),
    [anon_sym_function] = ACTIONS(351),
    [anon_sym_new] = ACTIONS(353),
    [anon_sym_PLUS] = ACTIONS(355),
    [anon_sym_DASH] = ACTIONS(355),
    [anon_sym_BANG] = ACTIONS(357),
    [anon_sym_TILDE] = ACTIONS(357),
    [anon_sym_typeof] = ACTIONS(359),
    [anon_sym_void] = ACTIONS(359),
    [anon_sym_delete] = ACTIONS(359),
    [anon_sym_PLUS_PLUS] = ACTIONS(361),
    [anon_sym_DASH_DASH] = ACTIONS(361),
    [anon_sym_DQUOTE] = ACTIONS(363),
    [anon_sym_SQUOTE] = ACTIONS(365),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(367),
    [sym_number] = ACTIONS(369),
    [sym_this] = ACTIONS(371),
    [sym_super] = ACTIONS(371),
    [sym_true] = ACTIONS(371),
    [sym_false] = ACTIONS(371),
    [sym_null] = ACTIONS(371),
    [sym_undefined] = ACTIONS(371),
    [anon_sym_AT] = ACTIONS(85),
    [anon_sym_static] = ACTIONS(323),
    [anon_sym_get] = ACTIONS(323),
    [anon_sym_set] = ACTIONS(323),
  },
  [86] = {
    [sym_import] = STATE(426),
    [sym_parenthesized_expression] = STATE(355),
    [sym_expression] = STATE(626),
    [sym_primary_expression] = STATE(425),
    [sym_yield_expression] = STATE(424),
    [sym_object] = STATE(426),
    [sym_object_pattern] = STATE(1333),
    [sym_array] = STATE(426),
    [sym_array_pattern] = STATE(1333),
    [sym_jsx_element] = STATE(424),
    [sym_jsx_fragment] = STATE(424),
    [sym_jsx_opening_element] = STATE(768),
    [sym_jsx_self_closing_element] = STATE(424),
    [sym_class] = STATE(426),
    [sym_function] = STATE(426),
    [sym_generator_function] = STATE(426),
    [sym_arrow_function] = STATE(426),
    [sym_call_expression] = STATE(426),
    [sym_new_expression] = STATE(424),
    [sym_await_expression] = STATE(424),
    [sym_member_expression] = STATE(355),
    [sym_subscript_expression] = STATE(355),
    [sym_assignment_expression] = STATE(424),
    [sym__augmented_assignment_lhs] = STATE(714),
    [sym_augmented_assignment_expression] = STATE(424),
    [sym__destructuring_pattern] = STATE(1333),
    [sym_ternary_expression] = STATE(424),
    [sym_binary_expression] = STATE(424),
    [sym_unary_expression] = STATE(424),
    [sym_update_expression] = STATE(424),
    [sym_sequence_expression] = STATE(1287),
    [sym_string] = STATE(426),
    [sym_template_string] = STATE(426),
    [sym_regex] = STATE(426),
    [sym_meta_property] = STATE(426),
    [sym_decorator] = STATE(750),
    [sym_formal_parameters] = STATE(1322),
    [aux_sym_export_statement_repeat1] = STATE(924),
    [sym_identifier] = ACTIONS(321),
    [anon_sym_export] = ACTIONS(323),
    [anon_sym_LBRACE] = ACTIONS(327),
    [anon_sym_import] = ACTIONS(331),
    [anon_sym_LPAREN] = ACTIONS(333),
    [anon_sym_RPAREN] = ACTIONS(624),
    [anon_sym_await] = ACTIONS(335),
    [anon_sym_yield] = ACTIONS(339),
    [anon_sym_LBRACK] = ACTIONS(341),
    [anon_sym_LT] = ACTIONS(537),
    [anon_sym_SLASH] = ACTIONS(345),
    [anon_sym_class] = ACTIONS(347),
    [anon_sym_async] = ACTIONS(349),
    [anon_sym_function] = ACTIONS(351),
    [anon_sym_new] = ACTIONS(353),
    [anon_sym_PLUS] = ACTIONS(355),
    [anon_sym_DASH] = ACTIONS(355),
    [anon_sym_BANG] = ACTIONS(357),
    [anon_sym_TILDE] = ACTIONS(357),
    [anon_sym_typeof] = ACTIONS(359),
    [anon_sym_void] = ACTIONS(359),
    [anon_sym_delete] = ACTIONS(359),
    [anon_sym_PLUS_PLUS] = ACTIONS(361),
    [anon_sym_DASH_DASH] = ACTIONS(361),
    [anon_sym_DQUOTE] = ACTIONS(363),
    [anon_sym_SQUOTE] = ACTIONS(365),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(367),
    [sym_number] = ACTIONS(369),
    [sym_this] = ACTIONS(371),
    [sym_super] = ACTIONS(371),
    [sym_true] = ACTIONS(371),
    [sym_false] = ACTIONS(371),
    [sym_null] = ACTIONS(371),
    [sym_undefined] = ACTIONS(371),
    [anon_sym_AT] = ACTIONS(85),
    [anon_sym_static] = ACTIONS(323),
    [anon_sym_get] = ACTIONS(323),
    [anon_sym_set] = ACTIONS(323),
  },
  [87] = {
    [sym_import] = STATE(539),
    [sym_parenthesized_expression] = STATE(362),
    [sym_expression] = STATE(533),
    [sym_primary_expression] = STATE(546),
    [sym_yield_expression] = STATE(550),
    [sym_object] = STATE(539),
    [sym_object_pattern] = STATE(1320),
    [sym_array] = STATE(539),
    [sym_array_pattern] = STATE(1320),
    [sym_jsx_element] = STATE(550),
    [sym_jsx_fragment] = STATE(550),
    [sym_jsx_opening_element] = STATE(772),
    [sym_jsx_self_closing_element] = STATE(550),
    [sym_class] = STATE(539),
    [sym_function] = STATE(539),
    [sym_generator_function] = STATE(539),
    [sym_arrow_function] = STATE(539),
    [sym_call_expression] = STATE(539),
    [sym_new_expression] = STATE(550),
    [sym_await_expression] = STATE(550),
    [sym_member_expression] = STATE(362),
    [sym_subscript_expression] = STATE(362),
    [sym_assignment_expression] = STATE(550),
    [sym__augmented_assignment_lhs] = STATE(720),
    [sym_augmented_assignment_expression] = STATE(550),
    [sym__destructuring_pattern] = STATE(1320),
    [sym_ternary_expression] = STATE(550),
    [sym_binary_expression] = STATE(550),
    [sym_unary_expression] = STATE(550),
    [sym_update_expression] = STATE(550),
    [sym_sequence_expression] = STATE(1091),
    [sym_string] = STATE(539),
    [sym_template_string] = STATE(539),
    [sym_regex] = STATE(539),
    [sym_meta_property] = STATE(539),
    [sym_decorator] = STATE(750),
    [sym_formal_parameters] = STATE(1318),
    [aux_sym_export_statement_repeat1] = STATE(925),
    [sym_identifier] = ACTIONS(373),
    [anon_sym_export] = ACTIONS(375),
    [anon_sym_LBRACE] = ACTIONS(379),
    [anon_sym_import] = ACTIONS(381),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(29),
    [anon_sym_yield] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(53),
    [anon_sym_LT] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(385),
    [anon_sym_async] = ACTIONS(387),
    [anon_sym_function] = ACTIONS(389),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_typeof] = ACTIONS(71),
    [anon_sym_void] = ACTIONS(71),
    [anon_sym_delete] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DQUOTE] = ACTIONS(75),
    [anon_sym_SQUOTE] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(79),
    [sym_number] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(83),
    [sym_true] = ACTIONS(83),
    [sym_false] = ACTIONS(83),
    [sym_null] = ACTIONS(83),
    [sym_undefined] = ACTIONS(83),
    [anon_sym_AT] = ACTIONS(85),
    [anon_sym_static] = ACTIONS(375),
    [anon_sym_get] = ACTIONS(375),
    [anon_sym_set] = ACTIONS(375),
  },
  [88] = {
    [sym_import] = STATE(426),
    [sym_statement_block] = STATE(472),
    [sym_parenthesized_expression] = STATE(355),
    [sym_expression] = STATE(401),
    [sym_primary_expression] = STATE(425),
    [sym_yield_expression] = STATE(424),
    [sym_object] = STATE(426),
    [sym_object_pattern] = STATE(1333),
    [sym_array] = STATE(426),
    [sym_array_pattern] = STATE(1333),
    [sym_jsx_element] = STATE(424),
    [sym_jsx_fragment] = STATE(424),
    [sym_jsx_opening_element] = STATE(768),
    [sym_jsx_self_closing_element] = STATE(424),
    [sym_class] = STATE(426),
    [sym_function] = STATE(426),
    [sym_generator_function] = STATE(426),
    [sym_arrow_function] = STATE(426),
    [sym_call_expression] = STATE(426),
    [sym_new_expression] = STATE(424),
    [sym_await_expression] = STATE(424),
    [sym_member_expression] = STATE(355),
    [sym_subscript_expression] = STATE(355),
    [sym_assignment_expression] = STATE(424),
    [sym__augmented_assignment_lhs] = STATE(714),
    [sym_augmented_assignment_expression] = STATE(424),
    [sym__destructuring_pattern] = STATE(1333),
    [sym_ternary_expression] = STATE(424),
    [sym_binary_expression] = STATE(424),
    [sym_unary_expression] = STATE(424),
    [sym_update_expression] = STATE(424),
    [sym_string] = STATE(426),
    [sym_template_string] = STATE(426),
    [sym_regex] = STATE(426),
    [sym_meta_property] = STATE(426),
    [sym_decorator] = STATE(750),
    [sym_formal_parameters] = STATE(1322),
    [aux_sym_export_statement_repeat1] = STATE(924),
    [sym_identifier] = ACTIONS(321),
    [anon_sym_export] = ACTIONS(323),
    [anon_sym_LBRACE] = ACTIONS(626),
    [anon_sym_import] = ACTIONS(331),
    [anon_sym_LPAREN] = ACTIONS(333),
    [anon_sym_await] = ACTIONS(335),
    [anon_sym_yield] = ACTIONS(339),
    [anon_sym_LBRACK] = ACTIONS(341),
    [anon_sym_LT] = ACTIONS(537),
    [anon_sym_SLASH] = ACTIONS(345),
    [anon_sym_class] = ACTIONS(347),
    [anon_sym_async] = ACTIONS(349),
    [anon_sym_function] = ACTIONS(351),
    [anon_sym_new] = ACTIONS(353),
    [anon_sym_PLUS] = ACTIONS(355),
    [anon_sym_DASH] = ACTIONS(355),
    [anon_sym_BANG] = ACTIONS(357),
    [anon_sym_TILDE] = ACTIONS(357),
    [anon_sym_typeof] = ACTIONS(359),
    [anon_sym_void] = ACTIONS(359),
    [anon_sym_delete] = ACTIONS(359),
    [anon_sym_PLUS_PLUS] = ACTIONS(361),
    [anon_sym_DASH_DASH] = ACTIONS(361),
    [anon_sym_DQUOTE] = ACTIONS(363),
    [anon_sym_SQUOTE] = ACTIONS(365),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(367),
    [sym_number] = ACTIONS(369),
    [sym_this] = ACTIONS(371),
    [sym_super] = ACTIONS(371),
    [sym_true] = ACTIONS(371),
    [sym_false] = ACTIONS(371),
    [sym_null] = ACTIONS(371),
    [sym_undefined] = ACTIONS(371),
    [anon_sym_AT] = ACTIONS(85),
    [anon_sym_static] = ACTIONS(323),
    [anon_sym_get] = ACTIONS(323),
    [anon_sym_set] = ACTIONS(323),
  },
  [89] = {
    [sym_import] = STATE(426),
    [sym_statement_block] = STATE(471),
    [sym_parenthesized_expression] = STATE(355),
    [sym_expression] = STATE(398),
    [sym_primary_expression] = STATE(425),
    [sym_yield_expression] = STATE(424),
    [sym_object] = STATE(426),
    [sym_object_pattern] = STATE(1333),
    [sym_array] = STATE(426),
    [sym_array_pattern] = STATE(1333),
    [sym_jsx_element] = STATE(424),
    [sym_jsx_fragment] = STATE(424),
    [sym_jsx_opening_element] = STATE(768),
    [sym_jsx_self_closing_element] = STATE(424),
    [sym_class] = STATE(426),
    [sym_function] = STATE(426),
    [sym_generator_function] = STATE(426),
    [sym_arrow_function] = STATE(426),
    [sym_call_expression] = STATE(426),
    [sym_new_expression] = STATE(424),
    [sym_await_expression] = STATE(424),
    [sym_member_expression] = STATE(355),
    [sym_subscript_expression] = STATE(355),
    [sym_assignment_expression] = STATE(424),
    [sym__augmented_assignment_lhs] = STATE(714),
    [sym_augmented_assignment_expression] = STATE(424),
    [sym__destructuring_pattern] = STATE(1333),
    [sym_ternary_expression] = STATE(424),
    [sym_binary_expression] = STATE(424),
    [sym_unary_expression] = STATE(424),
    [sym_update_expression] = STATE(424),
    [sym_string] = STATE(426),
    [sym_template_string] = STATE(426),
    [sym_regex] = STATE(426),
    [sym_meta_property] = STATE(426),
    [sym_decorator] = STATE(750),
    [sym_formal_parameters] = STATE(1322),
    [aux_sym_export_statement_repeat1] = STATE(924),
    [sym_identifier] = ACTIONS(321),
    [anon_sym_export] = ACTIONS(323),
    [anon_sym_LBRACE] = ACTIONS(626),
    [anon_sym_import] = ACTIONS(331),
    [anon_sym_LPAREN] = ACTIONS(333),
    [anon_sym_await] = ACTIONS(335),
    [anon_sym_yield] = ACTIONS(339),
    [anon_sym_LBRACK] = ACTIONS(341),
    [anon_sym_LT] = ACTIONS(537),
    [anon_sym_SLASH] = ACTIONS(345),
    [anon_sym_class] = ACTIONS(347),
    [anon_sym_async] = ACTIONS(349),
    [anon_sym_function] = ACTIONS(351),
    [anon_sym_new] = ACTIONS(353),
    [anon_sym_PLUS] = ACTIONS(355),
    [anon_sym_DASH] = ACTIONS(355),
    [anon_sym_BANG] = ACTIONS(357),
    [anon_sym_TILDE] = ACTIONS(357),
    [anon_sym_typeof] = ACTIONS(359),
    [anon_sym_void] = ACTIONS(359),
    [anon_sym_delete] = ACTIONS(359),
    [anon_sym_PLUS_PLUS] = ACTIONS(361),
    [anon_sym_DASH_DASH] = ACTIONS(361),
    [anon_sym_DQUOTE] = ACTIONS(363),
    [anon_sym_SQUOTE] = ACTIONS(365),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(367),
    [sym_number] = ACTIONS(369),
    [sym_this] = ACTIONS(371),
    [sym_super] = ACTIONS(371),
    [sym_true] = ACTIONS(371),
    [sym_false] = ACTIONS(371),
    [sym_null] = ACTIONS(371),
    [sym_undefined] = ACTIONS(371),
    [anon_sym_AT] = ACTIONS(85),
    [anon_sym_static] = ACTIONS(323),
    [anon_sym_get] = ACTIONS(323),
    [anon_sym_set] = ACTIONS(323),
  },
  [90] = {
    [sym_import] = STATE(539),
    [sym_statement_block] = STATE(554),
    [sym_parenthesized_expression] = STATE(362),
    [sym_expression] = STATE(450),
    [sym_primary_expression] = STATE(546),
    [sym_yield_expression] = STATE(550),
    [sym_object] = STATE(539),
    [sym_object_pattern] = STATE(1320),
    [sym_array] = STATE(539),
    [sym_array_pattern] = STATE(1320),
    [sym_jsx_element] = STATE(550),
    [sym_jsx_fragment] = STATE(550),
    [sym_jsx_opening_element] = STATE(772),
    [sym_jsx_self_closing_element] = STATE(550),
    [sym_class] = STATE(539),
    [sym_function] = STATE(539),
    [sym_generator_function] = STATE(539),
    [sym_arrow_function] = STATE(539),
    [sym_call_expression] = STATE(539),
    [sym_new_expression] = STATE(550),
    [sym_await_expression] = STATE(550),
    [sym_member_expression] = STATE(362),
    [sym_subscript_expression] = STATE(362),
    [sym_assignment_expression] = STATE(550),
    [sym__augmented_assignment_lhs] = STATE(720),
    [sym_augmented_assignment_expression] = STATE(550),
    [sym__destructuring_pattern] = STATE(1320),
    [sym_ternary_expression] = STATE(550),
    [sym_binary_expression] = STATE(550),
    [sym_unary_expression] = STATE(550),
    [sym_update_expression] = STATE(550),
    [sym_string] = STATE(539),
    [sym_template_string] = STATE(539),
    [sym_regex] = STATE(539),
    [sym_meta_property] = STATE(539),
    [sym_decorator] = STATE(750),
    [sym_formal_parameters] = STATE(1318),
    [aux_sym_export_statement_repeat1] = STATE(925),
    [sym_identifier] = ACTIONS(373),
    [anon_sym_export] = ACTIONS(375),
    [anon_sym_LBRACE] = ACTIONS(628),
    [anon_sym_import] = ACTIONS(381),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(29),
    [anon_sym_yield] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(53),
    [anon_sym_LT] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(385),
    [anon_sym_async] = ACTIONS(387),
    [anon_sym_function] = ACTIONS(389),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_typeof] = ACTIONS(71),
    [anon_sym_void] = ACTIONS(71),
    [anon_sym_delete] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DQUOTE] = ACTIONS(75),
    [anon_sym_SQUOTE] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(79),
    [sym_number] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(83),
    [sym_true] = ACTIONS(83),
    [sym_false] = ACTIONS(83),
    [sym_null] = ACTIONS(83),
    [sym_undefined] = ACTIONS(83),
    [anon_sym_AT] = ACTIONS(85),
    [anon_sym_static] = ACTIONS(375),
    [anon_sym_get] = ACTIONS(375),
    [anon_sym_set] = ACTIONS(375),
  },
  [91] = {
    [sym_import] = STATE(426),
    [sym_parenthesized_expression] = STATE(355),
    [sym_expression] = STATE(408),
    [sym_primary_expression] = STATE(425),
    [sym_yield_expression] = STATE(424),
    [sym_object] = STATE(426),
    [sym_object_pattern] = STATE(1333),
    [sym_array] = STATE(426),
    [sym_array_pattern] = STATE(1333),
    [sym_jsx_element] = STATE(424),
    [sym_jsx_fragment] = STATE(424),
    [sym_jsx_opening_element] = STATE(768),
    [sym_jsx_self_closing_element] = STATE(424),
    [sym_class] = STATE(426),
    [sym_function] = STATE(426),
    [sym_generator_function] = STATE(426),
    [sym_arrow_function] = STATE(426),
    [sym_call_expression] = STATE(426),
    [sym_new_expression] = STATE(424),
    [sym_await_expression] = STATE(424),
    [sym_member_expression] = STATE(355),
    [sym_subscript_expression] = STATE(355),
    [sym_assignment_expression] = STATE(424),
    [sym__augmented_assignment_lhs] = STATE(714),
    [sym_augmented_assignment_expression] = STATE(424),
    [sym__destructuring_pattern] = STATE(1333),
    [sym_ternary_expression] = STATE(424),
    [sym_binary_expression] = STATE(424),
    [sym_unary_expression] = STATE(424),
    [sym_update_expression] = STATE(424),
    [sym_sequence_expression] = STATE(958),
    [sym_string] = STATE(426),
    [sym_template_string] = STATE(426),
    [sym_regex] = STATE(426),
    [sym_meta_property] = STATE(426),
    [sym_decorator] = STATE(750),
    [sym_formal_parameters] = STATE(1322),
    [aux_sym_export_statement_repeat1] = STATE(924),
    [sym_identifier] = ACTIONS(321),
    [anon_sym_export] = ACTIONS(323),
    [anon_sym_LBRACE] = ACTIONS(327),
    [anon_sym_import] = ACTIONS(331),
    [anon_sym_LPAREN] = ACTIONS(333),
    [anon_sym_await] = ACTIONS(335),
    [anon_sym_yield] = ACTIONS(339),
    [anon_sym_LBRACK] = ACTIONS(341),
    [anon_sym_LT] = ACTIONS(537),
    [anon_sym_SLASH] = ACTIONS(345),
    [anon_sym_class] = ACTIONS(347),
    [anon_sym_async] = ACTIONS(349),
    [anon_sym_function] = ACTIONS(351),
    [anon_sym_new] = ACTIONS(353),
    [anon_sym_PLUS] = ACTIONS(355),
    [anon_sym_DASH] = ACTIONS(355),
    [anon_sym_BANG] = ACTIONS(357),
    [anon_sym_TILDE] = ACTIONS(357),
    [anon_sym_typeof] = ACTIONS(359),
    [anon_sym_void] = ACTIONS(359),
    [anon_sym_delete] = ACTIONS(359),
    [anon_sym_PLUS_PLUS] = ACTIONS(361),
    [anon_sym_DASH_DASH] = ACTIONS(361),
    [anon_sym_DQUOTE] = ACTIONS(363),
    [anon_sym_SQUOTE] = ACTIONS(365),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(367),
    [sym_number] = ACTIONS(369),
    [sym_this] = ACTIONS(371),
    [sym_super] = ACTIONS(371),
    [sym_true] = ACTIONS(371),
    [sym_false] = ACTIONS(371),
    [sym_null] = ACTIONS(371),
    [sym_undefined] = ACTIONS(371),
    [anon_sym_AT] = ACTIONS(85),
    [anon_sym_static] = ACTIONS(323),
    [anon_sym_get] = ACTIONS(323),
    [anon_sym_set] = ACTIONS(323),
  },
  [92] = {
    [sym_export_clause] = STATE(927),
    [sym_declaration] = STATE(293),
    [sym_variable_declaration] = STATE(275),
    [sym_lexical_declaration] = STATE(275),
    [sym_class_declaration] = STATE(275),
    [sym_function_declaration] = STATE(275),
    [sym_generator_function_declaration] = STATE(275),
    [sym_decorator] = STATE(750),
    [aux_sym_export_statement_repeat1] = STATE(922),
    [aux_sym_object_repeat1] = STATE(976),
    [aux_sym_object_pattern_repeat1] = STATE(978),
    [anon_sym_STAR] = ACTIONS(630),
    [anon_sym_default] = ACTIONS(632),
    [anon_sym_LBRACE] = ACTIONS(634),
    [anon_sym_COMMA] = ACTIONS(636),
    [anon_sym_RBRACE] = ACTIONS(638),
    [anon_sym_var] = ACTIONS(640),
    [anon_sym_let] = ACTIONS(642),
    [anon_sym_const] = ACTIONS(642),
    [anon_sym_LPAREN] = ACTIONS(644),
    [anon_sym_in] = ACTIONS(647),
    [anon_sym_SEMI] = ACTIONS(636),
    [anon_sym_COLON] = ACTIONS(649),
    [anon_sym_EQ] = ACTIONS(652),
    [anon_sym_LBRACK] = ACTIONS(636),
    [anon_sym_LT] = ACTIONS(647),
    [anon_sym_GT] = ACTIONS(647),
    [anon_sym_SLASH] = ACTIONS(647),
    [anon_sym_DOT] = ACTIONS(636),
    [anon_sym_class] = ACTIONS(654),
    [anon_sym_async] = ACTIONS(656),
    [anon_sym_function] = ACTIONS(658),
    [anon_sym_EQ_GT] = ACTIONS(660),
    [anon_sym_QMARK_DOT] = ACTIONS(636),
    [anon_sym_PLUS_EQ] = ACTIONS(662),
    [anon_sym_DASH_EQ] = ACTIONS(662),
    [anon_sym_STAR_EQ] = ACTIONS(662),
    [anon_sym_SLASH_EQ] = ACTIONS(662),
    [anon_sym_PERCENT_EQ] = ACTIONS(662),
    [anon_sym_CARET_EQ] = ACTIONS(662),
    [anon_sym_AMP_EQ] = ACTIONS(662),
    [anon_sym_PIPE_EQ] = ACTIONS(662),
    [anon_sym_GT_GT_EQ] = ACTIONS(662),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(662),
    [anon_sym_LT_LT_EQ] = ACTIONS(662),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(662),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(662),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(662),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(662),
    [anon_sym_QMARK] = ACTIONS(647),
    [anon_sym_AMP_AMP] = ACTIONS(647),
    [anon_sym_PIPE_PIPE] = ACTIONS(647),
    [anon_sym_GT_GT] = ACTIONS(647),
    [anon_sym_GT_GT_GT] = ACTIONS(647),
    [anon_sym_LT_LT] = ACTIONS(647),
    [anon_sym_AMP] = ACTIONS(647),
    [anon_sym_CARET] = ACTIONS(647),
    [anon_sym_PIPE] = ACTIONS(647),
    [anon_sym_PLUS] = ACTIONS(647),
    [anon_sym_DASH] = ACTIONS(647),
    [anon_sym_PERCENT] = ACTIONS(647),
    [anon_sym_STAR_STAR] = ACTIONS(647),
    [anon_sym_LT_EQ] = ACTIONS(636),
    [anon_sym_EQ_EQ] = ACTIONS(647),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(636),
    [anon_sym_BANG_EQ] = ACTIONS(647),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(636),
    [anon_sym_GT_EQ] = ACTIONS(636),
    [anon_sym_QMARK_QMARK] = ACTIONS(647),
    [anon_sym_instanceof] = ACTIONS(636),
    [anon_sym_PLUS_PLUS] = ACTIONS(636),
    [anon_sym_DASH_DASH] = ACTIONS(636),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(636),
    [anon_sym_AT] = ACTIONS(85),
    [sym__automatic_semicolon] = ACTIONS(636),
  },
  [93] = {
    [sym_import] = STATE(426),
    [sym_statement_block] = STATE(477),
    [sym_parenthesized_expression] = STATE(355),
    [sym_expression] = STATE(399),
    [sym_primary_expression] = STATE(425),
    [sym_yield_expression] = STATE(424),
    [sym_object] = STATE(426),
    [sym_object_pattern] = STATE(1333),
    [sym_array] = STATE(426),
    [sym_array_pattern] = STATE(1333),
    [sym_jsx_element] = STATE(424),
    [sym_jsx_fragment] = STATE(424),
    [sym_jsx_opening_element] = STATE(768),
    [sym_jsx_self_closing_element] = STATE(424),
    [sym_class] = STATE(426),
    [sym_function] = STATE(426),
    [sym_generator_function] = STATE(426),
    [sym_arrow_function] = STATE(426),
    [sym_call_expression] = STATE(426),
    [sym_new_expression] = STATE(424),
    [sym_await_expression] = STATE(424),
    [sym_member_expression] = STATE(355),
    [sym_subscript_expression] = STATE(355),
    [sym_assignment_expression] = STATE(424),
    [sym__augmented_assignment_lhs] = STATE(714),
    [sym_augmented_assignment_expression] = STATE(424),
    [sym__destructuring_pattern] = STATE(1333),
    [sym_ternary_expression] = STATE(424),
    [sym_binary_expression] = STATE(424),
    [sym_unary_expression] = STATE(424),
    [sym_update_expression] = STATE(424),
    [sym_string] = STATE(426),
    [sym_template_string] = STATE(426),
    [sym_regex] = STATE(426),
    [sym_meta_property] = STATE(426),
    [sym_decorator] = STATE(750),
    [sym_formal_parameters] = STATE(1322),
    [aux_sym_export_statement_repeat1] = STATE(924),
    [sym_identifier] = ACTIONS(321),
    [anon_sym_export] = ACTIONS(323),
    [anon_sym_LBRACE] = ACTIONS(626),
    [anon_sym_import] = ACTIONS(331),
    [anon_sym_LPAREN] = ACTIONS(333),
    [anon_sym_await] = ACTIONS(335),
    [anon_sym_yield] = ACTIONS(339),
    [anon_sym_LBRACK] = ACTIONS(341),
    [anon_sym_LT] = ACTIONS(537),
    [anon_sym_SLASH] = ACTIONS(345),
    [anon_sym_class] = ACTIONS(347),
    [anon_sym_async] = ACTIONS(349),
    [anon_sym_function] = ACTIONS(351),
    [anon_sym_new] = ACTIONS(353),
    [anon_sym_PLUS] = ACTIONS(355),
    [anon_sym_DASH] = ACTIONS(355),
    [anon_sym_BANG] = ACTIONS(357),
    [anon_sym_TILDE] = ACTIONS(357),
    [anon_sym_typeof] = ACTIONS(359),
    [anon_sym_void] = ACTIONS(359),
    [anon_sym_delete] = ACTIONS(359),
    [anon_sym_PLUS_PLUS] = ACTIONS(361),
    [anon_sym_DASH_DASH] = ACTIONS(361),
    [anon_sym_DQUOTE] = ACTIONS(363),
    [anon_sym_SQUOTE] = ACTIONS(365),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(367),
    [sym_number] = ACTIONS(369),
    [sym_this] = ACTIONS(371),
    [sym_super] = ACTIONS(371),
    [sym_true] = ACTIONS(371),
    [sym_false] = ACTIONS(371),
    [sym_null] = ACTIONS(371),
    [sym_undefined] = ACTIONS(371),
    [anon_sym_AT] = ACTIONS(85),
    [anon_sym_static] = ACTIONS(323),
    [anon_sym_get] = ACTIONS(323),
    [anon_sym_set] = ACTIONS(323),
  },
  [94] = {
    [sym_import] = STATE(426),
    [sym_parenthesized_expression] = STATE(355),
    [sym_expression] = STATE(581),
    [sym_primary_expression] = STATE(425),
    [sym_yield_expression] = STATE(424),
    [sym_object] = STATE(426),
    [sym_object_pattern] = STATE(1333),
    [sym_array] = STATE(426),
    [sym_array_pattern] = STATE(1333),
    [sym_jsx_element] = STATE(424),
    [sym_jsx_fragment] = STATE(424),
    [sym_jsx_opening_element] = STATE(768),
    [sym_jsx_self_closing_element] = STATE(424),
    [sym_class] = STATE(426),
    [sym_function] = STATE(426),
    [sym_generator_function] = STATE(426),
    [sym_arrow_function] = STATE(426),
    [sym_call_expression] = STATE(426),
    [sym_new_expression] = STATE(424),
    [sym_await_expression] = STATE(424),
    [sym_member_expression] = STATE(355),
    [sym_subscript_expression] = STATE(355),
    [sym_assignment_expression] = STATE(424),
    [sym__augmented_assignment_lhs] = STATE(714),
    [sym_augmented_assignment_expression] = STATE(424),
    [sym__destructuring_pattern] = STATE(1333),
    [sym_ternary_expression] = STATE(424),
    [sym_binary_expression] = STATE(424),
    [sym_unary_expression] = STATE(424),
    [sym_update_expression] = STATE(424),
    [sym_sequence_expression] = STATE(1283),
    [sym_string] = STATE(426),
    [sym_template_string] = STATE(426),
    [sym_regex] = STATE(426),
    [sym_meta_property] = STATE(426),
    [sym_decorator] = STATE(750),
    [sym_formal_parameters] = STATE(1322),
    [aux_sym_export_statement_repeat1] = STATE(924),
    [sym_identifier] = ACTIONS(321),
    [anon_sym_export] = ACTIONS(323),
    [anon_sym_LBRACE] = ACTIONS(327),
    [anon_sym_import] = ACTIONS(331),
    [anon_sym_LPAREN] = ACTIONS(333),
    [anon_sym_await] = ACTIONS(335),
    [anon_sym_yield] = ACTIONS(339),
    [anon_sym_LBRACK] = ACTIONS(341),
    [anon_sym_LT] = ACTIONS(537),
    [anon_sym_SLASH] = ACTIONS(345),
    [anon_sym_class] = ACTIONS(347),
    [anon_sym_async] = ACTIONS(349),
    [anon_sym_function] = ACTIONS(351),
    [anon_sym_new] = ACTIONS(353),
    [anon_sym_PLUS] = ACTIONS(355),
    [anon_sym_DASH] = ACTIONS(355),
    [anon_sym_BANG] = ACTIONS(357),
    [anon_sym_TILDE] = ACTIONS(357),
    [anon_sym_typeof] = ACTIONS(359),
    [anon_sym_void] = ACTIONS(359),
    [anon_sym_delete] = ACTIONS(359),
    [anon_sym_PLUS_PLUS] = ACTIONS(361),
    [anon_sym_DASH_DASH] = ACTIONS(361),
    [anon_sym_DQUOTE] = ACTIONS(363),
    [anon_sym_SQUOTE] = ACTIONS(365),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(367),
    [sym_number] = ACTIONS(369),
    [sym_this] = ACTIONS(371),
    [sym_super] = ACTIONS(371),
    [sym_true] = ACTIONS(371),
    [sym_false] = ACTIONS(371),
    [sym_null] = ACTIONS(371),
    [sym_undefined] = ACTIONS(371),
    [anon_sym_AT] = ACTIONS(85),
    [anon_sym_static] = ACTIONS(323),
    [anon_sym_get] = ACTIONS(323),
    [anon_sym_set] = ACTIONS(323),
  },
  [95] = {
    [sym_import] = STATE(426),
    [sym_statement_block] = STATE(440),
    [sym_parenthesized_expression] = STATE(355),
    [sym_expression] = STATE(389),
    [sym_primary_expression] = STATE(425),
    [sym_yield_expression] = STATE(424),
    [sym_object] = STATE(426),
    [sym_object_pattern] = STATE(1333),
    [sym_array] = STATE(426),
    [sym_array_pattern] = STATE(1333),
    [sym_jsx_element] = STATE(424),
    [sym_jsx_fragment] = STATE(424),
    [sym_jsx_opening_element] = STATE(768),
    [sym_jsx_self_closing_element] = STATE(424),
    [sym_class] = STATE(426),
    [sym_function] = STATE(426),
    [sym_generator_function] = STATE(426),
    [sym_arrow_function] = STATE(426),
    [sym_call_expression] = STATE(426),
    [sym_new_expression] = STATE(424),
    [sym_await_expression] = STATE(424),
    [sym_member_expression] = STATE(355),
    [sym_subscript_expression] = STATE(355),
    [sym_assignment_expression] = STATE(424),
    [sym__augmented_assignment_lhs] = STATE(714),
    [sym_augmented_assignment_expression] = STATE(424),
    [sym__destructuring_pattern] = STATE(1333),
    [sym_ternary_expression] = STATE(424),
    [sym_binary_expression] = STATE(424),
    [sym_unary_expression] = STATE(424),
    [sym_update_expression] = STATE(424),
    [sym_string] = STATE(426),
    [sym_template_string] = STATE(426),
    [sym_regex] = STATE(426),
    [sym_meta_property] = STATE(426),
    [sym_decorator] = STATE(750),
    [sym_formal_parameters] = STATE(1322),
    [aux_sym_export_statement_repeat1] = STATE(924),
    [sym_identifier] = ACTIONS(321),
    [anon_sym_export] = ACTIONS(323),
    [anon_sym_LBRACE] = ACTIONS(626),
    [anon_sym_import] = ACTIONS(331),
    [anon_sym_LPAREN] = ACTIONS(333),
    [anon_sym_await] = ACTIONS(335),
    [anon_sym_yield] = ACTIONS(339),
    [anon_sym_LBRACK] = ACTIONS(341),
    [anon_sym_LT] = ACTIONS(537),
    [anon_sym_SLASH] = ACTIONS(345),
    [anon_sym_class] = ACTIONS(347),
    [anon_sym_async] = ACTIONS(349),
    [anon_sym_function] = ACTIONS(351),
    [anon_sym_new] = ACTIONS(353),
    [anon_sym_PLUS] = ACTIONS(355),
    [anon_sym_DASH] = ACTIONS(355),
    [anon_sym_BANG] = ACTIONS(357),
    [anon_sym_TILDE] = ACTIONS(357),
    [anon_sym_typeof] = ACTIONS(359),
    [anon_sym_void] = ACTIONS(359),
    [anon_sym_delete] = ACTIONS(359),
    [anon_sym_PLUS_PLUS] = ACTIONS(361),
    [anon_sym_DASH_DASH] = ACTIONS(361),
    [anon_sym_DQUOTE] = ACTIONS(363),
    [anon_sym_SQUOTE] = ACTIONS(365),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(367),
    [sym_number] = ACTIONS(369),
    [sym_this] = ACTIONS(371),
    [sym_super] = ACTIONS(371),
    [sym_true] = ACTIONS(371),
    [sym_false] = ACTIONS(371),
    [sym_null] = ACTIONS(371),
    [sym_undefined] = ACTIONS(371),
    [anon_sym_AT] = ACTIONS(85),
    [anon_sym_static] = ACTIONS(323),
    [anon_sym_get] = ACTIONS(323),
    [anon_sym_set] = ACTIONS(323),
  },
  [96] = {
    [sym_import] = STATE(426),
    [sym_parenthesized_expression] = STATE(340),
    [sym_expression] = STATE(640),
    [sym_primary_expression] = STATE(400),
    [sym_yield_expression] = STATE(424),
    [sym_object] = STATE(426),
    [sym_object_pattern] = STATE(1317),
    [sym_array] = STATE(426),
    [sym_array_pattern] = STATE(1317),
    [sym_jsx_element] = STATE(424),
    [sym_jsx_fragment] = STATE(424),
    [sym_jsx_opening_element] = STATE(768),
    [sym_jsx_self_closing_element] = STATE(424),
    [sym_class] = STATE(426),
    [sym_function] = STATE(426),
    [sym_generator_function] = STATE(426),
    [sym_arrow_function] = STATE(426),
    [sym_call_expression] = STATE(426),
    [sym_new_expression] = STATE(424),
    [sym_await_expression] = STATE(424),
    [sym_member_expression] = STATE(340),
    [sym_subscript_expression] = STATE(340),
    [sym_assignment_expression] = STATE(424),
    [sym__augmented_assignment_lhs] = STATE(712),
    [sym_augmented_assignment_expression] = STATE(424),
    [sym__destructuring_pattern] = STATE(1317),
    [sym_ternary_expression] = STATE(424),
    [sym_binary_expression] = STATE(424),
    [sym_unary_expression] = STATE(424),
    [sym_update_expression] = STATE(424),
    [sym_string] = STATE(426),
    [sym_template_string] = STATE(426),
    [sym_regex] = STATE(426),
    [sym_meta_property] = STATE(426),
    [sym_decorator] = STATE(750),
    [sym_formal_parameters] = STATE(1267),
    [aux_sym_export_statement_repeat1] = STATE(924),
    [sym_identifier] = ACTIONS(391),
    [anon_sym_export] = ACTIONS(393),
    [anon_sym_LBRACE] = ACTIONS(397),
    [anon_sym_import] = ACTIONS(331),
    [anon_sym_LPAREN] = ACTIONS(333),
    [anon_sym_await] = ACTIONS(399),
    [anon_sym_yield] = ACTIONS(401),
    [anon_sym_LBRACK] = ACTIONS(403),
    [anon_sym_LT] = ACTIONS(537),
    [anon_sym_SLASH] = ACTIONS(345),
    [anon_sym_DOT] = ACTIONS(664),
    [anon_sym_class] = ACTIONS(347),
    [anon_sym_async] = ACTIONS(405),
    [anon_sym_function] = ACTIONS(351),
    [anon_sym_new] = ACTIONS(407),
    [anon_sym_PLUS] = ACTIONS(409),
    [anon_sym_DASH] = ACTIONS(409),
    [anon_sym_BANG] = ACTIONS(411),
    [anon_sym_TILDE] = ACTIONS(411),
    [anon_sym_typeof] = ACTIONS(413),
    [anon_sym_void] = ACTIONS(413),
    [anon_sym_delete] = ACTIONS(413),
    [anon_sym_PLUS_PLUS] = ACTIONS(415),
    [anon_sym_DASH_DASH] = ACTIONS(415),
    [anon_sym_DQUOTE] = ACTIONS(363),
    [anon_sym_SQUOTE] = ACTIONS(365),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(367),
    [sym_number] = ACTIONS(369),
    [sym_this] = ACTIONS(371),
    [sym_super] = ACTIONS(371),
    [sym_true] = ACTIONS(371),
    [sym_false] = ACTIONS(371),
    [sym_null] = ACTIONS(371),
    [sym_undefined] = ACTIONS(371),
    [anon_sym_AT] = ACTIONS(85),
    [anon_sym_static] = ACTIONS(393),
    [anon_sym_get] = ACTIONS(393),
    [anon_sym_set] = ACTIONS(393),
  },
  [97] = {
    [sym_import] = STATE(426),
    [sym_statement_block] = STATE(471),
    [sym_parenthesized_expression] = STATE(340),
    [sym_expression] = STATE(622),
    [sym_primary_expression] = STATE(425),
    [sym_yield_expression] = STATE(424),
    [sym_object] = STATE(426),
    [sym_object_pattern] = STATE(1317),
    [sym_array] = STATE(426),
    [sym_array_pattern] = STATE(1317),
    [sym_jsx_element] = STATE(424),
    [sym_jsx_fragment] = STATE(424),
    [sym_jsx_opening_element] = STATE(768),
    [sym_jsx_self_closing_element] = STATE(424),
    [sym_class] = STATE(426),
    [sym_function] = STATE(426),
    [sym_generator_function] = STATE(426),
    [sym_arrow_function] = STATE(426),
    [sym_call_expression] = STATE(426),
    [sym_new_expression] = STATE(424),
    [sym_await_expression] = STATE(424),
    [sym_member_expression] = STATE(340),
    [sym_subscript_expression] = STATE(340),
    [sym_assignment_expression] = STATE(424),
    [sym__augmented_assignment_lhs] = STATE(712),
    [sym_augmented_assignment_expression] = STATE(424),
    [sym__destructuring_pattern] = STATE(1317),
    [sym_ternary_expression] = STATE(424),
    [sym_binary_expression] = STATE(424),
    [sym_unary_expression] = STATE(424),
    [sym_update_expression] = STATE(424),
    [sym_string] = STATE(426),
    [sym_template_string] = STATE(426),
    [sym_regex] = STATE(426),
    [sym_meta_property] = STATE(426),
    [sym_decorator] = STATE(750),
    [sym_formal_parameters] = STATE(1267),
    [aux_sym_export_statement_repeat1] = STATE(924),
    [sym_identifier] = ACTIONS(391),
    [anon_sym_export] = ACTIONS(393),
    [anon_sym_LBRACE] = ACTIONS(666),
    [anon_sym_import] = ACTIONS(331),
    [anon_sym_LPAREN] = ACTIONS(333),
    [anon_sym_await] = ACTIONS(399),
    [anon_sym_yield] = ACTIONS(401),
    [anon_sym_LBRACK] = ACTIONS(403),
    [anon_sym_LT] = ACTIONS(537),
    [anon_sym_SLASH] = ACTIONS(345),
    [anon_sym_class] = ACTIONS(347),
    [anon_sym_async] = ACTIONS(405),
    [anon_sym_function] = ACTIONS(351),
    [anon_sym_new] = ACTIONS(407),
    [anon_sym_PLUS] = ACTIONS(409),
    [anon_sym_DASH] = ACTIONS(409),
    [anon_sym_BANG] = ACTIONS(411),
    [anon_sym_TILDE] = ACTIONS(411),
    [anon_sym_typeof] = ACTIONS(413),
    [anon_sym_void] = ACTIONS(413),
    [anon_sym_delete] = ACTIONS(413),
    [anon_sym_PLUS_PLUS] = ACTIONS(415),
    [anon_sym_DASH_DASH] = ACTIONS(415),
    [anon_sym_DQUOTE] = ACTIONS(363),
    [anon_sym_SQUOTE] = ACTIONS(365),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(367),
    [sym_number] = ACTIONS(369),
    [sym_this] = ACTIONS(371),
    [sym_super] = ACTIONS(371),
    [sym_true] = ACTIONS(371),
    [sym_false] = ACTIONS(371),
    [sym_null] = ACTIONS(371),
    [sym_undefined] = ACTIONS(371),
    [anon_sym_AT] = ACTIONS(85),
    [anon_sym_static] = ACTIONS(393),
    [anon_sym_get] = ACTIONS(393),
    [anon_sym_set] = ACTIONS(393),
  },
  [98] = {
    [sym_import] = STATE(426),
    [sym_statement_block] = STATE(477),
    [sym_parenthesized_expression] = STATE(340),
    [sym_expression] = STATE(623),
    [sym_primary_expression] = STATE(425),
    [sym_yield_expression] = STATE(424),
    [sym_object] = STATE(426),
    [sym_object_pattern] = STATE(1317),
    [sym_array] = STATE(426),
    [sym_array_pattern] = STATE(1317),
    [sym_jsx_element] = STATE(424),
    [sym_jsx_fragment] = STATE(424),
    [sym_jsx_opening_element] = STATE(768),
    [sym_jsx_self_closing_element] = STATE(424),
    [sym_class] = STATE(426),
    [sym_function] = STATE(426),
    [sym_generator_function] = STATE(426),
    [sym_arrow_function] = STATE(426),
    [sym_call_expression] = STATE(426),
    [sym_new_expression] = STATE(424),
    [sym_await_expression] = STATE(424),
    [sym_member_expression] = STATE(340),
    [sym_subscript_expression] = STATE(340),
    [sym_assignment_expression] = STATE(424),
    [sym__augmented_assignment_lhs] = STATE(712),
    [sym_augmented_assignment_expression] = STATE(424),
    [sym__destructuring_pattern] = STATE(1317),
    [sym_ternary_expression] = STATE(424),
    [sym_binary_expression] = STATE(424),
    [sym_unary_expression] = STATE(424),
    [sym_update_expression] = STATE(424),
    [sym_string] = STATE(426),
    [sym_template_string] = STATE(426),
    [sym_regex] = STATE(426),
    [sym_meta_property] = STATE(426),
    [sym_decorator] = STATE(750),
    [sym_formal_parameters] = STATE(1267),
    [aux_sym_export_statement_repeat1] = STATE(924),
    [sym_identifier] = ACTIONS(391),
    [anon_sym_export] = ACTIONS(393),
    [anon_sym_LBRACE] = ACTIONS(666),
    [anon_sym_import] = ACTIONS(331),
    [anon_sym_LPAREN] = ACTIONS(333),
    [anon_sym_await] = ACTIONS(399),
    [anon_sym_yield] = ACTIONS(401),
    [anon_sym_LBRACK] = ACTIONS(403),
    [anon_sym_LT] = ACTIONS(537),
    [anon_sym_SLASH] = ACTIONS(345),
    [anon_sym_class] = ACTIONS(347),
    [anon_sym_async] = ACTIONS(405),
    [anon_sym_function] = ACTIONS(351),
    [anon_sym_new] = ACTIONS(407),
    [anon_sym_PLUS] = ACTIONS(409),
    [anon_sym_DASH] = ACTIONS(409),
    [anon_sym_BANG] = ACTIONS(411),
    [anon_sym_TILDE] = ACTIONS(411),
    [anon_sym_typeof] = ACTIONS(413),
    [anon_sym_void] = ACTIONS(413),
    [anon_sym_delete] = ACTIONS(413),
    [anon_sym_PLUS_PLUS] = ACTIONS(415),
    [anon_sym_DASH_DASH] = ACTIONS(415),
    [anon_sym_DQUOTE] = ACTIONS(363),
    [anon_sym_SQUOTE] = ACTIONS(365),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(367),
    [sym_number] = ACTIONS(369),
    [sym_this] = ACTIONS(371),
    [sym_super] = ACTIONS(371),
    [sym_true] = ACTIONS(371),
    [sym_false] = ACTIONS(371),
    [sym_null] = ACTIONS(371),
    [sym_undefined] = ACTIONS(371),
    [anon_sym_AT] = ACTIONS(85),
    [anon_sym_static] = ACTIONS(393),
    [anon_sym_get] = ACTIONS(393),
    [anon_sym_set] = ACTIONS(393),
  },
  [99] = {
    [sym_import] = STATE(426),
    [sym_parenthesized_expression] = STATE(355),
    [sym_expression] = STATE(587),
    [sym_primary_expression] = STATE(425),
    [sym_yield_expression] = STATE(424),
    [sym_object] = STATE(426),
    [sym_object_pattern] = STATE(1333),
    [sym_array] = STATE(426),
    [sym_array_pattern] = STATE(1333),
    [sym_jsx_element] = STATE(424),
    [sym_jsx_fragment] = STATE(424),
    [sym_jsx_opening_element] = STATE(768),
    [sym_jsx_self_closing_element] = STATE(424),
    [sym_class] = STATE(426),
    [sym_function] = STATE(426),
    [sym_generator_function] = STATE(426),
    [sym_arrow_function] = STATE(426),
    [sym_call_expression] = STATE(426),
    [sym_new_expression] = STATE(424),
    [sym_await_expression] = STATE(424),
    [sym_member_expression] = STATE(355),
    [sym_subscript_expression] = STATE(355),
    [sym_assignment_expression] = STATE(424),
    [sym__augmented_assignment_lhs] = STATE(714),
    [sym_augmented_assignment_expression] = STATE(424),
    [sym__destructuring_pattern] = STATE(1333),
    [sym_ternary_expression] = STATE(424),
    [sym_binary_expression] = STATE(424),
    [sym_unary_expression] = STATE(424),
    [sym_update_expression] = STATE(424),
    [sym_sequence_expression] = STATE(1284),
    [sym_string] = STATE(426),
    [sym_template_string] = STATE(426),
    [sym_regex] = STATE(426),
    [sym_meta_property] = STATE(426),
    [sym_decorator] = STATE(750),
    [sym_formal_parameters] = STATE(1322),
    [aux_sym_export_statement_repeat1] = STATE(924),
    [sym_identifier] = ACTIONS(321),
    [anon_sym_export] = ACTIONS(323),
    [anon_sym_LBRACE] = ACTIONS(327),
    [anon_sym_import] = ACTIONS(331),
    [anon_sym_LPAREN] = ACTIONS(333),
    [anon_sym_await] = ACTIONS(335),
    [anon_sym_yield] = ACTIONS(339),
    [anon_sym_LBRACK] = ACTIONS(341),
    [anon_sym_LT] = ACTIONS(537),
    [anon_sym_SLASH] = ACTIONS(345),
    [anon_sym_class] = ACTIONS(347),
    [anon_sym_async] = ACTIONS(349),
    [anon_sym_function] = ACTIONS(351),
    [anon_sym_new] = ACTIONS(353),
    [anon_sym_PLUS] = ACTIONS(355),
    [anon_sym_DASH] = ACTIONS(355),
    [anon_sym_BANG] = ACTIONS(357),
    [anon_sym_TILDE] = ACTIONS(357),
    [anon_sym_typeof] = ACTIONS(359),
    [anon_sym_void] = ACTIONS(359),
    [anon_sym_delete] = ACTIONS(359),
    [anon_sym_PLUS_PLUS] = ACTIONS(361),
    [anon_sym_DASH_DASH] = ACTIONS(361),
    [anon_sym_DQUOTE] = ACTIONS(363),
    [anon_sym_SQUOTE] = ACTIONS(365),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(367),
    [sym_number] = ACTIONS(369),
    [sym_this] = ACTIONS(371),
    [sym_super] = ACTIONS(371),
    [sym_true] = ACTIONS(371),
    [sym_false] = ACTIONS(371),
    [sym_null] = ACTIONS(371),
    [sym_undefined] = ACTIONS(371),
    [anon_sym_AT] = ACTIONS(85),
    [anon_sym_static] = ACTIONS(323),
    [anon_sym_get] = ACTIONS(323),
    [anon_sym_set] = ACTIONS(323),
  },
  [100] = {
    [sym_import] = STATE(426),
    [sym_statement_block] = STATE(440),
    [sym_parenthesized_expression] = STATE(340),
    [sym_expression] = STATE(542),
    [sym_primary_expression] = STATE(425),
    [sym_yield_expression] = STATE(424),
    [sym_object] = STATE(426),
    [sym_object_pattern] = STATE(1317),
    [sym_array] = STATE(426),
    [sym_array_pattern] = STATE(1317),
    [sym_jsx_element] = STATE(424),
    [sym_jsx_fragment] = STATE(424),
    [sym_jsx_opening_element] = STATE(768),
    [sym_jsx_self_closing_element] = STATE(424),
    [sym_class] = STATE(426),
    [sym_function] = STATE(426),
    [sym_generator_function] = STATE(426),
    [sym_arrow_function] = STATE(426),
    [sym_call_expression] = STATE(426),
    [sym_new_expression] = STATE(424),
    [sym_await_expression] = STATE(424),
    [sym_member_expression] = STATE(340),
    [sym_subscript_expression] = STATE(340),
    [sym_assignment_expression] = STATE(424),
    [sym__augmented_assignment_lhs] = STATE(712),
    [sym_augmented_assignment_expression] = STATE(424),
    [sym__destructuring_pattern] = STATE(1317),
    [sym_ternary_expression] = STATE(424),
    [sym_binary_expression] = STATE(424),
    [sym_unary_expression] = STATE(424),
    [sym_update_expression] = STATE(424),
    [sym_string] = STATE(426),
    [sym_template_string] = STATE(426),
    [sym_regex] = STATE(426),
    [sym_meta_property] = STATE(426),
    [sym_decorator] = STATE(750),
    [sym_formal_parameters] = STATE(1267),
    [aux_sym_export_statement_repeat1] = STATE(924),
    [sym_identifier] = ACTIONS(391),
    [anon_sym_export] = ACTIONS(393),
    [anon_sym_LBRACE] = ACTIONS(666),
    [anon_sym_import] = ACTIONS(331),
    [anon_sym_LPAREN] = ACTIONS(333),
    [anon_sym_await] = ACTIONS(399),
    [anon_sym_yield] = ACTIONS(401),
    [anon_sym_LBRACK] = ACTIONS(403),
    [anon_sym_LT] = ACTIONS(537),
    [anon_sym_SLASH] = ACTIONS(345),
    [anon_sym_class] = ACTIONS(347),
    [anon_sym_async] = ACTIONS(405),
    [anon_sym_function] = ACTIONS(351),
    [anon_sym_new] = ACTIONS(407),
    [anon_sym_PLUS] = ACTIONS(409),
    [anon_sym_DASH] = ACTIONS(409),
    [anon_sym_BANG] = ACTIONS(411),
    [anon_sym_TILDE] = ACTIONS(411),
    [anon_sym_typeof] = ACTIONS(413),
    [anon_sym_void] = ACTIONS(413),
    [anon_sym_delete] = ACTIONS(413),
    [anon_sym_PLUS_PLUS] = ACTIONS(415),
    [anon_sym_DASH_DASH] = ACTIONS(415),
    [anon_sym_DQUOTE] = ACTIONS(363),
    [anon_sym_SQUOTE] = ACTIONS(365),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(367),
    [sym_number] = ACTIONS(369),
    [sym_this] = ACTIONS(371),
    [sym_super] = ACTIONS(371),
    [sym_true] = ACTIONS(371),
    [sym_false] = ACTIONS(371),
    [sym_null] = ACTIONS(371),
    [sym_undefined] = ACTIONS(371),
    [anon_sym_AT] = ACTIONS(85),
    [anon_sym_static] = ACTIONS(393),
    [anon_sym_get] = ACTIONS(393),
    [anon_sym_set] = ACTIONS(393),
  },
  [101] = {
    [sym_import] = STATE(539),
    [sym_statement_block] = STATE(592),
    [sym_parenthesized_expression] = STATE(362),
    [sym_expression] = STATE(449),
    [sym_primary_expression] = STATE(546),
    [sym_yield_expression] = STATE(550),
    [sym_object] = STATE(539),
    [sym_object_pattern] = STATE(1320),
    [sym_array] = STATE(539),
    [sym_array_pattern] = STATE(1320),
    [sym_jsx_element] = STATE(550),
    [sym_jsx_fragment] = STATE(550),
    [sym_jsx_opening_element] = STATE(772),
    [sym_jsx_self_closing_element] = STATE(550),
    [sym_class] = STATE(539),
    [sym_function] = STATE(539),
    [sym_generator_function] = STATE(539),
    [sym_arrow_function] = STATE(539),
    [sym_call_expression] = STATE(539),
    [sym_new_expression] = STATE(550),
    [sym_await_expression] = STATE(550),
    [sym_member_expression] = STATE(362),
    [sym_subscript_expression] = STATE(362),
    [sym_assignment_expression] = STATE(550),
    [sym__augmented_assignment_lhs] = STATE(720),
    [sym_augmented_assignment_expression] = STATE(550),
    [sym__destructuring_pattern] = STATE(1320),
    [sym_ternary_expression] = STATE(550),
    [sym_binary_expression] = STATE(550),
    [sym_unary_expression] = STATE(550),
    [sym_update_expression] = STATE(550),
    [sym_string] = STATE(539),
    [sym_template_string] = STATE(539),
    [sym_regex] = STATE(539),
    [sym_meta_property] = STATE(539),
    [sym_decorator] = STATE(750),
    [sym_formal_parameters] = STATE(1318),
    [aux_sym_export_statement_repeat1] = STATE(925),
    [sym_identifier] = ACTIONS(373),
    [anon_sym_export] = ACTIONS(375),
    [anon_sym_LBRACE] = ACTIONS(628),
    [anon_sym_import] = ACTIONS(381),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(29),
    [anon_sym_yield] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(53),
    [anon_sym_LT] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(385),
    [anon_sym_async] = ACTIONS(387),
    [anon_sym_function] = ACTIONS(389),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_typeof] = ACTIONS(71),
    [anon_sym_void] = ACTIONS(71),
    [anon_sym_delete] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DQUOTE] = ACTIONS(75),
    [anon_sym_SQUOTE] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(79),
    [sym_number] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(83),
    [sym_true] = ACTIONS(83),
    [sym_false] = ACTIONS(83),
    [sym_null] = ACTIONS(83),
    [sym_undefined] = ACTIONS(83),
    [anon_sym_AT] = ACTIONS(85),
    [anon_sym_static] = ACTIONS(375),
    [anon_sym_get] = ACTIONS(375),
    [anon_sym_set] = ACTIONS(375),
  },
  [102] = {
    [sym_import] = STATE(426),
    [sym_statement_block] = STATE(472),
    [sym_parenthesized_expression] = STATE(340),
    [sym_expression] = STATE(591),
    [sym_primary_expression] = STATE(425),
    [sym_yield_expression] = STATE(424),
    [sym_object] = STATE(426),
    [sym_object_pattern] = STATE(1317),
    [sym_array] = STATE(426),
    [sym_array_pattern] = STATE(1317),
    [sym_jsx_element] = STATE(424),
    [sym_jsx_fragment] = STATE(424),
    [sym_jsx_opening_element] = STATE(768),
    [sym_jsx_self_closing_element] = STATE(424),
    [sym_class] = STATE(426),
    [sym_function] = STATE(426),
    [sym_generator_function] = STATE(426),
    [sym_arrow_function] = STATE(426),
    [sym_call_expression] = STATE(426),
    [sym_new_expression] = STATE(424),
    [sym_await_expression] = STATE(424),
    [sym_member_expression] = STATE(340),
    [sym_subscript_expression] = STATE(340),
    [sym_assignment_expression] = STATE(424),
    [sym__augmented_assignment_lhs] = STATE(712),
    [sym_augmented_assignment_expression] = STATE(424),
    [sym__destructuring_pattern] = STATE(1317),
    [sym_ternary_expression] = STATE(424),
    [sym_binary_expression] = STATE(424),
    [sym_unary_expression] = STATE(424),
    [sym_update_expression] = STATE(424),
    [sym_string] = STATE(426),
    [sym_template_string] = STATE(426),
    [sym_regex] = STATE(426),
    [sym_meta_property] = STATE(426),
    [sym_decorator] = STATE(750),
    [sym_formal_parameters] = STATE(1267),
    [aux_sym_export_statement_repeat1] = STATE(924),
    [sym_identifier] = ACTIONS(391),
    [anon_sym_export] = ACTIONS(393),
    [anon_sym_LBRACE] = ACTIONS(666),
    [anon_sym_import] = ACTIONS(331),
    [anon_sym_LPAREN] = ACTIONS(333),
    [anon_sym_await] = ACTIONS(399),
    [anon_sym_yield] = ACTIONS(401),
    [anon_sym_LBRACK] = ACTIONS(403),
    [anon_sym_LT] = ACTIONS(537),
    [anon_sym_SLASH] = ACTIONS(345),
    [anon_sym_class] = ACTIONS(347),
    [anon_sym_async] = ACTIONS(405),
    [anon_sym_function] = ACTIONS(351),
    [anon_sym_new] = ACTIONS(407),
    [anon_sym_PLUS] = ACTIONS(409),
    [anon_sym_DASH] = ACTIONS(409),
    [anon_sym_BANG] = ACTIONS(411),
    [anon_sym_TILDE] = ACTIONS(411),
    [anon_sym_typeof] = ACTIONS(413),
    [anon_sym_void] = ACTIONS(413),
    [anon_sym_delete] = ACTIONS(413),
    [anon_sym_PLUS_PLUS] = ACTIONS(415),
    [anon_sym_DASH_DASH] = ACTIONS(415),
    [anon_sym_DQUOTE] = ACTIONS(363),
    [anon_sym_SQUOTE] = ACTIONS(365),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(367),
    [sym_number] = ACTIONS(369),
    [sym_this] = ACTIONS(371),
    [sym_super] = ACTIONS(371),
    [sym_true] = ACTIONS(371),
    [sym_false] = ACTIONS(371),
    [sym_null] = ACTIONS(371),
    [sym_undefined] = ACTIONS(371),
    [anon_sym_AT] = ACTIONS(85),
    [anon_sym_static] = ACTIONS(393),
    [anon_sym_get] = ACTIONS(393),
    [anon_sym_set] = ACTIONS(393),
  },
  [103] = {
    [sym_import] = STATE(426),
    [sym_statement_block] = STATE(479),
    [sym_parenthesized_expression] = STATE(340),
    [sym_expression] = STATE(625),
    [sym_primary_expression] = STATE(425),
    [sym_yield_expression] = STATE(424),
    [sym_object] = STATE(426),
    [sym_object_pattern] = STATE(1317),
    [sym_array] = STATE(426),
    [sym_array_pattern] = STATE(1317),
    [sym_jsx_element] = STATE(424),
    [sym_jsx_fragment] = STATE(424),
    [sym_jsx_opening_element] = STATE(768),
    [sym_jsx_self_closing_element] = STATE(424),
    [sym_class] = STATE(426),
    [sym_function] = STATE(426),
    [sym_generator_function] = STATE(426),
    [sym_arrow_function] = STATE(426),
    [sym_call_expression] = STATE(426),
    [sym_new_expression] = STATE(424),
    [sym_await_expression] = STATE(424),
    [sym_member_expression] = STATE(340),
    [sym_subscript_expression] = STATE(340),
    [sym_assignment_expression] = STATE(424),
    [sym__augmented_assignment_lhs] = STATE(712),
    [sym_augmented_assignment_expression] = STATE(424),
    [sym__destructuring_pattern] = STATE(1317),
    [sym_ternary_expression] = STATE(424),
    [sym_binary_expression] = STATE(424),
    [sym_unary_expression] = STATE(424),
    [sym_update_expression] = STATE(424),
    [sym_string] = STATE(426),
    [sym_template_string] = STATE(426),
    [sym_regex] = STATE(426),
    [sym_meta_property] = STATE(426),
    [sym_decorator] = STATE(750),
    [sym_formal_parameters] = STATE(1267),
    [aux_sym_export_statement_repeat1] = STATE(924),
    [sym_identifier] = ACTIONS(391),
    [anon_sym_export] = ACTIONS(393),
    [anon_sym_LBRACE] = ACTIONS(666),
    [anon_sym_import] = ACTIONS(331),
    [anon_sym_LPAREN] = ACTIONS(333),
    [anon_sym_await] = ACTIONS(399),
    [anon_sym_yield] = ACTIONS(401),
    [anon_sym_LBRACK] = ACTIONS(403),
    [anon_sym_LT] = ACTIONS(537),
    [anon_sym_SLASH] = ACTIONS(345),
    [anon_sym_class] = ACTIONS(347),
    [anon_sym_async] = ACTIONS(405),
    [anon_sym_function] = ACTIONS(351),
    [anon_sym_new] = ACTIONS(407),
    [anon_sym_PLUS] = ACTIONS(409),
    [anon_sym_DASH] = ACTIONS(409),
    [anon_sym_BANG] = ACTIONS(411),
    [anon_sym_TILDE] = ACTIONS(411),
    [anon_sym_typeof] = ACTIONS(413),
    [anon_sym_void] = ACTIONS(413),
    [anon_sym_delete] = ACTIONS(413),
    [anon_sym_PLUS_PLUS] = ACTIONS(415),
    [anon_sym_DASH_DASH] = ACTIONS(415),
    [anon_sym_DQUOTE] = ACTIONS(363),
    [anon_sym_SQUOTE] = ACTIONS(365),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(367),
    [sym_number] = ACTIONS(369),
    [sym_this] = ACTIONS(371),
    [sym_super] = ACTIONS(371),
    [sym_true] = ACTIONS(371),
    [sym_false] = ACTIONS(371),
    [sym_null] = ACTIONS(371),
    [sym_undefined] = ACTIONS(371),
    [anon_sym_AT] = ACTIONS(85),
    [anon_sym_static] = ACTIONS(393),
    [anon_sym_get] = ACTIONS(393),
    [anon_sym_set] = ACTIONS(393),
  },
  [104] = {
    [sym_import] = STATE(539),
    [sym_statement_block] = STATE(605),
    [sym_parenthesized_expression] = STATE(362),
    [sym_expression] = STATE(433),
    [sym_primary_expression] = STATE(546),
    [sym_yield_expression] = STATE(550),
    [sym_object] = STATE(539),
    [sym_object_pattern] = STATE(1320),
    [sym_array] = STATE(539),
    [sym_array_pattern] = STATE(1320),
    [sym_jsx_element] = STATE(550),
    [sym_jsx_fragment] = STATE(550),
    [sym_jsx_opening_element] = STATE(772),
    [sym_jsx_self_closing_element] = STATE(550),
    [sym_class] = STATE(539),
    [sym_function] = STATE(539),
    [sym_generator_function] = STATE(539),
    [sym_arrow_function] = STATE(539),
    [sym_call_expression] = STATE(539),
    [sym_new_expression] = STATE(550),
    [sym_await_expression] = STATE(550),
    [sym_member_expression] = STATE(362),
    [sym_subscript_expression] = STATE(362),
    [sym_assignment_expression] = STATE(550),
    [sym__augmented_assignment_lhs] = STATE(720),
    [sym_augmented_assignment_expression] = STATE(550),
    [sym__destructuring_pattern] = STATE(1320),
    [sym_ternary_expression] = STATE(550),
    [sym_binary_expression] = STATE(550),
    [sym_unary_expression] = STATE(550),
    [sym_update_expression] = STATE(550),
    [sym_string] = STATE(539),
    [sym_template_string] = STATE(539),
    [sym_regex] = STATE(539),
    [sym_meta_property] = STATE(539),
    [sym_decorator] = STATE(750),
    [sym_formal_parameters] = STATE(1318),
    [aux_sym_export_statement_repeat1] = STATE(925),
    [sym_identifier] = ACTIONS(373),
    [anon_sym_export] = ACTIONS(375),
    [anon_sym_LBRACE] = ACTIONS(628),
    [anon_sym_import] = ACTIONS(381),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(29),
    [anon_sym_yield] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(53),
    [anon_sym_LT] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(385),
    [anon_sym_async] = ACTIONS(387),
    [anon_sym_function] = ACTIONS(389),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_typeof] = ACTIONS(71),
    [anon_sym_void] = ACTIONS(71),
    [anon_sym_delete] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DQUOTE] = ACTIONS(75),
    [anon_sym_SQUOTE] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(79),
    [sym_number] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(83),
    [sym_true] = ACTIONS(83),
    [sym_false] = ACTIONS(83),
    [sym_null] = ACTIONS(83),
    [sym_undefined] = ACTIONS(83),
    [anon_sym_AT] = ACTIONS(85),
    [anon_sym_static] = ACTIONS(375),
    [anon_sym_get] = ACTIONS(375),
    [anon_sym_set] = ACTIONS(375),
  },
  [105] = {
    [sym_import] = STATE(426),
    [sym_parenthesized_expression] = STATE(355),
    [sym_expression] = STATE(593),
    [sym_primary_expression] = STATE(425),
    [sym_yield_expression] = STATE(424),
    [sym_object] = STATE(426),
    [sym_object_pattern] = STATE(1333),
    [sym_array] = STATE(426),
    [sym_array_pattern] = STATE(1333),
    [sym_jsx_element] = STATE(424),
    [sym_jsx_fragment] = STATE(424),
    [sym_jsx_opening_element] = STATE(768),
    [sym_jsx_self_closing_element] = STATE(424),
    [sym_class] = STATE(426),
    [sym_function] = STATE(426),
    [sym_generator_function] = STATE(426),
    [sym_arrow_function] = STATE(426),
    [sym_call_expression] = STATE(426),
    [sym_new_expression] = STATE(424),
    [sym_await_expression] = STATE(424),
    [sym_member_expression] = STATE(355),
    [sym_subscript_expression] = STATE(355),
    [sym_assignment_expression] = STATE(424),
    [sym__augmented_assignment_lhs] = STATE(714),
    [sym_augmented_assignment_expression] = STATE(424),
    [sym__destructuring_pattern] = STATE(1333),
    [sym_ternary_expression] = STATE(424),
    [sym_binary_expression] = STATE(424),
    [sym_unary_expression] = STATE(424),
    [sym_update_expression] = STATE(424),
    [sym_sequence_expression] = STATE(1286),
    [sym_string] = STATE(426),
    [sym_template_string] = STATE(426),
    [sym_regex] = STATE(426),
    [sym_meta_property] = STATE(426),
    [sym_decorator] = STATE(750),
    [sym_formal_parameters] = STATE(1322),
    [aux_sym_export_statement_repeat1] = STATE(924),
    [sym_identifier] = ACTIONS(321),
    [anon_sym_export] = ACTIONS(323),
    [anon_sym_LBRACE] = ACTIONS(327),
    [anon_sym_import] = ACTIONS(331),
    [anon_sym_LPAREN] = ACTIONS(333),
    [anon_sym_await] = ACTIONS(335),
    [anon_sym_yield] = ACTIONS(339),
    [anon_sym_LBRACK] = ACTIONS(341),
    [anon_sym_LT] = ACTIONS(537),
    [anon_sym_SLASH] = ACTIONS(345),
    [anon_sym_class] = ACTIONS(347),
    [anon_sym_async] = ACTIONS(349),
    [anon_sym_function] = ACTIONS(351),
    [anon_sym_new] = ACTIONS(353),
    [anon_sym_PLUS] = ACTIONS(355),
    [anon_sym_DASH] = ACTIONS(355),
    [anon_sym_BANG] = ACTIONS(357),
    [anon_sym_TILDE] = ACTIONS(357),
    [anon_sym_typeof] = ACTIONS(359),
    [anon_sym_void] = ACTIONS(359),
    [anon_sym_delete] = ACTIONS(359),
    [anon_sym_PLUS_PLUS] = ACTIONS(361),
    [anon_sym_DASH_DASH] = ACTIONS(361),
    [anon_sym_DQUOTE] = ACTIONS(363),
    [anon_sym_SQUOTE] = ACTIONS(365),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(367),
    [sym_number] = ACTIONS(369),
    [sym_this] = ACTIONS(371),
    [sym_super] = ACTIONS(371),
    [sym_true] = ACTIONS(371),
    [sym_false] = ACTIONS(371),
    [sym_null] = ACTIONS(371),
    [sym_undefined] = ACTIONS(371),
    [anon_sym_AT] = ACTIONS(85),
    [anon_sym_static] = ACTIONS(323),
    [anon_sym_get] = ACTIONS(323),
    [anon_sym_set] = ACTIONS(323),
  },
  [106] = {
    [sym_import] = STATE(426),
    [sym_parenthesized_expression] = STATE(340),
    [sym_expression] = STATE(640),
    [sym_primary_expression] = STATE(400),
    [sym_yield_expression] = STATE(424),
    [sym_object] = STATE(426),
    [sym_object_pattern] = STATE(1317),
    [sym_array] = STATE(426),
    [sym_array_pattern] = STATE(1317),
    [sym_jsx_element] = STATE(424),
    [sym_jsx_fragment] = STATE(424),
    [sym_jsx_opening_element] = STATE(768),
    [sym_jsx_self_closing_element] = STATE(424),
    [sym_class] = STATE(426),
    [sym_function] = STATE(426),
    [sym_generator_function] = STATE(426),
    [sym_arrow_function] = STATE(426),
    [sym_call_expression] = STATE(426),
    [sym_new_expression] = STATE(424),
    [sym_await_expression] = STATE(424),
    [sym_member_expression] = STATE(340),
    [sym_subscript_expression] = STATE(340),
    [sym_assignment_expression] = STATE(424),
    [sym__augmented_assignment_lhs] = STATE(712),
    [sym_augmented_assignment_expression] = STATE(424),
    [sym__destructuring_pattern] = STATE(1317),
    [sym_ternary_expression] = STATE(424),
    [sym_binary_expression] = STATE(424),
    [sym_unary_expression] = STATE(424),
    [sym_update_expression] = STATE(424),
    [sym_string] = STATE(426),
    [sym_template_string] = STATE(426),
    [sym_regex] = STATE(426),
    [sym_meta_property] = STATE(426),
    [sym_decorator] = STATE(750),
    [sym_formal_parameters] = STATE(1322),
    [aux_sym_export_statement_repeat1] = STATE(924),
    [sym_identifier] = ACTIONS(668),
    [anon_sym_export] = ACTIONS(670),
    [anon_sym_LBRACE] = ACTIONS(327),
    [anon_sym_import] = ACTIONS(331),
    [anon_sym_LPAREN] = ACTIONS(333),
    [anon_sym_await] = ACTIONS(399),
    [anon_sym_yield] = ACTIONS(401),
    [anon_sym_LBRACK] = ACTIONS(341),
    [anon_sym_LT] = ACTIONS(537),
    [anon_sym_SLASH] = ACTIONS(345),
    [anon_sym_DOT] = ACTIONS(664),
    [anon_sym_class] = ACTIONS(347),
    [anon_sym_async] = ACTIONS(672),
    [anon_sym_function] = ACTIONS(351),
    [anon_sym_new] = ACTIONS(407),
    [anon_sym_PLUS] = ACTIONS(409),
    [anon_sym_DASH] = ACTIONS(409),
    [anon_sym_BANG] = ACTIONS(411),
    [anon_sym_TILDE] = ACTIONS(411),
    [anon_sym_typeof] = ACTIONS(413),
    [anon_sym_void] = ACTIONS(413),
    [anon_sym_delete] = ACTIONS(413),
    [anon_sym_PLUS_PLUS] = ACTIONS(415),
    [anon_sym_DASH_DASH] = ACTIONS(415),
    [anon_sym_DQUOTE] = ACTIONS(363),
    [anon_sym_SQUOTE] = ACTIONS(365),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(367),
    [sym_number] = ACTIONS(369),
    [sym_this] = ACTIONS(371),
    [sym_super] = ACTIONS(371),
    [sym_true] = ACTIONS(371),
    [sym_false] = ACTIONS(371),
    [sym_null] = ACTIONS(371),
    [sym_undefined] = ACTIONS(371),
    [anon_sym_AT] = ACTIONS(85),
    [anon_sym_static] = ACTIONS(670),
    [anon_sym_get] = ACTIONS(670),
    [anon_sym_set] = ACTIONS(670),
  },
  [107] = {
    [sym_export_clause] = STATE(927),
    [sym_declaration] = STATE(293),
    [sym_variable_declaration] = STATE(275),
    [sym_lexical_declaration] = STATE(275),
    [sym_class_declaration] = STATE(275),
    [sym_function_declaration] = STATE(275),
    [sym_generator_function_declaration] = STATE(275),
    [sym_decorator] = STATE(750),
    [aux_sym_export_statement_repeat1] = STATE(922),
    [aux_sym_object_repeat1] = STATE(1058),
    [aux_sym_object_pattern_repeat1] = STATE(978),
    [anon_sym_STAR] = ACTIONS(630),
    [anon_sym_default] = ACTIONS(632),
    [anon_sym_LBRACE] = ACTIONS(634),
    [anon_sym_COMMA] = ACTIONS(636),
    [anon_sym_RBRACE] = ACTIONS(674),
    [anon_sym_var] = ACTIONS(640),
    [anon_sym_let] = ACTIONS(642),
    [anon_sym_const] = ACTIONS(642),
    [anon_sym_LPAREN] = ACTIONS(644),
    [anon_sym_in] = ACTIONS(647),
    [anon_sym_SEMI] = ACTIONS(636),
    [anon_sym_COLON] = ACTIONS(649),
    [anon_sym_EQ] = ACTIONS(652),
    [anon_sym_LBRACK] = ACTIONS(636),
    [anon_sym_LT] = ACTIONS(647),
    [anon_sym_GT] = ACTIONS(647),
    [anon_sym_SLASH] = ACTIONS(647),
    [anon_sym_DOT] = ACTIONS(636),
    [anon_sym_class] = ACTIONS(654),
    [anon_sym_async] = ACTIONS(656),
    [anon_sym_function] = ACTIONS(658),
    [anon_sym_EQ_GT] = ACTIONS(660),
    [anon_sym_QMARK_DOT] = ACTIONS(636),
    [anon_sym_PLUS_EQ] = ACTIONS(662),
    [anon_sym_DASH_EQ] = ACTIONS(662),
    [anon_sym_STAR_EQ] = ACTIONS(662),
    [anon_sym_SLASH_EQ] = ACTIONS(662),
    [anon_sym_PERCENT_EQ] = ACTIONS(662),
    [anon_sym_CARET_EQ] = ACTIONS(662),
    [anon_sym_AMP_EQ] = ACTIONS(662),
    [anon_sym_PIPE_EQ] = ACTIONS(662),
    [anon_sym_GT_GT_EQ] = ACTIONS(662),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(662),
    [anon_sym_LT_LT_EQ] = ACTIONS(662),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(662),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(662),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(662),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(662),
    [anon_sym_QMARK] = ACTIONS(647),
    [anon_sym_AMP_AMP] = ACTIONS(647),
    [anon_sym_PIPE_PIPE] = ACTIONS(647),
    [anon_sym_GT_GT] = ACTIONS(647),
    [anon_sym_GT_GT_GT] = ACTIONS(647),
    [anon_sym_LT_LT] = ACTIONS(647),
    [anon_sym_AMP] = ACTIONS(647),
    [anon_sym_CARET] = ACTIONS(647),
    [anon_sym_PIPE] = ACTIONS(647),
    [anon_sym_PLUS] = ACTIONS(647),
    [anon_sym_DASH] = ACTIONS(647),
    [anon_sym_PERCENT] = ACTIONS(647),
    [anon_sym_STAR_STAR] = ACTIONS(647),
    [anon_sym_LT_EQ] = ACTIONS(636),
    [anon_sym_EQ_EQ] = ACTIONS(647),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(636),
    [anon_sym_BANG_EQ] = ACTIONS(647),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(636),
    [anon_sym_GT_EQ] = ACTIONS(636),
    [anon_sym_QMARK_QMARK] = ACTIONS(647),
    [anon_sym_instanceof] = ACTIONS(636),
    [anon_sym_PLUS_PLUS] = ACTIONS(636),
    [anon_sym_DASH_DASH] = ACTIONS(636),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(636),
    [anon_sym_AT] = ACTIONS(85),
    [sym__automatic_semicolon] = ACTIONS(636),
  },
  [108] = {
    [sym_import] = STATE(426),
    [sym_parenthesized_expression] = STATE(355),
    [sym_expression] = STATE(572),
    [sym_primary_expression] = STATE(425),
    [sym_yield_expression] = STATE(424),
    [sym_object] = STATE(426),
    [sym_object_pattern] = STATE(1333),
    [sym_array] = STATE(426),
    [sym_array_pattern] = STATE(1333),
    [sym_jsx_element] = STATE(424),
    [sym_jsx_fragment] = STATE(424),
    [sym_jsx_opening_element] = STATE(768),
    [sym_jsx_self_closing_element] = STATE(424),
    [sym_class] = STATE(426),
    [sym_function] = STATE(426),
    [sym_generator_function] = STATE(426),
    [sym_arrow_function] = STATE(426),
    [sym_call_expression] = STATE(426),
    [sym_new_expression] = STATE(424),
    [sym_await_expression] = STATE(424),
    [sym_member_expression] = STATE(355),
    [sym_subscript_expression] = STATE(355),
    [sym_assignment_expression] = STATE(424),
    [sym__augmented_assignment_lhs] = STATE(714),
    [sym_augmented_assignment_expression] = STATE(424),
    [sym__destructuring_pattern] = STATE(1333),
    [sym_ternary_expression] = STATE(424),
    [sym_binary_expression] = STATE(424),
    [sym_unary_expression] = STATE(424),
    [sym_update_expression] = STATE(424),
    [sym_sequence_expression] = STATE(1349),
    [sym_string] = STATE(426),
    [sym_template_string] = STATE(426),
    [sym_regex] = STATE(426),
    [sym_meta_property] = STATE(426),
    [sym_decorator] = STATE(750),
    [sym_formal_parameters] = STATE(1322),
    [aux_sym_export_statement_repeat1] = STATE(924),
    [sym_identifier] = ACTIONS(321),
    [anon_sym_export] = ACTIONS(323),
    [anon_sym_LBRACE] = ACTIONS(327),
    [anon_sym_import] = ACTIONS(331),
    [anon_sym_LPAREN] = ACTIONS(333),
    [anon_sym_await] = ACTIONS(335),
    [anon_sym_yield] = ACTIONS(339),
    [anon_sym_LBRACK] = ACTIONS(341),
    [anon_sym_LT] = ACTIONS(537),
    [anon_sym_SLASH] = ACTIONS(345),
    [anon_sym_class] = ACTIONS(347),
    [anon_sym_async] = ACTIONS(349),
    [anon_sym_function] = ACTIONS(351),
    [anon_sym_new] = ACTIONS(353),
    [anon_sym_PLUS] = ACTIONS(355),
    [anon_sym_DASH] = ACTIONS(355),
    [anon_sym_BANG] = ACTIONS(357),
    [anon_sym_TILDE] = ACTIONS(357),
    [anon_sym_typeof] = ACTIONS(359),
    [anon_sym_void] = ACTIONS(359),
    [anon_sym_delete] = ACTIONS(359),
    [anon_sym_PLUS_PLUS] = ACTIONS(361),
    [anon_sym_DASH_DASH] = ACTIONS(361),
    [anon_sym_DQUOTE] = ACTIONS(363),
    [anon_sym_SQUOTE] = ACTIONS(365),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(367),
    [sym_number] = ACTIONS(369),
    [sym_this] = ACTIONS(371),
    [sym_super] = ACTIONS(371),
    [sym_true] = ACTIONS(371),
    [sym_false] = ACTIONS(371),
    [sym_null] = ACTIONS(371),
    [sym_undefined] = ACTIONS(371),
    [anon_sym_AT] = ACTIONS(85),
    [anon_sym_static] = ACTIONS(323),
    [anon_sym_get] = ACTIONS(323),
    [anon_sym_set] = ACTIONS(323),
  },
  [109] = {
    [sym_import] = STATE(426),
    [sym_parenthesized_expression] = STATE(355),
    [sym_expression] = STATE(553),
    [sym_primary_expression] = STATE(425),
    [sym_yield_expression] = STATE(424),
    [sym_object] = STATE(426),
    [sym_object_pattern] = STATE(1333),
    [sym_array] = STATE(426),
    [sym_array_pattern] = STATE(1333),
    [sym_jsx_element] = STATE(424),
    [sym_jsx_fragment] = STATE(424),
    [sym_jsx_opening_element] = STATE(768),
    [sym_jsx_self_closing_element] = STATE(424),
    [sym_class] = STATE(426),
    [sym_function] = STATE(426),
    [sym_generator_function] = STATE(426),
    [sym_arrow_function] = STATE(426),
    [sym_call_expression] = STATE(426),
    [sym_new_expression] = STATE(424),
    [sym_await_expression] = STATE(424),
    [sym_member_expression] = STATE(355),
    [sym_subscript_expression] = STATE(355),
    [sym_assignment_expression] = STATE(424),
    [sym__augmented_assignment_lhs] = STATE(714),
    [sym_augmented_assignment_expression] = STATE(424),
    [sym__destructuring_pattern] = STATE(1333),
    [sym_ternary_expression] = STATE(424),
    [sym_binary_expression] = STATE(424),
    [sym_unary_expression] = STATE(424),
    [sym_update_expression] = STATE(424),
    [sym_sequence_expression] = STATE(1340),
    [sym_string] = STATE(426),
    [sym_template_string] = STATE(426),
    [sym_regex] = STATE(426),
    [sym_meta_property] = STATE(426),
    [sym_decorator] = STATE(750),
    [sym_formal_parameters] = STATE(1322),
    [aux_sym_export_statement_repeat1] = STATE(924),
    [sym_identifier] = ACTIONS(321),
    [anon_sym_export] = ACTIONS(323),
    [anon_sym_LBRACE] = ACTIONS(327),
    [anon_sym_import] = ACTIONS(331),
    [anon_sym_LPAREN] = ACTIONS(333),
    [anon_sym_await] = ACTIONS(335),
    [anon_sym_yield] = ACTIONS(339),
    [anon_sym_LBRACK] = ACTIONS(341),
    [anon_sym_LT] = ACTIONS(537),
    [anon_sym_SLASH] = ACTIONS(345),
    [anon_sym_class] = ACTIONS(347),
    [anon_sym_async] = ACTIONS(349),
    [anon_sym_function] = ACTIONS(351),
    [anon_sym_new] = ACTIONS(353),
    [anon_sym_PLUS] = ACTIONS(355),
    [anon_sym_DASH] = ACTIONS(355),
    [anon_sym_BANG] = ACTIONS(357),
    [anon_sym_TILDE] = ACTIONS(357),
    [anon_sym_typeof] = ACTIONS(359),
    [anon_sym_void] = ACTIONS(359),
    [anon_sym_delete] = ACTIONS(359),
    [anon_sym_PLUS_PLUS] = ACTIONS(361),
    [anon_sym_DASH_DASH] = ACTIONS(361),
    [anon_sym_DQUOTE] = ACTIONS(363),
    [anon_sym_SQUOTE] = ACTIONS(365),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(367),
    [sym_number] = ACTIONS(369),
    [sym_this] = ACTIONS(371),
    [sym_super] = ACTIONS(371),
    [sym_true] = ACTIONS(371),
    [sym_false] = ACTIONS(371),
    [sym_null] = ACTIONS(371),
    [sym_undefined] = ACTIONS(371),
    [anon_sym_AT] = ACTIONS(85),
    [anon_sym_static] = ACTIONS(323),
    [anon_sym_get] = ACTIONS(323),
    [anon_sym_set] = ACTIONS(323),
  },
  [110] = {
    [sym_import] = STATE(539),
    [sym_statement_block] = STATE(607),
    [sym_parenthesized_expression] = STATE(362),
    [sym_expression] = STATE(501),
    [sym_primary_expression] = STATE(546),
    [sym_yield_expression] = STATE(550),
    [sym_object] = STATE(539),
    [sym_object_pattern] = STATE(1320),
    [sym_array] = STATE(539),
    [sym_array_pattern] = STATE(1320),
    [sym_jsx_element] = STATE(550),
    [sym_jsx_fragment] = STATE(550),
    [sym_jsx_opening_element] = STATE(772),
    [sym_jsx_self_closing_element] = STATE(550),
    [sym_class] = STATE(539),
    [sym_function] = STATE(539),
    [sym_generator_function] = STATE(539),
    [sym_arrow_function] = STATE(539),
    [sym_call_expression] = STATE(539),
    [sym_new_expression] = STATE(550),
    [sym_await_expression] = STATE(550),
    [sym_member_expression] = STATE(362),
    [sym_subscript_expression] = STATE(362),
    [sym_assignment_expression] = STATE(550),
    [sym__augmented_assignment_lhs] = STATE(720),
    [sym_augmented_assignment_expression] = STATE(550),
    [sym__destructuring_pattern] = STATE(1320),
    [sym_ternary_expression] = STATE(550),
    [sym_binary_expression] = STATE(550),
    [sym_unary_expression] = STATE(550),
    [sym_update_expression] = STATE(550),
    [sym_string] = STATE(539),
    [sym_template_string] = STATE(539),
    [sym_regex] = STATE(539),
    [sym_meta_property] = STATE(539),
    [sym_decorator] = STATE(750),
    [sym_formal_parameters] = STATE(1318),
    [aux_sym_export_statement_repeat1] = STATE(925),
    [sym_identifier] = ACTIONS(373),
    [anon_sym_export] = ACTIONS(375),
    [anon_sym_LBRACE] = ACTIONS(628),
    [anon_sym_import] = ACTIONS(381),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(29),
    [anon_sym_yield] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(53),
    [anon_sym_LT] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(385),
    [anon_sym_async] = ACTIONS(387),
    [anon_sym_function] = ACTIONS(389),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_typeof] = ACTIONS(71),
    [anon_sym_void] = ACTIONS(71),
    [anon_sym_delete] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DQUOTE] = ACTIONS(75),
    [anon_sym_SQUOTE] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(79),
    [sym_number] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(83),
    [sym_true] = ACTIONS(83),
    [sym_false] = ACTIONS(83),
    [sym_null] = ACTIONS(83),
    [sym_undefined] = ACTIONS(83),
    [anon_sym_AT] = ACTIONS(85),
    [anon_sym_static] = ACTIONS(375),
    [anon_sym_get] = ACTIONS(375),
    [anon_sym_set] = ACTIONS(375),
  },
  [111] = {
    [sym_import] = STATE(426),
    [sym_parenthesized_expression] = STATE(355),
    [sym_expression] = STATE(578),
    [sym_primary_expression] = STATE(425),
    [sym_yield_expression] = STATE(424),
    [sym_object] = STATE(426),
    [sym_object_pattern] = STATE(1333),
    [sym_array] = STATE(426),
    [sym_array_pattern] = STATE(1333),
    [sym_jsx_element] = STATE(424),
    [sym_jsx_fragment] = STATE(424),
    [sym_jsx_opening_element] = STATE(768),
    [sym_jsx_self_closing_element] = STATE(424),
    [sym_class] = STATE(426),
    [sym_function] = STATE(426),
    [sym_generator_function] = STATE(426),
    [sym_arrow_function] = STATE(426),
    [sym_call_expression] = STATE(426),
    [sym_new_expression] = STATE(424),
    [sym_await_expression] = STATE(424),
    [sym_member_expression] = STATE(355),
    [sym_subscript_expression] = STATE(355),
    [sym_assignment_expression] = STATE(424),
    [sym__augmented_assignment_lhs] = STATE(714),
    [sym_augmented_assignment_expression] = STATE(424),
    [sym__destructuring_pattern] = STATE(1333),
    [sym_ternary_expression] = STATE(424),
    [sym_binary_expression] = STATE(424),
    [sym_unary_expression] = STATE(424),
    [sym_update_expression] = STATE(424),
    [sym_sequence_expression] = STATE(1326),
    [sym_string] = STATE(426),
    [sym_template_string] = STATE(426),
    [sym_regex] = STATE(426),
    [sym_meta_property] = STATE(426),
    [sym_decorator] = STATE(750),
    [sym_formal_parameters] = STATE(1322),
    [aux_sym_export_statement_repeat1] = STATE(924),
    [sym_identifier] = ACTIONS(321),
    [anon_sym_export] = ACTIONS(323),
    [anon_sym_LBRACE] = ACTIONS(327),
    [anon_sym_import] = ACTIONS(331),
    [anon_sym_LPAREN] = ACTIONS(333),
    [anon_sym_await] = ACTIONS(335),
    [anon_sym_yield] = ACTIONS(339),
    [anon_sym_LBRACK] = ACTIONS(341),
    [anon_sym_LT] = ACTIONS(537),
    [anon_sym_SLASH] = ACTIONS(345),
    [anon_sym_class] = ACTIONS(347),
    [anon_sym_async] = ACTIONS(349),
    [anon_sym_function] = ACTIONS(351),
    [anon_sym_new] = ACTIONS(353),
    [anon_sym_PLUS] = ACTIONS(355),
    [anon_sym_DASH] = ACTIONS(355),
    [anon_sym_BANG] = ACTIONS(357),
    [anon_sym_TILDE] = ACTIONS(357),
    [anon_sym_typeof] = ACTIONS(359),
    [anon_sym_void] = ACTIONS(359),
    [anon_sym_delete] = ACTIONS(359),
    [anon_sym_PLUS_PLUS] = ACTIONS(361),
    [anon_sym_DASH_DASH] = ACTIONS(361),
    [anon_sym_DQUOTE] = ACTIONS(363),
    [anon_sym_SQUOTE] = ACTIONS(365),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(367),
    [sym_number] = ACTIONS(369),
    [sym_this] = ACTIONS(371),
    [sym_super] = ACTIONS(371),
    [sym_true] = ACTIONS(371),
    [sym_false] = ACTIONS(371),
    [sym_null] = ACTIONS(371),
    [sym_undefined] = ACTIONS(371),
    [anon_sym_AT] = ACTIONS(85),
    [anon_sym_static] = ACTIONS(323),
    [anon_sym_get] = ACTIONS(323),
    [anon_sym_set] = ACTIONS(323),
  },
  [112] = {
    [sym_import] = STATE(539),
    [sym_statement_block] = STATE(609),
    [sym_parenthesized_expression] = STATE(362),
    [sym_expression] = STATE(503),
    [sym_primary_expression] = STATE(546),
    [sym_yield_expression] = STATE(550),
    [sym_object] = STATE(539),
    [sym_object_pattern] = STATE(1320),
    [sym_array] = STATE(539),
    [sym_array_pattern] = STATE(1320),
    [sym_jsx_element] = STATE(550),
    [sym_jsx_fragment] = STATE(550),
    [sym_jsx_opening_element] = STATE(772),
    [sym_jsx_self_closing_element] = STATE(550),
    [sym_class] = STATE(539),
    [sym_function] = STATE(539),
    [sym_generator_function] = STATE(539),
    [sym_arrow_function] = STATE(539),
    [sym_call_expression] = STATE(539),
    [sym_new_expression] = STATE(550),
    [sym_await_expression] = STATE(550),
    [sym_member_expression] = STATE(362),
    [sym_subscript_expression] = STATE(362),
    [sym_assignment_expression] = STATE(550),
    [sym__augmented_assignment_lhs] = STATE(720),
    [sym_augmented_assignment_expression] = STATE(550),
    [sym__destructuring_pattern] = STATE(1320),
    [sym_ternary_expression] = STATE(550),
    [sym_binary_expression] = STATE(550),
    [sym_unary_expression] = STATE(550),
    [sym_update_expression] = STATE(550),
    [sym_string] = STATE(539),
    [sym_template_string] = STATE(539),
    [sym_regex] = STATE(539),
    [sym_meta_property] = STATE(539),
    [sym_decorator] = STATE(750),
    [sym_formal_parameters] = STATE(1318),
    [aux_sym_export_statement_repeat1] = STATE(925),
    [sym_identifier] = ACTIONS(373),
    [anon_sym_export] = ACTIONS(375),
    [anon_sym_LBRACE] = ACTIONS(628),
    [anon_sym_import] = ACTIONS(381),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(29),
    [anon_sym_yield] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(53),
    [anon_sym_LT] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(385),
    [anon_sym_async] = ACTIONS(387),
    [anon_sym_function] = ACTIONS(389),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_typeof] = ACTIONS(71),
    [anon_sym_void] = ACTIONS(71),
    [anon_sym_delete] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DQUOTE] = ACTIONS(75),
    [anon_sym_SQUOTE] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(79),
    [sym_number] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(83),
    [sym_true] = ACTIONS(83),
    [sym_false] = ACTIONS(83),
    [sym_null] = ACTIONS(83),
    [sym_undefined] = ACTIONS(83),
    [anon_sym_AT] = ACTIONS(85),
    [anon_sym_static] = ACTIONS(375),
    [anon_sym_get] = ACTIONS(375),
    [anon_sym_set] = ACTIONS(375),
  },
  [113] = {
    [sym_import] = STATE(539),
    [sym_statement_block] = STATE(557),
    [sym_parenthesized_expression] = STATE(362),
    [sym_expression] = STATE(429),
    [sym_primary_expression] = STATE(546),
    [sym_yield_expression] = STATE(550),
    [sym_object] = STATE(539),
    [sym_object_pattern] = STATE(1320),
    [sym_array] = STATE(539),
    [sym_array_pattern] = STATE(1320),
    [sym_jsx_element] = STATE(550),
    [sym_jsx_fragment] = STATE(550),
    [sym_jsx_opening_element] = STATE(772),
    [sym_jsx_self_closing_element] = STATE(550),
    [sym_class] = STATE(539),
    [sym_function] = STATE(539),
    [sym_generator_function] = STATE(539),
    [sym_arrow_function] = STATE(539),
    [sym_call_expression] = STATE(539),
    [sym_new_expression] = STATE(550),
    [sym_await_expression] = STATE(550),
    [sym_member_expression] = STATE(362),
    [sym_subscript_expression] = STATE(362),
    [sym_assignment_expression] = STATE(550),
    [sym__augmented_assignment_lhs] = STATE(720),
    [sym_augmented_assignment_expression] = STATE(550),
    [sym__destructuring_pattern] = STATE(1320),
    [sym_ternary_expression] = STATE(550),
    [sym_binary_expression] = STATE(550),
    [sym_unary_expression] = STATE(550),
    [sym_update_expression] = STATE(550),
    [sym_string] = STATE(539),
    [sym_template_string] = STATE(539),
    [sym_regex] = STATE(539),
    [sym_meta_property] = STATE(539),
    [sym_decorator] = STATE(750),
    [sym_formal_parameters] = STATE(1318),
    [aux_sym_export_statement_repeat1] = STATE(925),
    [sym_identifier] = ACTIONS(373),
    [anon_sym_export] = ACTIONS(375),
    [anon_sym_LBRACE] = ACTIONS(628),
    [anon_sym_import] = ACTIONS(381),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(29),
    [anon_sym_yield] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(53),
    [anon_sym_LT] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(385),
    [anon_sym_async] = ACTIONS(387),
    [anon_sym_function] = ACTIONS(389),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_typeof] = ACTIONS(71),
    [anon_sym_void] = ACTIONS(71),
    [anon_sym_delete] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DQUOTE] = ACTIONS(75),
    [anon_sym_SQUOTE] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(79),
    [sym_number] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(83),
    [sym_true] = ACTIONS(83),
    [sym_false] = ACTIONS(83),
    [sym_null] = ACTIONS(83),
    [sym_undefined] = ACTIONS(83),
    [anon_sym_AT] = ACTIONS(85),
    [anon_sym_static] = ACTIONS(375),
    [anon_sym_get] = ACTIONS(375),
    [anon_sym_set] = ACTIONS(375),
  },
  [114] = {
    [sym_import] = STATE(426),
    [sym_parenthesized_expression] = STATE(355),
    [sym_expression] = STATE(555),
    [sym_primary_expression] = STATE(425),
    [sym_yield_expression] = STATE(424),
    [sym_object] = STATE(426),
    [sym_object_pattern] = STATE(1333),
    [sym_array] = STATE(426),
    [sym_array_pattern] = STATE(1333),
    [sym_jsx_element] = STATE(424),
    [sym_jsx_fragment] = STATE(424),
    [sym_jsx_opening_element] = STATE(768),
    [sym_jsx_self_closing_element] = STATE(424),
    [sym_class] = STATE(426),
    [sym_function] = STATE(426),
    [sym_generator_function] = STATE(426),
    [sym_arrow_function] = STATE(426),
    [sym_call_expression] = STATE(426),
    [sym_new_expression] = STATE(424),
    [sym_await_expression] = STATE(424),
    [sym_member_expression] = STATE(355),
    [sym_subscript_expression] = STATE(355),
    [sym_assignment_expression] = STATE(424),
    [sym__augmented_assignment_lhs] = STATE(714),
    [sym_augmented_assignment_expression] = STATE(424),
    [sym__destructuring_pattern] = STATE(1333),
    [sym_ternary_expression] = STATE(424),
    [sym_binary_expression] = STATE(424),
    [sym_unary_expression] = STATE(424),
    [sym_update_expression] = STATE(424),
    [sym_sequence_expression] = STATE(1315),
    [sym_string] = STATE(426),
    [sym_template_string] = STATE(426),
    [sym_regex] = STATE(426),
    [sym_meta_property] = STATE(426),
    [sym_decorator] = STATE(750),
    [sym_formal_parameters] = STATE(1322),
    [aux_sym_export_statement_repeat1] = STATE(924),
    [sym_identifier] = ACTIONS(321),
    [anon_sym_export] = ACTIONS(323),
    [anon_sym_LBRACE] = ACTIONS(327),
    [anon_sym_import] = ACTIONS(331),
    [anon_sym_LPAREN] = ACTIONS(333),
    [anon_sym_await] = ACTIONS(335),
    [anon_sym_yield] = ACTIONS(339),
    [anon_sym_LBRACK] = ACTIONS(341),
    [anon_sym_LT] = ACTIONS(537),
    [anon_sym_SLASH] = ACTIONS(345),
    [anon_sym_class] = ACTIONS(347),
    [anon_sym_async] = ACTIONS(349),
    [anon_sym_function] = ACTIONS(351),
    [anon_sym_new] = ACTIONS(353),
    [anon_sym_PLUS] = ACTIONS(355),
    [anon_sym_DASH] = ACTIONS(355),
    [anon_sym_BANG] = ACTIONS(357),
    [anon_sym_TILDE] = ACTIONS(357),
    [anon_sym_typeof] = ACTIONS(359),
    [anon_sym_void] = ACTIONS(359),
    [anon_sym_delete] = ACTIONS(359),
    [anon_sym_PLUS_PLUS] = ACTIONS(361),
    [anon_sym_DASH_DASH] = ACTIONS(361),
    [anon_sym_DQUOTE] = ACTIONS(363),
    [anon_sym_SQUOTE] = ACTIONS(365),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(367),
    [sym_number] = ACTIONS(369),
    [sym_this] = ACTIONS(371),
    [sym_super] = ACTIONS(371),
    [sym_true] = ACTIONS(371),
    [sym_false] = ACTIONS(371),
    [sym_null] = ACTIONS(371),
    [sym_undefined] = ACTIONS(371),
    [anon_sym_AT] = ACTIONS(85),
    [anon_sym_static] = ACTIONS(323),
    [anon_sym_get] = ACTIONS(323),
    [anon_sym_set] = ACTIONS(323),
  },
  [115] = {
    [sym_import] = STATE(426),
    [sym_statement_block] = STATE(479),
    [sym_parenthesized_expression] = STATE(355),
    [sym_expression] = STATE(407),
    [sym_primary_expression] = STATE(425),
    [sym_yield_expression] = STATE(424),
    [sym_object] = STATE(426),
    [sym_object_pattern] = STATE(1333),
    [sym_array] = STATE(426),
    [sym_array_pattern] = STATE(1333),
    [sym_jsx_element] = STATE(424),
    [sym_jsx_fragment] = STATE(424),
    [sym_jsx_opening_element] = STATE(768),
    [sym_jsx_self_closing_element] = STATE(424),
    [sym_class] = STATE(426),
    [sym_function] = STATE(426),
    [sym_generator_function] = STATE(426),
    [sym_arrow_function] = STATE(426),
    [sym_call_expression] = STATE(426),
    [sym_new_expression] = STATE(424),
    [sym_await_expression] = STATE(424),
    [sym_member_expression] = STATE(355),
    [sym_subscript_expression] = STATE(355),
    [sym_assignment_expression] = STATE(424),
    [sym__augmented_assignment_lhs] = STATE(714),
    [sym_augmented_assignment_expression] = STATE(424),
    [sym__destructuring_pattern] = STATE(1333),
    [sym_ternary_expression] = STATE(424),
    [sym_binary_expression] = STATE(424),
    [sym_unary_expression] = STATE(424),
    [sym_update_expression] = STATE(424),
    [sym_string] = STATE(426),
    [sym_template_string] = STATE(426),
    [sym_regex] = STATE(426),
    [sym_meta_property] = STATE(426),
    [sym_decorator] = STATE(750),
    [sym_formal_parameters] = STATE(1322),
    [aux_sym_export_statement_repeat1] = STATE(924),
    [sym_identifier] = ACTIONS(321),
    [anon_sym_export] = ACTIONS(323),
    [anon_sym_LBRACE] = ACTIONS(626),
    [anon_sym_import] = ACTIONS(331),
    [anon_sym_LPAREN] = ACTIONS(333),
    [anon_sym_await] = ACTIONS(335),
    [anon_sym_yield] = ACTIONS(339),
    [anon_sym_LBRACK] = ACTIONS(341),
    [anon_sym_LT] = ACTIONS(537),
    [anon_sym_SLASH] = ACTIONS(345),
    [anon_sym_class] = ACTIONS(347),
    [anon_sym_async] = ACTIONS(349),
    [anon_sym_function] = ACTIONS(351),
    [anon_sym_new] = ACTIONS(353),
    [anon_sym_PLUS] = ACTIONS(355),
    [anon_sym_DASH] = ACTIONS(355),
    [anon_sym_BANG] = ACTIONS(357),
    [anon_sym_TILDE] = ACTIONS(357),
    [anon_sym_typeof] = ACTIONS(359),
    [anon_sym_void] = ACTIONS(359),
    [anon_sym_delete] = ACTIONS(359),
    [anon_sym_PLUS_PLUS] = ACTIONS(361),
    [anon_sym_DASH_DASH] = ACTIONS(361),
    [anon_sym_DQUOTE] = ACTIONS(363),
    [anon_sym_SQUOTE] = ACTIONS(365),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(367),
    [sym_number] = ACTIONS(369),
    [sym_this] = ACTIONS(371),
    [sym_super] = ACTIONS(371),
    [sym_true] = ACTIONS(371),
    [sym_false] = ACTIONS(371),
    [sym_null] = ACTIONS(371),
    [sym_undefined] = ACTIONS(371),
    [anon_sym_AT] = ACTIONS(85),
    [anon_sym_static] = ACTIONS(323),
    [anon_sym_get] = ACTIONS(323),
    [anon_sym_set] = ACTIONS(323),
  },
  [116] = {
    [sym_import] = STATE(426),
    [sym_parenthesized_expression] = STATE(340),
    [sym_expression] = STATE(640),
    [sym_primary_expression] = STATE(400),
    [sym_yield_expression] = STATE(424),
    [sym_object] = STATE(426),
    [sym_object_pattern] = STATE(1317),
    [sym_array] = STATE(426),
    [sym_array_pattern] = STATE(1317),
    [sym_jsx_element] = STATE(424),
    [sym_jsx_fragment] = STATE(424),
    [sym_jsx_opening_element] = STATE(768),
    [sym_jsx_self_closing_element] = STATE(424),
    [sym_class] = STATE(426),
    [sym_function] = STATE(426),
    [sym_generator_function] = STATE(426),
    [sym_arrow_function] = STATE(426),
    [sym_call_expression] = STATE(426),
    [sym_new_expression] = STATE(424),
    [sym_await_expression] = STATE(424),
    [sym_member_expression] = STATE(340),
    [sym_subscript_expression] = STATE(340),
    [sym_assignment_expression] = STATE(424),
    [sym__augmented_assignment_lhs] = STATE(712),
    [sym_augmented_assignment_expression] = STATE(424),
    [sym__destructuring_pattern] = STATE(1317),
    [sym_ternary_expression] = STATE(424),
    [sym_binary_expression] = STATE(424),
    [sym_unary_expression] = STATE(424),
    [sym_update_expression] = STATE(424),
    [sym_string] = STATE(426),
    [sym_template_string] = STATE(426),
    [sym_regex] = STATE(426),
    [sym_meta_property] = STATE(426),
    [sym_decorator] = STATE(750),
    [sym_formal_parameters] = STATE(1267),
    [aux_sym_export_statement_repeat1] = STATE(924),
    [sym_identifier] = ACTIONS(391),
    [anon_sym_export] = ACTIONS(393),
    [anon_sym_LBRACE] = ACTIONS(397),
    [anon_sym_import] = ACTIONS(331),
    [anon_sym_LPAREN] = ACTIONS(333),
    [anon_sym_await] = ACTIONS(399),
    [anon_sym_yield] = ACTIONS(401),
    [anon_sym_LBRACK] = ACTIONS(403),
    [anon_sym_LT] = ACTIONS(537),
    [anon_sym_SLASH] = ACTIONS(345),
    [anon_sym_DOT] = ACTIONS(676),
    [anon_sym_class] = ACTIONS(347),
    [anon_sym_async] = ACTIONS(405),
    [anon_sym_function] = ACTIONS(351),
    [anon_sym_new] = ACTIONS(407),
    [anon_sym_PLUS] = ACTIONS(409),
    [anon_sym_DASH] = ACTIONS(409),
    [anon_sym_BANG] = ACTIONS(411),
    [anon_sym_TILDE] = ACTIONS(411),
    [anon_sym_typeof] = ACTIONS(413),
    [anon_sym_void] = ACTIONS(413),
    [anon_sym_delete] = ACTIONS(413),
    [anon_sym_PLUS_PLUS] = ACTIONS(415),
    [anon_sym_DASH_DASH] = ACTIONS(415),
    [anon_sym_DQUOTE] = ACTIONS(363),
    [anon_sym_SQUOTE] = ACTIONS(365),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(367),
    [sym_number] = ACTIONS(369),
    [sym_this] = ACTIONS(371),
    [sym_super] = ACTIONS(371),
    [sym_true] = ACTIONS(371),
    [sym_false] = ACTIONS(371),
    [sym_null] = ACTIONS(371),
    [sym_undefined] = ACTIONS(371),
    [anon_sym_AT] = ACTIONS(85),
    [anon_sym_static] = ACTIONS(393),
    [anon_sym_get] = ACTIONS(393),
    [anon_sym_set] = ACTIONS(393),
  },
  [117] = {
    [sym_import] = STATE(426),
    [sym_statement_block] = STATE(454),
    [sym_parenthesized_expression] = STATE(355),
    [sym_expression] = STATE(390),
    [sym_primary_expression] = STATE(425),
    [sym_yield_expression] = STATE(424),
    [sym_object] = STATE(426),
    [sym_object_pattern] = STATE(1333),
    [sym_array] = STATE(426),
    [sym_array_pattern] = STATE(1333),
    [sym_jsx_element] = STATE(424),
    [sym_jsx_fragment] = STATE(424),
    [sym_jsx_opening_element] = STATE(768),
    [sym_jsx_self_closing_element] = STATE(424),
    [sym_class] = STATE(426),
    [sym_function] = STATE(426),
    [sym_generator_function] = STATE(426),
    [sym_arrow_function] = STATE(426),
    [sym_call_expression] = STATE(426),
    [sym_new_expression] = STATE(424),
    [sym_await_expression] = STATE(424),
    [sym_member_expression] = STATE(355),
    [sym_subscript_expression] = STATE(355),
    [sym_assignment_expression] = STATE(424),
    [sym__augmented_assignment_lhs] = STATE(714),
    [sym_augmented_assignment_expression] = STATE(424),
    [sym__destructuring_pattern] = STATE(1333),
    [sym_ternary_expression] = STATE(424),
    [sym_binary_expression] = STATE(424),
    [sym_unary_expression] = STATE(424),
    [sym_update_expression] = STATE(424),
    [sym_string] = STATE(426),
    [sym_template_string] = STATE(426),
    [sym_regex] = STATE(426),
    [sym_meta_property] = STATE(426),
    [sym_decorator] = STATE(750),
    [sym_formal_parameters] = STATE(1322),
    [aux_sym_export_statement_repeat1] = STATE(924),
    [sym_identifier] = ACTIONS(321),
    [anon_sym_export] = ACTIONS(323),
    [anon_sym_LBRACE] = ACTIONS(626),
    [anon_sym_import] = ACTIONS(331),
    [anon_sym_LPAREN] = ACTIONS(333),
    [anon_sym_await] = ACTIONS(335),
    [anon_sym_yield] = ACTIONS(339),
    [anon_sym_LBRACK] = ACTIONS(341),
    [anon_sym_LT] = ACTIONS(537),
    [anon_sym_SLASH] = ACTIONS(345),
    [anon_sym_class] = ACTIONS(347),
    [anon_sym_async] = ACTIONS(349),
    [anon_sym_function] = ACTIONS(351),
    [anon_sym_new] = ACTIONS(353),
    [anon_sym_PLUS] = ACTIONS(355),
    [anon_sym_DASH] = ACTIONS(355),
    [anon_sym_BANG] = ACTIONS(357),
    [anon_sym_TILDE] = ACTIONS(357),
    [anon_sym_typeof] = ACTIONS(359),
    [anon_sym_void] = ACTIONS(359),
    [anon_sym_delete] = ACTIONS(359),
    [anon_sym_PLUS_PLUS] = ACTIONS(361),
    [anon_sym_DASH_DASH] = ACTIONS(361),
    [anon_sym_DQUOTE] = ACTIONS(363),
    [anon_sym_SQUOTE] = ACTIONS(365),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(367),
    [sym_number] = ACTIONS(369),
    [sym_this] = ACTIONS(371),
    [sym_super] = ACTIONS(371),
    [sym_true] = ACTIONS(371),
    [sym_false] = ACTIONS(371),
    [sym_null] = ACTIONS(371),
    [sym_undefined] = ACTIONS(371),
    [anon_sym_AT] = ACTIONS(85),
    [anon_sym_static] = ACTIONS(323),
    [anon_sym_get] = ACTIONS(323),
    [anon_sym_set] = ACTIONS(323),
  },
  [118] = {
    [sym_import] = STATE(426),
    [sym_statement_block] = STATE(454),
    [sym_parenthesized_expression] = STATE(340),
    [sym_expression] = STATE(618),
    [sym_primary_expression] = STATE(425),
    [sym_yield_expression] = STATE(424),
    [sym_object] = STATE(426),
    [sym_object_pattern] = STATE(1317),
    [sym_array] = STATE(426),
    [sym_array_pattern] = STATE(1317),
    [sym_jsx_element] = STATE(424),
    [sym_jsx_fragment] = STATE(424),
    [sym_jsx_opening_element] = STATE(768),
    [sym_jsx_self_closing_element] = STATE(424),
    [sym_class] = STATE(426),
    [sym_function] = STATE(426),
    [sym_generator_function] = STATE(426),
    [sym_arrow_function] = STATE(426),
    [sym_call_expression] = STATE(426),
    [sym_new_expression] = STATE(424),
    [sym_await_expression] = STATE(424),
    [sym_member_expression] = STATE(340),
    [sym_subscript_expression] = STATE(340),
    [sym_assignment_expression] = STATE(424),
    [sym__augmented_assignment_lhs] = STATE(712),
    [sym_augmented_assignment_expression] = STATE(424),
    [sym__destructuring_pattern] = STATE(1317),
    [sym_ternary_expression] = STATE(424),
    [sym_binary_expression] = STATE(424),
    [sym_unary_expression] = STATE(424),
    [sym_update_expression] = STATE(424),
    [sym_string] = STATE(426),
    [sym_template_string] = STATE(426),
    [sym_regex] = STATE(426),
    [sym_meta_property] = STATE(426),
    [sym_decorator] = STATE(750),
    [sym_formal_parameters] = STATE(1267),
    [aux_sym_export_statement_repeat1] = STATE(924),
    [sym_identifier] = ACTIONS(391),
    [anon_sym_export] = ACTIONS(393),
    [anon_sym_LBRACE] = ACTIONS(666),
    [anon_sym_import] = ACTIONS(331),
    [anon_sym_LPAREN] = ACTIONS(333),
    [anon_sym_await] = ACTIONS(399),
    [anon_sym_yield] = ACTIONS(401),
    [anon_sym_LBRACK] = ACTIONS(403),
    [anon_sym_LT] = ACTIONS(537),
    [anon_sym_SLASH] = ACTIONS(345),
    [anon_sym_class] = ACTIONS(347),
    [anon_sym_async] = ACTIONS(405),
    [anon_sym_function] = ACTIONS(351),
    [anon_sym_new] = ACTIONS(407),
    [anon_sym_PLUS] = ACTIONS(409),
    [anon_sym_DASH] = ACTIONS(409),
    [anon_sym_BANG] = ACTIONS(411),
    [anon_sym_TILDE] = ACTIONS(411),
    [anon_sym_typeof] = ACTIONS(413),
    [anon_sym_void] = ACTIONS(413),
    [anon_sym_delete] = ACTIONS(413),
    [anon_sym_PLUS_PLUS] = ACTIONS(415),
    [anon_sym_DASH_DASH] = ACTIONS(415),
    [anon_sym_DQUOTE] = ACTIONS(363),
    [anon_sym_SQUOTE] = ACTIONS(365),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(367),
    [sym_number] = ACTIONS(369),
    [sym_this] = ACTIONS(371),
    [sym_super] = ACTIONS(371),
    [sym_true] = ACTIONS(371),
    [sym_false] = ACTIONS(371),
    [sym_null] = ACTIONS(371),
    [sym_undefined] = ACTIONS(371),
    [anon_sym_AT] = ACTIONS(85),
    [anon_sym_static] = ACTIONS(393),
    [anon_sym_get] = ACTIONS(393),
    [anon_sym_set] = ACTIONS(393),
  },
  [119] = {
    [sym_import] = STATE(426),
    [sym_parenthesized_expression] = STATE(355),
    [sym_expression] = STATE(568),
    [sym_primary_expression] = STATE(425),
    [sym_yield_expression] = STATE(424),
    [sym_object] = STATE(426),
    [sym_object_pattern] = STATE(1333),
    [sym_array] = STATE(426),
    [sym_array_pattern] = STATE(1333),
    [sym_jsx_element] = STATE(424),
    [sym_jsx_fragment] = STATE(424),
    [sym_jsx_opening_element] = STATE(768),
    [sym_jsx_self_closing_element] = STATE(424),
    [sym_class] = STATE(426),
    [sym_function] = STATE(426),
    [sym_generator_function] = STATE(426),
    [sym_arrow_function] = STATE(426),
    [sym_call_expression] = STATE(426),
    [sym_new_expression] = STATE(424),
    [sym_await_expression] = STATE(424),
    [sym_member_expression] = STATE(355),
    [sym_subscript_expression] = STATE(355),
    [sym_assignment_expression] = STATE(424),
    [sym__augmented_assignment_lhs] = STATE(714),
    [sym_augmented_assignment_expression] = STATE(424),
    [sym__destructuring_pattern] = STATE(1333),
    [sym_ternary_expression] = STATE(424),
    [sym_binary_expression] = STATE(424),
    [sym_unary_expression] = STATE(424),
    [sym_update_expression] = STATE(424),
    [sym_sequence_expression] = STATE(1348),
    [sym_string] = STATE(426),
    [sym_template_string] = STATE(426),
    [sym_regex] = STATE(426),
    [sym_meta_property] = STATE(426),
    [sym_decorator] = STATE(750),
    [sym_formal_parameters] = STATE(1322),
    [aux_sym_export_statement_repeat1] = STATE(924),
    [sym_identifier] = ACTIONS(321),
    [anon_sym_export] = ACTIONS(323),
    [anon_sym_LBRACE] = ACTIONS(327),
    [anon_sym_import] = ACTIONS(331),
    [anon_sym_LPAREN] = ACTIONS(333),
    [anon_sym_await] = ACTIONS(335),
    [anon_sym_yield] = ACTIONS(339),
    [anon_sym_LBRACK] = ACTIONS(341),
    [anon_sym_LT] = ACTIONS(537),
    [anon_sym_SLASH] = ACTIONS(345),
    [anon_sym_class] = ACTIONS(347),
    [anon_sym_async] = ACTIONS(349),
    [anon_sym_function] = ACTIONS(351),
    [anon_sym_new] = ACTIONS(353),
    [anon_sym_PLUS] = ACTIONS(355),
    [anon_sym_DASH] = ACTIONS(355),
    [anon_sym_BANG] = ACTIONS(357),
    [anon_sym_TILDE] = ACTIONS(357),
    [anon_sym_typeof] = ACTIONS(359),
    [anon_sym_void] = ACTIONS(359),
    [anon_sym_delete] = ACTIONS(359),
    [anon_sym_PLUS_PLUS] = ACTIONS(361),
    [anon_sym_DASH_DASH] = ACTIONS(361),
    [anon_sym_DQUOTE] = ACTIONS(363),
    [anon_sym_SQUOTE] = ACTIONS(365),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(367),
    [sym_number] = ACTIONS(369),
    [sym_this] = ACTIONS(371),
    [sym_super] = ACTIONS(371),
    [sym_true] = ACTIONS(371),
    [sym_false] = ACTIONS(371),
    [sym_null] = ACTIONS(371),
    [sym_undefined] = ACTIONS(371),
    [anon_sym_AT] = ACTIONS(85),
    [anon_sym_static] = ACTIONS(323),
    [anon_sym_get] = ACTIONS(323),
    [anon_sym_set] = ACTIONS(323),
  },
  [120] = {
    [sym_import] = STATE(426),
    [sym_parenthesized_expression] = STATE(355),
    [sym_expression] = STATE(583),
    [sym_primary_expression] = STATE(425),
    [sym_yield_expression] = STATE(424),
    [sym_object] = STATE(426),
    [sym_object_pattern] = STATE(1333),
    [sym_array] = STATE(426),
    [sym_array_pattern] = STATE(1333),
    [sym_jsx_element] = STATE(424),
    [sym_jsx_fragment] = STATE(424),
    [sym_jsx_opening_element] = STATE(768),
    [sym_jsx_self_closing_element] = STATE(424),
    [sym_class] = STATE(426),
    [sym_function] = STATE(426),
    [sym_generator_function] = STATE(426),
    [sym_arrow_function] = STATE(426),
    [sym_call_expression] = STATE(426),
    [sym_new_expression] = STATE(424),
    [sym_await_expression] = STATE(424),
    [sym_member_expression] = STATE(355),
    [sym_subscript_expression] = STATE(355),
    [sym_assignment_expression] = STATE(424),
    [sym__augmented_assignment_lhs] = STATE(714),
    [sym_augmented_assignment_expression] = STATE(424),
    [sym__destructuring_pattern] = STATE(1333),
    [sym_ternary_expression] = STATE(424),
    [sym_binary_expression] = STATE(424),
    [sym_unary_expression] = STATE(424),
    [sym_update_expression] = STATE(424),
    [sym_sequence_expression] = STATE(1338),
    [sym_string] = STATE(426),
    [sym_template_string] = STATE(426),
    [sym_regex] = STATE(426),
    [sym_meta_property] = STATE(426),
    [sym_decorator] = STATE(750),
    [sym_formal_parameters] = STATE(1322),
    [aux_sym_export_statement_repeat1] = STATE(924),
    [sym_identifier] = ACTIONS(321),
    [anon_sym_export] = ACTIONS(323),
    [anon_sym_LBRACE] = ACTIONS(327),
    [anon_sym_import] = ACTIONS(331),
    [anon_sym_LPAREN] = ACTIONS(333),
    [anon_sym_await] = ACTIONS(335),
    [anon_sym_yield] = ACTIONS(339),
    [anon_sym_LBRACK] = ACTIONS(341),
    [anon_sym_LT] = ACTIONS(537),
    [anon_sym_SLASH] = ACTIONS(345),
    [anon_sym_class] = ACTIONS(347),
    [anon_sym_async] = ACTIONS(349),
    [anon_sym_function] = ACTIONS(351),
    [anon_sym_new] = ACTIONS(353),
    [anon_sym_PLUS] = ACTIONS(355),
    [anon_sym_DASH] = ACTIONS(355),
    [anon_sym_BANG] = ACTIONS(357),
    [anon_sym_TILDE] = ACTIONS(357),
    [anon_sym_typeof] = ACTIONS(359),
    [anon_sym_void] = ACTIONS(359),
    [anon_sym_delete] = ACTIONS(359),
    [anon_sym_PLUS_PLUS] = ACTIONS(361),
    [anon_sym_DASH_DASH] = ACTIONS(361),
    [anon_sym_DQUOTE] = ACTIONS(363),
    [anon_sym_SQUOTE] = ACTIONS(365),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(367),
    [sym_number] = ACTIONS(369),
    [sym_this] = ACTIONS(371),
    [sym_super] = ACTIONS(371),
    [sym_true] = ACTIONS(371),
    [sym_false] = ACTIONS(371),
    [sym_null] = ACTIONS(371),
    [sym_undefined] = ACTIONS(371),
    [anon_sym_AT] = ACTIONS(85),
    [anon_sym_static] = ACTIONS(323),
    [anon_sym_get] = ACTIONS(323),
    [anon_sym_set] = ACTIONS(323),
  },
  [121] = {
    [sym_export_clause] = STATE(927),
    [sym_declaration] = STATE(293),
    [sym_variable_declaration] = STATE(275),
    [sym_lexical_declaration] = STATE(275),
    [sym_class_declaration] = STATE(275),
    [sym_function_declaration] = STATE(275),
    [sym_generator_function_declaration] = STATE(275),
    [sym_decorator] = STATE(750),
    [aux_sym_export_statement_repeat1] = STATE(922),
    [aux_sym_object_repeat1] = STATE(1058),
    [aux_sym_object_pattern_repeat1] = STATE(978),
    [anon_sym_STAR] = ACTIONS(630),
    [anon_sym_default] = ACTIONS(632),
    [anon_sym_LBRACE] = ACTIONS(634),
    [anon_sym_COMMA] = ACTIONS(636),
    [anon_sym_RBRACE] = ACTIONS(678),
    [anon_sym_var] = ACTIONS(640),
    [anon_sym_let] = ACTIONS(642),
    [anon_sym_const] = ACTIONS(642),
    [anon_sym_LPAREN] = ACTIONS(644),
    [anon_sym_in] = ACTIONS(647),
    [anon_sym_SEMI] = ACTIONS(636),
    [anon_sym_COLON] = ACTIONS(649),
    [anon_sym_EQ] = ACTIONS(652),
    [anon_sym_LBRACK] = ACTIONS(636),
    [anon_sym_LT] = ACTIONS(647),
    [anon_sym_GT] = ACTIONS(647),
    [anon_sym_SLASH] = ACTIONS(647),
    [anon_sym_DOT] = ACTIONS(636),
    [anon_sym_class] = ACTIONS(654),
    [anon_sym_async] = ACTIONS(656),
    [anon_sym_function] = ACTIONS(658),
    [anon_sym_EQ_GT] = ACTIONS(660),
    [anon_sym_QMARK_DOT] = ACTIONS(636),
    [anon_sym_PLUS_EQ] = ACTIONS(662),
    [anon_sym_DASH_EQ] = ACTIONS(662),
    [anon_sym_STAR_EQ] = ACTIONS(662),
    [anon_sym_SLASH_EQ] = ACTIONS(662),
    [anon_sym_PERCENT_EQ] = ACTIONS(662),
    [anon_sym_CARET_EQ] = ACTIONS(662),
    [anon_sym_AMP_EQ] = ACTIONS(662),
    [anon_sym_PIPE_EQ] = ACTIONS(662),
    [anon_sym_GT_GT_EQ] = ACTIONS(662),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(662),
    [anon_sym_LT_LT_EQ] = ACTIONS(662),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(662),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(662),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(662),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(662),
    [anon_sym_QMARK] = ACTIONS(647),
    [anon_sym_AMP_AMP] = ACTIONS(647),
    [anon_sym_PIPE_PIPE] = ACTIONS(647),
    [anon_sym_GT_GT] = ACTIONS(647),
    [anon_sym_GT_GT_GT] = ACTIONS(647),
    [anon_sym_LT_LT] = ACTIONS(647),
    [anon_sym_AMP] = ACTIONS(647),
    [anon_sym_CARET] = ACTIONS(647),
    [anon_sym_PIPE] = ACTIONS(647),
    [anon_sym_PLUS] = ACTIONS(647),
    [anon_sym_DASH] = ACTIONS(647),
    [anon_sym_PERCENT] = ACTIONS(647),
    [anon_sym_STAR_STAR] = ACTIONS(647),
    [anon_sym_LT_EQ] = ACTIONS(636),
    [anon_sym_EQ_EQ] = ACTIONS(647),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(636),
    [anon_sym_BANG_EQ] = ACTIONS(647),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(636),
    [anon_sym_GT_EQ] = ACTIONS(636),
    [anon_sym_QMARK_QMARK] = ACTIONS(647),
    [anon_sym_instanceof] = ACTIONS(636),
    [anon_sym_PLUS_PLUS] = ACTIONS(636),
    [anon_sym_DASH_DASH] = ACTIONS(636),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(636),
    [anon_sym_AT] = ACTIONS(85),
    [sym__automatic_semicolon] = ACTIONS(636),
  },
  [122] = {
    [sym_import] = STATE(539),
    [sym_parenthesized_expression] = STATE(367),
    [sym_expression] = STATE(639),
    [sym_primary_expression] = STATE(518),
    [sym_yield_expression] = STATE(424),
    [sym_object] = STATE(539),
    [sym_object_pattern] = STATE(1317),
    [sym_array] = STATE(539),
    [sym_array_pattern] = STATE(1317),
    [sym_jsx_element] = STATE(424),
    [sym_jsx_fragment] = STATE(424),
    [sym_jsx_opening_element] = STATE(768),
    [sym_jsx_self_closing_element] = STATE(424),
    [sym_class] = STATE(539),
    [sym_function] = STATE(539),
    [sym_generator_function] = STATE(539),
    [sym_arrow_function] = STATE(539),
    [sym_call_expression] = STATE(539),
    [sym_new_expression] = STATE(424),
    [sym_await_expression] = STATE(424),
    [sym_member_expression] = STATE(367),
    [sym_subscript_expression] = STATE(367),
    [sym_assignment_expression] = STATE(424),
    [sym__augmented_assignment_lhs] = STATE(712),
    [sym_augmented_assignment_expression] = STATE(424),
    [sym__destructuring_pattern] = STATE(1317),
    [sym_ternary_expression] = STATE(424),
    [sym_binary_expression] = STATE(424),
    [sym_unary_expression] = STATE(424),
    [sym_update_expression] = STATE(424),
    [sym_string] = STATE(539),
    [sym_template_string] = STATE(539),
    [sym_regex] = STATE(539),
    [sym_meta_property] = STATE(539),
    [sym_decorator] = STATE(750),
    [sym_formal_parameters] = STATE(1318),
    [aux_sym_export_statement_repeat1] = STATE(925),
    [sym_identifier] = ACTIONS(680),
    [anon_sym_export] = ACTIONS(682),
    [anon_sym_LBRACE] = ACTIONS(379),
    [anon_sym_import] = ACTIONS(381),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(399),
    [anon_sym_yield] = ACTIONS(401),
    [anon_sym_LBRACK] = ACTIONS(53),
    [anon_sym_LT] = ACTIONS(537),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_DOT] = ACTIONS(676),
    [anon_sym_class] = ACTIONS(385),
    [anon_sym_async] = ACTIONS(684),
    [anon_sym_function] = ACTIONS(389),
    [anon_sym_new] = ACTIONS(686),
    [anon_sym_PLUS] = ACTIONS(409),
    [anon_sym_DASH] = ACTIONS(409),
    [anon_sym_BANG] = ACTIONS(411),
    [anon_sym_TILDE] = ACTIONS(411),
    [anon_sym_typeof] = ACTIONS(413),
    [anon_sym_void] = ACTIONS(413),
    [anon_sym_delete] = ACTIONS(413),
    [anon_sym_PLUS_PLUS] = ACTIONS(415),
    [anon_sym_DASH_DASH] = ACTIONS(415),
    [anon_sym_DQUOTE] = ACTIONS(75),
    [anon_sym_SQUOTE] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(79),
    [sym_number] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(83),
    [sym_true] = ACTIONS(83),
    [sym_false] = ACTIONS(83),
    [sym_null] = ACTIONS(83),
    [sym_undefined] = ACTIONS(83),
    [anon_sym_AT] = ACTIONS(85),
    [anon_sym_static] = ACTIONS(682),
    [anon_sym_get] = ACTIONS(682),
    [anon_sym_set] = ACTIONS(682),
  },
  [123] = {
    [sym_import] = STATE(426),
    [sym_parenthesized_expression] = STATE(355),
    [sym_expression] = STATE(619),
    [sym_primary_expression] = STATE(425),
    [sym_yield_expression] = STATE(424),
    [sym_object] = STATE(426),
    [sym_object_pattern] = STATE(1333),
    [sym_array] = STATE(426),
    [sym_array_pattern] = STATE(1333),
    [sym_jsx_element] = STATE(424),
    [sym_jsx_fragment] = STATE(424),
    [sym_jsx_opening_element] = STATE(768),
    [sym_jsx_self_closing_element] = STATE(424),
    [sym_class] = STATE(426),
    [sym_function] = STATE(426),
    [sym_generator_function] = STATE(426),
    [sym_arrow_function] = STATE(426),
    [sym_call_expression] = STATE(426),
    [sym_new_expression] = STATE(424),
    [sym_await_expression] = STATE(424),
    [sym_member_expression] = STATE(355),
    [sym_subscript_expression] = STATE(355),
    [sym_assignment_expression] = STATE(424),
    [sym__augmented_assignment_lhs] = STATE(714),
    [sym_augmented_assignment_expression] = STATE(424),
    [sym__destructuring_pattern] = STATE(1333),
    [sym_ternary_expression] = STATE(424),
    [sym_binary_expression] = STATE(424),
    [sym_unary_expression] = STATE(424),
    [sym_update_expression] = STATE(424),
    [sym_sequence_expression] = STATE(1273),
    [sym_string] = STATE(426),
    [sym_template_string] = STATE(426),
    [sym_regex] = STATE(426),
    [sym_meta_property] = STATE(426),
    [sym_decorator] = STATE(750),
    [sym_formal_parameters] = STATE(1322),
    [aux_sym_export_statement_repeat1] = STATE(924),
    [sym_identifier] = ACTIONS(321),
    [anon_sym_export] = ACTIONS(323),
    [anon_sym_LBRACE] = ACTIONS(327),
    [anon_sym_import] = ACTIONS(331),
    [anon_sym_LPAREN] = ACTIONS(333),
    [anon_sym_await] = ACTIONS(335),
    [anon_sym_yield] = ACTIONS(339),
    [anon_sym_LBRACK] = ACTIONS(341),
    [anon_sym_LT] = ACTIONS(537),
    [anon_sym_SLASH] = ACTIONS(345),
    [anon_sym_class] = ACTIONS(347),
    [anon_sym_async] = ACTIONS(349),
    [anon_sym_function] = ACTIONS(351),
    [anon_sym_new] = ACTIONS(353),
    [anon_sym_PLUS] = ACTIONS(355),
    [anon_sym_DASH] = ACTIONS(355),
    [anon_sym_BANG] = ACTIONS(357),
    [anon_sym_TILDE] = ACTIONS(357),
    [anon_sym_typeof] = ACTIONS(359),
    [anon_sym_void] = ACTIONS(359),
    [anon_sym_delete] = ACTIONS(359),
    [anon_sym_PLUS_PLUS] = ACTIONS(361),
    [anon_sym_DASH_DASH] = ACTIONS(361),
    [anon_sym_DQUOTE] = ACTIONS(363),
    [anon_sym_SQUOTE] = ACTIONS(365),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(367),
    [sym_number] = ACTIONS(369),
    [sym_this] = ACTIONS(371),
    [sym_super] = ACTIONS(371),
    [sym_true] = ACTIONS(371),
    [sym_false] = ACTIONS(371),
    [sym_null] = ACTIONS(371),
    [sym_undefined] = ACTIONS(371),
    [anon_sym_AT] = ACTIONS(85),
    [anon_sym_static] = ACTIONS(323),
    [anon_sym_get] = ACTIONS(323),
    [anon_sym_set] = ACTIONS(323),
  },
  [124] = {
    [sym_import] = STATE(539),
    [sym_parenthesized_expression] = STATE(362),
    [sym_expression] = STATE(523),
    [sym_primary_expression] = STATE(546),
    [sym_yield_expression] = STATE(550),
    [sym_object] = STATE(539),
    [sym_object_pattern] = STATE(1320),
    [sym_array] = STATE(539),
    [sym_array_pattern] = STATE(1320),
    [sym_jsx_element] = STATE(550),
    [sym_jsx_fragment] = STATE(550),
    [sym_jsx_opening_element] = STATE(772),
    [sym_jsx_self_closing_element] = STATE(550),
    [sym_class] = STATE(539),
    [sym_function] = STATE(539),
    [sym_generator_function] = STATE(539),
    [sym_arrow_function] = STATE(539),
    [sym_call_expression] = STATE(539),
    [sym_new_expression] = STATE(550),
    [sym_await_expression] = STATE(550),
    [sym_member_expression] = STATE(362),
    [sym_subscript_expression] = STATE(362),
    [sym_assignment_expression] = STATE(550),
    [sym__augmented_assignment_lhs] = STATE(720),
    [sym_augmented_assignment_expression] = STATE(550),
    [sym__destructuring_pattern] = STATE(1320),
    [sym_ternary_expression] = STATE(550),
    [sym_binary_expression] = STATE(550),
    [sym_unary_expression] = STATE(550),
    [sym_update_expression] = STATE(550),
    [sym_sequence_expression] = STATE(1239),
    [sym_string] = STATE(539),
    [sym_template_string] = STATE(539),
    [sym_regex] = STATE(539),
    [sym_meta_property] = STATE(539),
    [sym_decorator] = STATE(750),
    [sym_formal_parameters] = STATE(1318),
    [aux_sym_export_statement_repeat1] = STATE(925),
    [sym_identifier] = ACTIONS(373),
    [anon_sym_export] = ACTIONS(375),
    [anon_sym_LBRACE] = ACTIONS(379),
    [anon_sym_import] = ACTIONS(381),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(29),
    [anon_sym_yield] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(53),
    [anon_sym_LT] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(385),
    [anon_sym_async] = ACTIONS(387),
    [anon_sym_function] = ACTIONS(389),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_typeof] = ACTIONS(71),
    [anon_sym_void] = ACTIONS(71),
    [anon_sym_delete] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DQUOTE] = ACTIONS(75),
    [anon_sym_SQUOTE] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(79),
    [sym_number] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(83),
    [sym_true] = ACTIONS(83),
    [sym_false] = ACTIONS(83),
    [sym_null] = ACTIONS(83),
    [sym_undefined] = ACTIONS(83),
    [anon_sym_AT] = ACTIONS(85),
    [anon_sym_static] = ACTIONS(375),
    [anon_sym_get] = ACTIONS(375),
    [anon_sym_set] = ACTIONS(375),
  },
  [125] = {
    [sym_import] = STATE(426),
    [sym_parenthesized_expression] = STATE(355),
    [sym_expression] = STATE(602),
    [sym_primary_expression] = STATE(425),
    [sym_yield_expression] = STATE(424),
    [sym_object] = STATE(426),
    [sym_object_pattern] = STATE(1333),
    [sym_array] = STATE(426),
    [sym_array_pattern] = STATE(1333),
    [sym_jsx_element] = STATE(424),
    [sym_jsx_fragment] = STATE(424),
    [sym_jsx_opening_element] = STATE(768),
    [sym_jsx_self_closing_element] = STATE(424),
    [sym_class] = STATE(426),
    [sym_function] = STATE(426),
    [sym_generator_function] = STATE(426),
    [sym_arrow_function] = STATE(426),
    [sym_call_expression] = STATE(426),
    [sym_new_expression] = STATE(424),
    [sym_await_expression] = STATE(424),
    [sym_member_expression] = STATE(355),
    [sym_subscript_expression] = STATE(355),
    [sym_assignment_expression] = STATE(424),
    [sym__augmented_assignment_lhs] = STATE(714),
    [sym_augmented_assignment_expression] = STATE(424),
    [sym__destructuring_pattern] = STATE(1333),
    [sym_ternary_expression] = STATE(424),
    [sym_binary_expression] = STATE(424),
    [sym_unary_expression] = STATE(424),
    [sym_update_expression] = STATE(424),
    [sym_sequence_expression] = STATE(1252),
    [sym_string] = STATE(426),
    [sym_template_string] = STATE(426),
    [sym_regex] = STATE(426),
    [sym_meta_property] = STATE(426),
    [sym_decorator] = STATE(750),
    [sym_formal_parameters] = STATE(1322),
    [aux_sym_export_statement_repeat1] = STATE(924),
    [sym_identifier] = ACTIONS(321),
    [anon_sym_export] = ACTIONS(323),
    [anon_sym_LBRACE] = ACTIONS(327),
    [anon_sym_import] = ACTIONS(331),
    [anon_sym_LPAREN] = ACTIONS(333),
    [anon_sym_await] = ACTIONS(335),
    [anon_sym_yield] = ACTIONS(339),
    [anon_sym_LBRACK] = ACTIONS(341),
    [anon_sym_LT] = ACTIONS(537),
    [anon_sym_SLASH] = ACTIONS(345),
    [anon_sym_class] = ACTIONS(347),
    [anon_sym_async] = ACTIONS(349),
    [anon_sym_function] = ACTIONS(351),
    [anon_sym_new] = ACTIONS(353),
    [anon_sym_PLUS] = ACTIONS(355),
    [anon_sym_DASH] = ACTIONS(355),
    [anon_sym_BANG] = ACTIONS(357),
    [anon_sym_TILDE] = ACTIONS(357),
    [anon_sym_typeof] = ACTIONS(359),
    [anon_sym_void] = ACTIONS(359),
    [anon_sym_delete] = ACTIONS(359),
    [anon_sym_PLUS_PLUS] = ACTIONS(361),
    [anon_sym_DASH_DASH] = ACTIONS(361),
    [anon_sym_DQUOTE] = ACTIONS(363),
    [anon_sym_SQUOTE] = ACTIONS(365),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(367),
    [sym_number] = ACTIONS(369),
    [sym_this] = ACTIONS(371),
    [sym_super] = ACTIONS(371),
    [sym_true] = ACTIONS(371),
    [sym_false] = ACTIONS(371),
    [sym_null] = ACTIONS(371),
    [sym_undefined] = ACTIONS(371),
    [anon_sym_AT] = ACTIONS(85),
    [anon_sym_static] = ACTIONS(323),
    [anon_sym_get] = ACTIONS(323),
    [anon_sym_set] = ACTIONS(323),
  },
  [126] = {
    [sym_import] = STATE(539),
    [sym_parenthesized_expression] = STATE(362),
    [sym_expression] = STATE(488),
    [sym_primary_expression] = STATE(546),
    [sym_yield_expression] = STATE(550),
    [sym_object] = STATE(539),
    [sym_object_pattern] = STATE(1320),
    [sym_array] = STATE(539),
    [sym_array_pattern] = STATE(1320),
    [sym_jsx_element] = STATE(550),
    [sym_jsx_fragment] = STATE(550),
    [sym_jsx_opening_element] = STATE(772),
    [sym_jsx_self_closing_element] = STATE(550),
    [sym_class] = STATE(539),
    [sym_function] = STATE(539),
    [sym_generator_function] = STATE(539),
    [sym_arrow_function] = STATE(539),
    [sym_call_expression] = STATE(539),
    [sym_new_expression] = STATE(550),
    [sym_await_expression] = STATE(550),
    [sym_member_expression] = STATE(362),
    [sym_subscript_expression] = STATE(362),
    [sym_assignment_expression] = STATE(550),
    [sym__augmented_assignment_lhs] = STATE(720),
    [sym_augmented_assignment_expression] = STATE(550),
    [sym__destructuring_pattern] = STATE(1320),
    [sym_ternary_expression] = STATE(550),
    [sym_binary_expression] = STATE(550),
    [sym_unary_expression] = STATE(550),
    [sym_update_expression] = STATE(550),
    [sym_string] = STATE(539),
    [sym_template_string] = STATE(539),
    [sym_regex] = STATE(539),
    [sym_meta_property] = STATE(539),
    [sym_decorator] = STATE(750),
    [sym_formal_parameters] = STATE(1318),
    [aux_sym_export_statement_repeat1] = STATE(925),
    [sym_identifier] = ACTIONS(373),
    [anon_sym_export] = ACTIONS(375),
    [anon_sym_LBRACE] = ACTIONS(379),
    [anon_sym_import] = ACTIONS(381),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(29),
    [anon_sym_yield] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(53),
    [anon_sym_LT] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(385),
    [anon_sym_async] = ACTIONS(387),
    [anon_sym_function] = ACTIONS(389),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_typeof] = ACTIONS(71),
    [anon_sym_void] = ACTIONS(71),
    [anon_sym_delete] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DQUOTE] = ACTIONS(75),
    [anon_sym_SQUOTE] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(79),
    [sym_number] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(83),
    [sym_true] = ACTIONS(83),
    [sym_false] = ACTIONS(83),
    [sym_null] = ACTIONS(83),
    [sym_undefined] = ACTIONS(83),
    [anon_sym_AT] = ACTIONS(85),
    [anon_sym_static] = ACTIONS(375),
    [anon_sym_get] = ACTIONS(375),
    [anon_sym_set] = ACTIONS(375),
  },
  [127] = {
    [sym_import] = STATE(426),
    [sym_parenthesized_expression] = STATE(340),
    [sym_expression] = STATE(386),
    [sym_primary_expression] = STATE(425),
    [sym_yield_expression] = STATE(424),
    [sym_object] = STATE(426),
    [sym_object_pattern] = STATE(1317),
    [sym_array] = STATE(426),
    [sym_array_pattern] = STATE(1317),
    [sym_jsx_element] = STATE(424),
    [sym_jsx_fragment] = STATE(424),
    [sym_jsx_opening_element] = STATE(768),
    [sym_jsx_self_closing_element] = STATE(424),
    [sym_class] = STATE(426),
    [sym_function] = STATE(426),
    [sym_generator_function] = STATE(426),
    [sym_arrow_function] = STATE(426),
    [sym_call_expression] = STATE(426),
    [sym_new_expression] = STATE(424),
    [sym_await_expression] = STATE(424),
    [sym_member_expression] = STATE(340),
    [sym_subscript_expression] = STATE(340),
    [sym_assignment_expression] = STATE(424),
    [sym__augmented_assignment_lhs] = STATE(712),
    [sym_augmented_assignment_expression] = STATE(424),
    [sym__destructuring_pattern] = STATE(1317),
    [sym_ternary_expression] = STATE(424),
    [sym_binary_expression] = STATE(424),
    [sym_unary_expression] = STATE(424),
    [sym_update_expression] = STATE(424),
    [sym_string] = STATE(426),
    [sym_template_string] = STATE(426),
    [sym_regex] = STATE(426),
    [sym_meta_property] = STATE(426),
    [sym_decorator] = STATE(750),
    [sym_formal_parameters] = STATE(1267),
    [aux_sym_export_statement_repeat1] = STATE(924),
    [sym_identifier] = ACTIONS(391),
    [anon_sym_export] = ACTIONS(393),
    [anon_sym_LBRACE] = ACTIONS(397),
    [anon_sym_import] = ACTIONS(331),
    [anon_sym_LPAREN] = ACTIONS(333),
    [anon_sym_await] = ACTIONS(399),
    [anon_sym_yield] = ACTIONS(401),
    [anon_sym_LBRACK] = ACTIONS(403),
    [anon_sym_LT] = ACTIONS(537),
    [anon_sym_SLASH] = ACTIONS(345),
    [anon_sym_class] = ACTIONS(347),
    [anon_sym_async] = ACTIONS(405),
    [anon_sym_function] = ACTIONS(351),
    [anon_sym_new] = ACTIONS(407),
    [anon_sym_PLUS] = ACTIONS(409),
    [anon_sym_DASH] = ACTIONS(409),
    [anon_sym_BANG] = ACTIONS(411),
    [anon_sym_TILDE] = ACTIONS(411),
    [anon_sym_typeof] = ACTIONS(413),
    [anon_sym_void] = ACTIONS(413),
    [anon_sym_delete] = ACTIONS(413),
    [anon_sym_PLUS_PLUS] = ACTIONS(415),
    [anon_sym_DASH_DASH] = ACTIONS(415),
    [anon_sym_DQUOTE] = ACTIONS(363),
    [anon_sym_SQUOTE] = ACTIONS(365),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(367),
    [sym_number] = ACTIONS(369),
    [sym_this] = ACTIONS(371),
    [sym_super] = ACTIONS(371),
    [sym_true] = ACTIONS(371),
    [sym_false] = ACTIONS(371),
    [sym_null] = ACTIONS(371),
    [sym_undefined] = ACTIONS(371),
    [anon_sym_AT] = ACTIONS(85),
    [anon_sym_static] = ACTIONS(393),
    [anon_sym_get] = ACTIONS(393),
    [anon_sym_set] = ACTIONS(393),
  },
  [128] = {
    [sym_import] = STATE(426),
    [sym_parenthesized_expression] = STATE(355),
    [sym_expression] = STATE(498),
    [sym_primary_expression] = STATE(425),
    [sym_yield_expression] = STATE(424),
    [sym_object] = STATE(426),
    [sym_object_pattern] = STATE(1333),
    [sym_array] = STATE(426),
    [sym_array_pattern] = STATE(1333),
    [sym_jsx_element] = STATE(424),
    [sym_jsx_fragment] = STATE(424),
    [sym_jsx_opening_element] = STATE(768),
    [sym_jsx_self_closing_element] = STATE(424),
    [sym_class] = STATE(426),
    [sym_function] = STATE(426),
    [sym_generator_function] = STATE(426),
    [sym_arrow_function] = STATE(426),
    [sym_call_expression] = STATE(426),
    [sym_new_expression] = STATE(424),
    [sym_await_expression] = STATE(424),
    [sym_member_expression] = STATE(355),
    [sym_subscript_expression] = STATE(355),
    [sym_assignment_expression] = STATE(424),
    [sym__augmented_assignment_lhs] = STATE(714),
    [sym_augmented_assignment_expression] = STATE(424),
    [sym__destructuring_pattern] = STATE(1333),
    [sym_ternary_expression] = STATE(424),
    [sym_binary_expression] = STATE(424),
    [sym_unary_expression] = STATE(424),
    [sym_update_expression] = STATE(424),
    [sym_string] = STATE(426),
    [sym_template_string] = STATE(426),
    [sym_regex] = STATE(426),
    [sym_meta_property] = STATE(426),
    [sym_decorator] = STATE(750),
    [sym_formal_parameters] = STATE(1322),
    [aux_sym_export_statement_repeat1] = STATE(924),
    [sym_identifier] = ACTIONS(321),
    [anon_sym_export] = ACTIONS(323),
    [anon_sym_LBRACE] = ACTIONS(327),
    [anon_sym_import] = ACTIONS(331),
    [anon_sym_LPAREN] = ACTIONS(333),
    [anon_sym_await] = ACTIONS(335),
    [anon_sym_yield] = ACTIONS(339),
    [anon_sym_LBRACK] = ACTIONS(341),
    [anon_sym_LT] = ACTIONS(537),
    [anon_sym_SLASH] = ACTIONS(345),
    [anon_sym_class] = ACTIONS(347),
    [anon_sym_async] = ACTIONS(349),
    [anon_sym_function] = ACTIONS(351),
    [anon_sym_new] = ACTIONS(353),
    [anon_sym_PLUS] = ACTIONS(355),
    [anon_sym_DASH] = ACTIONS(355),
    [anon_sym_BANG] = ACTIONS(357),
    [anon_sym_TILDE] = ACTIONS(357),
    [anon_sym_typeof] = ACTIONS(359),
    [anon_sym_void] = ACTIONS(359),
    [anon_sym_delete] = ACTIONS(359),
    [anon_sym_PLUS_PLUS] = ACTIONS(361),
    [anon_sym_DASH_DASH] = ACTIONS(361),
    [anon_sym_DQUOTE] = ACTIONS(363),
    [anon_sym_SQUOTE] = ACTIONS(365),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(367),
    [sym_number] = ACTIONS(369),
    [sym_this] = ACTIONS(371),
    [sym_super] = ACTIONS(371),
    [sym_true] = ACTIONS(371),
    [sym_false] = ACTIONS(371),
    [sym_null] = ACTIONS(371),
    [sym_undefined] = ACTIONS(371),
    [anon_sym_AT] = ACTIONS(85),
    [anon_sym_static] = ACTIONS(323),
    [anon_sym_get] = ACTIONS(323),
    [anon_sym_set] = ACTIONS(323),
  },
  [129] = {
    [sym_import] = STATE(426),
    [sym_parenthesized_expression] = STATE(355),
    [sym_expression] = STATE(637),
    [sym_primary_expression] = STATE(425),
    [sym_yield_expression] = STATE(424),
    [sym_object] = STATE(426),
    [sym_object_pattern] = STATE(1333),
    [sym_array] = STATE(426),
    [sym_array_pattern] = STATE(1333),
    [sym_jsx_element] = STATE(424),
    [sym_jsx_fragment] = STATE(424),
    [sym_jsx_opening_element] = STATE(768),
    [sym_jsx_self_closing_element] = STATE(424),
    [sym_class] = STATE(426),
    [sym_function] = STATE(426),
    [sym_generator_function] = STATE(426),
    [sym_arrow_function] = STATE(426),
    [sym_call_expression] = STATE(426),
    [sym_new_expression] = STATE(424),
    [sym_await_expression] = STATE(424),
    [sym_member_expression] = STATE(355),
    [sym_subscript_expression] = STATE(355),
    [sym_assignment_expression] = STATE(424),
    [sym__augmented_assignment_lhs] = STATE(714),
    [sym_augmented_assignment_expression] = STATE(424),
    [sym__destructuring_pattern] = STATE(1333),
    [sym_ternary_expression] = STATE(424),
    [sym_binary_expression] = STATE(424),
    [sym_unary_expression] = STATE(424),
    [sym_update_expression] = STATE(424),
    [sym_string] = STATE(426),
    [sym_template_string] = STATE(426),
    [sym_regex] = STATE(426),
    [sym_meta_property] = STATE(426),
    [sym_decorator] = STATE(750),
    [sym_formal_parameters] = STATE(1322),
    [aux_sym_export_statement_repeat1] = STATE(924),
    [sym_identifier] = ACTIONS(321),
    [anon_sym_export] = ACTIONS(323),
    [anon_sym_LBRACE] = ACTIONS(327),
    [anon_sym_import] = ACTIONS(331),
    [anon_sym_LPAREN] = ACTIONS(333),
    [anon_sym_await] = ACTIONS(335),
    [anon_sym_yield] = ACTIONS(339),
    [anon_sym_LBRACK] = ACTIONS(341),
    [anon_sym_LT] = ACTIONS(537),
    [anon_sym_SLASH] = ACTIONS(345),
    [anon_sym_class] = ACTIONS(347),
    [anon_sym_async] = ACTIONS(349),
    [anon_sym_function] = ACTIONS(351),
    [anon_sym_new] = ACTIONS(353),
    [anon_sym_PLUS] = ACTIONS(355),
    [anon_sym_DASH] = ACTIONS(355),
    [anon_sym_BANG] = ACTIONS(357),
    [anon_sym_TILDE] = ACTIONS(357),
    [anon_sym_typeof] = ACTIONS(359),
    [anon_sym_void] = ACTIONS(359),
    [anon_sym_delete] = ACTIONS(359),
    [anon_sym_PLUS_PLUS] = ACTIONS(361),
    [anon_sym_DASH_DASH] = ACTIONS(361),
    [anon_sym_DQUOTE] = ACTIONS(363),
    [anon_sym_SQUOTE] = ACTIONS(365),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(367),
    [sym_number] = ACTIONS(369),
    [sym_this] = ACTIONS(371),
    [sym_super] = ACTIONS(371),
    [sym_true] = ACTIONS(371),
    [sym_false] = ACTIONS(371),
    [sym_null] = ACTIONS(371),
    [sym_undefined] = ACTIONS(371),
    [anon_sym_AT] = ACTIONS(85),
    [anon_sym_static] = ACTIONS(323),
    [anon_sym_get] = ACTIONS(323),
    [anon_sym_set] = ACTIONS(323),
  },
  [130] = {
    [sym_import] = STATE(426),
    [sym_parenthesized_expression] = STATE(355),
    [sym_expression] = STATE(412),
    [sym_primary_expression] = STATE(425),
    [sym_yield_expression] = STATE(424),
    [sym_object] = STATE(426),
    [sym_object_pattern] = STATE(1333),
    [sym_array] = STATE(426),
    [sym_array_pattern] = STATE(1333),
    [sym_jsx_element] = STATE(424),
    [sym_jsx_fragment] = STATE(424),
    [sym_jsx_opening_element] = STATE(768),
    [sym_jsx_self_closing_element] = STATE(424),
    [sym_class] = STATE(426),
    [sym_function] = STATE(426),
    [sym_generator_function] = STATE(426),
    [sym_arrow_function] = STATE(426),
    [sym_call_expression] = STATE(426),
    [sym_new_expression] = STATE(424),
    [sym_await_expression] = STATE(424),
    [sym_member_expression] = STATE(355),
    [sym_subscript_expression] = STATE(355),
    [sym_assignment_expression] = STATE(424),
    [sym__augmented_assignment_lhs] = STATE(714),
    [sym_augmented_assignment_expression] = STATE(424),
    [sym__destructuring_pattern] = STATE(1333),
    [sym_ternary_expression] = STATE(424),
    [sym_binary_expression] = STATE(424),
    [sym_unary_expression] = STATE(424),
    [sym_update_expression] = STATE(424),
    [sym_string] = STATE(426),
    [sym_template_string] = STATE(426),
    [sym_regex] = STATE(426),
    [sym_meta_property] = STATE(426),
    [sym_decorator] = STATE(750),
    [sym_formal_parameters] = STATE(1322),
    [aux_sym_export_statement_repeat1] = STATE(924),
    [sym_identifier] = ACTIONS(321),
    [anon_sym_export] = ACTIONS(323),
    [anon_sym_LBRACE] = ACTIONS(327),
    [anon_sym_import] = ACTIONS(331),
    [anon_sym_LPAREN] = ACTIONS(333),
    [anon_sym_await] = ACTIONS(335),
    [anon_sym_yield] = ACTIONS(339),
    [anon_sym_LBRACK] = ACTIONS(341),
    [anon_sym_LT] = ACTIONS(537),
    [anon_sym_SLASH] = ACTIONS(345),
    [anon_sym_class] = ACTIONS(347),
    [anon_sym_async] = ACTIONS(349),
    [anon_sym_function] = ACTIONS(351),
    [anon_sym_new] = ACTIONS(353),
    [anon_sym_PLUS] = ACTIONS(355),
    [anon_sym_DASH] = ACTIONS(355),
    [anon_sym_BANG] = ACTIONS(357),
    [anon_sym_TILDE] = ACTIONS(357),
    [anon_sym_typeof] = ACTIONS(359),
    [anon_sym_void] = ACTIONS(359),
    [anon_sym_delete] = ACTIONS(359),
    [anon_sym_PLUS_PLUS] = ACTIONS(361),
    [anon_sym_DASH_DASH] = ACTIONS(361),
    [anon_sym_DQUOTE] = ACTIONS(363),
    [anon_sym_SQUOTE] = ACTIONS(365),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(367),
    [sym_number] = ACTIONS(369),
    [sym_this] = ACTIONS(371),
    [sym_super] = ACTIONS(371),
    [sym_true] = ACTIONS(371),
    [sym_false] = ACTIONS(371),
    [sym_null] = ACTIONS(371),
    [sym_undefined] = ACTIONS(371),
    [anon_sym_AT] = ACTIONS(85),
    [anon_sym_static] = ACTIONS(323),
    [anon_sym_get] = ACTIONS(323),
    [anon_sym_set] = ACTIONS(323),
  },
  [131] = {
    [sym_import] = STATE(426),
    [sym_parenthesized_expression] = STATE(355),
    [sym_expression] = STATE(395),
    [sym_primary_expression] = STATE(425),
    [sym_yield_expression] = STATE(424),
    [sym_object] = STATE(426),
    [sym_object_pattern] = STATE(1333),
    [sym_array] = STATE(426),
    [sym_array_pattern] = STATE(1333),
    [sym_jsx_element] = STATE(424),
    [sym_jsx_fragment] = STATE(424),
    [sym_jsx_opening_element] = STATE(768),
    [sym_jsx_self_closing_element] = STATE(424),
    [sym_class] = STATE(426),
    [sym_function] = STATE(426),
    [sym_generator_function] = STATE(426),
    [sym_arrow_function] = STATE(426),
    [sym_call_expression] = STATE(426),
    [sym_new_expression] = STATE(424),
    [sym_await_expression] = STATE(424),
    [sym_member_expression] = STATE(355),
    [sym_subscript_expression] = STATE(355),
    [sym_assignment_expression] = STATE(424),
    [sym__augmented_assignment_lhs] = STATE(714),
    [sym_augmented_assignment_expression] = STATE(424),
    [sym__destructuring_pattern] = STATE(1333),
    [sym_ternary_expression] = STATE(424),
    [sym_binary_expression] = STATE(424),
    [sym_unary_expression] = STATE(424),
    [sym_update_expression] = STATE(424),
    [sym_string] = STATE(426),
    [sym_template_string] = STATE(426),
    [sym_regex] = STATE(426),
    [sym_meta_property] = STATE(426),
    [sym_decorator] = STATE(750),
    [sym_formal_parameters] = STATE(1322),
    [aux_sym_export_statement_repeat1] = STATE(924),
    [sym_identifier] = ACTIONS(321),
    [anon_sym_export] = ACTIONS(323),
    [anon_sym_LBRACE] = ACTIONS(327),
    [anon_sym_import] = ACTIONS(331),
    [anon_sym_LPAREN] = ACTIONS(333),
    [anon_sym_await] = ACTIONS(335),
    [anon_sym_yield] = ACTIONS(339),
    [anon_sym_LBRACK] = ACTIONS(341),
    [anon_sym_LT] = ACTIONS(537),
    [anon_sym_SLASH] = ACTIONS(345),
    [anon_sym_class] = ACTIONS(347),
    [anon_sym_async] = ACTIONS(349),
    [anon_sym_function] = ACTIONS(351),
    [anon_sym_new] = ACTIONS(353),
    [anon_sym_PLUS] = ACTIONS(355),
    [anon_sym_DASH] = ACTIONS(355),
    [anon_sym_BANG] = ACTIONS(357),
    [anon_sym_TILDE] = ACTIONS(357),
    [anon_sym_typeof] = ACTIONS(359),
    [anon_sym_void] = ACTIONS(359),
    [anon_sym_delete] = ACTIONS(359),
    [anon_sym_PLUS_PLUS] = ACTIONS(361),
    [anon_sym_DASH_DASH] = ACTIONS(361),
    [anon_sym_DQUOTE] = ACTIONS(363),
    [anon_sym_SQUOTE] = ACTIONS(365),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(367),
    [sym_number] = ACTIONS(369),
    [sym_this] = ACTIONS(371),
    [sym_super] = ACTIONS(371),
    [sym_true] = ACTIONS(371),
    [sym_false] = ACTIONS(371),
    [sym_null] = ACTIONS(371),
    [sym_undefined] = ACTIONS(371),
    [anon_sym_AT] = ACTIONS(85),
    [anon_sym_static] = ACTIONS(323),
    [anon_sym_get] = ACTIONS(323),
    [anon_sym_set] = ACTIONS(323),
  },
  [132] = {
    [sym_import] = STATE(426),
    [sym_parenthesized_expression] = STATE(340),
    [sym_expression] = STATE(576),
    [sym_primary_expression] = STATE(425),
    [sym_yield_expression] = STATE(424),
    [sym_object] = STATE(426),
    [sym_object_pattern] = STATE(1317),
    [sym_array] = STATE(426),
    [sym_array_pattern] = STATE(1317),
    [sym_jsx_element] = STATE(424),
    [sym_jsx_fragment] = STATE(424),
    [sym_jsx_opening_element] = STATE(768),
    [sym_jsx_self_closing_element] = STATE(424),
    [sym_class] = STATE(426),
    [sym_function] = STATE(426),
    [sym_generator_function] = STATE(426),
    [sym_arrow_function] = STATE(426),
    [sym_call_expression] = STATE(426),
    [sym_new_expression] = STATE(424),
    [sym_await_expression] = STATE(424),
    [sym_member_expression] = STATE(340),
    [sym_subscript_expression] = STATE(340),
    [sym_assignment_expression] = STATE(424),
    [sym__augmented_assignment_lhs] = STATE(712),
    [sym_augmented_assignment_expression] = STATE(424),
    [sym__destructuring_pattern] = STATE(1317),
    [sym_ternary_expression] = STATE(424),
    [sym_binary_expression] = STATE(424),
    [sym_unary_expression] = STATE(424),
    [sym_update_expression] = STATE(424),
    [sym_string] = STATE(426),
    [sym_template_string] = STATE(426),
    [sym_regex] = STATE(426),
    [sym_meta_property] = STATE(426),
    [sym_decorator] = STATE(750),
    [sym_formal_parameters] = STATE(1267),
    [aux_sym_export_statement_repeat1] = STATE(924),
    [sym_identifier] = ACTIONS(391),
    [anon_sym_export] = ACTIONS(393),
    [anon_sym_LBRACE] = ACTIONS(397),
    [anon_sym_import] = ACTIONS(331),
    [anon_sym_LPAREN] = ACTIONS(333),
    [anon_sym_await] = ACTIONS(399),
    [anon_sym_yield] = ACTIONS(401),
    [anon_sym_LBRACK] = ACTIONS(403),
    [anon_sym_LT] = ACTIONS(537),
    [anon_sym_SLASH] = ACTIONS(345),
    [anon_sym_class] = ACTIONS(347),
    [anon_sym_async] = ACTIONS(405),
    [anon_sym_function] = ACTIONS(351),
    [anon_sym_new] = ACTIONS(407),
    [anon_sym_PLUS] = ACTIONS(409),
    [anon_sym_DASH] = ACTIONS(409),
    [anon_sym_BANG] = ACTIONS(411),
    [anon_sym_TILDE] = ACTIONS(411),
    [anon_sym_typeof] = ACTIONS(413),
    [anon_sym_void] = ACTIONS(413),
    [anon_sym_delete] = ACTIONS(413),
    [anon_sym_PLUS_PLUS] = ACTIONS(415),
    [anon_sym_DASH_DASH] = ACTIONS(415),
    [anon_sym_DQUOTE] = ACTIONS(363),
    [anon_sym_SQUOTE] = ACTIONS(365),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(367),
    [sym_number] = ACTIONS(369),
    [sym_this] = ACTIONS(371),
    [sym_super] = ACTIONS(371),
    [sym_true] = ACTIONS(371),
    [sym_false] = ACTIONS(371),
    [sym_null] = ACTIONS(371),
    [sym_undefined] = ACTIONS(371),
    [anon_sym_AT] = ACTIONS(85),
    [anon_sym_static] = ACTIONS(393),
    [anon_sym_get] = ACTIONS(393),
    [anon_sym_set] = ACTIONS(393),
  },
  [133] = {
    [sym_import] = STATE(426),
    [sym_parenthesized_expression] = STATE(355),
    [sym_expression] = STATE(413),
    [sym_primary_expression] = STATE(425),
    [sym_yield_expression] = STATE(424),
    [sym_object] = STATE(426),
    [sym_object_pattern] = STATE(1333),
    [sym_array] = STATE(426),
    [sym_array_pattern] = STATE(1333),
    [sym_jsx_element] = STATE(424),
    [sym_jsx_fragment] = STATE(424),
    [sym_jsx_opening_element] = STATE(768),
    [sym_jsx_self_closing_element] = STATE(424),
    [sym_class] = STATE(426),
    [sym_function] = STATE(426),
    [sym_generator_function] = STATE(426),
    [sym_arrow_function] = STATE(426),
    [sym_call_expression] = STATE(426),
    [sym_new_expression] = STATE(424),
    [sym_await_expression] = STATE(424),
    [sym_member_expression] = STATE(355),
    [sym_subscript_expression] = STATE(355),
    [sym_assignment_expression] = STATE(424),
    [sym__augmented_assignment_lhs] = STATE(714),
    [sym_augmented_assignment_expression] = STATE(424),
    [sym__destructuring_pattern] = STATE(1333),
    [sym_ternary_expression] = STATE(424),
    [sym_binary_expression] = STATE(424),
    [sym_unary_expression] = STATE(424),
    [sym_update_expression] = STATE(424),
    [sym_string] = STATE(426),
    [sym_template_string] = STATE(426),
    [sym_regex] = STATE(426),
    [sym_meta_property] = STATE(426),
    [sym_decorator] = STATE(750),
    [sym_formal_parameters] = STATE(1322),
    [aux_sym_export_statement_repeat1] = STATE(924),
    [sym_identifier] = ACTIONS(321),
    [anon_sym_export] = ACTIONS(323),
    [anon_sym_LBRACE] = ACTIONS(327),
    [anon_sym_import] = ACTIONS(331),
    [anon_sym_LPAREN] = ACTIONS(333),
    [anon_sym_await] = ACTIONS(335),
    [anon_sym_yield] = ACTIONS(339),
    [anon_sym_LBRACK] = ACTIONS(341),
    [anon_sym_LT] = ACTIONS(537),
    [anon_sym_SLASH] = ACTIONS(345),
    [anon_sym_class] = ACTIONS(347),
    [anon_sym_async] = ACTIONS(349),
    [anon_sym_function] = ACTIONS(351),
    [anon_sym_new] = ACTIONS(353),
    [anon_sym_PLUS] = ACTIONS(355),
    [anon_sym_DASH] = ACTIONS(355),
    [anon_sym_BANG] = ACTIONS(357),
    [anon_sym_TILDE] = ACTIONS(357),
    [anon_sym_typeof] = ACTIONS(359),
    [anon_sym_void] = ACTIONS(359),
    [anon_sym_delete] = ACTIONS(359),
    [anon_sym_PLUS_PLUS] = ACTIONS(361),
    [anon_sym_DASH_DASH] = ACTIONS(361),
    [anon_sym_DQUOTE] = ACTIONS(363),
    [anon_sym_SQUOTE] = ACTIONS(365),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(367),
    [sym_number] = ACTIONS(369),
    [sym_this] = ACTIONS(371),
    [sym_super] = ACTIONS(371),
    [sym_true] = ACTIONS(371),
    [sym_false] = ACTIONS(371),
    [sym_null] = ACTIONS(371),
    [sym_undefined] = ACTIONS(371),
    [anon_sym_AT] = ACTIONS(85),
    [anon_sym_static] = ACTIONS(323),
    [anon_sym_get] = ACTIONS(323),
    [anon_sym_set] = ACTIONS(323),
  },
  [134] = {
    [sym_import] = STATE(539),
    [sym_parenthesized_expression] = STATE(362),
    [sym_expression] = STATE(627),
    [sym_primary_expression] = STATE(546),
    [sym_yield_expression] = STATE(550),
    [sym_object] = STATE(539),
    [sym_object_pattern] = STATE(1320),
    [sym_array] = STATE(539),
    [sym_array_pattern] = STATE(1320),
    [sym_jsx_element] = STATE(550),
    [sym_jsx_fragment] = STATE(550),
    [sym_jsx_opening_element] = STATE(772),
    [sym_jsx_self_closing_element] = STATE(550),
    [sym_class] = STATE(539),
    [sym_function] = STATE(539),
    [sym_generator_function] = STATE(539),
    [sym_arrow_function] = STATE(539),
    [sym_call_expression] = STATE(539),
    [sym_new_expression] = STATE(550),
    [sym_await_expression] = STATE(550),
    [sym_member_expression] = STATE(362),
    [sym_subscript_expression] = STATE(362),
    [sym_assignment_expression] = STATE(550),
    [sym__augmented_assignment_lhs] = STATE(720),
    [sym_augmented_assignment_expression] = STATE(550),
    [sym__destructuring_pattern] = STATE(1320),
    [sym_ternary_expression] = STATE(550),
    [sym_binary_expression] = STATE(550),
    [sym_unary_expression] = STATE(550),
    [sym_update_expression] = STATE(550),
    [sym_string] = STATE(539),
    [sym_template_string] = STATE(539),
    [sym_regex] = STATE(539),
    [sym_meta_property] = STATE(539),
    [sym_decorator] = STATE(750),
    [sym_formal_parameters] = STATE(1318),
    [aux_sym_export_statement_repeat1] = STATE(925),
    [sym_identifier] = ACTIONS(373),
    [anon_sym_export] = ACTIONS(375),
    [anon_sym_LBRACE] = ACTIONS(379),
    [anon_sym_import] = ACTIONS(381),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(29),
    [anon_sym_yield] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(53),
    [anon_sym_LT] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(385),
    [anon_sym_async] = ACTIONS(387),
    [anon_sym_function] = ACTIONS(389),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_typeof] = ACTIONS(71),
    [anon_sym_void] = ACTIONS(71),
    [anon_sym_delete] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DQUOTE] = ACTIONS(75),
    [anon_sym_SQUOTE] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(79),
    [sym_number] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(83),
    [sym_true] = ACTIONS(83),
    [sym_false] = ACTIONS(83),
    [sym_null] = ACTIONS(83),
    [sym_undefined] = ACTIONS(83),
    [anon_sym_AT] = ACTIONS(85),
    [anon_sym_static] = ACTIONS(375),
    [anon_sym_get] = ACTIONS(375),
    [anon_sym_set] = ACTIONS(375),
  },
  [135] = {
    [sym_import] = STATE(539),
    [sym_parenthesized_expression] = STATE(362),
    [sym_expression] = STATE(521),
    [sym_primary_expression] = STATE(546),
    [sym_yield_expression] = STATE(550),
    [sym_object] = STATE(539),
    [sym_object_pattern] = STATE(1320),
    [sym_array] = STATE(539),
    [sym_array_pattern] = STATE(1320),
    [sym_jsx_element] = STATE(550),
    [sym_jsx_fragment] = STATE(550),
    [sym_jsx_opening_element] = STATE(772),
    [sym_jsx_self_closing_element] = STATE(550),
    [sym_class] = STATE(539),
    [sym_function] = STATE(539),
    [sym_generator_function] = STATE(539),
    [sym_arrow_function] = STATE(539),
    [sym_call_expression] = STATE(539),
    [sym_new_expression] = STATE(550),
    [sym_await_expression] = STATE(550),
    [sym_member_expression] = STATE(362),
    [sym_subscript_expression] = STATE(362),
    [sym_assignment_expression] = STATE(550),
    [sym__augmented_assignment_lhs] = STATE(720),
    [sym_augmented_assignment_expression] = STATE(550),
    [sym__destructuring_pattern] = STATE(1320),
    [sym_ternary_expression] = STATE(550),
    [sym_binary_expression] = STATE(550),
    [sym_unary_expression] = STATE(550),
    [sym_update_expression] = STATE(550),
    [sym_string] = STATE(539),
    [sym_template_string] = STATE(539),
    [sym_regex] = STATE(539),
    [sym_meta_property] = STATE(539),
    [sym_decorator] = STATE(750),
    [sym_formal_parameters] = STATE(1318),
    [aux_sym_export_statement_repeat1] = STATE(925),
    [sym_identifier] = ACTIONS(373),
    [anon_sym_export] = ACTIONS(375),
    [anon_sym_LBRACE] = ACTIONS(379),
    [anon_sym_import] = ACTIONS(381),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(29),
    [anon_sym_yield] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(53),
    [anon_sym_LT] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(385),
    [anon_sym_async] = ACTIONS(387),
    [anon_sym_function] = ACTIONS(389),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_typeof] = ACTIONS(71),
    [anon_sym_void] = ACTIONS(71),
    [anon_sym_delete] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DQUOTE] = ACTIONS(75),
    [anon_sym_SQUOTE] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(79),
    [sym_number] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(83),
    [sym_true] = ACTIONS(83),
    [sym_false] = ACTIONS(83),
    [sym_null] = ACTIONS(83),
    [sym_undefined] = ACTIONS(83),
    [anon_sym_AT] = ACTIONS(85),
    [anon_sym_static] = ACTIONS(375),
    [anon_sym_get] = ACTIONS(375),
    [anon_sym_set] = ACTIONS(375),
  },
  [136] = {
    [sym_import] = STATE(426),
    [sym_parenthesized_expression] = STATE(355),
    [sym_expression] = STATE(415),
    [sym_primary_expression] = STATE(425),
    [sym_yield_expression] = STATE(424),
    [sym_object] = STATE(426),
    [sym_object_pattern] = STATE(1333),
    [sym_array] = STATE(426),
    [sym_array_pattern] = STATE(1333),
    [sym_jsx_element] = STATE(424),
    [sym_jsx_fragment] = STATE(424),
    [sym_jsx_opening_element] = STATE(768),
    [sym_jsx_self_closing_element] = STATE(424),
    [sym_class] = STATE(426),
    [sym_function] = STATE(426),
    [sym_generator_function] = STATE(426),
    [sym_arrow_function] = STATE(426),
    [sym_call_expression] = STATE(426),
    [sym_new_expression] = STATE(424),
    [sym_await_expression] = STATE(424),
    [sym_member_expression] = STATE(355),
    [sym_subscript_expression] = STATE(355),
    [sym_assignment_expression] = STATE(424),
    [sym__augmented_assignment_lhs] = STATE(714),
    [sym_augmented_assignment_expression] = STATE(424),
    [sym__destructuring_pattern] = STATE(1333),
    [sym_ternary_expression] = STATE(424),
    [sym_binary_expression] = STATE(424),
    [sym_unary_expression] = STATE(424),
    [sym_update_expression] = STATE(424),
    [sym_string] = STATE(426),
    [sym_template_string] = STATE(426),
    [sym_regex] = STATE(426),
    [sym_meta_property] = STATE(426),
    [sym_decorator] = STATE(750),
    [sym_formal_parameters] = STATE(1322),
    [aux_sym_export_statement_repeat1] = STATE(924),
    [sym_identifier] = ACTIONS(321),
    [anon_sym_export] = ACTIONS(323),
    [anon_sym_LBRACE] = ACTIONS(327),
    [anon_sym_import] = ACTIONS(331),
    [anon_sym_LPAREN] = ACTIONS(333),
    [anon_sym_await] = ACTIONS(335),
    [anon_sym_yield] = ACTIONS(339),
    [anon_sym_LBRACK] = ACTIONS(341),
    [anon_sym_LT] = ACTIONS(537),
    [anon_sym_SLASH] = ACTIONS(345),
    [anon_sym_class] = ACTIONS(347),
    [anon_sym_async] = ACTIONS(349),
    [anon_sym_function] = ACTIONS(351),
    [anon_sym_new] = ACTIONS(353),
    [anon_sym_PLUS] = ACTIONS(355),
    [anon_sym_DASH] = ACTIONS(355),
    [anon_sym_BANG] = ACTIONS(357),
    [anon_sym_TILDE] = ACTIONS(357),
    [anon_sym_typeof] = ACTIONS(359),
    [anon_sym_void] = ACTIONS(359),
    [anon_sym_delete] = ACTIONS(359),
    [anon_sym_PLUS_PLUS] = ACTIONS(361),
    [anon_sym_DASH_DASH] = ACTIONS(361),
    [anon_sym_DQUOTE] = ACTIONS(363),
    [anon_sym_SQUOTE] = ACTIONS(365),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(367),
    [sym_number] = ACTIONS(369),
    [sym_this] = ACTIONS(371),
    [sym_super] = ACTIONS(371),
    [sym_true] = ACTIONS(371),
    [sym_false] = ACTIONS(371),
    [sym_null] = ACTIONS(371),
    [sym_undefined] = ACTIONS(371),
    [anon_sym_AT] = ACTIONS(85),
    [anon_sym_static] = ACTIONS(323),
    [anon_sym_get] = ACTIONS(323),
    [anon_sym_set] = ACTIONS(323),
  },
  [137] = {
    [sym_import] = STATE(426),
    [sym_parenthesized_expression] = STATE(355),
    [sym_expression] = STATE(383),
    [sym_primary_expression] = STATE(425),
    [sym_yield_expression] = STATE(424),
    [sym_object] = STATE(426),
    [sym_object_pattern] = STATE(1333),
    [sym_array] = STATE(426),
    [sym_array_pattern] = STATE(1333),
    [sym_jsx_element] = STATE(424),
    [sym_jsx_fragment] = STATE(424),
    [sym_jsx_opening_element] = STATE(768),
    [sym_jsx_self_closing_element] = STATE(424),
    [sym_class] = STATE(426),
    [sym_function] = STATE(426),
    [sym_generator_function] = STATE(426),
    [sym_arrow_function] = STATE(426),
    [sym_call_expression] = STATE(426),
    [sym_new_expression] = STATE(424),
    [sym_await_expression] = STATE(424),
    [sym_member_expression] = STATE(355),
    [sym_subscript_expression] = STATE(355),
    [sym_assignment_expression] = STATE(424),
    [sym__augmented_assignment_lhs] = STATE(714),
    [sym_augmented_assignment_expression] = STATE(424),
    [sym__destructuring_pattern] = STATE(1333),
    [sym_ternary_expression] = STATE(424),
    [sym_binary_expression] = STATE(424),
    [sym_unary_expression] = STATE(424),
    [sym_update_expression] = STATE(424),
    [sym_string] = STATE(426),
    [sym_template_string] = STATE(426),
    [sym_regex] = STATE(426),
    [sym_meta_property] = STATE(426),
    [sym_decorator] = STATE(750),
    [sym_formal_parameters] = STATE(1322),
    [aux_sym_export_statement_repeat1] = STATE(924),
    [sym_identifier] = ACTIONS(321),
    [anon_sym_export] = ACTIONS(323),
    [anon_sym_LBRACE] = ACTIONS(327),
    [anon_sym_import] = ACTIONS(331),
    [anon_sym_LPAREN] = ACTIONS(333),
    [anon_sym_await] = ACTIONS(335),
    [anon_sym_yield] = ACTIONS(339),
    [anon_sym_LBRACK] = ACTIONS(341),
    [anon_sym_LT] = ACTIONS(537),
    [anon_sym_SLASH] = ACTIONS(345),
    [anon_sym_class] = ACTIONS(347),
    [anon_sym_async] = ACTIONS(349),
    [anon_sym_function] = ACTIONS(351),
    [anon_sym_new] = ACTIONS(353),
    [anon_sym_PLUS] = ACTIONS(355),
    [anon_sym_DASH] = ACTIONS(355),
    [anon_sym_BANG] = ACTIONS(357),
    [anon_sym_TILDE] = ACTIONS(357),
    [anon_sym_typeof] = ACTIONS(359),
    [anon_sym_void] = ACTIONS(359),
    [anon_sym_delete] = ACTIONS(359),
    [anon_sym_PLUS_PLUS] = ACTIONS(361),
    [anon_sym_DASH_DASH] = ACTIONS(361),
    [anon_sym_DQUOTE] = ACTIONS(363),
    [anon_sym_SQUOTE] = ACTIONS(365),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(367),
    [sym_number] = ACTIONS(369),
    [sym_this] = ACTIONS(371),
    [sym_super] = ACTIONS(371),
    [sym_true] = ACTIONS(371),
    [sym_false] = ACTIONS(371),
    [sym_null] = ACTIONS(371),
    [sym_undefined] = ACTIONS(371),
    [anon_sym_AT] = ACTIONS(85),
    [anon_sym_static] = ACTIONS(323),
    [anon_sym_get] = ACTIONS(323),
    [anon_sym_set] = ACTIONS(323),
  },
  [138] = {
    [sym_import] = STATE(539),
    [sym_parenthesized_expression] = STATE(362),
    [sym_expression] = STATE(499),
    [sym_primary_expression] = STATE(546),
    [sym_yield_expression] = STATE(550),
    [sym_object] = STATE(539),
    [sym_object_pattern] = STATE(1320),
    [sym_array] = STATE(539),
    [sym_array_pattern] = STATE(1320),
    [sym_jsx_element] = STATE(550),
    [sym_jsx_fragment] = STATE(550),
    [sym_jsx_opening_element] = STATE(772),
    [sym_jsx_self_closing_element] = STATE(550),
    [sym_class] = STATE(539),
    [sym_function] = STATE(539),
    [sym_generator_function] = STATE(539),
    [sym_arrow_function] = STATE(539),
    [sym_call_expression] = STATE(539),
    [sym_new_expression] = STATE(550),
    [sym_await_expression] = STATE(550),
    [sym_member_expression] = STATE(362),
    [sym_subscript_expression] = STATE(362),
    [sym_assignment_expression] = STATE(550),
    [sym__augmented_assignment_lhs] = STATE(720),
    [sym_augmented_assignment_expression] = STATE(550),
    [sym__destructuring_pattern] = STATE(1320),
    [sym_ternary_expression] = STATE(550),
    [sym_binary_expression] = STATE(550),
    [sym_unary_expression] = STATE(550),
    [sym_update_expression] = STATE(550),
    [sym_string] = STATE(539),
    [sym_template_string] = STATE(539),
    [sym_regex] = STATE(539),
    [sym_meta_property] = STATE(539),
    [sym_decorator] = STATE(750),
    [sym_formal_parameters] = STATE(1318),
    [aux_sym_export_statement_repeat1] = STATE(925),
    [sym_identifier] = ACTIONS(373),
    [anon_sym_export] = ACTIONS(375),
    [anon_sym_LBRACE] = ACTIONS(379),
    [anon_sym_import] = ACTIONS(381),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(29),
    [anon_sym_yield] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(53),
    [anon_sym_LT] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(385),
    [anon_sym_async] = ACTIONS(387),
    [anon_sym_function] = ACTIONS(389),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_typeof] = ACTIONS(71),
    [anon_sym_void] = ACTIONS(71),
    [anon_sym_delete] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DQUOTE] = ACTIONS(75),
    [anon_sym_SQUOTE] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(79),
    [sym_number] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(83),
    [sym_true] = ACTIONS(83),
    [sym_false] = ACTIONS(83),
    [sym_null] = ACTIONS(83),
    [sym_undefined] = ACTIONS(83),
    [anon_sym_AT] = ACTIONS(85),
    [anon_sym_static] = ACTIONS(375),
    [anon_sym_get] = ACTIONS(375),
    [anon_sym_set] = ACTIONS(375),
  },
  [139] = {
    [sym_import] = STATE(426),
    [sym_parenthesized_expression] = STATE(340),
    [sym_expression] = STATE(383),
    [sym_primary_expression] = STATE(425),
    [sym_yield_expression] = STATE(424),
    [sym_object] = STATE(426),
    [sym_object_pattern] = STATE(1317),
    [sym_array] = STATE(426),
    [sym_array_pattern] = STATE(1317),
    [sym_jsx_element] = STATE(424),
    [sym_jsx_fragment] = STATE(424),
    [sym_jsx_opening_element] = STATE(768),
    [sym_jsx_self_closing_element] = STATE(424),
    [sym_class] = STATE(426),
    [sym_function] = STATE(426),
    [sym_generator_function] = STATE(426),
    [sym_arrow_function] = STATE(426),
    [sym_call_expression] = STATE(426),
    [sym_new_expression] = STATE(424),
    [sym_await_expression] = STATE(424),
    [sym_member_expression] = STATE(340),
    [sym_subscript_expression] = STATE(340),
    [sym_assignment_expression] = STATE(424),
    [sym__augmented_assignment_lhs] = STATE(712),
    [sym_augmented_assignment_expression] = STATE(424),
    [sym__destructuring_pattern] = STATE(1317),
    [sym_ternary_expression] = STATE(424),
    [sym_binary_expression] = STATE(424),
    [sym_unary_expression] = STATE(424),
    [sym_update_expression] = STATE(424),
    [sym_string] = STATE(426),
    [sym_template_string] = STATE(426),
    [sym_regex] = STATE(426),
    [sym_meta_property] = STATE(426),
    [sym_decorator] = STATE(750),
    [sym_formal_parameters] = STATE(1267),
    [aux_sym_export_statement_repeat1] = STATE(924),
    [sym_identifier] = ACTIONS(391),
    [anon_sym_export] = ACTIONS(393),
    [anon_sym_LBRACE] = ACTIONS(397),
    [anon_sym_import] = ACTIONS(331),
    [anon_sym_LPAREN] = ACTIONS(333),
    [anon_sym_await] = ACTIONS(399),
    [anon_sym_yield] = ACTIONS(401),
    [anon_sym_LBRACK] = ACTIONS(403),
    [anon_sym_LT] = ACTIONS(537),
    [anon_sym_SLASH] = ACTIONS(345),
    [anon_sym_class] = ACTIONS(347),
    [anon_sym_async] = ACTIONS(405),
    [anon_sym_function] = ACTIONS(351),
    [anon_sym_new] = ACTIONS(407),
    [anon_sym_PLUS] = ACTIONS(409),
    [anon_sym_DASH] = ACTIONS(409),
    [anon_sym_BANG] = ACTIONS(411),
    [anon_sym_TILDE] = ACTIONS(411),
    [anon_sym_typeof] = ACTIONS(413),
    [anon_sym_void] = ACTIONS(413),
    [anon_sym_delete] = ACTIONS(413),
    [anon_sym_PLUS_PLUS] = ACTIONS(415),
    [anon_sym_DASH_DASH] = ACTIONS(415),
    [anon_sym_DQUOTE] = ACTIONS(363),
    [anon_sym_SQUOTE] = ACTIONS(365),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(367),
    [sym_number] = ACTIONS(369),
    [sym_this] = ACTIONS(371),
    [sym_super] = ACTIONS(371),
    [sym_true] = ACTIONS(371),
    [sym_false] = ACTIONS(371),
    [sym_null] = ACTIONS(371),
    [sym_undefined] = ACTIONS(371),
    [anon_sym_AT] = ACTIONS(85),
    [anon_sym_static] = ACTIONS(393),
    [anon_sym_get] = ACTIONS(393),
    [anon_sym_set] = ACTIONS(393),
  },
  [140] = {
    [sym_import] = STATE(426),
    [sym_parenthesized_expression] = STATE(340),
    [sym_expression] = STATE(621),
    [sym_primary_expression] = STATE(425),
    [sym_yield_expression] = STATE(424),
    [sym_object] = STATE(426),
    [sym_object_pattern] = STATE(1317),
    [sym_array] = STATE(426),
    [sym_array_pattern] = STATE(1317),
    [sym_jsx_element] = STATE(424),
    [sym_jsx_fragment] = STATE(424),
    [sym_jsx_opening_element] = STATE(768),
    [sym_jsx_self_closing_element] = STATE(424),
    [sym_class] = STATE(426),
    [sym_function] = STATE(426),
    [sym_generator_function] = STATE(426),
    [sym_arrow_function] = STATE(426),
    [sym_call_expression] = STATE(426),
    [sym_new_expression] = STATE(424),
    [sym_await_expression] = STATE(424),
    [sym_member_expression] = STATE(340),
    [sym_subscript_expression] = STATE(340),
    [sym_assignment_expression] = STATE(424),
    [sym__augmented_assignment_lhs] = STATE(712),
    [sym_augmented_assignment_expression] = STATE(424),
    [sym__destructuring_pattern] = STATE(1317),
    [sym_ternary_expression] = STATE(424),
    [sym_binary_expression] = STATE(424),
    [sym_unary_expression] = STATE(424),
    [sym_update_expression] = STATE(424),
    [sym_string] = STATE(426),
    [sym_template_string] = STATE(426),
    [sym_regex] = STATE(426),
    [sym_meta_property] = STATE(426),
    [sym_decorator] = STATE(750),
    [sym_formal_parameters] = STATE(1267),
    [aux_sym_export_statement_repeat1] = STATE(924),
    [sym_identifier] = ACTIONS(391),
    [anon_sym_export] = ACTIONS(393),
    [anon_sym_LBRACE] = ACTIONS(397),
    [anon_sym_import] = ACTIONS(331),
    [anon_sym_LPAREN] = ACTIONS(333),
    [anon_sym_await] = ACTIONS(399),
    [anon_sym_yield] = ACTIONS(401),
    [anon_sym_LBRACK] = ACTIONS(403),
    [anon_sym_LT] = ACTIONS(537),
    [anon_sym_SLASH] = ACTIONS(345),
    [anon_sym_class] = ACTIONS(347),
    [anon_sym_async] = ACTIONS(405),
    [anon_sym_function] = ACTIONS(351),
    [anon_sym_new] = ACTIONS(407),
    [anon_sym_PLUS] = ACTIONS(409),
    [anon_sym_DASH] = ACTIONS(409),
    [anon_sym_BANG] = ACTIONS(411),
    [anon_sym_TILDE] = ACTIONS(411),
    [anon_sym_typeof] = ACTIONS(413),
    [anon_sym_void] = ACTIONS(413),
    [anon_sym_delete] = ACTIONS(413),
    [anon_sym_PLUS_PLUS] = ACTIONS(415),
    [anon_sym_DASH_DASH] = ACTIONS(415),
    [anon_sym_DQUOTE] = ACTIONS(363),
    [anon_sym_SQUOTE] = ACTIONS(365),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(367),
    [sym_number] = ACTIONS(369),
    [sym_this] = ACTIONS(371),
    [sym_super] = ACTIONS(371),
    [sym_true] = ACTIONS(371),
    [sym_false] = ACTIONS(371),
    [sym_null] = ACTIONS(371),
    [sym_undefined] = ACTIONS(371),
    [anon_sym_AT] = ACTIONS(85),
    [anon_sym_static] = ACTIONS(393),
    [anon_sym_get] = ACTIONS(393),
    [anon_sym_set] = ACTIONS(393),
  },
  [141] = {
    [sym_import] = STATE(539),
    [sym_parenthesized_expression] = STATE(362),
    [sym_expression] = STATE(483),
    [sym_primary_expression] = STATE(546),
    [sym_yield_expression] = STATE(550),
    [sym_object] = STATE(539),
    [sym_object_pattern] = STATE(1320),
    [sym_array] = STATE(539),
    [sym_array_pattern] = STATE(1320),
    [sym_jsx_element] = STATE(550),
    [sym_jsx_fragment] = STATE(550),
    [sym_jsx_opening_element] = STATE(772),
    [sym_jsx_self_closing_element] = STATE(550),
    [sym_class] = STATE(539),
    [sym_function] = STATE(539),
    [sym_generator_function] = STATE(539),
    [sym_arrow_function] = STATE(539),
    [sym_call_expression] = STATE(539),
    [sym_new_expression] = STATE(550),
    [sym_await_expression] = STATE(550),
    [sym_member_expression] = STATE(362),
    [sym_subscript_expression] = STATE(362),
    [sym_assignment_expression] = STATE(550),
    [sym__augmented_assignment_lhs] = STATE(720),
    [sym_augmented_assignment_expression] = STATE(550),
    [sym__destructuring_pattern] = STATE(1320),
    [sym_ternary_expression] = STATE(550),
    [sym_binary_expression] = STATE(550),
    [sym_unary_expression] = STATE(550),
    [sym_update_expression] = STATE(550),
    [sym_string] = STATE(539),
    [sym_template_string] = STATE(539),
    [sym_regex] = STATE(539),
    [sym_meta_property] = STATE(539),
    [sym_decorator] = STATE(750),
    [sym_formal_parameters] = STATE(1318),
    [aux_sym_export_statement_repeat1] = STATE(925),
    [sym_identifier] = ACTIONS(373),
    [anon_sym_export] = ACTIONS(375),
    [anon_sym_LBRACE] = ACTIONS(379),
    [anon_sym_import] = ACTIONS(381),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(29),
    [anon_sym_yield] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(53),
    [anon_sym_LT] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(385),
    [anon_sym_async] = ACTIONS(387),
    [anon_sym_function] = ACTIONS(389),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_typeof] = ACTIONS(71),
    [anon_sym_void] = ACTIONS(71),
    [anon_sym_delete] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DQUOTE] = ACTIONS(75),
    [anon_sym_SQUOTE] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(79),
    [sym_number] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(83),
    [sym_true] = ACTIONS(83),
    [sym_false] = ACTIONS(83),
    [sym_null] = ACTIONS(83),
    [sym_undefined] = ACTIONS(83),
    [anon_sym_AT] = ACTIONS(85),
    [anon_sym_static] = ACTIONS(375),
    [anon_sym_get] = ACTIONS(375),
    [anon_sym_set] = ACTIONS(375),
  },
  [142] = {
    [sym_import] = STATE(426),
    [sym_parenthesized_expression] = STATE(355),
    [sym_expression] = STATE(396),
    [sym_primary_expression] = STATE(425),
    [sym_yield_expression] = STATE(424),
    [sym_object] = STATE(426),
    [sym_object_pattern] = STATE(1333),
    [sym_array] = STATE(426),
    [sym_array_pattern] = STATE(1333),
    [sym_jsx_element] = STATE(424),
    [sym_jsx_fragment] = STATE(424),
    [sym_jsx_opening_element] = STATE(768),
    [sym_jsx_self_closing_element] = STATE(424),
    [sym_class] = STATE(426),
    [sym_function] = STATE(426),
    [sym_generator_function] = STATE(426),
    [sym_arrow_function] = STATE(426),
    [sym_call_expression] = STATE(426),
    [sym_new_expression] = STATE(424),
    [sym_await_expression] = STATE(424),
    [sym_member_expression] = STATE(355),
    [sym_subscript_expression] = STATE(355),
    [sym_assignment_expression] = STATE(424),
    [sym__augmented_assignment_lhs] = STATE(714),
    [sym_augmented_assignment_expression] = STATE(424),
    [sym__destructuring_pattern] = STATE(1333),
    [sym_ternary_expression] = STATE(424),
    [sym_binary_expression] = STATE(424),
    [sym_unary_expression] = STATE(424),
    [sym_update_expression] = STATE(424),
    [sym_string] = STATE(426),
    [sym_template_string] = STATE(426),
    [sym_regex] = STATE(426),
    [sym_meta_property] = STATE(426),
    [sym_decorator] = STATE(750),
    [sym_formal_parameters] = STATE(1322),
    [aux_sym_export_statement_repeat1] = STATE(924),
    [sym_identifier] = ACTIONS(321),
    [anon_sym_export] = ACTIONS(323),
    [anon_sym_LBRACE] = ACTIONS(327),
    [anon_sym_import] = ACTIONS(331),
    [anon_sym_LPAREN] = ACTIONS(333),
    [anon_sym_await] = ACTIONS(335),
    [anon_sym_yield] = ACTIONS(339),
    [anon_sym_LBRACK] = ACTIONS(341),
    [anon_sym_LT] = ACTIONS(537),
    [anon_sym_SLASH] = ACTIONS(345),
    [anon_sym_class] = ACTIONS(347),
    [anon_sym_async] = ACTIONS(349),
    [anon_sym_function] = ACTIONS(351),
    [anon_sym_new] = ACTIONS(353),
    [anon_sym_PLUS] = ACTIONS(355),
    [anon_sym_DASH] = ACTIONS(355),
    [anon_sym_BANG] = ACTIONS(357),
    [anon_sym_TILDE] = ACTIONS(357),
    [anon_sym_typeof] = ACTIONS(359),
    [anon_sym_void] = ACTIONS(359),
    [anon_sym_delete] = ACTIONS(359),
    [anon_sym_PLUS_PLUS] = ACTIONS(361),
    [anon_sym_DASH_DASH] = ACTIONS(361),
    [anon_sym_DQUOTE] = ACTIONS(363),
    [anon_sym_SQUOTE] = ACTIONS(365),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(367),
    [sym_number] = ACTIONS(369),
    [sym_this] = ACTIONS(371),
    [sym_super] = ACTIONS(371),
    [sym_true] = ACTIONS(371),
    [sym_false] = ACTIONS(371),
    [sym_null] = ACTIONS(371),
    [sym_undefined] = ACTIONS(371),
    [anon_sym_AT] = ACTIONS(85),
    [anon_sym_static] = ACTIONS(323),
    [anon_sym_get] = ACTIONS(323),
    [anon_sym_set] = ACTIONS(323),
  },
  [143] = {
    [sym_import] = STATE(426),
    [sym_parenthesized_expression] = STATE(355),
    [sym_expression] = STATE(409),
    [sym_primary_expression] = STATE(425),
    [sym_yield_expression] = STATE(424),
    [sym_object] = STATE(426),
    [sym_object_pattern] = STATE(1333),
    [sym_array] = STATE(426),
    [sym_array_pattern] = STATE(1333),
    [sym_jsx_element] = STATE(424),
    [sym_jsx_fragment] = STATE(424),
    [sym_jsx_opening_element] = STATE(768),
    [sym_jsx_self_closing_element] = STATE(424),
    [sym_class] = STATE(426),
    [sym_function] = STATE(426),
    [sym_generator_function] = STATE(426),
    [sym_arrow_function] = STATE(426),
    [sym_call_expression] = STATE(426),
    [sym_new_expression] = STATE(424),
    [sym_await_expression] = STATE(424),
    [sym_member_expression] = STATE(355),
    [sym_subscript_expression] = STATE(355),
    [sym_assignment_expression] = STATE(424),
    [sym__augmented_assignment_lhs] = STATE(714),
    [sym_augmented_assignment_expression] = STATE(424),
    [sym__destructuring_pattern] = STATE(1333),
    [sym_ternary_expression] = STATE(424),
    [sym_binary_expression] = STATE(424),
    [sym_unary_expression] = STATE(424),
    [sym_update_expression] = STATE(424),
    [sym_string] = STATE(426),
    [sym_template_string] = STATE(426),
    [sym_regex] = STATE(426),
    [sym_meta_property] = STATE(426),
    [sym_decorator] = STATE(750),
    [sym_formal_parameters] = STATE(1322),
    [aux_sym_export_statement_repeat1] = STATE(924),
    [sym_identifier] = ACTIONS(321),
    [anon_sym_export] = ACTIONS(323),
    [anon_sym_LBRACE] = ACTIONS(327),
    [anon_sym_import] = ACTIONS(331),
    [anon_sym_LPAREN] = ACTIONS(333),
    [anon_sym_await] = ACTIONS(335),
    [anon_sym_yield] = ACTIONS(339),
    [anon_sym_LBRACK] = ACTIONS(341),
    [anon_sym_LT] = ACTIONS(537),
    [anon_sym_SLASH] = ACTIONS(345),
    [anon_sym_class] = ACTIONS(347),
    [anon_sym_async] = ACTIONS(349),
    [anon_sym_function] = ACTIONS(351),
    [anon_sym_new] = ACTIONS(353),
    [anon_sym_PLUS] = ACTIONS(355),
    [anon_sym_DASH] = ACTIONS(355),
    [anon_sym_BANG] = ACTIONS(357),
    [anon_sym_TILDE] = ACTIONS(357),
    [anon_sym_typeof] = ACTIONS(359),
    [anon_sym_void] = ACTIONS(359),
    [anon_sym_delete] = ACTIONS(359),
    [anon_sym_PLUS_PLUS] = ACTIONS(361),
    [anon_sym_DASH_DASH] = ACTIONS(361),
    [anon_sym_DQUOTE] = ACTIONS(363),
    [anon_sym_SQUOTE] = ACTIONS(365),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(367),
    [sym_number] = ACTIONS(369),
    [sym_this] = ACTIONS(371),
    [sym_super] = ACTIONS(371),
    [sym_true] = ACTIONS(371),
    [sym_false] = ACTIONS(371),
    [sym_null] = ACTIONS(371),
    [sym_undefined] = ACTIONS(371),
    [anon_sym_AT] = ACTIONS(85),
    [anon_sym_static] = ACTIONS(323),
    [anon_sym_get] = ACTIONS(323),
    [anon_sym_set] = ACTIONS(323),
  },
  [144] = {
    [sym_import] = STATE(426),
    [sym_parenthesized_expression] = STATE(355),
    [sym_expression] = STATE(558),
    [sym_primary_expression] = STATE(425),
    [sym_yield_expression] = STATE(424),
    [sym_object] = STATE(426),
    [sym_object_pattern] = STATE(1333),
    [sym_array] = STATE(426),
    [sym_array_pattern] = STATE(1333),
    [sym_jsx_element] = STATE(424),
    [sym_jsx_fragment] = STATE(424),
    [sym_jsx_opening_element] = STATE(768),
    [sym_jsx_self_closing_element] = STATE(424),
    [sym_class] = STATE(426),
    [sym_function] = STATE(426),
    [sym_generator_function] = STATE(426),
    [sym_arrow_function] = STATE(426),
    [sym_call_expression] = STATE(426),
    [sym_new_expression] = STATE(424),
    [sym_await_expression] = STATE(424),
    [sym_member_expression] = STATE(355),
    [sym_subscript_expression] = STATE(355),
    [sym_assignment_expression] = STATE(424),
    [sym__augmented_assignment_lhs] = STATE(714),
    [sym_augmented_assignment_expression] = STATE(424),
    [sym__destructuring_pattern] = STATE(1333),
    [sym_ternary_expression] = STATE(424),
    [sym_binary_expression] = STATE(424),
    [sym_unary_expression] = STATE(424),
    [sym_update_expression] = STATE(424),
    [sym_string] = STATE(426),
    [sym_template_string] = STATE(426),
    [sym_regex] = STATE(426),
    [sym_meta_property] = STATE(426),
    [sym_decorator] = STATE(750),
    [sym_formal_parameters] = STATE(1322),
    [aux_sym_export_statement_repeat1] = STATE(924),
    [sym_identifier] = ACTIONS(321),
    [anon_sym_export] = ACTIONS(323),
    [anon_sym_LBRACE] = ACTIONS(327),
    [anon_sym_import] = ACTIONS(331),
    [anon_sym_LPAREN] = ACTIONS(333),
    [anon_sym_await] = ACTIONS(335),
    [anon_sym_yield] = ACTIONS(339),
    [anon_sym_LBRACK] = ACTIONS(341),
    [anon_sym_LT] = ACTIONS(537),
    [anon_sym_SLASH] = ACTIONS(345),
    [anon_sym_class] = ACTIONS(347),
    [anon_sym_async] = ACTIONS(349),
    [anon_sym_function] = ACTIONS(351),
    [anon_sym_new] = ACTIONS(353),
    [anon_sym_PLUS] = ACTIONS(355),
    [anon_sym_DASH] = ACTIONS(355),
    [anon_sym_BANG] = ACTIONS(357),
    [anon_sym_TILDE] = ACTIONS(357),
    [anon_sym_typeof] = ACTIONS(359),
    [anon_sym_void] = ACTIONS(359),
    [anon_sym_delete] = ACTIONS(359),
    [anon_sym_PLUS_PLUS] = ACTIONS(361),
    [anon_sym_DASH_DASH] = ACTIONS(361),
    [anon_sym_DQUOTE] = ACTIONS(363),
    [anon_sym_SQUOTE] = ACTIONS(365),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(367),
    [sym_number] = ACTIONS(369),
    [sym_this] = ACTIONS(371),
    [sym_super] = ACTIONS(371),
    [sym_true] = ACTIONS(371),
    [sym_false] = ACTIONS(371),
    [sym_null] = ACTIONS(371),
    [sym_undefined] = ACTIONS(371),
    [anon_sym_AT] = ACTIONS(85),
    [anon_sym_static] = ACTIONS(323),
    [anon_sym_get] = ACTIONS(323),
    [anon_sym_set] = ACTIONS(323),
  },
  [145] = {
    [sym_import] = STATE(539),
    [sym_parenthesized_expression] = STATE(362),
    [sym_expression] = STATE(473),
    [sym_primary_expression] = STATE(546),
    [sym_yield_expression] = STATE(550),
    [sym_object] = STATE(539),
    [sym_object_pattern] = STATE(1320),
    [sym_array] = STATE(539),
    [sym_array_pattern] = STATE(1320),
    [sym_jsx_element] = STATE(550),
    [sym_jsx_fragment] = STATE(550),
    [sym_jsx_opening_element] = STATE(772),
    [sym_jsx_self_closing_element] = STATE(550),
    [sym_class] = STATE(539),
    [sym_function] = STATE(539),
    [sym_generator_function] = STATE(539),
    [sym_arrow_function] = STATE(539),
    [sym_call_expression] = STATE(539),
    [sym_new_expression] = STATE(550),
    [sym_await_expression] = STATE(550),
    [sym_member_expression] = STATE(362),
    [sym_subscript_expression] = STATE(362),
    [sym_assignment_expression] = STATE(550),
    [sym__augmented_assignment_lhs] = STATE(720),
    [sym_augmented_assignment_expression] = STATE(550),
    [sym__destructuring_pattern] = STATE(1320),
    [sym_ternary_expression] = STATE(550),
    [sym_binary_expression] = STATE(550),
    [sym_unary_expression] = STATE(550),
    [sym_update_expression] = STATE(550),
    [sym_string] = STATE(539),
    [sym_template_string] = STATE(539),
    [sym_regex] = STATE(539),
    [sym_meta_property] = STATE(539),
    [sym_decorator] = STATE(750),
    [sym_formal_parameters] = STATE(1318),
    [aux_sym_export_statement_repeat1] = STATE(925),
    [sym_identifier] = ACTIONS(373),
    [anon_sym_export] = ACTIONS(375),
    [anon_sym_LBRACE] = ACTIONS(379),
    [anon_sym_import] = ACTIONS(381),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(29),
    [anon_sym_yield] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(53),
    [anon_sym_LT] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(385),
    [anon_sym_async] = ACTIONS(387),
    [anon_sym_function] = ACTIONS(389),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_typeof] = ACTIONS(71),
    [anon_sym_void] = ACTIONS(71),
    [anon_sym_delete] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DQUOTE] = ACTIONS(75),
    [anon_sym_SQUOTE] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(79),
    [sym_number] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(83),
    [sym_true] = ACTIONS(83),
    [sym_false] = ACTIONS(83),
    [sym_null] = ACTIONS(83),
    [sym_undefined] = ACTIONS(83),
    [anon_sym_AT] = ACTIONS(85),
    [anon_sym_static] = ACTIONS(375),
    [anon_sym_get] = ACTIONS(375),
    [anon_sym_set] = ACTIONS(375),
  },
  [146] = {
    [sym_import] = STATE(426),
    [sym_parenthesized_expression] = STATE(355),
    [sym_expression] = STATE(391),
    [sym_primary_expression] = STATE(425),
    [sym_yield_expression] = STATE(424),
    [sym_object] = STATE(426),
    [sym_object_pattern] = STATE(1333),
    [sym_array] = STATE(426),
    [sym_array_pattern] = STATE(1333),
    [sym_jsx_element] = STATE(424),
    [sym_jsx_fragment] = STATE(424),
    [sym_jsx_opening_element] = STATE(768),
    [sym_jsx_self_closing_element] = STATE(424),
    [sym_class] = STATE(426),
    [sym_function] = STATE(426),
    [sym_generator_function] = STATE(426),
    [sym_arrow_function] = STATE(426),
    [sym_call_expression] = STATE(426),
    [sym_new_expression] = STATE(424),
    [sym_await_expression] = STATE(424),
    [sym_member_expression] = STATE(355),
    [sym_subscript_expression] = STATE(355),
    [sym_assignment_expression] = STATE(424),
    [sym__augmented_assignment_lhs] = STATE(714),
    [sym_augmented_assignment_expression] = STATE(424),
    [sym__destructuring_pattern] = STATE(1333),
    [sym_ternary_expression] = STATE(424),
    [sym_binary_expression] = STATE(424),
    [sym_unary_expression] = STATE(424),
    [sym_update_expression] = STATE(424),
    [sym_string] = STATE(426),
    [sym_template_string] = STATE(426),
    [sym_regex] = STATE(426),
    [sym_meta_property] = STATE(426),
    [sym_decorator] = STATE(750),
    [sym_formal_parameters] = STATE(1322),
    [aux_sym_export_statement_repeat1] = STATE(924),
    [sym_identifier] = ACTIONS(321),
    [anon_sym_export] = ACTIONS(323),
    [anon_sym_LBRACE] = ACTIONS(327),
    [anon_sym_import] = ACTIONS(331),
    [anon_sym_LPAREN] = ACTIONS(333),
    [anon_sym_await] = ACTIONS(335),
    [anon_sym_yield] = ACTIONS(339),
    [anon_sym_LBRACK] = ACTIONS(341),
    [anon_sym_LT] = ACTIONS(537),
    [anon_sym_SLASH] = ACTIONS(345),
    [anon_sym_class] = ACTIONS(347),
    [anon_sym_async] = ACTIONS(349),
    [anon_sym_function] = ACTIONS(351),
    [anon_sym_new] = ACTIONS(353),
    [anon_sym_PLUS] = ACTIONS(355),
    [anon_sym_DASH] = ACTIONS(355),
    [anon_sym_BANG] = ACTIONS(357),
    [anon_sym_TILDE] = ACTIONS(357),
    [anon_sym_typeof] = ACTIONS(359),
    [anon_sym_void] = ACTIONS(359),
    [anon_sym_delete] = ACTIONS(359),
    [anon_sym_PLUS_PLUS] = ACTIONS(361),
    [anon_sym_DASH_DASH] = ACTIONS(361),
    [anon_sym_DQUOTE] = ACTIONS(363),
    [anon_sym_SQUOTE] = ACTIONS(365),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(367),
    [sym_number] = ACTIONS(369),
    [sym_this] = ACTIONS(371),
    [sym_super] = ACTIONS(371),
    [sym_true] = ACTIONS(371),
    [sym_false] = ACTIONS(371),
    [sym_null] = ACTIONS(371),
    [sym_undefined] = ACTIONS(371),
    [anon_sym_AT] = ACTIONS(85),
    [anon_sym_static] = ACTIONS(323),
    [anon_sym_get] = ACTIONS(323),
    [anon_sym_set] = ACTIONS(323),
  },
  [147] = {
    [sym_import] = STATE(426),
    [sym_parenthesized_expression] = STATE(355),
    [sym_expression] = STATE(406),
    [sym_primary_expression] = STATE(425),
    [sym_yield_expression] = STATE(424),
    [sym_object] = STATE(426),
    [sym_object_pattern] = STATE(1333),
    [sym_array] = STATE(426),
    [sym_array_pattern] = STATE(1333),
    [sym_jsx_element] = STATE(424),
    [sym_jsx_fragment] = STATE(424),
    [sym_jsx_opening_element] = STATE(768),
    [sym_jsx_self_closing_element] = STATE(424),
    [sym_class] = STATE(426),
    [sym_function] = STATE(426),
    [sym_generator_function] = STATE(426),
    [sym_arrow_function] = STATE(426),
    [sym_call_expression] = STATE(426),
    [sym_new_expression] = STATE(424),
    [sym_await_expression] = STATE(424),
    [sym_member_expression] = STATE(355),
    [sym_subscript_expression] = STATE(355),
    [sym_assignment_expression] = STATE(424),
    [sym__augmented_assignment_lhs] = STATE(714),
    [sym_augmented_assignment_expression] = STATE(424),
    [sym__destructuring_pattern] = STATE(1333),
    [sym_ternary_expression] = STATE(424),
    [sym_binary_expression] = STATE(424),
    [sym_unary_expression] = STATE(424),
    [sym_update_expression] = STATE(424),
    [sym_string] = STATE(426),
    [sym_template_string] = STATE(426),
    [sym_regex] = STATE(426),
    [sym_meta_property] = STATE(426),
    [sym_decorator] = STATE(750),
    [sym_formal_parameters] = STATE(1322),
    [aux_sym_export_statement_repeat1] = STATE(924),
    [sym_identifier] = ACTIONS(321),
    [anon_sym_export] = ACTIONS(323),
    [anon_sym_LBRACE] = ACTIONS(327),
    [anon_sym_import] = ACTIONS(331),
    [anon_sym_LPAREN] = ACTIONS(333),
    [anon_sym_await] = ACTIONS(335),
    [anon_sym_yield] = ACTIONS(339),
    [anon_sym_LBRACK] = ACTIONS(341),
    [anon_sym_LT] = ACTIONS(537),
    [anon_sym_SLASH] = ACTIONS(345),
    [anon_sym_class] = ACTIONS(347),
    [anon_sym_async] = ACTIONS(349),
    [anon_sym_function] = ACTIONS(351),
    [anon_sym_new] = ACTIONS(353),
    [anon_sym_PLUS] = ACTIONS(355),
    [anon_sym_DASH] = ACTIONS(355),
    [anon_sym_BANG] = ACTIONS(357),
    [anon_sym_TILDE] = ACTIONS(357),
    [anon_sym_typeof] = ACTIONS(359),
    [anon_sym_void] = ACTIONS(359),
    [anon_sym_delete] = ACTIONS(359),
    [anon_sym_PLUS_PLUS] = ACTIONS(361),
    [anon_sym_DASH_DASH] = ACTIONS(361),
    [anon_sym_DQUOTE] = ACTIONS(363),
    [anon_sym_SQUOTE] = ACTIONS(365),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(367),
    [sym_number] = ACTIONS(369),
    [sym_this] = ACTIONS(371),
    [sym_super] = ACTIONS(371),
    [sym_true] = ACTIONS(371),
    [sym_false] = ACTIONS(371),
    [sym_null] = ACTIONS(371),
    [sym_undefined] = ACTIONS(371),
    [anon_sym_AT] = ACTIONS(85),
    [anon_sym_static] = ACTIONS(323),
    [anon_sym_get] = ACTIONS(323),
    [anon_sym_set] = ACTIONS(323),
  },
  [148] = {
    [sym_import] = STATE(426),
    [sym_parenthesized_expression] = STATE(355),
    [sym_expression] = STATE(530),
    [sym_primary_expression] = STATE(425),
    [sym_yield_expression] = STATE(424),
    [sym_object] = STATE(426),
    [sym_object_pattern] = STATE(1333),
    [sym_array] = STATE(426),
    [sym_array_pattern] = STATE(1333),
    [sym_jsx_element] = STATE(424),
    [sym_jsx_fragment] = STATE(424),
    [sym_jsx_opening_element] = STATE(768),
    [sym_jsx_self_closing_element] = STATE(424),
    [sym_class] = STATE(426),
    [sym_function] = STATE(426),
    [sym_generator_function] = STATE(426),
    [sym_arrow_function] = STATE(426),
    [sym_call_expression] = STATE(426),
    [sym_new_expression] = STATE(424),
    [sym_await_expression] = STATE(424),
    [sym_member_expression] = STATE(355),
    [sym_subscript_expression] = STATE(355),
    [sym_assignment_expression] = STATE(424),
    [sym__augmented_assignment_lhs] = STATE(714),
    [sym_augmented_assignment_expression] = STATE(424),
    [sym__destructuring_pattern] = STATE(1333),
    [sym_ternary_expression] = STATE(424),
    [sym_binary_expression] = STATE(424),
    [sym_unary_expression] = STATE(424),
    [sym_update_expression] = STATE(424),
    [sym_string] = STATE(426),
    [sym_template_string] = STATE(426),
    [sym_regex] = STATE(426),
    [sym_meta_property] = STATE(426),
    [sym_decorator] = STATE(750),
    [sym_formal_parameters] = STATE(1322),
    [aux_sym_export_statement_repeat1] = STATE(924),
    [sym_identifier] = ACTIONS(321),
    [anon_sym_export] = ACTIONS(323),
    [anon_sym_LBRACE] = ACTIONS(327),
    [anon_sym_import] = ACTIONS(331),
    [anon_sym_LPAREN] = ACTIONS(333),
    [anon_sym_await] = ACTIONS(335),
    [anon_sym_yield] = ACTIONS(339),
    [anon_sym_LBRACK] = ACTIONS(341),
    [anon_sym_LT] = ACTIONS(537),
    [anon_sym_SLASH] = ACTIONS(345),
    [anon_sym_class] = ACTIONS(347),
    [anon_sym_async] = ACTIONS(349),
    [anon_sym_function] = ACTIONS(351),
    [anon_sym_new] = ACTIONS(353),
    [anon_sym_PLUS] = ACTIONS(355),
    [anon_sym_DASH] = ACTIONS(355),
    [anon_sym_BANG] = ACTIONS(357),
    [anon_sym_TILDE] = ACTIONS(357),
    [anon_sym_typeof] = ACTIONS(359),
    [anon_sym_void] = ACTIONS(359),
    [anon_sym_delete] = ACTIONS(359),
    [anon_sym_PLUS_PLUS] = ACTIONS(361),
    [anon_sym_DASH_DASH] = ACTIONS(361),
    [anon_sym_DQUOTE] = ACTIONS(363),
    [anon_sym_SQUOTE] = ACTIONS(365),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(367),
    [sym_number] = ACTIONS(369),
    [sym_this] = ACTIONS(371),
    [sym_super] = ACTIONS(371),
    [sym_true] = ACTIONS(371),
    [sym_false] = ACTIONS(371),
    [sym_null] = ACTIONS(371),
    [sym_undefined] = ACTIONS(371),
    [anon_sym_AT] = ACTIONS(85),
    [anon_sym_static] = ACTIONS(323),
    [anon_sym_get] = ACTIONS(323),
    [anon_sym_set] = ACTIONS(323),
  },
  [149] = {
    [sym_import] = STATE(426),
    [sym_parenthesized_expression] = STATE(355),
    [sym_expression] = STATE(387),
    [sym_primary_expression] = STATE(425),
    [sym_yield_expression] = STATE(424),
    [sym_object] = STATE(426),
    [sym_object_pattern] = STATE(1333),
    [sym_array] = STATE(426),
    [sym_array_pattern] = STATE(1333),
    [sym_jsx_element] = STATE(424),
    [sym_jsx_fragment] = STATE(424),
    [sym_jsx_opening_element] = STATE(768),
    [sym_jsx_self_closing_element] = STATE(424),
    [sym_class] = STATE(426),
    [sym_function] = STATE(426),
    [sym_generator_function] = STATE(426),
    [sym_arrow_function] = STATE(426),
    [sym_call_expression] = STATE(426),
    [sym_new_expression] = STATE(424),
    [sym_await_expression] = STATE(424),
    [sym_member_expression] = STATE(355),
    [sym_subscript_expression] = STATE(355),
    [sym_assignment_expression] = STATE(424),
    [sym__augmented_assignment_lhs] = STATE(714),
    [sym_augmented_assignment_expression] = STATE(424),
    [sym__destructuring_pattern] = STATE(1333),
    [sym_ternary_expression] = STATE(424),
    [sym_binary_expression] = STATE(424),
    [sym_unary_expression] = STATE(424),
    [sym_update_expression] = STATE(424),
    [sym_string] = STATE(426),
    [sym_template_string] = STATE(426),
    [sym_regex] = STATE(426),
    [sym_meta_property] = STATE(426),
    [sym_decorator] = STATE(750),
    [sym_formal_parameters] = STATE(1322),
    [aux_sym_export_statement_repeat1] = STATE(924),
    [sym_identifier] = ACTIONS(321),
    [anon_sym_export] = ACTIONS(323),
    [anon_sym_LBRACE] = ACTIONS(327),
    [anon_sym_import] = ACTIONS(331),
    [anon_sym_LPAREN] = ACTIONS(333),
    [anon_sym_await] = ACTIONS(335),
    [anon_sym_yield] = ACTIONS(339),
    [anon_sym_LBRACK] = ACTIONS(341),
    [anon_sym_LT] = ACTIONS(537),
    [anon_sym_SLASH] = ACTIONS(345),
    [anon_sym_class] = ACTIONS(347),
    [anon_sym_async] = ACTIONS(349),
    [anon_sym_function] = ACTIONS(351),
    [anon_sym_new] = ACTIONS(353),
    [anon_sym_PLUS] = ACTIONS(355),
    [anon_sym_DASH] = ACTIONS(355),
    [anon_sym_BANG] = ACTIONS(357),
    [anon_sym_TILDE] = ACTIONS(357),
    [anon_sym_typeof] = ACTIONS(359),
    [anon_sym_void] = ACTIONS(359),
    [anon_sym_delete] = ACTIONS(359),
    [anon_sym_PLUS_PLUS] = ACTIONS(361),
    [anon_sym_DASH_DASH] = ACTIONS(361),
    [anon_sym_DQUOTE] = ACTIONS(363),
    [anon_sym_SQUOTE] = ACTIONS(365),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(367),
    [sym_number] = ACTIONS(369),
    [sym_this] = ACTIONS(371),
    [sym_super] = ACTIONS(371),
    [sym_true] = ACTIONS(371),
    [sym_false] = ACTIONS(371),
    [sym_null] = ACTIONS(371),
    [sym_undefined] = ACTIONS(371),
    [anon_sym_AT] = ACTIONS(85),
    [anon_sym_static] = ACTIONS(323),
    [anon_sym_get] = ACTIONS(323),
    [anon_sym_set] = ACTIONS(323),
  },
  [150] = {
    [sym_import] = STATE(426),
    [sym_parenthesized_expression] = STATE(340),
    [sym_expression] = STATE(597),
    [sym_primary_expression] = STATE(425),
    [sym_yield_expression] = STATE(424),
    [sym_object] = STATE(426),
    [sym_object_pattern] = STATE(1317),
    [sym_array] = STATE(426),
    [sym_array_pattern] = STATE(1317),
    [sym_jsx_element] = STATE(424),
    [sym_jsx_fragment] = STATE(424),
    [sym_jsx_opening_element] = STATE(768),
    [sym_jsx_self_closing_element] = STATE(424),
    [sym_class] = STATE(426),
    [sym_function] = STATE(426),
    [sym_generator_function] = STATE(426),
    [sym_arrow_function] = STATE(426),
    [sym_call_expression] = STATE(426),
    [sym_new_expression] = STATE(424),
    [sym_await_expression] = STATE(424),
    [sym_member_expression] = STATE(340),
    [sym_subscript_expression] = STATE(340),
    [sym_assignment_expression] = STATE(424),
    [sym__augmented_assignment_lhs] = STATE(712),
    [sym_augmented_assignment_expression] = STATE(424),
    [sym__destructuring_pattern] = STATE(1317),
    [sym_ternary_expression] = STATE(424),
    [sym_binary_expression] = STATE(424),
    [sym_unary_expression] = STATE(424),
    [sym_update_expression] = STATE(424),
    [sym_string] = STATE(426),
    [sym_template_string] = STATE(426),
    [sym_regex] = STATE(426),
    [sym_meta_property] = STATE(426),
    [sym_decorator] = STATE(750),
    [sym_formal_parameters] = STATE(1267),
    [aux_sym_export_statement_repeat1] = STATE(924),
    [sym_identifier] = ACTIONS(391),
    [anon_sym_export] = ACTIONS(393),
    [anon_sym_LBRACE] = ACTIONS(397),
    [anon_sym_import] = ACTIONS(331),
    [anon_sym_LPAREN] = ACTIONS(333),
    [anon_sym_await] = ACTIONS(399),
    [anon_sym_yield] = ACTIONS(401),
    [anon_sym_LBRACK] = ACTIONS(403),
    [anon_sym_LT] = ACTIONS(537),
    [anon_sym_SLASH] = ACTIONS(345),
    [anon_sym_class] = ACTIONS(347),
    [anon_sym_async] = ACTIONS(405),
    [anon_sym_function] = ACTIONS(351),
    [anon_sym_new] = ACTIONS(407),
    [anon_sym_PLUS] = ACTIONS(409),
    [anon_sym_DASH] = ACTIONS(409),
    [anon_sym_BANG] = ACTIONS(411),
    [anon_sym_TILDE] = ACTIONS(411),
    [anon_sym_typeof] = ACTIONS(413),
    [anon_sym_void] = ACTIONS(413),
    [anon_sym_delete] = ACTIONS(413),
    [anon_sym_PLUS_PLUS] = ACTIONS(415),
    [anon_sym_DASH_DASH] = ACTIONS(415),
    [anon_sym_DQUOTE] = ACTIONS(363),
    [anon_sym_SQUOTE] = ACTIONS(365),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(367),
    [sym_number] = ACTIONS(369),
    [sym_this] = ACTIONS(371),
    [sym_super] = ACTIONS(371),
    [sym_true] = ACTIONS(371),
    [sym_false] = ACTIONS(371),
    [sym_null] = ACTIONS(371),
    [sym_undefined] = ACTIONS(371),
    [anon_sym_AT] = ACTIONS(85),
    [anon_sym_static] = ACTIONS(393),
    [anon_sym_get] = ACTIONS(393),
    [anon_sym_set] = ACTIONS(393),
  },
  [151] = {
    [sym_import] = STATE(426),
    [sym_parenthesized_expression] = STATE(355),
    [sym_expression] = STATE(563),
    [sym_primary_expression] = STATE(425),
    [sym_yield_expression] = STATE(424),
    [sym_object] = STATE(426),
    [sym_object_pattern] = STATE(1333),
    [sym_array] = STATE(426),
    [sym_array_pattern] = STATE(1333),
    [sym_jsx_element] = STATE(424),
    [sym_jsx_fragment] = STATE(424),
    [sym_jsx_opening_element] = STATE(768),
    [sym_jsx_self_closing_element] = STATE(424),
    [sym_class] = STATE(426),
    [sym_function] = STATE(426),
    [sym_generator_function] = STATE(426),
    [sym_arrow_function] = STATE(426),
    [sym_call_expression] = STATE(426),
    [sym_new_expression] = STATE(424),
    [sym_await_expression] = STATE(424),
    [sym_member_expression] = STATE(355),
    [sym_subscript_expression] = STATE(355),
    [sym_assignment_expression] = STATE(424),
    [sym__augmented_assignment_lhs] = STATE(714),
    [sym_augmented_assignment_expression] = STATE(424),
    [sym__destructuring_pattern] = STATE(1333),
    [sym_ternary_expression] = STATE(424),
    [sym_binary_expression] = STATE(424),
    [sym_unary_expression] = STATE(424),
    [sym_update_expression] = STATE(424),
    [sym_string] = STATE(426),
    [sym_template_string] = STATE(426),
    [sym_regex] = STATE(426),
    [sym_meta_property] = STATE(426),
    [sym_decorator] = STATE(750),
    [sym_formal_parameters] = STATE(1322),
    [aux_sym_export_statement_repeat1] = STATE(924),
    [sym_identifier] = ACTIONS(321),
    [anon_sym_export] = ACTIONS(323),
    [anon_sym_LBRACE] = ACTIONS(327),
    [anon_sym_import] = ACTIONS(331),
    [anon_sym_LPAREN] = ACTIONS(333),
    [anon_sym_await] = ACTIONS(335),
    [anon_sym_yield] = ACTIONS(339),
    [anon_sym_LBRACK] = ACTIONS(341),
    [anon_sym_LT] = ACTIONS(537),
    [anon_sym_SLASH] = ACTIONS(345),
    [anon_sym_class] = ACTIONS(347),
    [anon_sym_async] = ACTIONS(349),
    [anon_sym_function] = ACTIONS(351),
    [anon_sym_new] = ACTIONS(353),
    [anon_sym_PLUS] = ACTIONS(355),
    [anon_sym_DASH] = ACTIONS(355),
    [anon_sym_BANG] = ACTIONS(357),
    [anon_sym_TILDE] = ACTIONS(357),
    [anon_sym_typeof] = ACTIONS(359),
    [anon_sym_void] = ACTIONS(359),
    [anon_sym_delete] = ACTIONS(359),
    [anon_sym_PLUS_PLUS] = ACTIONS(361),
    [anon_sym_DASH_DASH] = ACTIONS(361),
    [anon_sym_DQUOTE] = ACTIONS(363),
    [anon_sym_SQUOTE] = ACTIONS(365),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(367),
    [sym_number] = ACTIONS(369),
    [sym_this] = ACTIONS(371),
    [sym_super] = ACTIONS(371),
    [sym_true] = ACTIONS(371),
    [sym_false] = ACTIONS(371),
    [sym_null] = ACTIONS(371),
    [sym_undefined] = ACTIONS(371),
    [anon_sym_AT] = ACTIONS(85),
    [anon_sym_static] = ACTIONS(323),
    [anon_sym_get] = ACTIONS(323),
    [anon_sym_set] = ACTIONS(323),
  },
  [152] = {
    [sym_import] = STATE(426),
    [sym_parenthesized_expression] = STATE(340),
    [sym_expression] = STATE(541),
    [sym_primary_expression] = STATE(425),
    [sym_yield_expression] = STATE(424),
    [sym_object] = STATE(426),
    [sym_object_pattern] = STATE(1317),
    [sym_array] = STATE(426),
    [sym_array_pattern] = STATE(1317),
    [sym_jsx_element] = STATE(424),
    [sym_jsx_fragment] = STATE(424),
    [sym_jsx_opening_element] = STATE(768),
    [sym_jsx_self_closing_element] = STATE(424),
    [sym_class] = STATE(426),
    [sym_function] = STATE(426),
    [sym_generator_function] = STATE(426),
    [sym_arrow_function] = STATE(426),
    [sym_call_expression] = STATE(426),
    [sym_new_expression] = STATE(424),
    [sym_await_expression] = STATE(424),
    [sym_member_expression] = STATE(340),
    [sym_subscript_expression] = STATE(340),
    [sym_assignment_expression] = STATE(424),
    [sym__augmented_assignment_lhs] = STATE(712),
    [sym_augmented_assignment_expression] = STATE(424),
    [sym__destructuring_pattern] = STATE(1317),
    [sym_ternary_expression] = STATE(424),
    [sym_binary_expression] = STATE(424),
    [sym_unary_expression] = STATE(424),
    [sym_update_expression] = STATE(424),
    [sym_string] = STATE(426),
    [sym_template_string] = STATE(426),
    [sym_regex] = STATE(426),
    [sym_meta_property] = STATE(426),
    [sym_decorator] = STATE(750),
    [sym_formal_parameters] = STATE(1267),
    [aux_sym_export_statement_repeat1] = STATE(924),
    [sym_identifier] = ACTIONS(391),
    [anon_sym_export] = ACTIONS(393),
    [anon_sym_LBRACE] = ACTIONS(397),
    [anon_sym_import] = ACTIONS(331),
    [anon_sym_LPAREN] = ACTIONS(333),
    [anon_sym_await] = ACTIONS(399),
    [anon_sym_yield] = ACTIONS(401),
    [anon_sym_LBRACK] = ACTIONS(403),
    [anon_sym_LT] = ACTIONS(537),
    [anon_sym_SLASH] = ACTIONS(345),
    [anon_sym_class] = ACTIONS(347),
    [anon_sym_async] = ACTIONS(405),
    [anon_sym_function] = ACTIONS(351),
    [anon_sym_new] = ACTIONS(407),
    [anon_sym_PLUS] = ACTIONS(409),
    [anon_sym_DASH] = ACTIONS(409),
    [anon_sym_BANG] = ACTIONS(411),
    [anon_sym_TILDE] = ACTIONS(411),
    [anon_sym_typeof] = ACTIONS(413),
    [anon_sym_void] = ACTIONS(413),
    [anon_sym_delete] = ACTIONS(413),
    [anon_sym_PLUS_PLUS] = ACTIONS(415),
    [anon_sym_DASH_DASH] = ACTIONS(415),
    [anon_sym_DQUOTE] = ACTIONS(363),
    [anon_sym_SQUOTE] = ACTIONS(365),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(367),
    [sym_number] = ACTIONS(369),
    [sym_this] = ACTIONS(371),
    [sym_super] = ACTIONS(371),
    [sym_true] = ACTIONS(371),
    [sym_false] = ACTIONS(371),
    [sym_null] = ACTIONS(371),
    [sym_undefined] = ACTIONS(371),
    [anon_sym_AT] = ACTIONS(85),
    [anon_sym_static] = ACTIONS(393),
    [anon_sym_get] = ACTIONS(393),
    [anon_sym_set] = ACTIONS(393),
  },
  [153] = {
    [sym_import] = STATE(539),
    [sym_parenthesized_expression] = STATE(362),
    [sym_expression] = STATE(457),
    [sym_primary_expression] = STATE(546),
    [sym_yield_expression] = STATE(550),
    [sym_object] = STATE(539),
    [sym_object_pattern] = STATE(1320),
    [sym_array] = STATE(539),
    [sym_array_pattern] = STATE(1320),
    [sym_jsx_element] = STATE(550),
    [sym_jsx_fragment] = STATE(550),
    [sym_jsx_opening_element] = STATE(772),
    [sym_jsx_self_closing_element] = STATE(550),
    [sym_class] = STATE(539),
    [sym_function] = STATE(539),
    [sym_generator_function] = STATE(539),
    [sym_arrow_function] = STATE(539),
    [sym_call_expression] = STATE(539),
    [sym_new_expression] = STATE(550),
    [sym_await_expression] = STATE(550),
    [sym_member_expression] = STATE(362),
    [sym_subscript_expression] = STATE(362),
    [sym_assignment_expression] = STATE(550),
    [sym__augmented_assignment_lhs] = STATE(720),
    [sym_augmented_assignment_expression] = STATE(550),
    [sym__destructuring_pattern] = STATE(1320),
    [sym_ternary_expression] = STATE(550),
    [sym_binary_expression] = STATE(550),
    [sym_unary_expression] = STATE(550),
    [sym_update_expression] = STATE(550),
    [sym_string] = STATE(539),
    [sym_template_string] = STATE(539),
    [sym_regex] = STATE(539),
    [sym_meta_property] = STATE(539),
    [sym_decorator] = STATE(750),
    [sym_formal_parameters] = STATE(1318),
    [aux_sym_export_statement_repeat1] = STATE(925),
    [sym_identifier] = ACTIONS(373),
    [anon_sym_export] = ACTIONS(375),
    [anon_sym_LBRACE] = ACTIONS(379),
    [anon_sym_import] = ACTIONS(381),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(29),
    [anon_sym_yield] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(53),
    [anon_sym_LT] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(385),
    [anon_sym_async] = ACTIONS(387),
    [anon_sym_function] = ACTIONS(389),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_typeof] = ACTIONS(71),
    [anon_sym_void] = ACTIONS(71),
    [anon_sym_delete] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DQUOTE] = ACTIONS(75),
    [anon_sym_SQUOTE] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(79),
    [sym_number] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(83),
    [sym_true] = ACTIONS(83),
    [sym_false] = ACTIONS(83),
    [sym_null] = ACTIONS(83),
    [sym_undefined] = ACTIONS(83),
    [anon_sym_AT] = ACTIONS(85),
    [anon_sym_static] = ACTIONS(375),
    [anon_sym_get] = ACTIONS(375),
    [anon_sym_set] = ACTIONS(375),
  },
  [154] = {
    [sym_import] = STATE(426),
    [sym_parenthesized_expression] = STATE(355),
    [sym_expression] = STATE(561),
    [sym_primary_expression] = STATE(425),
    [sym_yield_expression] = STATE(424),
    [sym_object] = STATE(426),
    [sym_object_pattern] = STATE(1333),
    [sym_array] = STATE(426),
    [sym_array_pattern] = STATE(1333),
    [sym_jsx_element] = STATE(424),
    [sym_jsx_fragment] = STATE(424),
    [sym_jsx_opening_element] = STATE(768),
    [sym_jsx_self_closing_element] = STATE(424),
    [sym_class] = STATE(426),
    [sym_function] = STATE(426),
    [sym_generator_function] = STATE(426),
    [sym_arrow_function] = STATE(426),
    [sym_call_expression] = STATE(426),
    [sym_new_expression] = STATE(424),
    [sym_await_expression] = STATE(424),
    [sym_member_expression] = STATE(355),
    [sym_subscript_expression] = STATE(355),
    [sym_assignment_expression] = STATE(424),
    [sym__augmented_assignment_lhs] = STATE(714),
    [sym_augmented_assignment_expression] = STATE(424),
    [sym__destructuring_pattern] = STATE(1333),
    [sym_ternary_expression] = STATE(424),
    [sym_binary_expression] = STATE(424),
    [sym_unary_expression] = STATE(424),
    [sym_update_expression] = STATE(424),
    [sym_string] = STATE(426),
    [sym_template_string] = STATE(426),
    [sym_regex] = STATE(426),
    [sym_meta_property] = STATE(426),
    [sym_decorator] = STATE(750),
    [sym_formal_parameters] = STATE(1322),
    [aux_sym_export_statement_repeat1] = STATE(924),
    [sym_identifier] = ACTIONS(321),
    [anon_sym_export] = ACTIONS(323),
    [anon_sym_LBRACE] = ACTIONS(327),
    [anon_sym_import] = ACTIONS(331),
    [anon_sym_LPAREN] = ACTIONS(333),
    [anon_sym_await] = ACTIONS(335),
    [anon_sym_yield] = ACTIONS(339),
    [anon_sym_LBRACK] = ACTIONS(341),
    [anon_sym_LT] = ACTIONS(537),
    [anon_sym_SLASH] = ACTIONS(345),
    [anon_sym_class] = ACTIONS(347),
    [anon_sym_async] = ACTIONS(349),
    [anon_sym_function] = ACTIONS(351),
    [anon_sym_new] = ACTIONS(353),
    [anon_sym_PLUS] = ACTIONS(355),
    [anon_sym_DASH] = ACTIONS(355),
    [anon_sym_BANG] = ACTIONS(357),
    [anon_sym_TILDE] = ACTIONS(357),
    [anon_sym_typeof] = ACTIONS(359),
    [anon_sym_void] = ACTIONS(359),
    [anon_sym_delete] = ACTIONS(359),
    [anon_sym_PLUS_PLUS] = ACTIONS(361),
    [anon_sym_DASH_DASH] = ACTIONS(361),
    [anon_sym_DQUOTE] = ACTIONS(363),
    [anon_sym_SQUOTE] = ACTIONS(365),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(367),
    [sym_number] = ACTIONS(369),
    [sym_this] = ACTIONS(371),
    [sym_super] = ACTIONS(371),
    [sym_true] = ACTIONS(371),
    [sym_false] = ACTIONS(371),
    [sym_null] = ACTIONS(371),
    [sym_undefined] = ACTIONS(371),
    [anon_sym_AT] = ACTIONS(85),
    [anon_sym_static] = ACTIONS(323),
    [anon_sym_get] = ACTIONS(323),
    [anon_sym_set] = ACTIONS(323),
  },
  [155] = {
    [sym_import] = STATE(426),
    [sym_parenthesized_expression] = STATE(355),
    [sym_expression] = STATE(498),
    [sym_primary_expression] = STATE(425),
    [sym_yield_expression] = STATE(424),
    [sym_object] = STATE(426),
    [sym_object_pattern] = STATE(992),
    [sym_array] = STATE(426),
    [sym_array_pattern] = STATE(992),
    [sym_jsx_element] = STATE(424),
    [sym_jsx_fragment] = STATE(424),
    [sym_jsx_opening_element] = STATE(768),
    [sym_jsx_self_closing_element] = STATE(424),
    [sym_class] = STATE(426),
    [sym_function] = STATE(426),
    [sym_generator_function] = STATE(426),
    [sym_arrow_function] = STATE(426),
    [sym_call_expression] = STATE(426),
    [sym_new_expression] = STATE(424),
    [sym_await_expression] = STATE(424),
    [sym_member_expression] = STATE(355),
    [sym_subscript_expression] = STATE(355),
    [sym_assignment_expression] = STATE(424),
    [sym__augmented_assignment_lhs] = STATE(714),
    [sym_augmented_assignment_expression] = STATE(424),
    [sym__destructuring_pattern] = STATE(992),
    [sym_ternary_expression] = STATE(424),
    [sym_binary_expression] = STATE(424),
    [sym_unary_expression] = STATE(424),
    [sym_update_expression] = STATE(424),
    [sym_string] = STATE(426),
    [sym_template_string] = STATE(426),
    [sym_regex] = STATE(426),
    [sym_meta_property] = STATE(426),
    [sym_decorator] = STATE(750),
    [sym_formal_parameters] = STATE(1322),
    [aux_sym_export_statement_repeat1] = STATE(924),
    [sym_identifier] = ACTIONS(688),
    [anon_sym_export] = ACTIONS(323),
    [anon_sym_LBRACE] = ACTIONS(397),
    [anon_sym_import] = ACTIONS(331),
    [anon_sym_LPAREN] = ACTIONS(333),
    [anon_sym_await] = ACTIONS(335),
    [anon_sym_yield] = ACTIONS(339),
    [anon_sym_LBRACK] = ACTIONS(403),
    [anon_sym_LT] = ACTIONS(537),
    [anon_sym_SLASH] = ACTIONS(345),
    [anon_sym_class] = ACTIONS(347),
    [anon_sym_async] = ACTIONS(349),
    [anon_sym_function] = ACTIONS(351),
    [anon_sym_new] = ACTIONS(353),
    [anon_sym_PLUS] = ACTIONS(355),
    [anon_sym_DASH] = ACTIONS(355),
    [anon_sym_BANG] = ACTIONS(357),
    [anon_sym_TILDE] = ACTIONS(357),
    [anon_sym_typeof] = ACTIONS(359),
    [anon_sym_void] = ACTIONS(359),
    [anon_sym_delete] = ACTIONS(359),
    [anon_sym_PLUS_PLUS] = ACTIONS(361),
    [anon_sym_DASH_DASH] = ACTIONS(361),
    [anon_sym_DQUOTE] = ACTIONS(363),
    [anon_sym_SQUOTE] = ACTIONS(365),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(367),
    [sym_number] = ACTIONS(369),
    [sym_this] = ACTIONS(371),
    [sym_super] = ACTIONS(371),
    [sym_true] = ACTIONS(371),
    [sym_false] = ACTIONS(371),
    [sym_null] = ACTIONS(371),
    [sym_undefined] = ACTIONS(371),
    [anon_sym_AT] = ACTIONS(85),
    [anon_sym_static] = ACTIONS(323),
    [anon_sym_get] = ACTIONS(323),
    [anon_sym_set] = ACTIONS(323),
  },
  [156] = {
    [sym_import] = STATE(426),
    [sym_parenthesized_expression] = STATE(340),
    [sym_expression] = STATE(616),
    [sym_primary_expression] = STATE(425),
    [sym_yield_expression] = STATE(424),
    [sym_object] = STATE(426),
    [sym_object_pattern] = STATE(1317),
    [sym_array] = STATE(426),
    [sym_array_pattern] = STATE(1317),
    [sym_jsx_element] = STATE(424),
    [sym_jsx_fragment] = STATE(424),
    [sym_jsx_opening_element] = STATE(768),
    [sym_jsx_self_closing_element] = STATE(424),
    [sym_class] = STATE(426),
    [sym_function] = STATE(426),
    [sym_generator_function] = STATE(426),
    [sym_arrow_function] = STATE(426),
    [sym_call_expression] = STATE(426),
    [sym_new_expression] = STATE(424),
    [sym_await_expression] = STATE(424),
    [sym_member_expression] = STATE(340),
    [sym_subscript_expression] = STATE(340),
    [sym_assignment_expression] = STATE(424),
    [sym__augmented_assignment_lhs] = STATE(712),
    [sym_augmented_assignment_expression] = STATE(424),
    [sym__destructuring_pattern] = STATE(1317),
    [sym_ternary_expression] = STATE(424),
    [sym_binary_expression] = STATE(424),
    [sym_unary_expression] = STATE(424),
    [sym_update_expression] = STATE(424),
    [sym_string] = STATE(426),
    [sym_template_string] = STATE(426),
    [sym_regex] = STATE(426),
    [sym_meta_property] = STATE(426),
    [sym_decorator] = STATE(750),
    [sym_formal_parameters] = STATE(1267),
    [aux_sym_export_statement_repeat1] = STATE(924),
    [sym_identifier] = ACTIONS(391),
    [anon_sym_export] = ACTIONS(393),
    [anon_sym_LBRACE] = ACTIONS(397),
    [anon_sym_import] = ACTIONS(331),
    [anon_sym_LPAREN] = ACTIONS(333),
    [anon_sym_await] = ACTIONS(399),
    [anon_sym_yield] = ACTIONS(401),
    [anon_sym_LBRACK] = ACTIONS(403),
    [anon_sym_LT] = ACTIONS(537),
    [anon_sym_SLASH] = ACTIONS(345),
    [anon_sym_class] = ACTIONS(347),
    [anon_sym_async] = ACTIONS(405),
    [anon_sym_function] = ACTIONS(351),
    [anon_sym_new] = ACTIONS(407),
    [anon_sym_PLUS] = ACTIONS(409),
    [anon_sym_DASH] = ACTIONS(409),
    [anon_sym_BANG] = ACTIONS(411),
    [anon_sym_TILDE] = ACTIONS(411),
    [anon_sym_typeof] = ACTIONS(413),
    [anon_sym_void] = ACTIONS(413),
    [anon_sym_delete] = ACTIONS(413),
    [anon_sym_PLUS_PLUS] = ACTIONS(415),
    [anon_sym_DASH_DASH] = ACTIONS(415),
    [anon_sym_DQUOTE] = ACTIONS(363),
    [anon_sym_SQUOTE] = ACTIONS(365),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(367),
    [sym_number] = ACTIONS(369),
    [sym_this] = ACTIONS(371),
    [sym_super] = ACTIONS(371),
    [sym_true] = ACTIONS(371),
    [sym_false] = ACTIONS(371),
    [sym_null] = ACTIONS(371),
    [sym_undefined] = ACTIONS(371),
    [anon_sym_AT] = ACTIONS(85),
    [anon_sym_static] = ACTIONS(393),
    [anon_sym_get] = ACTIONS(393),
    [anon_sym_set] = ACTIONS(393),
  },
  [157] = {
    [sym_import] = STATE(426),
    [sym_parenthesized_expression] = STATE(340),
    [sym_expression] = STATE(573),
    [sym_primary_expression] = STATE(425),
    [sym_yield_expression] = STATE(424),
    [sym_object] = STATE(426),
    [sym_object_pattern] = STATE(1317),
    [sym_array] = STATE(426),
    [sym_array_pattern] = STATE(1317),
    [sym_jsx_element] = STATE(424),
    [sym_jsx_fragment] = STATE(424),
    [sym_jsx_opening_element] = STATE(768),
    [sym_jsx_self_closing_element] = STATE(424),
    [sym_class] = STATE(426),
    [sym_function] = STATE(426),
    [sym_generator_function] = STATE(426),
    [sym_arrow_function] = STATE(426),
    [sym_call_expression] = STATE(426),
    [sym_new_expression] = STATE(424),
    [sym_await_expression] = STATE(424),
    [sym_member_expression] = STATE(340),
    [sym_subscript_expression] = STATE(340),
    [sym_assignment_expression] = STATE(424),
    [sym__augmented_assignment_lhs] = STATE(712),
    [sym_augmented_assignment_expression] = STATE(424),
    [sym__destructuring_pattern] = STATE(1317),
    [sym_ternary_expression] = STATE(424),
    [sym_binary_expression] = STATE(424),
    [sym_unary_expression] = STATE(424),
    [sym_update_expression] = STATE(424),
    [sym_string] = STATE(426),
    [sym_template_string] = STATE(426),
    [sym_regex] = STATE(426),
    [sym_meta_property] = STATE(426),
    [sym_decorator] = STATE(750),
    [sym_formal_parameters] = STATE(1267),
    [aux_sym_export_statement_repeat1] = STATE(924),
    [sym_identifier] = ACTIONS(391),
    [anon_sym_export] = ACTIONS(393),
    [anon_sym_LBRACE] = ACTIONS(397),
    [anon_sym_import] = ACTIONS(331),
    [anon_sym_LPAREN] = ACTIONS(333),
    [anon_sym_await] = ACTIONS(399),
    [anon_sym_yield] = ACTIONS(401),
    [anon_sym_LBRACK] = ACTIONS(403),
    [anon_sym_LT] = ACTIONS(537),
    [anon_sym_SLASH] = ACTIONS(345),
    [anon_sym_class] = ACTIONS(347),
    [anon_sym_async] = ACTIONS(405),
    [anon_sym_function] = ACTIONS(351),
    [anon_sym_new] = ACTIONS(407),
    [anon_sym_PLUS] = ACTIONS(409),
    [anon_sym_DASH] = ACTIONS(409),
    [anon_sym_BANG] = ACTIONS(411),
    [anon_sym_TILDE] = ACTIONS(411),
    [anon_sym_typeof] = ACTIONS(413),
    [anon_sym_void] = ACTIONS(413),
    [anon_sym_delete] = ACTIONS(413),
    [anon_sym_PLUS_PLUS] = ACTIONS(415),
    [anon_sym_DASH_DASH] = ACTIONS(415),
    [anon_sym_DQUOTE] = ACTIONS(363),
    [anon_sym_SQUOTE] = ACTIONS(365),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(367),
    [sym_number] = ACTIONS(369),
    [sym_this] = ACTIONS(371),
    [sym_super] = ACTIONS(371),
    [sym_true] = ACTIONS(371),
    [sym_false] = ACTIONS(371),
    [sym_null] = ACTIONS(371),
    [sym_undefined] = ACTIONS(371),
    [anon_sym_AT] = ACTIONS(85),
    [anon_sym_static] = ACTIONS(393),
    [anon_sym_get] = ACTIONS(393),
    [anon_sym_set] = ACTIONS(393),
  },
  [158] = {
    [sym_import] = STATE(426),
    [sym_parenthesized_expression] = STATE(340),
    [sym_expression] = STATE(543),
    [sym_primary_expression] = STATE(425),
    [sym_yield_expression] = STATE(424),
    [sym_object] = STATE(426),
    [sym_object_pattern] = STATE(1317),
    [sym_array] = STATE(426),
    [sym_array_pattern] = STATE(1317),
    [sym_jsx_element] = STATE(424),
    [sym_jsx_fragment] = STATE(424),
    [sym_jsx_opening_element] = STATE(768),
    [sym_jsx_self_closing_element] = STATE(424),
    [sym_class] = STATE(426),
    [sym_function] = STATE(426),
    [sym_generator_function] = STATE(426),
    [sym_arrow_function] = STATE(426),
    [sym_call_expression] = STATE(426),
    [sym_new_expression] = STATE(424),
    [sym_await_expression] = STATE(424),
    [sym_member_expression] = STATE(340),
    [sym_subscript_expression] = STATE(340),
    [sym_assignment_expression] = STATE(424),
    [sym__augmented_assignment_lhs] = STATE(712),
    [sym_augmented_assignment_expression] = STATE(424),
    [sym__destructuring_pattern] = STATE(1317),
    [sym_ternary_expression] = STATE(424),
    [sym_binary_expression] = STATE(424),
    [sym_unary_expression] = STATE(424),
    [sym_update_expression] = STATE(424),
    [sym_string] = STATE(426),
    [sym_template_string] = STATE(426),
    [sym_regex] = STATE(426),
    [sym_meta_property] = STATE(426),
    [sym_decorator] = STATE(750),
    [sym_formal_parameters] = STATE(1267),
    [aux_sym_export_statement_repeat1] = STATE(924),
    [sym_identifier] = ACTIONS(391),
    [anon_sym_export] = ACTIONS(393),
    [anon_sym_LBRACE] = ACTIONS(397),
    [anon_sym_import] = ACTIONS(331),
    [anon_sym_LPAREN] = ACTIONS(333),
    [anon_sym_await] = ACTIONS(399),
    [anon_sym_yield] = ACTIONS(401),
    [anon_sym_LBRACK] = ACTIONS(403),
    [anon_sym_LT] = ACTIONS(537),
    [anon_sym_SLASH] = ACTIONS(345),
    [anon_sym_class] = ACTIONS(347),
    [anon_sym_async] = ACTIONS(405),
    [anon_sym_function] = ACTIONS(351),
    [anon_sym_new] = ACTIONS(407),
    [anon_sym_PLUS] = ACTIONS(409),
    [anon_sym_DASH] = ACTIONS(409),
    [anon_sym_BANG] = ACTIONS(411),
    [anon_sym_TILDE] = ACTIONS(411),
    [anon_sym_typeof] = ACTIONS(413),
    [anon_sym_void] = ACTIONS(413),
    [anon_sym_delete] = ACTIONS(413),
    [anon_sym_PLUS_PLUS] = ACTIONS(415),
    [anon_sym_DASH_DASH] = ACTIONS(415),
    [anon_sym_DQUOTE] = ACTIONS(363),
    [anon_sym_SQUOTE] = ACTIONS(365),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(367),
    [sym_number] = ACTIONS(369),
    [sym_this] = ACTIONS(371),
    [sym_super] = ACTIONS(371),
    [sym_true] = ACTIONS(371),
    [sym_false] = ACTIONS(371),
    [sym_null] = ACTIONS(371),
    [sym_undefined] = ACTIONS(371),
    [anon_sym_AT] = ACTIONS(85),
    [anon_sym_static] = ACTIONS(393),
    [anon_sym_get] = ACTIONS(393),
    [anon_sym_set] = ACTIONS(393),
  },
  [159] = {
    [sym_import] = STATE(426),
    [sym_parenthesized_expression] = STATE(340),
    [sym_expression] = STATE(631),
    [sym_primary_expression] = STATE(425),
    [sym_yield_expression] = STATE(424),
    [sym_object] = STATE(426),
    [sym_object_pattern] = STATE(1317),
    [sym_array] = STATE(426),
    [sym_array_pattern] = STATE(1317),
    [sym_jsx_element] = STATE(424),
    [sym_jsx_fragment] = STATE(424),
    [sym_jsx_opening_element] = STATE(768),
    [sym_jsx_self_closing_element] = STATE(424),
    [sym_class] = STATE(426),
    [sym_function] = STATE(426),
    [sym_generator_function] = STATE(426),
    [sym_arrow_function] = STATE(426),
    [sym_call_expression] = STATE(426),
    [sym_new_expression] = STATE(424),
    [sym_await_expression] = STATE(424),
    [sym_member_expression] = STATE(340),
    [sym_subscript_expression] = STATE(340),
    [sym_assignment_expression] = STATE(424),
    [sym__augmented_assignment_lhs] = STATE(712),
    [sym_augmented_assignment_expression] = STATE(424),
    [sym__destructuring_pattern] = STATE(1317),
    [sym_ternary_expression] = STATE(424),
    [sym_binary_expression] = STATE(424),
    [sym_unary_expression] = STATE(424),
    [sym_update_expression] = STATE(424),
    [sym_string] = STATE(426),
    [sym_template_string] = STATE(426),
    [sym_regex] = STATE(426),
    [sym_meta_property] = STATE(426),
    [sym_decorator] = STATE(750),
    [sym_formal_parameters] = STATE(1267),
    [aux_sym_export_statement_repeat1] = STATE(924),
    [sym_identifier] = ACTIONS(391),
    [anon_sym_export] = ACTIONS(393),
    [anon_sym_LBRACE] = ACTIONS(397),
    [anon_sym_import] = ACTIONS(331),
    [anon_sym_LPAREN] = ACTIONS(333),
    [anon_sym_await] = ACTIONS(399),
    [anon_sym_yield] = ACTIONS(401),
    [anon_sym_LBRACK] = ACTIONS(403),
    [anon_sym_LT] = ACTIONS(537),
    [anon_sym_SLASH] = ACTIONS(345),
    [anon_sym_class] = ACTIONS(347),
    [anon_sym_async] = ACTIONS(405),
    [anon_sym_function] = ACTIONS(351),
    [anon_sym_new] = ACTIONS(407),
    [anon_sym_PLUS] = ACTIONS(409),
    [anon_sym_DASH] = ACTIONS(409),
    [anon_sym_BANG] = ACTIONS(411),
    [anon_sym_TILDE] = ACTIONS(411),
    [anon_sym_typeof] = ACTIONS(413),
    [anon_sym_void] = ACTIONS(413),
    [anon_sym_delete] = ACTIONS(413),
    [anon_sym_PLUS_PLUS] = ACTIONS(415),
    [anon_sym_DASH_DASH] = ACTIONS(415),
    [anon_sym_DQUOTE] = ACTIONS(363),
    [anon_sym_SQUOTE] = ACTIONS(365),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(367),
    [sym_number] = ACTIONS(369),
    [sym_this] = ACTIONS(371),
    [sym_super] = ACTIONS(371),
    [sym_true] = ACTIONS(371),
    [sym_false] = ACTIONS(371),
    [sym_null] = ACTIONS(371),
    [sym_undefined] = ACTIONS(371),
    [anon_sym_AT] = ACTIONS(85),
    [anon_sym_static] = ACTIONS(393),
    [anon_sym_get] = ACTIONS(393),
    [anon_sym_set] = ACTIONS(393),
  },
  [160] = {
    [sym_import] = STATE(426),
    [sym_parenthesized_expression] = STATE(340),
    [sym_expression] = STATE(584),
    [sym_primary_expression] = STATE(425),
    [sym_yield_expression] = STATE(424),
    [sym_object] = STATE(426),
    [sym_object_pattern] = STATE(1317),
    [sym_array] = STATE(426),
    [sym_array_pattern] = STATE(1317),
    [sym_jsx_element] = STATE(424),
    [sym_jsx_fragment] = STATE(424),
    [sym_jsx_opening_element] = STATE(768),
    [sym_jsx_self_closing_element] = STATE(424),
    [sym_class] = STATE(426),
    [sym_function] = STATE(426),
    [sym_generator_function] = STATE(426),
    [sym_arrow_function] = STATE(426),
    [sym_call_expression] = STATE(426),
    [sym_new_expression] = STATE(424),
    [sym_await_expression] = STATE(424),
    [sym_member_expression] = STATE(340),
    [sym_subscript_expression] = STATE(340),
    [sym_assignment_expression] = STATE(424),
    [sym__augmented_assignment_lhs] = STATE(712),
    [sym_augmented_assignment_expression] = STATE(424),
    [sym__destructuring_pattern] = STATE(1317),
    [sym_ternary_expression] = STATE(424),
    [sym_binary_expression] = STATE(424),
    [sym_unary_expression] = STATE(424),
    [sym_update_expression] = STATE(424),
    [sym_string] = STATE(426),
    [sym_template_string] = STATE(426),
    [sym_regex] = STATE(426),
    [sym_meta_property] = STATE(426),
    [sym_decorator] = STATE(750),
    [sym_formal_parameters] = STATE(1267),
    [aux_sym_export_statement_repeat1] = STATE(924),
    [sym_identifier] = ACTIONS(391),
    [anon_sym_export] = ACTIONS(393),
    [anon_sym_LBRACE] = ACTIONS(397),
    [anon_sym_import] = ACTIONS(331),
    [anon_sym_LPAREN] = ACTIONS(333),
    [anon_sym_await] = ACTIONS(399),
    [anon_sym_yield] = ACTIONS(401),
    [anon_sym_LBRACK] = ACTIONS(403),
    [anon_sym_LT] = ACTIONS(537),
    [anon_sym_SLASH] = ACTIONS(345),
    [anon_sym_class] = ACTIONS(347),
    [anon_sym_async] = ACTIONS(405),
    [anon_sym_function] = ACTIONS(351),
    [anon_sym_new] = ACTIONS(407),
    [anon_sym_PLUS] = ACTIONS(409),
    [anon_sym_DASH] = ACTIONS(409),
    [anon_sym_BANG] = ACTIONS(411),
    [anon_sym_TILDE] = ACTIONS(411),
    [anon_sym_typeof] = ACTIONS(413),
    [anon_sym_void] = ACTIONS(413),
    [anon_sym_delete] = ACTIONS(413),
    [anon_sym_PLUS_PLUS] = ACTIONS(415),
    [anon_sym_DASH_DASH] = ACTIONS(415),
    [anon_sym_DQUOTE] = ACTIONS(363),
    [anon_sym_SQUOTE] = ACTIONS(365),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(367),
    [sym_number] = ACTIONS(369),
    [sym_this] = ACTIONS(371),
    [sym_super] = ACTIONS(371),
    [sym_true] = ACTIONS(371),
    [sym_false] = ACTIONS(371),
    [sym_null] = ACTIONS(371),
    [sym_undefined] = ACTIONS(371),
    [anon_sym_AT] = ACTIONS(85),
    [anon_sym_static] = ACTIONS(393),
    [anon_sym_get] = ACTIONS(393),
    [anon_sym_set] = ACTIONS(393),
  },
  [161] = {
    [sym_import] = STATE(426),
    [sym_parenthesized_expression] = STATE(340),
    [sym_expression] = STATE(536),
    [sym_primary_expression] = STATE(425),
    [sym_yield_expression] = STATE(424),
    [sym_object] = STATE(426),
    [sym_object_pattern] = STATE(1317),
    [sym_array] = STATE(426),
    [sym_array_pattern] = STATE(1317),
    [sym_jsx_element] = STATE(424),
    [sym_jsx_fragment] = STATE(424),
    [sym_jsx_opening_element] = STATE(768),
    [sym_jsx_self_closing_element] = STATE(424),
    [sym_class] = STATE(426),
    [sym_function] = STATE(426),
    [sym_generator_function] = STATE(426),
    [sym_arrow_function] = STATE(426),
    [sym_call_expression] = STATE(426),
    [sym_new_expression] = STATE(424),
    [sym_await_expression] = STATE(424),
    [sym_member_expression] = STATE(340),
    [sym_subscript_expression] = STATE(340),
    [sym_assignment_expression] = STATE(424),
    [sym__augmented_assignment_lhs] = STATE(712),
    [sym_augmented_assignment_expression] = STATE(424),
    [sym__destructuring_pattern] = STATE(1317),
    [sym_ternary_expression] = STATE(424),
    [sym_binary_expression] = STATE(424),
    [sym_unary_expression] = STATE(424),
    [sym_update_expression] = STATE(424),
    [sym_string] = STATE(426),
    [sym_template_string] = STATE(426),
    [sym_regex] = STATE(426),
    [sym_meta_property] = STATE(426),
    [sym_decorator] = STATE(750),
    [sym_formal_parameters] = STATE(1267),
    [aux_sym_export_statement_repeat1] = STATE(924),
    [sym_identifier] = ACTIONS(391),
    [anon_sym_export] = ACTIONS(393),
    [anon_sym_LBRACE] = ACTIONS(397),
    [anon_sym_import] = ACTIONS(331),
    [anon_sym_LPAREN] = ACTIONS(333),
    [anon_sym_await] = ACTIONS(399),
    [anon_sym_yield] = ACTIONS(401),
    [anon_sym_LBRACK] = ACTIONS(403),
    [anon_sym_LT] = ACTIONS(537),
    [anon_sym_SLASH] = ACTIONS(345),
    [anon_sym_class] = ACTIONS(347),
    [anon_sym_async] = ACTIONS(405),
    [anon_sym_function] = ACTIONS(351),
    [anon_sym_new] = ACTIONS(407),
    [anon_sym_PLUS] = ACTIONS(409),
    [anon_sym_DASH] = ACTIONS(409),
    [anon_sym_BANG] = ACTIONS(411),
    [anon_sym_TILDE] = ACTIONS(411),
    [anon_sym_typeof] = ACTIONS(413),
    [anon_sym_void] = ACTIONS(413),
    [anon_sym_delete] = ACTIONS(413),
    [anon_sym_PLUS_PLUS] = ACTIONS(415),
    [anon_sym_DASH_DASH] = ACTIONS(415),
    [anon_sym_DQUOTE] = ACTIONS(363),
    [anon_sym_SQUOTE] = ACTIONS(365),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(367),
    [sym_number] = ACTIONS(369),
    [sym_this] = ACTIONS(371),
    [sym_super] = ACTIONS(371),
    [sym_true] = ACTIONS(371),
    [sym_false] = ACTIONS(371),
    [sym_null] = ACTIONS(371),
    [sym_undefined] = ACTIONS(371),
    [anon_sym_AT] = ACTIONS(85),
    [anon_sym_static] = ACTIONS(393),
    [anon_sym_get] = ACTIONS(393),
    [anon_sym_set] = ACTIONS(393),
  },
  [162] = {
    [sym_import] = STATE(426),
    [sym_parenthesized_expression] = STATE(355),
    [sym_expression] = STATE(393),
    [sym_primary_expression] = STATE(425),
    [sym_yield_expression] = STATE(424),
    [sym_object] = STATE(426),
    [sym_object_pattern] = STATE(1333),
    [sym_array] = STATE(426),
    [sym_array_pattern] = STATE(1333),
    [sym_jsx_element] = STATE(424),
    [sym_jsx_fragment] = STATE(424),
    [sym_jsx_opening_element] = STATE(768),
    [sym_jsx_self_closing_element] = STATE(424),
    [sym_class] = STATE(426),
    [sym_function] = STATE(426),
    [sym_generator_function] = STATE(426),
    [sym_arrow_function] = STATE(426),
    [sym_call_expression] = STATE(426),
    [sym_new_expression] = STATE(424),
    [sym_await_expression] = STATE(424),
    [sym_member_expression] = STATE(355),
    [sym_subscript_expression] = STATE(355),
    [sym_assignment_expression] = STATE(424),
    [sym__augmented_assignment_lhs] = STATE(714),
    [sym_augmented_assignment_expression] = STATE(424),
    [sym__destructuring_pattern] = STATE(1333),
    [sym_ternary_expression] = STATE(424),
    [sym_binary_expression] = STATE(424),
    [sym_unary_expression] = STATE(424),
    [sym_update_expression] = STATE(424),
    [sym_string] = STATE(426),
    [sym_template_string] = STATE(426),
    [sym_regex] = STATE(426),
    [sym_meta_property] = STATE(426),
    [sym_decorator] = STATE(750),
    [sym_formal_parameters] = STATE(1322),
    [aux_sym_export_statement_repeat1] = STATE(924),
    [sym_identifier] = ACTIONS(321),
    [anon_sym_export] = ACTIONS(323),
    [anon_sym_LBRACE] = ACTIONS(327),
    [anon_sym_import] = ACTIONS(331),
    [anon_sym_LPAREN] = ACTIONS(333),
    [anon_sym_await] = ACTIONS(335),
    [anon_sym_yield] = ACTIONS(339),
    [anon_sym_LBRACK] = ACTIONS(341),
    [anon_sym_LT] = ACTIONS(537),
    [anon_sym_SLASH] = ACTIONS(345),
    [anon_sym_class] = ACTIONS(347),
    [anon_sym_async] = ACTIONS(349),
    [anon_sym_function] = ACTIONS(351),
    [anon_sym_new] = ACTIONS(353),
    [anon_sym_PLUS] = ACTIONS(355),
    [anon_sym_DASH] = ACTIONS(355),
    [anon_sym_BANG] = ACTIONS(357),
    [anon_sym_TILDE] = ACTIONS(357),
    [anon_sym_typeof] = ACTIONS(359),
    [anon_sym_void] = ACTIONS(359),
    [anon_sym_delete] = ACTIONS(359),
    [anon_sym_PLUS_PLUS] = ACTIONS(361),
    [anon_sym_DASH_DASH] = ACTIONS(361),
    [anon_sym_DQUOTE] = ACTIONS(363),
    [anon_sym_SQUOTE] = ACTIONS(365),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(367),
    [sym_number] = ACTIONS(369),
    [sym_this] = ACTIONS(371),
    [sym_super] = ACTIONS(371),
    [sym_true] = ACTIONS(371),
    [sym_false] = ACTIONS(371),
    [sym_null] = ACTIONS(371),
    [sym_undefined] = ACTIONS(371),
    [anon_sym_AT] = ACTIONS(85),
    [anon_sym_static] = ACTIONS(323),
    [anon_sym_get] = ACTIONS(323),
    [anon_sym_set] = ACTIONS(323),
  },
  [163] = {
    [sym_import] = STATE(539),
    [sym_parenthesized_expression] = STATE(362),
    [sym_expression] = STATE(496),
    [sym_primary_expression] = STATE(546),
    [sym_yield_expression] = STATE(550),
    [sym_object] = STATE(539),
    [sym_object_pattern] = STATE(1320),
    [sym_array] = STATE(539),
    [sym_array_pattern] = STATE(1320),
    [sym_jsx_element] = STATE(550),
    [sym_jsx_fragment] = STATE(550),
    [sym_jsx_opening_element] = STATE(772),
    [sym_jsx_self_closing_element] = STATE(550),
    [sym_class] = STATE(539),
    [sym_function] = STATE(539),
    [sym_generator_function] = STATE(539),
    [sym_arrow_function] = STATE(539),
    [sym_call_expression] = STATE(539),
    [sym_new_expression] = STATE(550),
    [sym_await_expression] = STATE(550),
    [sym_member_expression] = STATE(362),
    [sym_subscript_expression] = STATE(362),
    [sym_assignment_expression] = STATE(550),
    [sym__augmented_assignment_lhs] = STATE(720),
    [sym_augmented_assignment_expression] = STATE(550),
    [sym__destructuring_pattern] = STATE(1320),
    [sym_ternary_expression] = STATE(550),
    [sym_binary_expression] = STATE(550),
    [sym_unary_expression] = STATE(550),
    [sym_update_expression] = STATE(550),
    [sym_string] = STATE(539),
    [sym_template_string] = STATE(539),
    [sym_regex] = STATE(539),
    [sym_meta_property] = STATE(539),
    [sym_decorator] = STATE(750),
    [sym_formal_parameters] = STATE(1318),
    [aux_sym_export_statement_repeat1] = STATE(925),
    [sym_identifier] = ACTIONS(373),
    [anon_sym_export] = ACTIONS(375),
    [anon_sym_LBRACE] = ACTIONS(379),
    [anon_sym_import] = ACTIONS(381),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(29),
    [anon_sym_yield] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(53),
    [anon_sym_LT] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(385),
    [anon_sym_async] = ACTIONS(387),
    [anon_sym_function] = ACTIONS(389),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_typeof] = ACTIONS(71),
    [anon_sym_void] = ACTIONS(71),
    [anon_sym_delete] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DQUOTE] = ACTIONS(75),
    [anon_sym_SQUOTE] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(79),
    [sym_number] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(83),
    [sym_true] = ACTIONS(83),
    [sym_false] = ACTIONS(83),
    [sym_null] = ACTIONS(83),
    [sym_undefined] = ACTIONS(83),
    [anon_sym_AT] = ACTIONS(85),
    [anon_sym_static] = ACTIONS(375),
    [anon_sym_get] = ACTIONS(375),
    [anon_sym_set] = ACTIONS(375),
  },
  [164] = {
    [sym_import] = STATE(426),
    [sym_parenthesized_expression] = STATE(355),
    [sym_expression] = STATE(414),
    [sym_primary_expression] = STATE(425),
    [sym_yield_expression] = STATE(424),
    [sym_object] = STATE(426),
    [sym_object_pattern] = STATE(1333),
    [sym_array] = STATE(426),
    [sym_array_pattern] = STATE(1333),
    [sym_jsx_element] = STATE(424),
    [sym_jsx_fragment] = STATE(424),
    [sym_jsx_opening_element] = STATE(768),
    [sym_jsx_self_closing_element] = STATE(424),
    [sym_class] = STATE(426),
    [sym_function] = STATE(426),
    [sym_generator_function] = STATE(426),
    [sym_arrow_function] = STATE(426),
    [sym_call_expression] = STATE(426),
    [sym_new_expression] = STATE(424),
    [sym_await_expression] = STATE(424),
    [sym_member_expression] = STATE(355),
    [sym_subscript_expression] = STATE(355),
    [sym_assignment_expression] = STATE(424),
    [sym__augmented_assignment_lhs] = STATE(714),
    [sym_augmented_assignment_expression] = STATE(424),
    [sym__destructuring_pattern] = STATE(1333),
    [sym_ternary_expression] = STATE(424),
    [sym_binary_expression] = STATE(424),
    [sym_unary_expression] = STATE(424),
    [sym_update_expression] = STATE(424),
    [sym_string] = STATE(426),
    [sym_template_string] = STATE(426),
    [sym_regex] = STATE(426),
    [sym_meta_property] = STATE(426),
    [sym_decorator] = STATE(750),
    [sym_formal_parameters] = STATE(1322),
    [aux_sym_export_statement_repeat1] = STATE(924),
    [sym_identifier] = ACTIONS(321),
    [anon_sym_export] = ACTIONS(323),
    [anon_sym_LBRACE] = ACTIONS(327),
    [anon_sym_import] = ACTIONS(331),
    [anon_sym_LPAREN] = ACTIONS(333),
    [anon_sym_await] = ACTIONS(335),
    [anon_sym_yield] = ACTIONS(339),
    [anon_sym_LBRACK] = ACTIONS(341),
    [anon_sym_LT] = ACTIONS(537),
    [anon_sym_SLASH] = ACTIONS(345),
    [anon_sym_class] = ACTIONS(347),
    [anon_sym_async] = ACTIONS(349),
    [anon_sym_function] = ACTIONS(351),
    [anon_sym_new] = ACTIONS(353),
    [anon_sym_PLUS] = ACTIONS(355),
    [anon_sym_DASH] = ACTIONS(355),
    [anon_sym_BANG] = ACTIONS(357),
    [anon_sym_TILDE] = ACTIONS(357),
    [anon_sym_typeof] = ACTIONS(359),
    [anon_sym_void] = ACTIONS(359),
    [anon_sym_delete] = ACTIONS(359),
    [anon_sym_PLUS_PLUS] = ACTIONS(361),
    [anon_sym_DASH_DASH] = ACTIONS(361),
    [anon_sym_DQUOTE] = ACTIONS(363),
    [anon_sym_SQUOTE] = ACTIONS(365),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(367),
    [sym_number] = ACTIONS(369),
    [sym_this] = ACTIONS(371),
    [sym_super] = ACTIONS(371),
    [sym_true] = ACTIONS(371),
    [sym_false] = ACTIONS(371),
    [sym_null] = ACTIONS(371),
    [sym_undefined] = ACTIONS(371),
    [anon_sym_AT] = ACTIONS(85),
    [anon_sym_static] = ACTIONS(323),
    [anon_sym_get] = ACTIONS(323),
    [anon_sym_set] = ACTIONS(323),
  },
  [165] = {
    [sym_import] = STATE(426),
    [sym_parenthesized_expression] = STATE(355),
    [sym_expression] = STATE(388),
    [sym_primary_expression] = STATE(425),
    [sym_yield_expression] = STATE(424),
    [sym_object] = STATE(426),
    [sym_object_pattern] = STATE(1333),
    [sym_array] = STATE(426),
    [sym_array_pattern] = STATE(1333),
    [sym_jsx_element] = STATE(424),
    [sym_jsx_fragment] = STATE(424),
    [sym_jsx_opening_element] = STATE(768),
    [sym_jsx_self_closing_element] = STATE(424),
    [sym_class] = STATE(426),
    [sym_function] = STATE(426),
    [sym_generator_function] = STATE(426),
    [sym_arrow_function] = STATE(426),
    [sym_call_expression] = STATE(426),
    [sym_new_expression] = STATE(424),
    [sym_await_expression] = STATE(424),
    [sym_member_expression] = STATE(355),
    [sym_subscript_expression] = STATE(355),
    [sym_assignment_expression] = STATE(424),
    [sym__augmented_assignment_lhs] = STATE(714),
    [sym_augmented_assignment_expression] = STATE(424),
    [sym__destructuring_pattern] = STATE(1333),
    [sym_ternary_expression] = STATE(424),
    [sym_binary_expression] = STATE(424),
    [sym_unary_expression] = STATE(424),
    [sym_update_expression] = STATE(424),
    [sym_string] = STATE(426),
    [sym_template_string] = STATE(426),
    [sym_regex] = STATE(426),
    [sym_meta_property] = STATE(426),
    [sym_decorator] = STATE(750),
    [sym_formal_parameters] = STATE(1322),
    [aux_sym_export_statement_repeat1] = STATE(924),
    [sym_identifier] = ACTIONS(321),
    [anon_sym_export] = ACTIONS(323),
    [anon_sym_LBRACE] = ACTIONS(327),
    [anon_sym_import] = ACTIONS(331),
    [anon_sym_LPAREN] = ACTIONS(333),
    [anon_sym_await] = ACTIONS(335),
    [anon_sym_yield] = ACTIONS(339),
    [anon_sym_LBRACK] = ACTIONS(341),
    [anon_sym_LT] = ACTIONS(537),
    [anon_sym_SLASH] = ACTIONS(345),
    [anon_sym_class] = ACTIONS(347),
    [anon_sym_async] = ACTIONS(349),
    [anon_sym_function] = ACTIONS(351),
    [anon_sym_new] = ACTIONS(353),
    [anon_sym_PLUS] = ACTIONS(355),
    [anon_sym_DASH] = ACTIONS(355),
    [anon_sym_BANG] = ACTIONS(357),
    [anon_sym_TILDE] = ACTIONS(357),
    [anon_sym_typeof] = ACTIONS(359),
    [anon_sym_void] = ACTIONS(359),
    [anon_sym_delete] = ACTIONS(359),
    [anon_sym_PLUS_PLUS] = ACTIONS(361),
    [anon_sym_DASH_DASH] = ACTIONS(361),
    [anon_sym_DQUOTE] = ACTIONS(363),
    [anon_sym_SQUOTE] = ACTIONS(365),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(367),
    [sym_number] = ACTIONS(369),
    [sym_this] = ACTIONS(371),
    [sym_super] = ACTIONS(371),
    [sym_true] = ACTIONS(371),
    [sym_false] = ACTIONS(371),
    [sym_null] = ACTIONS(371),
    [sym_undefined] = ACTIONS(371),
    [anon_sym_AT] = ACTIONS(85),
    [anon_sym_static] = ACTIONS(323),
    [anon_sym_get] = ACTIONS(323),
    [anon_sym_set] = ACTIONS(323),
  },
  [166] = {
    [sym_import] = STATE(539),
    [sym_parenthesized_expression] = STATE(362),
    [sym_expression] = STATE(480),
    [sym_primary_expression] = STATE(546),
    [sym_yield_expression] = STATE(550),
    [sym_object] = STATE(539),
    [sym_object_pattern] = STATE(1320),
    [sym_array] = STATE(539),
    [sym_array_pattern] = STATE(1320),
    [sym_jsx_element] = STATE(550),
    [sym_jsx_fragment] = STATE(550),
    [sym_jsx_opening_element] = STATE(772),
    [sym_jsx_self_closing_element] = STATE(550),
    [sym_class] = STATE(539),
    [sym_function] = STATE(539),
    [sym_generator_function] = STATE(539),
    [sym_arrow_function] = STATE(539),
    [sym_call_expression] = STATE(539),
    [sym_new_expression] = STATE(550),
    [sym_await_expression] = STATE(550),
    [sym_member_expression] = STATE(362),
    [sym_subscript_expression] = STATE(362),
    [sym_assignment_expression] = STATE(550),
    [sym__augmented_assignment_lhs] = STATE(720),
    [sym_augmented_assignment_expression] = STATE(550),
    [sym__destructuring_pattern] = STATE(1320),
    [sym_ternary_expression] = STATE(550),
    [sym_binary_expression] = STATE(550),
    [sym_unary_expression] = STATE(550),
    [sym_update_expression] = STATE(550),
    [sym_string] = STATE(539),
    [sym_template_string] = STATE(539),
    [sym_regex] = STATE(539),
    [sym_meta_property] = STATE(539),
    [sym_decorator] = STATE(750),
    [sym_formal_parameters] = STATE(1318),
    [aux_sym_export_statement_repeat1] = STATE(925),
    [sym_identifier] = ACTIONS(373),
    [anon_sym_export] = ACTIONS(375),
    [anon_sym_LBRACE] = ACTIONS(379),
    [anon_sym_import] = ACTIONS(381),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(29),
    [anon_sym_yield] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(53),
    [anon_sym_LT] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(385),
    [anon_sym_async] = ACTIONS(387),
    [anon_sym_function] = ACTIONS(389),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_typeof] = ACTIONS(71),
    [anon_sym_void] = ACTIONS(71),
    [anon_sym_delete] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DQUOTE] = ACTIONS(75),
    [anon_sym_SQUOTE] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(79),
    [sym_number] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(83),
    [sym_true] = ACTIONS(83),
    [sym_false] = ACTIONS(83),
    [sym_null] = ACTIONS(83),
    [sym_undefined] = ACTIONS(83),
    [anon_sym_AT] = ACTIONS(85),
    [anon_sym_static] = ACTIONS(375),
    [anon_sym_get] = ACTIONS(375),
    [anon_sym_set] = ACTIONS(375),
  },
  [167] = {
    [sym_import] = STATE(426),
    [sym_parenthesized_expression] = STATE(340),
    [sym_expression] = STATE(615),
    [sym_primary_expression] = STATE(425),
    [sym_yield_expression] = STATE(424),
    [sym_object] = STATE(426),
    [sym_object_pattern] = STATE(1317),
    [sym_array] = STATE(426),
    [sym_array_pattern] = STATE(1317),
    [sym_jsx_element] = STATE(424),
    [sym_jsx_fragment] = STATE(424),
    [sym_jsx_opening_element] = STATE(768),
    [sym_jsx_self_closing_element] = STATE(424),
    [sym_class] = STATE(426),
    [sym_function] = STATE(426),
    [sym_generator_function] = STATE(426),
    [sym_arrow_function] = STATE(426),
    [sym_call_expression] = STATE(426),
    [sym_new_expression] = STATE(424),
    [sym_await_expression] = STATE(424),
    [sym_member_expression] = STATE(340),
    [sym_subscript_expression] = STATE(340),
    [sym_assignment_expression] = STATE(424),
    [sym__augmented_assignment_lhs] = STATE(712),
    [sym_augmented_assignment_expression] = STATE(424),
    [sym__destructuring_pattern] = STATE(1317),
    [sym_ternary_expression] = STATE(424),
    [sym_binary_expression] = STATE(424),
    [sym_unary_expression] = STATE(424),
    [sym_update_expression] = STATE(424),
    [sym_string] = STATE(426),
    [sym_template_string] = STATE(426),
    [sym_regex] = STATE(426),
    [sym_meta_property] = STATE(426),
    [sym_decorator] = STATE(750),
    [sym_formal_parameters] = STATE(1267),
    [aux_sym_export_statement_repeat1] = STATE(924),
    [sym_identifier] = ACTIONS(391),
    [anon_sym_export] = ACTIONS(393),
    [anon_sym_LBRACE] = ACTIONS(397),
    [anon_sym_import] = ACTIONS(331),
    [anon_sym_LPAREN] = ACTIONS(333),
    [anon_sym_await] = ACTIONS(399),
    [anon_sym_yield] = ACTIONS(401),
    [anon_sym_LBRACK] = ACTIONS(403),
    [anon_sym_LT] = ACTIONS(537),
    [anon_sym_SLASH] = ACTIONS(345),
    [anon_sym_class] = ACTIONS(347),
    [anon_sym_async] = ACTIONS(405),
    [anon_sym_function] = ACTIONS(351),
    [anon_sym_new] = ACTIONS(407),
    [anon_sym_PLUS] = ACTIONS(409),
    [anon_sym_DASH] = ACTIONS(409),
    [anon_sym_BANG] = ACTIONS(411),
    [anon_sym_TILDE] = ACTIONS(411),
    [anon_sym_typeof] = ACTIONS(413),
    [anon_sym_void] = ACTIONS(413),
    [anon_sym_delete] = ACTIONS(413),
    [anon_sym_PLUS_PLUS] = ACTIONS(415),
    [anon_sym_DASH_DASH] = ACTIONS(415),
    [anon_sym_DQUOTE] = ACTIONS(363),
    [anon_sym_SQUOTE] = ACTIONS(365),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(367),
    [sym_number] = ACTIONS(369),
    [sym_this] = ACTIONS(371),
    [sym_super] = ACTIONS(371),
    [sym_true] = ACTIONS(371),
    [sym_false] = ACTIONS(371),
    [sym_null] = ACTIONS(371),
    [sym_undefined] = ACTIONS(371),
    [anon_sym_AT] = ACTIONS(85),
    [anon_sym_static] = ACTIONS(393),
    [anon_sym_get] = ACTIONS(393),
    [anon_sym_set] = ACTIONS(393),
  },
  [168] = {
    [sym_import] = STATE(426),
    [sym_parenthesized_expression] = STATE(340),
    [sym_expression] = STATE(633),
    [sym_primary_expression] = STATE(425),
    [sym_yield_expression] = STATE(424),
    [sym_object] = STATE(426),
    [sym_object_pattern] = STATE(1317),
    [sym_array] = STATE(426),
    [sym_array_pattern] = STATE(1317),
    [sym_jsx_element] = STATE(424),
    [sym_jsx_fragment] = STATE(424),
    [sym_jsx_opening_element] = STATE(768),
    [sym_jsx_self_closing_element] = STATE(424),
    [sym_class] = STATE(426),
    [sym_function] = STATE(426),
    [sym_generator_function] = STATE(426),
    [sym_arrow_function] = STATE(426),
    [sym_call_expression] = STATE(426),
    [sym_new_expression] = STATE(424),
    [sym_await_expression] = STATE(424),
    [sym_member_expression] = STATE(340),
    [sym_subscript_expression] = STATE(340),
    [sym_assignment_expression] = STATE(424),
    [sym__augmented_assignment_lhs] = STATE(712),
    [sym_augmented_assignment_expression] = STATE(424),
    [sym__destructuring_pattern] = STATE(1317),
    [sym_ternary_expression] = STATE(424),
    [sym_binary_expression] = STATE(424),
    [sym_unary_expression] = STATE(424),
    [sym_update_expression] = STATE(424),
    [sym_string] = STATE(426),
    [sym_template_string] = STATE(426),
    [sym_regex] = STATE(426),
    [sym_meta_property] = STATE(426),
    [sym_decorator] = STATE(750),
    [sym_formal_parameters] = STATE(1267),
    [aux_sym_export_statement_repeat1] = STATE(924),
    [sym_identifier] = ACTIONS(391),
    [anon_sym_export] = ACTIONS(393),
    [anon_sym_LBRACE] = ACTIONS(397),
    [anon_sym_import] = ACTIONS(331),
    [anon_sym_LPAREN] = ACTIONS(333),
    [anon_sym_await] = ACTIONS(399),
    [anon_sym_yield] = ACTIONS(401),
    [anon_sym_LBRACK] = ACTIONS(403),
    [anon_sym_LT] = ACTIONS(537),
    [anon_sym_SLASH] = ACTIONS(345),
    [anon_sym_class] = ACTIONS(347),
    [anon_sym_async] = ACTIONS(405),
    [anon_sym_function] = ACTIONS(351),
    [anon_sym_new] = ACTIONS(407),
    [anon_sym_PLUS] = ACTIONS(409),
    [anon_sym_DASH] = ACTIONS(409),
    [anon_sym_BANG] = ACTIONS(411),
    [anon_sym_TILDE] = ACTIONS(411),
    [anon_sym_typeof] = ACTIONS(413),
    [anon_sym_void] = ACTIONS(413),
    [anon_sym_delete] = ACTIONS(413),
    [anon_sym_PLUS_PLUS] = ACTIONS(415),
    [anon_sym_DASH_DASH] = ACTIONS(415),
    [anon_sym_DQUOTE] = ACTIONS(363),
    [anon_sym_SQUOTE] = ACTIONS(365),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(367),
    [sym_number] = ACTIONS(369),
    [sym_this] = ACTIONS(371),
    [sym_super] = ACTIONS(371),
    [sym_true] = ACTIONS(371),
    [sym_false] = ACTIONS(371),
    [sym_null] = ACTIONS(371),
    [sym_undefined] = ACTIONS(371),
    [anon_sym_AT] = ACTIONS(85),
    [anon_sym_static] = ACTIONS(393),
    [anon_sym_get] = ACTIONS(393),
    [anon_sym_set] = ACTIONS(393),
  },
  [169] = {
    [sym_import] = STATE(426),
    [sym_parenthesized_expression] = STATE(340),
    [sym_expression] = STATE(600),
    [sym_primary_expression] = STATE(425),
    [sym_yield_expression] = STATE(424),
    [sym_object] = STATE(426),
    [sym_object_pattern] = STATE(1317),
    [sym_array] = STATE(426),
    [sym_array_pattern] = STATE(1317),
    [sym_jsx_element] = STATE(424),
    [sym_jsx_fragment] = STATE(424),
    [sym_jsx_opening_element] = STATE(768),
    [sym_jsx_self_closing_element] = STATE(424),
    [sym_class] = STATE(426),
    [sym_function] = STATE(426),
    [sym_generator_function] = STATE(426),
    [sym_arrow_function] = STATE(426),
    [sym_call_expression] = STATE(426),
    [sym_new_expression] = STATE(424),
    [sym_await_expression] = STATE(424),
    [sym_member_expression] = STATE(340),
    [sym_subscript_expression] = STATE(340),
    [sym_assignment_expression] = STATE(424),
    [sym__augmented_assignment_lhs] = STATE(712),
    [sym_augmented_assignment_expression] = STATE(424),
    [sym__destructuring_pattern] = STATE(1317),
    [sym_ternary_expression] = STATE(424),
    [sym_binary_expression] = STATE(424),
    [sym_unary_expression] = STATE(424),
    [sym_update_expression] = STATE(424),
    [sym_string] = STATE(426),
    [sym_template_string] = STATE(426),
    [sym_regex] = STATE(426),
    [sym_meta_property] = STATE(426),
    [sym_decorator] = STATE(750),
    [sym_formal_parameters] = STATE(1267),
    [aux_sym_export_statement_repeat1] = STATE(924),
    [sym_identifier] = ACTIONS(391),
    [anon_sym_export] = ACTIONS(393),
    [anon_sym_LBRACE] = ACTIONS(397),
    [anon_sym_import] = ACTIONS(331),
    [anon_sym_LPAREN] = ACTIONS(333),
    [anon_sym_await] = ACTIONS(399),
    [anon_sym_yield] = ACTIONS(401),
    [anon_sym_LBRACK] = ACTIONS(403),
    [anon_sym_LT] = ACTIONS(537),
    [anon_sym_SLASH] = ACTIONS(345),
    [anon_sym_class] = ACTIONS(347),
    [anon_sym_async] = ACTIONS(405),
    [anon_sym_function] = ACTIONS(351),
    [anon_sym_new] = ACTIONS(407),
    [anon_sym_PLUS] = ACTIONS(409),
    [anon_sym_DASH] = ACTIONS(409),
    [anon_sym_BANG] = ACTIONS(411),
    [anon_sym_TILDE] = ACTIONS(411),
    [anon_sym_typeof] = ACTIONS(413),
    [anon_sym_void] = ACTIONS(413),
    [anon_sym_delete] = ACTIONS(413),
    [anon_sym_PLUS_PLUS] = ACTIONS(415),
    [anon_sym_DASH_DASH] = ACTIONS(415),
    [anon_sym_DQUOTE] = ACTIONS(363),
    [anon_sym_SQUOTE] = ACTIONS(365),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(367),
    [sym_number] = ACTIONS(369),
    [sym_this] = ACTIONS(371),
    [sym_super] = ACTIONS(371),
    [sym_true] = ACTIONS(371),
    [sym_false] = ACTIONS(371),
    [sym_null] = ACTIONS(371),
    [sym_undefined] = ACTIONS(371),
    [anon_sym_AT] = ACTIONS(85),
    [anon_sym_static] = ACTIONS(393),
    [anon_sym_get] = ACTIONS(393),
    [anon_sym_set] = ACTIONS(393),
  },
  [170] = {
    [sym_import] = STATE(539),
    [sym_parenthesized_expression] = STATE(362),
    [sym_expression] = STATE(487),
    [sym_primary_expression] = STATE(546),
    [sym_yield_expression] = STATE(550),
    [sym_object] = STATE(539),
    [sym_object_pattern] = STATE(1320),
    [sym_array] = STATE(539),
    [sym_array_pattern] = STATE(1320),
    [sym_jsx_element] = STATE(550),
    [sym_jsx_fragment] = STATE(550),
    [sym_jsx_opening_element] = STATE(772),
    [sym_jsx_self_closing_element] = STATE(550),
    [sym_class] = STATE(539),
    [sym_function] = STATE(539),
    [sym_generator_function] = STATE(539),
    [sym_arrow_function] = STATE(539),
    [sym_call_expression] = STATE(539),
    [sym_new_expression] = STATE(550),
    [sym_await_expression] = STATE(550),
    [sym_member_expression] = STATE(362),
    [sym_subscript_expression] = STATE(362),
    [sym_assignment_expression] = STATE(550),
    [sym__augmented_assignment_lhs] = STATE(720),
    [sym_augmented_assignment_expression] = STATE(550),
    [sym__destructuring_pattern] = STATE(1320),
    [sym_ternary_expression] = STATE(550),
    [sym_binary_expression] = STATE(550),
    [sym_unary_expression] = STATE(550),
    [sym_update_expression] = STATE(550),
    [sym_string] = STATE(539),
    [sym_template_string] = STATE(539),
    [sym_regex] = STATE(539),
    [sym_meta_property] = STATE(539),
    [sym_decorator] = STATE(750),
    [sym_formal_parameters] = STATE(1318),
    [aux_sym_export_statement_repeat1] = STATE(925),
    [sym_identifier] = ACTIONS(373),
    [anon_sym_export] = ACTIONS(375),
    [anon_sym_LBRACE] = ACTIONS(379),
    [anon_sym_import] = ACTIONS(381),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(29),
    [anon_sym_yield] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(53),
    [anon_sym_LT] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(385),
    [anon_sym_async] = ACTIONS(387),
    [anon_sym_function] = ACTIONS(389),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_typeof] = ACTIONS(71),
    [anon_sym_void] = ACTIONS(71),
    [anon_sym_delete] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DQUOTE] = ACTIONS(75),
    [anon_sym_SQUOTE] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(79),
    [sym_number] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(83),
    [sym_true] = ACTIONS(83),
    [sym_false] = ACTIONS(83),
    [sym_null] = ACTIONS(83),
    [sym_undefined] = ACTIONS(83),
    [anon_sym_AT] = ACTIONS(85),
    [anon_sym_static] = ACTIONS(375),
    [anon_sym_get] = ACTIONS(375),
    [anon_sym_set] = ACTIONS(375),
  },
  [171] = {
    [sym_import] = STATE(539),
    [sym_parenthesized_expression] = STATE(362),
    [sym_expression] = STATE(448),
    [sym_primary_expression] = STATE(546),
    [sym_yield_expression] = STATE(550),
    [sym_object] = STATE(539),
    [sym_object_pattern] = STATE(1320),
    [sym_array] = STATE(539),
    [sym_array_pattern] = STATE(1320),
    [sym_jsx_element] = STATE(550),
    [sym_jsx_fragment] = STATE(550),
    [sym_jsx_opening_element] = STATE(772),
    [sym_jsx_self_closing_element] = STATE(550),
    [sym_class] = STATE(539),
    [sym_function] = STATE(539),
    [sym_generator_function] = STATE(539),
    [sym_arrow_function] = STATE(539),
    [sym_call_expression] = STATE(539),
    [sym_new_expression] = STATE(550),
    [sym_await_expression] = STATE(550),
    [sym_member_expression] = STATE(362),
    [sym_subscript_expression] = STATE(362),
    [sym_assignment_expression] = STATE(550),
    [sym__augmented_assignment_lhs] = STATE(720),
    [sym_augmented_assignment_expression] = STATE(550),
    [sym__destructuring_pattern] = STATE(1320),
    [sym_ternary_expression] = STATE(550),
    [sym_binary_expression] = STATE(550),
    [sym_unary_expression] = STATE(550),
    [sym_update_expression] = STATE(550),
    [sym_string] = STATE(539),
    [sym_template_string] = STATE(539),
    [sym_regex] = STATE(539),
    [sym_meta_property] = STATE(539),
    [sym_decorator] = STATE(750),
    [sym_formal_parameters] = STATE(1318),
    [aux_sym_export_statement_repeat1] = STATE(925),
    [sym_identifier] = ACTIONS(373),
    [anon_sym_export] = ACTIONS(375),
    [anon_sym_LBRACE] = ACTIONS(379),
    [anon_sym_import] = ACTIONS(381),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(29),
    [anon_sym_yield] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(53),
    [anon_sym_LT] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(385),
    [anon_sym_async] = ACTIONS(387),
    [anon_sym_function] = ACTIONS(389),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_typeof] = ACTIONS(71),
    [anon_sym_void] = ACTIONS(71),
    [anon_sym_delete] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DQUOTE] = ACTIONS(75),
    [anon_sym_SQUOTE] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(79),
    [sym_number] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(83),
    [sym_true] = ACTIONS(83),
    [sym_false] = ACTIONS(83),
    [sym_null] = ACTIONS(83),
    [sym_undefined] = ACTIONS(83),
    [anon_sym_AT] = ACTIONS(85),
    [anon_sym_static] = ACTIONS(375),
    [anon_sym_get] = ACTIONS(375),
    [anon_sym_set] = ACTIONS(375),
  },
  [172] = {
    [sym_import] = STATE(426),
    [sym_parenthesized_expression] = STATE(340),
    [sym_expression] = STATE(387),
    [sym_primary_expression] = STATE(425),
    [sym_yield_expression] = STATE(424),
    [sym_object] = STATE(426),
    [sym_object_pattern] = STATE(1317),
    [sym_array] = STATE(426),
    [sym_array_pattern] = STATE(1317),
    [sym_jsx_element] = STATE(424),
    [sym_jsx_fragment] = STATE(424),
    [sym_jsx_opening_element] = STATE(768),
    [sym_jsx_self_closing_element] = STATE(424),
    [sym_class] = STATE(426),
    [sym_function] = STATE(426),
    [sym_generator_function] = STATE(426),
    [sym_arrow_function] = STATE(426),
    [sym_call_expression] = STATE(426),
    [sym_new_expression] = STATE(424),
    [sym_await_expression] = STATE(424),
    [sym_member_expression] = STATE(340),
    [sym_subscript_expression] = STATE(340),
    [sym_assignment_expression] = STATE(424),
    [sym__augmented_assignment_lhs] = STATE(712),
    [sym_augmented_assignment_expression] = STATE(424),
    [sym__destructuring_pattern] = STATE(1317),
    [sym_ternary_expression] = STATE(424),
    [sym_binary_expression] = STATE(424),
    [sym_unary_expression] = STATE(424),
    [sym_update_expression] = STATE(424),
    [sym_string] = STATE(426),
    [sym_template_string] = STATE(426),
    [sym_regex] = STATE(426),
    [sym_meta_property] = STATE(426),
    [sym_decorator] = STATE(750),
    [sym_formal_parameters] = STATE(1267),
    [aux_sym_export_statement_repeat1] = STATE(924),
    [sym_identifier] = ACTIONS(391),
    [anon_sym_export] = ACTIONS(393),
    [anon_sym_LBRACE] = ACTIONS(397),
    [anon_sym_import] = ACTIONS(331),
    [anon_sym_LPAREN] = ACTIONS(333),
    [anon_sym_await] = ACTIONS(399),
    [anon_sym_yield] = ACTIONS(401),
    [anon_sym_LBRACK] = ACTIONS(403),
    [anon_sym_LT] = ACTIONS(537),
    [anon_sym_SLASH] = ACTIONS(345),
    [anon_sym_class] = ACTIONS(347),
    [anon_sym_async] = ACTIONS(405),
    [anon_sym_function] = ACTIONS(351),
    [anon_sym_new] = ACTIONS(407),
    [anon_sym_PLUS] = ACTIONS(409),
    [anon_sym_DASH] = ACTIONS(409),
    [anon_sym_BANG] = ACTIONS(411),
    [anon_sym_TILDE] = ACTIONS(411),
    [anon_sym_typeof] = ACTIONS(413),
    [anon_sym_void] = ACTIONS(413),
    [anon_sym_delete] = ACTIONS(413),
    [anon_sym_PLUS_PLUS] = ACTIONS(415),
    [anon_sym_DASH_DASH] = ACTIONS(415),
    [anon_sym_DQUOTE] = ACTIONS(363),
    [anon_sym_SQUOTE] = ACTIONS(365),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(367),
    [sym_number] = ACTIONS(369),
    [sym_this] = ACTIONS(371),
    [sym_super] = ACTIONS(371),
    [sym_true] = ACTIONS(371),
    [sym_false] = ACTIONS(371),
    [sym_null] = ACTIONS(371),
    [sym_undefined] = ACTIONS(371),
    [anon_sym_AT] = ACTIONS(85),
    [anon_sym_static] = ACTIONS(393),
    [anon_sym_get] = ACTIONS(393),
    [anon_sym_set] = ACTIONS(393),
  },
  [173] = {
    [sym_import] = STATE(426),
    [sym_parenthesized_expression] = STATE(340),
    [sym_expression] = STATE(535),
    [sym_primary_expression] = STATE(425),
    [sym_yield_expression] = STATE(424),
    [sym_object] = STATE(426),
    [sym_object_pattern] = STATE(1317),
    [sym_array] = STATE(426),
    [sym_array_pattern] = STATE(1317),
    [sym_jsx_element] = STATE(424),
    [sym_jsx_fragment] = STATE(424),
    [sym_jsx_opening_element] = STATE(768),
    [sym_jsx_self_closing_element] = STATE(424),
    [sym_class] = STATE(426),
    [sym_function] = STATE(426),
    [sym_generator_function] = STATE(426),
    [sym_arrow_function] = STATE(426),
    [sym_call_expression] = STATE(426),
    [sym_new_expression] = STATE(424),
    [sym_await_expression] = STATE(424),
    [sym_member_expression] = STATE(340),
    [sym_subscript_expression] = STATE(340),
    [sym_assignment_expression] = STATE(424),
    [sym__augmented_assignment_lhs] = STATE(712),
    [sym_augmented_assignment_expression] = STATE(424),
    [sym__destructuring_pattern] = STATE(1317),
    [sym_ternary_expression] = STATE(424),
    [sym_binary_expression] = STATE(424),
    [sym_unary_expression] = STATE(424),
    [sym_update_expression] = STATE(424),
    [sym_string] = STATE(426),
    [sym_template_string] = STATE(426),
    [sym_regex] = STATE(426),
    [sym_meta_property] = STATE(426),
    [sym_decorator] = STATE(750),
    [sym_formal_parameters] = STATE(1267),
    [aux_sym_export_statement_repeat1] = STATE(924),
    [sym_identifier] = ACTIONS(391),
    [anon_sym_export] = ACTIONS(393),
    [anon_sym_LBRACE] = ACTIONS(397),
    [anon_sym_import] = ACTIONS(331),
    [anon_sym_LPAREN] = ACTIONS(333),
    [anon_sym_await] = ACTIONS(399),
    [anon_sym_yield] = ACTIONS(401),
    [anon_sym_LBRACK] = ACTIONS(403),
    [anon_sym_LT] = ACTIONS(537),
    [anon_sym_SLASH] = ACTIONS(345),
    [anon_sym_class] = ACTIONS(347),
    [anon_sym_async] = ACTIONS(405),
    [anon_sym_function] = ACTIONS(351),
    [anon_sym_new] = ACTIONS(407),
    [anon_sym_PLUS] = ACTIONS(409),
    [anon_sym_DASH] = ACTIONS(409),
    [anon_sym_BANG] = ACTIONS(411),
    [anon_sym_TILDE] = ACTIONS(411),
    [anon_sym_typeof] = ACTIONS(413),
    [anon_sym_void] = ACTIONS(413),
    [anon_sym_delete] = ACTIONS(413),
    [anon_sym_PLUS_PLUS] = ACTIONS(415),
    [anon_sym_DASH_DASH] = ACTIONS(415),
    [anon_sym_DQUOTE] = ACTIONS(363),
    [anon_sym_SQUOTE] = ACTIONS(365),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(367),
    [sym_number] = ACTIONS(369),
    [sym_this] = ACTIONS(371),
    [sym_super] = ACTIONS(371),
    [sym_true] = ACTIONS(371),
    [sym_false] = ACTIONS(371),
    [sym_null] = ACTIONS(371),
    [sym_undefined] = ACTIONS(371),
    [anon_sym_AT] = ACTIONS(85),
    [anon_sym_static] = ACTIONS(393),
    [anon_sym_get] = ACTIONS(393),
    [anon_sym_set] = ACTIONS(393),
  },
  [174] = {
    [sym_import] = STATE(426),
    [sym_parenthesized_expression] = STATE(355),
    [sym_expression] = STATE(386),
    [sym_primary_expression] = STATE(425),
    [sym_yield_expression] = STATE(424),
    [sym_object] = STATE(426),
    [sym_object_pattern] = STATE(1333),
    [sym_array] = STATE(426),
    [sym_array_pattern] = STATE(1333),
    [sym_jsx_element] = STATE(424),
    [sym_jsx_fragment] = STATE(424),
    [sym_jsx_opening_element] = STATE(768),
    [sym_jsx_self_closing_element] = STATE(424),
    [sym_class] = STATE(426),
    [sym_function] = STATE(426),
    [sym_generator_function] = STATE(426),
    [sym_arrow_function] = STATE(426),
    [sym_call_expression] = STATE(426),
    [sym_new_expression] = STATE(424),
    [sym_await_expression] = STATE(424),
    [sym_member_expression] = STATE(355),
    [sym_subscript_expression] = STATE(355),
    [sym_assignment_expression] = STATE(424),
    [sym__augmented_assignment_lhs] = STATE(714),
    [sym_augmented_assignment_expression] = STATE(424),
    [sym__destructuring_pattern] = STATE(1333),
    [sym_ternary_expression] = STATE(424),
    [sym_binary_expression] = STATE(424),
    [sym_unary_expression] = STATE(424),
    [sym_update_expression] = STATE(424),
    [sym_string] = STATE(426),
    [sym_template_string] = STATE(426),
    [sym_regex] = STATE(426),
    [sym_meta_property] = STATE(426),
    [sym_decorator] = STATE(750),
    [sym_formal_parameters] = STATE(1322),
    [aux_sym_export_statement_repeat1] = STATE(924),
    [sym_identifier] = ACTIONS(321),
    [anon_sym_export] = ACTIONS(323),
    [anon_sym_LBRACE] = ACTIONS(327),
    [anon_sym_import] = ACTIONS(331),
    [anon_sym_LPAREN] = ACTIONS(333),
    [anon_sym_await] = ACTIONS(335),
    [anon_sym_yield] = ACTIONS(339),
    [anon_sym_LBRACK] = ACTIONS(341),
    [anon_sym_LT] = ACTIONS(537),
    [anon_sym_SLASH] = ACTIONS(345),
    [anon_sym_class] = ACTIONS(347),
    [anon_sym_async] = ACTIONS(349),
    [anon_sym_function] = ACTIONS(351),
    [anon_sym_new] = ACTIONS(353),
    [anon_sym_PLUS] = ACTIONS(355),
    [anon_sym_DASH] = ACTIONS(355),
    [anon_sym_BANG] = ACTIONS(357),
    [anon_sym_TILDE] = ACTIONS(357),
    [anon_sym_typeof] = ACTIONS(359),
    [anon_sym_void] = ACTIONS(359),
    [anon_sym_delete] = ACTIONS(359),
    [anon_sym_PLUS_PLUS] = ACTIONS(361),
    [anon_sym_DASH_DASH] = ACTIONS(361),
    [anon_sym_DQUOTE] = ACTIONS(363),
    [anon_sym_SQUOTE] = ACTIONS(365),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(367),
    [sym_number] = ACTIONS(369),
    [sym_this] = ACTIONS(371),
    [sym_super] = ACTIONS(371),
    [sym_true] = ACTIONS(371),
    [sym_false] = ACTIONS(371),
    [sym_null] = ACTIONS(371),
    [sym_undefined] = ACTIONS(371),
    [anon_sym_AT] = ACTIONS(85),
    [anon_sym_static] = ACTIONS(323),
    [anon_sym_get] = ACTIONS(323),
    [anon_sym_set] = ACTIONS(323),
  },
  [175] = {
    [sym_import] = STATE(539),
    [sym_parenthesized_expression] = STATE(362),
    [sym_expression] = STATE(469),
    [sym_primary_expression] = STATE(546),
    [sym_yield_expression] = STATE(550),
    [sym_object] = STATE(539),
    [sym_object_pattern] = STATE(1320),
    [sym_array] = STATE(539),
    [sym_array_pattern] = STATE(1320),
    [sym_jsx_element] = STATE(550),
    [sym_jsx_fragment] = STATE(550),
    [sym_jsx_opening_element] = STATE(772),
    [sym_jsx_self_closing_element] = STATE(550),
    [sym_class] = STATE(539),
    [sym_function] = STATE(539),
    [sym_generator_function] = STATE(539),
    [sym_arrow_function] = STATE(539),
    [sym_call_expression] = STATE(539),
    [sym_new_expression] = STATE(550),
    [sym_await_expression] = STATE(550),
    [sym_member_expression] = STATE(362),
    [sym_subscript_expression] = STATE(362),
    [sym_assignment_expression] = STATE(550),
    [sym__augmented_assignment_lhs] = STATE(720),
    [sym_augmented_assignment_expression] = STATE(550),
    [sym__destructuring_pattern] = STATE(1320),
    [sym_ternary_expression] = STATE(550),
    [sym_binary_expression] = STATE(550),
    [sym_unary_expression] = STATE(550),
    [sym_update_expression] = STATE(550),
    [sym_string] = STATE(539),
    [sym_template_string] = STATE(539),
    [sym_regex] = STATE(539),
    [sym_meta_property] = STATE(539),
    [sym_decorator] = STATE(750),
    [sym_formal_parameters] = STATE(1318),
    [aux_sym_export_statement_repeat1] = STATE(925),
    [sym_identifier] = ACTIONS(373),
    [anon_sym_export] = ACTIONS(375),
    [anon_sym_LBRACE] = ACTIONS(379),
    [anon_sym_import] = ACTIONS(381),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(29),
    [anon_sym_yield] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(53),
    [anon_sym_LT] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(385),
    [anon_sym_async] = ACTIONS(387),
    [anon_sym_function] = ACTIONS(389),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_typeof] = ACTIONS(71),
    [anon_sym_void] = ACTIONS(71),
    [anon_sym_delete] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DQUOTE] = ACTIONS(75),
    [anon_sym_SQUOTE] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(79),
    [sym_number] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(83),
    [sym_true] = ACTIONS(83),
    [sym_false] = ACTIONS(83),
    [sym_null] = ACTIONS(83),
    [sym_undefined] = ACTIONS(83),
    [anon_sym_AT] = ACTIONS(85),
    [anon_sym_static] = ACTIONS(375),
    [anon_sym_get] = ACTIONS(375),
    [anon_sym_set] = ACTIONS(375),
  },
  [176] = {
    [sym_import] = STATE(426),
    [sym_parenthesized_expression] = STATE(355),
    [sym_expression] = STATE(405),
    [sym_primary_expression] = STATE(425),
    [sym_yield_expression] = STATE(424),
    [sym_object] = STATE(426),
    [sym_object_pattern] = STATE(1333),
    [sym_array] = STATE(426),
    [sym_array_pattern] = STATE(1333),
    [sym_jsx_element] = STATE(424),
    [sym_jsx_fragment] = STATE(424),
    [sym_jsx_opening_element] = STATE(768),
    [sym_jsx_self_closing_element] = STATE(424),
    [sym_class] = STATE(426),
    [sym_function] = STATE(426),
    [sym_generator_function] = STATE(426),
    [sym_arrow_function] = STATE(426),
    [sym_call_expression] = STATE(426),
    [sym_new_expression] = STATE(424),
    [sym_await_expression] = STATE(424),
    [sym_member_expression] = STATE(355),
    [sym_subscript_expression] = STATE(355),
    [sym_assignment_expression] = STATE(424),
    [sym__augmented_assignment_lhs] = STATE(714),
    [sym_augmented_assignment_expression] = STATE(424),
    [sym__destructuring_pattern] = STATE(1333),
    [sym_ternary_expression] = STATE(424),
    [sym_binary_expression] = STATE(424),
    [sym_unary_expression] = STATE(424),
    [sym_update_expression] = STATE(424),
    [sym_string] = STATE(426),
    [sym_template_string] = STATE(426),
    [sym_regex] = STATE(426),
    [sym_meta_property] = STATE(426),
    [sym_decorator] = STATE(750),
    [sym_formal_parameters] = STATE(1322),
    [aux_sym_export_statement_repeat1] = STATE(924),
    [sym_identifier] = ACTIONS(321),
    [anon_sym_export] = ACTIONS(323),
    [anon_sym_LBRACE] = ACTIONS(327),
    [anon_sym_import] = ACTIONS(331),
    [anon_sym_LPAREN] = ACTIONS(333),
    [anon_sym_await] = ACTIONS(335),
    [anon_sym_yield] = ACTIONS(339),
    [anon_sym_LBRACK] = ACTIONS(341),
    [anon_sym_LT] = ACTIONS(537),
    [anon_sym_SLASH] = ACTIONS(345),
    [anon_sym_class] = ACTIONS(347),
    [anon_sym_async] = ACTIONS(349),
    [anon_sym_function] = ACTIONS(351),
    [anon_sym_new] = ACTIONS(353),
    [anon_sym_PLUS] = ACTIONS(355),
    [anon_sym_DASH] = ACTIONS(355),
    [anon_sym_BANG] = ACTIONS(357),
    [anon_sym_TILDE] = ACTIONS(357),
    [anon_sym_typeof] = ACTIONS(359),
    [anon_sym_void] = ACTIONS(359),
    [anon_sym_delete] = ACTIONS(359),
    [anon_sym_PLUS_PLUS] = ACTIONS(361),
    [anon_sym_DASH_DASH] = ACTIONS(361),
    [anon_sym_DQUOTE] = ACTIONS(363),
    [anon_sym_SQUOTE] = ACTIONS(365),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(367),
    [sym_number] = ACTIONS(369),
    [sym_this] = ACTIONS(371),
    [sym_super] = ACTIONS(371),
    [sym_true] = ACTIONS(371),
    [sym_false] = ACTIONS(371),
    [sym_null] = ACTIONS(371),
    [sym_undefined] = ACTIONS(371),
    [anon_sym_AT] = ACTIONS(85),
    [anon_sym_static] = ACTIONS(323),
    [anon_sym_get] = ACTIONS(323),
    [anon_sym_set] = ACTIONS(323),
  },
  [177] = {
    [sym_import] = STATE(539),
    [sym_parenthesized_expression] = STATE(362),
    [sym_expression] = STATE(447),
    [sym_primary_expression] = STATE(546),
    [sym_yield_expression] = STATE(550),
    [sym_object] = STATE(539),
    [sym_object_pattern] = STATE(1320),
    [sym_array] = STATE(539),
    [sym_array_pattern] = STATE(1320),
    [sym_jsx_element] = STATE(550),
    [sym_jsx_fragment] = STATE(550),
    [sym_jsx_opening_element] = STATE(772),
    [sym_jsx_self_closing_element] = STATE(550),
    [sym_class] = STATE(539),
    [sym_function] = STATE(539),
    [sym_generator_function] = STATE(539),
    [sym_arrow_function] = STATE(539),
    [sym_call_expression] = STATE(539),
    [sym_new_expression] = STATE(550),
    [sym_await_expression] = STATE(550),
    [sym_member_expression] = STATE(362),
    [sym_subscript_expression] = STATE(362),
    [sym_assignment_expression] = STATE(550),
    [sym__augmented_assignment_lhs] = STATE(720),
    [sym_augmented_assignment_expression] = STATE(550),
    [sym__destructuring_pattern] = STATE(1320),
    [sym_ternary_expression] = STATE(550),
    [sym_binary_expression] = STATE(550),
    [sym_unary_expression] = STATE(550),
    [sym_update_expression] = STATE(550),
    [sym_string] = STATE(539),
    [sym_template_string] = STATE(539),
    [sym_regex] = STATE(539),
    [sym_meta_property] = STATE(539),
    [sym_decorator] = STATE(750),
    [sym_formal_parameters] = STATE(1318),
    [aux_sym_export_statement_repeat1] = STATE(925),
    [sym_identifier] = ACTIONS(373),
    [anon_sym_export] = ACTIONS(375),
    [anon_sym_LBRACE] = ACTIONS(379),
    [anon_sym_import] = ACTIONS(381),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(29),
    [anon_sym_yield] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(53),
    [anon_sym_LT] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(385),
    [anon_sym_async] = ACTIONS(387),
    [anon_sym_function] = ACTIONS(389),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_typeof] = ACTIONS(71),
    [anon_sym_void] = ACTIONS(71),
    [anon_sym_delete] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DQUOTE] = ACTIONS(75),
    [anon_sym_SQUOTE] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(79),
    [sym_number] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(83),
    [sym_true] = ACTIONS(83),
    [sym_false] = ACTIONS(83),
    [sym_null] = ACTIONS(83),
    [sym_undefined] = ACTIONS(83),
    [anon_sym_AT] = ACTIONS(85),
    [anon_sym_static] = ACTIONS(375),
    [anon_sym_get] = ACTIONS(375),
    [anon_sym_set] = ACTIONS(375),
  },
  [178] = {
    [sym_import] = STATE(426),
    [sym_parenthesized_expression] = STATE(355),
    [sym_expression] = STATE(630),
    [sym_primary_expression] = STATE(425),
    [sym_yield_expression] = STATE(424),
    [sym_object] = STATE(426),
    [sym_object_pattern] = STATE(1333),
    [sym_array] = STATE(426),
    [sym_array_pattern] = STATE(1333),
    [sym_jsx_element] = STATE(424),
    [sym_jsx_fragment] = STATE(424),
    [sym_jsx_opening_element] = STATE(768),
    [sym_jsx_self_closing_element] = STATE(424),
    [sym_class] = STATE(426),
    [sym_function] = STATE(426),
    [sym_generator_function] = STATE(426),
    [sym_arrow_function] = STATE(426),
    [sym_call_expression] = STATE(426),
    [sym_new_expression] = STATE(424),
    [sym_await_expression] = STATE(424),
    [sym_member_expression] = STATE(355),
    [sym_subscript_expression] = STATE(355),
    [sym_assignment_expression] = STATE(424),
    [sym__augmented_assignment_lhs] = STATE(714),
    [sym_augmented_assignment_expression] = STATE(424),
    [sym__destructuring_pattern] = STATE(1333),
    [sym_ternary_expression] = STATE(424),
    [sym_binary_expression] = STATE(424),
    [sym_unary_expression] = STATE(424),
    [sym_update_expression] = STATE(424),
    [sym_string] = STATE(426),
    [sym_template_string] = STATE(426),
    [sym_regex] = STATE(426),
    [sym_meta_property] = STATE(426),
    [sym_decorator] = STATE(750),
    [sym_formal_parameters] = STATE(1322),
    [aux_sym_export_statement_repeat1] = STATE(924),
    [sym_identifier] = ACTIONS(321),
    [anon_sym_export] = ACTIONS(323),
    [anon_sym_LBRACE] = ACTIONS(327),
    [anon_sym_import] = ACTIONS(331),
    [anon_sym_LPAREN] = ACTIONS(333),
    [anon_sym_await] = ACTIONS(335),
    [anon_sym_yield] = ACTIONS(339),
    [anon_sym_LBRACK] = ACTIONS(341),
    [anon_sym_LT] = ACTIONS(537),
    [anon_sym_SLASH] = ACTIONS(345),
    [anon_sym_class] = ACTIONS(347),
    [anon_sym_async] = ACTIONS(349),
    [anon_sym_function] = ACTIONS(351),
    [anon_sym_new] = ACTIONS(353),
    [anon_sym_PLUS] = ACTIONS(355),
    [anon_sym_DASH] = ACTIONS(355),
    [anon_sym_BANG] = ACTIONS(357),
    [anon_sym_TILDE] = ACTIONS(357),
    [anon_sym_typeof] = ACTIONS(359),
    [anon_sym_void] = ACTIONS(359),
    [anon_sym_delete] = ACTIONS(359),
    [anon_sym_PLUS_PLUS] = ACTIONS(361),
    [anon_sym_DASH_DASH] = ACTIONS(361),
    [anon_sym_DQUOTE] = ACTIONS(363),
    [anon_sym_SQUOTE] = ACTIONS(365),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(367),
    [sym_number] = ACTIONS(369),
    [sym_this] = ACTIONS(371),
    [sym_super] = ACTIONS(371),
    [sym_true] = ACTIONS(371),
    [sym_false] = ACTIONS(371),
    [sym_null] = ACTIONS(371),
    [sym_undefined] = ACTIONS(371),
    [anon_sym_AT] = ACTIONS(85),
    [anon_sym_static] = ACTIONS(323),
    [anon_sym_get] = ACTIONS(323),
    [anon_sym_set] = ACTIONS(323),
  },
  [179] = {
    [sym_import] = STATE(539),
    [sym_parenthesized_expression] = STATE(362),
    [sym_expression] = STATE(482),
    [sym_primary_expression] = STATE(546),
    [sym_yield_expression] = STATE(550),
    [sym_object] = STATE(539),
    [sym_object_pattern] = STATE(1320),
    [sym_array] = STATE(539),
    [sym_array_pattern] = STATE(1320),
    [sym_jsx_element] = STATE(550),
    [sym_jsx_fragment] = STATE(550),
    [sym_jsx_opening_element] = STATE(772),
    [sym_jsx_self_closing_element] = STATE(550),
    [sym_class] = STATE(539),
    [sym_function] = STATE(539),
    [sym_generator_function] = STATE(539),
    [sym_arrow_function] = STATE(539),
    [sym_call_expression] = STATE(539),
    [sym_new_expression] = STATE(550),
    [sym_await_expression] = STATE(550),
    [sym_member_expression] = STATE(362),
    [sym_subscript_expression] = STATE(362),
    [sym_assignment_expression] = STATE(550),
    [sym__augmented_assignment_lhs] = STATE(720),
    [sym_augmented_assignment_expression] = STATE(550),
    [sym__destructuring_pattern] = STATE(1320),
    [sym_ternary_expression] = STATE(550),
    [sym_binary_expression] = STATE(550),
    [sym_unary_expression] = STATE(550),
    [sym_update_expression] = STATE(550),
    [sym_string] = STATE(539),
    [sym_template_string] = STATE(539),
    [sym_regex] = STATE(539),
    [sym_meta_property] = STATE(539),
    [sym_decorator] = STATE(750),
    [sym_formal_parameters] = STATE(1318),
    [aux_sym_export_statement_repeat1] = STATE(925),
    [sym_identifier] = ACTIONS(373),
    [anon_sym_export] = ACTIONS(375),
    [anon_sym_LBRACE] = ACTIONS(379),
    [anon_sym_import] = ACTIONS(381),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(29),
    [anon_sym_yield] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(53),
    [anon_sym_LT] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(385),
    [anon_sym_async] = ACTIONS(387),
    [anon_sym_function] = ACTIONS(389),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_typeof] = ACTIONS(71),
    [anon_sym_void] = ACTIONS(71),
    [anon_sym_delete] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DQUOTE] = ACTIONS(75),
    [anon_sym_SQUOTE] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(79),
    [sym_number] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(83),
    [sym_true] = ACTIONS(83),
    [sym_false] = ACTIONS(83),
    [sym_null] = ACTIONS(83),
    [sym_undefined] = ACTIONS(83),
    [anon_sym_AT] = ACTIONS(85),
    [anon_sym_static] = ACTIONS(375),
    [anon_sym_get] = ACTIONS(375),
    [anon_sym_set] = ACTIONS(375),
  },
  [180] = {
    [sym_import] = STATE(539),
    [sym_parenthesized_expression] = STATE(362),
    [sym_expression] = STATE(427),
    [sym_primary_expression] = STATE(546),
    [sym_yield_expression] = STATE(550),
    [sym_object] = STATE(539),
    [sym_object_pattern] = STATE(1320),
    [sym_array] = STATE(539),
    [sym_array_pattern] = STATE(1320),
    [sym_jsx_element] = STATE(550),
    [sym_jsx_fragment] = STATE(550),
    [sym_jsx_opening_element] = STATE(772),
    [sym_jsx_self_closing_element] = STATE(550),
    [sym_class] = STATE(539),
    [sym_function] = STATE(539),
    [sym_generator_function] = STATE(539),
    [sym_arrow_function] = STATE(539),
    [sym_call_expression] = STATE(539),
    [sym_new_expression] = STATE(550),
    [sym_await_expression] = STATE(550),
    [sym_member_expression] = STATE(362),
    [sym_subscript_expression] = STATE(362),
    [sym_assignment_expression] = STATE(550),
    [sym__augmented_assignment_lhs] = STATE(720),
    [sym_augmented_assignment_expression] = STATE(550),
    [sym__destructuring_pattern] = STATE(1320),
    [sym_ternary_expression] = STATE(550),
    [sym_binary_expression] = STATE(550),
    [sym_unary_expression] = STATE(550),
    [sym_update_expression] = STATE(550),
    [sym_string] = STATE(539),
    [sym_template_string] = STATE(539),
    [sym_regex] = STATE(539),
    [sym_meta_property] = STATE(539),
    [sym_decorator] = STATE(750),
    [sym_formal_parameters] = STATE(1318),
    [aux_sym_export_statement_repeat1] = STATE(925),
    [sym_identifier] = ACTIONS(373),
    [anon_sym_export] = ACTIONS(375),
    [anon_sym_LBRACE] = ACTIONS(379),
    [anon_sym_import] = ACTIONS(381),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(29),
    [anon_sym_yield] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(53),
    [anon_sym_LT] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(385),
    [anon_sym_async] = ACTIONS(387),
    [anon_sym_function] = ACTIONS(389),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_typeof] = ACTIONS(71),
    [anon_sym_void] = ACTIONS(71),
    [anon_sym_delete] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DQUOTE] = ACTIONS(75),
    [anon_sym_SQUOTE] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(79),
    [sym_number] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(83),
    [sym_true] = ACTIONS(83),
    [sym_false] = ACTIONS(83),
    [sym_null] = ACTIONS(83),
    [sym_undefined] = ACTIONS(83),
    [anon_sym_AT] = ACTIONS(85),
    [anon_sym_static] = ACTIONS(375),
    [anon_sym_get] = ACTIONS(375),
    [anon_sym_set] = ACTIONS(375),
  },
  [181] = {
    [sym_import] = STATE(539),
    [sym_parenthesized_expression] = STATE(362),
    [sym_expression] = STATE(446),
    [sym_primary_expression] = STATE(546),
    [sym_yield_expression] = STATE(550),
    [sym_object] = STATE(539),
    [sym_object_pattern] = STATE(1320),
    [sym_array] = STATE(539),
    [sym_array_pattern] = STATE(1320),
    [sym_jsx_element] = STATE(550),
    [sym_jsx_fragment] = STATE(550),
    [sym_jsx_opening_element] = STATE(772),
    [sym_jsx_self_closing_element] = STATE(550),
    [sym_class] = STATE(539),
    [sym_function] = STATE(539),
    [sym_generator_function] = STATE(539),
    [sym_arrow_function] = STATE(539),
    [sym_call_expression] = STATE(539),
    [sym_new_expression] = STATE(550),
    [sym_await_expression] = STATE(550),
    [sym_member_expression] = STATE(362),
    [sym_subscript_expression] = STATE(362),
    [sym_assignment_expression] = STATE(550),
    [sym__augmented_assignment_lhs] = STATE(720),
    [sym_augmented_assignment_expression] = STATE(550),
    [sym__destructuring_pattern] = STATE(1320),
    [sym_ternary_expression] = STATE(550),
    [sym_binary_expression] = STATE(550),
    [sym_unary_expression] = STATE(550),
    [sym_update_expression] = STATE(550),
    [sym_string] = STATE(539),
    [sym_template_string] = STATE(539),
    [sym_regex] = STATE(539),
    [sym_meta_property] = STATE(539),
    [sym_decorator] = STATE(750),
    [sym_formal_parameters] = STATE(1318),
    [aux_sym_export_statement_repeat1] = STATE(925),
    [sym_identifier] = ACTIONS(373),
    [anon_sym_export] = ACTIONS(375),
    [anon_sym_LBRACE] = ACTIONS(379),
    [anon_sym_import] = ACTIONS(381),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(29),
    [anon_sym_yield] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(53),
    [anon_sym_LT] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(385),
    [anon_sym_async] = ACTIONS(387),
    [anon_sym_function] = ACTIONS(389),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_typeof] = ACTIONS(71),
    [anon_sym_void] = ACTIONS(71),
    [anon_sym_delete] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DQUOTE] = ACTIONS(75),
    [anon_sym_SQUOTE] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(79),
    [sym_number] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(83),
    [sym_true] = ACTIONS(83),
    [sym_false] = ACTIONS(83),
    [sym_null] = ACTIONS(83),
    [sym_undefined] = ACTIONS(83),
    [anon_sym_AT] = ACTIONS(85),
    [anon_sym_static] = ACTIONS(375),
    [anon_sym_get] = ACTIONS(375),
    [anon_sym_set] = ACTIONS(375),
  },
  [182] = {
    [sym_import] = STATE(426),
    [sym_parenthesized_expression] = STATE(355),
    [sym_expression] = STATE(498),
    [sym_primary_expression] = STATE(425),
    [sym_yield_expression] = STATE(424),
    [sym_object] = STATE(426),
    [sym_object_pattern] = STATE(1070),
    [sym_array] = STATE(426),
    [sym_array_pattern] = STATE(1070),
    [sym_jsx_element] = STATE(424),
    [sym_jsx_fragment] = STATE(424),
    [sym_jsx_opening_element] = STATE(768),
    [sym_jsx_self_closing_element] = STATE(424),
    [sym_class] = STATE(426),
    [sym_function] = STATE(426),
    [sym_generator_function] = STATE(426),
    [sym_arrow_function] = STATE(426),
    [sym_call_expression] = STATE(426),
    [sym_new_expression] = STATE(424),
    [sym_await_expression] = STATE(424),
    [sym_member_expression] = STATE(355),
    [sym_subscript_expression] = STATE(355),
    [sym_assignment_expression] = STATE(424),
    [sym__augmented_assignment_lhs] = STATE(714),
    [sym_augmented_assignment_expression] = STATE(424),
    [sym__destructuring_pattern] = STATE(1070),
    [sym_ternary_expression] = STATE(424),
    [sym_binary_expression] = STATE(424),
    [sym_unary_expression] = STATE(424),
    [sym_update_expression] = STATE(424),
    [sym_string] = STATE(426),
    [sym_template_string] = STATE(426),
    [sym_regex] = STATE(426),
    [sym_meta_property] = STATE(426),
    [sym_decorator] = STATE(750),
    [sym_formal_parameters] = STATE(1322),
    [aux_sym_export_statement_repeat1] = STATE(924),
    [sym_identifier] = ACTIONS(690),
    [anon_sym_export] = ACTIONS(323),
    [anon_sym_LBRACE] = ACTIONS(397),
    [anon_sym_import] = ACTIONS(331),
    [anon_sym_LPAREN] = ACTIONS(333),
    [anon_sym_await] = ACTIONS(335),
    [anon_sym_yield] = ACTIONS(339),
    [anon_sym_LBRACK] = ACTIONS(403),
    [anon_sym_LT] = ACTIONS(537),
    [anon_sym_SLASH] = ACTIONS(345),
    [anon_sym_class] = ACTIONS(347),
    [anon_sym_async] = ACTIONS(349),
    [anon_sym_function] = ACTIONS(351),
    [anon_sym_new] = ACTIONS(353),
    [anon_sym_PLUS] = ACTIONS(355),
    [anon_sym_DASH] = ACTIONS(355),
    [anon_sym_BANG] = ACTIONS(357),
    [anon_sym_TILDE] = ACTIONS(357),
    [anon_sym_typeof] = ACTIONS(359),
    [anon_sym_void] = ACTIONS(359),
    [anon_sym_delete] = ACTIONS(359),
    [anon_sym_PLUS_PLUS] = ACTIONS(361),
    [anon_sym_DASH_DASH] = ACTIONS(361),
    [anon_sym_DQUOTE] = ACTIONS(363),
    [anon_sym_SQUOTE] = ACTIONS(365),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(367),
    [sym_number] = ACTIONS(369),
    [sym_this] = ACTIONS(371),
    [sym_super] = ACTIONS(371),
    [sym_true] = ACTIONS(371),
    [sym_false] = ACTIONS(371),
    [sym_null] = ACTIONS(371),
    [sym_undefined] = ACTIONS(371),
    [anon_sym_AT] = ACTIONS(85),
    [anon_sym_static] = ACTIONS(323),
    [anon_sym_get] = ACTIONS(323),
    [anon_sym_set] = ACTIONS(323),
  },
  [183] = {
    [sym_import] = STATE(539),
    [sym_parenthesized_expression] = STATE(362),
    [sym_expression] = STATE(445),
    [sym_primary_expression] = STATE(546),
    [sym_yield_expression] = STATE(550),
    [sym_object] = STATE(539),
    [sym_object_pattern] = STATE(1320),
    [sym_array] = STATE(539),
    [sym_array_pattern] = STATE(1320),
    [sym_jsx_element] = STATE(550),
    [sym_jsx_fragment] = STATE(550),
    [sym_jsx_opening_element] = STATE(772),
    [sym_jsx_self_closing_element] = STATE(550),
    [sym_class] = STATE(539),
    [sym_function] = STATE(539),
    [sym_generator_function] = STATE(539),
    [sym_arrow_function] = STATE(539),
    [sym_call_expression] = STATE(539),
    [sym_new_expression] = STATE(550),
    [sym_await_expression] = STATE(550),
    [sym_member_expression] = STATE(362),
    [sym_subscript_expression] = STATE(362),
    [sym_assignment_expression] = STATE(550),
    [sym__augmented_assignment_lhs] = STATE(720),
    [sym_augmented_assignment_expression] = STATE(550),
    [sym__destructuring_pattern] = STATE(1320),
    [sym_ternary_expression] = STATE(550),
    [sym_binary_expression] = STATE(550),
    [sym_unary_expression] = STATE(550),
    [sym_update_expression] = STATE(550),
    [sym_string] = STATE(539),
    [sym_template_string] = STATE(539),
    [sym_regex] = STATE(539),
    [sym_meta_property] = STATE(539),
    [sym_decorator] = STATE(750),
    [sym_formal_parameters] = STATE(1318),
    [aux_sym_export_statement_repeat1] = STATE(925),
    [sym_identifier] = ACTIONS(373),
    [anon_sym_export] = ACTIONS(375),
    [anon_sym_LBRACE] = ACTIONS(379),
    [anon_sym_import] = ACTIONS(381),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(29),
    [anon_sym_yield] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(53),
    [anon_sym_LT] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(385),
    [anon_sym_async] = ACTIONS(387),
    [anon_sym_function] = ACTIONS(389),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_typeof] = ACTIONS(71),
    [anon_sym_void] = ACTIONS(71),
    [anon_sym_delete] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DQUOTE] = ACTIONS(75),
    [anon_sym_SQUOTE] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(79),
    [sym_number] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(83),
    [sym_true] = ACTIONS(83),
    [sym_false] = ACTIONS(83),
    [sym_null] = ACTIONS(83),
    [sym_undefined] = ACTIONS(83),
    [anon_sym_AT] = ACTIONS(85),
    [anon_sym_static] = ACTIONS(375),
    [anon_sym_get] = ACTIONS(375),
    [anon_sym_set] = ACTIONS(375),
  },
  [184] = {
    [sym_import] = STATE(426),
    [sym_parenthesized_expression] = STATE(340),
    [sym_expression] = STATE(629),
    [sym_primary_expression] = STATE(425),
    [sym_yield_expression] = STATE(424),
    [sym_object] = STATE(426),
    [sym_object_pattern] = STATE(1317),
    [sym_array] = STATE(426),
    [sym_array_pattern] = STATE(1317),
    [sym_jsx_element] = STATE(424),
    [sym_jsx_fragment] = STATE(424),
    [sym_jsx_opening_element] = STATE(768),
    [sym_jsx_self_closing_element] = STATE(424),
    [sym_class] = STATE(426),
    [sym_function] = STATE(426),
    [sym_generator_function] = STATE(426),
    [sym_arrow_function] = STATE(426),
    [sym_call_expression] = STATE(426),
    [sym_new_expression] = STATE(424),
    [sym_await_expression] = STATE(424),
    [sym_member_expression] = STATE(340),
    [sym_subscript_expression] = STATE(340),
    [sym_assignment_expression] = STATE(424),
    [sym__augmented_assignment_lhs] = STATE(712),
    [sym_augmented_assignment_expression] = STATE(424),
    [sym__destructuring_pattern] = STATE(1317),
    [sym_ternary_expression] = STATE(424),
    [sym_binary_expression] = STATE(424),
    [sym_unary_expression] = STATE(424),
    [sym_update_expression] = STATE(424),
    [sym_string] = STATE(426),
    [sym_template_string] = STATE(426),
    [sym_regex] = STATE(426),
    [sym_meta_property] = STATE(426),
    [sym_decorator] = STATE(750),
    [sym_formal_parameters] = STATE(1267),
    [aux_sym_export_statement_repeat1] = STATE(924),
    [sym_identifier] = ACTIONS(391),
    [anon_sym_export] = ACTIONS(393),
    [anon_sym_LBRACE] = ACTIONS(397),
    [anon_sym_import] = ACTIONS(331),
    [anon_sym_LPAREN] = ACTIONS(333),
    [anon_sym_await] = ACTIONS(399),
    [anon_sym_yield] = ACTIONS(401),
    [anon_sym_LBRACK] = ACTIONS(403),
    [anon_sym_LT] = ACTIONS(537),
    [anon_sym_SLASH] = ACTIONS(345),
    [anon_sym_class] = ACTIONS(347),
    [anon_sym_async] = ACTIONS(405),
    [anon_sym_function] = ACTIONS(351),
    [anon_sym_new] = ACTIONS(407),
    [anon_sym_PLUS] = ACTIONS(409),
    [anon_sym_DASH] = ACTIONS(409),
    [anon_sym_BANG] = ACTIONS(411),
    [anon_sym_TILDE] = ACTIONS(411),
    [anon_sym_typeof] = ACTIONS(413),
    [anon_sym_void] = ACTIONS(413),
    [anon_sym_delete] = ACTIONS(413),
    [anon_sym_PLUS_PLUS] = ACTIONS(415),
    [anon_sym_DASH_DASH] = ACTIONS(415),
    [anon_sym_DQUOTE] = ACTIONS(363),
    [anon_sym_SQUOTE] = ACTIONS(365),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(367),
    [sym_number] = ACTIONS(369),
    [sym_this] = ACTIONS(371),
    [sym_super] = ACTIONS(371),
    [sym_true] = ACTIONS(371),
    [sym_false] = ACTIONS(371),
    [sym_null] = ACTIONS(371),
    [sym_undefined] = ACTIONS(371),
    [anon_sym_AT] = ACTIONS(85),
    [anon_sym_static] = ACTIONS(393),
    [anon_sym_get] = ACTIONS(393),
    [anon_sym_set] = ACTIONS(393),
  },
  [185] = {
    [sym_import] = STATE(539),
    [sym_parenthesized_expression] = STATE(362),
    [sym_expression] = STATE(432),
    [sym_primary_expression] = STATE(546),
    [sym_yield_expression] = STATE(550),
    [sym_object] = STATE(539),
    [sym_object_pattern] = STATE(1320),
    [sym_array] = STATE(539),
    [sym_array_pattern] = STATE(1320),
    [sym_jsx_element] = STATE(550),
    [sym_jsx_fragment] = STATE(550),
    [sym_jsx_opening_element] = STATE(772),
    [sym_jsx_self_closing_element] = STATE(550),
    [sym_class] = STATE(539),
    [sym_function] = STATE(539),
    [sym_generator_function] = STATE(539),
    [sym_arrow_function] = STATE(539),
    [sym_call_expression] = STATE(539),
    [sym_new_expression] = STATE(550),
    [sym_await_expression] = STATE(550),
    [sym_member_expression] = STATE(362),
    [sym_subscript_expression] = STATE(362),
    [sym_assignment_expression] = STATE(550),
    [sym__augmented_assignment_lhs] = STATE(720),
    [sym_augmented_assignment_expression] = STATE(550),
    [sym__destructuring_pattern] = STATE(1320),
    [sym_ternary_expression] = STATE(550),
    [sym_binary_expression] = STATE(550),
    [sym_unary_expression] = STATE(550),
    [sym_update_expression] = STATE(550),
    [sym_string] = STATE(539),
    [sym_template_string] = STATE(539),
    [sym_regex] = STATE(539),
    [sym_meta_property] = STATE(539),
    [sym_decorator] = STATE(750),
    [sym_formal_parameters] = STATE(1318),
    [aux_sym_export_statement_repeat1] = STATE(925),
    [sym_identifier] = ACTIONS(373),
    [anon_sym_export] = ACTIONS(375),
    [anon_sym_LBRACE] = ACTIONS(379),
    [anon_sym_import] = ACTIONS(381),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(29),
    [anon_sym_yield] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(53),
    [anon_sym_LT] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(385),
    [anon_sym_async] = ACTIONS(387),
    [anon_sym_function] = ACTIONS(389),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_typeof] = ACTIONS(71),
    [anon_sym_void] = ACTIONS(71),
    [anon_sym_delete] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DQUOTE] = ACTIONS(75),
    [anon_sym_SQUOTE] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(79),
    [sym_number] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(83),
    [sym_true] = ACTIONS(83),
    [sym_false] = ACTIONS(83),
    [sym_null] = ACTIONS(83),
    [sym_undefined] = ACTIONS(83),
    [anon_sym_AT] = ACTIONS(85),
    [anon_sym_static] = ACTIONS(375),
    [anon_sym_get] = ACTIONS(375),
    [anon_sym_set] = ACTIONS(375),
  },
  [186] = {
    [sym_import] = STATE(426),
    [sym_parenthesized_expression] = STATE(340),
    [sym_expression] = STATE(544),
    [sym_primary_expression] = STATE(425),
    [sym_yield_expression] = STATE(424),
    [sym_object] = STATE(426),
    [sym_object_pattern] = STATE(1317),
    [sym_array] = STATE(426),
    [sym_array_pattern] = STATE(1317),
    [sym_jsx_element] = STATE(424),
    [sym_jsx_fragment] = STATE(424),
    [sym_jsx_opening_element] = STATE(768),
    [sym_jsx_self_closing_element] = STATE(424),
    [sym_class] = STATE(426),
    [sym_function] = STATE(426),
    [sym_generator_function] = STATE(426),
    [sym_arrow_function] = STATE(426),
    [sym_call_expression] = STATE(426),
    [sym_new_expression] = STATE(424),
    [sym_await_expression] = STATE(424),
    [sym_member_expression] = STATE(340),
    [sym_subscript_expression] = STATE(340),
    [sym_assignment_expression] = STATE(424),
    [sym__augmented_assignment_lhs] = STATE(712),
    [sym_augmented_assignment_expression] = STATE(424),
    [sym__destructuring_pattern] = STATE(1317),
    [sym_ternary_expression] = STATE(424),
    [sym_binary_expression] = STATE(424),
    [sym_unary_expression] = STATE(424),
    [sym_update_expression] = STATE(424),
    [sym_string] = STATE(426),
    [sym_template_string] = STATE(426),
    [sym_regex] = STATE(426),
    [sym_meta_property] = STATE(426),
    [sym_decorator] = STATE(750),
    [sym_formal_parameters] = STATE(1267),
    [aux_sym_export_statement_repeat1] = STATE(924),
    [sym_identifier] = ACTIONS(391),
    [anon_sym_export] = ACTIONS(393),
    [anon_sym_LBRACE] = ACTIONS(397),
    [anon_sym_import] = ACTIONS(331),
    [anon_sym_LPAREN] = ACTIONS(333),
    [anon_sym_await] = ACTIONS(399),
    [anon_sym_yield] = ACTIONS(401),
    [anon_sym_LBRACK] = ACTIONS(403),
    [anon_sym_LT] = ACTIONS(537),
    [anon_sym_SLASH] = ACTIONS(345),
    [anon_sym_class] = ACTIONS(347),
    [anon_sym_async] = ACTIONS(405),
    [anon_sym_function] = ACTIONS(351),
    [anon_sym_new] = ACTIONS(407),
    [anon_sym_PLUS] = ACTIONS(409),
    [anon_sym_DASH] = ACTIONS(409),
    [anon_sym_BANG] = ACTIONS(411),
    [anon_sym_TILDE] = ACTIONS(411),
    [anon_sym_typeof] = ACTIONS(413),
    [anon_sym_void] = ACTIONS(413),
    [anon_sym_delete] = ACTIONS(413),
    [anon_sym_PLUS_PLUS] = ACTIONS(415),
    [anon_sym_DASH_DASH] = ACTIONS(415),
    [anon_sym_DQUOTE] = ACTIONS(363),
    [anon_sym_SQUOTE] = ACTIONS(365),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(367),
    [sym_number] = ACTIONS(369),
    [sym_this] = ACTIONS(371),
    [sym_super] = ACTIONS(371),
    [sym_true] = ACTIONS(371),
    [sym_false] = ACTIONS(371),
    [sym_null] = ACTIONS(371),
    [sym_undefined] = ACTIONS(371),
    [anon_sym_AT] = ACTIONS(85),
    [anon_sym_static] = ACTIONS(393),
    [anon_sym_get] = ACTIONS(393),
    [anon_sym_set] = ACTIONS(393),
  },
  [187] = {
    [sym_import] = STATE(539),
    [sym_parenthesized_expression] = STATE(362),
    [sym_expression] = STATE(562),
    [sym_primary_expression] = STATE(546),
    [sym_yield_expression] = STATE(550),
    [sym_object] = STATE(539),
    [sym_object_pattern] = STATE(1320),
    [sym_array] = STATE(539),
    [sym_array_pattern] = STATE(1320),
    [sym_jsx_element] = STATE(550),
    [sym_jsx_fragment] = STATE(550),
    [sym_jsx_opening_element] = STATE(772),
    [sym_jsx_self_closing_element] = STATE(550),
    [sym_class] = STATE(539),
    [sym_function] = STATE(539),
    [sym_generator_function] = STATE(539),
    [sym_arrow_function] = STATE(539),
    [sym_call_expression] = STATE(539),
    [sym_new_expression] = STATE(550),
    [sym_await_expression] = STATE(550),
    [sym_member_expression] = STATE(362),
    [sym_subscript_expression] = STATE(362),
    [sym_assignment_expression] = STATE(550),
    [sym__augmented_assignment_lhs] = STATE(720),
    [sym_augmented_assignment_expression] = STATE(550),
    [sym__destructuring_pattern] = STATE(1320),
    [sym_ternary_expression] = STATE(550),
    [sym_binary_expression] = STATE(550),
    [sym_unary_expression] = STATE(550),
    [sym_update_expression] = STATE(550),
    [sym_string] = STATE(539),
    [sym_template_string] = STATE(539),
    [sym_regex] = STATE(539),
    [sym_meta_property] = STATE(539),
    [sym_decorator] = STATE(750),
    [sym_formal_parameters] = STATE(1318),
    [aux_sym_export_statement_repeat1] = STATE(925),
    [sym_identifier] = ACTIONS(373),
    [anon_sym_export] = ACTIONS(375),
    [anon_sym_LBRACE] = ACTIONS(379),
    [anon_sym_import] = ACTIONS(381),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(29),
    [anon_sym_yield] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(53),
    [anon_sym_LT] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(385),
    [anon_sym_async] = ACTIONS(387),
    [anon_sym_function] = ACTIONS(389),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_typeof] = ACTIONS(71),
    [anon_sym_void] = ACTIONS(71),
    [anon_sym_delete] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DQUOTE] = ACTIONS(75),
    [anon_sym_SQUOTE] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(79),
    [sym_number] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(83),
    [sym_true] = ACTIONS(83),
    [sym_false] = ACTIONS(83),
    [sym_null] = ACTIONS(83),
    [sym_undefined] = ACTIONS(83),
    [anon_sym_AT] = ACTIONS(85),
    [anon_sym_static] = ACTIONS(375),
    [anon_sym_get] = ACTIONS(375),
    [anon_sym_set] = ACTIONS(375),
  },
  [188] = {
    [sym_import] = STATE(539),
    [sym_parenthesized_expression] = STATE(362),
    [sym_expression] = STATE(439),
    [sym_primary_expression] = STATE(546),
    [sym_yield_expression] = STATE(550),
    [sym_object] = STATE(539),
    [sym_object_pattern] = STATE(1320),
    [sym_array] = STATE(539),
    [sym_array_pattern] = STATE(1320),
    [sym_jsx_element] = STATE(550),
    [sym_jsx_fragment] = STATE(550),
    [sym_jsx_opening_element] = STATE(772),
    [sym_jsx_self_closing_element] = STATE(550),
    [sym_class] = STATE(539),
    [sym_function] = STATE(539),
    [sym_generator_function] = STATE(539),
    [sym_arrow_function] = STATE(539),
    [sym_call_expression] = STATE(539),
    [sym_new_expression] = STATE(550),
    [sym_await_expression] = STATE(550),
    [sym_member_expression] = STATE(362),
    [sym_subscript_expression] = STATE(362),
    [sym_assignment_expression] = STATE(550),
    [sym__augmented_assignment_lhs] = STATE(720),
    [sym_augmented_assignment_expression] = STATE(550),
    [sym__destructuring_pattern] = STATE(1320),
    [sym_ternary_expression] = STATE(550),
    [sym_binary_expression] = STATE(550),
    [sym_unary_expression] = STATE(550),
    [sym_update_expression] = STATE(550),
    [sym_string] = STATE(539),
    [sym_template_string] = STATE(539),
    [sym_regex] = STATE(539),
    [sym_meta_property] = STATE(539),
    [sym_decorator] = STATE(750),
    [sym_formal_parameters] = STATE(1318),
    [aux_sym_export_statement_repeat1] = STATE(925),
    [sym_identifier] = ACTIONS(373),
    [anon_sym_export] = ACTIONS(375),
    [anon_sym_LBRACE] = ACTIONS(379),
    [anon_sym_import] = ACTIONS(381),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(29),
    [anon_sym_yield] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(53),
    [anon_sym_LT] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(385),
    [anon_sym_async] = ACTIONS(387),
    [anon_sym_function] = ACTIONS(389),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_typeof] = ACTIONS(71),
    [anon_sym_void] = ACTIONS(71),
    [anon_sym_delete] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DQUOTE] = ACTIONS(75),
    [anon_sym_SQUOTE] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(79),
    [sym_number] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(83),
    [sym_true] = ACTIONS(83),
    [sym_false] = ACTIONS(83),
    [sym_null] = ACTIONS(83),
    [sym_undefined] = ACTIONS(83),
    [anon_sym_AT] = ACTIONS(85),
    [anon_sym_static] = ACTIONS(375),
    [anon_sym_get] = ACTIONS(375),
    [anon_sym_set] = ACTIONS(375),
  },
  [189] = {
    [sym_import] = STATE(426),
    [sym_parenthesized_expression] = STATE(340),
    [sym_expression] = STATE(385),
    [sym_primary_expression] = STATE(425),
    [sym_yield_expression] = STATE(424),
    [sym_object] = STATE(426),
    [sym_object_pattern] = STATE(1317),
    [sym_array] = STATE(426),
    [sym_array_pattern] = STATE(1317),
    [sym_jsx_element] = STATE(424),
    [sym_jsx_fragment] = STATE(424),
    [sym_jsx_opening_element] = STATE(768),
    [sym_jsx_self_closing_element] = STATE(424),
    [sym_class] = STATE(426),
    [sym_function] = STATE(426),
    [sym_generator_function] = STATE(426),
    [sym_arrow_function] = STATE(426),
    [sym_call_expression] = STATE(426),
    [sym_new_expression] = STATE(424),
    [sym_await_expression] = STATE(424),
    [sym_member_expression] = STATE(340),
    [sym_subscript_expression] = STATE(340),
    [sym_assignment_expression] = STATE(424),
    [sym__augmented_assignment_lhs] = STATE(712),
    [sym_augmented_assignment_expression] = STATE(424),
    [sym__destructuring_pattern] = STATE(1317),
    [sym_ternary_expression] = STATE(424),
    [sym_binary_expression] = STATE(424),
    [sym_unary_expression] = STATE(424),
    [sym_update_expression] = STATE(424),
    [sym_string] = STATE(426),
    [sym_template_string] = STATE(426),
    [sym_regex] = STATE(426),
    [sym_meta_property] = STATE(426),
    [sym_decorator] = STATE(750),
    [sym_formal_parameters] = STATE(1267),
    [aux_sym_export_statement_repeat1] = STATE(924),
    [sym_identifier] = ACTIONS(391),
    [anon_sym_export] = ACTIONS(393),
    [anon_sym_LBRACE] = ACTIONS(397),
    [anon_sym_import] = ACTIONS(331),
    [anon_sym_LPAREN] = ACTIONS(333),
    [anon_sym_await] = ACTIONS(399),
    [anon_sym_yield] = ACTIONS(401),
    [anon_sym_LBRACK] = ACTIONS(403),
    [anon_sym_LT] = ACTIONS(537),
    [anon_sym_SLASH] = ACTIONS(345),
    [anon_sym_class] = ACTIONS(347),
    [anon_sym_async] = ACTIONS(405),
    [anon_sym_function] = ACTIONS(351),
    [anon_sym_new] = ACTIONS(407),
    [anon_sym_PLUS] = ACTIONS(409),
    [anon_sym_DASH] = ACTIONS(409),
    [anon_sym_BANG] = ACTIONS(411),
    [anon_sym_TILDE] = ACTIONS(411),
    [anon_sym_typeof] = ACTIONS(413),
    [anon_sym_void] = ACTIONS(413),
    [anon_sym_delete] = ACTIONS(413),
    [anon_sym_PLUS_PLUS] = ACTIONS(415),
    [anon_sym_DASH_DASH] = ACTIONS(415),
    [anon_sym_DQUOTE] = ACTIONS(363),
    [anon_sym_SQUOTE] = ACTIONS(365),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(367),
    [sym_number] = ACTIONS(369),
    [sym_this] = ACTIONS(371),
    [sym_super] = ACTIONS(371),
    [sym_true] = ACTIONS(371),
    [sym_false] = ACTIONS(371),
    [sym_null] = ACTIONS(371),
    [sym_undefined] = ACTIONS(371),
    [anon_sym_AT] = ACTIONS(85),
    [anon_sym_static] = ACTIONS(393),
    [anon_sym_get] = ACTIONS(393),
    [anon_sym_set] = ACTIONS(393),
  },
  [190] = {
    [sym_import] = STATE(539),
    [sym_parenthesized_expression] = STATE(362),
    [sym_expression] = STATE(442),
    [sym_primary_expression] = STATE(546),
    [sym_yield_expression] = STATE(550),
    [sym_object] = STATE(539),
    [sym_object_pattern] = STATE(1320),
    [sym_array] = STATE(539),
    [sym_array_pattern] = STATE(1320),
    [sym_jsx_element] = STATE(550),
    [sym_jsx_fragment] = STATE(550),
    [sym_jsx_opening_element] = STATE(772),
    [sym_jsx_self_closing_element] = STATE(550),
    [sym_class] = STATE(539),
    [sym_function] = STATE(539),
    [sym_generator_function] = STATE(539),
    [sym_arrow_function] = STATE(539),
    [sym_call_expression] = STATE(539),
    [sym_new_expression] = STATE(550),
    [sym_await_expression] = STATE(550),
    [sym_member_expression] = STATE(362),
    [sym_subscript_expression] = STATE(362),
    [sym_assignment_expression] = STATE(550),
    [sym__augmented_assignment_lhs] = STATE(720),
    [sym_augmented_assignment_expression] = STATE(550),
    [sym__destructuring_pattern] = STATE(1320),
    [sym_ternary_expression] = STATE(550),
    [sym_binary_expression] = STATE(550),
    [sym_unary_expression] = STATE(550),
    [sym_update_expression] = STATE(550),
    [sym_string] = STATE(539),
    [sym_template_string] = STATE(539),
    [sym_regex] = STATE(539),
    [sym_meta_property] = STATE(539),
    [sym_decorator] = STATE(750),
    [sym_formal_parameters] = STATE(1318),
    [aux_sym_export_statement_repeat1] = STATE(925),
    [sym_identifier] = ACTIONS(373),
    [anon_sym_export] = ACTIONS(375),
    [anon_sym_LBRACE] = ACTIONS(379),
    [anon_sym_import] = ACTIONS(381),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(29),
    [anon_sym_yield] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(53),
    [anon_sym_LT] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(385),
    [anon_sym_async] = ACTIONS(387),
    [anon_sym_function] = ACTIONS(389),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_typeof] = ACTIONS(71),
    [anon_sym_void] = ACTIONS(71),
    [anon_sym_delete] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DQUOTE] = ACTIONS(75),
    [anon_sym_SQUOTE] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(79),
    [sym_number] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(83),
    [sym_true] = ACTIONS(83),
    [sym_false] = ACTIONS(83),
    [sym_null] = ACTIONS(83),
    [sym_undefined] = ACTIONS(83),
    [anon_sym_AT] = ACTIONS(85),
    [anon_sym_static] = ACTIONS(375),
    [anon_sym_get] = ACTIONS(375),
    [anon_sym_set] = ACTIONS(375),
  },
  [191] = {
    [sym_import] = STATE(426),
    [sym_parenthesized_expression] = STATE(355),
    [sym_expression] = STATE(410),
    [sym_primary_expression] = STATE(425),
    [sym_yield_expression] = STATE(424),
    [sym_object] = STATE(426),
    [sym_object_pattern] = STATE(1333),
    [sym_array] = STATE(426),
    [sym_array_pattern] = STATE(1333),
    [sym_jsx_element] = STATE(424),
    [sym_jsx_fragment] = STATE(424),
    [sym_jsx_opening_element] = STATE(768),
    [sym_jsx_self_closing_element] = STATE(424),
    [sym_class] = STATE(426),
    [sym_function] = STATE(426),
    [sym_generator_function] = STATE(426),
    [sym_arrow_function] = STATE(426),
    [sym_call_expression] = STATE(426),
    [sym_new_expression] = STATE(424),
    [sym_await_expression] = STATE(424),
    [sym_member_expression] = STATE(355),
    [sym_subscript_expression] = STATE(355),
    [sym_assignment_expression] = STATE(424),
    [sym__augmented_assignment_lhs] = STATE(714),
    [sym_augmented_assignment_expression] = STATE(424),
    [sym__destructuring_pattern] = STATE(1333),
    [sym_ternary_expression] = STATE(424),
    [sym_binary_expression] = STATE(424),
    [sym_unary_expression] = STATE(424),
    [sym_update_expression] = STATE(424),
    [sym_string] = STATE(426),
    [sym_template_string] = STATE(426),
    [sym_regex] = STATE(426),
    [sym_meta_property] = STATE(426),
    [sym_decorator] = STATE(750),
    [sym_formal_parameters] = STATE(1322),
    [aux_sym_export_statement_repeat1] = STATE(924),
    [sym_identifier] = ACTIONS(321),
    [anon_sym_export] = ACTIONS(323),
    [anon_sym_LBRACE] = ACTIONS(327),
    [anon_sym_import] = ACTIONS(331),
    [anon_sym_LPAREN] = ACTIONS(333),
    [anon_sym_await] = ACTIONS(335),
    [anon_sym_yield] = ACTIONS(339),
    [anon_sym_LBRACK] = ACTIONS(341),
    [anon_sym_LT] = ACTIONS(537),
    [anon_sym_SLASH] = ACTIONS(345),
    [anon_sym_class] = ACTIONS(347),
    [anon_sym_async] = ACTIONS(349),
    [anon_sym_function] = ACTIONS(351),
    [anon_sym_new] = ACTIONS(353),
    [anon_sym_PLUS] = ACTIONS(355),
    [anon_sym_DASH] = ACTIONS(355),
    [anon_sym_BANG] = ACTIONS(357),
    [anon_sym_TILDE] = ACTIONS(357),
    [anon_sym_typeof] = ACTIONS(359),
    [anon_sym_void] = ACTIONS(359),
    [anon_sym_delete] = ACTIONS(359),
    [anon_sym_PLUS_PLUS] = ACTIONS(361),
    [anon_sym_DASH_DASH] = ACTIONS(361),
    [anon_sym_DQUOTE] = ACTIONS(363),
    [anon_sym_SQUOTE] = ACTIONS(365),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(367),
    [sym_number] = ACTIONS(369),
    [sym_this] = ACTIONS(371),
    [sym_super] = ACTIONS(371),
    [sym_true] = ACTIONS(371),
    [sym_false] = ACTIONS(371),
    [sym_null] = ACTIONS(371),
    [sym_undefined] = ACTIONS(371),
    [anon_sym_AT] = ACTIONS(85),
    [anon_sym_static] = ACTIONS(323),
    [anon_sym_get] = ACTIONS(323),
    [anon_sym_set] = ACTIONS(323),
  },
  [192] = {
    [sym_import] = STATE(426),
    [sym_parenthesized_expression] = STATE(355),
    [sym_expression] = STATE(385),
    [sym_primary_expression] = STATE(425),
    [sym_yield_expression] = STATE(424),
    [sym_object] = STATE(426),
    [sym_object_pattern] = STATE(1333),
    [sym_array] = STATE(426),
    [sym_array_pattern] = STATE(1333),
    [sym_jsx_element] = STATE(424),
    [sym_jsx_fragment] = STATE(424),
    [sym_jsx_opening_element] = STATE(768),
    [sym_jsx_self_closing_element] = STATE(424),
    [sym_class] = STATE(426),
    [sym_function] = STATE(426),
    [sym_generator_function] = STATE(426),
    [sym_arrow_function] = STATE(426),
    [sym_call_expression] = STATE(426),
    [sym_new_expression] = STATE(424),
    [sym_await_expression] = STATE(424),
    [sym_member_expression] = STATE(355),
    [sym_subscript_expression] = STATE(355),
    [sym_assignment_expression] = STATE(424),
    [sym__augmented_assignment_lhs] = STATE(714),
    [sym_augmented_assignment_expression] = STATE(424),
    [sym__destructuring_pattern] = STATE(1333),
    [sym_ternary_expression] = STATE(424),
    [sym_binary_expression] = STATE(424),
    [sym_unary_expression] = STATE(424),
    [sym_update_expression] = STATE(424),
    [sym_string] = STATE(426),
    [sym_template_string] = STATE(426),
    [sym_regex] = STATE(426),
    [sym_meta_property] = STATE(426),
    [sym_decorator] = STATE(750),
    [sym_formal_parameters] = STATE(1322),
    [aux_sym_export_statement_repeat1] = STATE(924),
    [sym_identifier] = ACTIONS(321),
    [anon_sym_export] = ACTIONS(323),
    [anon_sym_LBRACE] = ACTIONS(327),
    [anon_sym_import] = ACTIONS(331),
    [anon_sym_LPAREN] = ACTIONS(333),
    [anon_sym_await] = ACTIONS(335),
    [anon_sym_yield] = ACTIONS(339),
    [anon_sym_LBRACK] = ACTIONS(341),
    [anon_sym_LT] = ACTIONS(537),
    [anon_sym_SLASH] = ACTIONS(345),
    [anon_sym_class] = ACTIONS(347),
    [anon_sym_async] = ACTIONS(349),
    [anon_sym_function] = ACTIONS(351),
    [anon_sym_new] = ACTIONS(353),
    [anon_sym_PLUS] = ACTIONS(355),
    [anon_sym_DASH] = ACTIONS(355),
    [anon_sym_BANG] = ACTIONS(357),
    [anon_sym_TILDE] = ACTIONS(357),
    [anon_sym_typeof] = ACTIONS(359),
    [anon_sym_void] = ACTIONS(359),
    [anon_sym_delete] = ACTIONS(359),
    [anon_sym_PLUS_PLUS] = ACTIONS(361),
    [anon_sym_DASH_DASH] = ACTIONS(361),
    [anon_sym_DQUOTE] = ACTIONS(363),
    [anon_sym_SQUOTE] = ACTIONS(365),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(367),
    [sym_number] = ACTIONS(369),
    [sym_this] = ACTIONS(371),
    [sym_super] = ACTIONS(371),
    [sym_true] = ACTIONS(371),
    [sym_false] = ACTIONS(371),
    [sym_null] = ACTIONS(371),
    [sym_undefined] = ACTIONS(371),
    [anon_sym_AT] = ACTIONS(85),
    [anon_sym_static] = ACTIONS(323),
    [anon_sym_get] = ACTIONS(323),
    [anon_sym_set] = ACTIONS(323),
  },
  [193] = {
    [sym_import] = STATE(426),
    [sym_parenthesized_expression] = STATE(340),
    [sym_expression] = STATE(632),
    [sym_primary_expression] = STATE(425),
    [sym_yield_expression] = STATE(424),
    [sym_object] = STATE(426),
    [sym_object_pattern] = STATE(1317),
    [sym_array] = STATE(426),
    [sym_array_pattern] = STATE(1317),
    [sym_jsx_element] = STATE(424),
    [sym_jsx_fragment] = STATE(424),
    [sym_jsx_opening_element] = STATE(768),
    [sym_jsx_self_closing_element] = STATE(424),
    [sym_class] = STATE(426),
    [sym_function] = STATE(426),
    [sym_generator_function] = STATE(426),
    [sym_arrow_function] = STATE(426),
    [sym_call_expression] = STATE(426),
    [sym_new_expression] = STATE(424),
    [sym_await_expression] = STATE(424),
    [sym_member_expression] = STATE(340),
    [sym_subscript_expression] = STATE(340),
    [sym_assignment_expression] = STATE(424),
    [sym__augmented_assignment_lhs] = STATE(712),
    [sym_augmented_assignment_expression] = STATE(424),
    [sym__destructuring_pattern] = STATE(1317),
    [sym_ternary_expression] = STATE(424),
    [sym_binary_expression] = STATE(424),
    [sym_unary_expression] = STATE(424),
    [sym_update_expression] = STATE(424),
    [sym_string] = STATE(426),
    [sym_template_string] = STATE(426),
    [sym_regex] = STATE(426),
    [sym_meta_property] = STATE(426),
    [sym_decorator] = STATE(750),
    [sym_formal_parameters] = STATE(1267),
    [aux_sym_export_statement_repeat1] = STATE(924),
    [sym_identifier] = ACTIONS(391),
    [anon_sym_export] = ACTIONS(393),
    [anon_sym_LBRACE] = ACTIONS(397),
    [anon_sym_import] = ACTIONS(331),
    [anon_sym_LPAREN] = ACTIONS(333),
    [anon_sym_await] = ACTIONS(399),
    [anon_sym_yield] = ACTIONS(401),
    [anon_sym_LBRACK] = ACTIONS(403),
    [anon_sym_LT] = ACTIONS(537),
    [anon_sym_SLASH] = ACTIONS(345),
    [anon_sym_class] = ACTIONS(347),
    [anon_sym_async] = ACTIONS(405),
    [anon_sym_function] = ACTIONS(351),
    [anon_sym_new] = ACTIONS(407),
    [anon_sym_PLUS] = ACTIONS(409),
    [anon_sym_DASH] = ACTIONS(409),
    [anon_sym_BANG] = ACTIONS(411),
    [anon_sym_TILDE] = ACTIONS(411),
    [anon_sym_typeof] = ACTIONS(413),
    [anon_sym_void] = ACTIONS(413),
    [anon_sym_delete] = ACTIONS(413),
    [anon_sym_PLUS_PLUS] = ACTIONS(415),
    [anon_sym_DASH_DASH] = ACTIONS(415),
    [anon_sym_DQUOTE] = ACTIONS(363),
    [anon_sym_SQUOTE] = ACTIONS(365),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(367),
    [sym_number] = ACTIONS(369),
    [sym_this] = ACTIONS(371),
    [sym_super] = ACTIONS(371),
    [sym_true] = ACTIONS(371),
    [sym_false] = ACTIONS(371),
    [sym_null] = ACTIONS(371),
    [sym_undefined] = ACTIONS(371),
    [anon_sym_AT] = ACTIONS(85),
    [anon_sym_static] = ACTIONS(393),
    [anon_sym_get] = ACTIONS(393),
    [anon_sym_set] = ACTIONS(393),
  },
  [194] = {
    [sym_import] = STATE(539),
    [sym_parenthesized_expression] = STATE(362),
    [sym_expression] = STATE(443),
    [sym_primary_expression] = STATE(546),
    [sym_yield_expression] = STATE(550),
    [sym_object] = STATE(539),
    [sym_object_pattern] = STATE(1320),
    [sym_array] = STATE(539),
    [sym_array_pattern] = STATE(1320),
    [sym_jsx_element] = STATE(550),
    [sym_jsx_fragment] = STATE(550),
    [sym_jsx_opening_element] = STATE(772),
    [sym_jsx_self_closing_element] = STATE(550),
    [sym_class] = STATE(539),
    [sym_function] = STATE(539),
    [sym_generator_function] = STATE(539),
    [sym_arrow_function] = STATE(539),
    [sym_call_expression] = STATE(539),
    [sym_new_expression] = STATE(550),
    [sym_await_expression] = STATE(550),
    [sym_member_expression] = STATE(362),
    [sym_subscript_expression] = STATE(362),
    [sym_assignment_expression] = STATE(550),
    [sym__augmented_assignment_lhs] = STATE(720),
    [sym_augmented_assignment_expression] = STATE(550),
    [sym__destructuring_pattern] = STATE(1320),
    [sym_ternary_expression] = STATE(550),
    [sym_binary_expression] = STATE(550),
    [sym_unary_expression] = STATE(550),
    [sym_update_expression] = STATE(550),
    [sym_string] = STATE(539),
    [sym_template_string] = STATE(539),
    [sym_regex] = STATE(539),
    [sym_meta_property] = STATE(539),
    [sym_decorator] = STATE(750),
    [sym_formal_parameters] = STATE(1318),
    [aux_sym_export_statement_repeat1] = STATE(925),
    [sym_identifier] = ACTIONS(373),
    [anon_sym_export] = ACTIONS(375),
    [anon_sym_LBRACE] = ACTIONS(379),
    [anon_sym_import] = ACTIONS(381),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(29),
    [anon_sym_yield] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(53),
    [anon_sym_LT] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(385),
    [anon_sym_async] = ACTIONS(387),
    [anon_sym_function] = ACTIONS(389),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_typeof] = ACTIONS(71),
    [anon_sym_void] = ACTIONS(71),
    [anon_sym_delete] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DQUOTE] = ACTIONS(75),
    [anon_sym_SQUOTE] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(79),
    [sym_number] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(83),
    [sym_true] = ACTIONS(83),
    [sym_false] = ACTIONS(83),
    [sym_null] = ACTIONS(83),
    [sym_undefined] = ACTIONS(83),
    [anon_sym_AT] = ACTIONS(85),
    [anon_sym_static] = ACTIONS(375),
    [anon_sym_get] = ACTIONS(375),
    [anon_sym_set] = ACTIONS(375),
  },
  [195] = {
    [sym_import] = STATE(539),
    [sym_parenthesized_expression] = STATE(362),
    [sym_expression] = STATE(444),
    [sym_primary_expression] = STATE(546),
    [sym_yield_expression] = STATE(550),
    [sym_object] = STATE(539),
    [sym_object_pattern] = STATE(1320),
    [sym_array] = STATE(539),
    [sym_array_pattern] = STATE(1320),
    [sym_jsx_element] = STATE(550),
    [sym_jsx_fragment] = STATE(550),
    [sym_jsx_opening_element] = STATE(772),
    [sym_jsx_self_closing_element] = STATE(550),
    [sym_class] = STATE(539),
    [sym_function] = STATE(539),
    [sym_generator_function] = STATE(539),
    [sym_arrow_function] = STATE(539),
    [sym_call_expression] = STATE(539),
    [sym_new_expression] = STATE(550),
    [sym_await_expression] = STATE(550),
    [sym_member_expression] = STATE(362),
    [sym_subscript_expression] = STATE(362),
    [sym_assignment_expression] = STATE(550),
    [sym__augmented_assignment_lhs] = STATE(720),
    [sym_augmented_assignment_expression] = STATE(550),
    [sym__destructuring_pattern] = STATE(1320),
    [sym_ternary_expression] = STATE(550),
    [sym_binary_expression] = STATE(550),
    [sym_unary_expression] = STATE(550),
    [sym_update_expression] = STATE(550),
    [sym_string] = STATE(539),
    [sym_template_string] = STATE(539),
    [sym_regex] = STATE(539),
    [sym_meta_property] = STATE(539),
    [sym_decorator] = STATE(750),
    [sym_formal_parameters] = STATE(1318),
    [aux_sym_export_statement_repeat1] = STATE(925),
    [sym_identifier] = ACTIONS(373),
    [anon_sym_export] = ACTIONS(375),
    [anon_sym_LBRACE] = ACTIONS(379),
    [anon_sym_import] = ACTIONS(381),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(29),
    [anon_sym_yield] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(53),
    [anon_sym_LT] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(385),
    [anon_sym_async] = ACTIONS(387),
    [anon_sym_function] = ACTIONS(389),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_typeof] = ACTIONS(71),
    [anon_sym_void] = ACTIONS(71),
    [anon_sym_delete] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DQUOTE] = ACTIONS(75),
    [anon_sym_SQUOTE] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(79),
    [sym_number] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(83),
    [sym_true] = ACTIONS(83),
    [sym_false] = ACTIONS(83),
    [sym_null] = ACTIONS(83),
    [sym_undefined] = ACTIONS(83),
    [anon_sym_AT] = ACTIONS(85),
    [anon_sym_static] = ACTIONS(375),
    [anon_sym_get] = ACTIONS(375),
    [anon_sym_set] = ACTIONS(375),
  },
  [196] = {
    [sym_export_clause] = STATE(927),
    [sym_declaration] = STATE(293),
    [sym_variable_declaration] = STATE(275),
    [sym_lexical_declaration] = STATE(275),
    [sym_class_declaration] = STATE(275),
    [sym_function_declaration] = STATE(275),
    [sym_generator_function_declaration] = STATE(275),
    [sym_decorator] = STATE(750),
    [aux_sym_export_statement_repeat1] = STATE(955),
    [anon_sym_STAR] = ACTIONS(630),
    [anon_sym_default] = ACTIONS(632),
    [anon_sym_LBRACE] = ACTIONS(634),
    [anon_sym_COMMA] = ACTIONS(636),
    [anon_sym_var] = ACTIONS(640),
    [anon_sym_let] = ACTIONS(642),
    [anon_sym_const] = ACTIONS(642),
    [anon_sym_LPAREN] = ACTIONS(636),
    [anon_sym_in] = ACTIONS(647),
    [anon_sym_SEMI] = ACTIONS(636),
    [anon_sym_COLON] = ACTIONS(692),
    [anon_sym_EQ] = ACTIONS(694),
    [anon_sym_LBRACK] = ACTIONS(636),
    [anon_sym_LT] = ACTIONS(647),
    [anon_sym_GT] = ACTIONS(647),
    [anon_sym_SLASH] = ACTIONS(647),
    [anon_sym_DOT] = ACTIONS(636),
    [anon_sym_class] = ACTIONS(696),
    [anon_sym_async] = ACTIONS(698),
    [anon_sym_function] = ACTIONS(700),
    [anon_sym_EQ_GT] = ACTIONS(660),
    [anon_sym_QMARK_DOT] = ACTIONS(636),
    [anon_sym_PLUS_EQ] = ACTIONS(662),
    [anon_sym_DASH_EQ] = ACTIONS(662),
    [anon_sym_STAR_EQ] = ACTIONS(662),
    [anon_sym_SLASH_EQ] = ACTIONS(662),
    [anon_sym_PERCENT_EQ] = ACTIONS(662),
    [anon_sym_CARET_EQ] = ACTIONS(662),
    [anon_sym_AMP_EQ] = ACTIONS(662),
    [anon_sym_PIPE_EQ] = ACTIONS(662),
    [anon_sym_GT_GT_EQ] = ACTIONS(662),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(662),
    [anon_sym_LT_LT_EQ] = ACTIONS(662),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(662),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(662),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(662),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(662),
    [anon_sym_QMARK] = ACTIONS(647),
    [anon_sym_AMP_AMP] = ACTIONS(647),
    [anon_sym_PIPE_PIPE] = ACTIONS(647),
    [anon_sym_GT_GT] = ACTIONS(647),
    [anon_sym_GT_GT_GT] = ACTIONS(647),
    [anon_sym_LT_LT] = ACTIONS(647),
    [anon_sym_AMP] = ACTIONS(647),
    [anon_sym_CARET] = ACTIONS(647),
    [anon_sym_PIPE] = ACTIONS(647),
    [anon_sym_PLUS] = ACTIONS(647),
    [anon_sym_DASH] = ACTIONS(647),
    [anon_sym_PERCENT] = ACTIONS(647),
    [anon_sym_STAR_STAR] = ACTIONS(647),
    [anon_sym_LT_EQ] = ACTIONS(636),
    [anon_sym_EQ_EQ] = ACTIONS(647),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(636),
    [anon_sym_BANG_EQ] = ACTIONS(647),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(636),
    [anon_sym_GT_EQ] = ACTIONS(636),
    [anon_sym_QMARK_QMARK] = ACTIONS(647),
    [anon_sym_instanceof] = ACTIONS(636),
    [anon_sym_PLUS_PLUS] = ACTIONS(636),
    [anon_sym_DASH_DASH] = ACTIONS(636),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(636),
    [anon_sym_AT] = ACTIONS(85),
    [sym__automatic_semicolon] = ACTIONS(636),
  },
  [197] = {
    [sym_export_clause] = STATE(927),
    [sym_declaration] = STATE(293),
    [sym_variable_declaration] = STATE(275),
    [sym_lexical_declaration] = STATE(275),
    [sym_class_declaration] = STATE(275),
    [sym_function_declaration] = STATE(275),
    [sym_generator_function_declaration] = STATE(275),
    [sym_decorator] = STATE(750),
    [aux_sym_export_statement_repeat1] = STATE(922),
    [anon_sym_STAR] = ACTIONS(630),
    [anon_sym_default] = ACTIONS(632),
    [anon_sym_LBRACE] = ACTIONS(634),
    [anon_sym_COMMA] = ACTIONS(636),
    [anon_sym_var] = ACTIONS(640),
    [anon_sym_let] = ACTIONS(642),
    [anon_sym_const] = ACTIONS(642),
    [anon_sym_LPAREN] = ACTIONS(636),
    [anon_sym_in] = ACTIONS(647),
    [anon_sym_SEMI] = ACTIONS(636),
    [anon_sym_COLON] = ACTIONS(702),
    [anon_sym_EQ] = ACTIONS(694),
    [anon_sym_LBRACK] = ACTIONS(636),
    [anon_sym_LT] = ACTIONS(647),
    [anon_sym_GT] = ACTIONS(647),
    [anon_sym_SLASH] = ACTIONS(647),
    [anon_sym_DOT] = ACTIONS(636),
    [anon_sym_class] = ACTIONS(654),
    [anon_sym_async] = ACTIONS(656),
    [anon_sym_function] = ACTIONS(658),
    [anon_sym_EQ_GT] = ACTIONS(660),
    [anon_sym_QMARK_DOT] = ACTIONS(636),
    [anon_sym_PLUS_EQ] = ACTIONS(662),
    [anon_sym_DASH_EQ] = ACTIONS(662),
    [anon_sym_STAR_EQ] = ACTIONS(662),
    [anon_sym_SLASH_EQ] = ACTIONS(662),
    [anon_sym_PERCENT_EQ] = ACTIONS(662),
    [anon_sym_CARET_EQ] = ACTIONS(662),
    [anon_sym_AMP_EQ] = ACTIONS(662),
    [anon_sym_PIPE_EQ] = ACTIONS(662),
    [anon_sym_GT_GT_EQ] = ACTIONS(662),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(662),
    [anon_sym_LT_LT_EQ] = ACTIONS(662),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(662),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(662),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(662),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(662),
    [anon_sym_QMARK] = ACTIONS(647),
    [anon_sym_AMP_AMP] = ACTIONS(647),
    [anon_sym_PIPE_PIPE] = ACTIONS(647),
    [anon_sym_GT_GT] = ACTIONS(647),
    [anon_sym_GT_GT_GT] = ACTIONS(647),
    [anon_sym_LT_LT] = ACTIONS(647),
    [anon_sym_AMP] = ACTIONS(647),
    [anon_sym_CARET] = ACTIONS(647),
    [anon_sym_PIPE] = ACTIONS(647),
    [anon_sym_PLUS] = ACTIONS(647),
    [anon_sym_DASH] = ACTIONS(647),
    [anon_sym_PERCENT] = ACTIONS(647),
    [anon_sym_STAR_STAR] = ACTIONS(647),
    [anon_sym_LT_EQ] = ACTIONS(636),
    [anon_sym_EQ_EQ] = ACTIONS(647),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(636),
    [anon_sym_BANG_EQ] = ACTIONS(647),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(636),
    [anon_sym_GT_EQ] = ACTIONS(636),
    [anon_sym_QMARK_QMARK] = ACTIONS(647),
    [anon_sym_instanceof] = ACTIONS(636),
    [anon_sym_PLUS_PLUS] = ACTIONS(636),
    [anon_sym_DASH_DASH] = ACTIONS(636),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(636),
    [anon_sym_AT] = ACTIONS(85),
    [sym__automatic_semicolon] = ACTIONS(636),
  },
  [198] = {
    [sym_string] = STATE(1181),
    [sym_formal_parameters] = STATE(1257),
    [sym__property_name] = STATE(1181),
    [sym_computed_property_name] = STATE(1181),
    [aux_sym_object_repeat1] = STATE(1058),
    [aux_sym_object_pattern_repeat1] = STATE(978),
    [sym_identifier] = ACTIONS(704),
    [anon_sym_export] = ACTIONS(706),
    [anon_sym_STAR] = ACTIONS(708),
    [anon_sym_COMMA] = ACTIONS(636),
    [anon_sym_RBRACE] = ACTIONS(674),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_in] = ACTIONS(647),
    [anon_sym_SEMI] = ACTIONS(636),
    [anon_sym_COLON] = ACTIONS(649),
    [anon_sym_EQ] = ACTIONS(652),
    [anon_sym_LBRACK] = ACTIONS(715),
    [anon_sym_LT] = ACTIONS(647),
    [anon_sym_GT] = ACTIONS(647),
    [anon_sym_SLASH] = ACTIONS(647),
    [anon_sym_DOT] = ACTIONS(647),
    [anon_sym_async] = ACTIONS(706),
    [anon_sym_function] = ACTIONS(718),
    [anon_sym_EQ_GT] = ACTIONS(660),
    [anon_sym_QMARK_DOT] = ACTIONS(636),
    [anon_sym_PLUS_EQ] = ACTIONS(662),
    [anon_sym_DASH_EQ] = ACTIONS(662),
    [anon_sym_STAR_EQ] = ACTIONS(662),
    [anon_sym_SLASH_EQ] = ACTIONS(662),
    [anon_sym_PERCENT_EQ] = ACTIONS(662),
    [anon_sym_CARET_EQ] = ACTIONS(662),
    [anon_sym_AMP_EQ] = ACTIONS(662),
    [anon_sym_PIPE_EQ] = ACTIONS(662),
    [anon_sym_GT_GT_EQ] = ACTIONS(662),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(662),
    [anon_sym_LT_LT_EQ] = ACTIONS(662),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(662),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(662),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(662),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(662),
    [anon_sym_QMARK] = ACTIONS(647),
    [anon_sym_AMP_AMP] = ACTIONS(647),
    [anon_sym_PIPE_PIPE] = ACTIONS(647),
    [anon_sym_GT_GT] = ACTIONS(647),
    [anon_sym_GT_GT_GT] = ACTIONS(647),
    [anon_sym_LT_LT] = ACTIONS(647),
    [anon_sym_AMP] = ACTIONS(647),
    [anon_sym_CARET] = ACTIONS(647),
    [anon_sym_PIPE] = ACTIONS(647),
    [anon_sym_PLUS] = ACTIONS(647),
    [anon_sym_DASH] = ACTIONS(647),
    [anon_sym_PERCENT] = ACTIONS(647),
    [anon_sym_STAR_STAR] = ACTIONS(647),
    [anon_sym_LT_EQ] = ACTIONS(636),
    [anon_sym_EQ_EQ] = ACTIONS(647),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(636),
    [anon_sym_BANG_EQ] = ACTIONS(647),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(636),
    [anon_sym_GT_EQ] = ACTIONS(636),
    [anon_sym_QMARK_QMARK] = ACTIONS(647),
    [anon_sym_instanceof] = ACTIONS(647),
    [anon_sym_PLUS_PLUS] = ACTIONS(636),
    [anon_sym_DASH_DASH] = ACTIONS(636),
    [anon_sym_DQUOTE] = ACTIONS(363),
    [anon_sym_SQUOTE] = ACTIONS(365),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(636),
    [sym_number] = ACTIONS(720),
    [anon_sym_static] = ACTIONS(706),
    [anon_sym_get] = ACTIONS(722),
    [anon_sym_set] = ACTIONS(722),
    [sym__automatic_semicolon] = ACTIONS(636),
  },
  [199] = {
    [sym_string] = STATE(1181),
    [sym_formal_parameters] = STATE(1257),
    [sym__property_name] = STATE(1181),
    [sym_computed_property_name] = STATE(1181),
    [aux_sym_object_repeat1] = STATE(976),
    [aux_sym_object_pattern_repeat1] = STATE(978),
    [sym_identifier] = ACTIONS(704),
    [anon_sym_export] = ACTIONS(706),
    [anon_sym_STAR] = ACTIONS(708),
    [anon_sym_COMMA] = ACTIONS(636),
    [anon_sym_RBRACE] = ACTIONS(638),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_in] = ACTIONS(647),
    [anon_sym_SEMI] = ACTIONS(636),
    [anon_sym_COLON] = ACTIONS(649),
    [anon_sym_EQ] = ACTIONS(652),
    [anon_sym_LBRACK] = ACTIONS(715),
    [anon_sym_LT] = ACTIONS(647),
    [anon_sym_GT] = ACTIONS(647),
    [anon_sym_SLASH] = ACTIONS(647),
    [anon_sym_DOT] = ACTIONS(647),
    [anon_sym_async] = ACTIONS(706),
    [anon_sym_function] = ACTIONS(718),
    [anon_sym_EQ_GT] = ACTIONS(660),
    [anon_sym_QMARK_DOT] = ACTIONS(636),
    [anon_sym_PLUS_EQ] = ACTIONS(662),
    [anon_sym_DASH_EQ] = ACTIONS(662),
    [anon_sym_STAR_EQ] = ACTIONS(662),
    [anon_sym_SLASH_EQ] = ACTIONS(662),
    [anon_sym_PERCENT_EQ] = ACTIONS(662),
    [anon_sym_CARET_EQ] = ACTIONS(662),
    [anon_sym_AMP_EQ] = ACTIONS(662),
    [anon_sym_PIPE_EQ] = ACTIONS(662),
    [anon_sym_GT_GT_EQ] = ACTIONS(662),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(662),
    [anon_sym_LT_LT_EQ] = ACTIONS(662),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(662),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(662),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(662),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(662),
    [anon_sym_QMARK] = ACTIONS(647),
    [anon_sym_AMP_AMP] = ACTIONS(647),
    [anon_sym_PIPE_PIPE] = ACTIONS(647),
    [anon_sym_GT_GT] = ACTIONS(647),
    [anon_sym_GT_GT_GT] = ACTIONS(647),
    [anon_sym_LT_LT] = ACTIONS(647),
    [anon_sym_AMP] = ACTIONS(647),
    [anon_sym_CARET] = ACTIONS(647),
    [anon_sym_PIPE] = ACTIONS(647),
    [anon_sym_PLUS] = ACTIONS(647),
    [anon_sym_DASH] = ACTIONS(647),
    [anon_sym_PERCENT] = ACTIONS(647),
    [anon_sym_STAR_STAR] = ACTIONS(647),
    [anon_sym_LT_EQ] = ACTIONS(636),
    [anon_sym_EQ_EQ] = ACTIONS(647),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(636),
    [anon_sym_BANG_EQ] = ACTIONS(647),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(636),
    [anon_sym_GT_EQ] = ACTIONS(636),
    [anon_sym_QMARK_QMARK] = ACTIONS(647),
    [anon_sym_instanceof] = ACTIONS(647),
    [anon_sym_PLUS_PLUS] = ACTIONS(636),
    [anon_sym_DASH_DASH] = ACTIONS(636),
    [anon_sym_DQUOTE] = ACTIONS(363),
    [anon_sym_SQUOTE] = ACTIONS(365),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(636),
    [sym_number] = ACTIONS(720),
    [anon_sym_static] = ACTIONS(706),
    [anon_sym_get] = ACTIONS(722),
    [anon_sym_set] = ACTIONS(722),
    [sym__automatic_semicolon] = ACTIONS(636),
  },
  [200] = {
    [sym_string] = STATE(1181),
    [sym_formal_parameters] = STATE(1257),
    [sym__property_name] = STATE(1181),
    [sym_computed_property_name] = STATE(1181),
    [aux_sym_object_repeat1] = STATE(1058),
    [aux_sym_object_pattern_repeat1] = STATE(978),
    [sym_identifier] = ACTIONS(704),
    [anon_sym_export] = ACTIONS(706),
    [anon_sym_STAR] = ACTIONS(708),
    [anon_sym_COMMA] = ACTIONS(636),
    [anon_sym_RBRACE] = ACTIONS(678),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_in] = ACTIONS(647),
    [anon_sym_SEMI] = ACTIONS(636),
    [anon_sym_COLON] = ACTIONS(649),
    [anon_sym_EQ] = ACTIONS(652),
    [anon_sym_LBRACK] = ACTIONS(715),
    [anon_sym_LT] = ACTIONS(647),
    [anon_sym_GT] = ACTIONS(647),
    [anon_sym_SLASH] = ACTIONS(647),
    [anon_sym_DOT] = ACTIONS(647),
    [anon_sym_async] = ACTIONS(706),
    [anon_sym_function] = ACTIONS(718),
    [anon_sym_EQ_GT] = ACTIONS(660),
    [anon_sym_QMARK_DOT] = ACTIONS(636),
    [anon_sym_PLUS_EQ] = ACTIONS(662),
    [anon_sym_DASH_EQ] = ACTIONS(662),
    [anon_sym_STAR_EQ] = ACTIONS(662),
    [anon_sym_SLASH_EQ] = ACTIONS(662),
    [anon_sym_PERCENT_EQ] = ACTIONS(662),
    [anon_sym_CARET_EQ] = ACTIONS(662),
    [anon_sym_AMP_EQ] = ACTIONS(662),
    [anon_sym_PIPE_EQ] = ACTIONS(662),
    [anon_sym_GT_GT_EQ] = ACTIONS(662),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(662),
    [anon_sym_LT_LT_EQ] = ACTIONS(662),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(662),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(662),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(662),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(662),
    [anon_sym_QMARK] = ACTIONS(647),
    [anon_sym_AMP_AMP] = ACTIONS(647),
    [anon_sym_PIPE_PIPE] = ACTIONS(647),
    [anon_sym_GT_GT] = ACTIONS(647),
    [anon_sym_GT_GT_GT] = ACTIONS(647),
    [anon_sym_LT_LT] = ACTIONS(647),
    [anon_sym_AMP] = ACTIONS(647),
    [anon_sym_CARET] = ACTIONS(647),
    [anon_sym_PIPE] = ACTIONS(647),
    [anon_sym_PLUS] = ACTIONS(647),
    [anon_sym_DASH] = ACTIONS(647),
    [anon_sym_PERCENT] = ACTIONS(647),
    [anon_sym_STAR_STAR] = ACTIONS(647),
    [anon_sym_LT_EQ] = ACTIONS(636),
    [anon_sym_EQ_EQ] = ACTIONS(647),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(636),
    [anon_sym_BANG_EQ] = ACTIONS(647),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(636),
    [anon_sym_GT_EQ] = ACTIONS(636),
    [anon_sym_QMARK_QMARK] = ACTIONS(647),
    [anon_sym_instanceof] = ACTIONS(647),
    [anon_sym_PLUS_PLUS] = ACTIONS(636),
    [anon_sym_DASH_DASH] = ACTIONS(636),
    [anon_sym_DQUOTE] = ACTIONS(363),
    [anon_sym_SQUOTE] = ACTIONS(365),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(636),
    [sym_number] = ACTIONS(720),
    [anon_sym_static] = ACTIONS(706),
    [anon_sym_get] = ACTIONS(722),
    [anon_sym_set] = ACTIONS(722),
    [sym__automatic_semicolon] = ACTIONS(636),
  },
  [201] = {
    [sym_string] = STATE(1181),
    [sym__property_name] = STATE(1181),
    [sym_computed_property_name] = STATE(1181),
    [aux_sym_object_repeat1] = STATE(976),
    [aux_sym_object_pattern_repeat1] = STATE(978),
    [sym_identifier] = ACTIONS(724),
    [anon_sym_export] = ACTIONS(724),
    [anon_sym_STAR] = ACTIONS(708),
    [anon_sym_COMMA] = ACTIONS(636),
    [anon_sym_RBRACE] = ACTIONS(638),
    [anon_sym_LPAREN] = ACTIONS(644),
    [anon_sym_in] = ACTIONS(647),
    [anon_sym_SEMI] = ACTIONS(636),
    [anon_sym_COLON] = ACTIONS(649),
    [anon_sym_EQ] = ACTIONS(652),
    [anon_sym_LBRACK] = ACTIONS(715),
    [anon_sym_LT] = ACTIONS(647),
    [anon_sym_GT] = ACTIONS(647),
    [anon_sym_SLASH] = ACTIONS(647),
    [anon_sym_DOT] = ACTIONS(647),
    [anon_sym_async] = ACTIONS(726),
    [anon_sym_EQ_GT] = ACTIONS(660),
    [anon_sym_QMARK_DOT] = ACTIONS(636),
    [anon_sym_PLUS_EQ] = ACTIONS(662),
    [anon_sym_DASH_EQ] = ACTIONS(662),
    [anon_sym_STAR_EQ] = ACTIONS(662),
    [anon_sym_SLASH_EQ] = ACTIONS(662),
    [anon_sym_PERCENT_EQ] = ACTIONS(662),
    [anon_sym_CARET_EQ] = ACTIONS(662),
    [anon_sym_AMP_EQ] = ACTIONS(662),
    [anon_sym_PIPE_EQ] = ACTIONS(662),
    [anon_sym_GT_GT_EQ] = ACTIONS(662),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(662),
    [anon_sym_LT_LT_EQ] = ACTIONS(662),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(662),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(662),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(662),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(662),
    [anon_sym_QMARK] = ACTIONS(647),
    [anon_sym_AMP_AMP] = ACTIONS(647),
    [anon_sym_PIPE_PIPE] = ACTIONS(647),
    [anon_sym_GT_GT] = ACTIONS(647),
    [anon_sym_GT_GT_GT] = ACTIONS(647),
    [anon_sym_LT_LT] = ACTIONS(647),
    [anon_sym_AMP] = ACTIONS(647),
    [anon_sym_CARET] = ACTIONS(647),
    [anon_sym_PIPE] = ACTIONS(647),
    [anon_sym_PLUS] = ACTIONS(647),
    [anon_sym_DASH] = ACTIONS(647),
    [anon_sym_PERCENT] = ACTIONS(647),
    [anon_sym_STAR_STAR] = ACTIONS(647),
    [anon_sym_LT_EQ] = ACTIONS(636),
    [anon_sym_EQ_EQ] = ACTIONS(647),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(636),
    [anon_sym_BANG_EQ] = ACTIONS(647),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(636),
    [anon_sym_GT_EQ] = ACTIONS(636),
    [anon_sym_QMARK_QMARK] = ACTIONS(647),
    [anon_sym_instanceof] = ACTIONS(647),
    [anon_sym_PLUS_PLUS] = ACTIONS(636),
    [anon_sym_DASH_DASH] = ACTIONS(636),
    [anon_sym_DQUOTE] = ACTIONS(363),
    [anon_sym_SQUOTE] = ACTIONS(365),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(636),
    [sym_number] = ACTIONS(720),
    [anon_sym_static] = ACTIONS(724),
    [anon_sym_get] = ACTIONS(728),
    [anon_sym_set] = ACTIONS(728),
    [sym__automatic_semicolon] = ACTIONS(636),
  },
  [202] = {
    [sym_string] = STATE(1181),
    [sym__property_name] = STATE(1181),
    [sym_computed_property_name] = STATE(1181),
    [aux_sym_object_repeat1] = STATE(1058),
    [aux_sym_object_pattern_repeat1] = STATE(978),
    [sym_identifier] = ACTIONS(724),
    [anon_sym_export] = ACTIONS(724),
    [anon_sym_STAR] = ACTIONS(647),
    [anon_sym_COMMA] = ACTIONS(636),
    [anon_sym_RBRACE] = ACTIONS(678),
    [anon_sym_LPAREN] = ACTIONS(644),
    [anon_sym_in] = ACTIONS(647),
    [anon_sym_SEMI] = ACTIONS(636),
    [anon_sym_COLON] = ACTIONS(649),
    [anon_sym_EQ] = ACTIONS(652),
    [anon_sym_LBRACK] = ACTIONS(715),
    [anon_sym_LT] = ACTIONS(647),
    [anon_sym_GT] = ACTIONS(647),
    [anon_sym_SLASH] = ACTIONS(647),
    [anon_sym_DOT] = ACTIONS(647),
    [anon_sym_async] = ACTIONS(724),
    [anon_sym_EQ_GT] = ACTIONS(660),
    [anon_sym_QMARK_DOT] = ACTIONS(636),
    [anon_sym_PLUS_EQ] = ACTIONS(662),
    [anon_sym_DASH_EQ] = ACTIONS(662),
    [anon_sym_STAR_EQ] = ACTIONS(662),
    [anon_sym_SLASH_EQ] = ACTIONS(662),
    [anon_sym_PERCENT_EQ] = ACTIONS(662),
    [anon_sym_CARET_EQ] = ACTIONS(662),
    [anon_sym_AMP_EQ] = ACTIONS(662),
    [anon_sym_PIPE_EQ] = ACTIONS(662),
    [anon_sym_GT_GT_EQ] = ACTIONS(662),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(662),
    [anon_sym_LT_LT_EQ] = ACTIONS(662),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(662),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(662),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(662),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(662),
    [anon_sym_QMARK] = ACTIONS(647),
    [anon_sym_AMP_AMP] = ACTIONS(647),
    [anon_sym_PIPE_PIPE] = ACTIONS(647),
    [anon_sym_GT_GT] = ACTIONS(647),
    [anon_sym_GT_GT_GT] = ACTIONS(647),
    [anon_sym_LT_LT] = ACTIONS(647),
    [anon_sym_AMP] = ACTIONS(647),
    [anon_sym_CARET] = ACTIONS(647),
    [anon_sym_PIPE] = ACTIONS(647),
    [anon_sym_PLUS] = ACTIONS(647),
    [anon_sym_DASH] = ACTIONS(647),
    [anon_sym_PERCENT] = ACTIONS(647),
    [anon_sym_STAR_STAR] = ACTIONS(647),
    [anon_sym_LT_EQ] = ACTIONS(636),
    [anon_sym_EQ_EQ] = ACTIONS(647),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(636),
    [anon_sym_BANG_EQ] = ACTIONS(647),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(636),
    [anon_sym_GT_EQ] = ACTIONS(636),
    [anon_sym_QMARK_QMARK] = ACTIONS(647),
    [anon_sym_instanceof] = ACTIONS(647),
    [anon_sym_PLUS_PLUS] = ACTIONS(636),
    [anon_sym_DASH_DASH] = ACTIONS(636),
    [anon_sym_DQUOTE] = ACTIONS(363),
    [anon_sym_SQUOTE] = ACTIONS(365),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(636),
    [sym_number] = ACTIONS(720),
    [anon_sym_static] = ACTIONS(724),
    [anon_sym_get] = ACTIONS(724),
    [anon_sym_set] = ACTIONS(724),
    [sym__automatic_semicolon] = ACTIONS(636),
  },
  [203] = {
    [sym_string] = STATE(1181),
    [sym__property_name] = STATE(1181),
    [sym_computed_property_name] = STATE(1181),
    [aux_sym_object_repeat1] = STATE(1058),
    [aux_sym_object_pattern_repeat1] = STATE(978),
    [sym_identifier] = ACTIONS(724),
    [anon_sym_export] = ACTIONS(724),
    [anon_sym_STAR] = ACTIONS(708),
    [anon_sym_COMMA] = ACTIONS(636),
    [anon_sym_RBRACE] = ACTIONS(674),
    [anon_sym_LPAREN] = ACTIONS(644),
    [anon_sym_in] = ACTIONS(647),
    [anon_sym_SEMI] = ACTIONS(636),
    [anon_sym_COLON] = ACTIONS(649),
    [anon_sym_EQ] = ACTIONS(652),
    [anon_sym_LBRACK] = ACTIONS(715),
    [anon_sym_LT] = ACTIONS(647),
    [anon_sym_GT] = ACTIONS(647),
    [anon_sym_SLASH] = ACTIONS(647),
    [anon_sym_DOT] = ACTIONS(647),
    [anon_sym_async] = ACTIONS(726),
    [anon_sym_EQ_GT] = ACTIONS(660),
    [anon_sym_QMARK_DOT] = ACTIONS(636),
    [anon_sym_PLUS_EQ] = ACTIONS(662),
    [anon_sym_DASH_EQ] = ACTIONS(662),
    [anon_sym_STAR_EQ] = ACTIONS(662),
    [anon_sym_SLASH_EQ] = ACTIONS(662),
    [anon_sym_PERCENT_EQ] = ACTIONS(662),
    [anon_sym_CARET_EQ] = ACTIONS(662),
    [anon_sym_AMP_EQ] = ACTIONS(662),
    [anon_sym_PIPE_EQ] = ACTIONS(662),
    [anon_sym_GT_GT_EQ] = ACTIONS(662),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(662),
    [anon_sym_LT_LT_EQ] = ACTIONS(662),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(662),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(662),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(662),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(662),
    [anon_sym_QMARK] = ACTIONS(647),
    [anon_sym_AMP_AMP] = ACTIONS(647),
    [anon_sym_PIPE_PIPE] = ACTIONS(647),
    [anon_sym_GT_GT] = ACTIONS(647),
    [anon_sym_GT_GT_GT] = ACTIONS(647),
    [anon_sym_LT_LT] = ACTIONS(647),
    [anon_sym_AMP] = ACTIONS(647),
    [anon_sym_CARET] = ACTIONS(647),
    [anon_sym_PIPE] = ACTIONS(647),
    [anon_sym_PLUS] = ACTIONS(647),
    [anon_sym_DASH] = ACTIONS(647),
    [anon_sym_PERCENT] = ACTIONS(647),
    [anon_sym_STAR_STAR] = ACTIONS(647),
    [anon_sym_LT_EQ] = ACTIONS(636),
    [anon_sym_EQ_EQ] = ACTIONS(647),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(636),
    [anon_sym_BANG_EQ] = ACTIONS(647),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(636),
    [anon_sym_GT_EQ] = ACTIONS(636),
    [anon_sym_QMARK_QMARK] = ACTIONS(647),
    [anon_sym_instanceof] = ACTIONS(647),
    [anon_sym_PLUS_PLUS] = ACTIONS(636),
    [anon_sym_DASH_DASH] = ACTIONS(636),
    [anon_sym_DQUOTE] = ACTIONS(363),
    [anon_sym_SQUOTE] = ACTIONS(365),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(636),
    [sym_number] = ACTIONS(720),
    [anon_sym_static] = ACTIONS(724),
    [anon_sym_get] = ACTIONS(728),
    [anon_sym_set] = ACTIONS(728),
    [sym__automatic_semicolon] = ACTIONS(636),
  },
  [204] = {
    [sym_string] = STATE(1181),
    [sym__property_name] = STATE(1181),
    [sym_computed_property_name] = STATE(1181),
    [aux_sym_object_repeat1] = STATE(1058),
    [aux_sym_object_pattern_repeat1] = STATE(978),
    [sym_identifier] = ACTIONS(724),
    [anon_sym_export] = ACTIONS(724),
    [anon_sym_STAR] = ACTIONS(708),
    [anon_sym_COMMA] = ACTIONS(636),
    [anon_sym_RBRACE] = ACTIONS(678),
    [anon_sym_LPAREN] = ACTIONS(644),
    [anon_sym_in] = ACTIONS(647),
    [anon_sym_SEMI] = ACTIONS(636),
    [anon_sym_COLON] = ACTIONS(649),
    [anon_sym_EQ] = ACTIONS(652),
    [anon_sym_LBRACK] = ACTIONS(715),
    [anon_sym_LT] = ACTIONS(647),
    [anon_sym_GT] = ACTIONS(647),
    [anon_sym_SLASH] = ACTIONS(647),
    [anon_sym_DOT] = ACTIONS(647),
    [anon_sym_async] = ACTIONS(726),
    [anon_sym_EQ_GT] = ACTIONS(660),
    [anon_sym_QMARK_DOT] = ACTIONS(636),
    [anon_sym_PLUS_EQ] = ACTIONS(662),
    [anon_sym_DASH_EQ] = ACTIONS(662),
    [anon_sym_STAR_EQ] = ACTIONS(662),
    [anon_sym_SLASH_EQ] = ACTIONS(662),
    [anon_sym_PERCENT_EQ] = ACTIONS(662),
    [anon_sym_CARET_EQ] = ACTIONS(662),
    [anon_sym_AMP_EQ] = ACTIONS(662),
    [anon_sym_PIPE_EQ] = ACTIONS(662),
    [anon_sym_GT_GT_EQ] = ACTIONS(662),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(662),
    [anon_sym_LT_LT_EQ] = ACTIONS(662),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(662),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(662),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(662),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(662),
    [anon_sym_QMARK] = ACTIONS(647),
    [anon_sym_AMP_AMP] = ACTIONS(647),
    [anon_sym_PIPE_PIPE] = ACTIONS(647),
    [anon_sym_GT_GT] = ACTIONS(647),
    [anon_sym_GT_GT_GT] = ACTIONS(647),
    [anon_sym_LT_LT] = ACTIONS(647),
    [anon_sym_AMP] = ACTIONS(647),
    [anon_sym_CARET] = ACTIONS(647),
    [anon_sym_PIPE] = ACTIONS(647),
    [anon_sym_PLUS] = ACTIONS(647),
    [anon_sym_DASH] = ACTIONS(647),
    [anon_sym_PERCENT] = ACTIONS(647),
    [anon_sym_STAR_STAR] = ACTIONS(647),
    [anon_sym_LT_EQ] = ACTIONS(636),
    [anon_sym_EQ_EQ] = ACTIONS(647),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(636),
    [anon_sym_BANG_EQ] = ACTIONS(647),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(636),
    [anon_sym_GT_EQ] = ACTIONS(636),
    [anon_sym_QMARK_QMARK] = ACTIONS(647),
    [anon_sym_instanceof] = ACTIONS(647),
    [anon_sym_PLUS_PLUS] = ACTIONS(636),
    [anon_sym_DASH_DASH] = ACTIONS(636),
    [anon_sym_DQUOTE] = ACTIONS(363),
    [anon_sym_SQUOTE] = ACTIONS(365),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(636),
    [sym_number] = ACTIONS(720),
    [anon_sym_static] = ACTIONS(724),
    [anon_sym_get] = ACTIONS(728),
    [anon_sym_set] = ACTIONS(728),
    [sym__automatic_semicolon] = ACTIONS(636),
  },
  [205] = {
    [sym_string] = STATE(1181),
    [sym__property_name] = STATE(1181),
    [sym_computed_property_name] = STATE(1181),
    [aux_sym_object_repeat1] = STATE(976),
    [aux_sym_object_pattern_repeat1] = STATE(978),
    [sym_identifier] = ACTIONS(724),
    [anon_sym_export] = ACTIONS(724),
    [anon_sym_STAR] = ACTIONS(647),
    [anon_sym_COMMA] = ACTIONS(636),
    [anon_sym_RBRACE] = ACTIONS(638),
    [anon_sym_LPAREN] = ACTIONS(644),
    [anon_sym_in] = ACTIONS(647),
    [anon_sym_SEMI] = ACTIONS(636),
    [anon_sym_COLON] = ACTIONS(649),
    [anon_sym_EQ] = ACTIONS(652),
    [anon_sym_LBRACK] = ACTIONS(715),
    [anon_sym_LT] = ACTIONS(647),
    [anon_sym_GT] = ACTIONS(647),
    [anon_sym_SLASH] = ACTIONS(647),
    [anon_sym_DOT] = ACTIONS(647),
    [anon_sym_async] = ACTIONS(724),
    [anon_sym_EQ_GT] = ACTIONS(660),
    [anon_sym_QMARK_DOT] = ACTIONS(636),
    [anon_sym_PLUS_EQ] = ACTIONS(662),
    [anon_sym_DASH_EQ] = ACTIONS(662),
    [anon_sym_STAR_EQ] = ACTIONS(662),
    [anon_sym_SLASH_EQ] = ACTIONS(662),
    [anon_sym_PERCENT_EQ] = ACTIONS(662),
    [anon_sym_CARET_EQ] = ACTIONS(662),
    [anon_sym_AMP_EQ] = ACTIONS(662),
    [anon_sym_PIPE_EQ] = ACTIONS(662),
    [anon_sym_GT_GT_EQ] = ACTIONS(662),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(662),
    [anon_sym_LT_LT_EQ] = ACTIONS(662),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(662),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(662),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(662),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(662),
    [anon_sym_QMARK] = ACTIONS(647),
    [anon_sym_AMP_AMP] = ACTIONS(647),
    [anon_sym_PIPE_PIPE] = ACTIONS(647),
    [anon_sym_GT_GT] = ACTIONS(647),
    [anon_sym_GT_GT_GT] = ACTIONS(647),
    [anon_sym_LT_LT] = ACTIONS(647),
    [anon_sym_AMP] = ACTIONS(647),
    [anon_sym_CARET] = ACTIONS(647),
    [anon_sym_PIPE] = ACTIONS(647),
    [anon_sym_PLUS] = ACTIONS(647),
    [anon_sym_DASH] = ACTIONS(647),
    [anon_sym_PERCENT] = ACTIONS(647),
    [anon_sym_STAR_STAR] = ACTIONS(647),
    [anon_sym_LT_EQ] = ACTIONS(636),
    [anon_sym_EQ_EQ] = ACTIONS(647),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(636),
    [anon_sym_BANG_EQ] = ACTIONS(647),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(636),
    [anon_sym_GT_EQ] = ACTIONS(636),
    [anon_sym_QMARK_QMARK] = ACTIONS(647),
    [anon_sym_instanceof] = ACTIONS(647),
    [anon_sym_PLUS_PLUS] = ACTIONS(636),
    [anon_sym_DASH_DASH] = ACTIONS(636),
    [anon_sym_DQUOTE] = ACTIONS(363),
    [anon_sym_SQUOTE] = ACTIONS(365),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(636),
    [sym_number] = ACTIONS(720),
    [anon_sym_static] = ACTIONS(724),
    [anon_sym_get] = ACTIONS(724),
    [anon_sym_set] = ACTIONS(724),
    [sym__automatic_semicolon] = ACTIONS(636),
  },
  [206] = {
    [sym_string] = STATE(1181),
    [sym__property_name] = STATE(1181),
    [sym_computed_property_name] = STATE(1181),
    [aux_sym_object_repeat1] = STATE(1058),
    [aux_sym_object_pattern_repeat1] = STATE(978),
    [sym_identifier] = ACTIONS(724),
    [anon_sym_export] = ACTIONS(724),
    [anon_sym_STAR] = ACTIONS(647),
    [anon_sym_COMMA] = ACTIONS(636),
    [anon_sym_RBRACE] = ACTIONS(674),
    [anon_sym_LPAREN] = ACTIONS(644),
    [anon_sym_in] = ACTIONS(647),
    [anon_sym_SEMI] = ACTIONS(636),
    [anon_sym_COLON] = ACTIONS(649),
    [anon_sym_EQ] = ACTIONS(652),
    [anon_sym_LBRACK] = ACTIONS(715),
    [anon_sym_LT] = ACTIONS(647),
    [anon_sym_GT] = ACTIONS(647),
    [anon_sym_SLASH] = ACTIONS(647),
    [anon_sym_DOT] = ACTIONS(647),
    [anon_sym_async] = ACTIONS(724),
    [anon_sym_EQ_GT] = ACTIONS(660),
    [anon_sym_QMARK_DOT] = ACTIONS(636),
    [anon_sym_PLUS_EQ] = ACTIONS(662),
    [anon_sym_DASH_EQ] = ACTIONS(662),
    [anon_sym_STAR_EQ] = ACTIONS(662),
    [anon_sym_SLASH_EQ] = ACTIONS(662),
    [anon_sym_PERCENT_EQ] = ACTIONS(662),
    [anon_sym_CARET_EQ] = ACTIONS(662),
    [anon_sym_AMP_EQ] = ACTIONS(662),
    [anon_sym_PIPE_EQ] = ACTIONS(662),
    [anon_sym_GT_GT_EQ] = ACTIONS(662),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(662),
    [anon_sym_LT_LT_EQ] = ACTIONS(662),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(662),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(662),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(662),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(662),
    [anon_sym_QMARK] = ACTIONS(647),
    [anon_sym_AMP_AMP] = ACTIONS(647),
    [anon_sym_PIPE_PIPE] = ACTIONS(647),
    [anon_sym_GT_GT] = ACTIONS(647),
    [anon_sym_GT_GT_GT] = ACTIONS(647),
    [anon_sym_LT_LT] = ACTIONS(647),
    [anon_sym_AMP] = ACTIONS(647),
    [anon_sym_CARET] = ACTIONS(647),
    [anon_sym_PIPE] = ACTIONS(647),
    [anon_sym_PLUS] = ACTIONS(647),
    [anon_sym_DASH] = ACTIONS(647),
    [anon_sym_PERCENT] = ACTIONS(647),
    [anon_sym_STAR_STAR] = ACTIONS(647),
    [anon_sym_LT_EQ] = ACTIONS(636),
    [anon_sym_EQ_EQ] = ACTIONS(647),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(636),
    [anon_sym_BANG_EQ] = ACTIONS(647),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(636),
    [anon_sym_GT_EQ] = ACTIONS(636),
    [anon_sym_QMARK_QMARK] = ACTIONS(647),
    [anon_sym_instanceof] = ACTIONS(647),
    [anon_sym_PLUS_PLUS] = ACTIONS(636),
    [anon_sym_DASH_DASH] = ACTIONS(636),
    [anon_sym_DQUOTE] = ACTIONS(363),
    [anon_sym_SQUOTE] = ACTIONS(365),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(636),
    [sym_number] = ACTIONS(720),
    [anon_sym_static] = ACTIONS(724),
    [anon_sym_get] = ACTIONS(724),
    [anon_sym_set] = ACTIONS(724),
    [sym__automatic_semicolon] = ACTIONS(636),
  },
};

static uint16_t ts_small_parse_table[] = {
  [0] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(730), 1,
      sym_identifier,
    ACTIONS(734), 1,
      anon_sym_LPAREN,
    ACTIONS(737), 1,
      anon_sym_EQ,
    ACTIONS(739), 1,
      anon_sym_function,
    ACTIONS(741), 1,
      anon_sym_EQ_GT,
    STATE(1332), 1,
      sym_formal_parameters,
    ACTIONS(732), 5,
      anon_sym_export,
      anon_sym_async,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(636), 15,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(662), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(647), 22,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [87] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(743), 1,
      sym__automatic_semicolon,
    ACTIONS(479), 18,
      ts_builtin_sym_end,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(481), 44,
      anon_sym_export,
      anon_sym_default,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_else,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_case,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [160] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(427), 1,
      sym__automatic_semicolon,
    ACTIONS(417), 18,
      ts_builtin_sym_end,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(419), 44,
      anon_sym_export,
      anon_sym_default,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_else,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_case,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [233] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(730), 1,
      sym_identifier,
    ACTIONS(734), 1,
      anon_sym_LPAREN,
    ACTIONS(739), 1,
      anon_sym_function,
    ACTIONS(741), 1,
      anon_sym_EQ_GT,
    ACTIONS(745), 1,
      anon_sym_EQ,
    STATE(1332), 1,
      sym_formal_parameters,
    ACTIONS(732), 5,
      anon_sym_export,
      anon_sym_async,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(636), 15,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(662), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(647), 22,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [320] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(660), 1,
      anon_sym_EQ_GT,
    ACTIONS(734), 1,
      anon_sym_LPAREN,
    ACTIONS(737), 1,
      anon_sym_EQ,
    ACTIONS(747), 1,
      sym_identifier,
    ACTIONS(751), 1,
      anon_sym_function,
    STATE(1257), 1,
      sym_formal_parameters,
    ACTIONS(749), 5,
      anon_sym_export,
      anon_sym_async,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(636), 14,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(662), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(647), 22,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [406] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(660), 1,
      anon_sym_EQ_GT,
    ACTIONS(694), 1,
      anon_sym_EQ,
    ACTIONS(734), 1,
      anon_sym_LPAREN,
    ACTIONS(747), 1,
      sym_identifier,
    ACTIONS(751), 1,
      anon_sym_function,
    STATE(1257), 1,
      sym_formal_parameters,
    ACTIONS(749), 5,
      anon_sym_export,
      anon_sym_async,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(636), 14,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(662), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(647), 22,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [492] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(660), 1,
      anon_sym_EQ_GT,
    ACTIONS(694), 1,
      anon_sym_EQ,
    ACTIONS(734), 1,
      anon_sym_LPAREN,
    ACTIONS(747), 1,
      sym_identifier,
    ACTIONS(751), 1,
      anon_sym_function,
    ACTIONS(753), 1,
      anon_sym_in,
    ACTIONS(756), 1,
      anon_sym_of,
    STATE(1257), 1,
      sym_formal_parameters,
    ACTIONS(749), 5,
      anon_sym_export,
      anon_sym_async,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(636), 13,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(662), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(647), 21,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [582] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(660), 1,
      anon_sym_EQ_GT,
    ACTIONS(692), 1,
      anon_sym_COLON,
    ACTIONS(694), 1,
      anon_sym_EQ,
    ACTIONS(734), 1,
      anon_sym_LPAREN,
    ACTIONS(747), 1,
      sym_identifier,
    ACTIONS(758), 1,
      anon_sym_function,
    STATE(1257), 1,
      sym_formal_parameters,
    ACTIONS(749), 5,
      anon_sym_export,
      anon_sym_async,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(636), 13,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(662), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(647), 22,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [670] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(764), 1,
      anon_sym_catch,
    ACTIONS(766), 1,
      anon_sym_finally,
    STATE(221), 1,
      sym_catch_clause,
    STATE(305), 1,
      sym_finally_clause,
    ACTIONS(760), 16,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(762), 42,
      anon_sym_export,
      anon_sym_default,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_else,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_case,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [748] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(660), 1,
      anon_sym_EQ_GT,
    ACTIONS(694), 1,
      anon_sym_EQ,
    ACTIONS(702), 1,
      anon_sym_COLON,
    ACTIONS(718), 1,
      anon_sym_function,
    ACTIONS(734), 1,
      anon_sym_LPAREN,
    ACTIONS(747), 1,
      sym_identifier,
    STATE(1257), 1,
      sym_formal_parameters,
    ACTIONS(749), 5,
      anon_sym_export,
      anon_sym_async,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(636), 13,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(662), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(647), 22,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [836] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(479), 18,
      ts_builtin_sym_end,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(481), 44,
      anon_sym_export,
      anon_sym_default,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_else,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_case,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [906] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(449), 18,
      ts_builtin_sym_end,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(451), 44,
      anon_sym_export,
      anon_sym_default,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_else,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_case,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [976] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(730), 1,
      sym_identifier,
    ACTIONS(734), 1,
      anon_sym_LPAREN,
    ACTIONS(739), 1,
      anon_sym_function,
    ACTIONS(741), 1,
      anon_sym_EQ_GT,
    ACTIONS(771), 1,
      anon_sym_EQ,
    STATE(1332), 1,
      sym_formal_parameters,
    ACTIONS(768), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
    ACTIONS(732), 5,
      anon_sym_export,
      anon_sym_async,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(636), 10,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(662), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(647), 22,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [1063] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(730), 1,
      sym_identifier,
    ACTIONS(734), 1,
      anon_sym_LPAREN,
    ACTIONS(739), 1,
      anon_sym_function,
    ACTIONS(741), 1,
      anon_sym_EQ_GT,
    ACTIONS(768), 1,
      anon_sym_RBRACK,
    ACTIONS(771), 1,
      anon_sym_EQ,
    ACTIONS(774), 1,
      anon_sym_COMMA,
    STATE(1332), 1,
      sym_formal_parameters,
    ACTIONS(732), 5,
      anon_sym_export,
      anon_sym_async,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(636), 10,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(662), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(647), 22,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [1151] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(766), 1,
      anon_sym_finally,
    STATE(270), 1,
      sym_finally_clause,
    ACTIONS(776), 16,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(778), 42,
      anon_sym_export,
      anon_sym_default,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_else,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_case,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [1223] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(734), 1,
      anon_sym_LPAREN,
    ACTIONS(737), 1,
      anon_sym_EQ,
    ACTIONS(739), 1,
      anon_sym_function,
    ACTIONS(780), 1,
      sym_identifier,
    ACTIONS(784), 1,
      anon_sym_EQ_GT,
    STATE(1294), 1,
      sym_formal_parameters,
    ACTIONS(782), 5,
      anon_sym_export,
      anon_sym_async,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(636), 12,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(662), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(647), 22,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [1307] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(730), 1,
      sym_identifier,
    ACTIONS(734), 1,
      anon_sym_LPAREN,
    ACTIONS(739), 1,
      anon_sym_function,
    ACTIONS(741), 1,
      anon_sym_EQ_GT,
    ACTIONS(745), 1,
      anon_sym_EQ,
    STATE(1332), 1,
      sym_formal_parameters,
    ACTIONS(768), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(732), 5,
      anon_sym_export,
      anon_sym_async,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(636), 10,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(662), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(647), 22,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [1393] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(463), 1,
      sym__automatic_semicolon,
    ACTIONS(455), 16,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(457), 42,
      anon_sym_export,
      anon_sym_default,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_else,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_case,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [1462] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(503), 1,
      sym__automatic_semicolon,
    ACTIONS(495), 16,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(497), 42,
      anon_sym_export,
      anon_sym_default,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_else,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_case,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [1531] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(734), 1,
      anon_sym_LPAREN,
    ACTIONS(737), 1,
      anon_sym_EQ,
    ACTIONS(739), 1,
      anon_sym_function,
    ACTIONS(753), 1,
      anon_sym_in,
    ACTIONS(756), 1,
      anon_sym_of,
    ACTIONS(780), 1,
      sym_identifier,
    ACTIONS(784), 1,
      anon_sym_EQ_GT,
    STATE(1294), 1,
      sym_formal_parameters,
    ACTIONS(782), 5,
      anon_sym_export,
      anon_sym_async,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(636), 10,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(662), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(647), 21,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [1618] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(786), 17,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(788), 42,
      anon_sym_export,
      anon_sym_default,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_else,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_case,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [1685] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(790), 16,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(792), 43,
      anon_sym_export,
      anon_sym_default,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_else,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_case,
      anon_sym_finally,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [1752] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(527), 1,
      sym__automatic_semicolon,
    ACTIONS(519), 16,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(521), 42,
      anon_sym_export,
      anon_sym_default,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_else,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_case,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [1821] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(493), 1,
      sym__automatic_semicolon,
    ACTIONS(485), 16,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(487), 42,
      anon_sym_export,
      anon_sym_default,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_else,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_case,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [1890] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(437), 1,
      sym__automatic_semicolon,
    ACTIONS(429), 16,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(431), 42,
      anon_sym_export,
      anon_sym_default,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_else,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_case,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [1959] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(798), 1,
      anon_sym_else,
    STATE(250), 1,
      sym_else_clause,
    ACTIONS(794), 16,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(796), 41,
      anon_sym_export,
      anon_sym_default,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_case,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [2030] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(477), 1,
      sym__automatic_semicolon,
    ACTIONS(469), 16,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(471), 42,
      anon_sym_export,
      anon_sym_default,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_else,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_case,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [2099] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(449), 17,
      sym__automatic_semicolon,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(451), 42,
      anon_sym_export,
      anon_sym_default,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_else,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_case,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [2166] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(800), 1,
      sym__automatic_semicolon,
    ACTIONS(417), 16,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(419), 42,
      anon_sym_export,
      anon_sym_default,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_else,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_case,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [2235] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(802), 16,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(804), 43,
      anon_sym_export,
      anon_sym_default,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_else,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_case,
      anon_sym_finally,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [2302] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(447), 1,
      sym__automatic_semicolon,
    ACTIONS(439), 16,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(441), 42,
      anon_sym_export,
      anon_sym_default,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_else,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_case,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [2371] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(513), 1,
      sym__automatic_semicolon,
    ACTIONS(505), 16,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(507), 42,
      anon_sym_export,
      anon_sym_default,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_else,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_case,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [2440] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(479), 17,
      sym__automatic_semicolon,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(481), 42,
      anon_sym_export,
      anon_sym_default,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_else,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_case,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [2507] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(806), 17,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(808), 42,
      anon_sym_export,
      anon_sym_default,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_else,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_case,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [2574] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(515), 17,
      sym__automatic_semicolon,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(517), 42,
      anon_sym_export,
      anon_sym_default,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_else,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_case,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [2641] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(465), 17,
      sym__automatic_semicolon,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(467), 42,
      anon_sym_export,
      anon_sym_default,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_else,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_case,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [2708] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(810), 1,
      sym__automatic_semicolon,
    ACTIONS(479), 16,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(481), 42,
      anon_sym_export,
      anon_sym_default,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_else,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_case,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [2777] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(812), 16,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(814), 42,
      anon_sym_export,
      anon_sym_default,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_else,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_case,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [2843] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(816), 16,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(818), 42,
      anon_sym_export,
      anon_sym_default,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_else,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_case,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [2909] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(820), 16,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(822), 42,
      anon_sym_export,
      anon_sym_default,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_else,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_case,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [2975] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(820), 16,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(822), 42,
      anon_sym_export,
      anon_sym_default,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_else,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_case,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [3041] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(824), 16,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(826), 42,
      anon_sym_export,
      anon_sym_default,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_else,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_case,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [3107] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(828), 16,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(830), 42,
      anon_sym_export,
      anon_sym_default,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_else,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_case,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [3173] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(832), 16,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(834), 42,
      anon_sym_export,
      anon_sym_default,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_else,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_case,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [3239] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(836), 16,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(838), 42,
      anon_sym_export,
      anon_sym_default,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_else,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_case,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [3305] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(820), 16,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(822), 42,
      anon_sym_export,
      anon_sym_default,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_else,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_case,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [3371] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(840), 16,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(842), 42,
      anon_sym_export,
      anon_sym_default,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_else,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_case,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [3437] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(820), 16,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(822), 42,
      anon_sym_export,
      anon_sym_default,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_else,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_case,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [3503] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(820), 16,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(822), 42,
      anon_sym_export,
      anon_sym_default,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_else,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_case,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [3569] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(820), 16,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(822), 42,
      anon_sym_export,
      anon_sym_default,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_else,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_case,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [3635] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(844), 16,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(846), 42,
      anon_sym_export,
      anon_sym_default,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_else,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_case,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [3701] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(820), 16,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(822), 42,
      anon_sym_export,
      anon_sym_default,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_else,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_case,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [3767] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(844), 16,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(846), 42,
      anon_sym_export,
      anon_sym_default,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_else,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_case,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [3833] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(820), 16,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(822), 42,
      anon_sym_export,
      anon_sym_default,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_else,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_case,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [3899] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(820), 16,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(822), 42,
      anon_sym_export,
      anon_sym_default,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_else,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_case,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [3965] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(820), 16,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(822), 42,
      anon_sym_export,
      anon_sym_default,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_else,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_case,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [4031] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(820), 16,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(822), 42,
      anon_sym_export,
      anon_sym_default,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_else,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_case,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [4097] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(820), 16,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(822), 42,
      anon_sym_export,
      anon_sym_default,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_else,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_case,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [4163] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(848), 16,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(850), 42,
      anon_sym_export,
      anon_sym_default,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_else,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_case,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [4229] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(820), 16,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(822), 42,
      anon_sym_export,
      anon_sym_default,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_else,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_case,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [4295] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(820), 16,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(822), 42,
      anon_sym_export,
      anon_sym_default,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_else,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_case,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [4361] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(820), 16,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(822), 42,
      anon_sym_export,
      anon_sym_default,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_else,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_case,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [4427] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(852), 16,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(854), 42,
      anon_sym_export,
      anon_sym_default,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_else,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_case,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [4493] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(856), 16,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(858), 42,
      anon_sym_export,
      anon_sym_default,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_else,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_case,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [4559] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(860), 16,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(862), 42,
      anon_sym_export,
      anon_sym_default,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_else,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_case,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [4625] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(864), 16,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(866), 42,
      anon_sym_export,
      anon_sym_default,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_else,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_case,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [4691] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(868), 16,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(870), 42,
      anon_sym_export,
      anon_sym_default,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_else,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_case,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [4757] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(820), 16,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(822), 42,
      anon_sym_export,
      anon_sym_default,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_else,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_case,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [4823] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(872), 16,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(874), 42,
      anon_sym_export,
      anon_sym_default,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_else,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_case,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [4889] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(876), 16,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(878), 42,
      anon_sym_export,
      anon_sym_default,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_else,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_case,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [4955] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(880), 16,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(882), 42,
      anon_sym_export,
      anon_sym_default,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_else,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_case,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [5021] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(880), 16,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(882), 42,
      anon_sym_export,
      anon_sym_default,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_else,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_case,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [5087] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(884), 16,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(886), 42,
      anon_sym_export,
      anon_sym_default,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_else,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_case,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [5153] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(888), 16,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(890), 42,
      anon_sym_export,
      anon_sym_default,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_else,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_case,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [5219] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(820), 16,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(822), 42,
      anon_sym_export,
      anon_sym_default,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_else,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_case,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [5285] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(892), 16,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(894), 42,
      anon_sym_export,
      anon_sym_default,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_else,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_case,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [5351] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(896), 16,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(898), 42,
      anon_sym_export,
      anon_sym_default,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_else,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_case,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [5417] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(900), 16,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(902), 42,
      anon_sym_export,
      anon_sym_default,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_else,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_case,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [5483] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(904), 16,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(906), 42,
      anon_sym_export,
      anon_sym_default,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_else,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_case,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [5549] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(880), 16,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(882), 42,
      anon_sym_export,
      anon_sym_default,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_else,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_case,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [5615] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(880), 16,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(882), 42,
      anon_sym_export,
      anon_sym_default,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_else,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_case,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [5681] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(908), 16,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(910), 42,
      anon_sym_export,
      anon_sym_default,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_else,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_case,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [5747] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(912), 16,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(914), 42,
      anon_sym_export,
      anon_sym_default,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_else,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_case,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [5813] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(916), 16,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(918), 42,
      anon_sym_export,
      anon_sym_default,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_else,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_case,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [5879] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(920), 16,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(922), 42,
      anon_sym_export,
      anon_sym_default,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_else,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_case,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [5945] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(924), 16,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(926), 42,
      anon_sym_export,
      anon_sym_default,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_else,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_case,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [6011] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(928), 16,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(930), 42,
      anon_sym_export,
      anon_sym_default,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_else,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_case,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [6077] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(932), 16,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(934), 42,
      anon_sym_export,
      anon_sym_default,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_else,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_case,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [6143] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(936), 16,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(938), 42,
      anon_sym_export,
      anon_sym_default,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_else,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_case,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [6209] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(820), 16,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(822), 42,
      anon_sym_export,
      anon_sym_default,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_else,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_case,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [6275] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(820), 16,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(822), 42,
      anon_sym_export,
      anon_sym_default,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_else,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_case,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [6341] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(940), 16,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(942), 42,
      anon_sym_export,
      anon_sym_default,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_else,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_case,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [6407] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(944), 16,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(946), 42,
      anon_sym_export,
      anon_sym_default,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_else,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_case,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [6473] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(948), 16,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(950), 42,
      anon_sym_export,
      anon_sym_default,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_else,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_case,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [6539] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(952), 16,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(954), 42,
      anon_sym_export,
      anon_sym_default,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_else,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_case,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [6605] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(956), 16,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(958), 42,
      anon_sym_export,
      anon_sym_default,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_else,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_case,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [6671] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(960), 16,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(962), 42,
      anon_sym_export,
      anon_sym_default,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_else,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_case,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [6737] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(964), 16,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(966), 42,
      anon_sym_export,
      anon_sym_default,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_else,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_case,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [6803] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(968), 16,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(970), 42,
      anon_sym_export,
      anon_sym_default,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_else,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_case,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [6869] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(820), 16,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(822), 42,
      anon_sym_export,
      anon_sym_default,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_else,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_case,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [6935] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(972), 16,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(974), 42,
      anon_sym_export,
      anon_sym_default,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_else,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_case,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [7001] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(976), 16,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(978), 42,
      anon_sym_export,
      anon_sym_default,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_else,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_case,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [7067] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(980), 16,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(982), 42,
      anon_sym_export,
      anon_sym_default,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_else,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_case,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [7133] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(984), 16,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(986), 42,
      anon_sym_export,
      anon_sym_default,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_else,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_case,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [7199] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(984), 16,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(986), 42,
      anon_sym_export,
      anon_sym_default,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_else,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_case,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [7265] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(984), 16,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(986), 42,
      anon_sym_export,
      anon_sym_default,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_else,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_case,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [7331] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(984), 16,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(986), 42,
      anon_sym_export,
      anon_sym_default,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_else,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_case,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [7397] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(984), 16,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(986), 42,
      anon_sym_export,
      anon_sym_default,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_else,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_case,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [7463] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(984), 16,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(986), 42,
      anon_sym_export,
      anon_sym_default,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_else,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_case,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [7529] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(984), 16,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(986), 42,
      anon_sym_export,
      anon_sym_default,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_else,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_case,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [7595] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(984), 16,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(986), 42,
      anon_sym_export,
      anon_sym_default,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_else,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_case,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [7661] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(984), 16,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(986), 42,
      anon_sym_export,
      anon_sym_default,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_else,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_case,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [7727] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(984), 16,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(986), 42,
      anon_sym_export,
      anon_sym_default,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_else,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_case,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [7793] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(984), 16,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(986), 42,
      anon_sym_export,
      anon_sym_default,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_else,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_case,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [7859] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(984), 16,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(986), 42,
      anon_sym_export,
      anon_sym_default,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_else,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_case,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [7925] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(984), 16,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(986), 42,
      anon_sym_export,
      anon_sym_default,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_else,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_case,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [7991] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(984), 16,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(986), 42,
      anon_sym_export,
      anon_sym_default,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_else,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_case,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [8057] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(984), 16,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(986), 42,
      anon_sym_export,
      anon_sym_default,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_else,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_case,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [8123] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(984), 16,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(986), 42,
      anon_sym_export,
      anon_sym_default,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_else,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_case,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [8189] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(984), 16,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(986), 42,
      anon_sym_export,
      anon_sym_default,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_else,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_case,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [8255] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(984), 16,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(986), 42,
      anon_sym_export,
      anon_sym_default,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_else,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_case,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [8321] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(984), 16,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(986), 42,
      anon_sym_export,
      anon_sym_default,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_else,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_case,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [8387] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(984), 16,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(986), 42,
      anon_sym_export,
      anon_sym_default,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_else,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_case,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [8453] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(980), 16,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(982), 42,
      anon_sym_export,
      anon_sym_default,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_else,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_case,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [8519] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(988), 16,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(990), 42,
      anon_sym_export,
      anon_sym_default,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_else,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_case,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [8585] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(638), 1,
      anon_sym_RBRACE,
    ACTIONS(649), 1,
      anon_sym_COLON,
    ACTIONS(996), 1,
      anon_sym_LPAREN,
    ACTIONS(999), 1,
      anon_sym_EQ,
    ACTIONS(1001), 1,
      anon_sym_EQ_GT,
    STATE(976), 1,
      aux_sym_object_repeat1,
    STATE(978), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(994), 14,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1003), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(992), 21,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [8666] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(649), 1,
      anon_sym_COLON,
    ACTIONS(678), 1,
      anon_sym_RBRACE,
    ACTIONS(996), 1,
      anon_sym_LPAREN,
    ACTIONS(999), 1,
      anon_sym_EQ,
    ACTIONS(1001), 1,
      anon_sym_EQ_GT,
    STATE(978), 1,
      aux_sym_object_pattern_repeat1,
    STATE(1058), 1,
      aux_sym_object_repeat1,
    ACTIONS(994), 14,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1003), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(992), 21,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [8747] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(649), 1,
      anon_sym_COLON,
    ACTIONS(674), 1,
      anon_sym_RBRACE,
    ACTIONS(996), 1,
      anon_sym_LPAREN,
    ACTIONS(999), 1,
      anon_sym_EQ,
    ACTIONS(1001), 1,
      anon_sym_EQ_GT,
    STATE(978), 1,
      aux_sym_object_pattern_repeat1,
    STATE(1058), 1,
      aux_sym_object_repeat1,
    ACTIONS(994), 14,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1003), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(992), 21,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [8828] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1005), 22,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(1007), 34,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [8892] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1009), 22,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(1011), 34,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [8956] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1013), 22,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(1015), 34,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [9020] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1017), 22,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(1019), 34,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [9084] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1021), 1,
      anon_sym_EQ,
    ACTIONS(1023), 1,
      anon_sym_EQ_GT,
    ACTIONS(1003), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(994), 17,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(992), 21,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [9153] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1025), 1,
      anon_sym_EQ,
    ACTIONS(1003), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(994), 18,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(992), 21,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [9220] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1023), 1,
      anon_sym_EQ_GT,
    ACTIONS(1025), 1,
      anon_sym_EQ,
    ACTIONS(1003), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(994), 17,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(992), 21,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [9289] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(737), 1,
      anon_sym_EQ,
    ACTIONS(741), 1,
      anon_sym_EQ_GT,
    ACTIONS(662), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(636), 17,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(647), 21,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [9358] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(741), 1,
      anon_sym_EQ_GT,
    ACTIONS(745), 1,
      anon_sym_EQ,
    ACTIONS(662), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(636), 17,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(647), 21,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [9427] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1005), 22,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(1007), 32,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [9489] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(660), 1,
      anon_sym_EQ_GT,
    ACTIONS(694), 1,
      anon_sym_EQ,
    ACTIONS(662), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(636), 16,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(647), 21,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [9557] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1001), 1,
      anon_sym_EQ_GT,
    ACTIONS(1025), 1,
      anon_sym_EQ,
    ACTIONS(1003), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(994), 16,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(992), 21,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [9625] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(702), 1,
      anon_sym_COLON,
    ACTIONS(1001), 1,
      anon_sym_EQ_GT,
    ACTIONS(1027), 1,
      anon_sym_EQ,
    ACTIONS(994), 15,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1003), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(992), 21,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [9695] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1017), 22,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(1019), 32,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [9757] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(660), 1,
      anon_sym_EQ_GT,
    ACTIONS(694), 1,
      anon_sym_EQ,
    ACTIONS(702), 1,
      anon_sym_COLON,
    ACTIONS(636), 15,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(662), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(647), 21,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [9827] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(660), 1,
      anon_sym_EQ_GT,
    ACTIONS(692), 1,
      anon_sym_COLON,
    ACTIONS(694), 1,
      anon_sym_EQ,
    ACTIONS(636), 15,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(662), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(647), 21,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [9897] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1013), 22,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(1015), 32,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [9959] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(692), 1,
      anon_sym_COLON,
    ACTIONS(1001), 1,
      anon_sym_EQ_GT,
    ACTIONS(1027), 1,
      anon_sym_EQ,
    ACTIONS(994), 15,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1003), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(992), 21,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [10029] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(660), 1,
      anon_sym_EQ_GT,
    ACTIONS(737), 1,
      anon_sym_EQ,
    ACTIONS(662), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(636), 16,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(647), 21,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [10097] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1001), 1,
      anon_sym_EQ_GT,
    ACTIONS(1027), 1,
      anon_sym_EQ,
    ACTIONS(1029), 1,
      anon_sym_in,
    ACTIONS(1032), 1,
      anon_sym_of,
    ACTIONS(994), 15,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1003), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(992), 20,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [10169] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1021), 1,
      anon_sym_EQ,
    ACTIONS(1003), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(994), 17,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(992), 21,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [10235] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(660), 1,
      anon_sym_EQ_GT,
    ACTIONS(694), 1,
      anon_sym_EQ,
    ACTIONS(753), 1,
      anon_sym_in,
    ACTIONS(1034), 1,
      anon_sym_of,
    ACTIONS(636), 15,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(662), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(647), 20,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [10307] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1001), 1,
      anon_sym_EQ_GT,
    ACTIONS(1027), 1,
      anon_sym_EQ,
    ACTIONS(1003), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(994), 16,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(992), 21,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [10375] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1009), 22,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(1011), 32,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [10437] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(741), 1,
      anon_sym_EQ_GT,
    ACTIONS(771), 1,
      anon_sym_EQ,
    ACTIONS(768), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
    ACTIONS(636), 12,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(662), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(647), 21,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [10506] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1023), 1,
      anon_sym_EQ_GT,
    ACTIONS(1039), 1,
      anon_sym_EQ,
    ACTIONS(1036), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
    ACTIONS(994), 12,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1003), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(992), 21,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [10575] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1019), 14,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(1017), 39,
      anon_sym_export,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [10636] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1027), 1,
      anon_sym_EQ,
    ACTIONS(1003), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(994), 16,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(992), 21,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [10701] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1027), 1,
      anon_sym_EQ,
    ACTIONS(1029), 1,
      anon_sym_in,
    ACTIONS(1032), 1,
      anon_sym_of,
    ACTIONS(994), 15,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1003), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(992), 20,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [10770] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1044), 14,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(1042), 39,
      anon_sym_export,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [10831] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1048), 14,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(1046), 39,
      anon_sym_export,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [10892] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1052), 14,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(1050), 39,
      anon_sym_export,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [10953] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1025), 1,
      anon_sym_EQ,
    ACTIONS(1003), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(994), 16,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(992), 21,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [11018] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(737), 1,
      anon_sym_EQ,
    ACTIONS(784), 1,
      anon_sym_EQ_GT,
    ACTIONS(636), 14,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(662), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(647), 21,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [11084] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1025), 1,
      anon_sym_EQ,
    ACTIONS(1054), 1,
      anon_sym_EQ_GT,
    ACTIONS(994), 14,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1003), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(992), 21,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [11150] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(741), 1,
      anon_sym_EQ_GT,
    ACTIONS(768), 1,
      anon_sym_RBRACK,
    ACTIONS(771), 1,
      anon_sym_EQ,
    ACTIONS(774), 1,
      anon_sym_COMMA,
    ACTIONS(636), 12,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(662), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(647), 21,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [11220] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1021), 1,
      anon_sym_EQ,
    ACTIONS(1023), 1,
      anon_sym_EQ_GT,
    ACTIONS(1056), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(994), 12,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1003), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(992), 21,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [11288] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1021), 1,
      anon_sym_EQ,
    ACTIONS(1023), 1,
      anon_sym_EQ_GT,
    ACTIONS(1036), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(994), 12,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1003), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(992), 21,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [11356] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(741), 1,
      anon_sym_EQ_GT,
    ACTIONS(745), 1,
      anon_sym_EQ,
    ACTIONS(768), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(636), 12,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(662), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(647), 21,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [11424] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1023), 1,
      anon_sym_EQ_GT,
    ACTIONS(1036), 1,
      anon_sym_RBRACK,
    ACTIONS(1039), 1,
      anon_sym_EQ,
    ACTIONS(1059), 1,
      anon_sym_COMMA,
    ACTIONS(994), 12,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1003), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(992), 21,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [11494] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1023), 1,
      anon_sym_EQ_GT,
    ACTIONS(1061), 1,
      anon_sym_EQ,
    ACTIONS(1056), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(994), 12,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1003), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(992), 21,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [11562] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1025), 1,
      anon_sym_EQ,
    ACTIONS(1029), 1,
      anon_sym_in,
    ACTIONS(1032), 1,
      anon_sym_of,
    ACTIONS(1054), 1,
      anon_sym_EQ_GT,
    ACTIONS(994), 12,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1003), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(992), 20,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [11631] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(737), 1,
      anon_sym_EQ,
    ACTIONS(753), 1,
      anon_sym_in,
    ACTIONS(784), 1,
      anon_sym_EQ_GT,
    ACTIONS(1034), 1,
      anon_sym_of,
    ACTIONS(636), 12,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(662), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(647), 20,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [11700] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1063), 22,
      anon_sym_export,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_class,
      anon_sym_async,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(1065), 28,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
  [11758] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1067), 22,
      anon_sym_export,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_class,
      anon_sym_async,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(1069), 28,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
  [11816] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1025), 1,
      anon_sym_EQ,
    ACTIONS(1029), 1,
      anon_sym_in,
    ACTIONS(1032), 1,
      anon_sym_of,
    ACTIONS(994), 12,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1003), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(992), 20,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [11882] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1071), 22,
      anon_sym_export,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_class,
      anon_sym_async,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(1073), 28,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
  [11940] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(75), 1,
      anon_sym_DQUOTE,
    ACTIONS(77), 1,
      anon_sym_SQUOTE,
    ACTIONS(1075), 1,
      sym_identifier,
    ACTIONS(1077), 1,
      anon_sym_STAR,
    ACTIONS(1079), 1,
      anon_sym_LBRACE,
    STATE(1185), 1,
      sym_import_clause,
    STATE(1188), 1,
      sym_string,
    STATE(1298), 2,
      sym_namespace_import,
      sym_named_imports,
    ACTIONS(1083), 13,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
    ACTIONS(1081), 22,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [12008] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(367), 1,
      anon_sym_BQUOTE,
    ACTIONS(1089), 1,
      anon_sym_LPAREN,
    ACTIONS(1091), 1,
      anon_sym_LBRACK,
    ACTIONS(1093), 1,
      anon_sym_DOT,
    ACTIONS(1095), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1097), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(453), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1085), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1087), 19,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [12071] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(425), 1,
      anon_sym_EQ,
    ACTIONS(1099), 1,
      sym__automatic_semicolon,
    ACTIONS(419), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(417), 26,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [12124] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(367), 1,
      anon_sym_BQUOTE,
    ACTIONS(1089), 1,
      anon_sym_LPAREN,
    ACTIONS(1091), 1,
      anon_sym_LBRACK,
    ACTIONS(1093), 1,
      anon_sym_DOT,
    ACTIONS(1095), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1097), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(453), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1101), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1103), 19,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [12187] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(367), 1,
      anon_sym_BQUOTE,
    ACTIONS(1089), 1,
      anon_sym_LPAREN,
    ACTIONS(1091), 1,
      anon_sym_LBRACK,
    ACTIONS(1093), 1,
      anon_sym_DOT,
    ACTIONS(1095), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1097), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(453), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1101), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1103), 19,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [12250] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(367), 1,
      anon_sym_BQUOTE,
    ACTIONS(1089), 1,
      anon_sym_LPAREN,
    ACTIONS(1091), 1,
      anon_sym_LBRACK,
    ACTIONS(1093), 1,
      anon_sym_DOT,
    ACTIONS(1095), 1,
      anon_sym_QMARK_DOT,
    STATE(453), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1105), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1107), 21,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
  [12311] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(367), 1,
      anon_sym_BQUOTE,
    ACTIONS(1089), 1,
      anon_sym_LPAREN,
    ACTIONS(1091), 1,
      anon_sym_LBRACK,
    ACTIONS(1093), 1,
      anon_sym_DOT,
    ACTIONS(1095), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1113), 1,
      anon_sym_in,
    ACTIONS(1117), 1,
      anon_sym_QMARK,
    ACTIONS(1119), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1125), 1,
      anon_sym_AMP,
    ACTIONS(1127), 1,
      anon_sym_PIPE,
    ACTIONS(1131), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1135), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1097), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1121), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1129), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(453), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1109), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1123), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1115), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1111), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(1133), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [12397] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(367), 1,
      anon_sym_BQUOTE,
    ACTIONS(1089), 1,
      anon_sym_LPAREN,
    ACTIONS(1091), 1,
      anon_sym_LBRACK,
    ACTIONS(1093), 1,
      anon_sym_DOT,
    ACTIONS(1095), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1113), 1,
      anon_sym_in,
    ACTIONS(1117), 1,
      anon_sym_QMARK,
    ACTIONS(1119), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1125), 1,
      anon_sym_AMP,
    ACTIONS(1127), 1,
      anon_sym_PIPE,
    ACTIONS(1131), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1135), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1097), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1121), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1129), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(453), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1109), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1123), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1115), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1133), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(1137), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [12483] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(367), 1,
      anon_sym_BQUOTE,
    ACTIONS(1089), 1,
      anon_sym_LPAREN,
    ACTIONS(1091), 1,
      anon_sym_LBRACK,
    ACTIONS(1093), 1,
      anon_sym_DOT,
    ACTIONS(1095), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1113), 1,
      anon_sym_in,
    ACTIONS(1117), 1,
      anon_sym_QMARK,
    ACTIONS(1119), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1125), 1,
      anon_sym_AMP,
    ACTIONS(1127), 1,
      anon_sym_PIPE,
    ACTIONS(1131), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1135), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1097), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1121), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1129), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(453), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1109), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1123), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1115), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1133), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(1139), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [12569] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(367), 1,
      anon_sym_BQUOTE,
    ACTIONS(1089), 1,
      anon_sym_LPAREN,
    ACTIONS(1091), 1,
      anon_sym_LBRACK,
    ACTIONS(1093), 1,
      anon_sym_DOT,
    ACTIONS(1095), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1113), 1,
      anon_sym_in,
    ACTIONS(1117), 1,
      anon_sym_QMARK,
    ACTIONS(1119), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1125), 1,
      anon_sym_AMP,
    ACTIONS(1127), 1,
      anon_sym_PIPE,
    ACTIONS(1131), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1135), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1097), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1121), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1129), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(453), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1109), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1123), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1115), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1133), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(1141), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [12655] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1143), 1,
      sym__automatic_semicolon,
    ACTIONS(481), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(479), 26,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [12705] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(367), 1,
      anon_sym_BQUOTE,
    ACTIONS(1085), 1,
      anon_sym_QMARK,
    ACTIONS(1089), 1,
      anon_sym_LPAREN,
    ACTIONS(1091), 1,
      anon_sym_LBRACK,
    ACTIONS(1093), 1,
      anon_sym_DOT,
    ACTIONS(1095), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1113), 1,
      anon_sym_in,
    ACTIONS(1119), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1125), 1,
      anon_sym_AMP,
    ACTIONS(1127), 1,
      anon_sym_PIPE,
    ACTIONS(1131), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1097), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1121), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1129), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(453), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1109), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1123), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1115), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1133), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(1087), 6,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_QMARK_QMARK,
  [12789] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1149), 1,
      sym_regex_flags,
    ACTIONS(1145), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
    ACTIONS(1147), 25,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [12839] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(367), 1,
      anon_sym_BQUOTE,
    ACTIONS(1089), 1,
      anon_sym_LPAREN,
    ACTIONS(1091), 1,
      anon_sym_LBRACK,
    ACTIONS(1093), 1,
      anon_sym_DOT,
    ACTIONS(1095), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1131), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1097), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1129), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(453), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1109), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1123), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1085), 4,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1115), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1133), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(1087), 9,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
  [12913] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(367), 1,
      anon_sym_BQUOTE,
    ACTIONS(1089), 1,
      anon_sym_LPAREN,
    ACTIONS(1091), 1,
      anon_sym_LBRACK,
    ACTIONS(1093), 1,
      anon_sym_DOT,
    ACTIONS(1095), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1131), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1097), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1129), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(453), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1109), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1123), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1085), 8,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1087), 14,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [12983] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1158), 1,
      anon_sym_EQ,
    ACTIONS(1155), 4,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
    ACTIONS(1151), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1153), 22,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [13035] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(367), 1,
      anon_sym_BQUOTE,
    ACTIONS(1089), 1,
      anon_sym_LPAREN,
    ACTIONS(1091), 1,
      anon_sym_LBRACK,
    ACTIONS(1093), 1,
      anon_sym_DOT,
    ACTIONS(1095), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1113), 1,
      anon_sym_in,
    ACTIONS(1117), 1,
      anon_sym_QMARK,
    ACTIONS(1119), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1125), 1,
      anon_sym_AMP,
    ACTIONS(1127), 1,
      anon_sym_PIPE,
    ACTIONS(1131), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1135), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1097), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1121), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1129), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(453), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1109), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1123), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1115), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1133), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(1160), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [13121] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(367), 1,
      anon_sym_BQUOTE,
    ACTIONS(1089), 1,
      anon_sym_LPAREN,
    ACTIONS(1091), 1,
      anon_sym_LBRACK,
    ACTIONS(1093), 1,
      anon_sym_DOT,
    ACTIONS(1095), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1113), 1,
      anon_sym_in,
    ACTIONS(1117), 1,
      anon_sym_QMARK,
    ACTIONS(1119), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1125), 1,
      anon_sym_AMP,
    ACTIONS(1127), 1,
      anon_sym_PIPE,
    ACTIONS(1131), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1135), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1097), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1121), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1129), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(453), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1109), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1123), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1115), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1133), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(1162), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [13207] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1089), 1,
      anon_sym_LPAREN,
    ACTIONS(1091), 1,
      anon_sym_LBRACK,
    ACTIONS(1093), 1,
      anon_sym_DOT,
    ACTIONS(1168), 1,
      anon_sym_QMARK_DOT,
    STATE(430), 1,
      sym_arguments,
    ACTIONS(1164), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1166), 22,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [13265] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(367), 1,
      anon_sym_BQUOTE,
    ACTIONS(1089), 1,
      anon_sym_LPAREN,
    ACTIONS(1091), 1,
      anon_sym_LBRACK,
    ACTIONS(1093), 1,
      anon_sym_DOT,
    ACTIONS(1095), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1113), 1,
      anon_sym_in,
    ACTIONS(1117), 1,
      anon_sym_QMARK,
    ACTIONS(1119), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1125), 1,
      anon_sym_AMP,
    ACTIONS(1127), 1,
      anon_sym_PIPE,
    ACTIONS(1131), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1135), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1097), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1121), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1129), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(453), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1109), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1123), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1115), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1133), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(1170), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [13351] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(425), 1,
      anon_sym_EQ,
    ACTIONS(1172), 4,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
    ACTIONS(421), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(423), 22,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [13403] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1182), 1,
      anon_sym_EQ,
    ACTIONS(1179), 4,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
    ACTIONS(1175), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1177), 22,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [13455] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(367), 1,
      anon_sym_BQUOTE,
    ACTIONS(1089), 1,
      anon_sym_LPAREN,
    ACTIONS(1091), 1,
      anon_sym_LBRACK,
    ACTIONS(1093), 1,
      anon_sym_DOT,
    ACTIONS(1095), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1113), 1,
      anon_sym_in,
    ACTIONS(1117), 1,
      anon_sym_QMARK,
    ACTIONS(1119), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1125), 1,
      anon_sym_AMP,
    ACTIONS(1127), 1,
      anon_sym_PIPE,
    ACTIONS(1131), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1135), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1097), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1121), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1129), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(453), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1109), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1123), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1115), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1133), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(1184), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [13541] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(367), 1,
      anon_sym_BQUOTE,
    ACTIONS(1089), 1,
      anon_sym_LPAREN,
    ACTIONS(1091), 1,
      anon_sym_LBRACK,
    ACTIONS(1093), 1,
      anon_sym_DOT,
    ACTIONS(1095), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1113), 1,
      anon_sym_in,
    ACTIONS(1117), 1,
      anon_sym_QMARK,
    ACTIONS(1119), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1125), 1,
      anon_sym_AMP,
    ACTIONS(1127), 1,
      anon_sym_PIPE,
    ACTIONS(1131), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1135), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1097), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1121), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1129), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(453), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1109), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1123), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1115), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1133), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(1186), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [13627] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(367), 1,
      anon_sym_BQUOTE,
    ACTIONS(1089), 1,
      anon_sym_LPAREN,
    ACTIONS(1091), 1,
      anon_sym_LBRACK,
    ACTIONS(1093), 1,
      anon_sym_DOT,
    ACTIONS(1095), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1131), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1097), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(453), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1085), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1087), 17,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [13691] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(367), 1,
      anon_sym_BQUOTE,
    ACTIONS(1089), 1,
      anon_sym_LPAREN,
    ACTIONS(1091), 1,
      anon_sym_LBRACK,
    ACTIONS(1093), 1,
      anon_sym_DOT,
    ACTIONS(1095), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1113), 1,
      anon_sym_in,
    ACTIONS(1117), 1,
      anon_sym_QMARK,
    ACTIONS(1119), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1125), 1,
      anon_sym_AMP,
    ACTIONS(1127), 1,
      anon_sym_PIPE,
    ACTIONS(1131), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1135), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1097), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1121), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1129), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(453), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1109), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1123), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1115), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1133), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(1188), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [13777] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(367), 1,
      anon_sym_BQUOTE,
    ACTIONS(1089), 1,
      anon_sym_LPAREN,
    ACTIONS(1091), 1,
      anon_sym_LBRACK,
    ACTIONS(1093), 1,
      anon_sym_DOT,
    ACTIONS(1095), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1113), 1,
      anon_sym_in,
    ACTIONS(1117), 1,
      anon_sym_QMARK,
    ACTIONS(1119), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1125), 1,
      anon_sym_AMP,
    ACTIONS(1127), 1,
      anon_sym_PIPE,
    ACTIONS(1131), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1135), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1190), 1,
      anon_sym_COMMA,
    ACTIONS(1097), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1121), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1129), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(453), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1109), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1123), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1115), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1192), 4,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(1133), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [13865] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(367), 1,
      anon_sym_BQUOTE,
    ACTIONS(1089), 1,
      anon_sym_LPAREN,
    ACTIONS(1091), 1,
      anon_sym_LBRACK,
    ACTIONS(1093), 1,
      anon_sym_DOT,
    ACTIONS(1095), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1113), 1,
      anon_sym_in,
    ACTIONS(1117), 1,
      anon_sym_QMARK,
    ACTIONS(1119), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1125), 1,
      anon_sym_AMP,
    ACTIONS(1127), 1,
      anon_sym_PIPE,
    ACTIONS(1131), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1135), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1097), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1121), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1129), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(453), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1109), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1123), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1115), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1133), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(1194), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [13951] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(367), 1,
      anon_sym_BQUOTE,
    ACTIONS(1089), 1,
      anon_sym_LPAREN,
    ACTIONS(1091), 1,
      anon_sym_LBRACK,
    ACTIONS(1093), 1,
      anon_sym_DOT,
    ACTIONS(1095), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1113), 1,
      anon_sym_in,
    ACTIONS(1117), 1,
      anon_sym_QMARK,
    ACTIONS(1119), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1125), 1,
      anon_sym_AMP,
    ACTIONS(1127), 1,
      anon_sym_PIPE,
    ACTIONS(1131), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1135), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1097), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1121), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1129), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(453), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1109), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1123), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1115), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1133), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(1196), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [14037] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1099), 1,
      sym__automatic_semicolon,
    ACTIONS(419), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(417), 26,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [14087] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(367), 1,
      anon_sym_BQUOTE,
    ACTIONS(1089), 1,
      anon_sym_LPAREN,
    ACTIONS(1091), 1,
      anon_sym_LBRACK,
    ACTIONS(1093), 1,
      anon_sym_DOT,
    ACTIONS(1095), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1113), 1,
      anon_sym_in,
    ACTIONS(1131), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1097), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1129), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(453), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1085), 3,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1109), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1123), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1115), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1133), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(1087), 9,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
  [14163] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(367), 1,
      anon_sym_BQUOTE,
    ACTIONS(1089), 1,
      anon_sym_LPAREN,
    ACTIONS(1091), 1,
      anon_sym_LBRACK,
    ACTIONS(1093), 1,
      anon_sym_DOT,
    ACTIONS(1095), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1113), 1,
      anon_sym_in,
    ACTIONS(1119), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1125), 1,
      anon_sym_AMP,
    ACTIONS(1131), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1085), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(1097), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1129), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(453), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1109), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1123), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1115), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1133), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(1087), 8,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
  [14243] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(367), 1,
      anon_sym_BQUOTE,
    ACTIONS(1089), 1,
      anon_sym_LPAREN,
    ACTIONS(1091), 1,
      anon_sym_LBRACK,
    ACTIONS(1093), 1,
      anon_sym_DOT,
    ACTIONS(1095), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1113), 1,
      anon_sym_in,
    ACTIONS(1117), 1,
      anon_sym_QMARK,
    ACTIONS(1119), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1125), 1,
      anon_sym_AMP,
    ACTIONS(1127), 1,
      anon_sym_PIPE,
    ACTIONS(1131), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1135), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1097), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1121), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1129), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(453), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1109), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1123), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1115), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1133), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(1198), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [14329] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(367), 1,
      anon_sym_BQUOTE,
    ACTIONS(1089), 1,
      anon_sym_LPAREN,
    ACTIONS(1091), 1,
      anon_sym_LBRACK,
    ACTIONS(1093), 1,
      anon_sym_DOT,
    ACTIONS(1095), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1131), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1097), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(453), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1109), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1123), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1085), 10,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1087), 14,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [14397] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1200), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1202), 26,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [14444] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1204), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1206), 26,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [14491] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1208), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1210), 26,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [14538] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1212), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1214), 26,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [14585] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1216), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1218), 26,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [14632] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1220), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1222), 26,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [14679] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1224), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1226), 25,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [14726] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(425), 1,
      anon_sym_EQ,
    ACTIONS(427), 1,
      sym__automatic_semicolon,
    ACTIONS(417), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(421), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(423), 22,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [14779] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1228), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1230), 26,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [14826] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1091), 1,
      anon_sym_LBRACK,
    ACTIONS(1093), 1,
      anon_sym_DOT,
    ACTIONS(1168), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1228), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1230), 23,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [14879] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(992), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(994), 26,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [14926] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(79), 1,
      anon_sym_BQUOTE,
    ACTIONS(1234), 1,
      anon_sym_LPAREN,
    ACTIONS(1236), 1,
      anon_sym_in,
    ACTIONS(1238), 1,
      anon_sym_LBRACK,
    ACTIONS(1242), 1,
      anon_sym_DOT,
    ACTIONS(1244), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1246), 1,
      anon_sym_QMARK,
    ACTIONS(1248), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1254), 1,
      anon_sym_AMP,
    ACTIONS(1256), 1,
      anon_sym_PIPE,
    ACTIONS(1260), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1264), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1250), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1258), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1266), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(569), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1232), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1252), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1196), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
    ACTIONS(1240), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1262), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [15011] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(523), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(525), 26,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [15058] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(79), 1,
      anon_sym_BQUOTE,
    ACTIONS(1234), 1,
      anon_sym_LPAREN,
    ACTIONS(1236), 1,
      anon_sym_in,
    ACTIONS(1238), 1,
      anon_sym_LBRACK,
    ACTIONS(1242), 1,
      anon_sym_DOT,
    ACTIONS(1244), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1246), 1,
      anon_sym_QMARK,
    ACTIONS(1248), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1254), 1,
      anon_sym_AMP,
    ACTIONS(1256), 1,
      anon_sym_PIPE,
    ACTIONS(1260), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1264), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1250), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1258), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1266), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(569), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1232), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1252), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1137), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
    ACTIONS(1240), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1262), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [15143] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1268), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1270), 26,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [15190] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1224), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1226), 26,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [15237] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(79), 1,
      anon_sym_BQUOTE,
    ACTIONS(1234), 1,
      anon_sym_LPAREN,
    ACTIONS(1238), 1,
      anon_sym_LBRACK,
    ACTIONS(1242), 1,
      anon_sym_DOT,
    ACTIONS(1244), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1260), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1266), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(569), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1085), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1087), 16,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [15300] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(79), 1,
      anon_sym_BQUOTE,
    ACTIONS(1234), 1,
      anon_sym_LPAREN,
    ACTIONS(1236), 1,
      anon_sym_in,
    ACTIONS(1238), 1,
      anon_sym_LBRACK,
    ACTIONS(1242), 1,
      anon_sym_DOT,
    ACTIONS(1244), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1246), 1,
      anon_sym_QMARK,
    ACTIONS(1248), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1254), 1,
      anon_sym_AMP,
    ACTIONS(1256), 1,
      anon_sym_PIPE,
    ACTIONS(1260), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1264), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1250), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1258), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1266), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(569), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1232), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1252), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1160), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
    ACTIONS(1240), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1262), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [15385] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1272), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1274), 26,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [15432] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(459), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(461), 26,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [15479] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1212), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1214), 25,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [15526] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(489), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(491), 26,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [15573] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(433), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(435), 26,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [15620] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(79), 1,
      anon_sym_BQUOTE,
    ACTIONS(1234), 1,
      anon_sym_LPAREN,
    ACTIONS(1238), 1,
      anon_sym_LBRACK,
    ACTIONS(1242), 1,
      anon_sym_DOT,
    ACTIONS(1244), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1260), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1258), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1266), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(569), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1232), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1252), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1085), 4,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1240), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1262), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(1087), 8,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
  [15693] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1276), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1137), 26,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [15740] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1182), 1,
      anon_sym_EQ,
    ACTIONS(1175), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1177), 25,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [15789] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(79), 1,
      anon_sym_BQUOTE,
    ACTIONS(1234), 1,
      anon_sym_LPAREN,
    ACTIONS(1238), 1,
      anon_sym_LBRACK,
    ACTIONS(1242), 1,
      anon_sym_DOT,
    ACTIONS(1244), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1260), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1258), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1266), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(569), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1232), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1252), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1085), 8,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1087), 13,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [15858] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(79), 1,
      anon_sym_BQUOTE,
    ACTIONS(1234), 1,
      anon_sym_LPAREN,
    ACTIONS(1236), 1,
      anon_sym_in,
    ACTIONS(1238), 1,
      anon_sym_LBRACK,
    ACTIONS(1242), 1,
      anon_sym_DOT,
    ACTIONS(1244), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1260), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1258), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1266), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(569), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1085), 3,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1232), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1252), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1240), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1262), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(1087), 8,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
  [15933] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(79), 1,
      anon_sym_BQUOTE,
    ACTIONS(1234), 1,
      anon_sym_LPAREN,
    ACTIONS(1236), 1,
      anon_sym_in,
    ACTIONS(1238), 1,
      anon_sym_LBRACK,
    ACTIONS(1242), 1,
      anon_sym_DOT,
    ACTIONS(1244), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1248), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1254), 1,
      anon_sym_AMP,
    ACTIONS(1260), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1085), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(1258), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1266), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(569), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1232), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1252), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1240), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1262), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(1087), 7,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
  [16012] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(79), 1,
      anon_sym_BQUOTE,
    ACTIONS(1234), 1,
      anon_sym_LPAREN,
    ACTIONS(1238), 1,
      anon_sym_LBRACK,
    ACTIONS(1242), 1,
      anon_sym_DOT,
    ACTIONS(1244), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1260), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1266), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(569), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1232), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1252), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1085), 10,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1087), 13,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [16079] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(79), 1,
      anon_sym_BQUOTE,
    ACTIONS(1234), 1,
      anon_sym_LPAREN,
    ACTIONS(1238), 1,
      anon_sym_LBRACK,
    ACTIONS(1242), 1,
      anon_sym_DOT,
    ACTIONS(1244), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1266), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(569), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1085), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1087), 17,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [16140] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(79), 1,
      anon_sym_BQUOTE,
    ACTIONS(1085), 1,
      anon_sym_QMARK,
    ACTIONS(1234), 1,
      anon_sym_LPAREN,
    ACTIONS(1236), 1,
      anon_sym_in,
    ACTIONS(1238), 1,
      anon_sym_LBRACK,
    ACTIONS(1242), 1,
      anon_sym_DOT,
    ACTIONS(1244), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1248), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1254), 1,
      anon_sym_AMP,
    ACTIONS(1256), 1,
      anon_sym_PIPE,
    ACTIONS(1260), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1250), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1258), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1266), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(569), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1232), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1252), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1240), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1087), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_QMARK_QMARK,
    ACTIONS(1262), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [16223] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(79), 1,
      anon_sym_BQUOTE,
    ACTIONS(1234), 1,
      anon_sym_LPAREN,
    ACTIONS(1236), 1,
      anon_sym_in,
    ACTIONS(1238), 1,
      anon_sym_LBRACK,
    ACTIONS(1242), 1,
      anon_sym_DOT,
    ACTIONS(1244), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1246), 1,
      anon_sym_QMARK,
    ACTIONS(1248), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1254), 1,
      anon_sym_AMP,
    ACTIONS(1256), 1,
      anon_sym_PIPE,
    ACTIONS(1260), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1264), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1250), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1258), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1266), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(569), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1232), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1252), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1111), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
    ACTIONS(1240), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1262), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [16308] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(79), 1,
      anon_sym_BQUOTE,
    ACTIONS(1234), 1,
      anon_sym_LPAREN,
    ACTIONS(1236), 1,
      anon_sym_in,
    ACTIONS(1238), 1,
      anon_sym_LBRACK,
    ACTIONS(1242), 1,
      anon_sym_DOT,
    ACTIONS(1244), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1246), 1,
      anon_sym_QMARK,
    ACTIONS(1248), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1254), 1,
      anon_sym_AMP,
    ACTIONS(1256), 1,
      anon_sym_PIPE,
    ACTIONS(1260), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1264), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1250), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1258), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1266), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(569), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1232), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1252), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1139), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
    ACTIONS(1240), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1262), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [16393] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(79), 1,
      anon_sym_BQUOTE,
    ACTIONS(1234), 1,
      anon_sym_LPAREN,
    ACTIONS(1236), 1,
      anon_sym_in,
    ACTIONS(1238), 1,
      anon_sym_LBRACK,
    ACTIONS(1242), 1,
      anon_sym_DOT,
    ACTIONS(1244), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1246), 1,
      anon_sym_QMARK,
    ACTIONS(1248), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1254), 1,
      anon_sym_AMP,
    ACTIONS(1256), 1,
      anon_sym_PIPE,
    ACTIONS(1260), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1264), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1250), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1258), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1266), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(569), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1232), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1252), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1170), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
    ACTIONS(1240), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1262), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [16478] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1278), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1280), 26,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [16525] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1282), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1284), 26,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [16572] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1286), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1288), 26,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [16619] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1290), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1139), 26,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [16666] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1292), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1294), 26,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [16713] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1083), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1081), 26,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [16760] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(79), 1,
      anon_sym_BQUOTE,
    ACTIONS(1234), 1,
      anon_sym_LPAREN,
    ACTIONS(1236), 1,
      anon_sym_in,
    ACTIONS(1238), 1,
      anon_sym_LBRACK,
    ACTIONS(1242), 1,
      anon_sym_DOT,
    ACTIONS(1244), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1246), 1,
      anon_sym_QMARK,
    ACTIONS(1248), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1254), 1,
      anon_sym_AMP,
    ACTIONS(1256), 1,
      anon_sym_PIPE,
    ACTIONS(1260), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1264), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1250), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1258), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1266), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(569), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1232), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1252), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1194), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
    ACTIONS(1240), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1262), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [16845] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1296), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1298), 26,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [16892] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1300), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1302), 26,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [16939] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1304), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1306), 26,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [16986] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(499), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(501), 26,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [17033] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(509), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(511), 26,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [17080] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1308), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1310), 26,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [17127] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1312), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1314), 26,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [17174] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(443), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(445), 26,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [17221] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1316), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1318), 26,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [17268] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1320), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1322), 26,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [17315] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(517), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(515), 26,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [17362] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(79), 1,
      anon_sym_BQUOTE,
    ACTIONS(1234), 1,
      anon_sym_LPAREN,
    ACTIONS(1236), 1,
      anon_sym_in,
    ACTIONS(1238), 1,
      anon_sym_LBRACK,
    ACTIONS(1242), 1,
      anon_sym_DOT,
    ACTIONS(1244), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1246), 1,
      anon_sym_QMARK,
    ACTIONS(1248), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1254), 1,
      anon_sym_AMP,
    ACTIONS(1256), 1,
      anon_sym_PIPE,
    ACTIONS(1260), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1264), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1250), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1258), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1266), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(569), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1232), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1252), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1186), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
    ACTIONS(1240), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1262), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [17447] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(425), 1,
      anon_sym_EQ,
    ACTIONS(421), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(423), 25,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [17496] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1324), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1160), 26,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [17543] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1326), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1170), 26,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [17590] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(79), 1,
      anon_sym_BQUOTE,
    ACTIONS(1234), 1,
      anon_sym_LPAREN,
    ACTIONS(1236), 1,
      anon_sym_in,
    ACTIONS(1238), 1,
      anon_sym_LBRACK,
    ACTIONS(1242), 1,
      anon_sym_DOT,
    ACTIONS(1244), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1246), 1,
      anon_sym_QMARK,
    ACTIONS(1248), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1254), 1,
      anon_sym_AMP,
    ACTIONS(1256), 1,
      anon_sym_PIPE,
    ACTIONS(1260), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1264), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1328), 1,
      anon_sym_COMMA,
    ACTIONS(1331), 1,
      anon_sym_RBRACE,
    ACTIONS(1141), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(1250), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1258), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1266), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(569), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1232), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1252), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1240), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1262), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [17679] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(451), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(449), 26,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [17726] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(79), 1,
      anon_sym_BQUOTE,
    ACTIONS(1234), 1,
      anon_sym_LPAREN,
    ACTIONS(1236), 1,
      anon_sym_in,
    ACTIONS(1238), 1,
      anon_sym_LBRACK,
    ACTIONS(1242), 1,
      anon_sym_DOT,
    ACTIONS(1244), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1246), 1,
      anon_sym_QMARK,
    ACTIONS(1248), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1254), 1,
      anon_sym_AMP,
    ACTIONS(1256), 1,
      anon_sym_PIPE,
    ACTIONS(1260), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1264), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1250), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1258), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1266), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(569), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1232), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1252), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1184), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
    ACTIONS(1240), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1262), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [17811] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1158), 1,
      anon_sym_EQ,
    ACTIONS(1151), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1153), 25,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [17860] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1333), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1162), 26,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [17907] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1335), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1337), 26,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [17954] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1339), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1188), 26,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [18001] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(79), 1,
      anon_sym_BQUOTE,
    ACTIONS(1234), 1,
      anon_sym_LPAREN,
    ACTIONS(1236), 1,
      anon_sym_in,
    ACTIONS(1238), 1,
      anon_sym_LBRACK,
    ACTIONS(1242), 1,
      anon_sym_DOT,
    ACTIONS(1244), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1246), 1,
      anon_sym_QMARK,
    ACTIONS(1248), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1254), 1,
      anon_sym_AMP,
    ACTIONS(1256), 1,
      anon_sym_PIPE,
    ACTIONS(1260), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1264), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1250), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1258), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1266), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(569), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1232), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1252), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1141), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
    ACTIONS(1240), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1262), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [18086] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1341), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1343), 26,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [18133] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(79), 1,
      anon_sym_BQUOTE,
    ACTIONS(1234), 1,
      anon_sym_LPAREN,
    ACTIONS(1236), 1,
      anon_sym_in,
    ACTIONS(1238), 1,
      anon_sym_LBRACK,
    ACTIONS(1242), 1,
      anon_sym_DOT,
    ACTIONS(1244), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1246), 1,
      anon_sym_QMARK,
    ACTIONS(1248), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1254), 1,
      anon_sym_AMP,
    ACTIONS(1256), 1,
      anon_sym_PIPE,
    ACTIONS(1260), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1264), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1331), 1,
      anon_sym_RBRACE,
    ACTIONS(1345), 1,
      anon_sym_COMMA,
    ACTIONS(1196), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(1250), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1258), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1266), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(569), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1232), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1252), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1240), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1262), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [18222] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(79), 1,
      anon_sym_BQUOTE,
    ACTIONS(1234), 1,
      anon_sym_LPAREN,
    ACTIONS(1236), 1,
      anon_sym_in,
    ACTIONS(1238), 1,
      anon_sym_LBRACK,
    ACTIONS(1242), 1,
      anon_sym_DOT,
    ACTIONS(1244), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1246), 1,
      anon_sym_QMARK,
    ACTIONS(1248), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1254), 1,
      anon_sym_AMP,
    ACTIONS(1256), 1,
      anon_sym_PIPE,
    ACTIONS(1260), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1264), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1250), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1258), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1266), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(569), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1232), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1252), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1198), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
    ACTIONS(1240), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1262), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [18307] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1348), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1350), 26,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [18354] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(473), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(475), 26,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [18401] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(481), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(479), 26,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [18448] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(79), 1,
      anon_sym_BQUOTE,
    ACTIONS(1234), 1,
      anon_sym_LPAREN,
    ACTIONS(1236), 1,
      anon_sym_in,
    ACTIONS(1238), 1,
      anon_sym_LBRACK,
    ACTIONS(1242), 1,
      anon_sym_DOT,
    ACTIONS(1244), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1246), 1,
      anon_sym_QMARK,
    ACTIONS(1248), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1254), 1,
      anon_sym_AMP,
    ACTIONS(1256), 1,
      anon_sym_PIPE,
    ACTIONS(1260), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1264), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1352), 1,
      anon_sym_COMMA,
    ACTIONS(1355), 1,
      anon_sym_RBRACE,
    ACTIONS(1196), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(1250), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1258), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1266), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(569), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1232), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1252), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1240), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1262), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [18537] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(79), 1,
      anon_sym_BQUOTE,
    ACTIONS(1234), 1,
      anon_sym_LPAREN,
    ACTIONS(1238), 1,
      anon_sym_LBRACK,
    ACTIONS(1242), 1,
      anon_sym_DOT,
    ACTIONS(1244), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1266), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(569), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1101), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1103), 17,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [18598] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1357), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1359), 26,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [18645] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1361), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1363), 26,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [18692] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1365), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1367), 26,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [18739] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1365), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1367), 26,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [18786] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1365), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1367), 26,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [18833] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1365), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1367), 26,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [18880] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1369), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1371), 26,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [18927] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(79), 1,
      anon_sym_BQUOTE,
    ACTIONS(1234), 1,
      anon_sym_LPAREN,
    ACTIONS(1238), 1,
      anon_sym_LBRACK,
    ACTIONS(1242), 1,
      anon_sym_DOT,
    ACTIONS(1244), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1266), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(569), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1101), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1103), 17,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [18988] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(467), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(465), 26,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [19035] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(367), 1,
      anon_sym_BQUOTE,
    ACTIONS(1089), 1,
      anon_sym_LPAREN,
    ACTIONS(1091), 1,
      anon_sym_LBRACK,
    ACTIONS(1093), 1,
      anon_sym_DOT,
    ACTIONS(1095), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1113), 1,
      anon_sym_in,
    ACTIONS(1117), 1,
      anon_sym_QMARK,
    ACTIONS(1119), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1125), 1,
      anon_sym_AMP,
    ACTIONS(1127), 1,
      anon_sym_PIPE,
    ACTIONS(1131), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1135), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1097), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1121), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1129), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(453), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1109), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1123), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1115), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1373), 4,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
    ACTIONS(1133), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [19120] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(79), 1,
      anon_sym_BQUOTE,
    ACTIONS(1234), 1,
      anon_sym_LPAREN,
    ACTIONS(1238), 1,
      anon_sym_LBRACK,
    ACTIONS(1242), 1,
      anon_sym_DOT,
    ACTIONS(1244), 1,
      anon_sym_QMARK_DOT,
    STATE(569), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1105), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1107), 19,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
  [19179] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1375), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1377), 26,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [19226] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(79), 1,
      anon_sym_BQUOTE,
    ACTIONS(1234), 1,
      anon_sym_LPAREN,
    ACTIONS(1236), 1,
      anon_sym_in,
    ACTIONS(1238), 1,
      anon_sym_LBRACK,
    ACTIONS(1242), 1,
      anon_sym_DOT,
    ACTIONS(1244), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1246), 1,
      anon_sym_QMARK,
    ACTIONS(1248), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1254), 1,
      anon_sym_AMP,
    ACTIONS(1256), 1,
      anon_sym_PIPE,
    ACTIONS(1260), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1264), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1250), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1258), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1266), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(569), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1232), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1252), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1162), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
    ACTIONS(1240), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1262), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [19311] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1379), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1381), 26,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [19358] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(79), 1,
      anon_sym_BQUOTE,
    ACTIONS(1234), 1,
      anon_sym_LPAREN,
    ACTIONS(1236), 1,
      anon_sym_in,
    ACTIONS(1238), 1,
      anon_sym_LBRACK,
    ACTIONS(1242), 1,
      anon_sym_DOT,
    ACTIONS(1244), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1246), 1,
      anon_sym_QMARK,
    ACTIONS(1248), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1254), 1,
      anon_sym_AMP,
    ACTIONS(1256), 1,
      anon_sym_PIPE,
    ACTIONS(1260), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1264), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1250), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1258), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1266), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(569), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1232), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1252), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1188), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
    ACTIONS(1240), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1262), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [19443] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1383), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1385), 26,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [19490] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1387), 1,
      sym_regex_flags,
    ACTIONS(1145), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
    ACTIONS(1147), 23,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [19538] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(367), 1,
      anon_sym_BQUOTE,
    ACTIONS(588), 1,
      anon_sym_COMMA,
    ACTIONS(1089), 1,
      anon_sym_LPAREN,
    ACTIONS(1091), 1,
      anon_sym_LBRACK,
    ACTIONS(1093), 1,
      anon_sym_DOT,
    ACTIONS(1095), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1113), 1,
      anon_sym_in,
    ACTIONS(1117), 1,
      anon_sym_QMARK,
    ACTIONS(1119), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1125), 1,
      anon_sym_AMP,
    ACTIONS(1127), 1,
      anon_sym_PIPE,
    ACTIONS(1131), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1135), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1389), 1,
      anon_sym_RBRACK,
    STATE(1028), 1,
      aux_sym_array_repeat1,
    ACTIONS(1097), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1121), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1129), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(453), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1109), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1123), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1115), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1133), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [19626] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(79), 1,
      anon_sym_BQUOTE,
    ACTIONS(1234), 1,
      anon_sym_LPAREN,
    ACTIONS(1236), 1,
      anon_sym_in,
    ACTIONS(1238), 1,
      anon_sym_LBRACK,
    ACTIONS(1242), 1,
      anon_sym_DOT,
    ACTIONS(1244), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1246), 1,
      anon_sym_QMARK,
    ACTIONS(1248), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1254), 1,
      anon_sym_AMP,
    ACTIONS(1256), 1,
      anon_sym_PIPE,
    ACTIONS(1260), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1264), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1391), 1,
      anon_sym_COMMA,
    ACTIONS(1250), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1258), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1266), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1393), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    STATE(569), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1232), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1252), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1240), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1262), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [19712] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(527), 1,
      sym__automatic_semicolon,
    ACTIONS(519), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(523), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(525), 22,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [19762] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(477), 1,
      sym__automatic_semicolon,
    ACTIONS(469), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(473), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(475), 22,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [19812] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(367), 1,
      anon_sym_BQUOTE,
    ACTIONS(1089), 1,
      anon_sym_LPAREN,
    ACTIONS(1091), 1,
      anon_sym_LBRACK,
    ACTIONS(1093), 1,
      anon_sym_DOT,
    ACTIONS(1095), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1113), 1,
      anon_sym_in,
    ACTIONS(1117), 1,
      anon_sym_QMARK,
    ACTIONS(1119), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1125), 1,
      anon_sym_AMP,
    ACTIONS(1127), 1,
      anon_sym_PIPE,
    ACTIONS(1131), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1135), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1097), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1121), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1129), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(453), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1109), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1123), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1395), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
    ACTIONS(1115), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1133), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [19896] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(425), 1,
      anon_sym_EQ,
    ACTIONS(421), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(423), 24,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [19944] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(493), 1,
      sym__automatic_semicolon,
    ACTIONS(485), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(489), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(491), 22,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [19994] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(437), 1,
      sym__automatic_semicolon,
    ACTIONS(429), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(433), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(435), 22,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [20044] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(503), 1,
      sym__automatic_semicolon,
    ACTIONS(495), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(499), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(501), 22,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [20094] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(367), 1,
      anon_sym_BQUOTE,
    ACTIONS(588), 1,
      anon_sym_COMMA,
    ACTIONS(1089), 1,
      anon_sym_LPAREN,
    ACTIONS(1091), 1,
      anon_sym_LBRACK,
    ACTIONS(1093), 1,
      anon_sym_DOT,
    ACTIONS(1095), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1113), 1,
      anon_sym_in,
    ACTIONS(1117), 1,
      anon_sym_QMARK,
    ACTIONS(1119), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1125), 1,
      anon_sym_AMP,
    ACTIONS(1127), 1,
      anon_sym_PIPE,
    ACTIONS(1131), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1135), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1397), 1,
      anon_sym_RBRACK,
    STATE(1028), 1,
      aux_sym_array_repeat1,
    ACTIONS(1097), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1121), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1129), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(453), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1109), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1123), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1115), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1133), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [20182] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1182), 1,
      anon_sym_EQ,
    ACTIONS(1175), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1177), 24,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [20230] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(513), 1,
      sym__automatic_semicolon,
    ACTIONS(505), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(509), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(511), 22,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [20280] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1234), 1,
      anon_sym_LPAREN,
    ACTIONS(1238), 1,
      anon_sym_LBRACK,
    ACTIONS(1242), 1,
      anon_sym_DOT,
    ACTIONS(1399), 1,
      anon_sym_QMARK_DOT,
    STATE(551), 1,
      sym_arguments,
    ACTIONS(1164), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1166), 20,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [20336] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(463), 1,
      sym__automatic_semicolon,
    ACTIONS(455), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(459), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(461), 22,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [20386] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(425), 1,
      anon_sym_EQ,
    ACTIONS(453), 1,
      sym__automatic_semicolon,
    ACTIONS(419), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(417), 23,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [20436] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(79), 1,
      anon_sym_BQUOTE,
    ACTIONS(1234), 1,
      anon_sym_LPAREN,
    ACTIONS(1236), 1,
      anon_sym_in,
    ACTIONS(1238), 1,
      anon_sym_LBRACK,
    ACTIONS(1242), 1,
      anon_sym_DOT,
    ACTIONS(1244), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1246), 1,
      anon_sym_QMARK,
    ACTIONS(1248), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1254), 1,
      anon_sym_AMP,
    ACTIONS(1256), 1,
      anon_sym_PIPE,
    ACTIONS(1260), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1264), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1250), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1258), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1266), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(569), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1232), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1252), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1401), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(1240), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1262), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [20520] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(79), 1,
      anon_sym_BQUOTE,
    ACTIONS(1234), 1,
      anon_sym_LPAREN,
    ACTIONS(1236), 1,
      anon_sym_in,
    ACTIONS(1238), 1,
      anon_sym_LBRACK,
    ACTIONS(1242), 1,
      anon_sym_DOT,
    ACTIONS(1244), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1246), 1,
      anon_sym_QMARK,
    ACTIONS(1248), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1254), 1,
      anon_sym_AMP,
    ACTIONS(1256), 1,
      anon_sym_PIPE,
    ACTIONS(1260), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1264), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1391), 1,
      anon_sym_COMMA,
    ACTIONS(1250), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1258), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1266), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1403), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    STATE(569), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1232), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1252), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1240), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1262), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [20606] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(79), 1,
      anon_sym_BQUOTE,
    ACTIONS(1234), 1,
      anon_sym_LPAREN,
    ACTIONS(1236), 1,
      anon_sym_in,
    ACTIONS(1238), 1,
      anon_sym_LBRACK,
    ACTIONS(1242), 1,
      anon_sym_DOT,
    ACTIONS(1244), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1246), 1,
      anon_sym_QMARK,
    ACTIONS(1248), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1254), 1,
      anon_sym_AMP,
    ACTIONS(1256), 1,
      anon_sym_PIPE,
    ACTIONS(1260), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1264), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1391), 1,
      anon_sym_COMMA,
    ACTIONS(1250), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1258), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1266), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1405), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    STATE(569), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1232), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1252), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1240), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1262), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [20692] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(447), 1,
      sym__automatic_semicolon,
    ACTIONS(439), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(443), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(445), 22,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [20742] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(367), 1,
      anon_sym_BQUOTE,
    ACTIONS(588), 1,
      anon_sym_COMMA,
    ACTIONS(1089), 1,
      anon_sym_LPAREN,
    ACTIONS(1091), 1,
      anon_sym_LBRACK,
    ACTIONS(1093), 1,
      anon_sym_DOT,
    ACTIONS(1095), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1113), 1,
      anon_sym_in,
    ACTIONS(1117), 1,
      anon_sym_QMARK,
    ACTIONS(1119), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1125), 1,
      anon_sym_AMP,
    ACTIONS(1127), 1,
      anon_sym_PIPE,
    ACTIONS(1131), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1135), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1407), 1,
      anon_sym_RBRACK,
    STATE(1071), 1,
      aux_sym_array_repeat1,
    ACTIONS(1097), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1121), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1129), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(453), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1109), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1123), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1115), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1133), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [20830] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(367), 1,
      anon_sym_BQUOTE,
    ACTIONS(588), 1,
      anon_sym_COMMA,
    ACTIONS(1089), 1,
      anon_sym_LPAREN,
    ACTIONS(1091), 1,
      anon_sym_LBRACK,
    ACTIONS(1093), 1,
      anon_sym_DOT,
    ACTIONS(1095), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1113), 1,
      anon_sym_in,
    ACTIONS(1117), 1,
      anon_sym_QMARK,
    ACTIONS(1119), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1125), 1,
      anon_sym_AMP,
    ACTIONS(1127), 1,
      anon_sym_PIPE,
    ACTIONS(1131), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1135), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1409), 1,
      anon_sym_RPAREN,
    STATE(1047), 1,
      aux_sym_array_repeat1,
    ACTIONS(1097), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1121), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1129), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(453), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1109), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1123), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1115), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1133), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [20918] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1158), 1,
      anon_sym_EQ,
    ACTIONS(1411), 1,
      anon_sym_in,
    ACTIONS(1414), 1,
      anon_sym_of,
    ACTIONS(1151), 12,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1153), 23,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [20970] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1182), 1,
      anon_sym_EQ,
    ACTIONS(1416), 1,
      anon_sym_in,
    ACTIONS(1419), 1,
      anon_sym_of,
    ACTIONS(1175), 12,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1177), 23,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [21022] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1158), 1,
      anon_sym_EQ,
    ACTIONS(1151), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1153), 24,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [21070] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(367), 1,
      anon_sym_BQUOTE,
    ACTIONS(1089), 1,
      anon_sym_LPAREN,
    ACTIONS(1091), 1,
      anon_sym_LBRACK,
    ACTIONS(1093), 1,
      anon_sym_DOT,
    ACTIONS(1095), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1113), 1,
      anon_sym_in,
    ACTIONS(1117), 1,
      anon_sym_QMARK,
    ACTIONS(1119), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1125), 1,
      anon_sym_AMP,
    ACTIONS(1127), 1,
      anon_sym_PIPE,
    ACTIONS(1131), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1135), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1097), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1121), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1129), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(453), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1109), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1123), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1421), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
    ACTIONS(1115), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1133), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [21154] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(367), 1,
      anon_sym_BQUOTE,
    ACTIONS(588), 1,
      anon_sym_COMMA,
    ACTIONS(1089), 1,
      anon_sym_LPAREN,
    ACTIONS(1091), 1,
      anon_sym_LBRACK,
    ACTIONS(1093), 1,
      anon_sym_DOT,
    ACTIONS(1095), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1113), 1,
      anon_sym_in,
    ACTIONS(1117), 1,
      anon_sym_QMARK,
    ACTIONS(1119), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1125), 1,
      anon_sym_AMP,
    ACTIONS(1127), 1,
      anon_sym_PIPE,
    ACTIONS(1131), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1135), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1423), 1,
      anon_sym_RPAREN,
    STATE(994), 1,
      aux_sym_array_repeat1,
    ACTIONS(1097), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1121), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1129), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(453), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1109), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1123), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1115), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1133), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [21242] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(425), 1,
      anon_sym_EQ,
    ACTIONS(1425), 1,
      anon_sym_in,
    ACTIONS(1428), 1,
      anon_sym_of,
    ACTIONS(421), 12,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(423), 23,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [21294] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(79), 1,
      anon_sym_BQUOTE,
    ACTIONS(1234), 1,
      anon_sym_LPAREN,
    ACTIONS(1236), 1,
      anon_sym_in,
    ACTIONS(1238), 1,
      anon_sym_LBRACK,
    ACTIONS(1242), 1,
      anon_sym_DOT,
    ACTIONS(1244), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1246), 1,
      anon_sym_QMARK,
    ACTIONS(1248), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1254), 1,
      anon_sym_AMP,
    ACTIONS(1256), 1,
      anon_sym_PIPE,
    ACTIONS(1260), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1264), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1391), 1,
      anon_sym_COMMA,
    ACTIONS(1192), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(1250), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1258), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1266), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(569), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1232), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1252), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1240), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1262), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [21380] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1067), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1069), 24,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [21425] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(367), 1,
      anon_sym_BQUOTE,
    ACTIONS(1089), 1,
      anon_sym_LPAREN,
    ACTIONS(1091), 1,
      anon_sym_LBRACK,
    ACTIONS(1093), 1,
      anon_sym_DOT,
    ACTIONS(1095), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1432), 1,
      anon_sym_in,
    ACTIONS(1436), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1440), 1,
      anon_sym_AMP,
    ACTIONS(1444), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1085), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(1097), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1442), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(453), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1430), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1438), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1434), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1087), 5,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
    ACTIONS(1446), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [21502] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(367), 1,
      anon_sym_BQUOTE,
    ACTIONS(1089), 1,
      anon_sym_LPAREN,
    ACTIONS(1091), 1,
      anon_sym_LBRACK,
    ACTIONS(1093), 1,
      anon_sym_DOT,
    ACTIONS(1095), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1432), 1,
      anon_sym_in,
    ACTIONS(1436), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1440), 1,
      anon_sym_AMP,
    ACTIONS(1444), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1448), 1,
      anon_sym_QMARK,
    ACTIONS(1452), 1,
      anon_sym_PIPE,
    ACTIONS(1454), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1097), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1141), 2,
      anon_sym_LBRACE,
      anon_sym_COLON,
    ACTIONS(1442), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1450), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    STATE(453), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1430), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1438), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1434), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1446), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [21585] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1383), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1385), 24,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [21630] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1348), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1350), 24,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [21675] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(992), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(994), 24,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [21720] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1320), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1322), 24,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [21765] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(367), 1,
      anon_sym_BQUOTE,
    ACTIONS(1089), 1,
      anon_sym_LPAREN,
    ACTIONS(1091), 1,
      anon_sym_LBRACK,
    ACTIONS(1093), 1,
      anon_sym_DOT,
    ACTIONS(1095), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1432), 1,
      anon_sym_in,
    ACTIONS(1436), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1440), 1,
      anon_sym_AMP,
    ACTIONS(1444), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1448), 1,
      anon_sym_QMARK,
    ACTIONS(1452), 1,
      anon_sym_PIPE,
    ACTIONS(1454), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1097), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1196), 2,
      anon_sym_LBRACE,
      anon_sym_COLON,
    ACTIONS(1442), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1450), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    STATE(453), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1430), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1438), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1434), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1446), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [21848] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(367), 1,
      anon_sym_BQUOTE,
    ACTIONS(1089), 1,
      anon_sym_LPAREN,
    ACTIONS(1091), 1,
      anon_sym_LBRACK,
    ACTIONS(1093), 1,
      anon_sym_DOT,
    ACTIONS(1095), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1432), 1,
      anon_sym_in,
    ACTIONS(1436), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1440), 1,
      anon_sym_AMP,
    ACTIONS(1444), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1448), 1,
      anon_sym_QMARK,
    ACTIONS(1452), 1,
      anon_sym_PIPE,
    ACTIONS(1454), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1097), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1137), 2,
      anon_sym_LBRACE,
      anon_sym_COLON,
    ACTIONS(1442), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1450), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    STATE(453), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1430), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1438), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1434), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1446), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [21931] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(367), 1,
      anon_sym_BQUOTE,
    ACTIONS(1089), 1,
      anon_sym_LPAREN,
    ACTIONS(1091), 1,
      anon_sym_LBRACK,
    ACTIONS(1093), 1,
      anon_sym_DOT,
    ACTIONS(1095), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1444), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1097), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(453), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1085), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1087), 14,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [21992] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(367), 1,
      anon_sym_BQUOTE,
    ACTIONS(1089), 1,
      anon_sym_LPAREN,
    ACTIONS(1091), 1,
      anon_sym_LBRACK,
    ACTIONS(1093), 1,
      anon_sym_DOT,
    ACTIONS(1095), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1444), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1097), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1442), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(453), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1430), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1438), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1085), 4,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1434), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1446), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(1087), 6,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
  [22063] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1335), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1337), 24,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [22108] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1238), 1,
      anon_sym_LBRACK,
    ACTIONS(1242), 1,
      anon_sym_DOT,
    ACTIONS(1399), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1228), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1230), 21,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [22159] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1220), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1222), 24,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [22204] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1304), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1306), 24,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [22249] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(367), 1,
      anon_sym_BQUOTE,
    ACTIONS(1089), 1,
      anon_sym_LPAREN,
    ACTIONS(1091), 1,
      anon_sym_LBRACK,
    ACTIONS(1093), 1,
      anon_sym_DOT,
    ACTIONS(1095), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1113), 1,
      anon_sym_in,
    ACTIONS(1117), 1,
      anon_sym_QMARK,
    ACTIONS(1119), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1125), 1,
      anon_sym_AMP,
    ACTIONS(1127), 1,
      anon_sym_PIPE,
    ACTIONS(1131), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1135), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1190), 1,
      anon_sym_COMMA,
    ACTIONS(1456), 1,
      anon_sym_RPAREN,
    ACTIONS(1097), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1121), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1129), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(453), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1109), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1123), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1115), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1133), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [22334] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1228), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1230), 24,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [22379] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1268), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1270), 24,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [22424] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1083), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1081), 24,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [22469] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(367), 1,
      anon_sym_BQUOTE,
    ACTIONS(1089), 1,
      anon_sym_LPAREN,
    ACTIONS(1091), 1,
      anon_sym_LBRACK,
    ACTIONS(1093), 1,
      anon_sym_DOT,
    ACTIONS(1095), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1113), 1,
      anon_sym_in,
    ACTIONS(1117), 1,
      anon_sym_QMARK,
    ACTIONS(1119), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1125), 1,
      anon_sym_AMP,
    ACTIONS(1127), 1,
      anon_sym_PIPE,
    ACTIONS(1131), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1135), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1190), 1,
      anon_sym_COMMA,
    ACTIONS(1458), 1,
      anon_sym_RBRACK,
    ACTIONS(1097), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1121), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1129), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(453), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1109), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1123), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1115), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1133), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [22554] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1326), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1170), 24,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [22599] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(367), 1,
      anon_sym_BQUOTE,
    ACTIONS(1089), 1,
      anon_sym_LPAREN,
    ACTIONS(1091), 1,
      anon_sym_LBRACK,
    ACTIONS(1093), 1,
      anon_sym_DOT,
    ACTIONS(1095), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1113), 1,
      anon_sym_in,
    ACTIONS(1117), 1,
      anon_sym_QMARK,
    ACTIONS(1119), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1125), 1,
      anon_sym_AMP,
    ACTIONS(1127), 1,
      anon_sym_PIPE,
    ACTIONS(1131), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1135), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1190), 1,
      anon_sym_COMMA,
    ACTIONS(1460), 1,
      anon_sym_RBRACE,
    ACTIONS(1097), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1121), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1129), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(453), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1109), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1123), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1115), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1133), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [22684] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1272), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1274), 24,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [22729] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1276), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1137), 24,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [22774] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(367), 1,
      anon_sym_BQUOTE,
    ACTIONS(1089), 1,
      anon_sym_LPAREN,
    ACTIONS(1091), 1,
      anon_sym_LBRACK,
    ACTIONS(1093), 1,
      anon_sym_DOT,
    ACTIONS(1095), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1113), 1,
      anon_sym_in,
    ACTIONS(1117), 1,
      anon_sym_QMARK,
    ACTIONS(1119), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1125), 1,
      anon_sym_AMP,
    ACTIONS(1127), 1,
      anon_sym_PIPE,
    ACTIONS(1131), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1135), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1097), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1121), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1129), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1462), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(453), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1109), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1123), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1115), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1133), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [22857] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(367), 1,
      anon_sym_BQUOTE,
    ACTIONS(1089), 1,
      anon_sym_LPAREN,
    ACTIONS(1091), 1,
      anon_sym_LBRACK,
    ACTIONS(1093), 1,
      anon_sym_DOT,
    ACTIONS(1095), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1113), 1,
      anon_sym_in,
    ACTIONS(1117), 1,
      anon_sym_QMARK,
    ACTIONS(1119), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1125), 1,
      anon_sym_AMP,
    ACTIONS(1127), 1,
      anon_sym_PIPE,
    ACTIONS(1131), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1135), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1190), 1,
      anon_sym_COMMA,
    ACTIONS(1464), 1,
      anon_sym_RBRACE,
    ACTIONS(1097), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1121), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1129), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(453), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1109), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1123), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1115), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1133), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [22942] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1071), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1073), 24,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [22987] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(367), 1,
      anon_sym_BQUOTE,
    ACTIONS(1089), 1,
      anon_sym_LPAREN,
    ACTIONS(1091), 1,
      anon_sym_LBRACK,
    ACTIONS(1093), 1,
      anon_sym_DOT,
    ACTIONS(1095), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1113), 1,
      anon_sym_in,
    ACTIONS(1117), 1,
      anon_sym_QMARK,
    ACTIONS(1119), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1125), 1,
      anon_sym_AMP,
    ACTIONS(1127), 1,
      anon_sym_PIPE,
    ACTIONS(1131), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1135), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1097), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1121), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1129), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1355), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(453), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1109), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1123), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1115), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1133), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [23070] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(79), 1,
      anon_sym_BQUOTE,
    ACTIONS(1234), 1,
      anon_sym_LPAREN,
    ACTIONS(1236), 1,
      anon_sym_in,
    ACTIONS(1238), 1,
      anon_sym_LBRACK,
    ACTIONS(1242), 1,
      anon_sym_DOT,
    ACTIONS(1244), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1246), 1,
      anon_sym_QMARK,
    ACTIONS(1248), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1254), 1,
      anon_sym_AMP,
    ACTIONS(1256), 1,
      anon_sym_PIPE,
    ACTIONS(1260), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1264), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1250), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1258), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1266), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1466), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    STATE(569), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1232), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1252), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1240), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1262), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [23153] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(367), 1,
      anon_sym_BQUOTE,
    ACTIONS(1089), 1,
      anon_sym_LPAREN,
    ACTIONS(1091), 1,
      anon_sym_LBRACK,
    ACTIONS(1093), 1,
      anon_sym_DOT,
    ACTIONS(1095), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1113), 1,
      anon_sym_in,
    ACTIONS(1117), 1,
      anon_sym_QMARK,
    ACTIONS(1119), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1125), 1,
      anon_sym_AMP,
    ACTIONS(1127), 1,
      anon_sym_PIPE,
    ACTIONS(1131), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1135), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1097), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1121), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1129), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1331), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(453), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1109), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1123), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1115), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1133), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [23236] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1468), 1,
      anon_sym_LPAREN,
    ACTIONS(1471), 1,
      anon_sym_COLON,
    ACTIONS(992), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(994), 22,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [23285] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1379), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1381), 24,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [23330] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1292), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1294), 24,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [23375] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(443), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(445), 24,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [23420] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(367), 1,
      anon_sym_BQUOTE,
    ACTIONS(1089), 1,
      anon_sym_LPAREN,
    ACTIONS(1091), 1,
      anon_sym_LBRACK,
    ACTIONS(1093), 1,
      anon_sym_DOT,
    ACTIONS(1095), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1113), 1,
      anon_sym_in,
    ACTIONS(1117), 1,
      anon_sym_QMARK,
    ACTIONS(1119), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1125), 1,
      anon_sym_AMP,
    ACTIONS(1127), 1,
      anon_sym_PIPE,
    ACTIONS(1131), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1135), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1190), 1,
      anon_sym_COMMA,
    ACTIONS(1473), 1,
      anon_sym_RBRACK,
    ACTIONS(1097), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1121), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1129), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(453), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1109), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1123), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1115), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1133), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [23505] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1286), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1288), 24,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [23550] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1278), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1280), 24,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [23595] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(509), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(511), 24,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [23640] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(367), 1,
      anon_sym_BQUOTE,
    ACTIONS(1089), 1,
      anon_sym_LPAREN,
    ACTIONS(1091), 1,
      anon_sym_LBRACK,
    ACTIONS(1093), 1,
      anon_sym_DOT,
    ACTIONS(1095), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1113), 1,
      anon_sym_in,
    ACTIONS(1117), 1,
      anon_sym_QMARK,
    ACTIONS(1119), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1125), 1,
      anon_sym_AMP,
    ACTIONS(1127), 1,
      anon_sym_PIPE,
    ACTIONS(1131), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1135), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1190), 1,
      anon_sym_COMMA,
    ACTIONS(1475), 1,
      anon_sym_RBRACK,
    ACTIONS(1097), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1121), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1129), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(453), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1109), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1123), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1115), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1133), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [23725] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(367), 1,
      anon_sym_BQUOTE,
    ACTIONS(1089), 1,
      anon_sym_LPAREN,
    ACTIONS(1091), 1,
      anon_sym_LBRACK,
    ACTIONS(1093), 1,
      anon_sym_DOT,
    ACTIONS(1095), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1444), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1097), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1442), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(453), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1430), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1438), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1085), 8,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1087), 11,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [23792] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(367), 1,
      anon_sym_BQUOTE,
    ACTIONS(1089), 1,
      anon_sym_LPAREN,
    ACTIONS(1091), 1,
      anon_sym_LBRACK,
    ACTIONS(1093), 1,
      anon_sym_DOT,
    ACTIONS(1095), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1432), 1,
      anon_sym_in,
    ACTIONS(1436), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1440), 1,
      anon_sym_AMP,
    ACTIONS(1444), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1448), 1,
      anon_sym_QMARK,
    ACTIONS(1452), 1,
      anon_sym_PIPE,
    ACTIONS(1454), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1097), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1184), 2,
      anon_sym_LBRACE,
      anon_sym_COLON,
    ACTIONS(1442), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1450), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    STATE(453), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1430), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1438), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1434), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1446), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [23875] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1208), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1210), 24,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [23920] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(367), 1,
      anon_sym_BQUOTE,
    ACTIONS(1089), 1,
      anon_sym_LPAREN,
    ACTIONS(1091), 1,
      anon_sym_LBRACK,
    ACTIONS(1093), 1,
      anon_sym_DOT,
    ACTIONS(1095), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1432), 1,
      anon_sym_in,
    ACTIONS(1444), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1097), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1442), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(453), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1085), 3,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1430), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1438), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1434), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1446), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(1087), 6,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
  [23993] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(499), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(501), 24,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [24038] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(367), 1,
      anon_sym_BQUOTE,
    ACTIONS(1089), 1,
      anon_sym_LPAREN,
    ACTIONS(1091), 1,
      anon_sym_LBRACK,
    ACTIONS(1093), 1,
      anon_sym_DOT,
    ACTIONS(1095), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1113), 1,
      anon_sym_in,
    ACTIONS(1117), 1,
      anon_sym_QMARK,
    ACTIONS(1119), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1125), 1,
      anon_sym_AMP,
    ACTIONS(1127), 1,
      anon_sym_PIPE,
    ACTIONS(1131), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1135), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1190), 1,
      anon_sym_COMMA,
    ACTIONS(1477), 1,
      anon_sym_RPAREN,
    ACTIONS(1097), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1121), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1129), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(453), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1109), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1123), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1115), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1133), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [24123] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1479), 1,
      anon_sym_LPAREN,
    ACTIONS(1482), 1,
      anon_sym_COLON,
    ACTIONS(1383), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1385), 22,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [24172] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1282), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1284), 24,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [24217] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(367), 1,
      anon_sym_BQUOTE,
    ACTIONS(1089), 1,
      anon_sym_LPAREN,
    ACTIONS(1091), 1,
      anon_sym_LBRACK,
    ACTIONS(1093), 1,
      anon_sym_DOT,
    ACTIONS(1095), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1113), 1,
      anon_sym_in,
    ACTIONS(1117), 1,
      anon_sym_QMARK,
    ACTIONS(1119), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1125), 1,
      anon_sym_AMP,
    ACTIONS(1127), 1,
      anon_sym_PIPE,
    ACTIONS(1131), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1135), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1190), 1,
      anon_sym_COMMA,
    ACTIONS(1484), 1,
      anon_sym_COLON,
    ACTIONS(1097), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1121), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1129), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(453), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1109), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1123), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1115), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1133), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [24302] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1300), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1302), 24,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [24347] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(367), 1,
      anon_sym_BQUOTE,
    ACTIONS(1089), 1,
      anon_sym_LPAREN,
    ACTIONS(1091), 1,
      anon_sym_LBRACK,
    ACTIONS(1093), 1,
      anon_sym_DOT,
    ACTIONS(1095), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1113), 1,
      anon_sym_in,
    ACTIONS(1117), 1,
      anon_sym_QMARK,
    ACTIONS(1119), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1125), 1,
      anon_sym_AMP,
    ACTIONS(1127), 1,
      anon_sym_PIPE,
    ACTIONS(1131), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1135), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1190), 1,
      anon_sym_COMMA,
    ACTIONS(1486), 1,
      anon_sym_RPAREN,
    ACTIONS(1097), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1121), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1129), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(453), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1109), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1123), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1115), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1133), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [24432] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(367), 1,
      anon_sym_BQUOTE,
    ACTIONS(1089), 1,
      anon_sym_LPAREN,
    ACTIONS(1091), 1,
      anon_sym_LBRACK,
    ACTIONS(1093), 1,
      anon_sym_DOT,
    ACTIONS(1095), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1432), 1,
      anon_sym_in,
    ACTIONS(1436), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1440), 1,
      anon_sym_AMP,
    ACTIONS(1444), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1448), 1,
      anon_sym_QMARK,
    ACTIONS(1452), 1,
      anon_sym_PIPE,
    ACTIONS(1454), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1097), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1186), 2,
      anon_sym_LBRACE,
      anon_sym_COLON,
    ACTIONS(1442), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1450), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    STATE(453), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1430), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1438), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1434), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1446), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [24515] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(367), 1,
      anon_sym_BQUOTE,
    ACTIONS(1089), 1,
      anon_sym_LPAREN,
    ACTIONS(1091), 1,
      anon_sym_LBRACK,
    ACTIONS(1093), 1,
      anon_sym_DOT,
    ACTIONS(1095), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1113), 1,
      anon_sym_in,
    ACTIONS(1117), 1,
      anon_sym_QMARK,
    ACTIONS(1119), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1125), 1,
      anon_sym_AMP,
    ACTIONS(1127), 1,
      anon_sym_PIPE,
    ACTIONS(1131), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1135), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1190), 1,
      anon_sym_COMMA,
    ACTIONS(1488), 1,
      anon_sym_RPAREN,
    ACTIONS(1097), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1121), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1129), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(453), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1109), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1123), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1115), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1133), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [24600] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1308), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1310), 24,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [24645] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(367), 1,
      anon_sym_BQUOTE,
    ACTIONS(1089), 1,
      anon_sym_LPAREN,
    ACTIONS(1091), 1,
      anon_sym_LBRACK,
    ACTIONS(1093), 1,
      anon_sym_DOT,
    ACTIONS(1095), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1113), 1,
      anon_sym_in,
    ACTIONS(1117), 1,
      anon_sym_QMARK,
    ACTIONS(1119), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1125), 1,
      anon_sym_AMP,
    ACTIONS(1127), 1,
      anon_sym_PIPE,
    ACTIONS(1131), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1135), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1190), 1,
      anon_sym_COMMA,
    ACTIONS(1490), 1,
      anon_sym_RPAREN,
    ACTIONS(1097), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1121), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1129), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(453), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1109), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1123), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1115), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1133), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [24730] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1200), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1202), 24,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [24775] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(367), 1,
      anon_sym_BQUOTE,
    ACTIONS(1089), 1,
      anon_sym_LPAREN,
    ACTIONS(1091), 1,
      anon_sym_LBRACK,
    ACTIONS(1093), 1,
      anon_sym_DOT,
    ACTIONS(1095), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1113), 1,
      anon_sym_in,
    ACTIONS(1117), 1,
      anon_sym_QMARK,
    ACTIONS(1119), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1125), 1,
      anon_sym_AMP,
    ACTIONS(1127), 1,
      anon_sym_PIPE,
    ACTIONS(1131), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1135), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1190), 1,
      anon_sym_COMMA,
    ACTIONS(1492), 1,
      anon_sym_RBRACE,
    ACTIONS(1097), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1121), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1129), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(453), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1109), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1123), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1115), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1133), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [24860] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1312), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1314), 24,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [24905] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(367), 1,
      anon_sym_BQUOTE,
    ACTIONS(1089), 1,
      anon_sym_LPAREN,
    ACTIONS(1091), 1,
      anon_sym_LBRACK,
    ACTIONS(1093), 1,
      anon_sym_DOT,
    ACTIONS(1095), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1432), 1,
      anon_sym_in,
    ACTIONS(1436), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1440), 1,
      anon_sym_AMP,
    ACTIONS(1444), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1448), 1,
      anon_sym_QMARK,
    ACTIONS(1452), 1,
      anon_sym_PIPE,
    ACTIONS(1454), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1097), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1170), 2,
      anon_sym_LBRACE,
      anon_sym_COLON,
    ACTIONS(1442), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1450), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    STATE(453), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1430), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1438), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1434), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1446), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [24988] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1290), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1139), 24,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [25033] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(367), 1,
      anon_sym_BQUOTE,
    ACTIONS(1089), 1,
      anon_sym_LPAREN,
    ACTIONS(1091), 1,
      anon_sym_LBRACK,
    ACTIONS(1093), 1,
      anon_sym_DOT,
    ACTIONS(1095), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1113), 1,
      anon_sym_in,
    ACTIONS(1117), 1,
      anon_sym_QMARK,
    ACTIONS(1119), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1125), 1,
      anon_sym_AMP,
    ACTIONS(1127), 1,
      anon_sym_PIPE,
    ACTIONS(1131), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1135), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1190), 1,
      anon_sym_COMMA,
    ACTIONS(1494), 1,
      anon_sym_RPAREN,
    ACTIONS(1097), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1121), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1129), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(453), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1109), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1123), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1115), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1133), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [25118] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1296), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1298), 24,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [25163] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(433), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(435), 24,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [25208] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(489), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(491), 24,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [25253] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(367), 1,
      anon_sym_BQUOTE,
    ACTIONS(1089), 1,
      anon_sym_LPAREN,
    ACTIONS(1091), 1,
      anon_sym_LBRACK,
    ACTIONS(1093), 1,
      anon_sym_DOT,
    ACTIONS(1095), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1444), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1097), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(453), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1430), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1438), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1085), 10,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1087), 11,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [25318] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1316), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1318), 24,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [25363] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1375), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1377), 24,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [25408] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(367), 1,
      anon_sym_BQUOTE,
    ACTIONS(1085), 1,
      anon_sym_QMARK,
    ACTIONS(1089), 1,
      anon_sym_LPAREN,
    ACTIONS(1091), 1,
      anon_sym_LBRACK,
    ACTIONS(1093), 1,
      anon_sym_DOT,
    ACTIONS(1095), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1432), 1,
      anon_sym_in,
    ACTIONS(1436), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1440), 1,
      anon_sym_AMP,
    ACTIONS(1444), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1452), 1,
      anon_sym_PIPE,
    ACTIONS(1097), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1442), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1450), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    STATE(453), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1087), 3,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
    ACTIONS(1430), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1438), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1434), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1446), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [25489] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1063), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1065), 24,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [25534] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(367), 1,
      anon_sym_BQUOTE,
    ACTIONS(1089), 1,
      anon_sym_LPAREN,
    ACTIONS(1091), 1,
      anon_sym_LBRACK,
    ACTIONS(1093), 1,
      anon_sym_DOT,
    ACTIONS(1095), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1113), 1,
      anon_sym_in,
    ACTIONS(1117), 1,
      anon_sym_QMARK,
    ACTIONS(1119), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1125), 1,
      anon_sym_AMP,
    ACTIONS(1127), 1,
      anon_sym_PIPE,
    ACTIONS(1131), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1135), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1190), 1,
      anon_sym_COMMA,
    ACTIONS(1496), 1,
      anon_sym_RPAREN,
    ACTIONS(1097), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1121), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1129), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(453), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1109), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1123), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1115), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1133), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [25619] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1357), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1359), 24,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [25664] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1369), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1371), 24,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [25709] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1324), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1160), 24,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [25754] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1204), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1206), 24,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [25799] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1333), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1162), 24,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [25844] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1365), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1367), 24,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [25889] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1339), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1188), 24,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [25934] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1365), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1367), 24,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [25979] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1365), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1367), 24,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [26024] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1341), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1343), 24,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [26069] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1216), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1218), 24,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [26114] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1365), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1367), 24,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [26159] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(367), 1,
      anon_sym_BQUOTE,
    ACTIONS(1089), 1,
      anon_sym_LPAREN,
    ACTIONS(1091), 1,
      anon_sym_LBRACK,
    ACTIONS(1093), 1,
      anon_sym_DOT,
    ACTIONS(1095), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1432), 1,
      anon_sym_in,
    ACTIONS(1436), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1440), 1,
      anon_sym_AMP,
    ACTIONS(1444), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1448), 1,
      anon_sym_QMARK,
    ACTIONS(1452), 1,
      anon_sym_PIPE,
    ACTIONS(1454), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1097), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1111), 2,
      anon_sym_LBRACE,
      anon_sym_COLON,
    ACTIONS(1442), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1450), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    STATE(453), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1430), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1438), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1434), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1446), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [26242] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(367), 1,
      anon_sym_BQUOTE,
    ACTIONS(1089), 1,
      anon_sym_LPAREN,
    ACTIONS(1091), 1,
      anon_sym_LBRACK,
    ACTIONS(1093), 1,
      anon_sym_DOT,
    ACTIONS(1095), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1432), 1,
      anon_sym_in,
    ACTIONS(1436), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1440), 1,
      anon_sym_AMP,
    ACTIONS(1444), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1448), 1,
      anon_sym_QMARK,
    ACTIONS(1452), 1,
      anon_sym_PIPE,
    ACTIONS(1454), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1097), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1198), 2,
      anon_sym_LBRACE,
      anon_sym_COLON,
    ACTIONS(1442), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1450), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    STATE(453), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1430), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1438), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1434), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1446), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [26325] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1361), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1363), 24,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [26370] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(367), 1,
      anon_sym_BQUOTE,
    ACTIONS(1089), 1,
      anon_sym_LPAREN,
    ACTIONS(1091), 1,
      anon_sym_LBRACK,
    ACTIONS(1093), 1,
      anon_sym_DOT,
    ACTIONS(1095), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1432), 1,
      anon_sym_in,
    ACTIONS(1436), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1440), 1,
      anon_sym_AMP,
    ACTIONS(1444), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1448), 1,
      anon_sym_QMARK,
    ACTIONS(1452), 1,
      anon_sym_PIPE,
    ACTIONS(1454), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1097), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1139), 2,
      anon_sym_LBRACE,
      anon_sym_COLON,
    ACTIONS(1442), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1450), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    STATE(453), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1430), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1438), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1434), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1446), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [26453] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(367), 1,
      anon_sym_BQUOTE,
    ACTIONS(1089), 1,
      anon_sym_LPAREN,
    ACTIONS(1091), 1,
      anon_sym_LBRACK,
    ACTIONS(1093), 1,
      anon_sym_DOT,
    ACTIONS(1095), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1113), 1,
      anon_sym_in,
    ACTIONS(1117), 1,
      anon_sym_QMARK,
    ACTIONS(1119), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1125), 1,
      anon_sym_AMP,
    ACTIONS(1127), 1,
      anon_sym_PIPE,
    ACTIONS(1131), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1135), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1190), 1,
      anon_sym_COMMA,
    ACTIONS(1498), 1,
      anon_sym_RBRACK,
    ACTIONS(1097), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1121), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1129), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(453), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1109), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1123), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1115), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1133), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [26538] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(473), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(475), 24,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [26583] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(367), 1,
      anon_sym_BQUOTE,
    ACTIONS(1089), 1,
      anon_sym_LPAREN,
    ACTIONS(1091), 1,
      anon_sym_LBRACK,
    ACTIONS(1093), 1,
      anon_sym_DOT,
    ACTIONS(1095), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1432), 1,
      anon_sym_in,
    ACTIONS(1436), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1440), 1,
      anon_sym_AMP,
    ACTIONS(1444), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1448), 1,
      anon_sym_QMARK,
    ACTIONS(1452), 1,
      anon_sym_PIPE,
    ACTIONS(1454), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1097), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1194), 2,
      anon_sym_LBRACE,
      anon_sym_COLON,
    ACTIONS(1442), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1450), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    STATE(453), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1430), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1438), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1434), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1446), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [26666] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(367), 1,
      anon_sym_BQUOTE,
    ACTIONS(1089), 1,
      anon_sym_LPAREN,
    ACTIONS(1091), 1,
      anon_sym_LBRACK,
    ACTIONS(1093), 1,
      anon_sym_DOT,
    ACTIONS(1095), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1432), 1,
      anon_sym_in,
    ACTIONS(1436), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1440), 1,
      anon_sym_AMP,
    ACTIONS(1444), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1448), 1,
      anon_sym_QMARK,
    ACTIONS(1452), 1,
      anon_sym_PIPE,
    ACTIONS(1454), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1097), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1160), 2,
      anon_sym_LBRACE,
      anon_sym_COLON,
    ACTIONS(1442), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1450), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    STATE(453), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1430), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1438), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1434), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1446), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [26749] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(367), 1,
      anon_sym_BQUOTE,
    ACTIONS(1089), 1,
      anon_sym_LPAREN,
    ACTIONS(1091), 1,
      anon_sym_LBRACK,
    ACTIONS(1093), 1,
      anon_sym_DOT,
    ACTIONS(1095), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1432), 1,
      anon_sym_in,
    ACTIONS(1436), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1440), 1,
      anon_sym_AMP,
    ACTIONS(1444), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1448), 1,
      anon_sym_QMARK,
    ACTIONS(1452), 1,
      anon_sym_PIPE,
    ACTIONS(1454), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1097), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1162), 2,
      anon_sym_LBRACE,
      anon_sym_COLON,
    ACTIONS(1442), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1450), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    STATE(453), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1430), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1438), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1434), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1446), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [26832] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(523), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(525), 24,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [26877] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(367), 1,
      anon_sym_BQUOTE,
    ACTIONS(1089), 1,
      anon_sym_LPAREN,
    ACTIONS(1091), 1,
      anon_sym_LBRACK,
    ACTIONS(1093), 1,
      anon_sym_DOT,
    ACTIONS(1095), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1432), 1,
      anon_sym_in,
    ACTIONS(1436), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1440), 1,
      anon_sym_AMP,
    ACTIONS(1444), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1448), 1,
      anon_sym_QMARK,
    ACTIONS(1452), 1,
      anon_sym_PIPE,
    ACTIONS(1454), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1097), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1188), 2,
      anon_sym_LBRACE,
      anon_sym_COLON,
    ACTIONS(1442), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1450), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    STATE(453), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1430), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1438), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1434), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1446), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [26960] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(367), 1,
      anon_sym_BQUOTE,
    ACTIONS(1089), 1,
      anon_sym_LPAREN,
    ACTIONS(1091), 1,
      anon_sym_LBRACK,
    ACTIONS(1093), 1,
      anon_sym_DOT,
    ACTIONS(1095), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1113), 1,
      anon_sym_in,
    ACTIONS(1117), 1,
      anon_sym_QMARK,
    ACTIONS(1119), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1125), 1,
      anon_sym_AMP,
    ACTIONS(1127), 1,
      anon_sym_PIPE,
    ACTIONS(1131), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1135), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1190), 1,
      anon_sym_COMMA,
    ACTIONS(1500), 1,
      anon_sym_RPAREN,
    ACTIONS(1097), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1121), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1129), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(453), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1109), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1123), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1115), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1133), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [27045] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(79), 1,
      anon_sym_BQUOTE,
    ACTIONS(1234), 1,
      anon_sym_LPAREN,
    ACTIONS(1236), 1,
      anon_sym_in,
    ACTIONS(1238), 1,
      anon_sym_LBRACK,
    ACTIONS(1242), 1,
      anon_sym_DOT,
    ACTIONS(1244), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1246), 1,
      anon_sym_QMARK,
    ACTIONS(1248), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1254), 1,
      anon_sym_AMP,
    ACTIONS(1256), 1,
      anon_sym_PIPE,
    ACTIONS(1260), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1264), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1502), 1,
      anon_sym_SEMI,
    ACTIONS(1504), 1,
      sym__automatic_semicolon,
    ACTIONS(1250), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1258), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1266), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(569), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1232), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1252), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1240), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1262), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [27130] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(459), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(461), 24,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [27175] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(367), 1,
      anon_sym_BQUOTE,
    ACTIONS(1089), 1,
      anon_sym_LPAREN,
    ACTIONS(1091), 1,
      anon_sym_LBRACK,
    ACTIONS(1093), 1,
      anon_sym_DOT,
    ACTIONS(1095), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1432), 1,
      anon_sym_in,
    ACTIONS(1436), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1440), 1,
      anon_sym_AMP,
    ACTIONS(1444), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1448), 1,
      anon_sym_QMARK,
    ACTIONS(1452), 1,
      anon_sym_PIPE,
    ACTIONS(1454), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1506), 1,
      anon_sym_LBRACE,
    ACTIONS(1097), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1442), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1450), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    STATE(453), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1430), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1438), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1434), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1446), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [27257] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(367), 1,
      anon_sym_BQUOTE,
    ACTIONS(1089), 1,
      anon_sym_LPAREN,
    ACTIONS(1091), 1,
      anon_sym_LBRACK,
    ACTIONS(1093), 1,
      anon_sym_DOT,
    ACTIONS(1095), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1113), 1,
      anon_sym_in,
    ACTIONS(1117), 1,
      anon_sym_QMARK,
    ACTIONS(1119), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1125), 1,
      anon_sym_AMP,
    ACTIONS(1127), 1,
      anon_sym_PIPE,
    ACTIONS(1131), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1135), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1508), 1,
      anon_sym_RBRACK,
    ACTIONS(1097), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1121), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1129), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(453), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1109), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1123), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1115), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1133), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [27339] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(367), 1,
      anon_sym_BQUOTE,
    ACTIONS(1089), 1,
      anon_sym_LPAREN,
    ACTIONS(1091), 1,
      anon_sym_LBRACK,
    ACTIONS(1093), 1,
      anon_sym_DOT,
    ACTIONS(1095), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1432), 1,
      anon_sym_in,
    ACTIONS(1436), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1440), 1,
      anon_sym_AMP,
    ACTIONS(1444), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1448), 1,
      anon_sym_QMARK,
    ACTIONS(1452), 1,
      anon_sym_PIPE,
    ACTIONS(1454), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1510), 1,
      anon_sym_COLON,
    ACTIONS(1097), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1442), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1450), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    STATE(453), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1430), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1438), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1434), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1446), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [27421] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(367), 1,
      anon_sym_BQUOTE,
    ACTIONS(1089), 1,
      anon_sym_LPAREN,
    ACTIONS(1091), 1,
      anon_sym_LBRACK,
    ACTIONS(1093), 1,
      anon_sym_DOT,
    ACTIONS(1095), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1432), 1,
      anon_sym_in,
    ACTIONS(1436), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1440), 1,
      anon_sym_AMP,
    ACTIONS(1444), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1448), 1,
      anon_sym_QMARK,
    ACTIONS(1452), 1,
      anon_sym_PIPE,
    ACTIONS(1454), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1512), 1,
      anon_sym_COLON,
    ACTIONS(1097), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1442), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1450), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    STATE(453), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1430), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1438), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1434), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1446), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [27503] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(367), 1,
      anon_sym_BQUOTE,
    ACTIONS(1089), 1,
      anon_sym_LPAREN,
    ACTIONS(1091), 1,
      anon_sym_LBRACK,
    ACTIONS(1093), 1,
      anon_sym_DOT,
    ACTIONS(1095), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1432), 1,
      anon_sym_in,
    ACTIONS(1436), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1440), 1,
      anon_sym_AMP,
    ACTIONS(1444), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1448), 1,
      anon_sym_QMARK,
    ACTIONS(1452), 1,
      anon_sym_PIPE,
    ACTIONS(1454), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1514), 1,
      anon_sym_COLON,
    ACTIONS(1097), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1442), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1450), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    STATE(453), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1430), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1438), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1434), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1446), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [27585] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1179), 1,
      anon_sym_RBRACK,
    ACTIONS(1182), 1,
      anon_sym_EQ,
    ACTIONS(1419), 1,
      anon_sym_COMMA,
    ACTIONS(1175), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1177), 20,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [27635] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1155), 1,
      anon_sym_RBRACK,
    ACTIONS(1158), 1,
      anon_sym_EQ,
    ACTIONS(1414), 1,
      anon_sym_COMMA,
    ACTIONS(1151), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1153), 20,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [27685] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(425), 1,
      anon_sym_EQ,
    ACTIONS(1172), 1,
      anon_sym_RBRACK,
    ACTIONS(1428), 1,
      anon_sym_COMMA,
    ACTIONS(421), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(423), 20,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [27735] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(367), 1,
      anon_sym_BQUOTE,
    ACTIONS(1089), 1,
      anon_sym_LPAREN,
    ACTIONS(1091), 1,
      anon_sym_LBRACK,
    ACTIONS(1093), 1,
      anon_sym_DOT,
    ACTIONS(1095), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1113), 1,
      anon_sym_in,
    ACTIONS(1117), 1,
      anon_sym_QMARK,
    ACTIONS(1119), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1125), 1,
      anon_sym_AMP,
    ACTIONS(1127), 1,
      anon_sym_PIPE,
    ACTIONS(1131), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1135), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1516), 1,
      anon_sym_RBRACK,
    ACTIONS(1097), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1121), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1129), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(453), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1109), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1123), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1115), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1133), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [27817] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(425), 1,
      anon_sym_EQ,
    ACTIONS(1425), 1,
      anon_sym_in,
    ACTIONS(1428), 1,
      anon_sym_of,
    ACTIONS(421), 12,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(423), 20,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [27866] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(79), 1,
      anon_sym_BQUOTE,
    ACTIONS(1234), 1,
      anon_sym_LPAREN,
    ACTIONS(1238), 1,
      anon_sym_LBRACK,
    ACTIONS(1242), 1,
      anon_sym_DOT,
    ACTIONS(1244), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1432), 1,
      anon_sym_in,
    ACTIONS(1436), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1440), 1,
      anon_sym_AMP,
    ACTIONS(1444), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1448), 1,
      anon_sym_QMARK,
    ACTIONS(1452), 1,
      anon_sym_PIPE,
    ACTIONS(1454), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1097), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1442), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1450), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    STATE(569), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1430), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1438), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1434), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1446), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [27945] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(367), 1,
      anon_sym_BQUOTE,
    ACTIONS(1089), 1,
      anon_sym_LPAREN,
    ACTIONS(1091), 1,
      anon_sym_LBRACK,
    ACTIONS(1093), 1,
      anon_sym_DOT,
    ACTIONS(1095), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1432), 1,
      anon_sym_in,
    ACTIONS(1436), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1440), 1,
      anon_sym_AMP,
    ACTIONS(1444), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1448), 1,
      anon_sym_QMARK,
    ACTIONS(1452), 1,
      anon_sym_PIPE,
    ACTIONS(1454), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1097), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1442), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1450), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    STATE(453), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1430), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1438), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1434), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1446), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [28024] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1182), 1,
      anon_sym_EQ,
    ACTIONS(1416), 1,
      anon_sym_in,
    ACTIONS(1419), 1,
      anon_sym_of,
    ACTIONS(1175), 12,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1177), 20,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [28073] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1158), 1,
      anon_sym_EQ,
    ACTIONS(1411), 1,
      anon_sym_in,
    ACTIONS(1414), 1,
      anon_sym_of,
    ACTIONS(1151), 12,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1153), 20,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [28122] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_AT,
    ACTIONS(93), 1,
      anon_sym_STAR,
    ACTIONS(95), 1,
      anon_sym_COMMA,
    ACTIONS(103), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(363), 1,
      anon_sym_DQUOTE,
    ACTIONS(365), 1,
      anon_sym_SQUOTE,
    ACTIONS(1520), 1,
      anon_sym_LBRACE,
    ACTIONS(1522), 1,
      anon_sym_RBRACE,
    ACTIONS(1524), 1,
      anon_sym_LBRACK,
    ACTIONS(1526), 1,
      anon_sym_async,
    ACTIONS(1528), 1,
      sym_number,
    ACTIONS(1530), 1,
      anon_sym_static,
    STATE(695), 1,
      aux_sym_export_statement_repeat1,
    STATE(750), 1,
      sym_decorator,
    STATE(1044), 1,
      aux_sym_object_pattern_repeat1,
    STATE(1048), 1,
      aux_sym_object_repeat1,
    ACTIONS(1518), 2,
      anon_sym_export,
      sym_identifier,
    ACTIONS(1532), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1049), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(1050), 3,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    STATE(1052), 3,
      sym_object_assignment_pattern,
      sym_rest_pattern,
      sym_pair_pattern,
    STATE(1251), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
  [28202] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_AT,
    ACTIONS(93), 1,
      anon_sym_STAR,
    ACTIONS(95), 1,
      anon_sym_COMMA,
    ACTIONS(103), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(363), 1,
      anon_sym_DQUOTE,
    ACTIONS(365), 1,
      anon_sym_SQUOTE,
    ACTIONS(1520), 1,
      anon_sym_LBRACE,
    ACTIONS(1524), 1,
      anon_sym_LBRACK,
    ACTIONS(1528), 1,
      sym_number,
    ACTIONS(1536), 1,
      anon_sym_RBRACE,
    ACTIONS(1538), 1,
      anon_sym_async,
    ACTIONS(1540), 1,
      anon_sym_static,
    STATE(695), 1,
      aux_sym_export_statement_repeat1,
    STATE(750), 1,
      sym_decorator,
    STATE(1018), 1,
      aux_sym_object_repeat1,
    STATE(1044), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(1534), 2,
      anon_sym_export,
      sym_identifier,
    ACTIONS(1542), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1016), 3,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    STATE(1049), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(1052), 3,
      sym_object_assignment_pattern,
      sym_rest_pattern,
      sym_pair_pattern,
    STATE(1251), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
  [28282] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_AT,
    ACTIONS(93), 1,
      anon_sym_STAR,
    ACTIONS(95), 1,
      anon_sym_COMMA,
    ACTIONS(103), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(363), 1,
      anon_sym_DQUOTE,
    ACTIONS(365), 1,
      anon_sym_SQUOTE,
    ACTIONS(1520), 1,
      anon_sym_LBRACE,
    ACTIONS(1524), 1,
      anon_sym_LBRACK,
    ACTIONS(1528), 1,
      sym_number,
    ACTIONS(1546), 1,
      anon_sym_RBRACE,
    ACTIONS(1548), 1,
      anon_sym_async,
    ACTIONS(1550), 1,
      anon_sym_static,
    STATE(695), 1,
      aux_sym_export_statement_repeat1,
    STATE(750), 1,
      sym_decorator,
    STATE(1044), 1,
      aux_sym_object_pattern_repeat1,
    STATE(1048), 1,
      aux_sym_object_repeat1,
    ACTIONS(1544), 2,
      anon_sym_export,
      sym_identifier,
    ACTIONS(1552), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1049), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(1050), 3,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    STATE(1052), 3,
      sym_object_assignment_pattern,
      sym_rest_pattern,
      sym_pair_pattern,
    STATE(1251), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
  [28362] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_AT,
    ACTIONS(93), 1,
      anon_sym_STAR,
    ACTIONS(95), 1,
      anon_sym_COMMA,
    ACTIONS(103), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(363), 1,
      anon_sym_DQUOTE,
    ACTIONS(365), 1,
      anon_sym_SQUOTE,
    ACTIONS(1520), 1,
      anon_sym_LBRACE,
    ACTIONS(1524), 1,
      anon_sym_LBRACK,
    ACTIONS(1528), 1,
      sym_number,
    ACTIONS(1556), 1,
      anon_sym_RBRACE,
    ACTIONS(1558), 1,
      anon_sym_async,
    ACTIONS(1560), 1,
      anon_sym_static,
    STATE(695), 1,
      aux_sym_export_statement_repeat1,
    STATE(750), 1,
      sym_decorator,
    STATE(1018), 1,
      aux_sym_object_repeat1,
    STATE(1044), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(1554), 2,
      anon_sym_export,
      sym_identifier,
    ACTIONS(1562), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1016), 3,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    STATE(1049), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(1052), 3,
      sym_object_assignment_pattern,
      sym_rest_pattern,
      sym_pair_pattern,
    STATE(1251), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
  [28442] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_AT,
    ACTIONS(93), 1,
      anon_sym_STAR,
    ACTIONS(95), 1,
      anon_sym_COMMA,
    ACTIONS(103), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(363), 1,
      anon_sym_DQUOTE,
    ACTIONS(365), 1,
      anon_sym_SQUOTE,
    ACTIONS(1520), 1,
      anon_sym_LBRACE,
    ACTIONS(1524), 1,
      anon_sym_LBRACK,
    ACTIONS(1528), 1,
      sym_number,
    ACTIONS(1566), 1,
      anon_sym_RBRACE,
    ACTIONS(1568), 1,
      anon_sym_async,
    ACTIONS(1570), 1,
      anon_sym_static,
    STATE(695), 1,
      aux_sym_export_statement_repeat1,
    STATE(750), 1,
      sym_decorator,
    STATE(1018), 1,
      aux_sym_object_repeat1,
    STATE(1044), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(1564), 2,
      anon_sym_export,
      sym_identifier,
    ACTIONS(1572), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1016), 3,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    STATE(1049), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(1052), 3,
      sym_object_assignment_pattern,
      sym_rest_pattern,
      sym_pair_pattern,
    STATE(1251), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
  [28522] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_AT,
    ACTIONS(93), 1,
      anon_sym_STAR,
    ACTIONS(95), 1,
      anon_sym_COMMA,
    ACTIONS(103), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(363), 1,
      anon_sym_DQUOTE,
    ACTIONS(365), 1,
      anon_sym_SQUOTE,
    ACTIONS(1520), 1,
      anon_sym_LBRACE,
    ACTIONS(1524), 1,
      anon_sym_LBRACK,
    ACTIONS(1528), 1,
      sym_number,
    ACTIONS(1576), 1,
      anon_sym_RBRACE,
    ACTIONS(1578), 1,
      anon_sym_async,
    ACTIONS(1580), 1,
      anon_sym_static,
    STATE(695), 1,
      aux_sym_export_statement_repeat1,
    STATE(750), 1,
      sym_decorator,
    STATE(1018), 1,
      aux_sym_object_repeat1,
    STATE(1044), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(1574), 2,
      anon_sym_export,
      sym_identifier,
    ACTIONS(1582), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1016), 3,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    STATE(1049), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(1052), 3,
      sym_object_assignment_pattern,
      sym_rest_pattern,
      sym_pair_pattern,
    STATE(1251), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
  [28602] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_AT,
    ACTIONS(93), 1,
      anon_sym_STAR,
    ACTIONS(103), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(363), 1,
      anon_sym_DQUOTE,
    ACTIONS(365), 1,
      anon_sym_SQUOTE,
    ACTIONS(1520), 1,
      anon_sym_LBRACE,
    ACTIONS(1524), 1,
      anon_sym_LBRACK,
    ACTIONS(1528), 1,
      sym_number,
    ACTIONS(1589), 1,
      anon_sym_async,
    ACTIONS(1591), 1,
      anon_sym_static,
    STATE(695), 1,
      aux_sym_export_statement_repeat1,
    STATE(750), 1,
      sym_decorator,
    ACTIONS(1584), 2,
      anon_sym_export,
      sym_identifier,
    ACTIONS(1586), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(1593), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1049), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(1177), 3,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    STATE(1179), 3,
      sym_object_assignment_pattern,
      sym_rest_pattern,
      sym_pair_pattern,
    STATE(1251), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
  [28674] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(363), 1,
      anon_sym_DQUOTE,
    ACTIONS(365), 1,
      anon_sym_SQUOTE,
    ACTIONS(584), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1520), 1,
      anon_sym_LBRACE,
    ACTIONS(1524), 1,
      anon_sym_LBRACK,
    ACTIONS(1597), 1,
      anon_sym_COMMA,
    ACTIONS(1599), 1,
      anon_sym_RBRACE,
    ACTIONS(1601), 1,
      sym_number,
    STATE(1044), 1,
      aux_sym_object_pattern_repeat1,
    STATE(1052), 3,
      sym_object_assignment_pattern,
      sym_rest_pattern,
      sym_pair_pattern,
    STATE(1251), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
    STATE(1319), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1595), 6,
      anon_sym_export,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [28728] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(363), 1,
      anon_sym_DQUOTE,
    ACTIONS(365), 1,
      anon_sym_SQUOTE,
    ACTIONS(584), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1520), 1,
      anon_sym_LBRACE,
    ACTIONS(1524), 1,
      anon_sym_LBRACK,
    ACTIONS(1597), 1,
      anon_sym_COMMA,
    ACTIONS(1601), 1,
      sym_number,
    ACTIONS(1605), 1,
      anon_sym_RBRACE,
    STATE(1019), 1,
      aux_sym_object_pattern_repeat1,
    STATE(1015), 3,
      sym_object_assignment_pattern,
      sym_rest_pattern,
      sym_pair_pattern,
    STATE(1251), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
    STATE(1319), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1603), 6,
      anon_sym_export,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [28782] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(363), 1,
      anon_sym_DQUOTE,
    ACTIONS(365), 1,
      anon_sym_SQUOTE,
    ACTIONS(584), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1520), 1,
      anon_sym_LBRACE,
    ACTIONS(1524), 1,
      anon_sym_LBRACK,
    ACTIONS(1601), 1,
      sym_number,
    ACTIONS(1609), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(1179), 3,
      sym_object_assignment_pattern,
      sym_rest_pattern,
      sym_pair_pattern,
    STATE(1251), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
    STATE(1319), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1607), 6,
      anon_sym_export,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [28831] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_AT,
    ACTIONS(93), 1,
      anon_sym_STAR,
    ACTIONS(363), 1,
      anon_sym_DQUOTE,
    ACTIONS(365), 1,
      anon_sym_SQUOTE,
    ACTIONS(592), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1615), 1,
      anon_sym_LBRACK,
    ACTIONS(1617), 1,
      anon_sym_async,
    ACTIONS(1619), 1,
      sym_number,
    ACTIONS(1621), 1,
      anon_sym_static,
    STATE(695), 1,
      aux_sym_export_statement_repeat1,
    STATE(750), 1,
      sym_decorator,
    ACTIONS(1611), 2,
      anon_sym_export,
      sym_identifier,
    ACTIONS(1613), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(1623), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1023), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(1177), 3,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
  [28890] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_COMMA,
    ACTIONS(363), 1,
      anon_sym_DQUOTE,
    ACTIONS(365), 1,
      anon_sym_SQUOTE,
    ACTIONS(638), 1,
      anon_sym_RBRACE,
    ACTIONS(720), 1,
      sym_number,
    ACTIONS(1615), 1,
      anon_sym_LBRACK,
    ACTIONS(1625), 1,
      anon_sym_STAR,
    ACTIONS(1629), 1,
      anon_sym_EQ,
    STATE(976), 1,
      aux_sym_object_repeat1,
    STATE(978), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(728), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(1627), 2,
      anon_sym_LPAREN,
      anon_sym_COLON,
    STATE(1181), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(724), 4,
      anon_sym_export,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
  [28943] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_COMMA,
    ACTIONS(363), 1,
      anon_sym_DQUOTE,
    ACTIONS(365), 1,
      anon_sym_SQUOTE,
    ACTIONS(720), 1,
      sym_number,
    ACTIONS(1615), 1,
      anon_sym_LBRACK,
    ACTIONS(1625), 1,
      anon_sym_STAR,
    ACTIONS(1629), 1,
      anon_sym_EQ,
    ACTIONS(1631), 1,
      anon_sym_RBRACE,
    STATE(978), 1,
      aux_sym_object_pattern_repeat1,
    STATE(1058), 1,
      aux_sym_object_repeat1,
    ACTIONS(728), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(1627), 2,
      anon_sym_LPAREN,
      anon_sym_COLON,
    STATE(1181), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(724), 4,
      anon_sym_export,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
  [28996] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_COMMA,
    ACTIONS(363), 1,
      anon_sym_DQUOTE,
    ACTIONS(365), 1,
      anon_sym_SQUOTE,
    ACTIONS(674), 1,
      anon_sym_RBRACE,
    ACTIONS(720), 1,
      sym_number,
    ACTIONS(726), 1,
      anon_sym_async,
    ACTIONS(1615), 1,
      anon_sym_LBRACK,
    ACTIONS(1625), 1,
      anon_sym_STAR,
    ACTIONS(1629), 1,
      anon_sym_EQ,
    STATE(978), 1,
      aux_sym_object_pattern_repeat1,
    STATE(1058), 1,
      aux_sym_object_repeat1,
    ACTIONS(728), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(1627), 2,
      anon_sym_LPAREN,
      anon_sym_COLON,
    ACTIONS(724), 3,
      anon_sym_export,
      sym_identifier,
      anon_sym_static,
    STATE(1181), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
  [29051] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_COMMA,
    ACTIONS(363), 1,
      anon_sym_DQUOTE,
    ACTIONS(365), 1,
      anon_sym_SQUOTE,
    ACTIONS(720), 1,
      sym_number,
    ACTIONS(726), 1,
      anon_sym_async,
    ACTIONS(1615), 1,
      anon_sym_LBRACK,
    ACTIONS(1625), 1,
      anon_sym_STAR,
    ACTIONS(1629), 1,
      anon_sym_EQ,
    ACTIONS(1631), 1,
      anon_sym_RBRACE,
    STATE(978), 1,
      aux_sym_object_pattern_repeat1,
    STATE(1058), 1,
      aux_sym_object_repeat1,
    ACTIONS(728), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(1627), 2,
      anon_sym_LPAREN,
      anon_sym_COLON,
    ACTIONS(724), 3,
      anon_sym_export,
      sym_identifier,
      anon_sym_static,
    STATE(1181), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
  [29106] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_COMMA,
    ACTIONS(363), 1,
      anon_sym_DQUOTE,
    ACTIONS(365), 1,
      anon_sym_SQUOTE,
    ACTIONS(674), 1,
      anon_sym_RBRACE,
    ACTIONS(720), 1,
      sym_number,
    ACTIONS(1615), 1,
      anon_sym_LBRACK,
    ACTIONS(1625), 1,
      anon_sym_STAR,
    ACTIONS(1629), 1,
      anon_sym_EQ,
    STATE(978), 1,
      aux_sym_object_pattern_repeat1,
    STATE(1058), 1,
      aux_sym_object_repeat1,
    ACTIONS(728), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(1627), 2,
      anon_sym_LPAREN,
      anon_sym_COLON,
    STATE(1181), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(724), 4,
      anon_sym_export,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
  [29159] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(75), 1,
      anon_sym_DQUOTE,
    ACTIONS(77), 1,
      anon_sym_SQUOTE,
    ACTIONS(85), 1,
      anon_sym_AT,
    ACTIONS(93), 1,
      anon_sym_STAR,
    ACTIONS(1635), 1,
      anon_sym_RBRACE,
    ACTIONS(1637), 1,
      anon_sym_LBRACK,
    ACTIONS(1639), 1,
      anon_sym_async,
    ACTIONS(1641), 1,
      sym_number,
    ACTIONS(1643), 1,
      anon_sym_static,
    STATE(660), 1,
      aux_sym_class_body_repeat1,
    STATE(695), 1,
      aux_sym_export_statement_repeat1,
    STATE(744), 1,
      sym_method_definition,
    STATE(750), 1,
      sym_decorator,
    STATE(1128), 1,
      sym_public_field_definition,
    ACTIONS(1633), 2,
      anon_sym_export,
      sym_identifier,
    ACTIONS(1645), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(832), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
  [29218] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(75), 1,
      anon_sym_DQUOTE,
    ACTIONS(77), 1,
      anon_sym_SQUOTE,
    ACTIONS(85), 1,
      anon_sym_AT,
    ACTIONS(93), 1,
      anon_sym_STAR,
    ACTIONS(1637), 1,
      anon_sym_LBRACK,
    ACTIONS(1639), 1,
      anon_sym_async,
    ACTIONS(1641), 1,
      sym_number,
    ACTIONS(1643), 1,
      anon_sym_static,
    ACTIONS(1647), 1,
      anon_sym_RBRACE,
    STATE(661), 1,
      aux_sym_class_body_repeat1,
    STATE(695), 1,
      aux_sym_export_statement_repeat1,
    STATE(744), 1,
      sym_method_definition,
    STATE(750), 1,
      sym_decorator,
    STATE(1128), 1,
      sym_public_field_definition,
    ACTIONS(1633), 2,
      anon_sym_export,
      sym_identifier,
    ACTIONS(1645), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(832), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
  [29277] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1652), 1,
      anon_sym_STAR,
    ACTIONS(1655), 1,
      anon_sym_RBRACE,
    ACTIONS(1657), 1,
      anon_sym_LBRACK,
    ACTIONS(1660), 1,
      anon_sym_async,
    ACTIONS(1663), 1,
      anon_sym_DQUOTE,
    ACTIONS(1666), 1,
      anon_sym_SQUOTE,
    ACTIONS(1669), 1,
      sym_number,
    ACTIONS(1672), 1,
      anon_sym_AT,
    ACTIONS(1675), 1,
      anon_sym_static,
    STATE(661), 1,
      aux_sym_class_body_repeat1,
    STATE(695), 1,
      aux_sym_export_statement_repeat1,
    STATE(744), 1,
      sym_method_definition,
    STATE(750), 1,
      sym_decorator,
    STATE(1128), 1,
      sym_public_field_definition,
    ACTIONS(1649), 2,
      anon_sym_export,
      sym_identifier,
    ACTIONS(1678), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(832), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
  [29336] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(75), 1,
      anon_sym_DQUOTE,
    ACTIONS(77), 1,
      anon_sym_SQUOTE,
    ACTIONS(85), 1,
      anon_sym_AT,
    ACTIONS(93), 1,
      anon_sym_STAR,
    ACTIONS(1637), 1,
      anon_sym_LBRACK,
    ACTIONS(1639), 1,
      anon_sym_async,
    ACTIONS(1641), 1,
      sym_number,
    ACTIONS(1643), 1,
      anon_sym_static,
    ACTIONS(1681), 1,
      anon_sym_RBRACE,
    STATE(664), 1,
      aux_sym_class_body_repeat1,
    STATE(695), 1,
      aux_sym_export_statement_repeat1,
    STATE(744), 1,
      sym_method_definition,
    STATE(750), 1,
      sym_decorator,
    STATE(1128), 1,
      sym_public_field_definition,
    ACTIONS(1633), 2,
      anon_sym_export,
      sym_identifier,
    ACTIONS(1645), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(832), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
  [29395] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(75), 1,
      anon_sym_DQUOTE,
    ACTIONS(77), 1,
      anon_sym_SQUOTE,
    ACTIONS(85), 1,
      anon_sym_AT,
    ACTIONS(93), 1,
      anon_sym_STAR,
    ACTIONS(1637), 1,
      anon_sym_LBRACK,
    ACTIONS(1639), 1,
      anon_sym_async,
    ACTIONS(1641), 1,
      sym_number,
    ACTIONS(1643), 1,
      anon_sym_static,
    ACTIONS(1683), 1,
      anon_sym_RBRACE,
    STATE(661), 1,
      aux_sym_class_body_repeat1,
    STATE(695), 1,
      aux_sym_export_statement_repeat1,
    STATE(744), 1,
      sym_method_definition,
    STATE(750), 1,
      sym_decorator,
    STATE(1128), 1,
      sym_public_field_definition,
    ACTIONS(1633), 2,
      anon_sym_export,
      sym_identifier,
    ACTIONS(1645), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(832), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
  [29454] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(75), 1,
      anon_sym_DQUOTE,
    ACTIONS(77), 1,
      anon_sym_SQUOTE,
    ACTIONS(85), 1,
      anon_sym_AT,
    ACTIONS(93), 1,
      anon_sym_STAR,
    ACTIONS(1637), 1,
      anon_sym_LBRACK,
    ACTIONS(1639), 1,
      anon_sym_async,
    ACTIONS(1641), 1,
      sym_number,
    ACTIONS(1643), 1,
      anon_sym_static,
    ACTIONS(1685), 1,
      anon_sym_RBRACE,
    STATE(661), 1,
      aux_sym_class_body_repeat1,
    STATE(695), 1,
      aux_sym_export_statement_repeat1,
    STATE(744), 1,
      sym_method_definition,
    STATE(750), 1,
      sym_decorator,
    STATE(1128), 1,
      sym_public_field_definition,
    ACTIONS(1633), 2,
      anon_sym_export,
      sym_identifier,
    ACTIONS(1645), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(832), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
  [29513] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(75), 1,
      anon_sym_DQUOTE,
    ACTIONS(77), 1,
      anon_sym_SQUOTE,
    ACTIONS(85), 1,
      anon_sym_AT,
    ACTIONS(93), 1,
      anon_sym_STAR,
    ACTIONS(1637), 1,
      anon_sym_LBRACK,
    ACTIONS(1639), 1,
      anon_sym_async,
    ACTIONS(1641), 1,
      sym_number,
    ACTIONS(1643), 1,
      anon_sym_static,
    ACTIONS(1687), 1,
      anon_sym_RBRACE,
    STATE(663), 1,
      aux_sym_class_body_repeat1,
    STATE(695), 1,
      aux_sym_export_statement_repeat1,
    STATE(744), 1,
      sym_method_definition,
    STATE(750), 1,
      sym_decorator,
    STATE(1128), 1,
      sym_public_field_definition,
    ACTIONS(1633), 2,
      anon_sym_export,
      sym_identifier,
    ACTIONS(1645), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(832), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
  [29572] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_COMMA,
    ACTIONS(363), 1,
      anon_sym_DQUOTE,
    ACTIONS(365), 1,
      anon_sym_SQUOTE,
    ACTIONS(678), 1,
      anon_sym_RBRACE,
    ACTIONS(720), 1,
      sym_number,
    ACTIONS(726), 1,
      anon_sym_async,
    ACTIONS(1615), 1,
      anon_sym_LBRACK,
    ACTIONS(1625), 1,
      anon_sym_STAR,
    ACTIONS(1629), 1,
      anon_sym_EQ,
    STATE(978), 1,
      aux_sym_object_pattern_repeat1,
    STATE(1058), 1,
      aux_sym_object_repeat1,
    ACTIONS(728), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(1627), 2,
      anon_sym_LPAREN,
      anon_sym_COLON,
    ACTIONS(724), 3,
      anon_sym_export,
      sym_identifier,
      anon_sym_static,
    STATE(1181), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
  [29627] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_COMMA,
    ACTIONS(363), 1,
      anon_sym_DQUOTE,
    ACTIONS(365), 1,
      anon_sym_SQUOTE,
    ACTIONS(720), 1,
      sym_number,
    ACTIONS(726), 1,
      anon_sym_async,
    ACTIONS(1615), 1,
      anon_sym_LBRACK,
    ACTIONS(1625), 1,
      anon_sym_STAR,
    ACTIONS(1629), 1,
      anon_sym_EQ,
    ACTIONS(1689), 1,
      anon_sym_RBRACE,
    STATE(978), 1,
      aux_sym_object_pattern_repeat1,
    STATE(1058), 1,
      aux_sym_object_repeat1,
    ACTIONS(728), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(1627), 2,
      anon_sym_LPAREN,
      anon_sym_COLON,
    ACTIONS(724), 3,
      anon_sym_export,
      sym_identifier,
      anon_sym_static,
    STATE(1181), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
  [29682] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_COMMA,
    ACTIONS(363), 1,
      anon_sym_DQUOTE,
    ACTIONS(365), 1,
      anon_sym_SQUOTE,
    ACTIONS(720), 1,
      sym_number,
    ACTIONS(1615), 1,
      anon_sym_LBRACK,
    ACTIONS(1625), 1,
      anon_sym_STAR,
    ACTIONS(1629), 1,
      anon_sym_EQ,
    ACTIONS(1689), 1,
      anon_sym_RBRACE,
    STATE(978), 1,
      aux_sym_object_pattern_repeat1,
    STATE(1058), 1,
      aux_sym_object_repeat1,
    ACTIONS(728), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(1627), 2,
      anon_sym_LPAREN,
      anon_sym_COLON,
    STATE(1181), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(724), 4,
      anon_sym_export,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
  [29735] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_COMMA,
    ACTIONS(363), 1,
      anon_sym_DQUOTE,
    ACTIONS(365), 1,
      anon_sym_SQUOTE,
    ACTIONS(678), 1,
      anon_sym_RBRACE,
    ACTIONS(720), 1,
      sym_number,
    ACTIONS(1615), 1,
      anon_sym_LBRACK,
    ACTIONS(1625), 1,
      anon_sym_STAR,
    ACTIONS(1629), 1,
      anon_sym_EQ,
    STATE(978), 1,
      aux_sym_object_pattern_repeat1,
    STATE(1058), 1,
      aux_sym_object_repeat1,
    ACTIONS(728), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(1627), 2,
      anon_sym_LPAREN,
      anon_sym_COLON,
    STATE(1181), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(724), 4,
      anon_sym_export,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
  [29788] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_COMMA,
    ACTIONS(363), 1,
      anon_sym_DQUOTE,
    ACTIONS(365), 1,
      anon_sym_SQUOTE,
    ACTIONS(720), 1,
      sym_number,
    ACTIONS(726), 1,
      anon_sym_async,
    ACTIONS(1615), 1,
      anon_sym_LBRACK,
    ACTIONS(1625), 1,
      anon_sym_STAR,
    ACTIONS(1629), 1,
      anon_sym_EQ,
    ACTIONS(1691), 1,
      anon_sym_RBRACE,
    STATE(976), 1,
      aux_sym_object_repeat1,
    STATE(978), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(728), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(1627), 2,
      anon_sym_LPAREN,
      anon_sym_COLON,
    ACTIONS(724), 3,
      anon_sym_export,
      sym_identifier,
      anon_sym_static,
    STATE(1181), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
  [29843] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_COMMA,
    ACTIONS(363), 1,
      anon_sym_DQUOTE,
    ACTIONS(365), 1,
      anon_sym_SQUOTE,
    ACTIONS(720), 1,
      sym_number,
    ACTIONS(1615), 1,
      anon_sym_LBRACK,
    ACTIONS(1625), 1,
      anon_sym_STAR,
    ACTIONS(1629), 1,
      anon_sym_EQ,
    ACTIONS(1691), 1,
      anon_sym_RBRACE,
    STATE(976), 1,
      aux_sym_object_repeat1,
    STATE(978), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(728), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(1627), 2,
      anon_sym_LPAREN,
      anon_sym_COLON,
    STATE(1181), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(724), 4,
      anon_sym_export,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
  [29896] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_COMMA,
    ACTIONS(363), 1,
      anon_sym_DQUOTE,
    ACTIONS(365), 1,
      anon_sym_SQUOTE,
    ACTIONS(638), 1,
      anon_sym_RBRACE,
    ACTIONS(720), 1,
      sym_number,
    ACTIONS(726), 1,
      anon_sym_async,
    ACTIONS(1615), 1,
      anon_sym_LBRACK,
    ACTIONS(1625), 1,
      anon_sym_STAR,
    ACTIONS(1629), 1,
      anon_sym_EQ,
    STATE(976), 1,
      aux_sym_object_repeat1,
    STATE(978), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(728), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(1627), 2,
      anon_sym_LPAREN,
      anon_sym_COLON,
    ACTIONS(724), 3,
      anon_sym_export,
      sym_identifier,
      anon_sym_static,
    STATE(1181), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
  [29951] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_COMMA,
    ACTIONS(363), 1,
      anon_sym_DQUOTE,
    ACTIONS(365), 1,
      anon_sym_SQUOTE,
    ACTIONS(678), 1,
      anon_sym_RBRACE,
    ACTIONS(720), 1,
      sym_number,
    ACTIONS(1615), 1,
      anon_sym_LBRACK,
    ACTIONS(1629), 1,
      anon_sym_EQ,
    STATE(978), 1,
      aux_sym_object_pattern_repeat1,
    STATE(1058), 1,
      aux_sym_object_repeat1,
    ACTIONS(1627), 2,
      anon_sym_LPAREN,
      anon_sym_COLON,
    STATE(1181), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(724), 6,
      anon_sym_export,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [29999] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_COMMA,
    ACTIONS(363), 1,
      anon_sym_DQUOTE,
    ACTIONS(365), 1,
      anon_sym_SQUOTE,
    ACTIONS(720), 1,
      sym_number,
    ACTIONS(1615), 1,
      anon_sym_LBRACK,
    ACTIONS(1629), 1,
      anon_sym_EQ,
    ACTIONS(1691), 1,
      anon_sym_RBRACE,
    STATE(976), 1,
      aux_sym_object_repeat1,
    STATE(978), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(1627), 2,
      anon_sym_LPAREN,
      anon_sym_COLON,
    STATE(1181), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(724), 6,
      anon_sym_export,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [30047] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_COMMA,
    ACTIONS(363), 1,
      anon_sym_DQUOTE,
    ACTIONS(365), 1,
      anon_sym_SQUOTE,
    ACTIONS(720), 1,
      sym_number,
    ACTIONS(1615), 1,
      anon_sym_LBRACK,
    ACTIONS(1629), 1,
      anon_sym_EQ,
    ACTIONS(1631), 1,
      anon_sym_RBRACE,
    STATE(978), 1,
      aux_sym_object_pattern_repeat1,
    STATE(1058), 1,
      aux_sym_object_repeat1,
    ACTIONS(1627), 2,
      anon_sym_LPAREN,
      anon_sym_COLON,
    STATE(1181), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(724), 6,
      anon_sym_export,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [30095] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_COMMA,
    ACTIONS(363), 1,
      anon_sym_DQUOTE,
    ACTIONS(365), 1,
      anon_sym_SQUOTE,
    ACTIONS(674), 1,
      anon_sym_RBRACE,
    ACTIONS(720), 1,
      sym_number,
    ACTIONS(1615), 1,
      anon_sym_LBRACK,
    ACTIONS(1629), 1,
      anon_sym_EQ,
    STATE(978), 1,
      aux_sym_object_pattern_repeat1,
    STATE(1058), 1,
      aux_sym_object_repeat1,
    ACTIONS(1627), 2,
      anon_sym_LPAREN,
      anon_sym_COLON,
    STATE(1181), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(724), 6,
      anon_sym_export,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [30143] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_COMMA,
    ACTIONS(363), 1,
      anon_sym_DQUOTE,
    ACTIONS(365), 1,
      anon_sym_SQUOTE,
    ACTIONS(720), 1,
      sym_number,
    ACTIONS(1615), 1,
      anon_sym_LBRACK,
    ACTIONS(1629), 1,
      anon_sym_EQ,
    ACTIONS(1689), 1,
      anon_sym_RBRACE,
    STATE(978), 1,
      aux_sym_object_pattern_repeat1,
    STATE(1058), 1,
      aux_sym_object_repeat1,
    ACTIONS(1627), 2,
      anon_sym_LPAREN,
      anon_sym_COLON,
    STATE(1181), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(724), 6,
      anon_sym_export,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [30191] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_COMMA,
    ACTIONS(363), 1,
      anon_sym_DQUOTE,
    ACTIONS(365), 1,
      anon_sym_SQUOTE,
    ACTIONS(638), 1,
      anon_sym_RBRACE,
    ACTIONS(720), 1,
      sym_number,
    ACTIONS(1615), 1,
      anon_sym_LBRACK,
    ACTIONS(1629), 1,
      anon_sym_EQ,
    STATE(976), 1,
      aux_sym_object_repeat1,
    STATE(978), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(1627), 2,
      anon_sym_LPAREN,
      anon_sym_COLON,
    STATE(1181), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(724), 6,
      anon_sym_export,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [30239] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(363), 1,
      anon_sym_DQUOTE,
    ACTIONS(365), 1,
      anon_sym_SQUOTE,
    ACTIONS(720), 1,
      sym_number,
    ACTIONS(726), 1,
      anon_sym_async,
    ACTIONS(1615), 1,
      anon_sym_LBRACK,
    ACTIONS(1625), 1,
      anon_sym_STAR,
    ACTIONS(1629), 1,
      anon_sym_EQ,
    ACTIONS(728), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(1627), 2,
      anon_sym_LPAREN,
      anon_sym_COLON,
    ACTIONS(1693), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(724), 3,
      anon_sym_export,
      sym_identifier,
      anon_sym_static,
    STATE(1181), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
  [30286] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(363), 1,
      anon_sym_DQUOTE,
    ACTIONS(365), 1,
      anon_sym_SQUOTE,
    ACTIONS(720), 1,
      sym_number,
    ACTIONS(1615), 1,
      anon_sym_LBRACK,
    ACTIONS(1625), 1,
      anon_sym_STAR,
    ACTIONS(1629), 1,
      anon_sym_EQ,
    ACTIONS(728), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(1627), 2,
      anon_sym_LPAREN,
      anon_sym_COLON,
    ACTIONS(1693), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(1181), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(724), 4,
      anon_sym_export,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
  [30331] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(363), 1,
      anon_sym_DQUOTE,
    ACTIONS(365), 1,
      anon_sym_SQUOTE,
    ACTIONS(720), 1,
      sym_number,
    ACTIONS(1615), 1,
      anon_sym_LBRACK,
    ACTIONS(1625), 1,
      anon_sym_STAR,
    ACTIONS(728), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(1627), 2,
      anon_sym_LPAREN,
      anon_sym_COLON,
    ACTIONS(1696), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(1181), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(724), 4,
      anon_sym_export,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
  [30373] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(75), 1,
      anon_sym_DQUOTE,
    ACTIONS(77), 1,
      anon_sym_SQUOTE,
    ACTIONS(1625), 1,
      anon_sym_STAR,
    ACTIONS(1637), 1,
      anon_sym_LBRACK,
    ACTIONS(1698), 1,
      anon_sym_async,
    ACTIONS(1700), 1,
      sym_number,
    ACTIONS(1702), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(1633), 3,
      anon_sym_export,
      sym_identifier,
      anon_sym_static,
    STATE(849), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1627), 4,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
  [30415] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(576), 1,
      anon_sym_COMMA,
    ACTIONS(580), 1,
      anon_sym_RBRACK,
    ACTIONS(584), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1520), 1,
      anon_sym_LBRACE,
    ACTIONS(1704), 1,
      sym_identifier,
    ACTIONS(1708), 1,
      anon_sym_LBRACK,
    STATE(930), 1,
      sym_pattern,
    STATE(1013), 1,
      aux_sym_array_pattern_repeat1,
    STATE(1026), 1,
      sym_assignment_pattern,
    STATE(895), 4,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
      sym_rest_pattern,
    ACTIONS(1706), 5,
      anon_sym_export,
      anon_sym_async,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [30459] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(363), 1,
      anon_sym_DQUOTE,
    ACTIONS(365), 1,
      anon_sym_SQUOTE,
    ACTIONS(720), 1,
      sym_number,
    ACTIONS(1615), 1,
      anon_sym_LBRACK,
    ACTIONS(1625), 1,
      anon_sym_STAR,
    ACTIONS(728), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1181), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(724), 4,
      anon_sym_export,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
    ACTIONS(1627), 4,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
  [30499] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(576), 1,
      anon_sym_COMMA,
    ACTIONS(584), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1520), 1,
      anon_sym_LBRACE,
    ACTIONS(1704), 1,
      sym_identifier,
    ACTIONS(1708), 1,
      anon_sym_LBRACK,
    ACTIONS(1710), 1,
      anon_sym_RBRACK,
    STATE(914), 1,
      sym_pattern,
    STATE(1033), 1,
      sym_assignment_pattern,
    STATE(1037), 1,
      aux_sym_array_pattern_repeat1,
    STATE(895), 4,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
      sym_rest_pattern,
    ACTIONS(1706), 5,
      anon_sym_export,
      anon_sym_async,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [30543] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(363), 1,
      anon_sym_DQUOTE,
    ACTIONS(365), 1,
      anon_sym_SQUOTE,
    ACTIONS(720), 1,
      sym_number,
    ACTIONS(1615), 1,
      anon_sym_LBRACK,
    ACTIONS(1629), 1,
      anon_sym_EQ,
    ACTIONS(1627), 2,
      anon_sym_LPAREN,
      anon_sym_COLON,
    ACTIONS(1693), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(1181), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(724), 6,
      anon_sym_export,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [30583] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(363), 1,
      anon_sym_DQUOTE,
    ACTIONS(365), 1,
      anon_sym_SQUOTE,
    ACTIONS(1615), 1,
      anon_sym_LBRACK,
    ACTIONS(1712), 1,
      anon_sym_STAR,
    ACTIONS(1714), 1,
      sym_number,
    ACTIONS(1716), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1138), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(724), 4,
      anon_sym_export,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
    ACTIONS(1627), 4,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
  [30623] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_AT,
    ACTIONS(363), 1,
      anon_sym_DQUOTE,
    ACTIONS(365), 1,
      anon_sym_SQUOTE,
    ACTIONS(724), 1,
      sym_identifier,
    ACTIONS(1615), 1,
      anon_sym_LBRACK,
    ACTIONS(1718), 1,
      anon_sym_export,
    ACTIONS(1720), 1,
      anon_sym_STAR,
    ACTIONS(1722), 1,
      anon_sym_class,
    ACTIONS(1724), 1,
      anon_sym_async,
    ACTIONS(1726), 1,
      sym_number,
    ACTIONS(1728), 1,
      anon_sym_static,
    ACTIONS(1730), 1,
      anon_sym_get,
    ACTIONS(1732), 1,
      anon_sym_set,
    STATE(716), 1,
      aux_sym_export_statement_repeat1,
    STATE(750), 1,
      sym_decorator,
    STATE(1166), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
  [30677] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(363), 1,
      anon_sym_DQUOTE,
    ACTIONS(365), 1,
      anon_sym_SQUOTE,
    ACTIONS(720), 1,
      sym_number,
    ACTIONS(726), 1,
      anon_sym_async,
    ACTIONS(1615), 1,
      anon_sym_LBRACK,
    ACTIONS(1625), 1,
      anon_sym_STAR,
    ACTIONS(728), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(1627), 2,
      anon_sym_LPAREN,
      anon_sym_COLON,
    ACTIONS(1696), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(724), 3,
      anon_sym_export,
      sym_identifier,
      anon_sym_static,
    STATE(1181), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
  [30721] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(363), 1,
      anon_sym_DQUOTE,
    ACTIONS(365), 1,
      anon_sym_SQUOTE,
    ACTIONS(720), 1,
      sym_number,
    ACTIONS(1615), 1,
      anon_sym_LBRACK,
    STATE(1181), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1627), 4,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
    ACTIONS(724), 6,
      anon_sym_export,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [30756] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(363), 1,
      anon_sym_DQUOTE,
    ACTIONS(365), 1,
      anon_sym_SQUOTE,
    ACTIONS(1615), 1,
      anon_sym_LBRACK,
    ACTIONS(1714), 1,
      sym_number,
    STATE(1138), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1627), 4,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
    ACTIONS(724), 6,
      anon_sym_export,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [30791] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(584), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1520), 1,
      anon_sym_LBRACE,
    ACTIONS(1704), 1,
      sym_identifier,
    ACTIONS(1708), 1,
      anon_sym_LBRACK,
    STATE(1027), 1,
      sym_pattern,
    STATE(1140), 1,
      sym_assignment_pattern,
    ACTIONS(1734), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    STATE(895), 4,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
      sym_rest_pattern,
    ACTIONS(1706), 5,
      anon_sym_export,
      anon_sym_async,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [30830] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_AT,
    ACTIONS(640), 1,
      anon_sym_var,
    ACTIONS(654), 1,
      anon_sym_class,
    ACTIONS(656), 1,
      anon_sym_async,
    ACTIONS(658), 1,
      anon_sym_function,
    ACTIONS(1627), 1,
      anon_sym_LPAREN,
    ACTIONS(1736), 1,
      anon_sym_default,
    STATE(289), 1,
      sym_declaration,
    STATE(750), 1,
      sym_decorator,
    STATE(922), 1,
      aux_sym_export_statement_repeat1,
    ACTIONS(642), 2,
      anon_sym_let,
      anon_sym_const,
    STATE(275), 5,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
  [30875] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(363), 1,
      anon_sym_DQUOTE,
    ACTIONS(365), 1,
      anon_sym_SQUOTE,
    ACTIONS(720), 1,
      sym_number,
    ACTIONS(1615), 1,
      anon_sym_LBRACK,
    ACTIONS(1627), 2,
      anon_sym_LPAREN,
      anon_sym_COLON,
    ACTIONS(1696), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(1181), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(724), 6,
      anon_sym_export,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [30912] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_AT,
    ACTIONS(363), 1,
      anon_sym_DQUOTE,
    ACTIONS(365), 1,
      anon_sym_SQUOTE,
    ACTIONS(1615), 1,
      anon_sym_LBRACK,
    ACTIONS(1720), 1,
      anon_sym_STAR,
    ACTIONS(1724), 1,
      anon_sym_async,
    ACTIONS(1726), 1,
      sym_number,
    ACTIONS(1728), 1,
      anon_sym_static,
    ACTIONS(1730), 1,
      anon_sym_get,
    ACTIONS(1732), 1,
      anon_sym_set,
    STATE(716), 1,
      aux_sym_export_statement_repeat1,
    STATE(750), 1,
      sym_decorator,
    ACTIONS(724), 2,
      anon_sym_export,
      sym_identifier,
    STATE(1166), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
  [30961] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(584), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1520), 1,
      anon_sym_LBRACE,
    ACTIONS(1704), 1,
      sym_identifier,
    ACTIONS(1708), 1,
      anon_sym_LBRACK,
    ACTIONS(1738), 1,
      anon_sym_RPAREN,
    STATE(991), 1,
      sym_pattern,
    STATE(1180), 1,
      sym_assignment_pattern,
    STATE(895), 4,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
      sym_rest_pattern,
    ACTIONS(1706), 5,
      anon_sym_export,
      anon_sym_async,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [30999] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(584), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(586), 1,
      anon_sym_RPAREN,
    ACTIONS(1520), 1,
      anon_sym_LBRACE,
    ACTIONS(1704), 1,
      sym_identifier,
    ACTIONS(1708), 1,
      anon_sym_LBRACK,
    STATE(921), 1,
      sym_pattern,
    STATE(1030), 1,
      sym_assignment_pattern,
    STATE(895), 4,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
      sym_rest_pattern,
    ACTIONS(1706), 5,
      anon_sym_export,
      anon_sym_async,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [31037] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_AT,
    ACTIONS(640), 1,
      anon_sym_var,
    ACTIONS(696), 1,
      anon_sym_class,
    ACTIONS(698), 1,
      anon_sym_async,
    ACTIONS(700), 1,
      anon_sym_function,
    ACTIONS(1736), 1,
      anon_sym_default,
    STATE(289), 1,
      sym_declaration,
    STATE(750), 1,
      sym_decorator,
    STATE(955), 1,
      aux_sym_export_statement_repeat1,
    ACTIONS(642), 2,
      anon_sym_let,
      anon_sym_const,
    STATE(275), 5,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
  [31079] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1089), 1,
      anon_sym_LPAREN,
    ACTIONS(1744), 1,
      anon_sym_DOT,
    STATE(749), 1,
      sym_arguments,
    ACTIONS(1742), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(1740), 7,
      anon_sym_export,
      anon_sym_class,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [31109] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(584), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1520), 1,
      anon_sym_LBRACE,
    ACTIONS(1704), 1,
      sym_identifier,
    ACTIONS(1708), 1,
      anon_sym_LBRACK,
    ACTIONS(1746), 1,
      anon_sym_RPAREN,
    STATE(991), 1,
      sym_pattern,
    STATE(1180), 1,
      sym_assignment_pattern,
    STATE(895), 4,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
      sym_rest_pattern,
    ACTIONS(1706), 5,
      anon_sym_export,
      anon_sym_async,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [31147] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_AT,
    ACTIONS(640), 1,
      anon_sym_var,
    ACTIONS(654), 1,
      anon_sym_class,
    ACTIONS(656), 1,
      anon_sym_async,
    ACTIONS(658), 1,
      anon_sym_function,
    ACTIONS(1736), 1,
      anon_sym_default,
    STATE(289), 1,
      sym_declaration,
    STATE(750), 1,
      sym_decorator,
    STATE(922), 1,
      aux_sym_export_statement_repeat1,
    ACTIONS(642), 2,
      anon_sym_let,
      anon_sym_const,
    STATE(275), 5,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
  [31189] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1748), 6,
      anon_sym_export,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(1750), 9,
      anon_sym_STAR,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
  [31212] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1752), 6,
      anon_sym_export,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(1754), 9,
      anon_sym_STAR,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
  [31235] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1758), 7,
      anon_sym_STAR,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(1756), 8,
      anon_sym_export,
      anon_sym_DOT,
      anon_sym_class,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [31258] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1760), 6,
      anon_sym_export,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(1762), 9,
      anon_sym_STAR,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
  [31281] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(363), 1,
      anon_sym_DQUOTE,
    ACTIONS(365), 1,
      anon_sym_SQUOTE,
    ACTIONS(1615), 1,
      anon_sym_LBRACK,
    ACTIONS(1627), 1,
      anon_sym_LPAREN,
    ACTIONS(1712), 1,
      anon_sym_STAR,
    ACTIONS(1714), 1,
      sym_number,
    ACTIONS(1716), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1138), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(724), 4,
      anon_sym_export,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
  [31318] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1764), 6,
      anon_sym_export,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(1766), 9,
      anon_sym_STAR,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
  [31341] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1752), 6,
      anon_sym_export,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(1754), 9,
      anon_sym_STAR,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
  [31364] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1752), 6,
      anon_sym_export,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(1754), 9,
      anon_sym_STAR,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
  [31387] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1752), 6,
      anon_sym_export,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(1754), 9,
      anon_sym_STAR,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
  [31410] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(584), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1520), 1,
      anon_sym_LBRACE,
    ACTIONS(1704), 1,
      sym_identifier,
    ACTIONS(1708), 1,
      anon_sym_LBRACK,
    STATE(991), 1,
      sym_pattern,
    STATE(1180), 1,
      sym_assignment_pattern,
    STATE(895), 4,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
      sym_rest_pattern,
    ACTIONS(1706), 5,
      anon_sym_export,
      anon_sym_async,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [31445] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1768), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [31466] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1752), 6,
      anon_sym_export,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(1754), 9,
      anon_sym_STAR,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
  [31489] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1770), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [31510] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(363), 1,
      anon_sym_DQUOTE,
    ACTIONS(365), 1,
      anon_sym_SQUOTE,
    ACTIONS(1615), 1,
      anon_sym_LBRACK,
    ACTIONS(1627), 1,
      anon_sym_LPAREN,
    ACTIONS(1772), 1,
      anon_sym_STAR,
    ACTIONS(1774), 1,
      sym_number,
    ACTIONS(1776), 1,
      anon_sym_get,
    ACTIONS(1778), 1,
      anon_sym_set,
    STATE(1223), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(724), 4,
      anon_sym_export,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
  [31549] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1784), 1,
      anon_sym_AT,
    STATE(716), 1,
      aux_sym_export_statement_repeat1,
    STATE(750), 1,
      sym_decorator,
    ACTIONS(1782), 5,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
    ACTIONS(1780), 7,
      anon_sym_export,
      anon_sym_class,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [31578] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1752), 6,
      anon_sym_export,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(1754), 9,
      anon_sym_STAR,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
  [31601] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1752), 6,
      anon_sym_export,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(1754), 9,
      anon_sym_STAR,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
  [31624] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1787), 6,
      anon_sym_export,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(1789), 9,
      anon_sym_STAR,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
  [31647] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1791), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [31668] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1787), 6,
      anon_sym_export,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(1789), 9,
      anon_sym_STAR,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
  [31691] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1787), 6,
      anon_sym_export,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(1789), 9,
      anon_sym_STAR,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
  [31714] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1793), 6,
      anon_sym_export,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(1795), 9,
      anon_sym_STAR,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
  [31737] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1797), 6,
      anon_sym_export,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(1799), 9,
      anon_sym_STAR,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
  [31760] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(363), 1,
      anon_sym_DQUOTE,
    ACTIONS(365), 1,
      anon_sym_SQUOTE,
    ACTIONS(1615), 1,
      anon_sym_LBRACK,
    ACTIONS(1627), 1,
      anon_sym_LPAREN,
    ACTIONS(1714), 1,
      sym_number,
    ACTIONS(1801), 1,
      anon_sym_EQ_GT,
    STATE(1138), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(724), 6,
      anon_sym_export,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [31795] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1748), 6,
      anon_sym_export,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(1750), 9,
      anon_sym_STAR,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
  [31818] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1803), 6,
      anon_sym_export,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(1805), 9,
      anon_sym_STAR,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
  [31841] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(363), 1,
      anon_sym_DQUOTE,
    ACTIONS(365), 1,
      anon_sym_SQUOTE,
    ACTIONS(1615), 1,
      anon_sym_LBRACK,
    ACTIONS(1627), 1,
      anon_sym_LPAREN,
    ACTIONS(1807), 1,
      anon_sym_STAR,
    ACTIONS(1809), 1,
      anon_sym_async,
    ACTIONS(1811), 1,
      sym_number,
    ACTIONS(1813), 1,
      anon_sym_get,
    ACTIONS(1815), 1,
      anon_sym_set,
    ACTIONS(724), 3,
      anon_sym_export,
      sym_identifier,
      anon_sym_static,
    STATE(1148), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
  [31882] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1787), 6,
      anon_sym_export,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(1789), 9,
      anon_sym_STAR,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
  [31905] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(363), 1,
      anon_sym_DQUOTE,
    ACTIONS(365), 1,
      anon_sym_SQUOTE,
    ACTIONS(1615), 1,
      anon_sym_LBRACK,
    ACTIONS(1627), 1,
      anon_sym_LPAREN,
    ACTIONS(1817), 1,
      anon_sym_STAR,
    ACTIONS(1819), 1,
      sym_number,
    ACTIONS(1821), 1,
      anon_sym_get,
    ACTIONS(1823), 1,
      anon_sym_set,
    STATE(1145), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(724), 4,
      anon_sym_export,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
  [31944] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1787), 6,
      anon_sym_export,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(1789), 9,
      anon_sym_STAR,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
  [31967] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1748), 6,
      anon_sym_export,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(1750), 9,
      anon_sym_STAR,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
  [31990] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(363), 1,
      anon_sym_DQUOTE,
    ACTIONS(365), 1,
      anon_sym_SQUOTE,
    ACTIONS(1615), 1,
      anon_sym_LBRACK,
    ACTIONS(1627), 1,
      anon_sym_LPAREN,
    ACTIONS(1825), 1,
      sym_number,
    STATE(1219), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(724), 6,
      anon_sym_export,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [32022] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(363), 1,
      anon_sym_DQUOTE,
    ACTIONS(365), 1,
      anon_sym_SQUOTE,
    ACTIONS(1615), 1,
      anon_sym_LBRACK,
    ACTIONS(1627), 1,
      anon_sym_LPAREN,
    ACTIONS(1827), 1,
      sym_number,
    STATE(1250), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(724), 6,
      anon_sym_export,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [32054] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(584), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1520), 1,
      anon_sym_LBRACE,
    ACTIONS(1704), 1,
      sym_identifier,
    ACTIONS(1708), 1,
      anon_sym_LBRACK,
    STATE(1142), 1,
      sym_pattern,
    STATE(895), 4,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
      sym_rest_pattern,
    ACTIONS(1706), 5,
      anon_sym_export,
      anon_sym_async,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [32086] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(363), 1,
      anon_sym_DQUOTE,
    ACTIONS(365), 1,
      anon_sym_SQUOTE,
    ACTIONS(1615), 1,
      anon_sym_LBRACK,
    ACTIONS(1627), 1,
      anon_sym_LPAREN,
    ACTIONS(1714), 1,
      sym_number,
    STATE(1138), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(724), 6,
      anon_sym_export,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [32118] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(363), 1,
      anon_sym_DQUOTE,
    ACTIONS(365), 1,
      anon_sym_SQUOTE,
    ACTIONS(1615), 1,
      anon_sym_LBRACK,
    ACTIONS(1627), 1,
      anon_sym_LPAREN,
    ACTIONS(1829), 1,
      sym_number,
    STATE(1232), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(724), 6,
      anon_sym_export,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [32150] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(363), 1,
      anon_sym_DQUOTE,
    ACTIONS(365), 1,
      anon_sym_SQUOTE,
    ACTIONS(1615), 1,
      anon_sym_LBRACK,
    ACTIONS(1627), 1,
      anon_sym_LPAREN,
    ACTIONS(1831), 1,
      sym_number,
    STATE(1149), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(724), 6,
      anon_sym_export,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [32182] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(363), 1,
      anon_sym_DQUOTE,
    ACTIONS(365), 1,
      anon_sym_SQUOTE,
    ACTIONS(1615), 1,
      anon_sym_LBRACK,
    ACTIONS(1627), 1,
      anon_sym_LPAREN,
    ACTIONS(1833), 1,
      sym_number,
    STATE(1131), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(724), 6,
      anon_sym_export,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [32214] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(363), 1,
      anon_sym_DQUOTE,
    ACTIONS(365), 1,
      anon_sym_SQUOTE,
    ACTIONS(1615), 1,
      anon_sym_LBRACK,
    ACTIONS(1627), 1,
      anon_sym_LPAREN,
    ACTIONS(1835), 1,
      sym_number,
    STATE(1129), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(724), 6,
      anon_sym_export,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [32246] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(363), 1,
      anon_sym_DQUOTE,
    ACTIONS(365), 1,
      anon_sym_SQUOTE,
    ACTIONS(1615), 1,
      anon_sym_LBRACK,
    ACTIONS(1627), 1,
      anon_sym_LPAREN,
    ACTIONS(1837), 1,
      sym_number,
    STATE(1221), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(724), 6,
      anon_sym_export,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [32278] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(363), 1,
      anon_sym_DQUOTE,
    ACTIONS(365), 1,
      anon_sym_SQUOTE,
    ACTIONS(1615), 1,
      anon_sym_LBRACK,
    ACTIONS(1627), 1,
      anon_sym_LPAREN,
    ACTIONS(1839), 1,
      sym_number,
    STATE(1228), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(724), 6,
      anon_sym_export,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [32310] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(363), 1,
      anon_sym_DQUOTE,
    ACTIONS(365), 1,
      anon_sym_SQUOTE,
    ACTIONS(1615), 1,
      anon_sym_LBRACK,
    ACTIONS(1627), 1,
      anon_sym_LPAREN,
    ACTIONS(1841), 1,
      sym_number,
    STATE(1150), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(724), 6,
      anon_sym_export,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [32342] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1847), 1,
      anon_sym_SEMI,
    ACTIONS(1843), 6,
      anon_sym_export,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(1845), 7,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
  [32366] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(363), 1,
      anon_sym_DQUOTE,
    ACTIONS(365), 1,
      anon_sym_SQUOTE,
    ACTIONS(1615), 1,
      anon_sym_LBRACK,
    ACTIONS(1827), 1,
      sym_number,
    STATE(1250), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(724), 6,
      anon_sym_export,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [32395] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(363), 1,
      anon_sym_DQUOTE,
    ACTIONS(365), 1,
      anon_sym_SQUOTE,
    ACTIONS(1615), 1,
      anon_sym_LBRACK,
    ACTIONS(1849), 1,
      sym_number,
    STATE(1134), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(724), 6,
      anon_sym_export,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [32424] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(363), 1,
      anon_sym_DQUOTE,
    ACTIONS(365), 1,
      anon_sym_SQUOTE,
    ACTIONS(1615), 1,
      anon_sym_LBRACK,
    ACTIONS(1851), 1,
      sym_number,
    STATE(1144), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(724), 6,
      anon_sym_export,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [32453] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1853), 6,
      anon_sym_export,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(1855), 7,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
  [32474] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1859), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(1857), 7,
      anon_sym_export,
      anon_sym_class,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [32495] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1863), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(1861), 7,
      anon_sym_export,
      anon_sym_class,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [32516] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(363), 1,
      anon_sym_DQUOTE,
    ACTIONS(365), 1,
      anon_sym_SQUOTE,
    ACTIONS(1615), 1,
      anon_sym_LBRACK,
    ACTIONS(1865), 1,
      sym_number,
    STATE(1242), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(724), 6,
      anon_sym_export,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [32545] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(363), 1,
      anon_sym_DQUOTE,
    ACTIONS(365), 1,
      anon_sym_SQUOTE,
    ACTIONS(1615), 1,
      anon_sym_LBRACK,
    ACTIONS(1867), 1,
      sym_number,
    STATE(1225), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(724), 6,
      anon_sym_export,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [32574] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1742), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(1740), 7,
      anon_sym_export,
      anon_sym_class,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [32595] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(363), 1,
      anon_sym_DQUOTE,
    ACTIONS(365), 1,
      anon_sym_SQUOTE,
    ACTIONS(1615), 1,
      anon_sym_LBRACK,
    ACTIONS(1714), 1,
      sym_number,
    STATE(1138), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(724), 6,
      anon_sym_export,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [32624] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(363), 1,
      anon_sym_DQUOTE,
    ACTIONS(365), 1,
      anon_sym_SQUOTE,
    ACTIONS(720), 1,
      sym_number,
    ACTIONS(1615), 1,
      anon_sym_LBRACK,
    STATE(1181), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(724), 6,
      anon_sym_export,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [32653] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1869), 1,
      sym_identifier,
    ACTIONS(1871), 1,
      anon_sym_LBRACE,
    ACTIONS(1873), 1,
      anon_sym_COLON,
    ACTIONS(1875), 1,
      anon_sym_GT,
    ACTIONS(1877), 1,
      anon_sym_SLASH,
    ACTIONS(1879), 1,
      sym_jsx_identifier,
    ACTIONS(1881), 1,
      anon_sym_DOT,
    STATE(805), 1,
      aux_sym_jsx_opening_element_repeat1,
    STATE(851), 1,
      sym_jsx_namespace_name,
    STATE(900), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [32688] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1869), 1,
      sym_identifier,
    ACTIONS(1871), 1,
      anon_sym_LBRACE,
    ACTIONS(1873), 1,
      anon_sym_COLON,
    ACTIONS(1875), 1,
      anon_sym_GT,
    ACTIONS(1879), 1,
      sym_jsx_identifier,
    ACTIONS(1881), 1,
      anon_sym_DOT,
    ACTIONS(1883), 1,
      anon_sym_SLASH,
    STATE(784), 1,
      aux_sym_jsx_opening_element_repeat1,
    STATE(851), 1,
      sym_jsx_namespace_name,
    STATE(900), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [32723] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1869), 1,
      sym_identifier,
    ACTIONS(1871), 1,
      anon_sym_LBRACE,
    ACTIONS(1873), 1,
      anon_sym_COLON,
    ACTIONS(1875), 1,
      anon_sym_GT,
    ACTIONS(1879), 1,
      sym_jsx_identifier,
    ACTIONS(1881), 1,
      anon_sym_DOT,
    ACTIONS(1885), 1,
      anon_sym_SLASH,
    STATE(804), 1,
      aux_sym_jsx_opening_element_repeat1,
    STATE(851), 1,
      sym_jsx_namespace_name,
    STATE(900), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [32758] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1869), 1,
      sym_identifier,
    ACTIONS(1871), 1,
      anon_sym_LBRACE,
    ACTIONS(1873), 1,
      anon_sym_COLON,
    ACTIONS(1875), 1,
      anon_sym_GT,
    ACTIONS(1879), 1,
      sym_jsx_identifier,
    ACTIONS(1881), 1,
      anon_sym_DOT,
    ACTIONS(1887), 1,
      anon_sym_SLASH,
    STATE(796), 1,
      aux_sym_jsx_opening_element_repeat1,
    STATE(851), 1,
      sym_jsx_namespace_name,
    STATE(900), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [32793] = 7,
    ACTIONS(1889), 1,
      anon_sym_LBRACE,
    ACTIONS(1891), 1,
      anon_sym_LT,
    ACTIONS(1893), 1,
      sym_jsx_text,
    ACTIONS(1895), 1,
      sym_comment,
    STATE(452), 1,
      sym_jsx_closing_element,
    STATE(765), 1,
      sym_jsx_opening_element,
    STATE(786), 5,
      sym_jsx_element,
      sym_jsx_fragment,
      sym_jsx_expression,
      sym_jsx_self_closing_element,
      aux_sym_jsx_element_repeat1,
  [32819] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1869), 1,
      sym_identifier,
    ACTIONS(1871), 1,
      anon_sym_LBRACE,
    ACTIONS(1873), 1,
      anon_sym_COLON,
    ACTIONS(1875), 1,
      anon_sym_GT,
    ACTIONS(1877), 1,
      anon_sym_SLASH,
    ACTIONS(1879), 1,
      sym_jsx_identifier,
    STATE(803), 1,
      aux_sym_jsx_opening_element_repeat1,
    STATE(851), 1,
      sym_jsx_namespace_name,
    STATE(900), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [32851] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1869), 1,
      sym_identifier,
    ACTIONS(1871), 1,
      anon_sym_LBRACE,
    ACTIONS(1873), 1,
      anon_sym_COLON,
    ACTIONS(1875), 1,
      anon_sym_GT,
    ACTIONS(1879), 1,
      sym_jsx_identifier,
    ACTIONS(1885), 1,
      anon_sym_SLASH,
    STATE(806), 1,
      aux_sym_jsx_opening_element_repeat1,
    STATE(851), 1,
      sym_jsx_namespace_name,
    STATE(900), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [32883] = 7,
    ACTIONS(1889), 1,
      anon_sym_LBRACE,
    ACTIONS(1893), 1,
      sym_jsx_text,
    ACTIONS(1895), 1,
      sym_comment,
    ACTIONS(1897), 1,
      anon_sym_LT,
    STATE(580), 1,
      sym_jsx_closing_element,
    STATE(765), 1,
      sym_jsx_opening_element,
    STATE(786), 5,
      sym_jsx_element,
      sym_jsx_fragment,
      sym_jsx_expression,
      sym_jsx_self_closing_element,
      aux_sym_jsx_element_repeat1,
  [32909] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1869), 1,
      sym_identifier,
    ACTIONS(1871), 1,
      anon_sym_LBRACE,
    ACTIONS(1875), 1,
      anon_sym_GT,
    ACTIONS(1879), 1,
      sym_jsx_identifier,
    ACTIONS(1881), 1,
      anon_sym_DOT,
    ACTIONS(1885), 1,
      anon_sym_SLASH,
    STATE(794), 1,
      aux_sym_jsx_opening_element_repeat1,
    STATE(851), 1,
      sym_jsx_namespace_name,
    STATE(900), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [32941] = 7,
    ACTIONS(1889), 1,
      anon_sym_LBRACE,
    ACTIONS(1895), 1,
      sym_comment,
    ACTIONS(1899), 1,
      anon_sym_LT,
    ACTIONS(1901), 1,
      sym_jsx_text,
    STATE(765), 1,
      sym_jsx_opening_element,
    STATE(988), 1,
      sym_jsx_closing_element,
    STATE(773), 5,
      sym_jsx_element,
      sym_jsx_fragment,
      sym_jsx_expression,
      sym_jsx_self_closing_element,
      aux_sym_jsx_element_repeat1,
  [32967] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1871), 1,
      anon_sym_LBRACE,
    ACTIONS(1903), 1,
      anon_sym_LT,
    ACTIONS(1905), 1,
      anon_sym_DQUOTE,
    ACTIONS(1907), 1,
      anon_sym_SQUOTE,
    STATE(767), 1,
      sym_jsx_opening_element,
    STATE(897), 5,
      sym_jsx_element,
      sym_jsx_fragment,
      sym_jsx_expression,
      sym_jsx_self_closing_element,
      sym_string,
  [32993] = 7,
    ACTIONS(1889), 1,
      anon_sym_LBRACE,
    ACTIONS(1895), 1,
      sym_comment,
    ACTIONS(1909), 1,
      anon_sym_LT,
    ACTIONS(1911), 1,
      sym_jsx_text,
    STATE(765), 1,
      sym_jsx_opening_element,
    STATE(902), 1,
      sym_jsx_closing_element,
    STATE(770), 5,
      sym_jsx_element,
      sym_jsx_fragment,
      sym_jsx_expression,
      sym_jsx_self_closing_element,
      aux_sym_jsx_element_repeat1,
  [33019] = 7,
    ACTIONS(1889), 1,
      anon_sym_LBRACE,
    ACTIONS(1891), 1,
      anon_sym_LT,
    ACTIONS(1895), 1,
      sym_comment,
    ACTIONS(1913), 1,
      sym_jsx_text,
    STATE(455), 1,
      sym_jsx_closing_element,
    STATE(765), 1,
      sym_jsx_opening_element,
    STATE(760), 5,
      sym_jsx_element,
      sym_jsx_fragment,
      sym_jsx_expression,
      sym_jsx_self_closing_element,
      aux_sym_jsx_element_repeat1,
  [33045] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1869), 1,
      sym_identifier,
    ACTIONS(1871), 1,
      anon_sym_LBRACE,
    ACTIONS(1873), 1,
      anon_sym_COLON,
    ACTIONS(1875), 1,
      anon_sym_GT,
    ACTIONS(1879), 1,
      sym_jsx_identifier,
    ACTIONS(1883), 1,
      anon_sym_SLASH,
    STATE(783), 1,
      aux_sym_jsx_opening_element_repeat1,
    STATE(851), 1,
      sym_jsx_namespace_name,
    STATE(900), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [33077] = 7,
    ACTIONS(1889), 1,
      anon_sym_LBRACE,
    ACTIONS(1893), 1,
      sym_jsx_text,
    ACTIONS(1895), 1,
      sym_comment,
    ACTIONS(1909), 1,
      anon_sym_LT,
    STATE(765), 1,
      sym_jsx_opening_element,
    STATE(869), 1,
      sym_jsx_closing_element,
    STATE(786), 5,
      sym_jsx_element,
      sym_jsx_fragment,
      sym_jsx_expression,
      sym_jsx_self_closing_element,
      aux_sym_jsx_element_repeat1,
  [33103] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1869), 1,
      sym_identifier,
    ACTIONS(1871), 1,
      anon_sym_LBRACE,
    ACTIONS(1875), 1,
      anon_sym_GT,
    ACTIONS(1877), 1,
      anon_sym_SLASH,
    ACTIONS(1879), 1,
      sym_jsx_identifier,
    ACTIONS(1881), 1,
      anon_sym_DOT,
    STATE(807), 1,
      aux_sym_jsx_opening_element_repeat1,
    STATE(851), 1,
      sym_jsx_namespace_name,
    STATE(900), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [33135] = 7,
    ACTIONS(1889), 1,
      anon_sym_LBRACE,
    ACTIONS(1895), 1,
      sym_comment,
    ACTIONS(1897), 1,
      anon_sym_LT,
    ACTIONS(1915), 1,
      sym_jsx_text,
    STATE(566), 1,
      sym_jsx_closing_element,
    STATE(765), 1,
      sym_jsx_opening_element,
    STATE(763), 5,
      sym_jsx_element,
      sym_jsx_fragment,
      sym_jsx_expression,
      sym_jsx_self_closing_element,
      aux_sym_jsx_element_repeat1,
  [33161] = 7,
    ACTIONS(1889), 1,
      anon_sym_LBRACE,
    ACTIONS(1893), 1,
      sym_jsx_text,
    ACTIONS(1895), 1,
      sym_comment,
    ACTIONS(1899), 1,
      anon_sym_LT,
    STATE(765), 1,
      sym_jsx_opening_element,
    STATE(983), 1,
      sym_jsx_closing_element,
    STATE(786), 5,
      sym_jsx_element,
      sym_jsx_fragment,
      sym_jsx_expression,
      sym_jsx_self_closing_element,
      aux_sym_jsx_element_repeat1,
  [33187] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1871), 1,
      anon_sym_LBRACE,
    ACTIONS(1903), 1,
      anon_sym_LT,
    ACTIONS(1905), 1,
      anon_sym_DQUOTE,
    ACTIONS(1907), 1,
      anon_sym_SQUOTE,
    STATE(767), 1,
      sym_jsx_opening_element,
    STATE(898), 5,
      sym_jsx_element,
      sym_jsx_fragment,
      sym_jsx_expression,
      sym_jsx_self_closing_element,
      sym_string,
  [33213] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1869), 1,
      sym_identifier,
    ACTIONS(1871), 1,
      anon_sym_LBRACE,
    ACTIONS(1873), 1,
      anon_sym_COLON,
    ACTIONS(1875), 1,
      anon_sym_GT,
    ACTIONS(1879), 1,
      sym_jsx_identifier,
    ACTIONS(1887), 1,
      anon_sym_SLASH,
    STATE(779), 1,
      aux_sym_jsx_opening_element_repeat1,
    STATE(851), 1,
      sym_jsx_namespace_name,
    STATE(900), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [33245] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1869), 1,
      sym_identifier,
    ACTIONS(1871), 1,
      anon_sym_LBRACE,
    ACTIONS(1875), 1,
      anon_sym_GT,
    ACTIONS(1879), 1,
      sym_jsx_identifier,
    ACTIONS(1881), 1,
      anon_sym_DOT,
    ACTIONS(1887), 1,
      anon_sym_SLASH,
    STATE(795), 1,
      aux_sym_jsx_opening_element_repeat1,
    STATE(851), 1,
      sym_jsx_namespace_name,
    STATE(900), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [33277] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1869), 1,
      sym_identifier,
    ACTIONS(1871), 1,
      anon_sym_LBRACE,
    ACTIONS(1875), 1,
      anon_sym_GT,
    ACTIONS(1879), 1,
      sym_jsx_identifier,
    ACTIONS(1881), 1,
      anon_sym_DOT,
    ACTIONS(1883), 1,
      anon_sym_SLASH,
    STATE(785), 1,
      aux_sym_jsx_opening_element_repeat1,
    STATE(851), 1,
      sym_jsx_namespace_name,
    STATE(900), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [33309] = 6,
    ACTIONS(1889), 1,
      anon_sym_LBRACE,
    ACTIONS(1895), 1,
      sym_comment,
    ACTIONS(1917), 1,
      anon_sym_LT,
    ACTIONS(1919), 1,
      sym_jsx_text,
    STATE(765), 1,
      sym_jsx_opening_element,
    STATE(797), 5,
      sym_jsx_element,
      sym_jsx_fragment,
      sym_jsx_expression,
      sym_jsx_self_closing_element,
      aux_sym_jsx_element_repeat1,
  [33332] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1869), 1,
      sym_identifier,
    ACTIONS(1871), 1,
      anon_sym_LBRACE,
    ACTIONS(1879), 1,
      sym_jsx_identifier,
    ACTIONS(1921), 1,
      anon_sym_GT,
    ACTIONS(1923), 1,
      anon_sym_SLASH,
    STATE(787), 1,
      aux_sym_jsx_opening_element_repeat1,
    STATE(851), 1,
      sym_jsx_namespace_name,
    STATE(900), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [33361] = 6,
    ACTIONS(1889), 1,
      anon_sym_LBRACE,
    ACTIONS(1893), 1,
      sym_jsx_text,
    ACTIONS(1895), 1,
      sym_comment,
    ACTIONS(1925), 1,
      anon_sym_LT,
    STATE(765), 1,
      sym_jsx_opening_element,
    STATE(786), 5,
      sym_jsx_element,
      sym_jsx_fragment,
      sym_jsx_expression,
      sym_jsx_self_closing_element,
      aux_sym_jsx_element_repeat1,
  [33384] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1869), 1,
      sym_identifier,
    ACTIONS(1871), 1,
      anon_sym_LBRACE,
    ACTIONS(1875), 1,
      anon_sym_GT,
    ACTIONS(1877), 1,
      anon_sym_SLASH,
    ACTIONS(1879), 1,
      sym_jsx_identifier,
    STATE(799), 1,
      aux_sym_jsx_opening_element_repeat1,
    STATE(851), 1,
      sym_jsx_namespace_name,
    STATE(900), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [33413] = 6,
    ACTIONS(1889), 1,
      anon_sym_LBRACE,
    ACTIONS(1893), 1,
      sym_jsx_text,
    ACTIONS(1895), 1,
      sym_comment,
    ACTIONS(1927), 1,
      anon_sym_LT,
    STATE(765), 1,
      sym_jsx_opening_element,
    STATE(786), 5,
      sym_jsx_element,
      sym_jsx_fragment,
      sym_jsx_expression,
      sym_jsx_self_closing_element,
      aux_sym_jsx_element_repeat1,
  [33436] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1869), 1,
      sym_identifier,
    ACTIONS(1871), 1,
      anon_sym_LBRACE,
    ACTIONS(1879), 1,
      sym_jsx_identifier,
    ACTIONS(1921), 1,
      anon_sym_GT,
    ACTIONS(1929), 1,
      anon_sym_SLASH,
    STATE(787), 1,
      aux_sym_jsx_opening_element_repeat1,
    STATE(851), 1,
      sym_jsx_namespace_name,
    STATE(900), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [33465] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1869), 1,
      sym_identifier,
    ACTIONS(1871), 1,
      anon_sym_LBRACE,
    ACTIONS(1879), 1,
      sym_jsx_identifier,
    ACTIONS(1931), 1,
      anon_sym_GT,
    ACTIONS(1933), 1,
      anon_sym_SLASH,
    STATE(787), 1,
      aux_sym_jsx_opening_element_repeat1,
    STATE(851), 1,
      sym_jsx_namespace_name,
    STATE(900), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [33494] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1869), 1,
      sym_identifier,
    ACTIONS(1871), 1,
      anon_sym_LBRACE,
    ACTIONS(1879), 1,
      sym_jsx_identifier,
    ACTIONS(1935), 1,
      anon_sym_GT,
    ACTIONS(1937), 1,
      anon_sym_SLASH,
    STATE(787), 1,
      aux_sym_jsx_opening_element_repeat1,
    STATE(851), 1,
      sym_jsx_namespace_name,
    STATE(900), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [33523] = 6,
    ACTIONS(1895), 1,
      sym_comment,
    ACTIONS(1939), 1,
      anon_sym_LBRACE,
    ACTIONS(1942), 1,
      anon_sym_LT,
    ACTIONS(1945), 1,
      sym_jsx_text,
    STATE(765), 1,
      sym_jsx_opening_element,
    STATE(786), 5,
      sym_jsx_element,
      sym_jsx_fragment,
      sym_jsx_expression,
      sym_jsx_self_closing_element,
      aux_sym_jsx_element_repeat1,
  [33546] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1948), 1,
      sym_identifier,
    ACTIONS(1951), 1,
      anon_sym_LBRACE,
    ACTIONS(1954), 1,
      anon_sym_GT,
    ACTIONS(1956), 1,
      anon_sym_SLASH,
    ACTIONS(1958), 1,
      sym_jsx_identifier,
    STATE(787), 1,
      aux_sym_jsx_opening_element_repeat1,
    STATE(851), 1,
      sym_jsx_namespace_name,
    STATE(900), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [33575] = 6,
    ACTIONS(1889), 1,
      anon_sym_LBRACE,
    ACTIONS(1895), 1,
      sym_comment,
    ACTIONS(1961), 1,
      anon_sym_LT,
    ACTIONS(1963), 1,
      sym_jsx_text,
    STATE(765), 1,
      sym_jsx_opening_element,
    STATE(780), 5,
      sym_jsx_element,
      sym_jsx_fragment,
      sym_jsx_expression,
      sym_jsx_self_closing_element,
      aux_sym_jsx_element_repeat1,
  [33598] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1869), 1,
      sym_identifier,
    ACTIONS(1871), 1,
      anon_sym_LBRACE,
    ACTIONS(1879), 1,
      sym_jsx_identifier,
    ACTIONS(1965), 1,
      anon_sym_GT,
    ACTIONS(1967), 1,
      anon_sym_SLASH,
    STATE(787), 1,
      aux_sym_jsx_opening_element_repeat1,
    STATE(851), 1,
      sym_jsx_namespace_name,
    STATE(900), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [33627] = 6,
    ACTIONS(1889), 1,
      anon_sym_LBRACE,
    ACTIONS(1893), 1,
      sym_jsx_text,
    ACTIONS(1895), 1,
      sym_comment,
    ACTIONS(1969), 1,
      anon_sym_LT,
    STATE(765), 1,
      sym_jsx_opening_element,
    STATE(786), 5,
      sym_jsx_element,
      sym_jsx_fragment,
      sym_jsx_expression,
      sym_jsx_self_closing_element,
      aux_sym_jsx_element_repeat1,
  [33650] = 6,
    ACTIONS(1889), 1,
      anon_sym_LBRACE,
    ACTIONS(1895), 1,
      sym_comment,
    ACTIONS(1971), 1,
      anon_sym_LT,
    ACTIONS(1973), 1,
      sym_jsx_text,
    STATE(765), 1,
      sym_jsx_opening_element,
    STATE(790), 5,
      sym_jsx_element,
      sym_jsx_fragment,
      sym_jsx_expression,
      sym_jsx_self_closing_element,
      aux_sym_jsx_element_repeat1,
  [33673] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1869), 1,
      sym_identifier,
    ACTIONS(1871), 1,
      anon_sym_LBRACE,
    ACTIONS(1879), 1,
      sym_jsx_identifier,
    ACTIONS(1965), 1,
      anon_sym_GT,
    ACTIONS(1975), 1,
      anon_sym_SLASH,
    STATE(787), 1,
      aux_sym_jsx_opening_element_repeat1,
    STATE(851), 1,
      sym_jsx_namespace_name,
    STATE(900), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [33702] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1869), 1,
      sym_identifier,
    ACTIONS(1871), 1,
      anon_sym_LBRACE,
    ACTIONS(1879), 1,
      sym_jsx_identifier,
    ACTIONS(1965), 1,
      anon_sym_GT,
    ACTIONS(1977), 1,
      anon_sym_SLASH,
    STATE(787), 1,
      aux_sym_jsx_opening_element_repeat1,
    STATE(851), 1,
      sym_jsx_namespace_name,
    STATE(900), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [33731] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1869), 1,
      sym_identifier,
    ACTIONS(1871), 1,
      anon_sym_LBRACE,
    ACTIONS(1879), 1,
      sym_jsx_identifier,
    ACTIONS(1935), 1,
      anon_sym_GT,
    ACTIONS(1979), 1,
      anon_sym_SLASH,
    STATE(787), 1,
      aux_sym_jsx_opening_element_repeat1,
    STATE(851), 1,
      sym_jsx_namespace_name,
    STATE(900), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [33760] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1869), 1,
      sym_identifier,
    ACTIONS(1871), 1,
      anon_sym_LBRACE,
    ACTIONS(1879), 1,
      sym_jsx_identifier,
    ACTIONS(1935), 1,
      anon_sym_GT,
    ACTIONS(1981), 1,
      anon_sym_SLASH,
    STATE(787), 1,
      aux_sym_jsx_opening_element_repeat1,
    STATE(851), 1,
      sym_jsx_namespace_name,
    STATE(900), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [33789] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1869), 1,
      sym_identifier,
    ACTIONS(1871), 1,
      anon_sym_LBRACE,
    ACTIONS(1879), 1,
      sym_jsx_identifier,
    ACTIONS(1931), 1,
      anon_sym_GT,
    ACTIONS(1983), 1,
      anon_sym_SLASH,
    STATE(787), 1,
      aux_sym_jsx_opening_element_repeat1,
    STATE(851), 1,
      sym_jsx_namespace_name,
    STATE(900), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [33818] = 6,
    ACTIONS(1889), 1,
      anon_sym_LBRACE,
    ACTIONS(1893), 1,
      sym_jsx_text,
    ACTIONS(1895), 1,
      sym_comment,
    ACTIONS(1985), 1,
      anon_sym_LT,
    STATE(765), 1,
      sym_jsx_opening_element,
    STATE(786), 5,
      sym_jsx_element,
      sym_jsx_fragment,
      sym_jsx_expression,
      sym_jsx_self_closing_element,
      aux_sym_jsx_element_repeat1,
  [33841] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1869), 1,
      sym_identifier,
    ACTIONS(1871), 1,
      anon_sym_LBRACE,
    ACTIONS(1875), 1,
      anon_sym_GT,
    ACTIONS(1879), 1,
      sym_jsx_identifier,
    ACTIONS(1887), 1,
      anon_sym_SLASH,
    STATE(793), 1,
      aux_sym_jsx_opening_element_repeat1,
    STATE(851), 1,
      sym_jsx_namespace_name,
    STATE(900), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [33870] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1869), 1,
      sym_identifier,
    ACTIONS(1871), 1,
      anon_sym_LBRACE,
    ACTIONS(1879), 1,
      sym_jsx_identifier,
    ACTIONS(1965), 1,
      anon_sym_GT,
    ACTIONS(1987), 1,
      anon_sym_SLASH,
    STATE(787), 1,
      aux_sym_jsx_opening_element_repeat1,
    STATE(851), 1,
      sym_jsx_namespace_name,
    STATE(900), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [33899] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1869), 1,
      sym_identifier,
    ACTIONS(1871), 1,
      anon_sym_LBRACE,
    ACTIONS(1875), 1,
      anon_sym_GT,
    ACTIONS(1879), 1,
      sym_jsx_identifier,
    ACTIONS(1883), 1,
      anon_sym_SLASH,
    STATE(789), 1,
      aux_sym_jsx_opening_element_repeat1,
    STATE(851), 1,
      sym_jsx_namespace_name,
    STATE(900), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [33928] = 6,
    ACTIONS(1889), 1,
      anon_sym_LBRACE,
    ACTIONS(1895), 1,
      sym_comment,
    ACTIONS(1989), 1,
      anon_sym_LT,
    ACTIONS(1991), 1,
      sym_jsx_text,
    STATE(765), 1,
      sym_jsx_opening_element,
    STATE(782), 5,
      sym_jsx_element,
      sym_jsx_fragment,
      sym_jsx_expression,
      sym_jsx_self_closing_element,
      aux_sym_jsx_element_repeat1,
  [33951] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1869), 1,
      sym_identifier,
    ACTIONS(1871), 1,
      anon_sym_LBRACE,
    ACTIONS(1875), 1,
      anon_sym_GT,
    ACTIONS(1879), 1,
      sym_jsx_identifier,
    ACTIONS(1885), 1,
      anon_sym_SLASH,
    STATE(792), 1,
      aux_sym_jsx_opening_element_repeat1,
    STATE(851), 1,
      sym_jsx_namespace_name,
    STATE(900), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [33980] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1869), 1,
      sym_identifier,
    ACTIONS(1871), 1,
      anon_sym_LBRACE,
    ACTIONS(1879), 1,
      sym_jsx_identifier,
    ACTIONS(1921), 1,
      anon_sym_GT,
    ACTIONS(1993), 1,
      anon_sym_SLASH,
    STATE(787), 1,
      aux_sym_jsx_opening_element_repeat1,
    STATE(851), 1,
      sym_jsx_namespace_name,
    STATE(900), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [34009] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1869), 1,
      sym_identifier,
    ACTIONS(1871), 1,
      anon_sym_LBRACE,
    ACTIONS(1879), 1,
      sym_jsx_identifier,
    ACTIONS(1931), 1,
      anon_sym_GT,
    ACTIONS(1995), 1,
      anon_sym_SLASH,
    STATE(787), 1,
      aux_sym_jsx_opening_element_repeat1,
    STATE(851), 1,
      sym_jsx_namespace_name,
    STATE(900), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [34038] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1869), 1,
      sym_identifier,
    ACTIONS(1871), 1,
      anon_sym_LBRACE,
    ACTIONS(1879), 1,
      sym_jsx_identifier,
    ACTIONS(1931), 1,
      anon_sym_GT,
    ACTIONS(1997), 1,
      anon_sym_SLASH,
    STATE(787), 1,
      aux_sym_jsx_opening_element_repeat1,
    STATE(851), 1,
      sym_jsx_namespace_name,
    STATE(900), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [34067] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1869), 1,
      sym_identifier,
    ACTIONS(1871), 1,
      anon_sym_LBRACE,
    ACTIONS(1879), 1,
      sym_jsx_identifier,
    ACTIONS(1921), 1,
      anon_sym_GT,
    ACTIONS(1999), 1,
      anon_sym_SLASH,
    STATE(787), 1,
      aux_sym_jsx_opening_element_repeat1,
    STATE(851), 1,
      sym_jsx_namespace_name,
    STATE(900), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [34096] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1869), 1,
      sym_identifier,
    ACTIONS(1871), 1,
      anon_sym_LBRACE,
    ACTIONS(1879), 1,
      sym_jsx_identifier,
    ACTIONS(1935), 1,
      anon_sym_GT,
    ACTIONS(2001), 1,
      anon_sym_SLASH,
    STATE(787), 1,
      aux_sym_jsx_opening_element_repeat1,
    STATE(851), 1,
      sym_jsx_namespace_name,
    STATE(900), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [34125] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2003), 1,
      sym_identifier,
    ACTIONS(2005), 1,
      anon_sym_LBRACE,
    ACTIONS(2007), 1,
      anon_sym_LBRACK,
    STATE(910), 1,
      sym_variable_declarator,
    STATE(815), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
  [34146] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 7,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_of,
      anon_sym_EQ,
      anon_sym_RBRACK,
  [34159] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1428), 7,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_of,
      anon_sym_EQ,
      anon_sym_RBRACK,
  [34172] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2009), 7,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_of,
      anon_sym_EQ,
      anon_sym_RBRACK,
  [34185] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2011), 7,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_of,
      anon_sym_EQ,
      anon_sym_RBRACK,
  [34198] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_COMMA,
    ACTIONS(638), 1,
      anon_sym_RBRACE,
    ACTIONS(1629), 1,
      anon_sym_EQ,
    STATE(976), 1,
      aux_sym_object_repeat1,
    STATE(978), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(1627), 2,
      anon_sym_LPAREN,
      anon_sym_COLON,
  [34221] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2003), 1,
      sym_identifier,
    ACTIONS(2005), 1,
      anon_sym_LBRACE,
    ACTIONS(2007), 1,
      anon_sym_LBRACK,
    STATE(912), 1,
      sym_variable_declarator,
    STATE(815), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
  [34242] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2017), 1,
      anon_sym_EQ,
    STATE(1007), 1,
      sym__initializer,
    ACTIONS(2015), 2,
      anon_sym_in,
      anon_sym_of,
    ACTIONS(2013), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [34261] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_COMMA,
    ACTIONS(1629), 1,
      anon_sym_EQ,
    ACTIONS(1631), 1,
      anon_sym_RBRACE,
    STATE(978), 1,
      aux_sym_object_pattern_repeat1,
    STATE(1058), 1,
      aux_sym_object_repeat1,
    ACTIONS(1627), 2,
      anon_sym_LPAREN,
      anon_sym_COLON,
  [34284] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_COMMA,
    ACTIONS(1629), 1,
      anon_sym_EQ,
    ACTIONS(1691), 1,
      anon_sym_RBRACE,
    STATE(976), 1,
      aux_sym_object_repeat1,
    STATE(978), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(1627), 2,
      anon_sym_LPAREN,
      anon_sym_COLON,
  [34307] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_COMMA,
    ACTIONS(674), 1,
      anon_sym_RBRACE,
    ACTIONS(1629), 1,
      anon_sym_EQ,
    STATE(978), 1,
      aux_sym_object_pattern_repeat1,
    STATE(1058), 1,
      aux_sym_object_repeat1,
    ACTIONS(1627), 2,
      anon_sym_LPAREN,
      anon_sym_COLON,
  [34330] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_COMMA,
    ACTIONS(678), 1,
      anon_sym_RBRACE,
    ACTIONS(1629), 1,
      anon_sym_EQ,
    STATE(978), 1,
      aux_sym_object_pattern_repeat1,
    STATE(1058), 1,
      aux_sym_object_repeat1,
    ACTIONS(1627), 2,
      anon_sym_LPAREN,
      anon_sym_COLON,
  [34353] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_COMMA,
    ACTIONS(1629), 1,
      anon_sym_EQ,
    ACTIONS(1689), 1,
      anon_sym_RBRACE,
    STATE(978), 1,
      aux_sym_object_pattern_repeat1,
    STATE(1058), 1,
      aux_sym_object_repeat1,
    ACTIONS(1627), 2,
      anon_sym_LPAREN,
      anon_sym_COLON,
  [34376] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2005), 1,
      anon_sym_LBRACE,
    ACTIONS(2007), 1,
      anon_sym_LBRACK,
    ACTIONS(2019), 1,
      sym_identifier,
    STATE(910), 1,
      sym_variable_declarator,
    STATE(901), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
  [34397] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1414), 7,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_of,
      anon_sym_EQ,
      anon_sym_RBRACK,
  [34410] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2021), 7,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_of,
      anon_sym_EQ,
      anon_sym_RBRACK,
  [34423] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2005), 1,
      anon_sym_LBRACE,
    ACTIONS(2007), 1,
      anon_sym_LBRACK,
    ACTIONS(2019), 1,
      sym_identifier,
    STATE(973), 1,
      sym_variable_declarator,
    STATE(901), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
  [34444] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2005), 1,
      anon_sym_LBRACE,
    ACTIONS(2007), 1,
      anon_sym_LBRACK,
    ACTIONS(2019), 1,
      sym_identifier,
    STATE(912), 1,
      sym_variable_declarator,
    STATE(901), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
  [34465] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2023), 7,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_of,
      anon_sym_EQ,
      anon_sym_RBRACK,
  [34478] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2025), 7,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_of,
      anon_sym_EQ,
      anon_sym_RBRACK,
  [34491] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1873), 1,
      anon_sym_COLON,
    ACTIONS(2031), 1,
      anon_sym_EQ,
    ACTIONS(2027), 2,
      anon_sym_SLASH,
      sym_identifier,
    ACTIONS(2029), 3,
      anon_sym_LBRACE,
      anon_sym_GT,
      sym_jsx_identifier,
  [34510] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2033), 1,
      sym_identifier,
    ACTIONS(2035), 1,
      anon_sym_GT,
    ACTIONS(2037), 1,
      anon_sym_SLASH,
    ACTIONS(2039), 1,
      sym_jsx_identifier,
    STATE(777), 1,
      sym_nested_identifier,
    STATE(800), 1,
      sym_jsx_namespace_name,
  [34532] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2043), 1,
      anon_sym_BQUOTE,
    ACTIONS(2045), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(2041), 2,
      sym__template_chars,
      sym_escape_sequence,
    STATE(863), 2,
      sym_template_substitution,
      aux_sym_template_string_repeat1,
  [34550] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2045), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(2049), 1,
      anon_sym_BQUOTE,
    ACTIONS(2047), 2,
      sym__template_chars,
      sym_escape_sequence,
    STATE(854), 2,
      sym_template_substitution,
      aux_sym_template_string_repeat1,
  [34568] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2017), 1,
      anon_sym_EQ,
    ACTIONS(2051), 1,
      anon_sym_LPAREN,
    STATE(1167), 1,
      sym_formal_parameters,
    STATE(1198), 1,
      sym__initializer,
    ACTIONS(2053), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [34588] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2009), 6,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_EQ,
  [34600] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2033), 1,
      sym_identifier,
    ACTIONS(2035), 1,
      anon_sym_GT,
    ACTIONS(2039), 1,
      sym_jsx_identifier,
    ACTIONS(2055), 1,
      anon_sym_SLASH,
    STATE(777), 1,
      sym_nested_identifier,
    STATE(800), 1,
      sym_jsx_namespace_name,
  [34622] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2033), 1,
      sym_identifier,
    ACTIONS(2035), 1,
      anon_sym_GT,
    ACTIONS(2039), 1,
      sym_jsx_identifier,
    ACTIONS(2057), 1,
      anon_sym_SLASH,
    STATE(777), 1,
      sym_nested_identifier,
    STATE(800), 1,
      sym_jsx_namespace_name,
  [34644] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2033), 1,
      sym_identifier,
    ACTIONS(2035), 1,
      anon_sym_GT,
    ACTIONS(2039), 1,
      sym_jsx_identifier,
    ACTIONS(2059), 1,
      anon_sym_SLASH,
    STATE(777), 1,
      sym_nested_identifier,
    STATE(800), 1,
      sym_jsx_namespace_name,
  [34666] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1414), 6,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_EQ,
  [34678] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2025), 6,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_EQ,
  [34690] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2061), 1,
      anon_sym_default,
    ACTIONS(2064), 1,
      anon_sym_RBRACE,
    ACTIONS(2066), 1,
      anon_sym_case,
    STATE(839), 3,
      sym_switch_case,
      sym_switch_default,
      aux_sym_switch_body_repeat1,
  [34708] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2033), 1,
      sym_identifier,
    ACTIONS(2035), 1,
      anon_sym_GT,
    ACTIONS(2039), 1,
      sym_jsx_identifier,
    ACTIONS(2069), 1,
      anon_sym_SLASH,
    STATE(777), 1,
      sym_nested_identifier,
    STATE(800), 1,
      sym_jsx_namespace_name,
  [34730] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2023), 6,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_EQ,
  [34742] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2033), 1,
      sym_identifier,
    ACTIONS(2035), 1,
      anon_sym_GT,
    ACTIONS(2039), 1,
      sym_jsx_identifier,
    ACTIONS(2071), 1,
      anon_sym_SLASH,
    STATE(777), 1,
      sym_nested_identifier,
    STATE(800), 1,
      sym_jsx_namespace_name,
  [34764] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2021), 6,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_EQ,
  [34776] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2045), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(2075), 1,
      anon_sym_BQUOTE,
    ACTIONS(2073), 2,
      sym__template_chars,
      sym_escape_sequence,
    STATE(831), 2,
      sym_template_substitution,
      aux_sym_template_string_repeat1,
  [34794] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1428), 6,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_EQ,
  [34806] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1520), 1,
      anon_sym_LBRACE,
    ACTIONS(1708), 1,
      anon_sym_LBRACK,
    ACTIONS(2077), 1,
      sym_identifier,
    STATE(865), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
  [34824] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2033), 1,
      sym_identifier,
    ACTIONS(2035), 1,
      anon_sym_GT,
    ACTIONS(2039), 1,
      sym_jsx_identifier,
    ACTIONS(2079), 1,
      anon_sym_SLASH,
    STATE(777), 1,
      sym_nested_identifier,
    STATE(800), 1,
      sym_jsx_namespace_name,
  [34846] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2033), 1,
      sym_identifier,
    ACTIONS(2035), 1,
      anon_sym_GT,
    ACTIONS(2039), 1,
      sym_jsx_identifier,
    ACTIONS(2081), 1,
      anon_sym_SLASH,
    STATE(777), 1,
      sym_nested_identifier,
    STATE(800), 1,
      sym_jsx_namespace_name,
  [34868] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2017), 1,
      anon_sym_EQ,
    ACTIONS(2051), 1,
      anon_sym_LPAREN,
    STATE(1137), 1,
      sym_formal_parameters,
    STATE(1163), 1,
      sym__initializer,
    ACTIONS(2083), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [34888] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2085), 1,
      anon_sym_default,
    ACTIONS(2087), 1,
      anon_sym_RBRACE,
    ACTIONS(2089), 1,
      anon_sym_case,
    STATE(839), 3,
      sym_switch_case,
      sym_switch_default,
      aux_sym_switch_body_repeat1,
  [34906] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2095), 1,
      anon_sym_EQ,
    ACTIONS(2091), 2,
      anon_sym_SLASH,
      sym_identifier,
    ACTIONS(2093), 3,
      anon_sym_LBRACE,
      anon_sym_GT,
      sym_jsx_identifier,
  [34922] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 6,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_EQ,
  [34934] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1520), 1,
      anon_sym_LBRACE,
    ACTIONS(1708), 1,
      anon_sym_LBRACK,
    ACTIONS(2097), 1,
      sym_identifier,
    STATE(1192), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
  [34952] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2102), 1,
      anon_sym_BQUOTE,
    ACTIONS(2104), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(2099), 2,
      sym__template_chars,
      sym_escape_sequence,
    STATE(854), 2,
      sym_template_substitution,
      aux_sym_template_string_repeat1,
  [34970] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2107), 2,
      anon_sym_SLASH,
      sym_identifier,
    ACTIONS(2109), 4,
      anon_sym_LBRACE,
      anon_sym_GT,
      sym_jsx_identifier,
      anon_sym_DOT,
  [34984] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2033), 1,
      sym_identifier,
    ACTIONS(2035), 1,
      anon_sym_GT,
    ACTIONS(2039), 1,
      sym_jsx_identifier,
    ACTIONS(2111), 1,
      anon_sym_SLASH,
    STATE(777), 1,
      sym_nested_identifier,
    STATE(800), 1,
      sym_jsx_namespace_name,
  [35006] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2113), 2,
      anon_sym_SLASH,
      sym_identifier,
    ACTIONS(2115), 4,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT,
      sym_jsx_identifier,
  [35020] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2033), 1,
      sym_identifier,
    ACTIONS(2035), 1,
      anon_sym_GT,
    ACTIONS(2039), 1,
      sym_jsx_identifier,
    ACTIONS(2117), 1,
      anon_sym_SLASH,
    STATE(777), 1,
      sym_nested_identifier,
    STATE(800), 1,
      sym_jsx_namespace_name,
  [35042] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2011), 6,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_EQ,
  [35054] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2033), 1,
      sym_identifier,
    ACTIONS(2035), 1,
      anon_sym_GT,
    ACTIONS(2039), 1,
      sym_jsx_identifier,
    ACTIONS(2119), 1,
      anon_sym_SLASH,
    STATE(777), 1,
      sym_nested_identifier,
    STATE(800), 1,
      sym_jsx_namespace_name,
  [35076] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2033), 1,
      sym_identifier,
    ACTIONS(2035), 1,
      anon_sym_GT,
    ACTIONS(2039), 1,
      sym_jsx_identifier,
    ACTIONS(2121), 1,
      anon_sym_SLASH,
    STATE(777), 1,
      sym_nested_identifier,
    STATE(800), 1,
      sym_jsx_namespace_name,
  [35098] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1520), 1,
      anon_sym_LBRACE,
    ACTIONS(1708), 1,
      anon_sym_LBRACK,
    ACTIONS(2123), 1,
      sym_identifier,
    STATE(1308), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
  [35116] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2045), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(2125), 1,
      anon_sym_BQUOTE,
    ACTIONS(2047), 2,
      sym__template_chars,
      sym_escape_sequence,
    STATE(854), 2,
      sym_template_substitution,
      aux_sym_template_string_repeat1,
  [35134] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2085), 1,
      anon_sym_default,
    ACTIONS(2089), 1,
      anon_sym_case,
    ACTIONS(2127), 1,
      anon_sym_RBRACE,
    STATE(850), 3,
      sym_switch_case,
      sym_switch_default,
      aux_sym_switch_body_repeat1,
  [35152] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2129), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_RBRACK,
  [35163] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2131), 1,
      sym_identifier,
    ACTIONS(2133), 1,
      anon_sym_LBRACE,
    ACTIONS(2135), 1,
      anon_sym_extends,
    STATE(420), 1,
      sym_class_body,
    STATE(1130), 1,
      sym_class_heritage,
  [35182] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2135), 1,
      anon_sym_extends,
    ACTIONS(2137), 1,
      sym_identifier,
    ACTIONS(2139), 1,
      anon_sym_LBRACE,
    STATE(594), 1,
      sym_class_body,
    STATE(1079), 1,
      sym_class_heritage,
  [35201] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1629), 1,
      anon_sym_EQ,
    ACTIONS(1627), 2,
      anon_sym_LPAREN,
      anon_sym_COLON,
    ACTIONS(1693), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [35216] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1282), 2,
      anon_sym_SLASH,
      sym_identifier,
    ACTIONS(1284), 3,
      anon_sym_LBRACE,
      anon_sym_GT,
      sym_jsx_identifier,
  [35229] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1312), 2,
      anon_sym_SLASH,
      sym_identifier,
    ACTIONS(1314), 3,
      anon_sym_LBRACE,
      anon_sym_GT,
      sym_jsx_identifier,
  [35242] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2141), 1,
      sym_identifier,
    ACTIONS(2143), 1,
      anon_sym_GT,
    ACTIONS(2145), 1,
      sym_jsx_identifier,
    STATE(776), 1,
      sym_nested_identifier,
    STATE(798), 1,
      sym_jsx_namespace_name,
  [35261] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1224), 2,
      anon_sym_SLASH,
      sym_identifier,
    ACTIONS(1226), 3,
      anon_sym_LBRACE,
      anon_sym_GT,
      sym_jsx_identifier,
  [35274] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1597), 1,
      anon_sym_COMMA,
    ACTIONS(1627), 1,
      anon_sym_COLON,
    ACTIONS(1629), 1,
      anon_sym_EQ,
    ACTIONS(2147), 1,
      anon_sym_RBRACE,
    STATE(978), 1,
      aux_sym_object_pattern_repeat1,
  [35293] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2033), 1,
      sym_identifier,
    ACTIONS(2035), 1,
      anon_sym_GT,
    ACTIONS(2039), 1,
      sym_jsx_identifier,
    STATE(777), 1,
      sym_nested_identifier,
    STATE(800), 1,
      sym_jsx_namespace_name,
  [35312] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1361), 2,
      anon_sym_SLASH,
      sym_identifier,
    ACTIONS(1363), 3,
      anon_sym_LBRACE,
      anon_sym_GT,
      sym_jsx_identifier,
  [35325] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2149), 1,
      sym_identifier,
    ACTIONS(2151), 1,
      anon_sym_GT,
    ACTIONS(2153), 1,
      sym_jsx_identifier,
    STATE(771), 1,
      sym_nested_identifier,
    STATE(781), 1,
      sym_jsx_namespace_name,
  [35344] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1365), 2,
      anon_sym_SLASH,
      sym_identifier,
    ACTIONS(1367), 3,
      anon_sym_LBRACE,
      anon_sym_GT,
      sym_jsx_identifier,
  [35357] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1365), 2,
      anon_sym_SLASH,
      sym_identifier,
    ACTIONS(1367), 3,
      anon_sym_LBRACE,
      anon_sym_GT,
      sym_jsx_identifier,
  [35370] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1365), 2,
      anon_sym_SLASH,
      sym_identifier,
    ACTIONS(1367), 3,
      anon_sym_LBRACE,
      anon_sym_GT,
      sym_jsx_identifier,
  [35383] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2135), 1,
      anon_sym_extends,
    ACTIONS(2139), 1,
      anon_sym_LBRACE,
    ACTIONS(2155), 1,
      sym_identifier,
    STATE(613), 1,
      sym_class_body,
    STATE(1240), 1,
      sym_class_heritage,
  [35402] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1365), 2,
      anon_sym_SLASH,
      sym_identifier,
    ACTIONS(1367), 3,
      anon_sym_LBRACE,
      anon_sym_GT,
      sym_jsx_identifier,
  [35415] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_AT,
    ACTIONS(2157), 1,
      anon_sym_export,
    ACTIONS(2159), 1,
      anon_sym_class,
    STATE(716), 1,
      aux_sym_export_statement_repeat1,
    STATE(750), 1,
      sym_decorator,
  [35434] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1212), 2,
      anon_sym_SLASH,
      sym_identifier,
    ACTIONS(1214), 3,
      anon_sym_LBRACE,
      anon_sym_GT,
      sym_jsx_identifier,
  [35447] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2161), 1,
      sym_identifier,
    ACTIONS(2163), 1,
      anon_sym_GT,
    ACTIONS(2165), 1,
      sym_jsx_identifier,
    STATE(764), 1,
      sym_nested_identifier,
    STATE(802), 1,
      sym_jsx_namespace_name,
  [35466] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1375), 2,
      anon_sym_SLASH,
      sym_identifier,
    ACTIONS(1377), 3,
      anon_sym_LBRACE,
      anon_sym_GT,
      sym_jsx_identifier,
  [35479] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1379), 2,
      anon_sym_SLASH,
      sym_identifier,
    ACTIONS(1381), 3,
      anon_sym_LBRACE,
      anon_sym_GT,
      sym_jsx_identifier,
  [35492] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2135), 1,
      anon_sym_extends,
    ACTIONS(2139), 1,
      anon_sym_LBRACE,
    ACTIONS(2167), 1,
      sym_identifier,
    STATE(594), 1,
      sym_class_body,
    STATE(1079), 1,
      sym_class_heritage,
  [35511] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1597), 1,
      anon_sym_COMMA,
    ACTIONS(1627), 1,
      anon_sym_COLON,
    ACTIONS(1629), 1,
      anon_sym_EQ,
    ACTIONS(2169), 1,
      anon_sym_RBRACE,
    STATE(1059), 1,
      aux_sym_object_pattern_repeat1,
  [35530] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2171), 2,
      anon_sym_SLASH,
      sym_identifier,
    ACTIONS(2173), 3,
      anon_sym_LBRACE,
      anon_sym_GT,
      sym_jsx_identifier,
  [35543] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(774), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_RBRACK,
  [35554] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_AT,
    ACTIONS(2175), 1,
      anon_sym_export,
    ACTIONS(2177), 1,
      anon_sym_class,
    STATE(716), 1,
      aux_sym_export_statement_repeat1,
    STATE(750), 1,
      sym_decorator,
  [35573] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2133), 1,
      anon_sym_LBRACE,
    ACTIONS(2135), 1,
      anon_sym_extends,
    ACTIONS(2179), 1,
      sym_identifier,
    STATE(458), 1,
      sym_class_body,
    STATE(1089), 1,
      sym_class_heritage,
  [35592] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2135), 1,
      anon_sym_extends,
    ACTIONS(2139), 1,
      anon_sym_LBRACE,
    ACTIONS(2181), 1,
      sym_identifier,
    STATE(613), 1,
      sym_class_body,
    STATE(1240), 1,
      sym_class_heritage,
  [35611] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2135), 1,
      anon_sym_extends,
    ACTIONS(2139), 1,
      anon_sym_LBRACE,
    ACTIONS(2183), 1,
      sym_identifier,
    STATE(613), 1,
      sym_class_body,
    STATE(1240), 1,
      sym_class_heritage,
  [35630] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1059), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_RBRACK,
  [35641] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2185), 2,
      anon_sym_SLASH,
      sym_identifier,
    ACTIONS(2187), 3,
      anon_sym_LBRACE,
      anon_sym_GT,
      sym_jsx_identifier,
  [35654] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2189), 2,
      anon_sym_SLASH,
      sym_identifier,
    ACTIONS(2191), 3,
      anon_sym_LBRACE,
      anon_sym_GT,
      sym_jsx_identifier,
  [35667] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2193), 2,
      anon_sym_SLASH,
      sym_identifier,
    ACTIONS(2195), 3,
      anon_sym_LBRACE,
      anon_sym_GT,
      sym_jsx_identifier,
  [35680] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2135), 1,
      anon_sym_extends,
    ACTIONS(2139), 1,
      anon_sym_LBRACE,
    ACTIONS(2197), 1,
      sym_identifier,
    STATE(594), 1,
      sym_class_body,
    STATE(1079), 1,
      sym_class_heritage,
  [35699] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2199), 2,
      anon_sym_SLASH,
      sym_identifier,
    ACTIONS(2201), 3,
      anon_sym_LBRACE,
      anon_sym_GT,
      sym_jsx_identifier,
  [35712] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2017), 1,
      anon_sym_EQ,
    STATE(1007), 1,
      sym__initializer,
    ACTIONS(2013), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [35727] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1292), 2,
      anon_sym_SLASH,
      sym_identifier,
    ACTIONS(1294), 3,
      anon_sym_LBRACE,
      anon_sym_GT,
      sym_jsx_identifier,
  [35740] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2203), 1,
      anon_sym_LBRACE,
    ACTIONS(2205), 1,
      anon_sym_extends,
    STATE(225), 1,
      sym_class_body,
    STATE(1244), 1,
      sym_class_heritage,
  [35756] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2139), 1,
      anon_sym_LBRACE,
    ACTIONS(2205), 1,
      anon_sym_extends,
    STATE(54), 1,
      sym_class_body,
    STATE(1105), 1,
      sym_class_heritage,
  [35772] = 4,
    ACTIONS(1895), 1,
      sym_comment,
    ACTIONS(2207), 1,
      anon_sym_DQUOTE,
    STATE(907), 1,
      aux_sym_string_repeat1,
    ACTIONS(2209), 2,
      aux_sym_string_token1,
      sym_escape_sequence,
  [35786] = 4,
    ACTIONS(1895), 1,
      sym_comment,
    ACTIONS(2211), 1,
      anon_sym_SQUOTE,
    STATE(906), 1,
      aux_sym_string_repeat2,
    ACTIONS(2213), 2,
      aux_sym_string_token2,
      sym_escape_sequence,
  [35800] = 4,
    ACTIONS(1895), 1,
      sym_comment,
    ACTIONS(2216), 1,
      anon_sym_DQUOTE,
    STATE(907), 1,
      aux_sym_string_repeat1,
    ACTIONS(2218), 2,
      aux_sym_string_token1,
      sym_escape_sequence,
  [35814] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2221), 1,
      sym_identifier,
    ACTIONS(2223), 1,
      anon_sym_COMMA,
    ACTIONS(2225), 1,
      anon_sym_RBRACE,
    STATE(999), 1,
      sym__import_export_specifier,
  [35830] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2139), 1,
      anon_sym_LBRACE,
    ACTIONS(2205), 1,
      anon_sym_extends,
    STATE(509), 1,
      sym_class_body,
    STATE(1082), 1,
      sym_class_heritage,
  [35846] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2227), 1,
      anon_sym_COMMA,
    STATE(937), 1,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(2229), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [35860] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2231), 1,
      sym_identifier,
    ACTIONS(2233), 1,
      sym_jsx_identifier,
    STATE(1109), 1,
      sym_nested_identifier,
    STATE(1337), 1,
      sym_jsx_namespace_name,
  [35876] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2227), 1,
      anon_sym_COMMA,
    STATE(936), 1,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(2235), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [35890] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2051), 1,
      anon_sym_LPAREN,
    ACTIONS(2237), 1,
      sym_identifier,
    ACTIONS(2239), 1,
      anon_sym_STAR,
    STATE(1113), 1,
      sym_formal_parameters,
  [35906] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(576), 1,
      anon_sym_COMMA,
    ACTIONS(2241), 1,
      anon_sym_EQ,
    ACTIONS(2243), 1,
      anon_sym_RBRACK,
    STATE(1072), 1,
      aux_sym_array_pattern_repeat1,
  [35922] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2245), 1,
      anon_sym_COMMA,
    STATE(915), 1,
      aux_sym_array_repeat1,
    ACTIONS(1395), 2,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
  [35936] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2051), 1,
      anon_sym_LPAREN,
    ACTIONS(2248), 1,
      sym_identifier,
    ACTIONS(2250), 1,
      anon_sym_STAR,
    STATE(1124), 1,
      sym_formal_parameters,
  [35952] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1627), 1,
      anon_sym_COLON,
    ACTIONS(1629), 1,
      anon_sym_EQ,
    ACTIONS(2252), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [35966] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2139), 1,
      anon_sym_LBRACE,
    ACTIONS(2205), 1,
      anon_sym_extends,
    STATE(620), 1,
      sym_class_body,
    STATE(1093), 1,
      sym_class_heritage,
  [35982] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2254), 1,
      anon_sym_EQ,
    ACTIONS(1059), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
  [35994] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2139), 1,
      anon_sym_LBRACE,
    ACTIONS(2205), 1,
      anon_sym_extends,
    STATE(577), 1,
      sym_class_body,
    STATE(1116), 1,
      sym_class_heritage,
  [36010] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2241), 1,
      anon_sym_EQ,
    ACTIONS(2257), 1,
      anon_sym_COMMA,
    ACTIONS(2259), 1,
      anon_sym_RPAREN,
    STATE(1017), 1,
      aux_sym_formal_parameters_repeat1,
  [36026] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_AT,
    ACTIONS(2261), 1,
      anon_sym_class,
    STATE(716), 1,
      aux_sym_export_statement_repeat1,
    STATE(750), 1,
      sym_decorator,
  [36042] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1482), 4,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
  [36052] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_AT,
    ACTIONS(2263), 1,
      anon_sym_class,
    STATE(716), 1,
      aux_sym_export_statement_repeat1,
    STATE(750), 1,
      sym_decorator,
  [36068] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_AT,
    ACTIONS(2265), 1,
      anon_sym_class,
    STATE(716), 1,
      aux_sym_export_statement_repeat1,
    STATE(750), 1,
      sym_decorator,
  [36084] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2051), 1,
      anon_sym_LPAREN,
    ACTIONS(2267), 1,
      sym_identifier,
    ACTIONS(2269), 1,
      anon_sym_STAR,
    STATE(1222), 1,
      sym_formal_parameters,
  [36100] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2271), 1,
      anon_sym_from,
    STATE(1193), 1,
      sym__from_clause,
    ACTIONS(2273), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [36114] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1627), 2,
      anon_sym_LPAREN,
      anon_sym_COLON,
    ACTIONS(1696), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [36126] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2139), 1,
      anon_sym_LBRACE,
    ACTIONS(2205), 1,
      anon_sym_extends,
    STATE(225), 1,
      sym_class_body,
    STATE(1112), 1,
      sym_class_heritage,
  [36142] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(576), 1,
      anon_sym_COMMA,
    ACTIONS(2241), 1,
      anon_sym_EQ,
    ACTIONS(2275), 1,
      anon_sym_RBRACK,
    STATE(1029), 1,
      aux_sym_array_pattern_repeat1,
  [36158] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2277), 1,
      sym_identifier,
    ACTIONS(2279), 1,
      sym_jsx_identifier,
    STATE(1207), 1,
      sym_nested_identifier,
    STATE(1278), 1,
      sym_jsx_namespace_name,
  [36174] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2051), 1,
      anon_sym_LPAREN,
    ACTIONS(2281), 1,
      sym_identifier,
    ACTIONS(2283), 1,
      anon_sym_STAR,
    STATE(1083), 1,
      sym_formal_parameters,
  [36190] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2133), 1,
      anon_sym_LBRACE,
    ACTIONS(2205), 1,
      anon_sym_extends,
    STATE(485), 1,
      sym_class_body,
    STATE(1095), 1,
      sym_class_heritage,
  [36206] = 4,
    ACTIONS(1895), 1,
      sym_comment,
    ACTIONS(2207), 1,
      anon_sym_SQUOTE,
    STATE(906), 1,
      aux_sym_string_repeat2,
    ACTIONS(2285), 2,
      aux_sym_string_token2,
      sym_escape_sequence,
  [36220] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2051), 1,
      anon_sym_LPAREN,
    ACTIONS(2287), 1,
      sym_identifier,
    ACTIONS(2289), 1,
      anon_sym_STAR,
    STATE(1124), 1,
      sym_formal_parameters,
  [36236] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2227), 1,
      anon_sym_COMMA,
    STATE(941), 1,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(2291), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [36250] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2227), 1,
      anon_sym_COMMA,
    STATE(941), 1,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(2293), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [36264] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2221), 1,
      sym_identifier,
    ACTIONS(2295), 1,
      anon_sym_COMMA,
    ACTIONS(2297), 1,
      anon_sym_RBRACE,
    STATE(986), 1,
      sym__import_export_specifier,
  [36280] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2139), 1,
      anon_sym_LBRACE,
    ACTIONS(2205), 1,
      anon_sym_extends,
    STATE(514), 1,
      sym_class_body,
    STATE(1074), 1,
      sym_class_heritage,
  [36296] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1079), 1,
      anon_sym_LBRACE,
    ACTIONS(2299), 1,
      anon_sym_STAR,
    STATE(1316), 2,
      sym_namespace_import,
      sym_named_imports,
  [36310] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2301), 1,
      anon_sym_COMMA,
    STATE(941), 1,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(2304), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [36324] = 4,
    ACTIONS(1895), 1,
      sym_comment,
    ACTIONS(2306), 1,
      anon_sym_DQUOTE,
    STATE(907), 1,
      aux_sym_string_repeat1,
    ACTIONS(2209), 2,
      aux_sym_string_token1,
      sym_escape_sequence,
  [36338] = 4,
    ACTIONS(1895), 1,
      sym_comment,
    ACTIONS(2306), 1,
      anon_sym_SQUOTE,
    STATE(906), 1,
      aux_sym_string_repeat2,
    ACTIONS(2285), 2,
      aux_sym_string_token2,
      sym_escape_sequence,
  [36352] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1234), 1,
      anon_sym_LPAREN,
    ACTIONS(2308), 1,
      sym_identifier,
    ACTIONS(2310), 1,
      anon_sym_LBRACK,
    STATE(588), 1,
      sym_arguments,
  [36368] = 4,
    ACTIONS(1895), 1,
      sym_comment,
    ACTIONS(2312), 1,
      anon_sym_SQUOTE,
    STATE(943), 1,
      aux_sym_string_repeat2,
    ACTIONS(2314), 2,
      aux_sym_string_token2,
      sym_escape_sequence,
  [36382] = 4,
    ACTIONS(1895), 1,
      sym_comment,
    ACTIONS(2316), 1,
      anon_sym_SQUOTE,
    STATE(934), 1,
      aux_sym_string_repeat2,
    ACTIONS(2318), 2,
      aux_sym_string_token2,
      sym_escape_sequence,
  [36396] = 4,
    ACTIONS(1895), 1,
      sym_comment,
    ACTIONS(2316), 1,
      anon_sym_DQUOTE,
    STATE(905), 1,
      aux_sym_string_repeat1,
    ACTIONS(2320), 2,
      aux_sym_string_token1,
      sym_escape_sequence,
  [36410] = 4,
    ACTIONS(1895), 1,
      sym_comment,
    ACTIONS(2322), 1,
      anon_sym_DQUOTE,
    STATE(963), 1,
      aux_sym_string_repeat1,
    ACTIONS(2324), 2,
      aux_sym_string_token1,
      sym_escape_sequence,
  [36424] = 4,
    ACTIONS(1895), 1,
      sym_comment,
    ACTIONS(2322), 1,
      anon_sym_SQUOTE,
    STATE(959), 1,
      aux_sym_string_repeat2,
    ACTIONS(2326), 2,
      aux_sym_string_token2,
      sym_escape_sequence,
  [36438] = 4,
    ACTIONS(1895), 1,
      sym_comment,
    ACTIONS(2312), 1,
      anon_sym_DQUOTE,
    STATE(942), 1,
      aux_sym_string_repeat1,
    ACTIONS(2328), 2,
      aux_sym_string_token1,
      sym_escape_sequence,
  [36452] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2330), 4,
      sym__template_chars,
      sym_escape_sequence,
      anon_sym_BQUOTE,
      anon_sym_DOLLAR_LBRACE,
  [36462] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2332), 1,
      sym_identifier,
    ACTIONS(2334), 1,
      sym_jsx_identifier,
    STATE(1231), 1,
      sym_nested_identifier,
    STATE(1259), 1,
      sym_jsx_namespace_name,
  [36478] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2051), 1,
      anon_sym_LPAREN,
    ACTIONS(2336), 1,
      sym_identifier,
    ACTIONS(2338), 1,
      anon_sym_STAR,
    STATE(1222), 1,
      sym_formal_parameters,
  [36494] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2051), 1,
      anon_sym_LPAREN,
    ACTIONS(2340), 1,
      sym_identifier,
    ACTIONS(2342), 1,
      anon_sym_STAR,
    STATE(1222), 1,
      sym_formal_parameters,
  [36510] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_AT,
    ACTIONS(2344), 1,
      anon_sym_class,
    STATE(716), 1,
      aux_sym_export_statement_repeat1,
    STATE(750), 1,
      sym_decorator,
  [36526] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2051), 1,
      anon_sym_LPAREN,
    ACTIONS(2346), 1,
      sym_identifier,
    ACTIONS(2348), 1,
      anon_sym_STAR,
    STATE(1124), 1,
      sym_formal_parameters,
  [36542] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2203), 1,
      anon_sym_LBRACE,
    ACTIONS(2205), 1,
      anon_sym_extends,
    STATE(233), 1,
      sym_class_body,
    STATE(1104), 1,
      sym_class_heritage,
  [36558] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1192), 4,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [36568] = 4,
    ACTIONS(1895), 1,
      sym_comment,
    ACTIONS(2350), 1,
      anon_sym_SQUOTE,
    STATE(906), 1,
      aux_sym_string_repeat2,
    ACTIONS(2285), 2,
      aux_sym_string_token2,
      sym_escape_sequence,
  [36582] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1089), 1,
      anon_sym_LPAREN,
    ACTIONS(2352), 1,
      sym_identifier,
    ACTIONS(2354), 1,
      anon_sym_LBRACK,
    STATE(416), 1,
      sym_arguments,
  [36598] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2139), 1,
      anon_sym_LBRACE,
    ACTIONS(2205), 1,
      anon_sym_extends,
    STATE(233), 1,
      sym_class_body,
    STATE(1090), 1,
      sym_class_heritage,
  [36614] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2139), 1,
      anon_sym_LBRACE,
    ACTIONS(2205), 1,
      anon_sym_extends,
    STATE(58), 1,
      sym_class_body,
    STATE(1220), 1,
      sym_class_heritage,
  [36630] = 4,
    ACTIONS(1895), 1,
      sym_comment,
    ACTIONS(2350), 1,
      anon_sym_DQUOTE,
    STATE(907), 1,
      aux_sym_string_repeat1,
    ACTIONS(2209), 2,
      aux_sym_string_token1,
      sym_escape_sequence,
  [36644] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2133), 1,
      anon_sym_LBRACE,
    ACTIONS(2205), 1,
      anon_sym_extends,
    STATE(461), 1,
      sym_class_body,
    STATE(1164), 1,
      sym_class_heritage,
  [36660] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2356), 1,
      sym_identifier,
    ACTIONS(2358), 1,
      sym_jsx_identifier,
    STATE(1075), 1,
      sym_nested_identifier,
    STATE(1269), 1,
      sym_jsx_namespace_name,
  [36676] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1627), 4,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
  [36686] = 2,
    ACTIONS(1895), 1,
      sym_comment,
    ACTIONS(1365), 3,
      anon_sym_LBRACE,
      anon_sym_LT,
      sym_jsx_text,
  [36695] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(588), 1,
      anon_sym_COMMA,
    ACTIONS(1397), 1,
      anon_sym_RBRACK,
    STATE(915), 1,
      aux_sym_array_repeat1,
  [36708] = 2,
    ACTIONS(1895), 1,
      sym_comment,
    ACTIONS(1365), 3,
      anon_sym_LBRACE,
      anon_sym_LT,
      sym_jsx_text,
  [36717] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(588), 1,
      anon_sym_COMMA,
    ACTIONS(1409), 1,
      anon_sym_RPAREN,
    STATE(915), 1,
      aux_sym_array_repeat1,
  [36730] = 2,
    ACTIONS(1895), 1,
      sym_comment,
    ACTIONS(1375), 3,
      anon_sym_LBRACE,
      anon_sym_LT,
      sym_jsx_text,
  [36739] = 2,
    ACTIONS(1895), 1,
      sym_comment,
    ACTIONS(1379), 3,
      anon_sym_LBRACE,
      anon_sym_LT,
      sym_jsx_text,
  [36748] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2304), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [36757] = 2,
    ACTIONS(1895), 1,
      sym_comment,
    ACTIONS(2360), 3,
      anon_sym_LBRACE,
      anon_sym_LT,
      sym_jsx_text,
  [36766] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2362), 1,
      anon_sym_EQ,
    ACTIONS(1059), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [36777] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2364), 1,
      anon_sym_COMMA,
    ACTIONS(2366), 1,
      anon_sym_RBRACE,
    STATE(996), 1,
      aux_sym_object_repeat1,
  [36790] = 2,
    ACTIONS(1895), 1,
      sym_comment,
    ACTIONS(2360), 3,
      anon_sym_LBRACE,
      anon_sym_LT,
      sym_jsx_text,
  [36799] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1597), 1,
      anon_sym_COMMA,
    ACTIONS(2368), 1,
      anon_sym_RBRACE,
    STATE(998), 1,
      aux_sym_object_pattern_repeat1,
  [36812] = 2,
    ACTIONS(1895), 1,
      sym_comment,
    ACTIONS(1365), 3,
      anon_sym_LBRACE,
      anon_sym_LT,
      sym_jsx_text,
  [36821] = 2,
    ACTIONS(1895), 1,
      sym_comment,
    ACTIONS(1361), 3,
      anon_sym_LBRACE,
      anon_sym_LT,
      sym_jsx_text,
  [36830] = 2,
    ACTIONS(1895), 1,
      sym_comment,
    ACTIONS(2360), 3,
      anon_sym_LBRACE,
      anon_sym_LT,
      sym_jsx_text,
  [36839] = 2,
    ACTIONS(1895), 1,
      sym_comment,
    ACTIONS(1312), 3,
      anon_sym_LBRACE,
      anon_sym_LT,
      sym_jsx_text,
  [36848] = 2,
    ACTIONS(1895), 1,
      sym_comment,
    ACTIONS(1282), 3,
      anon_sym_LBRACE,
      anon_sym_LT,
      sym_jsx_text,
  [36857] = 2,
    ACTIONS(1895), 1,
      sym_comment,
    ACTIONS(2360), 3,
      anon_sym_LBRACE,
      anon_sym_LT,
      sym_jsx_text,
  [36866] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(483), 1,
      sym__automatic_semicolon,
    ACTIONS(479), 2,
      anon_sym_else,
      anon_sym_while,
  [36877] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2370), 1,
      anon_sym_COMMA,
    ACTIONS(2372), 1,
      anon_sym_RBRACE,
    STATE(1051), 1,
      aux_sym_export_clause_repeat1,
  [36890] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1873), 1,
      anon_sym_COLON,
    ACTIONS(1881), 1,
      anon_sym_DOT,
    ACTIONS(2374), 1,
      anon_sym_GT,
  [36903] = 2,
    ACTIONS(1895), 1,
      sym_comment,
    ACTIONS(1292), 3,
      anon_sym_LBRACE,
      anon_sym_LT,
      sym_jsx_text,
  [36912] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2378), 1,
      anon_sym_as,
    ACTIONS(2376), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [36923] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2380), 1,
      anon_sym_COMMA,
    ACTIONS(2383), 1,
      anon_sym_RPAREN,
    STATE(990), 1,
      aux_sym_formal_parameters_repeat1,
  [36936] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2241), 1,
      anon_sym_EQ,
    ACTIONS(2383), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [36947] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2362), 1,
      anon_sym_EQ,
    ACTIONS(2129), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [36958] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1597), 1,
      anon_sym_COMMA,
    ACTIONS(2385), 1,
      anon_sym_RBRACE,
    STATE(998), 1,
      aux_sym_object_pattern_repeat1,
  [36971] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(588), 1,
      anon_sym_COMMA,
    ACTIONS(2387), 1,
      anon_sym_RPAREN,
    STATE(915), 1,
      aux_sym_array_repeat1,
  [36984] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2389), 3,
      sym__automatic_semicolon,
      anon_sym_from,
      anon_sym_SEMI,
  [36993] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2391), 1,
      anon_sym_COMMA,
    ACTIONS(2394), 1,
      anon_sym_RBRACE,
    STATE(996), 1,
      aux_sym_object_repeat1,
  [37006] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2051), 1,
      anon_sym_LPAREN,
    ACTIONS(2396), 1,
      sym_identifier,
    STATE(1101), 1,
      sym_formal_parameters,
  [37019] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2398), 1,
      anon_sym_COMMA,
    ACTIONS(2401), 1,
      anon_sym_RBRACE,
    STATE(998), 1,
      aux_sym_object_pattern_repeat1,
  [37032] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2403), 1,
      anon_sym_COMMA,
    ACTIONS(2405), 1,
      anon_sym_RBRACE,
    STATE(1005), 1,
      aux_sym_named_imports_repeat1,
  [37045] = 2,
    ACTIONS(1895), 1,
      sym_comment,
    ACTIONS(2185), 3,
      anon_sym_LBRACE,
      anon_sym_LT,
      sym_jsx_text,
  [37054] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(75), 1,
      anon_sym_DQUOTE,
    ACTIONS(77), 1,
      anon_sym_SQUOTE,
    STATE(1078), 1,
      sym_string,
  [37067] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1873), 1,
      anon_sym_COLON,
    ACTIONS(1881), 1,
      anon_sym_DOT,
    ACTIONS(2407), 1,
      anon_sym_GT,
  [37080] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2409), 3,
      sym__automatic_semicolon,
      anon_sym_from,
      anon_sym_SEMI,
  [37089] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1873), 1,
      anon_sym_COLON,
    ACTIONS(1881), 1,
      anon_sym_DOT,
    ACTIONS(2411), 1,
      anon_sym_GT,
  [37102] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2413), 1,
      anon_sym_COMMA,
    ACTIONS(2415), 1,
      anon_sym_RBRACE,
    STATE(1040), 1,
      aux_sym_named_imports_repeat1,
  [37115] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2221), 1,
      sym_identifier,
    ACTIONS(2417), 1,
      anon_sym_RBRACE,
    STATE(1235), 1,
      sym__import_export_specifier,
  [37128] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2419), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [37137] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2409), 3,
      sym__automatic_semicolon,
      anon_sym_from,
      anon_sym_SEMI,
  [37146] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2221), 1,
      sym_identifier,
    ACTIONS(2421), 1,
      anon_sym_RBRACE,
    STATE(1209), 1,
      sym__import_export_specifier,
  [37159] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2423), 1,
      anon_sym_COMMA,
    ACTIONS(2426), 1,
      anon_sym_RBRACE,
    STATE(1010), 1,
      aux_sym_export_clause_repeat1,
  [37172] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2428), 1,
      anon_sym_EQ,
    ACTIONS(1032), 2,
      anon_sym_in,
      anon_sym_of,
  [37183] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2051), 1,
      anon_sym_LPAREN,
    ACTIONS(2430), 1,
      sym_identifier,
    STATE(1122), 1,
      sym_formal_parameters,
  [37196] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(576), 1,
      anon_sym_COMMA,
    ACTIONS(2275), 1,
      anon_sym_RBRACK,
    STATE(1032), 1,
      aux_sym_array_pattern_repeat1,
  [37209] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2051), 1,
      anon_sym_LPAREN,
    ACTIONS(2432), 1,
      sym_identifier,
    STATE(1084), 1,
      sym_formal_parameters,
  [37222] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1597), 1,
      anon_sym_COMMA,
    ACTIONS(2434), 1,
      anon_sym_RBRACE,
    STATE(1060), 1,
      aux_sym_object_pattern_repeat1,
  [37235] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2364), 1,
      anon_sym_COMMA,
    ACTIONS(2436), 1,
      anon_sym_RBRACE,
    STATE(1061), 1,
      aux_sym_object_repeat1,
  [37248] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1746), 1,
      anon_sym_RPAREN,
    ACTIONS(2438), 1,
      anon_sym_COMMA,
    STATE(990), 1,
      aux_sym_formal_parameters_repeat1,
  [37261] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2364), 1,
      anon_sym_COMMA,
    ACTIONS(2436), 1,
      anon_sym_RBRACE,
    STATE(996), 1,
      aux_sym_object_repeat1,
  [37274] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1597), 1,
      anon_sym_COMMA,
    ACTIONS(2434), 1,
      anon_sym_RBRACE,
    STATE(998), 1,
      aux_sym_object_pattern_repeat1,
  [37287] = 2,
    ACTIONS(1895), 1,
      sym_comment,
    ACTIONS(1365), 3,
      anon_sym_LBRACE,
      anon_sym_LT,
      sym_jsx_text,
  [37296] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2440), 1,
      anon_sym_LBRACE,
    ACTIONS(2442), 1,
      anon_sym_LPAREN,
    STATE(236), 1,
      sym_statement_block,
  [37309] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1395), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
  [37318] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2051), 1,
      anon_sym_LPAREN,
    ACTIONS(2444), 1,
      anon_sym_COLON,
    STATE(1167), 1,
      sym_formal_parameters,
  [37331] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2446), 1,
      anon_sym_LPAREN,
    ACTIONS(2448), 1,
      anon_sym_await,
    STATE(39), 1,
      sym__for_header,
  [37344] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(588), 1,
      anon_sym_COMMA,
    ACTIONS(1397), 1,
      anon_sym_RBRACK,
    STATE(1028), 1,
      aux_sym_array_repeat1,
  [37357] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(576), 1,
      anon_sym_COMMA,
    ACTIONS(2275), 1,
      anon_sym_RBRACK,
    STATE(1029), 1,
      aux_sym_array_pattern_repeat1,
  [37370] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2241), 1,
      anon_sym_EQ,
    ACTIONS(2450), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [37381] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(588), 1,
      anon_sym_COMMA,
    ACTIONS(2452), 1,
      anon_sym_RBRACK,
    STATE(915), 1,
      aux_sym_array_repeat1,
  [37394] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(576), 1,
      anon_sym_COMMA,
    ACTIONS(2454), 1,
      anon_sym_RBRACK,
    STATE(1032), 1,
      aux_sym_array_pattern_repeat1,
  [37407] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2257), 1,
      anon_sym_COMMA,
    ACTIONS(2259), 1,
      anon_sym_RPAREN,
    STATE(1017), 1,
      aux_sym_formal_parameters_repeat1,
  [37420] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(794), 1,
      anon_sym_while,
    ACTIONS(2456), 1,
      anon_sym_else,
    STATE(250), 1,
      sym_else_clause,
  [37433] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2450), 1,
      anon_sym_RBRACK,
    ACTIONS(2458), 1,
      anon_sym_COMMA,
    STATE(1032), 1,
      aux_sym_array_pattern_repeat1,
  [37446] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(576), 1,
      anon_sym_COMMA,
    ACTIONS(2243), 1,
      anon_sym_RBRACK,
    STATE(1072), 1,
      aux_sym_array_pattern_repeat1,
  [37459] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(588), 1,
      anon_sym_COMMA,
    ACTIONS(1407), 1,
      anon_sym_RBRACK,
    STATE(1071), 1,
      aux_sym_array_repeat1,
  [37472] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2051), 1,
      anon_sym_LPAREN,
    ACTIONS(2461), 1,
      sym_identifier,
    STATE(1122), 1,
      sym_formal_parameters,
  [37485] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(588), 1,
      anon_sym_COMMA,
    ACTIONS(1407), 1,
      anon_sym_RBRACK,
    STATE(915), 1,
      aux_sym_array_repeat1,
  [37498] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(576), 1,
      anon_sym_COMMA,
    ACTIONS(2243), 1,
      anon_sym_RBRACK,
    STATE(1032), 1,
      aux_sym_array_pattern_repeat1,
  [37511] = 2,
    ACTIONS(1895), 1,
      sym_comment,
    ACTIONS(2463), 3,
      anon_sym_LBRACE,
      anon_sym_LT,
      sym_jsx_text,
  [37520] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2221), 1,
      sym_identifier,
    ACTIONS(2465), 1,
      anon_sym_RBRACE,
    STATE(1209), 1,
      sym__import_export_specifier,
  [37533] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2467), 1,
      anon_sym_COMMA,
    ACTIONS(2470), 1,
      anon_sym_RBRACE,
    STATE(1040), 1,
      aux_sym_named_imports_repeat1,
  [37546] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2364), 1,
      anon_sym_COMMA,
    ACTIONS(2472), 1,
      anon_sym_RBRACE,
    STATE(996), 1,
      aux_sym_object_repeat1,
  [37559] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2051), 1,
      anon_sym_LPAREN,
    ACTIONS(2474), 1,
      sym_identifier,
    STATE(1206), 1,
      sym_formal_parameters,
  [37572] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2051), 1,
      anon_sym_LPAREN,
    ACTIONS(2476), 1,
      sym_identifier,
    STATE(1206), 1,
      sym_formal_parameters,
  [37585] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1597), 1,
      anon_sym_COMMA,
    ACTIONS(2478), 1,
      anon_sym_RBRACE,
    STATE(998), 1,
      aux_sym_object_pattern_repeat1,
  [37598] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2480), 1,
      anon_sym_EQ,
    ACTIONS(1032), 2,
      anon_sym_in,
      anon_sym_of,
  [37609] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1873), 1,
      anon_sym_COLON,
    ACTIONS(1881), 1,
      anon_sym_DOT,
    ACTIONS(2482), 1,
      anon_sym_GT,
  [37622] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(588), 1,
      anon_sym_COMMA,
    ACTIONS(2484), 1,
      anon_sym_RPAREN,
    STATE(915), 1,
      aux_sym_array_repeat1,
  [37635] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2364), 1,
      anon_sym_COMMA,
    ACTIONS(2486), 1,
      anon_sym_RBRACE,
    STATE(996), 1,
      aux_sym_object_repeat1,
  [37648] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2051), 1,
      anon_sym_LPAREN,
    ACTIONS(2488), 1,
      anon_sym_COLON,
    STATE(1167), 1,
      sym_formal_parameters,
  [37661] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2364), 1,
      anon_sym_COMMA,
    ACTIONS(2486), 1,
      anon_sym_RBRACE,
    STATE(1041), 1,
      aux_sym_object_repeat1,
  [37674] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2490), 1,
      anon_sym_COMMA,
    ACTIONS(2492), 1,
      anon_sym_RBRACE,
    STATE(1010), 1,
      aux_sym_export_clause_repeat1,
  [37687] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1597), 1,
      anon_sym_COMMA,
    ACTIONS(2478), 1,
      anon_sym_RBRACE,
    STATE(993), 1,
      aux_sym_object_pattern_repeat1,
  [37700] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2494), 3,
      sym__automatic_semicolon,
      anon_sym_from,
      anon_sym_SEMI,
  [37709] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2496), 1,
      sym_identifier,
    STATE(699), 1,
      sym_decorator_member_expression,
    STATE(753), 1,
      sym_decorator_call_expression,
  [37722] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2498), 3,
      sym__automatic_semicolon,
      anon_sym_from,
      anon_sym_SEMI,
  [37731] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2221), 1,
      sym_identifier,
    ACTIONS(2500), 1,
      anon_sym_RBRACE,
    STATE(1235), 1,
      sym__import_export_specifier,
  [37744] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2051), 1,
      anon_sym_LPAREN,
    ACTIONS(2502), 1,
      sym_identifier,
    STATE(1122), 1,
      sym_formal_parameters,
  [37757] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2364), 1,
      anon_sym_COMMA,
    ACTIONS(2504), 1,
      anon_sym_RBRACE,
    STATE(996), 1,
      aux_sym_object_repeat1,
  [37770] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1597), 1,
      anon_sym_COMMA,
    ACTIONS(2506), 1,
      anon_sym_RBRACE,
    STATE(998), 1,
      aux_sym_object_pattern_repeat1,
  [37783] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1597), 1,
      anon_sym_COMMA,
    ACTIONS(2508), 1,
      anon_sym_RBRACE,
    STATE(998), 1,
      aux_sym_object_pattern_repeat1,
  [37796] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2364), 1,
      anon_sym_COMMA,
    ACTIONS(2510), 1,
      anon_sym_RBRACE,
    STATE(996), 1,
      aux_sym_object_repeat1,
  [37809] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(588), 1,
      anon_sym_COMMA,
    ACTIONS(1423), 1,
      anon_sym_RPAREN,
    STATE(915), 1,
      aux_sym_array_repeat1,
  [37822] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2051), 1,
      anon_sym_LPAREN,
    ACTIONS(2512), 1,
      sym_identifier,
    STATE(1206), 1,
      sym_formal_parameters,
  [37835] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2514), 3,
      sym__automatic_semicolon,
      anon_sym_from,
      anon_sym_SEMI,
  [37844] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(588), 1,
      anon_sym_COMMA,
    ACTIONS(1423), 1,
      anon_sym_RPAREN,
    STATE(994), 1,
      aux_sym_array_repeat1,
  [37857] = 2,
    ACTIONS(1895), 1,
      sym_comment,
    ACTIONS(2171), 3,
      anon_sym_LBRACE,
      anon_sym_LT,
      sym_jsx_text,
  [37866] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2516), 1,
      sym_identifier,
    ACTIONS(2518), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [37877] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2520), 1,
      sym_identifier,
    ACTIONS(2522), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [37888] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2524), 1,
      anon_sym_LPAREN,
    ACTIONS(2526), 1,
      anon_sym_await,
    STATE(33), 1,
      sym__for_header,
  [37901] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2129), 3,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_RBRACK,
  [37910] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(588), 1,
      anon_sym_COMMA,
    ACTIONS(2528), 1,
      anon_sym_RBRACK,
    STATE(915), 1,
      aux_sym_array_repeat1,
  [37923] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(576), 1,
      anon_sym_COMMA,
    ACTIONS(2530), 1,
      anon_sym_RBRACK,
    STATE(1032), 1,
      aux_sym_array_pattern_repeat1,
  [37936] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(588), 1,
      anon_sym_COMMA,
    ACTIONS(1409), 1,
      anon_sym_RPAREN,
    STATE(1047), 1,
      aux_sym_array_repeat1,
  [37949] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2139), 1,
      anon_sym_LBRACE,
    STATE(519), 1,
      sym_class_body,
  [37959] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1881), 1,
      anon_sym_DOT,
    ACTIONS(2407), 1,
      anon_sym_GT,
  [37969] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2352), 1,
      sym_identifier,
    ACTIONS(2354), 1,
      anon_sym_LBRACK,
  [37979] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2532), 1,
      sym_identifier,
    ACTIONS(2534), 1,
      anon_sym_STAR,
  [37989] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2536), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [37997] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2139), 1,
      anon_sym_LBRACE,
    STATE(603), 1,
      sym_class_body,
  [38007] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2538), 1,
      anon_sym_LPAREN,
    STATE(1203), 1,
      sym_parenthesized_expression,
  [38017] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2540), 1,
      sym_identifier,
    ACTIONS(2542), 1,
      anon_sym_STAR,
  [38027] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2139), 1,
      anon_sym_LBRACE,
    STATE(524), 1,
      sym_class_body,
  [38037] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2544), 1,
      anon_sym_LBRACE,
    STATE(417), 1,
      sym_statement_block,
  [38047] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2544), 1,
      anon_sym_LBRACE,
    STATE(481), 1,
      sym_statement_block,
  [38057] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2546), 1,
      anon_sym_LBRACE,
    STATE(517), 1,
      sym_statement_block,
  [38067] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2440), 1,
      anon_sym_LBRACE,
    STATE(702), 1,
      sym_statement_block,
  [38077] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2538), 1,
      anon_sym_LPAREN,
    STATE(28), 1,
      sym_parenthesized_expression,
  [38087] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2440), 1,
      anon_sym_LBRACE,
    STATE(215), 1,
      sym_statement_block,
  [38097] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2133), 1,
      anon_sym_LBRACE,
    STATE(489), 1,
      sym_class_body,
  [38107] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2139), 1,
      anon_sym_LBRACE,
    STATE(237), 1,
      sym_class_body,
  [38117] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1192), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [38125] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2440), 1,
      anon_sym_LBRACE,
    STATE(732), 1,
      sym_statement_block,
  [38135] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2139), 1,
      anon_sym_LBRACE,
    STATE(567), 1,
      sym_class_body,
  [38145] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2546), 1,
      anon_sym_LBRACE,
    STATE(571), 1,
      sym_statement_block,
  [38155] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2133), 1,
      anon_sym_LBRACE,
    STATE(465), 1,
      sym_class_body,
  [38165] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2538), 1,
      anon_sym_LPAREN,
    STATE(36), 1,
      sym_parenthesized_expression,
  [38175] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2440), 1,
      anon_sym_LBRACE,
    STATE(726), 1,
      sym_statement_block,
  [38185] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2440), 1,
      anon_sym_LBRACE,
    STATE(228), 1,
      sym_statement_block,
  [38195] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2544), 1,
      anon_sym_LBRACE,
    STATE(428), 1,
      sym_statement_block,
  [38205] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2051), 1,
      anon_sym_LPAREN,
    STATE(1186), 1,
      sym_formal_parameters,
  [38215] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2544), 1,
      anon_sym_LBRACE,
    STATE(495), 1,
      sym_statement_block,
  [38225] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2546), 1,
      anon_sym_LBRACE,
    STATE(513), 1,
      sym_statement_block,
  [38235] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2546), 1,
      anon_sym_LBRACE,
    STATE(512), 1,
      sym_statement_block,
  [38245] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2203), 1,
      anon_sym_LBRACE,
    STATE(237), 1,
      sym_class_body,
  [38255] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2139), 1,
      anon_sym_LBRACE,
    STATE(49), 1,
      sym_class_body,
  [38265] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2051), 1,
      anon_sym_LPAREN,
    STATE(1189), 1,
      sym_formal_parameters,
  [38275] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1873), 1,
      anon_sym_COLON,
    ACTIONS(2482), 1,
      anon_sym_GT,
  [38285] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2051), 1,
      anon_sym_LPAREN,
    STATE(1190), 1,
      sym_formal_parameters,
  [38295] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1881), 1,
      anon_sym_DOT,
    ACTIONS(2482), 1,
      anon_sym_GT,
  [38305] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2548), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [38313] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2221), 1,
      sym_identifier,
    STATE(1209), 1,
      sym__import_export_specifier,
  [38323] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2139), 1,
      anon_sym_LBRACE,
    STATE(224), 1,
      sym_class_body,
  [38333] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2544), 1,
      anon_sym_LBRACE,
    STATE(478), 1,
      sym_statement_block,
  [38343] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2546), 1,
      anon_sym_LBRACE,
    STATE(595), 1,
      sym_statement_block,
  [38353] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2546), 1,
      anon_sym_LBRACE,
    STATE(596), 1,
      sym_statement_block,
  [38363] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2139), 1,
      anon_sym_LBRACE,
    STATE(628), 1,
      sym_class_body,
  [38373] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2051), 1,
      anon_sym_LPAREN,
    STATE(1200), 1,
      sym_formal_parameters,
  [38383] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2546), 1,
      anon_sym_LBRACE,
    STATE(508), 1,
      sym_statement_block,
  [38393] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2440), 1,
      anon_sym_LBRACE,
    STATE(718), 1,
      sym_statement_block,
  [38403] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2546), 1,
      anon_sym_LBRACE,
    STATE(624), 1,
      sym_statement_block,
  [38413] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2546), 1,
      anon_sym_LBRACE,
    STATE(59), 1,
      sym_statement_block,
  [38423] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2546), 1,
      anon_sym_LBRACE,
    STATE(612), 1,
      sym_statement_block,
  [38433] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2051), 1,
      anon_sym_LPAREN,
    STATE(1211), 1,
      sym_formal_parameters,
  [38443] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2546), 1,
      anon_sym_LBRACE,
    STATE(606), 1,
      sym_statement_block,
  [38453] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2051), 1,
      anon_sym_LPAREN,
    STATE(1210), 1,
      sym_formal_parameters,
  [38463] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2440), 1,
      anon_sym_LBRACE,
    STATE(703), 1,
      sym_statement_block,
  [38473] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2440), 1,
      anon_sym_LBRACE,
    STATE(717), 1,
      sym_statement_block,
  [38483] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1847), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [38491] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2051), 1,
      anon_sym_LPAREN,
    STATE(1086), 1,
      sym_formal_parameters,
  [38501] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2133), 1,
      anon_sym_LBRACE,
    STATE(467), 1,
      sym_class_body,
  [38511] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2051), 1,
      anon_sym_LPAREN,
    STATE(1092), 1,
      sym_formal_parameters,
  [38521] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2051), 1,
      anon_sym_LPAREN,
    STATE(1241), 1,
      sym_formal_parameters,
  [38531] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2550), 1,
      sym_identifier,
    ACTIONS(2552), 1,
      sym_jsx_identifier,
  [38541] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2051), 1,
      anon_sym_LPAREN,
    STATE(1097), 1,
      sym_formal_parameters,
  [38551] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2051), 1,
      anon_sym_LPAREN,
    STATE(1243), 1,
      sym_formal_parameters,
  [38561] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2554), 1,
      anon_sym_LBRACE,
    STATE(238), 1,
      sym_statement_block,
  [38571] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2440), 1,
      anon_sym_LBRACE,
    STATE(707), 1,
      sym_statement_block,
  [38581] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2051), 1,
      anon_sym_LPAREN,
    STATE(1230), 1,
      sym_formal_parameters,
  [38591] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2440), 1,
      anon_sym_LBRACE,
    STATE(713), 1,
      sym_statement_block,
  [38601] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2450), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [38609] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2440), 1,
      anon_sym_LBRACE,
    STATE(269), 1,
      sym_statement_block,
  [38619] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2556), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [38627] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2558), 1,
      anon_sym_LPAREN,
    STATE(1184), 1,
      sym_parenthesized_expression,
  [38637] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2051), 1,
      anon_sym_LPAREN,
    STATE(1247), 1,
      sym_formal_parameters,
  [38647] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2051), 1,
      anon_sym_LPAREN,
    STATE(1226), 1,
      sym_formal_parameters,
  [38657] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2560), 2,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
  [38665] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2051), 1,
      anon_sym_LPAREN,
    STATE(1171), 1,
      sym_formal_parameters,
  [38675] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2051), 1,
      anon_sym_LPAREN,
    STATE(1218), 1,
      sym_formal_parameters,
  [38685] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2051), 1,
      anon_sym_LPAREN,
    STATE(1216), 1,
      sym_formal_parameters,
  [38695] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2051), 1,
      anon_sym_LPAREN,
    STATE(1214), 1,
      sym_formal_parameters,
  [38705] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2440), 1,
      anon_sym_LBRACE,
    STATE(723), 1,
      sym_statement_block,
  [38715] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2440), 1,
      anon_sym_LBRACE,
    STATE(710), 1,
      sym_statement_block,
  [38725] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2440), 1,
      anon_sym_LBRACE,
    STATE(709), 1,
      sym_statement_block,
  [38735] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2440), 1,
      anon_sym_LBRACE,
    STATE(708), 1,
      sym_statement_block,
  [38745] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2440), 1,
      anon_sym_LBRACE,
    STATE(705), 1,
      sym_statement_block,
  [38755] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1403), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [38763] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2554), 1,
      anon_sym_LBRACE,
    STATE(229), 1,
      sym_statement_block,
  [38773] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2562), 1,
      anon_sym_SEMI,
    ACTIONS(2564), 1,
      sym__automatic_semicolon,
  [38783] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2271), 1,
      anon_sym_from,
    STATE(1213), 1,
      sym__from_clause,
  [38793] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2221), 1,
      sym_identifier,
    STATE(1235), 1,
      sym__import_export_specifier,
  [38803] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2546), 1,
      anon_sym_LBRACE,
    STATE(61), 1,
      sym_statement_block,
  [38813] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2566), 1,
      sym_identifier,
    ACTIONS(2568), 1,
      anon_sym_STAR,
  [38823] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2570), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [38831] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2133), 1,
      anon_sym_LBRACE,
    STATE(435), 1,
      sym_class_body,
  [38841] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2572), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [38849] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2051), 1,
      anon_sym_LPAREN,
    STATE(1151), 1,
      sym_formal_parameters,
  [38859] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2440), 1,
      anon_sym_LBRACE,
    STATE(724), 1,
      sym_statement_block,
  [38869] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2051), 1,
      anon_sym_LPAREN,
    STATE(1121), 1,
      sym_formal_parameters,
  [38879] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2051), 1,
      anon_sym_LPAREN,
    STATE(1178), 1,
      sym_formal_parameters,
  [38889] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2051), 1,
      anon_sym_LPAREN,
    STATE(1174), 1,
      sym_formal_parameters,
  [38899] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2544), 1,
      anon_sym_LBRACE,
    STATE(462), 1,
      sym_statement_block,
  [38909] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2574), 2,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
  [38917] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2576), 2,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
  [38925] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2544), 1,
      anon_sym_LBRACE,
    STATE(437), 1,
      sym_statement_block,
  [38935] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1627), 1,
      anon_sym_LPAREN,
    ACTIONS(2578), 1,
      anon_sym_EQ_GT,
  [38945] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1627), 1,
      anon_sym_LPAREN,
    ACTIONS(1801), 1,
      anon_sym_EQ_GT,
  [38955] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2394), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [38963] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2544), 1,
      anon_sym_LBRACE,
    STATE(438), 1,
      sym_statement_block,
  [38973] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2401), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [38981] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2383), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [38989] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2051), 1,
      anon_sym_LPAREN,
    STATE(1137), 1,
      sym_formal_parameters,
  [38999] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2051), 1,
      anon_sym_LPAREN,
    STATE(1099), 1,
      sym_formal_parameters,
  [39009] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2580), 1,
      anon_sym_COMMA,
    ACTIONS(2582), 1,
      anon_sym_from,
  [39019] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2584), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [39027] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2271), 1,
      anon_sym_from,
    STATE(1158), 1,
      sym__from_clause,
  [39037] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2586), 1,
      anon_sym_LBRACE,
    STATE(229), 1,
      sym_statement_block,
  [39047] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2051), 1,
      anon_sym_LPAREN,
    STATE(1120), 1,
      sym_formal_parameters,
  [39057] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2588), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [39065] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2586), 1,
      anon_sym_LBRACE,
    STATE(230), 1,
      sym_statement_block,
  [39075] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2586), 1,
      anon_sym_LBRACE,
    STATE(231), 1,
      sym_statement_block,
  [39085] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2051), 1,
      anon_sym_LPAREN,
    STATE(1118), 1,
      sym_formal_parameters,
  [39095] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2015), 2,
      anon_sym_in,
      anon_sym_of,
  [39103] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2590), 1,
      anon_sym_SEMI,
    ACTIONS(2592), 1,
      sym__automatic_semicolon,
  [39113] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2051), 1,
      anon_sym_LPAREN,
    STATE(1136), 1,
      sym_formal_parameters,
  [39123] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2051), 1,
      anon_sym_LPAREN,
    STATE(1115), 1,
      sym_formal_parameters,
  [39133] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2594), 1,
      sym_identifier,
    ACTIONS(2596), 1,
      anon_sym_STAR,
  [39143] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2051), 1,
      anon_sym_LPAREN,
    STATE(1114), 1,
      sym_formal_parameters,
  [39153] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2598), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [39161] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2051), 1,
      anon_sym_LPAREN,
    STATE(1161), 1,
      sym_formal_parameters,
  [39171] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2586), 1,
      anon_sym_LBRACE,
    STATE(238), 1,
      sym_statement_block,
  [39181] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2051), 1,
      anon_sym_LPAREN,
    STATE(1103), 1,
      sym_formal_parameters,
  [39191] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2051), 1,
      anon_sym_LPAREN,
    STATE(1102), 1,
      sym_formal_parameters,
  [39201] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2600), 1,
      anon_sym_LBRACE,
    STATE(299), 1,
      sym_switch_body,
  [39211] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2602), 1,
      anon_sym_LPAREN,
    STATE(26), 1,
      sym__for_header,
  [39221] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1873), 1,
      anon_sym_COLON,
    ACTIONS(2374), 1,
      anon_sym_GT,
  [39231] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2546), 1,
      anon_sym_LBRACE,
    STATE(604), 1,
      sym_statement_block,
  [39241] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1881), 1,
      anon_sym_DOT,
    ACTIONS(2374), 1,
      anon_sym_GT,
  [39251] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2604), 2,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
  [39259] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2606), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [39267] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2546), 1,
      anon_sym_LBRACE,
    STATE(48), 1,
      sym_statement_block,
  [39277] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2546), 1,
      anon_sym_LBRACE,
    STATE(56), 1,
      sym_statement_block,
  [39287] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2051), 1,
      anon_sym_LPAREN,
    STATE(1094), 1,
      sym_formal_parameters,
  [39297] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2608), 1,
      anon_sym_SEMI,
    ACTIONS(2610), 1,
      sym__automatic_semicolon,
  [39307] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2440), 1,
      anon_sym_LBRACE,
    STATE(719), 1,
      sym_statement_block,
  [39317] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1873), 1,
      anon_sym_COLON,
    ACTIONS(2407), 1,
      anon_sym_GT,
  [39327] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2440), 1,
      anon_sym_LBRACE,
    STATE(721), 1,
      sym_statement_block,
  [39337] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2308), 1,
      sym_identifier,
    ACTIONS(2310), 1,
      anon_sym_LBRACK,
  [39347] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2440), 1,
      anon_sym_LBRACE,
    STATE(722), 1,
      sym_statement_block,
  [39357] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2051), 1,
      anon_sym_LPAREN,
    STATE(1119), 1,
      sym_formal_parameters,
  [39367] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2139), 1,
      anon_sym_LBRACE,
    STATE(52), 1,
      sym_class_body,
  [39377] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2051), 1,
      anon_sym_LPAREN,
    STATE(1126), 1,
      sym_formal_parameters,
  [39387] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2546), 1,
      anon_sym_LBRACE,
    STATE(545), 1,
      sym_statement_block,
  [39397] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2051), 1,
      anon_sym_LPAREN,
    STATE(1127), 1,
      sym_formal_parameters,
  [39407] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2051), 1,
      anon_sym_LPAREN,
    STATE(1085), 1,
      sym_formal_parameters,
  [39417] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2051), 1,
      anon_sym_LPAREN,
    STATE(1139), 1,
      sym_formal_parameters,
  [39427] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2440), 1,
      anon_sym_LBRACE,
    STATE(731), 1,
      sym_statement_block,
  [39437] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2612), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [39445] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2051), 1,
      anon_sym_LPAREN,
    STATE(1152), 1,
      sym_formal_parameters,
  [39455] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1873), 1,
      anon_sym_COLON,
    ACTIONS(2411), 1,
      anon_sym_GT,
  [39465] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2440), 1,
      anon_sym_LBRACE,
    STATE(727), 1,
      sym_statement_block,
  [39475] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1881), 1,
      anon_sym_DOT,
    ACTIONS(2411), 1,
      anon_sym_GT,
  [39485] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2051), 1,
      anon_sym_LPAREN,
    STATE(1153), 1,
      sym_formal_parameters,
  [39495] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2602), 1,
      anon_sym_LPAREN,
    STATE(25), 1,
      sym__for_header,
  [39505] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1393), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [39513] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2614), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [39521] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2616), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [39529] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2538), 1,
      anon_sym_LPAREN,
    STATE(38), 1,
      sym_parenthesized_expression,
  [39539] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2051), 1,
      anon_sym_LPAREN,
    STATE(1157), 1,
      sym_formal_parameters,
  [39549] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1405), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [39557] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2139), 1,
      anon_sym_LBRACE,
    STATE(540), 1,
      sym_class_body,
  [39567] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2554), 1,
      anon_sym_LBRACE,
    STATE(231), 1,
      sym_statement_block,
  [39577] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2051), 1,
      anon_sym_LPAREN,
    STATE(1154), 1,
      sym_formal_parameters,
  [39587] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2554), 1,
      anon_sym_LBRACE,
    STATE(230), 1,
      sym_statement_block,
  [39597] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2203), 1,
      anon_sym_LBRACE,
    STATE(224), 1,
      sym_class_body,
  [39607] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2538), 1,
      anon_sym_LPAREN,
    STATE(41), 1,
      sym_parenthesized_expression,
  [39617] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1482), 2,
      anon_sym_LPAREN,
      anon_sym_COLON,
  [39625] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2440), 1,
      anon_sym_LBRACE,
    STATE(729), 1,
      sym_statement_block,
  [39635] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2538), 1,
      anon_sym_LPAREN,
    STATE(37), 1,
      sym_parenthesized_expression,
  [39645] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2538), 1,
      anon_sym_LPAREN,
    STATE(35), 1,
      sym_parenthesized_expression,
  [39655] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2051), 1,
      anon_sym_LPAREN,
    STATE(1155), 1,
      sym_formal_parameters,
  [39665] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2618), 1,
      anon_sym_EQ,
  [39672] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1496), 1,
      anon_sym_RPAREN,
  [39679] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2620), 1,
      anon_sym_SLASH2,
  [39686] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1801), 1,
      anon_sym_EQ_GT,
  [39693] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2622), 1,
      sym_identifier,
  [39700] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2578), 1,
      anon_sym_EQ_GT,
  [39707] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2624), 1,
      anon_sym_EQ_GT,
  [39714] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2626), 1,
      anon_sym_GT,
  [39721] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2411), 1,
      anon_sym_GT,
  [39728] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2628), 1,
      anon_sym_GT,
  [39735] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2630), 1,
      anon_sym_GT,
  [39742] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2632), 1,
      anon_sym_while,
  [39749] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2634), 1,
      anon_sym_GT,
  [39756] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2636), 1,
      anon_sym_GT,
  [39763] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2638), 1,
      anon_sym_GT,
  [39770] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2640), 1,
      anon_sym_GT,
  [39777] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2642), 1,
      anon_sym_EQ_GT,
  [39784] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2644), 1,
      anon_sym_target,
  [39791] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2407), 1,
      anon_sym_GT,
  [39798] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2646), 1,
      sym_identifier,
  [39805] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2308), 1,
      sym_identifier,
  [39812] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2352), 1,
      sym_identifier,
  [39819] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1498), 1,
      anon_sym_RBRACK,
  [39826] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2648), 1,
      anon_sym_from,
  [39833] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2650), 1,
      anon_sym_RBRACE,
  [39840] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2652), 1,
      anon_sym_GT,
  [39847] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2648), 1,
      anon_sym_from,
  [39854] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2374), 1,
      anon_sym_GT,
  [39861] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2654), 1,
      anon_sym_GT,
  [39868] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2656), 1,
      anon_sym_GT,
  [39875] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2658), 1,
      anon_sym_GT,
  [39882] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2660), 1,
      anon_sym_GT,
  [39889] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1484), 1,
      anon_sym_COLON,
  [39896] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1490), 1,
      anon_sym_RPAREN,
  [39903] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2662), 1,
      anon_sym_GT,
  [39910] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1494), 1,
      anon_sym_RPAREN,
  [39917] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1500), 1,
      anon_sym_RPAREN,
  [39924] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2664), 1,
      anon_sym_GT,
  [39931] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2666), 1,
      sym_identifier,
  [39938] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2668), 1,
      anon_sym_GT,
  [39945] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2670), 1,
      sym_identifier,
  [39952] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2672), 1,
      anon_sym_GT,
  [39959] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2674), 1,
      anon_sym_GT,
  [39966] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2676), 1,
      anon_sym_EQ_GT,
  [39973] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1488), 1,
      anon_sym_RPAREN,
  [39980] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2678), 1,
      anon_sym_EQ_GT,
  [39987] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2680), 1,
      anon_sym_EQ_GT,
  [39994] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2582), 1,
      anon_sym_from,
  [40001] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2682), 1,
      anon_sym_GT,
  [40008] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1456), 1,
      anon_sym_RPAREN,
  [40015] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1627), 1,
      anon_sym_LPAREN,
  [40022] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2684), 1,
      anon_sym_as,
  [40029] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1492), 1,
      anon_sym_RBRACE,
  [40036] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2686), 1,
      anon_sym_GT,
  [40043] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2688), 1,
      anon_sym_from,
  [40050] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2690), 1,
      anon_sym_COLON,
  [40057] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2692), 1,
      anon_sym_EQ,
  [40064] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2694), 1,
      anon_sym_RPAREN,
  [40071] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2696), 1,
      anon_sym_GT,
  [40078] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2698), 1,
      sym_identifier,
  [40085] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2700), 1,
      anon_sym_RBRACE,
  [40092] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2702), 1,
      anon_sym_function,
  [40099] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2704), 1,
      anon_sym_from,
  [40106] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2706), 1,
      sym_identifier,
  [40113] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1460), 1,
      anon_sym_RBRACE,
  [40120] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2708), 1,
      anon_sym_from,
  [40127] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2480), 1,
      anon_sym_EQ,
  [40134] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2710), 1,
      anon_sym_EQ_GT,
  [40141] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2712), 1,
      anon_sym_COLON,
  [40148] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2428), 1,
      anon_sym_EQ,
  [40155] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2714), 1,
      ts_builtin_sym_end,
  [40162] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2716), 1,
      anon_sym_EQ_GT,
  [40169] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2718), 1,
      anon_sym_from,
  [40176] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2720), 1,
      anon_sym_from,
  [40183] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2722), 1,
      anon_sym_from,
  [40190] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1477), 1,
      anon_sym_RPAREN,
  [40197] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2724), 1,
      anon_sym_SLASH2,
  [40204] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2726), 1,
      anon_sym_GT,
  [40211] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2728), 1,
      sym_identifier,
  [40218] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2730), 1,
      anon_sym_EQ_GT,
  [40225] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2732), 1,
      anon_sym_EQ_GT,
  [40232] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2734), 1,
      anon_sym_EQ_GT,
  [40239] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2362), 1,
      anon_sym_EQ,
  [40246] = 2,
    ACTIONS(1895), 1,
      sym_comment,
    ACTIONS(2736), 1,
      sym_regex_pattern,
  [40253] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2738), 1,
      anon_sym_GT,
  [40260] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2740), 1,
      anon_sym_target,
  [40267] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2482), 1,
      anon_sym_GT,
  [40274] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1486), 1,
      anon_sym_RPAREN,
  [40281] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2742), 1,
      sym_identifier,
  [40288] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1458), 1,
      anon_sym_RBRACK,
  [40295] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2744), 1,
      anon_sym_GT,
  [40302] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2746), 1,
      anon_sym_GT,
  [40309] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2748), 1,
      anon_sym_GT,
  [40316] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2750), 1,
      anon_sym_GT,
  [40323] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2752), 1,
      anon_sym_GT,
  [40330] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2754), 1,
      sym_identifier,
  [40337] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1464), 1,
      anon_sym_RBRACE,
  [40344] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1473), 1,
      anon_sym_RBRACK,
  [40351] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1475), 1,
      anon_sym_RBRACK,
  [40358] = 2,
    ACTIONS(1895), 1,
      sym_comment,
    ACTIONS(2756), 1,
      sym_regex_pattern,
  [40365] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2758), 1,
      anon_sym_GT,
  [40372] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2760), 1,
      sym_identifier,
  [40379] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2762), 1,
      sym_identifier,
  [40386] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2764), 1,
      sym_identifier,
  [40393] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2766), 1,
      anon_sym_function,
};

static uint32_t ts_small_parse_table_map[] = {
  [SMALL_STATE(207)] = 0,
  [SMALL_STATE(208)] = 87,
  [SMALL_STATE(209)] = 160,
  [SMALL_STATE(210)] = 233,
  [SMALL_STATE(211)] = 320,
  [SMALL_STATE(212)] = 406,
  [SMALL_STATE(213)] = 492,
  [SMALL_STATE(214)] = 582,
  [SMALL_STATE(215)] = 670,
  [SMALL_STATE(216)] = 748,
  [SMALL_STATE(217)] = 836,
  [SMALL_STATE(218)] = 906,
  [SMALL_STATE(219)] = 976,
  [SMALL_STATE(220)] = 1063,
  [SMALL_STATE(221)] = 1151,
  [SMALL_STATE(222)] = 1223,
  [SMALL_STATE(223)] = 1307,
  [SMALL_STATE(224)] = 1393,
  [SMALL_STATE(225)] = 1462,
  [SMALL_STATE(226)] = 1531,
  [SMALL_STATE(227)] = 1618,
  [SMALL_STATE(228)] = 1685,
  [SMALL_STATE(229)] = 1752,
  [SMALL_STATE(230)] = 1821,
  [SMALL_STATE(231)] = 1890,
  [SMALL_STATE(232)] = 1959,
  [SMALL_STATE(233)] = 2030,
  [SMALL_STATE(234)] = 2099,
  [SMALL_STATE(235)] = 2166,
  [SMALL_STATE(236)] = 2235,
  [SMALL_STATE(237)] = 2302,
  [SMALL_STATE(238)] = 2371,
  [SMALL_STATE(239)] = 2440,
  [SMALL_STATE(240)] = 2507,
  [SMALL_STATE(241)] = 2574,
  [SMALL_STATE(242)] = 2641,
  [SMALL_STATE(243)] = 2708,
  [SMALL_STATE(244)] = 2777,
  [SMALL_STATE(245)] = 2843,
  [SMALL_STATE(246)] = 2909,
  [SMALL_STATE(247)] = 2975,
  [SMALL_STATE(248)] = 3041,
  [SMALL_STATE(249)] = 3107,
  [SMALL_STATE(250)] = 3173,
  [SMALL_STATE(251)] = 3239,
  [SMALL_STATE(252)] = 3305,
  [SMALL_STATE(253)] = 3371,
  [SMALL_STATE(254)] = 3437,
  [SMALL_STATE(255)] = 3503,
  [SMALL_STATE(256)] = 3569,
  [SMALL_STATE(257)] = 3635,
  [SMALL_STATE(258)] = 3701,
  [SMALL_STATE(259)] = 3767,
  [SMALL_STATE(260)] = 3833,
  [SMALL_STATE(261)] = 3899,
  [SMALL_STATE(262)] = 3965,
  [SMALL_STATE(263)] = 4031,
  [SMALL_STATE(264)] = 4097,
  [SMALL_STATE(265)] = 4163,
  [SMALL_STATE(266)] = 4229,
  [SMALL_STATE(267)] = 4295,
  [SMALL_STATE(268)] = 4361,
  [SMALL_STATE(269)] = 4427,
  [SMALL_STATE(270)] = 4493,
  [SMALL_STATE(271)] = 4559,
  [SMALL_STATE(272)] = 4625,
  [SMALL_STATE(273)] = 4691,
  [SMALL_STATE(274)] = 4757,
  [SMALL_STATE(275)] = 4823,
  [SMALL_STATE(276)] = 4889,
  [SMALL_STATE(277)] = 4955,
  [SMALL_STATE(278)] = 5021,
  [SMALL_STATE(279)] = 5087,
  [SMALL_STATE(280)] = 5153,
  [SMALL_STATE(281)] = 5219,
  [SMALL_STATE(282)] = 5285,
  [SMALL_STATE(283)] = 5351,
  [SMALL_STATE(284)] = 5417,
  [SMALL_STATE(285)] = 5483,
  [SMALL_STATE(286)] = 5549,
  [SMALL_STATE(287)] = 5615,
  [SMALL_STATE(288)] = 5681,
  [SMALL_STATE(289)] = 5747,
  [SMALL_STATE(290)] = 5813,
  [SMALL_STATE(291)] = 5879,
  [SMALL_STATE(292)] = 5945,
  [SMALL_STATE(293)] = 6011,
  [SMALL_STATE(294)] = 6077,
  [SMALL_STATE(295)] = 6143,
  [SMALL_STATE(296)] = 6209,
  [SMALL_STATE(297)] = 6275,
  [SMALL_STATE(298)] = 6341,
  [SMALL_STATE(299)] = 6407,
  [SMALL_STATE(300)] = 6473,
  [SMALL_STATE(301)] = 6539,
  [SMALL_STATE(302)] = 6605,
  [SMALL_STATE(303)] = 6671,
  [SMALL_STATE(304)] = 6737,
  [SMALL_STATE(305)] = 6803,
  [SMALL_STATE(306)] = 6869,
  [SMALL_STATE(307)] = 6935,
  [SMALL_STATE(308)] = 7001,
  [SMALL_STATE(309)] = 7067,
  [SMALL_STATE(310)] = 7133,
  [SMALL_STATE(311)] = 7199,
  [SMALL_STATE(312)] = 7265,
  [SMALL_STATE(313)] = 7331,
  [SMALL_STATE(314)] = 7397,
  [SMALL_STATE(315)] = 7463,
  [SMALL_STATE(316)] = 7529,
  [SMALL_STATE(317)] = 7595,
  [SMALL_STATE(318)] = 7661,
  [SMALL_STATE(319)] = 7727,
  [SMALL_STATE(320)] = 7793,
  [SMALL_STATE(321)] = 7859,
  [SMALL_STATE(322)] = 7925,
  [SMALL_STATE(323)] = 7991,
  [SMALL_STATE(324)] = 8057,
  [SMALL_STATE(325)] = 8123,
  [SMALL_STATE(326)] = 8189,
  [SMALL_STATE(327)] = 8255,
  [SMALL_STATE(328)] = 8321,
  [SMALL_STATE(329)] = 8387,
  [SMALL_STATE(330)] = 8453,
  [SMALL_STATE(331)] = 8519,
  [SMALL_STATE(332)] = 8585,
  [SMALL_STATE(333)] = 8666,
  [SMALL_STATE(334)] = 8747,
  [SMALL_STATE(335)] = 8828,
  [SMALL_STATE(336)] = 8892,
  [SMALL_STATE(337)] = 8956,
  [SMALL_STATE(338)] = 9020,
  [SMALL_STATE(339)] = 9084,
  [SMALL_STATE(340)] = 9153,
  [SMALL_STATE(341)] = 9220,
  [SMALL_STATE(342)] = 9289,
  [SMALL_STATE(343)] = 9358,
  [SMALL_STATE(344)] = 9427,
  [SMALL_STATE(345)] = 9489,
  [SMALL_STATE(346)] = 9557,
  [SMALL_STATE(347)] = 9625,
  [SMALL_STATE(348)] = 9695,
  [SMALL_STATE(349)] = 9757,
  [SMALL_STATE(350)] = 9827,
  [SMALL_STATE(351)] = 9897,
  [SMALL_STATE(352)] = 9959,
  [SMALL_STATE(353)] = 10029,
  [SMALL_STATE(354)] = 10097,
  [SMALL_STATE(355)] = 10169,
  [SMALL_STATE(356)] = 10235,
  [SMALL_STATE(357)] = 10307,
  [SMALL_STATE(358)] = 10375,
  [SMALL_STATE(359)] = 10437,
  [SMALL_STATE(360)] = 10506,
  [SMALL_STATE(361)] = 10575,
  [SMALL_STATE(362)] = 10636,
  [SMALL_STATE(363)] = 10701,
  [SMALL_STATE(364)] = 10770,
  [SMALL_STATE(365)] = 10831,
  [SMALL_STATE(366)] = 10892,
  [SMALL_STATE(367)] = 10953,
  [SMALL_STATE(368)] = 11018,
  [SMALL_STATE(369)] = 11084,
  [SMALL_STATE(370)] = 11150,
  [SMALL_STATE(371)] = 11220,
  [SMALL_STATE(372)] = 11288,
  [SMALL_STATE(373)] = 11356,
  [SMALL_STATE(374)] = 11424,
  [SMALL_STATE(375)] = 11494,
  [SMALL_STATE(376)] = 11562,
  [SMALL_STATE(377)] = 11631,
  [SMALL_STATE(378)] = 11700,
  [SMALL_STATE(379)] = 11758,
  [SMALL_STATE(380)] = 11816,
  [SMALL_STATE(381)] = 11882,
  [SMALL_STATE(382)] = 11940,
  [SMALL_STATE(383)] = 12008,
  [SMALL_STATE(384)] = 12071,
  [SMALL_STATE(385)] = 12124,
  [SMALL_STATE(386)] = 12187,
  [SMALL_STATE(387)] = 12250,
  [SMALL_STATE(388)] = 12311,
  [SMALL_STATE(389)] = 12397,
  [SMALL_STATE(390)] = 12483,
  [SMALL_STATE(391)] = 12569,
  [SMALL_STATE(392)] = 12655,
  [SMALL_STATE(393)] = 12705,
  [SMALL_STATE(394)] = 12789,
  [SMALL_STATE(395)] = 12839,
  [SMALL_STATE(396)] = 12913,
  [SMALL_STATE(397)] = 12983,
  [SMALL_STATE(398)] = 13035,
  [SMALL_STATE(399)] = 13121,
  [SMALL_STATE(400)] = 13207,
  [SMALL_STATE(401)] = 13265,
  [SMALL_STATE(402)] = 13351,
  [SMALL_STATE(403)] = 13403,
  [SMALL_STATE(404)] = 13455,
  [SMALL_STATE(405)] = 13541,
  [SMALL_STATE(406)] = 13627,
  [SMALL_STATE(407)] = 13691,
  [SMALL_STATE(408)] = 13777,
  [SMALL_STATE(409)] = 13865,
  [SMALL_STATE(410)] = 13951,
  [SMALL_STATE(411)] = 14037,
  [SMALL_STATE(412)] = 14087,
  [SMALL_STATE(413)] = 14163,
  [SMALL_STATE(414)] = 14243,
  [SMALL_STATE(415)] = 14329,
  [SMALL_STATE(416)] = 14397,
  [SMALL_STATE(417)] = 14444,
  [SMALL_STATE(418)] = 14491,
  [SMALL_STATE(419)] = 14538,
  [SMALL_STATE(420)] = 14585,
  [SMALL_STATE(421)] = 14632,
  [SMALL_STATE(422)] = 14679,
  [SMALL_STATE(423)] = 14726,
  [SMALL_STATE(424)] = 14779,
  [SMALL_STATE(425)] = 14826,
  [SMALL_STATE(426)] = 14879,
  [SMALL_STATE(427)] = 14926,
  [SMALL_STATE(428)] = 15011,
  [SMALL_STATE(429)] = 15058,
  [SMALL_STATE(430)] = 15143,
  [SMALL_STATE(431)] = 15190,
  [SMALL_STATE(432)] = 15237,
  [SMALL_STATE(433)] = 15300,
  [SMALL_STATE(434)] = 15385,
  [SMALL_STATE(435)] = 15432,
  [SMALL_STATE(436)] = 15479,
  [SMALL_STATE(437)] = 15526,
  [SMALL_STATE(438)] = 15573,
  [SMALL_STATE(439)] = 15620,
  [SMALL_STATE(440)] = 15693,
  [SMALL_STATE(441)] = 15740,
  [SMALL_STATE(442)] = 15789,
  [SMALL_STATE(443)] = 15858,
  [SMALL_STATE(444)] = 15933,
  [SMALL_STATE(445)] = 16012,
  [SMALL_STATE(446)] = 16079,
  [SMALL_STATE(447)] = 16140,
  [SMALL_STATE(448)] = 16223,
  [SMALL_STATE(449)] = 16308,
  [SMALL_STATE(450)] = 16393,
  [SMALL_STATE(451)] = 16478,
  [SMALL_STATE(452)] = 16525,
  [SMALL_STATE(453)] = 16572,
  [SMALL_STATE(454)] = 16619,
  [SMALL_STATE(455)] = 16666,
  [SMALL_STATE(456)] = 16713,
  [SMALL_STATE(457)] = 16760,
  [SMALL_STATE(458)] = 16845,
  [SMALL_STATE(459)] = 16892,
  [SMALL_STATE(460)] = 16939,
  [SMALL_STATE(461)] = 16986,
  [SMALL_STATE(462)] = 17033,
  [SMALL_STATE(463)] = 17080,
  [SMALL_STATE(464)] = 17127,
  [SMALL_STATE(465)] = 17174,
  [SMALL_STATE(466)] = 17221,
  [SMALL_STATE(467)] = 17268,
  [SMALL_STATE(468)] = 17315,
  [SMALL_STATE(469)] = 17362,
  [SMALL_STATE(470)] = 17447,
  [SMALL_STATE(471)] = 17496,
  [SMALL_STATE(472)] = 17543,
  [SMALL_STATE(473)] = 17590,
  [SMALL_STATE(474)] = 17679,
  [SMALL_STATE(475)] = 17726,
  [SMALL_STATE(476)] = 17811,
  [SMALL_STATE(477)] = 17860,
  [SMALL_STATE(478)] = 17907,
  [SMALL_STATE(479)] = 17954,
  [SMALL_STATE(480)] = 18001,
  [SMALL_STATE(481)] = 18086,
  [SMALL_STATE(482)] = 18133,
  [SMALL_STATE(483)] = 18222,
  [SMALL_STATE(484)] = 18307,
  [SMALL_STATE(485)] = 18354,
  [SMALL_STATE(486)] = 18401,
  [SMALL_STATE(487)] = 18448,
  [SMALL_STATE(488)] = 18537,
  [SMALL_STATE(489)] = 18598,
  [SMALL_STATE(490)] = 18645,
  [SMALL_STATE(491)] = 18692,
  [SMALL_STATE(492)] = 18739,
  [SMALL_STATE(493)] = 18786,
  [SMALL_STATE(494)] = 18833,
  [SMALL_STATE(495)] = 18880,
  [SMALL_STATE(496)] = 18927,
  [SMALL_STATE(497)] = 18988,
  [SMALL_STATE(498)] = 19035,
  [SMALL_STATE(499)] = 19120,
  [SMALL_STATE(500)] = 19179,
  [SMALL_STATE(501)] = 19226,
  [SMALL_STATE(502)] = 19311,
  [SMALL_STATE(503)] = 19358,
  [SMALL_STATE(504)] = 19443,
  [SMALL_STATE(505)] = 19490,
  [SMALL_STATE(506)] = 19538,
  [SMALL_STATE(507)] = 19626,
  [SMALL_STATE(508)] = 19712,
  [SMALL_STATE(509)] = 19762,
  [SMALL_STATE(510)] = 19812,
  [SMALL_STATE(511)] = 19896,
  [SMALL_STATE(512)] = 19944,
  [SMALL_STATE(513)] = 19994,
  [SMALL_STATE(514)] = 20044,
  [SMALL_STATE(515)] = 20094,
  [SMALL_STATE(516)] = 20182,
  [SMALL_STATE(517)] = 20230,
  [SMALL_STATE(518)] = 20280,
  [SMALL_STATE(519)] = 20336,
  [SMALL_STATE(520)] = 20386,
  [SMALL_STATE(521)] = 20436,
  [SMALL_STATE(522)] = 20520,
  [SMALL_STATE(523)] = 20606,
  [SMALL_STATE(524)] = 20692,
  [SMALL_STATE(525)] = 20742,
  [SMALL_STATE(526)] = 20830,
  [SMALL_STATE(527)] = 20918,
  [SMALL_STATE(528)] = 20970,
  [SMALL_STATE(529)] = 21022,
  [SMALL_STATE(530)] = 21070,
  [SMALL_STATE(531)] = 21154,
  [SMALL_STATE(532)] = 21242,
  [SMALL_STATE(533)] = 21294,
  [SMALL_STATE(534)] = 21380,
  [SMALL_STATE(535)] = 21425,
  [SMALL_STATE(536)] = 21502,
  [SMALL_STATE(537)] = 21585,
  [SMALL_STATE(538)] = 21630,
  [SMALL_STATE(539)] = 21675,
  [SMALL_STATE(540)] = 21720,
  [SMALL_STATE(541)] = 21765,
  [SMALL_STATE(542)] = 21848,
  [SMALL_STATE(543)] = 21931,
  [SMALL_STATE(544)] = 21992,
  [SMALL_STATE(545)] = 22063,
  [SMALL_STATE(546)] = 22108,
  [SMALL_STATE(547)] = 22159,
  [SMALL_STATE(548)] = 22204,
  [SMALL_STATE(549)] = 22249,
  [SMALL_STATE(550)] = 22334,
  [SMALL_STATE(551)] = 22379,
  [SMALL_STATE(552)] = 22424,
  [SMALL_STATE(553)] = 22469,
  [SMALL_STATE(554)] = 22554,
  [SMALL_STATE(555)] = 22599,
  [SMALL_STATE(556)] = 22684,
  [SMALL_STATE(557)] = 22729,
  [SMALL_STATE(558)] = 22774,
  [SMALL_STATE(559)] = 22857,
  [SMALL_STATE(560)] = 22942,
  [SMALL_STATE(561)] = 22987,
  [SMALL_STATE(562)] = 23070,
  [SMALL_STATE(563)] = 23153,
  [SMALL_STATE(564)] = 23236,
  [SMALL_STATE(565)] = 23285,
  [SMALL_STATE(566)] = 23330,
  [SMALL_STATE(567)] = 23375,
  [SMALL_STATE(568)] = 23420,
  [SMALL_STATE(569)] = 23505,
  [SMALL_STATE(570)] = 23550,
  [SMALL_STATE(571)] = 23595,
  [SMALL_STATE(572)] = 23640,
  [SMALL_STATE(573)] = 23725,
  [SMALL_STATE(574)] = 23792,
  [SMALL_STATE(575)] = 23875,
  [SMALL_STATE(576)] = 23920,
  [SMALL_STATE(577)] = 23993,
  [SMALL_STATE(578)] = 24038,
  [SMALL_STATE(579)] = 24123,
  [SMALL_STATE(580)] = 24172,
  [SMALL_STATE(581)] = 24217,
  [SMALL_STATE(582)] = 24302,
  [SMALL_STATE(583)] = 24347,
  [SMALL_STATE(584)] = 24432,
  [SMALL_STATE(585)] = 24515,
  [SMALL_STATE(586)] = 24600,
  [SMALL_STATE(587)] = 24645,
  [SMALL_STATE(588)] = 24730,
  [SMALL_STATE(589)] = 24775,
  [SMALL_STATE(590)] = 24860,
  [SMALL_STATE(591)] = 24905,
  [SMALL_STATE(592)] = 24988,
  [SMALL_STATE(593)] = 25033,
  [SMALL_STATE(594)] = 25118,
  [SMALL_STATE(595)] = 25163,
  [SMALL_STATE(596)] = 25208,
  [SMALL_STATE(597)] = 25253,
  [SMALL_STATE(598)] = 25318,
  [SMALL_STATE(599)] = 25363,
  [SMALL_STATE(600)] = 25408,
  [SMALL_STATE(601)] = 25489,
  [SMALL_STATE(602)] = 25534,
  [SMALL_STATE(603)] = 25619,
  [SMALL_STATE(604)] = 25664,
  [SMALL_STATE(605)] = 25709,
  [SMALL_STATE(606)] = 25754,
  [SMALL_STATE(607)] = 25799,
  [SMALL_STATE(608)] = 25844,
  [SMALL_STATE(609)] = 25889,
  [SMALL_STATE(610)] = 25934,
  [SMALL_STATE(611)] = 25979,
  [SMALL_STATE(612)] = 26024,
  [SMALL_STATE(613)] = 26069,
  [SMALL_STATE(614)] = 26114,
  [SMALL_STATE(615)] = 26159,
  [SMALL_STATE(616)] = 26242,
  [SMALL_STATE(617)] = 26325,
  [SMALL_STATE(618)] = 26370,
  [SMALL_STATE(619)] = 26453,
  [SMALL_STATE(620)] = 26538,
  [SMALL_STATE(621)] = 26583,
  [SMALL_STATE(622)] = 26666,
  [SMALL_STATE(623)] = 26749,
  [SMALL_STATE(624)] = 26832,
  [SMALL_STATE(625)] = 26877,
  [SMALL_STATE(626)] = 26960,
  [SMALL_STATE(627)] = 27045,
  [SMALL_STATE(628)] = 27130,
  [SMALL_STATE(629)] = 27175,
  [SMALL_STATE(630)] = 27257,
  [SMALL_STATE(631)] = 27339,
  [SMALL_STATE(632)] = 27421,
  [SMALL_STATE(633)] = 27503,
  [SMALL_STATE(634)] = 27585,
  [SMALL_STATE(635)] = 27635,
  [SMALL_STATE(636)] = 27685,
  [SMALL_STATE(637)] = 27735,
  [SMALL_STATE(638)] = 27817,
  [SMALL_STATE(639)] = 27866,
  [SMALL_STATE(640)] = 27945,
  [SMALL_STATE(641)] = 28024,
  [SMALL_STATE(642)] = 28073,
  [SMALL_STATE(643)] = 28122,
  [SMALL_STATE(644)] = 28202,
  [SMALL_STATE(645)] = 28282,
  [SMALL_STATE(646)] = 28362,
  [SMALL_STATE(647)] = 28442,
  [SMALL_STATE(648)] = 28522,
  [SMALL_STATE(649)] = 28602,
  [SMALL_STATE(650)] = 28674,
  [SMALL_STATE(651)] = 28728,
  [SMALL_STATE(652)] = 28782,
  [SMALL_STATE(653)] = 28831,
  [SMALL_STATE(654)] = 28890,
  [SMALL_STATE(655)] = 28943,
  [SMALL_STATE(656)] = 28996,
  [SMALL_STATE(657)] = 29051,
  [SMALL_STATE(658)] = 29106,
  [SMALL_STATE(659)] = 29159,
  [SMALL_STATE(660)] = 29218,
  [SMALL_STATE(661)] = 29277,
  [SMALL_STATE(662)] = 29336,
  [SMALL_STATE(663)] = 29395,
  [SMALL_STATE(664)] = 29454,
  [SMALL_STATE(665)] = 29513,
  [SMALL_STATE(666)] = 29572,
  [SMALL_STATE(667)] = 29627,
  [SMALL_STATE(668)] = 29682,
  [SMALL_STATE(669)] = 29735,
  [SMALL_STATE(670)] = 29788,
  [SMALL_STATE(671)] = 29843,
  [SMALL_STATE(672)] = 29896,
  [SMALL_STATE(673)] = 29951,
  [SMALL_STATE(674)] = 29999,
  [SMALL_STATE(675)] = 30047,
  [SMALL_STATE(676)] = 30095,
  [SMALL_STATE(677)] = 30143,
  [SMALL_STATE(678)] = 30191,
  [SMALL_STATE(679)] = 30239,
  [SMALL_STATE(680)] = 30286,
  [SMALL_STATE(681)] = 30331,
  [SMALL_STATE(682)] = 30373,
  [SMALL_STATE(683)] = 30415,
  [SMALL_STATE(684)] = 30459,
  [SMALL_STATE(685)] = 30499,
  [SMALL_STATE(686)] = 30543,
  [SMALL_STATE(687)] = 30583,
  [SMALL_STATE(688)] = 30623,
  [SMALL_STATE(689)] = 30677,
  [SMALL_STATE(690)] = 30721,
  [SMALL_STATE(691)] = 30756,
  [SMALL_STATE(692)] = 30791,
  [SMALL_STATE(693)] = 30830,
  [SMALL_STATE(694)] = 30875,
  [SMALL_STATE(695)] = 30912,
  [SMALL_STATE(696)] = 30961,
  [SMALL_STATE(697)] = 30999,
  [SMALL_STATE(698)] = 31037,
  [SMALL_STATE(699)] = 31079,
  [SMALL_STATE(700)] = 31109,
  [SMALL_STATE(701)] = 31147,
  [SMALL_STATE(702)] = 31189,
  [SMALL_STATE(703)] = 31212,
  [SMALL_STATE(704)] = 31235,
  [SMALL_STATE(705)] = 31258,
  [SMALL_STATE(706)] = 31281,
  [SMALL_STATE(707)] = 31318,
  [SMALL_STATE(708)] = 31341,
  [SMALL_STATE(709)] = 31364,
  [SMALL_STATE(710)] = 31387,
  [SMALL_STATE(711)] = 31410,
  [SMALL_STATE(712)] = 31445,
  [SMALL_STATE(713)] = 31466,
  [SMALL_STATE(714)] = 31489,
  [SMALL_STATE(715)] = 31510,
  [SMALL_STATE(716)] = 31549,
  [SMALL_STATE(717)] = 31578,
  [SMALL_STATE(718)] = 31601,
  [SMALL_STATE(719)] = 31624,
  [SMALL_STATE(720)] = 31647,
  [SMALL_STATE(721)] = 31668,
  [SMALL_STATE(722)] = 31691,
  [SMALL_STATE(723)] = 31714,
  [SMALL_STATE(724)] = 31737,
  [SMALL_STATE(725)] = 31760,
  [SMALL_STATE(726)] = 31795,
  [SMALL_STATE(727)] = 31818,
  [SMALL_STATE(728)] = 31841,
  [SMALL_STATE(729)] = 31882,
  [SMALL_STATE(730)] = 31905,
  [SMALL_STATE(731)] = 31944,
  [SMALL_STATE(732)] = 31967,
  [SMALL_STATE(733)] = 31990,
  [SMALL_STATE(734)] = 32022,
  [SMALL_STATE(735)] = 32054,
  [SMALL_STATE(736)] = 32086,
  [SMALL_STATE(737)] = 32118,
  [SMALL_STATE(738)] = 32150,
  [SMALL_STATE(739)] = 32182,
  [SMALL_STATE(740)] = 32214,
  [SMALL_STATE(741)] = 32246,
  [SMALL_STATE(742)] = 32278,
  [SMALL_STATE(743)] = 32310,
  [SMALL_STATE(744)] = 32342,
  [SMALL_STATE(745)] = 32366,
  [SMALL_STATE(746)] = 32395,
  [SMALL_STATE(747)] = 32424,
  [SMALL_STATE(748)] = 32453,
  [SMALL_STATE(749)] = 32474,
  [SMALL_STATE(750)] = 32495,
  [SMALL_STATE(751)] = 32516,
  [SMALL_STATE(752)] = 32545,
  [SMALL_STATE(753)] = 32574,
  [SMALL_STATE(754)] = 32595,
  [SMALL_STATE(755)] = 32624,
  [SMALL_STATE(756)] = 32653,
  [SMALL_STATE(757)] = 32688,
  [SMALL_STATE(758)] = 32723,
  [SMALL_STATE(759)] = 32758,
  [SMALL_STATE(760)] = 32793,
  [SMALL_STATE(761)] = 32819,
  [SMALL_STATE(762)] = 32851,
  [SMALL_STATE(763)] = 32883,
  [SMALL_STATE(764)] = 32909,
  [SMALL_STATE(765)] = 32941,
  [SMALL_STATE(766)] = 32967,
  [SMALL_STATE(767)] = 32993,
  [SMALL_STATE(768)] = 33019,
  [SMALL_STATE(769)] = 33045,
  [SMALL_STATE(770)] = 33077,
  [SMALL_STATE(771)] = 33103,
  [SMALL_STATE(772)] = 33135,
  [SMALL_STATE(773)] = 33161,
  [SMALL_STATE(774)] = 33187,
  [SMALL_STATE(775)] = 33213,
  [SMALL_STATE(776)] = 33245,
  [SMALL_STATE(777)] = 33277,
  [SMALL_STATE(778)] = 33309,
  [SMALL_STATE(779)] = 33332,
  [SMALL_STATE(780)] = 33361,
  [SMALL_STATE(781)] = 33384,
  [SMALL_STATE(782)] = 33413,
  [SMALL_STATE(783)] = 33436,
  [SMALL_STATE(784)] = 33465,
  [SMALL_STATE(785)] = 33494,
  [SMALL_STATE(786)] = 33523,
  [SMALL_STATE(787)] = 33546,
  [SMALL_STATE(788)] = 33575,
  [SMALL_STATE(789)] = 33598,
  [SMALL_STATE(790)] = 33627,
  [SMALL_STATE(791)] = 33650,
  [SMALL_STATE(792)] = 33673,
  [SMALL_STATE(793)] = 33702,
  [SMALL_STATE(794)] = 33731,
  [SMALL_STATE(795)] = 33760,
  [SMALL_STATE(796)] = 33789,
  [SMALL_STATE(797)] = 33818,
  [SMALL_STATE(798)] = 33841,
  [SMALL_STATE(799)] = 33870,
  [SMALL_STATE(800)] = 33899,
  [SMALL_STATE(801)] = 33928,
  [SMALL_STATE(802)] = 33951,
  [SMALL_STATE(803)] = 33980,
  [SMALL_STATE(804)] = 34009,
  [SMALL_STATE(805)] = 34038,
  [SMALL_STATE(806)] = 34067,
  [SMALL_STATE(807)] = 34096,
  [SMALL_STATE(808)] = 34125,
  [SMALL_STATE(809)] = 34146,
  [SMALL_STATE(810)] = 34159,
  [SMALL_STATE(811)] = 34172,
  [SMALL_STATE(812)] = 34185,
  [SMALL_STATE(813)] = 34198,
  [SMALL_STATE(814)] = 34221,
  [SMALL_STATE(815)] = 34242,
  [SMALL_STATE(816)] = 34261,
  [SMALL_STATE(817)] = 34284,
  [SMALL_STATE(818)] = 34307,
  [SMALL_STATE(819)] = 34330,
  [SMALL_STATE(820)] = 34353,
  [SMALL_STATE(821)] = 34376,
  [SMALL_STATE(822)] = 34397,
  [SMALL_STATE(823)] = 34410,
  [SMALL_STATE(824)] = 34423,
  [SMALL_STATE(825)] = 34444,
  [SMALL_STATE(826)] = 34465,
  [SMALL_STATE(827)] = 34478,
  [SMALL_STATE(828)] = 34491,
  [SMALL_STATE(829)] = 34510,
  [SMALL_STATE(830)] = 34532,
  [SMALL_STATE(831)] = 34550,
  [SMALL_STATE(832)] = 34568,
  [SMALL_STATE(833)] = 34588,
  [SMALL_STATE(834)] = 34600,
  [SMALL_STATE(835)] = 34622,
  [SMALL_STATE(836)] = 34644,
  [SMALL_STATE(837)] = 34666,
  [SMALL_STATE(838)] = 34678,
  [SMALL_STATE(839)] = 34690,
  [SMALL_STATE(840)] = 34708,
  [SMALL_STATE(841)] = 34730,
  [SMALL_STATE(842)] = 34742,
  [SMALL_STATE(843)] = 34764,
  [SMALL_STATE(844)] = 34776,
  [SMALL_STATE(845)] = 34794,
  [SMALL_STATE(846)] = 34806,
  [SMALL_STATE(847)] = 34824,
  [SMALL_STATE(848)] = 34846,
  [SMALL_STATE(849)] = 34868,
  [SMALL_STATE(850)] = 34888,
  [SMALL_STATE(851)] = 34906,
  [SMALL_STATE(852)] = 34922,
  [SMALL_STATE(853)] = 34934,
  [SMALL_STATE(854)] = 34952,
  [SMALL_STATE(855)] = 34970,
  [SMALL_STATE(856)] = 34984,
  [SMALL_STATE(857)] = 35006,
  [SMALL_STATE(858)] = 35020,
  [SMALL_STATE(859)] = 35042,
  [SMALL_STATE(860)] = 35054,
  [SMALL_STATE(861)] = 35076,
  [SMALL_STATE(862)] = 35098,
  [SMALL_STATE(863)] = 35116,
  [SMALL_STATE(864)] = 35134,
  [SMALL_STATE(865)] = 35152,
  [SMALL_STATE(866)] = 35163,
  [SMALL_STATE(867)] = 35182,
  [SMALL_STATE(868)] = 35201,
  [SMALL_STATE(869)] = 35216,
  [SMALL_STATE(870)] = 35229,
  [SMALL_STATE(871)] = 35242,
  [SMALL_STATE(872)] = 35261,
  [SMALL_STATE(873)] = 35274,
  [SMALL_STATE(874)] = 35293,
  [SMALL_STATE(875)] = 35312,
  [SMALL_STATE(876)] = 35325,
  [SMALL_STATE(877)] = 35344,
  [SMALL_STATE(878)] = 35357,
  [SMALL_STATE(879)] = 35370,
  [SMALL_STATE(880)] = 35383,
  [SMALL_STATE(881)] = 35402,
  [SMALL_STATE(882)] = 35415,
  [SMALL_STATE(883)] = 35434,
  [SMALL_STATE(884)] = 35447,
  [SMALL_STATE(885)] = 35466,
  [SMALL_STATE(886)] = 35479,
  [SMALL_STATE(887)] = 35492,
  [SMALL_STATE(888)] = 35511,
  [SMALL_STATE(889)] = 35530,
  [SMALL_STATE(890)] = 35543,
  [SMALL_STATE(891)] = 35554,
  [SMALL_STATE(892)] = 35573,
  [SMALL_STATE(893)] = 35592,
  [SMALL_STATE(894)] = 35611,
  [SMALL_STATE(895)] = 35630,
  [SMALL_STATE(896)] = 35641,
  [SMALL_STATE(897)] = 35654,
  [SMALL_STATE(898)] = 35667,
  [SMALL_STATE(899)] = 35680,
  [SMALL_STATE(900)] = 35699,
  [SMALL_STATE(901)] = 35712,
  [SMALL_STATE(902)] = 35727,
  [SMALL_STATE(903)] = 35740,
  [SMALL_STATE(904)] = 35756,
  [SMALL_STATE(905)] = 35772,
  [SMALL_STATE(906)] = 35786,
  [SMALL_STATE(907)] = 35800,
  [SMALL_STATE(908)] = 35814,
  [SMALL_STATE(909)] = 35830,
  [SMALL_STATE(910)] = 35846,
  [SMALL_STATE(911)] = 35860,
  [SMALL_STATE(912)] = 35876,
  [SMALL_STATE(913)] = 35890,
  [SMALL_STATE(914)] = 35906,
  [SMALL_STATE(915)] = 35922,
  [SMALL_STATE(916)] = 35936,
  [SMALL_STATE(917)] = 35952,
  [SMALL_STATE(918)] = 35966,
  [SMALL_STATE(919)] = 35982,
  [SMALL_STATE(920)] = 35994,
  [SMALL_STATE(921)] = 36010,
  [SMALL_STATE(922)] = 36026,
  [SMALL_STATE(923)] = 36042,
  [SMALL_STATE(924)] = 36052,
  [SMALL_STATE(925)] = 36068,
  [SMALL_STATE(926)] = 36084,
  [SMALL_STATE(927)] = 36100,
  [SMALL_STATE(928)] = 36114,
  [SMALL_STATE(929)] = 36126,
  [SMALL_STATE(930)] = 36142,
  [SMALL_STATE(931)] = 36158,
  [SMALL_STATE(932)] = 36174,
  [SMALL_STATE(933)] = 36190,
  [SMALL_STATE(934)] = 36206,
  [SMALL_STATE(935)] = 36220,
  [SMALL_STATE(936)] = 36236,
  [SMALL_STATE(937)] = 36250,
  [SMALL_STATE(938)] = 36264,
  [SMALL_STATE(939)] = 36280,
  [SMALL_STATE(940)] = 36296,
  [SMALL_STATE(941)] = 36310,
  [SMALL_STATE(942)] = 36324,
  [SMALL_STATE(943)] = 36338,
  [SMALL_STATE(944)] = 36352,
  [SMALL_STATE(945)] = 36368,
  [SMALL_STATE(946)] = 36382,
  [SMALL_STATE(947)] = 36396,
  [SMALL_STATE(948)] = 36410,
  [SMALL_STATE(949)] = 36424,
  [SMALL_STATE(950)] = 36438,
  [SMALL_STATE(951)] = 36452,
  [SMALL_STATE(952)] = 36462,
  [SMALL_STATE(953)] = 36478,
  [SMALL_STATE(954)] = 36494,
  [SMALL_STATE(955)] = 36510,
  [SMALL_STATE(956)] = 36526,
  [SMALL_STATE(957)] = 36542,
  [SMALL_STATE(958)] = 36558,
  [SMALL_STATE(959)] = 36568,
  [SMALL_STATE(960)] = 36582,
  [SMALL_STATE(961)] = 36598,
  [SMALL_STATE(962)] = 36614,
  [SMALL_STATE(963)] = 36630,
  [SMALL_STATE(964)] = 36644,
  [SMALL_STATE(965)] = 36660,
  [SMALL_STATE(966)] = 36676,
  [SMALL_STATE(967)] = 36686,
  [SMALL_STATE(968)] = 36695,
  [SMALL_STATE(969)] = 36708,
  [SMALL_STATE(970)] = 36717,
  [SMALL_STATE(971)] = 36730,
  [SMALL_STATE(972)] = 36739,
  [SMALL_STATE(973)] = 36748,
  [SMALL_STATE(974)] = 36757,
  [SMALL_STATE(975)] = 36766,
  [SMALL_STATE(976)] = 36777,
  [SMALL_STATE(977)] = 36790,
  [SMALL_STATE(978)] = 36799,
  [SMALL_STATE(979)] = 36812,
  [SMALL_STATE(980)] = 36821,
  [SMALL_STATE(981)] = 36830,
  [SMALL_STATE(982)] = 36839,
  [SMALL_STATE(983)] = 36848,
  [SMALL_STATE(984)] = 36857,
  [SMALL_STATE(985)] = 36866,
  [SMALL_STATE(986)] = 36877,
  [SMALL_STATE(987)] = 36890,
  [SMALL_STATE(988)] = 36903,
  [SMALL_STATE(989)] = 36912,
  [SMALL_STATE(990)] = 36923,
  [SMALL_STATE(991)] = 36936,
  [SMALL_STATE(992)] = 36947,
  [SMALL_STATE(993)] = 36958,
  [SMALL_STATE(994)] = 36971,
  [SMALL_STATE(995)] = 36984,
  [SMALL_STATE(996)] = 36993,
  [SMALL_STATE(997)] = 37006,
  [SMALL_STATE(998)] = 37019,
  [SMALL_STATE(999)] = 37032,
  [SMALL_STATE(1000)] = 37045,
  [SMALL_STATE(1001)] = 37054,
  [SMALL_STATE(1002)] = 37067,
  [SMALL_STATE(1003)] = 37080,
  [SMALL_STATE(1004)] = 37089,
  [SMALL_STATE(1005)] = 37102,
  [SMALL_STATE(1006)] = 37115,
  [SMALL_STATE(1007)] = 37128,
  [SMALL_STATE(1008)] = 37137,
  [SMALL_STATE(1009)] = 37146,
  [SMALL_STATE(1010)] = 37159,
  [SMALL_STATE(1011)] = 37172,
  [SMALL_STATE(1012)] = 37183,
  [SMALL_STATE(1013)] = 37196,
  [SMALL_STATE(1014)] = 37209,
  [SMALL_STATE(1015)] = 37222,
  [SMALL_STATE(1016)] = 37235,
  [SMALL_STATE(1017)] = 37248,
  [SMALL_STATE(1018)] = 37261,
  [SMALL_STATE(1019)] = 37274,
  [SMALL_STATE(1020)] = 37287,
  [SMALL_STATE(1021)] = 37296,
  [SMALL_STATE(1022)] = 37309,
  [SMALL_STATE(1023)] = 37318,
  [SMALL_STATE(1024)] = 37331,
  [SMALL_STATE(1025)] = 37344,
  [SMALL_STATE(1026)] = 37357,
  [SMALL_STATE(1027)] = 37370,
  [SMALL_STATE(1028)] = 37381,
  [SMALL_STATE(1029)] = 37394,
  [SMALL_STATE(1030)] = 37407,
  [SMALL_STATE(1031)] = 37420,
  [SMALL_STATE(1032)] = 37433,
  [SMALL_STATE(1033)] = 37446,
  [SMALL_STATE(1034)] = 37459,
  [SMALL_STATE(1035)] = 37472,
  [SMALL_STATE(1036)] = 37485,
  [SMALL_STATE(1037)] = 37498,
  [SMALL_STATE(1038)] = 37511,
  [SMALL_STATE(1039)] = 37520,
  [SMALL_STATE(1040)] = 37533,
  [SMALL_STATE(1041)] = 37546,
  [SMALL_STATE(1042)] = 37559,
  [SMALL_STATE(1043)] = 37572,
  [SMALL_STATE(1044)] = 37585,
  [SMALL_STATE(1045)] = 37598,
  [SMALL_STATE(1046)] = 37609,
  [SMALL_STATE(1047)] = 37622,
  [SMALL_STATE(1048)] = 37635,
  [SMALL_STATE(1049)] = 37648,
  [SMALL_STATE(1050)] = 37661,
  [SMALL_STATE(1051)] = 37674,
  [SMALL_STATE(1052)] = 37687,
  [SMALL_STATE(1053)] = 37700,
  [SMALL_STATE(1054)] = 37709,
  [SMALL_STATE(1055)] = 37722,
  [SMALL_STATE(1056)] = 37731,
  [SMALL_STATE(1057)] = 37744,
  [SMALL_STATE(1058)] = 37757,
  [SMALL_STATE(1059)] = 37770,
  [SMALL_STATE(1060)] = 37783,
  [SMALL_STATE(1061)] = 37796,
  [SMALL_STATE(1062)] = 37809,
  [SMALL_STATE(1063)] = 37822,
  [SMALL_STATE(1064)] = 37835,
  [SMALL_STATE(1065)] = 37844,
  [SMALL_STATE(1066)] = 37857,
  [SMALL_STATE(1067)] = 37866,
  [SMALL_STATE(1068)] = 37877,
  [SMALL_STATE(1069)] = 37888,
  [SMALL_STATE(1070)] = 37901,
  [SMALL_STATE(1071)] = 37910,
  [SMALL_STATE(1072)] = 37923,
  [SMALL_STATE(1073)] = 37936,
  [SMALL_STATE(1074)] = 37949,
  [SMALL_STATE(1075)] = 37959,
  [SMALL_STATE(1076)] = 37969,
  [SMALL_STATE(1077)] = 37979,
  [SMALL_STATE(1078)] = 37989,
  [SMALL_STATE(1079)] = 37997,
  [SMALL_STATE(1080)] = 38007,
  [SMALL_STATE(1081)] = 38017,
  [SMALL_STATE(1082)] = 38027,
  [SMALL_STATE(1083)] = 38037,
  [SMALL_STATE(1084)] = 38047,
  [SMALL_STATE(1085)] = 38057,
  [SMALL_STATE(1086)] = 38067,
  [SMALL_STATE(1087)] = 38077,
  [SMALL_STATE(1088)] = 38087,
  [SMALL_STATE(1089)] = 38097,
  [SMALL_STATE(1090)] = 38107,
  [SMALL_STATE(1091)] = 38117,
  [SMALL_STATE(1092)] = 38125,
  [SMALL_STATE(1093)] = 38135,
  [SMALL_STATE(1094)] = 38145,
  [SMALL_STATE(1095)] = 38155,
  [SMALL_STATE(1096)] = 38165,
  [SMALL_STATE(1097)] = 38175,
  [SMALL_STATE(1098)] = 38185,
  [SMALL_STATE(1099)] = 38195,
  [SMALL_STATE(1100)] = 38205,
  [SMALL_STATE(1101)] = 38215,
  [SMALL_STATE(1102)] = 38225,
  [SMALL_STATE(1103)] = 38235,
  [SMALL_STATE(1104)] = 38245,
  [SMALL_STATE(1105)] = 38255,
  [SMALL_STATE(1106)] = 38265,
  [SMALL_STATE(1107)] = 38275,
  [SMALL_STATE(1108)] = 38285,
  [SMALL_STATE(1109)] = 38295,
  [SMALL_STATE(1110)] = 38305,
  [SMALL_STATE(1111)] = 38313,
  [SMALL_STATE(1112)] = 38323,
  [SMALL_STATE(1113)] = 38333,
  [SMALL_STATE(1114)] = 38343,
  [SMALL_STATE(1115)] = 38353,
  [SMALL_STATE(1116)] = 38363,
  [SMALL_STATE(1117)] = 38373,
  [SMALL_STATE(1118)] = 38383,
  [SMALL_STATE(1119)] = 38393,
  [SMALL_STATE(1120)] = 38403,
  [SMALL_STATE(1121)] = 38413,
  [SMALL_STATE(1122)] = 38423,
  [SMALL_STATE(1123)] = 38433,
  [SMALL_STATE(1124)] = 38443,
  [SMALL_STATE(1125)] = 38453,
  [SMALL_STATE(1126)] = 38463,
  [SMALL_STATE(1127)] = 38473,
  [SMALL_STATE(1128)] = 38483,
  [SMALL_STATE(1129)] = 38491,
  [SMALL_STATE(1130)] = 38501,
  [SMALL_STATE(1131)] = 38511,
  [SMALL_STATE(1132)] = 38521,
  [SMALL_STATE(1133)] = 38531,
  [SMALL_STATE(1134)] = 38541,
  [SMALL_STATE(1135)] = 38551,
  [SMALL_STATE(1136)] = 38561,
  [SMALL_STATE(1137)] = 38571,
  [SMALL_STATE(1138)] = 38581,
  [SMALL_STATE(1139)] = 38591,
  [SMALL_STATE(1140)] = 38601,
  [SMALL_STATE(1141)] = 38609,
  [SMALL_STATE(1142)] = 38619,
  [SMALL_STATE(1143)] = 38627,
  [SMALL_STATE(1144)] = 38637,
  [SMALL_STATE(1145)] = 38647,
  [SMALL_STATE(1146)] = 38657,
  [SMALL_STATE(1147)] = 38665,
  [SMALL_STATE(1148)] = 38675,
  [SMALL_STATE(1149)] = 38685,
  [SMALL_STATE(1150)] = 38695,
  [SMALL_STATE(1151)] = 38705,
  [SMALL_STATE(1152)] = 38715,
  [SMALL_STATE(1153)] = 38725,
  [SMALL_STATE(1154)] = 38735,
  [SMALL_STATE(1155)] = 38745,
  [SMALL_STATE(1156)] = 38755,
  [SMALL_STATE(1157)] = 38763,
  [SMALL_STATE(1158)] = 38773,
  [SMALL_STATE(1159)] = 38783,
  [SMALL_STATE(1160)] = 38793,
  [SMALL_STATE(1161)] = 38803,
  [SMALL_STATE(1162)] = 38813,
  [SMALL_STATE(1163)] = 38823,
  [SMALL_STATE(1164)] = 38831,
  [SMALL_STATE(1165)] = 38841,
  [SMALL_STATE(1166)] = 38849,
  [SMALL_STATE(1167)] = 38859,
  [SMALL_STATE(1168)] = 38869,
  [SMALL_STATE(1169)] = 38879,
  [SMALL_STATE(1170)] = 38889,
  [SMALL_STATE(1171)] = 38899,
  [SMALL_STATE(1172)] = 38909,
  [SMALL_STATE(1173)] = 38917,
  [SMALL_STATE(1174)] = 38925,
  [SMALL_STATE(1175)] = 38935,
  [SMALL_STATE(1176)] = 38945,
  [SMALL_STATE(1177)] = 38955,
  [SMALL_STATE(1178)] = 38963,
  [SMALL_STATE(1179)] = 38973,
  [SMALL_STATE(1180)] = 38981,
  [SMALL_STATE(1181)] = 38989,
  [SMALL_STATE(1182)] = 38999,
  [SMALL_STATE(1183)] = 39009,
  [SMALL_STATE(1184)] = 39019,
  [SMALL_STATE(1185)] = 39027,
  [SMALL_STATE(1186)] = 39037,
  [SMALL_STATE(1187)] = 39047,
  [SMALL_STATE(1188)] = 39057,
  [SMALL_STATE(1189)] = 39065,
  [SMALL_STATE(1190)] = 39075,
  [SMALL_STATE(1191)] = 39085,
  [SMALL_STATE(1192)] = 39095,
  [SMALL_STATE(1193)] = 39103,
  [SMALL_STATE(1194)] = 39113,
  [SMALL_STATE(1195)] = 39123,
  [SMALL_STATE(1196)] = 39133,
  [SMALL_STATE(1197)] = 39143,
  [SMALL_STATE(1198)] = 39153,
  [SMALL_STATE(1199)] = 39161,
  [SMALL_STATE(1200)] = 39171,
  [SMALL_STATE(1201)] = 39181,
  [SMALL_STATE(1202)] = 39191,
  [SMALL_STATE(1203)] = 39201,
  [SMALL_STATE(1204)] = 39211,
  [SMALL_STATE(1205)] = 39221,
  [SMALL_STATE(1206)] = 39231,
  [SMALL_STATE(1207)] = 39241,
  [SMALL_STATE(1208)] = 39251,
  [SMALL_STATE(1209)] = 39259,
  [SMALL_STATE(1210)] = 39267,
  [SMALL_STATE(1211)] = 39277,
  [SMALL_STATE(1212)] = 39287,
  [SMALL_STATE(1213)] = 39297,
  [SMALL_STATE(1214)] = 39307,
  [SMALL_STATE(1215)] = 39317,
  [SMALL_STATE(1216)] = 39327,
  [SMALL_STATE(1217)] = 39337,
  [SMALL_STATE(1218)] = 39347,
  [SMALL_STATE(1219)] = 39357,
  [SMALL_STATE(1220)] = 39367,
  [SMALL_STATE(1221)] = 39377,
  [SMALL_STATE(1222)] = 39387,
  [SMALL_STATE(1223)] = 39397,
  [SMALL_STATE(1224)] = 39407,
  [SMALL_STATE(1225)] = 39417,
  [SMALL_STATE(1226)] = 39427,
  [SMALL_STATE(1227)] = 39437,
  [SMALL_STATE(1228)] = 39445,
  [SMALL_STATE(1229)] = 39455,
  [SMALL_STATE(1230)] = 39465,
  [SMALL_STATE(1231)] = 39475,
  [SMALL_STATE(1232)] = 39485,
  [SMALL_STATE(1233)] = 39495,
  [SMALL_STATE(1234)] = 39505,
  [SMALL_STATE(1235)] = 39513,
  [SMALL_STATE(1236)] = 39521,
  [SMALL_STATE(1237)] = 39529,
  [SMALL_STATE(1238)] = 39539,
  [SMALL_STATE(1239)] = 39549,
  [SMALL_STATE(1240)] = 39557,
  [SMALL_STATE(1241)] = 39567,
  [SMALL_STATE(1242)] = 39577,
  [SMALL_STATE(1243)] = 39587,
  [SMALL_STATE(1244)] = 39597,
  [SMALL_STATE(1245)] = 39607,
  [SMALL_STATE(1246)] = 39617,
  [SMALL_STATE(1247)] = 39625,
  [SMALL_STATE(1248)] = 39635,
  [SMALL_STATE(1249)] = 39645,
  [SMALL_STATE(1250)] = 39655,
  [SMALL_STATE(1251)] = 39665,
  [SMALL_STATE(1252)] = 39672,
  [SMALL_STATE(1253)] = 39679,
  [SMALL_STATE(1254)] = 39686,
  [SMALL_STATE(1255)] = 39693,
  [SMALL_STATE(1256)] = 39700,
  [SMALL_STATE(1257)] = 39707,
  [SMALL_STATE(1258)] = 39714,
  [SMALL_STATE(1259)] = 39721,
  [SMALL_STATE(1260)] = 39728,
  [SMALL_STATE(1261)] = 39735,
  [SMALL_STATE(1262)] = 39742,
  [SMALL_STATE(1263)] = 39749,
  [SMALL_STATE(1264)] = 39756,
  [SMALL_STATE(1265)] = 39763,
  [SMALL_STATE(1266)] = 39770,
  [SMALL_STATE(1267)] = 39777,
  [SMALL_STATE(1268)] = 39784,
  [SMALL_STATE(1269)] = 39791,
  [SMALL_STATE(1270)] = 39798,
  [SMALL_STATE(1271)] = 39805,
  [SMALL_STATE(1272)] = 39812,
  [SMALL_STATE(1273)] = 39819,
  [SMALL_STATE(1274)] = 39826,
  [SMALL_STATE(1275)] = 39833,
  [SMALL_STATE(1276)] = 39840,
  [SMALL_STATE(1277)] = 39847,
  [SMALL_STATE(1278)] = 39854,
  [SMALL_STATE(1279)] = 39861,
  [SMALL_STATE(1280)] = 39868,
  [SMALL_STATE(1281)] = 39875,
  [SMALL_STATE(1282)] = 39882,
  [SMALL_STATE(1283)] = 39889,
  [SMALL_STATE(1284)] = 39896,
  [SMALL_STATE(1285)] = 39903,
  [SMALL_STATE(1286)] = 39910,
  [SMALL_STATE(1287)] = 39917,
  [SMALL_STATE(1288)] = 39924,
  [SMALL_STATE(1289)] = 39931,
  [SMALL_STATE(1290)] = 39938,
  [SMALL_STATE(1291)] = 39945,
  [SMALL_STATE(1292)] = 39952,
  [SMALL_STATE(1293)] = 39959,
  [SMALL_STATE(1294)] = 39966,
  [SMALL_STATE(1295)] = 39973,
  [SMALL_STATE(1296)] = 39980,
  [SMALL_STATE(1297)] = 39987,
  [SMALL_STATE(1298)] = 39994,
  [SMALL_STATE(1299)] = 40001,
  [SMALL_STATE(1300)] = 40008,
  [SMALL_STATE(1301)] = 40015,
  [SMALL_STATE(1302)] = 40022,
  [SMALL_STATE(1303)] = 40029,
  [SMALL_STATE(1304)] = 40036,
  [SMALL_STATE(1305)] = 40043,
  [SMALL_STATE(1306)] = 40050,
  [SMALL_STATE(1307)] = 40057,
  [SMALL_STATE(1308)] = 40064,
  [SMALL_STATE(1309)] = 40071,
  [SMALL_STATE(1310)] = 40078,
  [SMALL_STATE(1311)] = 40085,
  [SMALL_STATE(1312)] = 40092,
  [SMALL_STATE(1313)] = 40099,
  [SMALL_STATE(1314)] = 40106,
  [SMALL_STATE(1315)] = 40113,
  [SMALL_STATE(1316)] = 40120,
  [SMALL_STATE(1317)] = 40127,
  [SMALL_STATE(1318)] = 40134,
  [SMALL_STATE(1319)] = 40141,
  [SMALL_STATE(1320)] = 40148,
  [SMALL_STATE(1321)] = 40155,
  [SMALL_STATE(1322)] = 40162,
  [SMALL_STATE(1323)] = 40169,
  [SMALL_STATE(1324)] = 40176,
  [SMALL_STATE(1325)] = 40183,
  [SMALL_STATE(1326)] = 40190,
  [SMALL_STATE(1327)] = 40197,
  [SMALL_STATE(1328)] = 40204,
  [SMALL_STATE(1329)] = 40211,
  [SMALL_STATE(1330)] = 40218,
  [SMALL_STATE(1331)] = 40225,
  [SMALL_STATE(1332)] = 40232,
  [SMALL_STATE(1333)] = 40239,
  [SMALL_STATE(1334)] = 40246,
  [SMALL_STATE(1335)] = 40253,
  [SMALL_STATE(1336)] = 40260,
  [SMALL_STATE(1337)] = 40267,
  [SMALL_STATE(1338)] = 40274,
  [SMALL_STATE(1339)] = 40281,
  [SMALL_STATE(1340)] = 40288,
  [SMALL_STATE(1341)] = 40295,
  [SMALL_STATE(1342)] = 40302,
  [SMALL_STATE(1343)] = 40309,
  [SMALL_STATE(1344)] = 40316,
  [SMALL_STATE(1345)] = 40323,
  [SMALL_STATE(1346)] = 40330,
  [SMALL_STATE(1347)] = 40337,
  [SMALL_STATE(1348)] = 40344,
  [SMALL_STATE(1349)] = 40351,
  [SMALL_STATE(1350)] = 40358,
  [SMALL_STATE(1351)] = 40365,
  [SMALL_STATE(1352)] = 40372,
  [SMALL_STATE(1353)] = 40379,
  [SMALL_STATE(1354)] = 40386,
  [SMALL_STATE(1355)] = 40393,
};

static TSParseActionEntry ts_parse_actions[] = {
  [0] = {.entry = {.count = 0, .reusable = false}},
  [1] = {.entry = {.count = 1, .reusable = false}}, RECOVER(),
  [3] = {.entry = {.count = 1, .reusable = true}}, SHIFT_EXTRA(),
  [5] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_program, 0),
  [7] = {.entry = {.count = 1, .reusable = false}}, SHIFT(347),
  [9] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14),
  [11] = {.entry = {.count = 1, .reusable = false}}, SHIFT(197),
  [13] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3),
  [15] = {.entry = {.count = 1, .reusable = false}}, SHIFT(382),
  [17] = {.entry = {.count = 1, .reusable = false}}, SHIFT(821),
  [19] = {.entry = {.count = 1, .reusable = false}}, SHIFT(825),
  [21] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1237),
  [23] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1080),
  [25] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1069),
  [27] = {.entry = {.count = 1, .reusable = true}}, SHIFT(74),
  [29] = {.entry = {.count = 1, .reusable = false}}, SHIFT(175),
  [31] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1087),
  [33] = {.entry = {.count = 1, .reusable = false}}, SHIFT(40),
  [35] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1088),
  [37] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1096),
  [39] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1068),
  [41] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1067),
  [43] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1110),
  [45] = {.entry = {.count = 1, .reusable = false}}, SHIFT(83),
  [47] = {.entry = {.count = 1, .reusable = false}}, SHIFT(124),
  [49] = {.entry = {.count = 1, .reusable = true}}, SHIFT(227),
  [51] = {.entry = {.count = 1, .reusable = false}}, SHIFT(45),
  [53] = {.entry = {.count = 1, .reusable = true}}, SHIFT(69),
  [55] = {.entry = {.count = 1, .reusable = true}}, SHIFT(876),
  [57] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1334),
  [59] = {.entry = {.count = 1, .reusable = false}}, SHIFT(880),
  [61] = {.entry = {.count = 1, .reusable = false}}, SHIFT(216),
  [63] = {.entry = {.count = 1, .reusable = false}}, SHIFT(953),
  [65] = {.entry = {.count = 1, .reusable = false}}, SHIFT(122),
  [67] = {.entry = {.count = 1, .reusable = false}}, SHIFT(126),
  [69] = {.entry = {.count = 1, .reusable = true}}, SHIFT(126),
  [71] = {.entry = {.count = 1, .reusable = false}}, SHIFT(163),
  [73] = {.entry = {.count = 1, .reusable = true}}, SHIFT(138),
  [75] = {.entry = {.count = 1, .reusable = true}}, SHIFT(950),
  [77] = {.entry = {.count = 1, .reusable = true}}, SHIFT(945),
  [79] = {.entry = {.count = 1, .reusable = true}}, SHIFT(830),
  [81] = {.entry = {.count = 1, .reusable = true}}, SHIFT(539),
  [83] = {.entry = {.count = 1, .reusable = false}}, SHIFT(539),
  [85] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1054),
  [87] = {.entry = {.count = 1, .reusable = false}}, SHIFT(349),
  [89] = {.entry = {.count = 1, .reusable = false}}, SHIFT(332),
  [91] = {.entry = {.count = 1, .reusable = false}}, SHIFT(92),
  [93] = {.entry = {.count = 1, .reusable = true}}, SHIFT(755),
  [95] = {.entry = {.count = 1, .reusable = true}}, SHIFT(649),
  [97] = {.entry = {.count = 1, .reusable = true}}, SHIFT(520),
  [99] = {.entry = {.count = 1, .reusable = true}}, SHIFT(70),
  [101] = {.entry = {.count = 1, .reusable = false}}, SHIFT(199),
  [103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(155),
  [105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(564),
  [107] = {.entry = {.count = 1, .reusable = false}}, SHIFT(201),
  [109] = {.entry = {.count = 1, .reusable = false}}, SHIFT(205),
  [111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(47),
  [113] = {.entry = {.count = 1, .reusable = false}}, SHIFT(334),
  [115] = {.entry = {.count = 1, .reusable = false}}, SHIFT(107),
  [117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(384),
  [119] = {.entry = {.count = 1, .reusable = false}}, SHIFT(198),
  [121] = {.entry = {.count = 1, .reusable = false}}, SHIFT(203),
  [123] = {.entry = {.count = 1, .reusable = false}}, SHIFT(206),
  [125] = {.entry = {.count = 1, .reusable = false}}, SHIFT(333),
  [127] = {.entry = {.count = 1, .reusable = false}}, SHIFT(121),
  [129] = {.entry = {.count = 1, .reusable = false}}, SHIFT(200),
  [131] = {.entry = {.count = 1, .reusable = false}}, SHIFT(204),
  [133] = {.entry = {.count = 1, .reusable = false}}, SHIFT(202),
  [135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(423),
  [137] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2),
  [139] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(347),
  [142] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(197),
  [145] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2),
  [147] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(3),
  [150] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(382),
  [153] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(821),
  [156] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(825),
  [159] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1237),
  [162] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1080),
  [165] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1069),
  [168] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(74),
  [171] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(175),
  [174] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1087),
  [177] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(40),
  [180] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1088),
  [183] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1096),
  [186] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1068),
  [189] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1067),
  [192] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1110),
  [195] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(83),
  [198] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(124),
  [201] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(227),
  [204] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(45),
  [207] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(69),
  [210] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(876),
  [213] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1334),
  [216] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(880),
  [219] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(216),
  [222] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(953),
  [225] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(122),
  [228] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(126),
  [231] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(126),
  [234] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(163),
  [237] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(138),
  [240] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(950),
  [243] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(945),
  [246] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(830),
  [249] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(539),
  [252] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(539),
  [255] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1054),
  [258] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(349),
  [261] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_case, 4, .production_id = 53),
  [263] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_case, 4, .production_id = 53),
  [265] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_default, 3),
  [267] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_default, 3),
  [269] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_case, 3, .production_id = 53),
  [271] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_case, 3, .production_id = 53),
  [273] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_default, 2),
  [275] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_default, 2),
  [277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(208),
  [279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(235),
  [281] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_program, 1),
  [283] = {.entry = {.count = 1, .reusable = true}}, SHIFT(55),
  [285] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_program, 2),
  [287] = {.entry = {.count = 1, .reusable = true}}, SHIFT(392),
  [289] = {.entry = {.count = 1, .reusable = true}}, SHIFT(51),
  [291] = {.entry = {.count = 1, .reusable = true}}, SHIFT(243),
  [293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(411),
  [295] = {.entry = {.count = 1, .reusable = true}}, SHIFT(209),
  [297] = {.entry = {.count = 1, .reusable = true}}, SHIFT(985),
  [299] = {.entry = {.count = 1, .reusable = false}}, SHIFT(352),
  [301] = {.entry = {.count = 1, .reusable = false}}, SHIFT(196),
  [303] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6),
  [305] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1245),
  [307] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1024),
  [309] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1248),
  [311] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1249),
  [313] = {.entry = {.count = 1, .reusable = false}}, SHIFT(893),
  [315] = {.entry = {.count = 1, .reusable = false}}, SHIFT(214),
  [317] = {.entry = {.count = 1, .reusable = false}}, SHIFT(954),
  [319] = {.entry = {.count = 1, .reusable = false}}, SHIFT(350),
  [321] = {.entry = {.count = 1, .reusable = false}}, SHIFT(339),
  [323] = {.entry = {.count = 1, .reusable = false}}, SHIFT(343),
  [325] = {.entry = {.count = 1, .reusable = false}}, SHIFT(164),
  [327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(646),
  [329] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_yield_expression, 1),
  [331] = {.entry = {.count = 1, .reusable = false}}, SHIFT(456),
  [333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(73),
  [335] = {.entry = {.count = 1, .reusable = false}}, SHIFT(176),
  [337] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_yield_expression, 1),
  [339] = {.entry = {.count = 1, .reusable = false}}, SHIFT(44),
  [341] = {.entry = {.count = 1, .reusable = true}}, SHIFT(63),
  [343] = {.entry = {.count = 1, .reusable = false}}, SHIFT(884),
  [345] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1350),
  [347] = {.entry = {.count = 1, .reusable = false}}, SHIFT(866),
  [349] = {.entry = {.count = 1, .reusable = false}}, SHIFT(210),
  [351] = {.entry = {.count = 1, .reusable = false}}, SHIFT(913),
  [353] = {.entry = {.count = 1, .reusable = false}}, SHIFT(106),
  [355] = {.entry = {.count = 1, .reusable = false}}, SHIFT(192),
  [357] = {.entry = {.count = 1, .reusable = true}}, SHIFT(192),
  [359] = {.entry = {.count = 1, .reusable = false}}, SHIFT(174),
  [361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(149),
  [363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(947),
  [365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(946),
  [367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(844),
  [369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(426),
  [371] = {.entry = {.count = 1, .reusable = false}}, SHIFT(426),
  [373] = {.entry = {.count = 1, .reusable = false}}, SHIFT(357),
  [375] = {.entry = {.count = 1, .reusable = false}}, SHIFT(345),
  [377] = {.entry = {.count = 1, .reusable = false}}, SHIFT(141),
  [379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(645),
  [381] = {.entry = {.count = 1, .reusable = false}}, SHIFT(552),
  [383] = {.entry = {.count = 1, .reusable = false}}, SHIFT(876),
  [385] = {.entry = {.count = 1, .reusable = false}}, SHIFT(894),
  [387] = {.entry = {.count = 1, .reusable = false}}, SHIFT(212),
  [389] = {.entry = {.count = 1, .reusable = false}}, SHIFT(926),
  [391] = {.entry = {.count = 1, .reusable = false}}, SHIFT(369),
  [393] = {.entry = {.count = 1, .reusable = false}}, SHIFT(368),
  [395] = {.entry = {.count = 1, .reusable = false}}, SHIFT(156),
  [397] = {.entry = {.count = 1, .reusable = true}}, SHIFT(648),
  [399] = {.entry = {.count = 1, .reusable = false}}, SHIFT(160),
  [401] = {.entry = {.count = 1, .reusable = false}}, SHIFT(46),
  [403] = {.entry = {.count = 1, .reusable = true}}, SHIFT(68),
  [405] = {.entry = {.count = 1, .reusable = false}}, SHIFT(222),
  [407] = {.entry = {.count = 1, .reusable = false}}, SHIFT(96),
  [409] = {.entry = {.count = 1, .reusable = false}}, SHIFT(189),
  [411] = {.entry = {.count = 1, .reusable = true}}, SHIFT(189),
  [413] = {.entry = {.count = 1, .reusable = false}}, SHIFT(127),
  [415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(172),
  [417] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_statement_block, 2),
  [419] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_statement_block, 2),
  [421] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object, 2),
  [423] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object, 2),
  [425] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object_pattern, 2),
  [427] = {.entry = {.count = 1, .reusable = true}}, SHIFT(217),
  [429] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declaration, 5, .production_id = 78),
  [431] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_declaration, 5, .production_id = 78),
  [433] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function, 5, .production_id = 78),
  [435] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function, 5, .production_id = 78),
  [437] = {.entry = {.count = 1, .reusable = true}}, SHIFT(276),
  [439] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 4, .production_id = 64),
  [441] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 4, .production_id = 64),
  [443] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 4, .production_id = 64),
  [445] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 4, .production_id = 64),
  [447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(303),
  [449] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_statement_block, 4),
  [451] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_statement_block, 4),
  [453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(57),
  [455] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 5, .production_id = 83),
  [457] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 5, .production_id = 83),
  [459] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 5, .production_id = 83),
  [461] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 5, .production_id = 83),
  [463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(271),
  [465] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_body, 2),
  [467] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_body, 2),
  [469] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 3, .production_id = 33),
  [471] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 3, .production_id = 33),
  [473] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 3, .production_id = 33),
  [475] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 3, .production_id = 33),
  [477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(272),
  [479] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_statement_block, 3),
  [481] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_statement_block, 3),
  [483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(50),
  [485] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generator_function_declaration, 5, .production_id = 78),
  [487] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generator_function_declaration, 5, .production_id = 78),
  [489] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generator_function, 5, .production_id = 78),
  [491] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generator_function, 5, .production_id = 78),
  [493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(273),
  [495] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 4, .production_id = 71),
  [497] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 4, .production_id = 71),
  [499] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 4, .production_id = 71),
  [501] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 4, .production_id = 71),
  [503] = {.entry = {.count = 1, .reusable = true}}, SHIFT(331),
  [505] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declaration, 4, .production_id = 69),
  [507] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_declaration, 4, .production_id = 69),
  [509] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function, 4, .production_id = 69),
  [511] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function, 4, .production_id = 69),
  [513] = {.entry = {.count = 1, .reusable = true}}, SHIFT(307),
  [515] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_body, 3, .production_id = 62),
  [517] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_body, 3, .production_id = 62),
  [519] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generator_function_declaration, 6, .production_id = 88),
  [521] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generator_function_declaration, 6, .production_id = 88),
  [523] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generator_function, 6, .production_id = 88),
  [525] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generator_function, 6, .production_id = 88),
  [527] = {.entry = {.count = 1, .reusable = true}}, SHIFT(283),
  [529] = {.entry = {.count = 1, .reusable = false}}, SHIFT(360),
  [531] = {.entry = {.count = 1, .reusable = false}}, SHIFT(359),
  [533] = {.entry = {.count = 1, .reusable = true}}, SHIFT(71),
  [535] = {.entry = {.count = 1, .reusable = true}}, SHIFT(634),
  [537] = {.entry = {.count = 1, .reusable = true}}, SHIFT(884),
  [539] = {.entry = {.count = 1, .reusable = false}}, SHIFT(219),
  [541] = {.entry = {.count = 1, .reusable = true}}, SHIFT(182),
  [543] = {.entry = {.count = 1, .reusable = true}}, SHIFT(441),
  [545] = {.entry = {.count = 1, .reusable = true}}, SHIFT(641),
  [547] = {.entry = {.count = 1, .reusable = false}}, SHIFT(354),
  [549] = {.entry = {.count = 1, .reusable = false}}, SHIFT(356),
  [551] = {.entry = {.count = 1, .reusable = true}}, SHIFT(643),
  [553] = {.entry = {.count = 1, .reusable = false}}, SHIFT(808),
  [555] = {.entry = {.count = 1, .reusable = false}}, SHIFT(814),
  [557] = {.entry = {.count = 1, .reusable = true}}, SHIFT(66),
  [559] = {.entry = {.count = 1, .reusable = false}}, SHIFT(213),
  [561] = {.entry = {.count = 1, .reusable = true}}, SHIFT(528),
  [563] = {.entry = {.count = 1, .reusable = true}}, SHIFT(403),
  [565] = {.entry = {.count = 1, .reusable = true}}, SHIFT(516),
  [567] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_array_repeat1, 1), REDUCE(aux_sym_array_pattern_repeat1, 1),
  [570] = {.entry = {.count = 1, .reusable = false}}, SHIFT(374),
  [572] = {.entry = {.count = 1, .reusable = false}}, SHIFT(370),
  [574] = {.entry = {.count = 1, .reusable = true}}, SHIFT(644),
  [576] = {.entry = {.count = 1, .reusable = true}}, SHIFT(692),
  [578] = {.entry = {.count = 1, .reusable = true}}, SHIFT(62),
  [580] = {.entry = {.count = 1, .reusable = true}}, SHIFT(809),
  [582] = {.entry = {.count = 1, .reusable = false}}, SHIFT(220),
  [584] = {.entry = {.count = 1, .reusable = true}}, SHIFT(846),
  [586] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1208),
  [588] = {.entry = {.count = 1, .reusable = true}}, SHIFT(76),
  [590] = {.entry = {.count = 1, .reusable = true}}, SHIFT(381),
  [592] = {.entry = {.count = 1, .reusable = true}}, SHIFT(128),
  [594] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_array_repeat1, 1),
  [596] = {.entry = {.count = 1, .reusable = true}}, SHIFT(560),
  [598] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1066),
  [600] = {.entry = {.count = 1, .reusable = true}}, SHIFT(889),
  [602] = {.entry = {.count = 1, .reusable = false}}, SHIFT(372),
  [604] = {.entry = {.count = 1, .reusable = false}}, SHIFT(373),
  [606] = {.entry = {.count = 1, .reusable = false}}, SHIFT(223),
  [608] = {.entry = {.count = 1, .reusable = true}}, SHIFT(288),
  [610] = {.entry = {.count = 1, .reusable = false}}, SHIFT(376),
  [612] = {.entry = {.count = 1, .reusable = false}}, SHIFT(377),
  [614] = {.entry = {.count = 1, .reusable = true}}, SHIFT(647),
  [616] = {.entry = {.count = 1, .reusable = false}}, SHIFT(853),
  [618] = {.entry = {.count = 1, .reusable = true}}, SHIFT(64),
  [620] = {.entry = {.count = 1, .reusable = false}}, SHIFT(226),
  [622] = {.entry = {.count = 1, .reusable = true}}, SHIFT(31),
  [624] = {.entry = {.count = 1, .reusable = true}}, SHIFT(30),
  [626] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5),
  [628] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2),
  [630] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1159),
  [632] = {.entry = {.count = 1, .reusable = true}}, SHIFT(187),
  [634] = {.entry = {.count = 1, .reusable = true}}, SHIFT(938),
  [636] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_primary_expression, 1, .production_id = 1),
  [638] = {.entry = {.count = 1, .reusable = true}}, SHIFT(529),
  [640] = {.entry = {.count = 1, .reusable = true}}, SHIFT(821),
  [642] = {.entry = {.count = 1, .reusable = true}}, SHIFT(825),
  [644] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1, .production_id = 1), REDUCE(sym__property_name, 1, .production_id = 4),
  [647] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_primary_expression, 1, .production_id = 1),
  [649] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__property_name, 1, .production_id = 4), SHIFT(43),
  [652] = {.entry = {.count = 1, .reusable = false}}, SHIFT(145),
  [654] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1314),
  [656] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1312),
  [658] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1162),
  [660] = {.entry = {.count = 1, .reusable = true}}, SHIFT(90),
  [662] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__augmented_assignment_lhs, 1, .production_id = 1),
  [664] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1336),
  [666] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4),
  [668] = {.entry = {.count = 1, .reusable = false}}, SHIFT(341),
  [670] = {.entry = {.count = 1, .reusable = false}}, SHIFT(342),
  [672] = {.entry = {.count = 1, .reusable = false}}, SHIFT(207),
  [674] = {.entry = {.count = 1, .reusable = true}}, SHIFT(397),
  [676] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1268),
  [678] = {.entry = {.count = 1, .reusable = true}}, SHIFT(476),
  [680] = {.entry = {.count = 1, .reusable = false}}, SHIFT(346),
  [682] = {.entry = {.count = 1, .reusable = false}}, SHIFT(353),
  [684] = {.entry = {.count = 1, .reusable = false}}, SHIFT(211),
  [686] = {.entry = {.count = 1, .reusable = false}}, SHIFT(116),
  [688] = {.entry = {.count = 1, .reusable = false}}, SHIFT(371),
  [690] = {.entry = {.count = 1, .reusable = false}}, SHIFT(375),
  [692] = {.entry = {.count = 1, .reusable = true}}, SHIFT(34),
  [694] = {.entry = {.count = 1, .reusable = false}}, SHIFT(166),
  [696] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1255),
  [698] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1355),
  [700] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1081),
  [702] = {.entry = {.count = 1, .reusable = true}}, SHIFT(43),
  [704] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1175),
  [706] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1176),
  [708] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1, .production_id = 1), SHIFT(754),
  [711] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_primary_expression, 1, .production_id = 1), REDUCE(sym__property_name, 1, .production_id = 4), SHIFT(697),
  [715] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1, .production_id = 1), SHIFT(129),
  [718] = {.entry = {.count = 1, .reusable = false}}, SHIFT(935),
  [720] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1181),
  [722] = {.entry = {.count = 1, .reusable = false}}, SHIFT(725),
  [724] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1301),
  [726] = {.entry = {.count = 1, .reusable = false}}, SHIFT(706),
  [728] = {.entry = {.count = 1, .reusable = false}}, SHIFT(736),
  [730] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1331),
  [732] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1330),
  [734] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1, .production_id = 1), SHIFT(697),
  [737] = {.entry = {.count = 1, .reusable = false}}, SHIFT(161),
  [739] = {.entry = {.count = 1, .reusable = false}}, SHIFT(932),
  [741] = {.entry = {.count = 1, .reusable = true}}, SHIFT(88),
  [743] = {.entry = {.count = 1, .reusable = true}}, SHIFT(218),
  [745] = {.entry = {.count = 1, .reusable = false}}, SHIFT(146),
  [747] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1256),
  [749] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1254),
  [751] = {.entry = {.count = 1, .reusable = false}}, SHIFT(916),
  [753] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1, .production_id = 1), SHIFT(99),
  [756] = {.entry = {.count = 1, .reusable = false}}, SHIFT(99),
  [758] = {.entry = {.count = 1, .reusable = false}}, SHIFT(956),
  [760] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_try_statement, 2, .production_id = 6),
  [762] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_try_statement, 2, .production_id = 6),
  [764] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1021),
  [766] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1141),
  [768] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1, .production_id = 1), REDUCE(sym_pattern, 1, .dynamic_precedence = -1, .production_id = 1),
  [771] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_pattern, 1, .dynamic_precedence = -1, .production_id = 1), SHIFT(146),
  [774] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pattern, 1, .dynamic_precedence = -1, .production_id = 1),
  [776] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_try_statement, 3, .production_id = 24),
  [778] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_try_statement, 3, .production_id = 24),
  [780] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1296),
  [782] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1297),
  [784] = {.entry = {.count = 1, .reusable = true}}, SHIFT(102),
  [786] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_empty_statement, 1),
  [788] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_empty_statement, 1),
  [790] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_catch_clause, 5, .production_id = 92),
  [792] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_catch_clause, 5, .production_id = 92),
  [794] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 3, .production_id = 20),
  [796] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 3, .production_id = 20),
  [798] = {.entry = {.count = 1, .reusable = false}}, SHIFT(27),
  [800] = {.entry = {.count = 1, .reusable = true}}, SHIFT(239),
  [802] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_catch_clause, 2, .production_id = 6),
  [804] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_catch_clause, 2, .production_id = 6),
  [806] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression_statement, 2),
  [808] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_expression_statement, 2),
  [810] = {.entry = {.count = 1, .reusable = true}}, SHIFT(234),
  [812] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_body, 3),
  [814] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_body, 3),
  [816] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_break_statement, 2),
  [818] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_break_statement, 2),
  [820] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_in_statement, 4, .production_id = 55),
  [822] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_in_statement, 4, .production_id = 55),
  [824] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_statement, 3),
  [826] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_export_statement, 3),
  [828] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_body, 2),
  [830] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_body, 2),
  [832] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 4, .production_id = 54),
  [834] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 4, .production_id = 54),
  [836] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lexical_declaration, 4),
  [838] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lexical_declaration, 4),
  [840] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declaration, 4),
  [842] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_variable_declaration, 4),
  [844] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_statement, 4, .production_id = 46),
  [846] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_statement, 4, .production_id = 46),
  [848] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_while_statement, 3, .production_id = 23),
  [850] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_while_statement, 3, .production_id = 23),
  [852] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_finally_clause, 2, .production_id = 6),
  [854] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_finally_clause, 2, .production_id = 6),
  [856] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_try_statement, 4, .production_id = 56),
  [858] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_try_statement, 4, .production_id = 56),
  [860] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 6, .production_id = 83),
  [862] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 6, .production_id = 83),
  [864] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 4, .production_id = 33),
  [866] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 4, .production_id = 33),
  [868] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generator_function_declaration, 6, .production_id = 78),
  [870] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generator_function_declaration, 6, .production_id = 78),
  [872] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declaration, 1),
  [874] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declaration, 1),
  [876] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declaration, 6, .production_id = 78),
  [878] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_declaration, 6, .production_id = 78),
  [880] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_statement, 4, .production_id = 46),
  [882] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_export_statement, 4, .production_id = 46),
  [884] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 6, .production_id = 87),
  [886] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 6, .production_id = 87),
  [888] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_labeled_statement, 3, .dynamic_precedence = -1, .production_id = 13),
  [890] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_labeled_statement, 3, .dynamic_precedence = -1, .production_id = 13),
  [892] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_else_clause, 2),
  [894] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_else_clause, 2),
  [896] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generator_function_declaration, 7, .production_id = 88),
  [898] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generator_function_declaration, 7, .production_id = 88),
  [900] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_statement, 3, .production_id = 18),
  [902] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_statement, 3, .production_id = 18),
  [904] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_statement, 4, .production_id = 47),
  [906] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_export_statement, 4, .production_id = 47),
  [908] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_return_statement, 2),
  [910] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_return_statement, 2),
  [912] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_statement, 3, .production_id = 44),
  [914] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_export_statement, 3, .production_id = 44),
  [916] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_debugger_statement, 2),
  [918] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_debugger_statement, 2),
  [920] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_continue_statement, 2),
  [922] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_continue_statement, 2),
  [924] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declaration, 3),
  [926] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_variable_declaration, 3),
  [928] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_statement, 2, .production_id = 3),
  [930] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_export_statement, 2, .production_id = 3),
  [932] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_throw_statement, 3),
  [934] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_throw_statement, 3),
  [936] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lexical_declaration, 3),
  [938] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lexical_declaration, 3),
  [940] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_return_statement, 3),
  [942] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_return_statement, 3),
  [944] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_statement, 3, .production_id = 21),
  [946] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_statement, 3, .production_id = 21),
  [948] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_continue_statement, 3, .production_id = 27),
  [950] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_continue_statement, 3, .production_id = 27),
  [952] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_break_statement, 3, .production_id = 27),
  [954] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_break_statement, 3, .production_id = 27),
  [956] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_do_statement, 5, .production_id = 75),
  [958] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_do_statement, 5, .production_id = 75),
  [960] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 5, .production_id = 64),
  [962] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 5, .production_id = 64),
  [964] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_statement, 3, .production_id = 26),
  [966] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_with_statement, 3, .production_id = 26),
  [968] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_try_statement, 3, .production_id = 25),
  [970] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_try_statement, 3, .production_id = 25),
  [972] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declaration, 5, .production_id = 69),
  [974] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_declaration, 5, .production_id = 69),
  [976] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 7, .production_id = 91),
  [978] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 7, .production_id = 91),
  [980] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_statement, 5, .production_id = 82),
  [982] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_export_statement, 5, .production_id = 82),
  [984] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_in_statement, 3, .production_id = 22),
  [986] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_in_statement, 3, .production_id = 22),
  [988] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 5, .production_id = 71),
  [990] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 5, .production_id = 71),
  [992] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_primary_expression, 1),
  [994] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_primary_expression, 1),
  [996] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1), REDUCE(sym__property_name, 1, .production_id = 4),
  [999] = {.entry = {.count = 1, .reusable = false}}, SHIFT(179),
  [1001] = {.entry = {.count = 1, .reusable = true}}, SHIFT(113),
  [1003] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__augmented_assignment_lhs, 1),
  [1005] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_subscript_expression, 4, .production_id = 70),
  [1007] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_subscript_expression, 4, .production_id = 70),
  [1009] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_member_expression, 3, .production_id = 40),
  [1011] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_member_expression, 3, .production_id = 40),
  [1013] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_subscript_expression, 5, .production_id = 79),
  [1015] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_subscript_expression, 5, .production_id = 79),
  [1017] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parenthesized_expression, 3),
  [1019] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_expression, 3),
  [1021] = {.entry = {.count = 1, .reusable = false}}, SHIFT(191),
  [1023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(95),
  [1025] = {.entry = {.count = 1, .reusable = false}}, SHIFT(152),
  [1027] = {.entry = {.count = 1, .reusable = false}}, SHIFT(180),
  [1029] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1), SHIFT(105),
  [1032] = {.entry = {.count = 1, .reusable = true}}, SHIFT(105),
  [1034] = {.entry = {.count = 1, .reusable = true}}, SHIFT(99),
  [1036] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1), REDUCE(sym_pattern, 1, .dynamic_precedence = -1),
  [1039] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_pattern, 1, .dynamic_precedence = -1), SHIFT(191),
  [1042] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__for_header, 6, .production_id = 90),
  [1044] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_header, 6, .production_id = 90),
  [1046] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__for_header, 5, .production_id = 86),
  [1048] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_header, 5, .production_id = 86),
  [1050] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__for_header, 5, .production_id = 85),
  [1052] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_header, 5, .production_id = 85),
  [1054] = {.entry = {.count = 1, .reusable = true}}, SHIFT(100),
  [1056] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1), REDUCE(sym_rest_pattern, 2),
  [1059] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pattern, 1, .dynamic_precedence = -1),
  [1061] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_rest_pattern, 2),
  [1063] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arguments, 4),
  [1065] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arguments, 4),
  [1067] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arguments, 3),
  [1069] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arguments, 3),
  [1071] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arguments, 2),
  [1073] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arguments, 2),
  [1075] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1183),
  [1077] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1302),
  [1079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(908),
  [1081] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import, 1),
  [1083] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import, 1),
  [1085] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_binary_expression, 3, .production_id = 39),
  [1087] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_binary_expression, 3, .production_id = 39),
  [1089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(75),
  [1091] = {.entry = {.count = 1, .reusable = true}}, SHIFT(119),
  [1093] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1272),
  [1095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1076),
  [1097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(451),
  [1099] = {.entry = {.count = 1, .reusable = true}}, SHIFT(486),
  [1101] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_unary_expression, 2, .production_id = 8),
  [1103] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_unary_expression, 2, .production_id = 8),
  [1105] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_update_expression, 2, .production_id = 8),
  [1107] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_update_expression, 2, .production_id = 8),
  [1109] = {.entry = {.count = 1, .reusable = false}}, SHIFT(147),
  [1111] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_augmented_assignment_expression, 3, .production_id = 37),
  [1113] = {.entry = {.count = 1, .reusable = false}}, SHIFT(131),
  [1115] = {.entry = {.count = 1, .reusable = false}}, SHIFT(142),
  [1117] = {.entry = {.count = 1, .reusable = false}}, SHIFT(168),
  [1119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(130),
  [1121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(133),
  [1123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(147),
  [1125] = {.entry = {.count = 1, .reusable = false}}, SHIFT(130),
  [1127] = {.entry = {.count = 1, .reusable = false}}, SHIFT(133),
  [1129] = {.entry = {.count = 1, .reusable = false}}, SHIFT(136),
  [1131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(137),
  [1133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(142),
  [1135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(162),
  [1137] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arrow_function, 3, .production_id = 38),
  [1139] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arrow_function, 3, .production_id = 43),
  [1141] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assignment_expression, 3, .production_id = 14),
  [1143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(474),
  [1145] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_regex, 3, .production_id = 30),
  [1147] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_regex, 3, .production_id = 30),
  [1149] = {.entry = {.count = 1, .reusable = false}}, SHIFT(466),
  [1151] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object, 3, .production_id = 16),
  [1153] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object, 3, .production_id = 16),
  [1155] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_object, 3, .production_id = 16), REDUCE(sym_object_pattern, 3, .production_id = 17),
  [1158] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object_pattern, 3, .production_id = 17),
  [1160] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arrow_function, 4, .production_id = 65),
  [1162] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arrow_function, 4, .production_id = 67),
  [1164] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_expression, 2, .production_id = 7),
  [1166] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_expression, 2, .production_id = 7),
  [1168] = {.entry = {.count = 1, .reusable = true}}, SHIFT(960),
  [1170] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arrow_function, 3, .production_id = 15),
  [1172] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_object, 2), REDUCE(sym_object_pattern, 2),
  [1175] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array, 2),
  [1177] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array, 2),
  [1179] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array, 2), REDUCE(sym_array_pattern, 2),
  [1182] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_pattern, 2),
  [1184] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_yield_expression, 2),
  [1186] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_await_expression, 2),
  [1188] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arrow_function, 4, .production_id = 68),
  [1190] = {.entry = {.count = 1, .reusable = true}}, SHIFT(91),
  [1192] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sequence_expression, 3, .production_id = 37),
  [1194] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ternary_expression, 5, .production_id = 80),
  [1196] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assignment_expression, 3, .production_id = 37),
  [1198] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_yield_expression, 3),
  [1200] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_call_expression, 3, .production_id = 41),
  [1202] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_call_expression, 3, .production_id = 41),
  [1204] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function, 4, .production_id = 66),
  [1206] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function, 4, .production_id = 66),
  [1208] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_template_string, 2),
  [1210] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_string, 2),
  [1212] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_string, 2),
  [1214] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string, 2),
  [1216] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 2, .production_id = 6),
  [1218] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 2, .production_id = 6),
  [1220] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_meta_property, 3),
  [1222] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_meta_property, 3),
  [1224] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_string, 3),
  [1226] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string, 3),
  [1228] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_expression, 1),
  [1230] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression, 1),
  [1232] = {.entry = {.count = 1, .reusable = false}}, SHIFT(185),
  [1234] = {.entry = {.count = 1, .reusable = true}}, SHIFT(77),
  [1236] = {.entry = {.count = 1, .reusable = false}}, SHIFT(188),
  [1238] = {.entry = {.count = 1, .reusable = true}}, SHIFT(108),
  [1240] = {.entry = {.count = 1, .reusable = false}}, SHIFT(190),
  [1242] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1271),
  [1244] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1217),
  [1246] = {.entry = {.count = 1, .reusable = false}}, SHIFT(193),
  [1248] = {.entry = {.count = 1, .reusable = true}}, SHIFT(194),
  [1250] = {.entry = {.count = 1, .reusable = true}}, SHIFT(195),
  [1252] = {.entry = {.count = 1, .reusable = true}}, SHIFT(185),
  [1254] = {.entry = {.count = 1, .reusable = false}}, SHIFT(194),
  [1256] = {.entry = {.count = 1, .reusable = false}}, SHIFT(195),
  [1258] = {.entry = {.count = 1, .reusable = false}}, SHIFT(183),
  [1260] = {.entry = {.count = 1, .reusable = true}}, SHIFT(181),
  [1262] = {.entry = {.count = 1, .reusable = true}}, SHIFT(190),
  [1264] = {.entry = {.count = 1, .reusable = true}}, SHIFT(177),
  [1266] = {.entry = {.count = 1, .reusable = true}}, SHIFT(570),
  [1268] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_expression, 3, .dynamic_precedence = 1, .production_id = 36),
  [1270] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_expression, 3, .dynamic_precedence = 1, .production_id = 36),
  [1272] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_template_string, 3),
  [1274] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_string, 3),
  [1276] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arrow_function, 3, .production_id = 38),
  [1278] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_update_expression, 2, .production_id = 9),
  [1280] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_update_expression, 2, .production_id = 9),
  [1282] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_jsx_element, 3, .production_id = 42),
  [1284] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_jsx_element, 3, .production_id = 42),
  [1286] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_call_expression, 2, .production_id = 10),
  [1288] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_call_expression, 2, .production_id = 10),
  [1290] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arrow_function, 3, .production_id = 43),
  [1292] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_jsx_element, 2, .production_id = 11),
  [1294] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_jsx_element, 2, .production_id = 11),
  [1296] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 3, .production_id = 45),
  [1298] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 3, .production_id = 45),
  [1300] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object, 4, .production_id = 16),
  [1302] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object, 4, .production_id = 16),
  [1304] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object, 4),
  [1306] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object, 4),
  [1308] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array, 4),
  [1310] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array, 4),
  [1312] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_jsx_self_closing_element, 4, .production_id = 28),
  [1314] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_jsx_self_closing_element, 4, .production_id = 28),
  [1316] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_regex, 4, .production_id = 59),
  [1318] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_regex, 4, .production_id = 59),
  [1320] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 3, .production_id = 34),
  [1322] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 3, .production_id = 34),
  [1324] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arrow_function, 4, .production_id = 65),
  [1326] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arrow_function, 3, .production_id = 15),
  [1328] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_object_assignment_pattern, 3, .production_id = 49), REDUCE(sym_assignment_expression, 3, .production_id = 14),
  [1331] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_assignment_pattern, 3, .production_id = 49),
  [1333] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arrow_function, 4, .production_id = 67),
  [1335] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function, 3, .production_id = 35),
  [1337] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function, 3, .production_id = 35),
  [1339] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arrow_function, 4, .production_id = 68),
  [1341] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generator_function, 4, .production_id = 66),
  [1343] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generator_function, 4, .production_id = 66),
  [1345] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_object_assignment_pattern, 3, .production_id = 49), REDUCE(sym_assignment_expression, 3, .production_id = 37),
  [1348] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object, 3),
  [1350] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object, 3),
  [1352] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_object_assignment_pattern, 3, .production_id = 37), REDUCE(sym_assignment_expression, 3, .production_id = 37),
  [1355] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_assignment_pattern, 3, .production_id = 37),
  [1357] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 4, .production_id = 72),
  [1359] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 4, .production_id = 72),
  [1361] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_jsx_fragment, 5),
  [1363] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_jsx_fragment, 5),
  [1365] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_jsx_self_closing_element, 5, .production_id = 57),
  [1367] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_jsx_self_closing_element, 5, .production_id = 57),
  [1369] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generator_function, 5, .production_id = 77),
  [1371] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generator_function, 5, .production_id = 77),
  [1373] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_spread_element, 2),
  [1375] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_jsx_closing_element, 4, .production_id = 81),
  [1377] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_jsx_closing_element, 4, .production_id = 81),
  [1379] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_jsx_fragment, 6),
  [1381] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_jsx_fragment, 6),
  [1383] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array, 3),
  [1385] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array, 3),
  [1387] = {.entry = {.count = 1, .reusable = false}}, SHIFT(598),
  [1389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(579),
  [1391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(87),
  [1393] = {.entry = {.count = 1, .reusable = true}}, SHIFT(298),
  [1395] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_array_repeat1, 2),
  [1397] = {.entry = {.count = 1, .reusable = true}}, SHIFT(537),
  [1399] = {.entry = {.count = 1, .reusable = true}}, SHIFT(944),
  [1401] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__initializer, 2, .production_id = 53),
  [1403] = {.entry = {.count = 1, .reusable = true}}, SHIFT(240),
  [1405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(294),
  [1407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(504),
  [1409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(379),
  [1411] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_object, 3, .production_id = 16), REDUCE(sym_object_pattern, 3, .production_id = 17),
  [1414] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_pattern, 3, .production_id = 17),
  [1416] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_array, 2), REDUCE(sym_array_pattern, 2),
  [1419] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_pattern, 2),
  [1421] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assignment_pattern, 3, .production_id = 37),
  [1423] = {.entry = {.count = 1, .reusable = true}}, SHIFT(534),
  [1425] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_object, 2), REDUCE(sym_object_pattern, 2),
  [1428] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_pattern, 2),
  [1430] = {.entry = {.count = 1, .reusable = false}}, SHIFT(158),
  [1432] = {.entry = {.count = 1, .reusable = false}}, SHIFT(186),
  [1434] = {.entry = {.count = 1, .reusable = false}}, SHIFT(157),
  [1436] = {.entry = {.count = 1, .reusable = true}}, SHIFT(132),
  [1438] = {.entry = {.count = 1, .reusable = true}}, SHIFT(158),
  [1440] = {.entry = {.count = 1, .reusable = false}}, SHIFT(132),
  [1442] = {.entry = {.count = 1, .reusable = false}}, SHIFT(150),
  [1444] = {.entry = {.count = 1, .reusable = true}}, SHIFT(139),
  [1446] = {.entry = {.count = 1, .reusable = true}}, SHIFT(157),
  [1448] = {.entry = {.count = 1, .reusable = false}}, SHIFT(159),
  [1450] = {.entry = {.count = 1, .reusable = true}}, SHIFT(173),
  [1452] = {.entry = {.count = 1, .reusable = false}}, SHIFT(173),
  [1454] = {.entry = {.count = 1, .reusable = true}}, SHIFT(169),
  [1456] = {.entry = {.count = 1, .reusable = true}}, SHIFT(338),
  [1458] = {.entry = {.count = 1, .reusable = true}}, SHIFT(337),
  [1460] = {.entry = {.count = 1, .reusable = true}}, SHIFT(951),
  [1462] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pair, 3, .production_id = 50),
  [1464] = {.entry = {.count = 1, .reusable = true}}, SHIFT(896),
  [1466] = {.entry = {.count = 1, .reusable = true}}, SHIFT(285),
  [1468] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1), REDUCE(sym__property_name, 1),
  [1471] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__property_name, 1),
  [1473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(335),
  [1475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(344),
  [1477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(361),
  [1479] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array, 3), REDUCE(sym_computed_property_name, 3),
  [1482] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_computed_property_name, 3),
  [1484] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10),
  [1486] = {.entry = {.count = 1, .reusable = true}}, SHIFT(364),
  [1488] = {.entry = {.count = 1, .reusable = true}}, SHIFT(32),
  [1490] = {.entry = {.count = 1, .reusable = true}}, SHIFT(366),
  [1492] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1000),
  [1494] = {.entry = {.count = 1, .reusable = true}}, SHIFT(365),
  [1496] = {.entry = {.count = 1, .reusable = true}}, SHIFT(348),
  [1498] = {.entry = {.count = 1, .reusable = true}}, SHIFT(351),
  [1500] = {.entry = {.count = 1, .reusable = true}}, SHIFT(42),
  [1502] = {.entry = {.count = 1, .reusable = true}}, SHIFT(330),
  [1504] = {.entry = {.count = 1, .reusable = true}}, SHIFT(309),
  [1506] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_heritage, 2),
  [1508] = {.entry = {.count = 1, .reusable = true}}, SHIFT(923),
  [1510] = {.entry = {.count = 1, .reusable = true}}, SHIFT(140),
  [1512] = {.entry = {.count = 1, .reusable = true}}, SHIFT(153),
  [1514] = {.entry = {.count = 1, .reusable = true}}, SHIFT(143),
  [1516] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1246),
  [1518] = {.entry = {.count = 1, .reusable = false}}, SHIFT(817),
  [1520] = {.entry = {.count = 1, .reusable = true}}, SHIFT(650),
  [1522] = {.entry = {.count = 1, .reusable = true}}, SHIFT(532),
  [1524] = {.entry = {.count = 1, .reusable = true}}, SHIFT(72),
  [1526] = {.entry = {.count = 1, .reusable = false}}, SHIFT(671),
  [1528] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1049),
  [1530] = {.entry = {.count = 1, .reusable = false}}, SHIFT(670),
  [1532] = {.entry = {.count = 1, .reusable = false}}, SHIFT(674),
  [1534] = {.entry = {.count = 1, .reusable = false}}, SHIFT(820),
  [1536] = {.entry = {.count = 1, .reusable = true}}, SHIFT(636),
  [1538] = {.entry = {.count = 1, .reusable = false}}, SHIFT(668),
  [1540] = {.entry = {.count = 1, .reusable = false}}, SHIFT(667),
  [1542] = {.entry = {.count = 1, .reusable = false}}, SHIFT(677),
  [1544] = {.entry = {.count = 1, .reusable = false}}, SHIFT(813),
  [1546] = {.entry = {.count = 1, .reusable = true}}, SHIFT(511),
  [1548] = {.entry = {.count = 1, .reusable = false}}, SHIFT(654),
  [1550] = {.entry = {.count = 1, .reusable = false}}, SHIFT(672),
  [1552] = {.entry = {.count = 1, .reusable = false}}, SHIFT(678),
  [1554] = {.entry = {.count = 1, .reusable = false}}, SHIFT(819),
  [1556] = {.entry = {.count = 1, .reusable = true}}, SHIFT(470),
  [1558] = {.entry = {.count = 1, .reusable = false}}, SHIFT(669),
  [1560] = {.entry = {.count = 1, .reusable = false}}, SHIFT(666),
  [1562] = {.entry = {.count = 1, .reusable = false}}, SHIFT(673),
  [1564] = {.entry = {.count = 1, .reusable = false}}, SHIFT(816),
  [1566] = {.entry = {.count = 1, .reusable = true}}, SHIFT(638),
  [1568] = {.entry = {.count = 1, .reusable = false}}, SHIFT(655),
  [1570] = {.entry = {.count = 1, .reusable = false}}, SHIFT(657),
  [1572] = {.entry = {.count = 1, .reusable = false}}, SHIFT(675),
  [1574] = {.entry = {.count = 1, .reusable = false}}, SHIFT(818),
  [1576] = {.entry = {.count = 1, .reusable = true}}, SHIFT(402),
  [1578] = {.entry = {.count = 1, .reusable = false}}, SHIFT(658),
  [1580] = {.entry = {.count = 1, .reusable = false}}, SHIFT(656),
  [1582] = {.entry = {.count = 1, .reusable = false}}, SHIFT(676),
  [1584] = {.entry = {.count = 1, .reusable = false}}, SHIFT(868),
  [1586] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_object_repeat1, 1), REDUCE(aux_sym_object_pattern_repeat1, 1),
  [1589] = {.entry = {.count = 1, .reusable = false}}, SHIFT(680),
  [1591] = {.entry = {.count = 1, .reusable = false}}, SHIFT(679),
  [1593] = {.entry = {.count = 1, .reusable = false}}, SHIFT(686),
  [1595] = {.entry = {.count = 1, .reusable = false}}, SHIFT(873),
  [1597] = {.entry = {.count = 1, .reusable = true}}, SHIFT(652),
  [1599] = {.entry = {.count = 1, .reusable = true}}, SHIFT(810),
  [1601] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1319),
  [1603] = {.entry = {.count = 1, .reusable = false}}, SHIFT(888),
  [1605] = {.entry = {.count = 1, .reusable = true}}, SHIFT(845),
  [1607] = {.entry = {.count = 1, .reusable = false}}, SHIFT(917),
  [1609] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_object_pattern_repeat1, 1),
  [1611] = {.entry = {.count = 1, .reusable = false}}, SHIFT(928),
  [1613] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_object_repeat1, 1),
  [1615] = {.entry = {.count = 1, .reusable = true}}, SHIFT(129),
  [1617] = {.entry = {.count = 1, .reusable = false}}, SHIFT(681),
  [1619] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1023),
  [1621] = {.entry = {.count = 1, .reusable = false}}, SHIFT(689),
  [1623] = {.entry = {.count = 1, .reusable = false}}, SHIFT(694),
  [1625] = {.entry = {.count = 1, .reusable = true}}, SHIFT(754),
  [1627] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__property_name, 1, .production_id = 4),
  [1629] = {.entry = {.count = 1, .reusable = true}}, SHIFT(151),
  [1631] = {.entry = {.count = 1, .reusable = true}}, SHIFT(642),
  [1633] = {.entry = {.count = 1, .reusable = false}}, SHIFT(966),
  [1635] = {.entry = {.count = 1, .reusable = true}}, SHIFT(53),
  [1637] = {.entry = {.count = 1, .reusable = true}}, SHIFT(178),
  [1639] = {.entry = {.count = 1, .reusable = false}}, SHIFT(684),
  [1641] = {.entry = {.count = 1, .reusable = true}}, SHIFT(832),
  [1643] = {.entry = {.count = 1, .reusable = false}}, SHIFT(682),
  [1645] = {.entry = {.count = 1, .reusable = false}}, SHIFT(690),
  [1647] = {.entry = {.count = 1, .reusable = true}}, SHIFT(60),
  [1649] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_class_body_repeat1, 2, .production_id = 63), SHIFT_REPEAT(966),
  [1652] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_class_body_repeat1, 2, .production_id = 63), SHIFT_REPEAT(755),
  [1655] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_class_body_repeat1, 2, .production_id = 63),
  [1657] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_class_body_repeat1, 2, .production_id = 63), SHIFT_REPEAT(178),
  [1660] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_class_body_repeat1, 2, .production_id = 63), SHIFT_REPEAT(684),
  [1663] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_class_body_repeat1, 2, .production_id = 63), SHIFT_REPEAT(950),
  [1666] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_class_body_repeat1, 2, .production_id = 63), SHIFT_REPEAT(945),
  [1669] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_class_body_repeat1, 2, .production_id = 63), SHIFT_REPEAT(832),
  [1672] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_class_body_repeat1, 2, .production_id = 63), SHIFT_REPEAT(1054),
  [1675] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_class_body_repeat1, 2, .production_id = 63), SHIFT_REPEAT(682),
  [1678] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_class_body_repeat1, 2, .production_id = 63), SHIFT_REPEAT(690),
  [1681] = {.entry = {.count = 1, .reusable = true}}, SHIFT(497),
  [1683] = {.entry = {.count = 1, .reusable = true}}, SHIFT(241),
  [1685] = {.entry = {.count = 1, .reusable = true}}, SHIFT(468),
  [1687] = {.entry = {.count = 1, .reusable = true}}, SHIFT(242),
  [1689] = {.entry = {.count = 1, .reusable = true}}, SHIFT(635),
  [1691] = {.entry = {.count = 1, .reusable = true}}, SHIFT(527),
  [1693] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_object_repeat1, 2, .production_id = 16), REDUCE(aux_sym_object_pattern_repeat1, 2, .production_id = 17),
  [1696] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_object_repeat1, 2, .production_id = 16),
  [1698] = {.entry = {.count = 1, .reusable = false}}, SHIFT(687),
  [1700] = {.entry = {.count = 1, .reusable = true}}, SHIFT(849),
  [1702] = {.entry = {.count = 1, .reusable = false}}, SHIFT(691),
  [1704] = {.entry = {.count = 1, .reusable = false}}, SHIFT(895),
  [1706] = {.entry = {.count = 1, .reusable = false}}, SHIFT(890),
  [1708] = {.entry = {.count = 1, .reusable = true}}, SHIFT(683),
  [1710] = {.entry = {.count = 1, .reusable = true}}, SHIFT(852),
  [1712] = {.entry = {.count = 1, .reusable = true}}, SHIFT(745),
  [1714] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1138),
  [1716] = {.entry = {.count = 1, .reusable = false}}, SHIFT(734),
  [1718] = {.entry = {.count = 1, .reusable = false}}, SHIFT(693),
  [1720] = {.entry = {.count = 1, .reusable = true}}, SHIFT(747),
  [1722] = {.entry = {.count = 1, .reusable = false}}, SHIFT(887),
  [1724] = {.entry = {.count = 1, .reusable = false}}, SHIFT(730),
  [1726] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1166),
  [1728] = {.entry = {.count = 1, .reusable = false}}, SHIFT(728),
  [1730] = {.entry = {.count = 1, .reusable = false}}, SHIFT(738),
  [1732] = {.entry = {.count = 1, .reusable = false}}, SHIFT(743),
  [1734] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_array_pattern_repeat1, 1),
  [1736] = {.entry = {.count = 1, .reusable = true}}, SHIFT(134),
  [1738] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1173),
  [1740] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_decorator, 2),
  [1742] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decorator, 2),
  [1744] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1346),
  [1746] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1172),
  [1748] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_definition, 7, .production_id = 93),
  [1750] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_definition, 7, .production_id = 93),
  [1752] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_definition, 6, .production_id = 89),
  [1754] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_definition, 6, .production_id = 89),
  [1756] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_decorator_member_expression, 3, .production_id = 40),
  [1758] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decorator_member_expression, 3, .production_id = 40),
  [1760] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_definition, 6, .production_id = 88),
  [1762] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_definition, 6, .production_id = 88),
  [1764] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_definition, 4, .production_id = 69),
  [1766] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_definition, 4, .production_id = 69),
  [1768] = {.entry = {.count = 1, .reusable = true}}, SHIFT(167),
  [1770] = {.entry = {.count = 1, .reusable = true}}, SHIFT(165),
  [1772] = {.entry = {.count = 1, .reusable = true}}, SHIFT(746),
  [1774] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1223),
  [1776] = {.entry = {.count = 1, .reusable = false}}, SHIFT(739),
  [1778] = {.entry = {.count = 1, .reusable = false}}, SHIFT(740),
  [1780] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_export_statement_repeat1, 2, .production_id = 12),
  [1782] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_export_statement_repeat1, 2, .production_id = 12),
  [1784] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_export_statement_repeat1, 2, .production_id = 12), SHIFT_REPEAT(1054),
  [1787] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_definition, 5, .production_id = 84),
  [1789] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_definition, 5, .production_id = 84),
  [1791] = {.entry = {.count = 1, .reusable = true}}, SHIFT(171),
  [1793] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_definition, 4, .production_id = 74),
  [1795] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_definition, 4, .production_id = 74),
  [1797] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_definition, 3, .production_id = 51),
  [1799] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_definition, 3, .production_id = 51),
  [1801] = {.entry = {.count = 1, .reusable = true}}, SHIFT(104),
  [1803] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_definition, 5, .production_id = 78),
  [1805] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_definition, 5, .production_id = 78),
  [1807] = {.entry = {.count = 1, .reusable = true}}, SHIFT(752),
  [1809] = {.entry = {.count = 1, .reusable = false}}, SHIFT(715),
  [1811] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1148),
  [1813] = {.entry = {.count = 1, .reusable = false}}, SHIFT(741),
  [1815] = {.entry = {.count = 1, .reusable = false}}, SHIFT(733),
  [1817] = {.entry = {.count = 1, .reusable = true}}, SHIFT(751),
  [1819] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1145),
  [1821] = {.entry = {.count = 1, .reusable = false}}, SHIFT(737),
  [1823] = {.entry = {.count = 1, .reusable = false}}, SHIFT(742),
  [1825] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1219),
  [1827] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1250),
  [1829] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1232),
  [1831] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1149),
  [1833] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1131),
  [1835] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1129),
  [1837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1221),
  [1839] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1228),
  [1841] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1150),
  [1843] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_class_body_repeat1, 1, .production_id = 31),
  [1845] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_class_body_repeat1, 1, .production_id = 31),
  [1847] = {.entry = {.count = 1, .reusable = true}}, SHIFT(748),
  [1849] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1134),
  [1851] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1144),
  [1853] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_class_body_repeat1, 2, .production_id = 31),
  [1855] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_class_body_repeat1, 2, .production_id = 31),
  [1857] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_decorator_call_expression, 2, .production_id = 10),
  [1859] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decorator_call_expression, 2, .production_id = 10),
  [1861] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_export_statement_repeat1, 1, .production_id = 2),
  [1863] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_export_statement_repeat1, 1, .production_id = 2),
  [1865] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1242),
  [1867] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1225),
  [1869] = {.entry = {.count = 1, .reusable = false}}, SHIFT(828),
  [1871] = {.entry = {.count = 1, .reusable = true}}, SHIFT(81),
  [1873] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1133),
  [1875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1038),
  [1877] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1328),
  [1879] = {.entry = {.count = 1, .reusable = true}}, SHIFT(828),
  [1881] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1329),
  [1883] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1288),
  [1885] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1351),
  [1887] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1266),
  [1889] = {.entry = {.count = 1, .reusable = false}}, SHIFT(79),
  [1891] = {.entry = {.count = 1, .reusable = false}}, SHIFT(834),
  [1893] = {.entry = {.count = 1, .reusable = false}}, SHIFT(786),
  [1895] = {.entry = {.count = 1, .reusable = false}}, SHIFT_EXTRA(),
  [1897] = {.entry = {.count = 1, .reusable = false}}, SHIFT(842),
  [1899] = {.entry = {.count = 1, .reusable = false}}, SHIFT(836),
  [1901] = {.entry = {.count = 1, .reusable = false}}, SHIFT(773),
  [1903] = {.entry = {.count = 1, .reusable = true}}, SHIFT(871),
  [1905] = {.entry = {.count = 1, .reusable = true}}, SHIFT(948),
  [1907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(949),
  [1909] = {.entry = {.count = 1, .reusable = false}}, SHIFT(847),
  [1911] = {.entry = {.count = 1, .reusable = false}}, SHIFT(770),
  [1913] = {.entry = {.count = 1, .reusable = false}}, SHIFT(760),
  [1915] = {.entry = {.count = 1, .reusable = false}}, SHIFT(763),
  [1917] = {.entry = {.count = 1, .reusable = false}}, SHIFT(860),
  [1919] = {.entry = {.count = 1, .reusable = false}}, SHIFT(797),
  [1921] = {.entry = {.count = 1, .reusable = true}}, SHIFT(977),
  [1923] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1264),
  [1925] = {.entry = {.count = 1, .reusable = false}}, SHIFT(829),
  [1927] = {.entry = {.count = 1, .reusable = false}}, SHIFT(840),
  [1929] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1282),
  [1931] = {.entry = {.count = 1, .reusable = true}}, SHIFT(974),
  [1933] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1281),
  [1935] = {.entry = {.count = 1, .reusable = true}}, SHIFT(981),
  [1937] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1280),
  [1939] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_jsx_element_repeat1, 2), SHIFT_REPEAT(79),
  [1942] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_jsx_element_repeat1, 2), SHIFT_REPEAT(874),
  [1945] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_jsx_element_repeat1, 2), SHIFT_REPEAT(786),
  [1948] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_jsx_opening_element_repeat1, 2, .production_id = 58), SHIFT_REPEAT(828),
  [1951] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_jsx_opening_element_repeat1, 2, .production_id = 58), SHIFT_REPEAT(81),
  [1954] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_jsx_opening_element_repeat1, 2, .production_id = 58),
  [1956] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_jsx_opening_element_repeat1, 2, .production_id = 58),
  [1958] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_jsx_opening_element_repeat1, 2, .production_id = 58), SHIFT_REPEAT(828),
  [1961] = {.entry = {.count = 1, .reusable = false}}, SHIFT(856),
  [1963] = {.entry = {.count = 1, .reusable = false}}, SHIFT(780),
  [1965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(984),
  [1967] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1279),
  [1969] = {.entry = {.count = 1, .reusable = false}}, SHIFT(861),
  [1971] = {.entry = {.count = 1, .reusable = false}}, SHIFT(848),
  [1973] = {.entry = {.count = 1, .reusable = false}}, SHIFT(790),
  [1975] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1341),
  [1977] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1260),
  [1979] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1342),
  [1981] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1261),
  [1983] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1263),
  [1985] = {.entry = {.count = 1, .reusable = false}}, SHIFT(858),
  [1987] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1290),
  [1989] = {.entry = {.count = 1, .reusable = false}}, SHIFT(835),
  [1991] = {.entry = {.count = 1, .reusable = false}}, SHIFT(782),
  [1993] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1293),
  [1995] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1343),
  [1997] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1304),
  [1999] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1344),
  [2001] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1292),
  [2003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(815),
  [2005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(651),
  [2007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(685),
  [2009] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_pattern, 4),
  [2011] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_pattern, 3),
  [2013] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declarator, 1, .production_id = 5),
  [2015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(120),
  [2017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(135),
  [2019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(901),
  [2021] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_pattern, 4, .production_id = 17),
  [2023] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_pattern, 3),
  [2025] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_pattern, 4),
  [2027] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_jsx_attribute, 1, .production_id = 4),
  [2029] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_jsx_attribute, 1, .production_id = 4),
  [2031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(774),
  [2033] = {.entry = {.count = 1, .reusable = false}}, SHIFT(757),
  [2035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(788),
  [2037] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1276),
  [2039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(769),
  [2041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(863),
  [2043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(575),
  [2045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(114),
  [2047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(854),
  [2049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(434),
  [2051] = {.entry = {.count = 1, .reusable = true}}, SHIFT(697),
  [2053] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 1, .production_id = 32),
  [2055] = {.entry = {.count = 1, .reusable = false}}, SHIFT(911),
  [2057] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1265),
  [2059] = {.entry = {.count = 1, .reusable = false}}, SHIFT(931),
  [2061] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_switch_body_repeat1, 2), SHIFT_REPEAT(1306),
  [2064] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_switch_body_repeat1, 2),
  [2066] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_switch_body_repeat1, 2), SHIFT_REPEAT(94),
  [2069] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1258),
  [2071] = {.entry = {.count = 1, .reusable = false}}, SHIFT(965),
  [2073] = {.entry = {.count = 1, .reusable = true}}, SHIFT(831),
  [2075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(418),
  [2077] = {.entry = {.count = 1, .reusable = true}}, SHIFT(865),
  [2079] = {.entry = {.count = 1, .reusable = false}}, SHIFT(952),
  [2081] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1345),
  [2083] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 2, .production_id = 60),
  [2085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1306),
  [2087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(244),
  [2089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(94),
  [2091] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_jsx_attribute, 1),
  [2093] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_jsx_attribute, 1),
  [2095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(766),
  [2097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1192),
  [2099] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_template_string_repeat1, 2), SHIFT_REPEAT(854),
  [2102] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_template_string_repeat1, 2),
  [2104] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_template_string_repeat1, 2), SHIFT_REPEAT(114),
  [2107] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_nested_identifier, 3),
  [2109] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_nested_identifier, 3),
  [2111] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1285),
  [2113] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_jsx_namespace_name, 3),
  [2115] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_jsx_namespace_name, 3),
  [2117] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1309),
  [2119] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1299),
  [2121] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1335),
  [2123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1308),
  [2125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(556),
  [2127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(249),
  [2129] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_rest_pattern, 2),
  [2131] = {.entry = {.count = 1, .reusable = false}}, SHIFT(933),
  [2133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(662),
  [2135] = {.entry = {.count = 1, .reusable = false}}, SHIFT(184),
  [2137] = {.entry = {.count = 1, .reusable = false}}, SHIFT(920),
  [2139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(659),
  [2141] = {.entry = {.count = 1, .reusable = false}}, SHIFT(759),
  [2143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(801),
  [2145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(775),
  [2147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(822),
  [2149] = {.entry = {.count = 1, .reusable = false}}, SHIFT(756),
  [2151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(778),
  [2153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(761),
  [2155] = {.entry = {.count = 1, .reusable = false}}, SHIFT(904),
  [2157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(698),
  [2159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(899),
  [2161] = {.entry = {.count = 1, .reusable = false}}, SHIFT(758),
  [2163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(791),
  [2165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(762),
  [2167] = {.entry = {.count = 1, .reusable = false}}, SHIFT(962),
  [2169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(837),
  [2171] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_jsx_expression, 2),
  [2173] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_jsx_expression, 2),
  [2175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(701),
  [2177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(887),
  [2179] = {.entry = {.count = 1, .reusable = false}}, SHIFT(964),
  [2181] = {.entry = {.count = 1, .reusable = false}}, SHIFT(909),
  [2183] = {.entry = {.count = 1, .reusable = false}}, SHIFT(918),
  [2185] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_jsx_expression, 3),
  [2187] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_jsx_expression, 3),
  [2189] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_jsx_attribute, 3),
  [2191] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_jsx_attribute, 3),
  [2193] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_jsx_attribute, 3, .production_id = 4),
  [2195] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_jsx_attribute, 3, .production_id = 4),
  [2197] = {.entry = {.count = 1, .reusable = false}}, SHIFT(939),
  [2199] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_jsx_opening_element_repeat1, 1, .production_id = 29),
  [2201] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_jsx_opening_element_repeat1, 1, .production_id = 29),
  [2203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(665),
  [2205] = {.entry = {.count = 1, .reusable = true}}, SHIFT(184),
  [2207] = {.entry = {.count = 1, .reusable = false}}, SHIFT(431),
  [2209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(907),
  [2211] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_string_repeat2, 2),
  [2213] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_string_repeat2, 2), SHIFT_REPEAT(906),
  [2216] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_string_repeat1, 2),
  [2218] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_string_repeat1, 2), SHIFT_REPEAT(907),
  [2221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(989),
  [2223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1311),
  [2225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1313),
  [2227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(824),
  [2229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(292),
  [2231] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1046),
  [2233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1107),
  [2235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(295),
  [2237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1147),
  [2239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1014),
  [2241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(148),
  [2243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(859),
  [2245] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_array_repeat1, 2), SHIFT_REPEAT(76),
  [2248] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1197),
  [2250] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1043),
  [2252] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_object_pattern_repeat1, 2, .production_id = 17),
  [2254] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_pattern, 1, .dynamic_precedence = -1), SHIFT(191),
  [2257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(700),
  [2259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1146),
  [2261] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1291),
  [2263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(892),
  [2265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(867),
  [2267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1212),
  [2269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1035),
  [2271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1001),
  [2273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(248),
  [2275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(812),
  [2277] = {.entry = {.count = 1, .reusable = false}}, SHIFT(987),
  [2279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1205),
  [2281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1169),
  [2283] = {.entry = {.count = 1, .reusable = true}}, SHIFT(997),
  [2285] = {.entry = {.count = 1, .reusable = true}}, SHIFT(906),
  [2287] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1125),
  [2289] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1042),
  [2291] = {.entry = {.count = 1, .reusable = true}}, SHIFT(251),
  [2293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(253),
  [2295] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1275),
  [2297] = {.entry = {.count = 1, .reusable = true}}, SHIFT(995),
  [2299] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1302),
  [2301] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_variable_declaration_repeat1, 2), SHIFT_REPEAT(824),
  [2304] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_variable_declaration_repeat1, 2),
  [2306] = {.entry = {.count = 1, .reusable = false}}, SHIFT(422),
  [2308] = {.entry = {.count = 1, .reusable = true}}, SHIFT(358),
  [2310] = {.entry = {.count = 1, .reusable = true}}, SHIFT(123),
  [2312] = {.entry = {.count = 1, .reusable = false}}, SHIFT(436),
  [2314] = {.entry = {.count = 1, .reusable = true}}, SHIFT(943),
  [2316] = {.entry = {.count = 1, .reusable = false}}, SHIFT(419),
  [2318] = {.entry = {.count = 1, .reusable = true}}, SHIFT(934),
  [2320] = {.entry = {.count = 1, .reusable = true}}, SHIFT(905),
  [2322] = {.entry = {.count = 1, .reusable = false}}, SHIFT(883),
  [2324] = {.entry = {.count = 1, .reusable = true}}, SHIFT(963),
  [2326] = {.entry = {.count = 1, .reusable = true}}, SHIFT(959),
  [2328] = {.entry = {.count = 1, .reusable = true}}, SHIFT(942),
  [2330] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_substitution, 3),
  [2332] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1004),
  [2334] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1229),
  [2336] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1168),
  [2338] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1012),
  [2340] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1224),
  [2342] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1057),
  [2344] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1270),
  [2346] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1202),
  [2348] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1063),
  [2350] = {.entry = {.count = 1, .reusable = false}}, SHIFT(872),
  [2352] = {.entry = {.count = 1, .reusable = true}}, SHIFT(336),
  [2354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(109),
  [2356] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1002),
  [2358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1215),
  [2360] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_jsx_opening_element, 4, .dynamic_precedence = -1, .production_id = 57),
  [2362] = {.entry = {.count = 1, .reusable = true}}, SHIFT(191),
  [2364] = {.entry = {.count = 1, .reusable = true}}, SHIFT(653),
  [2366] = {.entry = {.count = 1, .reusable = true}}, SHIFT(582),
  [2368] = {.entry = {.count = 1, .reusable = true}}, SHIFT(823),
  [2370] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1056),
  [2372] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1055),
  [2374] = {.entry = {.count = 1, .reusable = true}}, SHIFT(971),
  [2376] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__import_export_specifier, 1, .production_id = 5),
  [2378] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1352),
  [2380] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_formal_parameters_repeat1, 2), SHIFT_REPEAT(711),
  [2383] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_formal_parameters_repeat1, 2),
  [2385] = {.entry = {.count = 1, .reusable = true}}, SHIFT(827),
  [2387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(601),
  [2389] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_clause, 2),
  [2391] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_object_repeat1, 2), SHIFT_REPEAT(653),
  [2394] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_object_repeat1, 2),
  [2396] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1182),
  [2398] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_object_pattern_repeat1, 2), SHIFT_REPEAT(652),
  [2401] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_object_pattern_repeat1, 2),
  [2403] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1009),
  [2405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1323),
  [2407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(599),
  [2409] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_clause, 4, .production_id = 48),
  [2411] = {.entry = {.count = 1, .reusable = true}}, SHIFT(885),
  [2413] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1039),
  [2415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1277),
  [2417] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1053),
  [2419] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declarator, 2, .production_id = 19),
  [2421] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1274),
  [2423] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_export_clause_repeat1, 2), SHIFT_REPEAT(1160),
  [2426] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_export_clause_repeat1, 2),
  [2428] = {.entry = {.count = 1, .reusable = true}}, SHIFT(180),
  [2430] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1123),
  [2432] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1170),
  [2434] = {.entry = {.count = 1, .reusable = true}}, SHIFT(841),
  [2436] = {.entry = {.count = 1, .reusable = true}}, SHIFT(484),
  [2438] = {.entry = {.count = 1, .reusable = true}}, SHIFT(696),
  [2440] = {.entry = {.count = 1, .reusable = true}}, SHIFT(23),
  [2442] = {.entry = {.count = 1, .reusable = true}}, SHIFT(862),
  [2444] = {.entry = {.count = 1, .reusable = true}}, SHIFT(144),
  [2446] = {.entry = {.count = 1, .reusable = true}}, SHIFT(65),
  [2448] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1233),
  [2450] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_array_pattern_repeat1, 2),
  [2452] = {.entry = {.count = 1, .reusable = true}}, SHIFT(586),
  [2454] = {.entry = {.count = 1, .reusable = true}}, SHIFT(811),
  [2456] = {.entry = {.count = 1, .reusable = true}}, SHIFT(29),
  [2458] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_array_pattern_repeat1, 2), SHIFT_REPEAT(692),
  [2461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1195),
  [2463] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_jsx_opening_element, 3, .dynamic_precedence = -1, .production_id = 28),
  [2465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1305),
  [2467] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_named_imports_repeat1, 2), SHIFT_REPEAT(1111),
  [2470] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_named_imports_repeat1, 2),
  [2472] = {.entry = {.count = 1, .reusable = true}}, SHIFT(548),
  [2474] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1199),
  [2476] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1187),
  [2478] = {.entry = {.count = 1, .reusable = true}}, SHIFT(826),
  [2480] = {.entry = {.count = 1, .reusable = true}}, SHIFT(152),
  [2482] = {.entry = {.count = 1, .reusable = true}}, SHIFT(500),
  [2484] = {.entry = {.count = 1, .reusable = true}}, SHIFT(378),
  [2486] = {.entry = {.count = 1, .reusable = true}}, SHIFT(538),
  [2488] = {.entry = {.count = 1, .reusable = true}}, SHIFT(82),
  [2490] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1006),
  [2492] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1008),
  [2494] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_clause, 5, .production_id = 48),
  [2496] = {.entry = {.count = 1, .reusable = true}}, SHIFT(699),
  [2498] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_clause, 3, .production_id = 48),
  [2500] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1003),
  [2502] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1201),
  [2504] = {.entry = {.count = 1, .reusable = true}}, SHIFT(459),
  [2506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(843),
  [2508] = {.entry = {.count = 1, .reusable = true}}, SHIFT(838),
  [2510] = {.entry = {.count = 1, .reusable = true}}, SHIFT(460),
  [2512] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1191),
  [2514] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_clause, 3),
  [2516] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1236),
  [2518] = {.entry = {.count = 1, .reusable = true}}, SHIFT(291),
  [2520] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1227),
  [2522] = {.entry = {.count = 1, .reusable = true}}, SHIFT(245),
  [2524] = {.entry = {.count = 1, .reusable = true}}, SHIFT(67),
  [2526] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1204),
  [2528] = {.entry = {.count = 1, .reusable = true}}, SHIFT(463),
  [2530] = {.entry = {.count = 1, .reusable = true}}, SHIFT(833),
  [2532] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1108),
  [2534] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1354),
  [2536] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__from_clause, 2, .production_id = 18),
  [2538] = {.entry = {.count = 1, .reusable = true}}, SHIFT(111),
  [2540] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1117),
  [2542] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1353),
  [2544] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21),
  [2546] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22),
  [2548] = {.entry = {.count = 1, .reusable = true}}, SHIFT(290),
  [2550] = {.entry = {.count = 1, .reusable = false}}, SHIFT(857),
  [2552] = {.entry = {.count = 1, .reusable = true}}, SHIFT(857),
  [2554] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13),
  [2556] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pair_pattern, 3, .production_id = 50),
  [2558] = {.entry = {.count = 1, .reusable = true}}, SHIFT(125),
  [2560] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_formal_parameters, 3),
  [2562] = {.entry = {.count = 1, .reusable = true}}, SHIFT(257),
  [2564] = {.entry = {.count = 1, .reusable = true}}, SHIFT(259),
  [2566] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1194),
  [2568] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1289),
  [2570] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 3, .production_id = 76),
  [2572] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__import_export_specifier, 3, .production_id = 73),
  [2574] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_formal_parameters, 4),
  [2576] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_formal_parameters, 5),
  [2578] = {.entry = {.count = 1, .reusable = true}}, SHIFT(110),
  [2580] = {.entry = {.count = 1, .reusable = true}}, SHIFT(940),
  [2582] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_clause, 1),
  [2584] = {.entry = {.count = 1, .reusable = true}}, SHIFT(302),
  [2586] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19),
  [2588] = {.entry = {.count = 1, .reusable = true}}, SHIFT(284),
  [2590] = {.entry = {.count = 1, .reusable = true}}, SHIFT(277),
  [2592] = {.entry = {.count = 1, .reusable = true}}, SHIFT(278),
  [2594] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1132),
  [2596] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1339),
  [2598] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 2, .production_id = 61),
  [2600] = {.entry = {.count = 1, .reusable = true}}, SHIFT(864),
  [2602] = {.entry = {.count = 1, .reusable = true}}, SHIFT(84),
  [2604] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_formal_parameters, 2),
  [2606] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_named_imports_repeat1, 2, .production_id = 52),
  [2608] = {.entry = {.count = 1, .reusable = true}}, SHIFT(286),
  [2610] = {.entry = {.count = 1, .reusable = true}}, SHIFT(287),
  [2612] = {.entry = {.count = 1, .reusable = true}}, SHIFT(301),
  [2614] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_export_clause_repeat1, 2, .production_id = 48),
  [2616] = {.entry = {.count = 1, .reusable = true}}, SHIFT(300),
  [2618] = {.entry = {.count = 1, .reusable = true}}, SHIFT(154),
  [2620] = {.entry = {.count = 1, .reusable = false}}, SHIFT(505),
  [2622] = {.entry = {.count = 1, .reusable = true}}, SHIFT(961),
  [2624] = {.entry = {.count = 1, .reusable = true}}, SHIFT(112),
  [2626] = {.entry = {.count = 1, .reusable = true}}, SHIFT(886),
  [2628] = {.entry = {.count = 1, .reusable = true}}, SHIFT(881),
  [2630] = {.entry = {.count = 1, .reusable = true}}, SHIFT(879),
  [2632] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1143),
  [2634] = {.entry = {.count = 1, .reusable = true}}, SHIFT(878),
  [2636] = {.entry = {.count = 1, .reusable = true}}, SHIFT(877),
  [2638] = {.entry = {.count = 1, .reusable = true}}, SHIFT(875),
  [2640] = {.entry = {.count = 1, .reusable = true}}, SHIFT(870),
  [2642] = {.entry = {.count = 1, .reusable = true}}, SHIFT(118),
  [2644] = {.entry = {.count = 1, .reusable = true}}, SHIFT(547),
  [2646] = {.entry = {.count = 1, .reusable = true}}, SHIFT(929),
  [2648] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_named_imports, 4, .production_id = 52),
  [2650] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1064),
  [2652] = {.entry = {.count = 1, .reusable = true}}, SHIFT(972),
  [2654] = {.entry = {.count = 1, .reusable = true}}, SHIFT(967),
  [2656] = {.entry = {.count = 1, .reusable = true}}, SHIFT(969),
  [2658] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1020),
  [2660] = {.entry = {.count = 1, .reusable = true}}, SHIFT(979),
  [2662] = {.entry = {.count = 1, .reusable = true}}, SHIFT(980),
  [2664] = {.entry = {.count = 1, .reusable = true}}, SHIFT(982),
  [2666] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1135),
  [2668] = {.entry = {.count = 1, .reusable = true}}, SHIFT(608),
  [2670] = {.entry = {.count = 1, .reusable = true}}, SHIFT(903),
  [2672] = {.entry = {.count = 1, .reusable = true}}, SHIFT(610),
  [2674] = {.entry = {.count = 1, .reusable = true}}, SHIFT(614),
  [2676] = {.entry = {.count = 1, .reusable = true}}, SHIFT(103),
  [2678] = {.entry = {.count = 1, .reusable = true}}, SHIFT(98),
  [2680] = {.entry = {.count = 1, .reusable = true}}, SHIFT(97),
  [2682] = {.entry = {.count = 1, .reusable = true}}, SHIFT(617),
  [2684] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1310),
  [2686] = {.entry = {.count = 1, .reusable = true}}, SHIFT(611),
  [2688] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_named_imports, 5, .production_id = 52),
  [2690] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11),
  [2692] = {.entry = {.count = 1, .reusable = true}}, SHIFT(170),
  [2694] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1098),
  [2696] = {.entry = {.count = 1, .reusable = true}}, SHIFT(565),
  [2698] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1325),
  [2700] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1324),
  [2702] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1196),
  [2704] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_named_imports, 2),
  [2706] = {.entry = {.count = 1, .reusable = true}}, SHIFT(957),
  [2708] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_clause, 3),
  [2710] = {.entry = {.count = 1, .reusable = true}}, SHIFT(101),
  [2712] = {.entry = {.count = 1, .reusable = true}}, SHIFT(735),
  [2714] = {.entry = {.count = 1, .reusable = true}},  ACCEPT_INPUT(),
  [2716] = {.entry = {.count = 1, .reusable = true}}, SHIFT(117),
  [2718] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_named_imports, 3, .production_id = 52),
  [2720] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_named_imports, 3),
  [2722] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_namespace_import, 3),
  [2724] = {.entry = {.count = 1, .reusable = false}}, SHIFT(394),
  [2726] = {.entry = {.count = 1, .reusable = true}}, SHIFT(590),
  [2728] = {.entry = {.count = 1, .reusable = true}}, SHIFT(855),
  [2730] = {.entry = {.count = 1, .reusable = true}}, SHIFT(89),
  [2732] = {.entry = {.count = 1, .reusable = true}}, SHIFT(93),
  [2734] = {.entry = {.count = 1, .reusable = true}}, SHIFT(115),
  [2736] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1253),
  [2738] = {.entry = {.count = 1, .reusable = true}}, SHIFT(502),
  [2740] = {.entry = {.count = 1, .reusable = true}}, SHIFT(421),
  [2742] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1238),
  [2744] = {.entry = {.count = 1, .reusable = true}}, SHIFT(494),
  [2746] = {.entry = {.count = 1, .reusable = true}}, SHIFT(493),
  [2748] = {.entry = {.count = 1, .reusable = true}}, SHIFT(492),
  [2750] = {.entry = {.count = 1, .reusable = true}}, SHIFT(491),
  [2752] = {.entry = {.count = 1, .reusable = true}}, SHIFT(490),
  [2754] = {.entry = {.count = 1, .reusable = true}}, SHIFT(704),
  [2756] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1327),
  [2758] = {.entry = {.count = 1, .reusable = true}}, SHIFT(464),
  [2760] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1165),
  [2762] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1106),
  [2764] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1100),
  [2766] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1077),
};

#ifdef __cplusplus
extern "C" {
#endif
void *tree_sitter_javascript_external_scanner_create(void);
void tree_sitter_javascript_external_scanner_destroy(void *);
bool tree_sitter_javascript_external_scanner_scan(void *, TSLexer *, const bool *);
unsigned tree_sitter_javascript_external_scanner_serialize(void *, char *);
void tree_sitter_javascript_external_scanner_deserialize(void *, const char *, unsigned);

#ifdef _WIN32
#define extern __declspec(dllexport)
#endif

extern const TSLanguage *tree_sitter_javascript(void) {
  static TSLanguage language = {
    .version = LANGUAGE_VERSION,
    .symbol_count = SYMBOL_COUNT,
    .alias_count = ALIAS_COUNT,
    .token_count = TOKEN_COUNT,
    .external_token_count = EXTERNAL_TOKEN_COUNT,
    .state_count = STATE_COUNT,
    .large_state_count = LARGE_STATE_COUNT,
    .production_id_count = PRODUCTION_ID_COUNT,
    .field_count = FIELD_COUNT,
    .max_alias_sequence_length = MAX_ALIAS_SEQUENCE_LENGTH,
    .parse_table = (const uint16_t *)ts_parse_table,
    .small_parse_table = (const uint16_t *)ts_small_parse_table,
    .small_parse_table_map = (const uint32_t *)ts_small_parse_table_map,
    .parse_actions = ts_parse_actions,
    .symbol_names = ts_symbol_names,
    .field_names = ts_field_names,
    .field_map_slices = (const TSFieldMapSlice *)ts_field_map_slices,
    .field_map_entries = (const TSFieldMapEntry *)ts_field_map_entries,
    .symbol_metadata = ts_symbol_metadata,
    .public_symbol_map = ts_symbol_map,
    .alias_map = ts_non_terminal_alias_map,
    .alias_sequences = (const TSSymbol *)ts_alias_sequences,
    .lex_modes = ts_lex_modes,
    .lex_fn = ts_lex,
    .keyword_lex_fn = ts_lex_keywords,
    .keyword_capture_token = sym_identifier,
    .external_scanner = {
      (const bool *)ts_external_scanner_states,
      ts_external_scanner_symbol_map,
      tree_sitter_javascript_external_scanner_create,
      tree_sitter_javascript_external_scanner_destroy,
      tree_sitter_javascript_external_scanner_scan,
      tree_sitter_javascript_external_scanner_serialize,
      tree_sitter_javascript_external_scanner_deserialize,
    },
  };
  return &language;
}
#ifdef __cplusplus
}
#endif
